/*
 * Internal module API header file.
 *
 * Generated by SIP 4.7.9 on Mon Apr 27 14:29:45 2009
 *
 * Copyright (c) 2008 Riverbank Computing Limited <info@riverbankcomputing.com>
 * 
 * This file is part of PyQt.
 * 
 * This file may be used under the terms of the GNU General Public
 * License versions 2.0 or 3.0 as published by the Free Software
 * Foundation and appearing in the files LICENSE.GPL2 and LICENSE.GPL3
 * included in the packaging of this file.  Alternatively you may (at
 * your option) use any later version of the GNU General Public
 * License if such license has been publicly approved by Riverbank
 * Computing Limited (or its successors, if any) and the KDE Free Qt
 * Foundation. In addition, as a special exception, Riverbank gives you
 * certain additional rights. These rights are described in the Riverbank
 * GPL Exception version 1.1, which can be found in the file
 * GPL_EXCEPTION.txt in this package.
 * 
 * Please review the following information to ensure GNU General
 * Public Licensing requirements will be met:
 * http://trolltech.com/products/qt/licenses/licensing/opensource/. If
 * you are unsure which license is appropriate for your use, please
 * review the following information:
 * http://trolltech.com/products/qt/licenses/licensing/licensingoverview
 * or contact the sales department at sales@riverbankcomputing.com.
 * 
 * This file is provided "AS IS" with NO WARRANTY OF ANY KIND,
 * INCLUDING THE WARRANTIES OF DESIGN, MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE. Trolltech reserves all rights not expressly
 * granted herein.
 * 
 * This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
 * WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

#ifndef _QtCoreAPI_H
#define _QtCoreAPI_H


#include <sip.h>

#include <QMetaType>

/* These are the features that are enabled. */
#define SIP_FEATURE_PyQt_qreal_double
#define SIP_FEATURE_PyQt_SizeGrip
#define SIP_FEATURE_PyQt_OpenSSL
#define SIP_FEATURE_Py_DateTime
#define SIP_FEATURE_PyQt_NoQtPrintRangeBug
#define SIP_FEATURE_PyQt_WhatsThis
#define SIP_FEATURE_PyQt_ToolTip
#define SIP_FEATURE_PyQt_StatusTip
#define SIP_FEATURE_PyQt_SessionManager
#define SIP_FEATURE_PyQt_Accessibility

#line 621 "sip/QtCore/qobject.sip"
// The metatype id of the PyQt_PyObject class.
extern int qtcore_PyObject_metatype;

// The signature attribute name as an object.
extern PyObject *qtcore_signature_attr;

// The name attribute name as an object.
extern PyObject *qtcore_name_attr;

// Support for converting between PyObject and QVariant.
PyObject *qtcore_PyObject_FromQVariant(const QVariant &qvar);
QVariant qtcore_PyObject_AsQVariant(PyObject *obj);

// Support for creating QGenericArgument and QGenericReturnArgument instances.
#include <qobjectdefs.h>

PyObject *qtcore_ArgumentFactory(const char *type, PyObject *data);
PyObject *qtcore_ReturnFactory(const char *type);
PyObject *qtcore_ReturnValue(PyObject *gra);

// The data structure for holding arguments for pyqtSignature() and its delete
// function.
#include <qpair.h>
#include <qbytearray.h>

typedef QPair<QByteArray, QByteArray> qtcore_SignatureArgs;
extern "C" {void qtcore_SignatureArgs_delete(void *);}


// Support for QObject.staticMetaObject %GetCode.
PyObject *qtcore_staticMetaObject_helper(PyObject *type_obj);
#line 588 "sip/QtCore/qstring.sip"
// Support for converting between PyObject and QString.
PyObject *qtcore_QStringToPyUnicode(QString *qs);
QString qtcore_PyUnicode_AsQString(PyObject *obj);
#line 96 "sipAPIQtCore.h"

/*
 * Convenient names to refer to the names of classes defined in this module.
 * These are part of the public API.
 */
#define sipName_QXmlStreamWriter  sipNm_QtCore_QXmlStreamWriter
#define sipName_QXmlStreamReader  sipNm_QtCore_QXmlStreamReader
#define sipName_QXmlStreamEntityResolver  sipNm_QtCore_QXmlStreamEntityResolver
#define sipName_QXmlStreamEntityDeclaration  sipNm_QtCore_QXmlStreamEntityDeclaration
#define sipName_QXmlStreamNotationDeclaration  sipNm_QtCore_QXmlStreamNotationDeclaration
#define sipName_QXmlStreamNamespaceDeclaration  sipNm_QtCore_QXmlStreamNamespaceDeclaration
#define sipName_QXmlStreamAttributes  sipNm_QtCore_QXmlStreamAttributes
#define sipName_QXmlStreamAttribute  sipNm_QtCore_QXmlStreamAttribute
#define sipName_QWaitCondition  sipNm_QtCore_QWaitCondition
#define sipName_QVariant  sipNm_QtCore_QVariant
#define sipName_QUuid  sipNm_QtCore_QUuid
#define sipName_FormattingOptions  sipNm_QtCore_FormattingOptions
#define sipName_QTranslator  sipNm_QtCore_QTranslator
#define sipName_QTimer  sipNm_QtCore_QTimer
#define sipName_QTimeLine  sipNm_QtCore_QTimeLine
#define sipName_QThreadPool  sipNm_QtCore_QThreadPool
#define sipName_QThread  sipNm_QtCore_QThread
#define sipName_QTextStreamManipulator  sipNm_QtCore_QTextStreamManipulator
#define sipName_NumberFlags  sipNm_QtCore_NumberFlags
#define sipName_QTextStream  sipNm_QtCore_QTextStream
#define sipName_QTextDecoder  sipNm_QtCore_QTextDecoder
#define sipName_QTextEncoder  sipNm_QtCore_QTextEncoder
#define sipName_ConverterState  sipNm_QtCore_ConverterState
#define sipName_ConversionFlags  sipNm_QtCore_ConversionFlags
#define sipName_QTextCodec  sipNm_QtCore_QTextCodec
#define sipName_BoundaryReasons  sipNm_QtCore_BoundaryReasons
#define sipName_QTextBoundaryFinder  sipNm_QtCore_QTextBoundaryFinder
#define sipName_QTemporaryFile  sipNm_QtCore_QTemporaryFile
#define sipName_QSystemSemaphore  sipNm_QtCore_QSystemSemaphore
#define sipName_QStringMatcher  sipNm_QtCore_QStringMatcher
#define sipName_QStringRef  sipNm_QtCore_QStringRef
#define sipName_QLatin1String  sipNm_QtCore_QLatin1String
#define sipName_SectionFlags  sipNm_QtCore_SectionFlags
#define sipName_QSocketNotifier  sipNm_QtCore_QSocketNotifier
#define sipName_QSignalMapper  sipNm_QtCore_QSignalMapper
#define sipName_QSharedMemory  sipNm_QtCore_QSharedMemory
#define sipName_QSettings  sipNm_QtCore_QSettings
#define sipName_QSemaphore  sipNm_QtCore_QSemaphore
#define sipName_QRunnable  sipNm_QtCore_QRunnable
#define sipName_QResource  sipNm_QtCore_QResource
#define sipName_QWriteLocker  sipNm_QtCore_QWriteLocker
#define sipName_QReadLocker  sipNm_QtCore_QReadLocker
#define sipName_QReadWriteLock  sipNm_QtCore_QReadWriteLock
#define sipName_QProcess  sipNm_QtCore_QProcess
#define sipName_QPluginLoader  sipNm_QtCore_QPluginLoader
#define sipName_QGenericReturnArgument  sipNm_QtCore_QGenericReturnArgument
#define sipName_QGenericArgument  sipNm_QtCore_QGenericArgument
#define sipName_QMetaObject  sipNm_QtCore_QMetaObject
#define sipName_QObjectCleanupHandler  sipNm_QtCore_QObjectCleanupHandler
#define sipName_QWidget  sipNm_QtCore_QWidget
#define sipName_QMutexLocker  sipNm_QtCore_QMutexLocker
#define sipName_QMutex  sipNm_QtCore_QMutex
#define sipName_QMimeData  sipNm_QtCore_QMimeData
#define sipName_QTransform  sipNm_QtCore_QTransform
#define sipName_QMatrix  sipNm_QtCore_QMatrix
#define sipName_QTextFormat  sipNm_QtCore_QTextFormat
#define sipName_QTextLength  sipNm_QtCore_QTextLength
#define sipName_QPen  sipNm_QtCore_QPen
#define sipName_QKeySequence  sipNm_QtCore_QKeySequence
#define sipName_QSizePolicy  sipNm_QtCore_QSizePolicy
#define sipName_QCursor  sipNm_QtCore_QCursor
#define sipName_QBitmap  sipNm_QtCore_QBitmap
#define sipName_QRegion  sipNm_QtCore_QRegion
#define sipName_QPolygon  sipNm_QtCore_QPolygon
#define sipName_QImage  sipNm_QtCore_QImage
#define sipName_QIcon  sipNm_QtCore_QIcon
#define sipName_QPalette  sipNm_QtCore_QPalette
#define sipName_QColor  sipNm_QtCore_QColor
#define sipName_QBrush  sipNm_QtCore_QBrush
#define sipName_QPixmap  sipNm_QtCore_QPixmap
#define sipName_QFont  sipNm_QtCore_QFont
#define sipName_QRegExp  sipNm_QtCore_QRegExp
#define sipName_QPointF  sipNm_QtCore_QPointF
#define sipName_QPoint  sipNm_QtCore_QPoint
#define sipName_QSizeF  sipNm_QtCore_QSizeF
#define sipName_QSize  sipNm_QtCore_QSize
#define sipName_QRectF  sipNm_QtCore_QRectF
#define sipName_QRect  sipNm_QtCore_QRect
#define sipName_QUrl  sipNm_QtCore_QUrl
#define sipName_QStringList  sipNm_QtCore_QStringList
#define sipName_QString  sipNm_QtCore_QString
#define sipName_QMetaType  sipNm_QtCore_QMetaType
#define sipName_QMetaClassInfo  sipNm_QtCore_QMetaClassInfo
#define sipName_QMetaProperty  sipNm_QtCore_QMetaProperty
#define sipName_QMetaEnum  sipNm_QtCore_QMetaEnum
#define sipName_QMetaMethod  sipNm_QtCore_QMetaMethod
#define sipName_QSystemLocale  sipNm_QtCore_QSystemLocale
#define sipName_NumberOptions  sipNm_QtCore_NumberOptions
#define sipName_QLocale  sipNm_QtCore_QLocale
#define sipName_QLineF  sipNm_QtCore_QLineF
#define sipName_QLine  sipNm_QtCore_QLine
#define sipName_QLibraryInfo  sipNm_QtCore_QLibraryInfo
#define sipName_LoadHints  sipNm_QtCore_LoadHints
#define sipName_QLibrary  sipNm_QtCore_QLibrary
#define sipName_OpenMode  sipNm_QtCore_OpenMode
#define sipName_QFSFileEngine  sipNm_QtCore_QFSFileEngine
#define sipName_QFileSystemWatcher  sipNm_QtCore_QFileSystemWatcher
#define sipName_QFileInfo  sipNm_QtCore_QFileInfo
#define sipName_Permissions  sipNm_QtCore_Permissions
#define sipName_QFile  sipNm_QtCore_QFile
#define sipName_ProcessEventsFlags  sipNm_QtCore_ProcessEventsFlags
#define sipName_QEventLoop  sipNm_QtCore_QEventLoop
#define sipName_IteratorFlags  sipNm_QtCore_IteratorFlags
#define sipName_QDirIterator  sipNm_QtCore_QDirIterator
#define sipName_SortFlags  sipNm_QtCore_SortFlags
#define sipName_Filters  sipNm_QtCore_Filters
#define sipName_QDir  sipNm_QtCore_QDir
#define sipName_QDateTime  sipNm_QtCore_QDateTime
#define sipName_QTime  sipNm_QtCore_QTime
#define sipName_QDate  sipNm_QtCore_QDate
#define sipName_QDataStream  sipNm_QtCore_QDataStream
#define sipName_QCryptographicHash  sipNm_QtCore_QCryptographicHash
#define sipName_QDynamicPropertyChangeEvent  sipNm_QtCore_QDynamicPropertyChangeEvent
#define sipName_QChildEvent  sipNm_QtCore_QChildEvent
#define sipName_QTimerEvent  sipNm_QtCore_QTimerEvent
#define sipName_QEvent  sipNm_QtCore_QEvent
#define sipName_QCoreApplication  sipNm_QtCore_QCoreApplication
#define sipName_QChar  sipNm_QtCore_QChar
#define sipName_QLatin1Char  sipNm_QtCore_QLatin1Char
#define sipName_QByteArrayMatcher  sipNm_QtCore_QByteArrayMatcher
#define sipName_QByteArray  sipNm_QtCore_QByteArray
#define sipName_QIODevice  sipNm_QtCore_QIODevice
#define sipName_QBuffer  sipNm_QtCore_QBuffer
#define sipName_QBitArray  sipNm_QtCore_QBitArray
#define sipName_QBasicTimer  sipNm_QtCore_QBasicTimer
#define sipName_QAbstractListModel  sipNm_QtCore_QAbstractListModel
#define sipName_QAbstractTableModel  sipNm_QtCore_QAbstractTableModel
#define sipName_QAbstractItemModel  sipNm_QtCore_QAbstractItemModel
#define sipName_QPersistentModelIndex  sipNm_QtCore_QPersistentModelIndex
#define sipName_QModelIndex  sipNm_QtCore_QModelIndex
#define sipName_QAbstractFileEngineIterator  sipNm_QtCore_QAbstractFileEngineIterator
#define sipName_QAbstractFileEngineHandler  sipNm_QtCore_QAbstractFileEngineHandler
#define sipName_FileFlags  sipNm_QtCore_FileFlags
#define sipName_QAbstractFileEngine  sipNm_QtCore_QAbstractFileEngine
#define sipName_QObject  sipNm_QtCore_QObject
#define sipName_QAbstractEventDispatcher  sipNm_QtCore_QAbstractEventDispatcher
#define sipName_TextInteractionFlags  sipNm_QtCore_TextInteractionFlags
#define sipName_MatchFlags  sipNm_QtCore_MatchFlags
#define sipName_ItemFlags  sipNm_QtCore_ItemFlags
#define sipName_DropActions  sipNm_QtCore_DropActions
#define sipName_ToolBarAreas  sipNm_QtCore_ToolBarAreas
#define sipName_DockWidgetAreas  sipNm_QtCore_DockWidgetAreas
#define sipName_ImageConversionFlags  sipNm_QtCore_ImageConversionFlags
#define sipName_WindowStates  sipNm_QtCore_WindowStates
#define sipName_WindowFlags  sipNm_QtCore_WindowFlags
#define sipName_Alignment  sipNm_QtCore_Alignment
#define sipName_Orientations  sipNm_QtCore_Orientations
#define sipName_MouseButtons  sipNm_QtCore_MouseButtons
#define sipName_KeyboardModifiers  sipNm_QtCore_KeyboardModifiers
#define sipName_QFlags  sipNm_QtCore_QFlags
#define sipName_QSysInfo  sipNm_QtCore_QSysInfo

/* Convenient names to call the SIP API. */
#define sipConvertFromSliceObject(o,len,start,stop,step,slen)   PySlice_GetIndicesEx((PySliceObject *)(o),(len),(start),(stop),(step),(slen))
#define sipIsSubClassInstance(o,wt) PyObject_TypeCheck((o),(PyTypeObject *)(wt))

#define sipMapStringToClass         sipAPI_QtCore->api_map_string_to_class
#define sipMapIntToClass            sipAPI_QtCore->api_map_int_to_class
#define sipMalloc                   sipAPI_QtCore->api_malloc
#define sipFree                     sipAPI_QtCore->api_free
#define sipBuildResult              sipAPI_QtCore->api_build_result
#define sipCallMethod               sipAPI_QtCore->api_call_method
#define sipParseResult              sipAPI_QtCore->api_parse_result
#define sipParseArgs                sipAPI_QtCore->api_parse_args
#define sipParsePair                sipAPI_QtCore->api_parse_pair
#define sipCommonCtor               sipAPI_QtCore->api_common_ctor
#define sipCommonDtor               sipAPI_QtCore->api_common_dtor
#define sipConvertFromSequenceIndex sipAPI_QtCore->api_convert_from_sequence_index
#define sipConvertFromVoidPtr       sipAPI_QtCore->api_convert_from_void_ptr
#define sipConvertToCpp             sipAPI_QtCore->api_convert_to_cpp
#define sipConvertToVoidPtr         sipAPI_QtCore->api_convert_to_void_ptr
#define sipNoFunction               sipAPI_QtCore->api_no_function
#define sipNoMethod                 sipAPI_QtCore->api_no_method
#define sipAbstractMethod           sipAPI_QtCore->api_abstract_method
#define sipBadClass                 sipAPI_QtCore->api_bad_class
#define sipBadSetType               sipAPI_QtCore->api_bad_set_type
#define sipBadCatcherResult         sipAPI_QtCore->api_bad_catcher_result
#define sipBadOperatorArg           sipAPI_QtCore->api_bad_operator_arg
#define sipTrace                    sipAPI_QtCore->api_trace
#define sipTransfer                 sipAPI_QtCore->api_transfer
#define sipTransferBack             sipAPI_QtCore->api_transfer_back
#define sipTransferTo               sipAPI_QtCore->api_transfer_to
#define sipTransferBreak            sipAPI_QtCore->api_transfer_break
#define sipWrapper_Check            sipAPI_QtCore->api_wrapper_check
#define sipGetWrapper               sipAPI_QtCore->api_get_wrapper
#define sipGetCppPtr                sipAPI_QtCore->api_get_cpp_ptr
#define sipGetComplexCppPtr         sipAPI_QtCore->api_get_complex_cpp_ptr
#define sipIsPyMethod               sipAPI_QtCore->api_is_py_method
#define sipCallHook                 sipAPI_QtCore->api_call_hook
#define sipStartThread              sipAPI_QtCore->api_start_thread
#define sipEndThread                sipAPI_QtCore->api_end_thread
#define sipEmitSignal               sipAPI_QtCore->api_emit_signal
#define sipConnectRx                sipAPI_QtCore->api_connect_rx
#define sipDisconnectRx             sipAPI_QtCore->api_disconnect_rx
#define sipGetSender                sipAPI_QtCore->api_get_sender
#define sipRaiseUnknownException    sipAPI_QtCore->api_raise_unknown_exception
#define sipRaiseClassException      sipAPI_QtCore->api_raise_class_exception
#define sipRaiseSubClassException   sipAPI_QtCore->api_raise_sub_class_exception
#define sipBadLengthForSlice        sipAPI_QtCore->api_bad_length_for_slice
#define sipClassName                sipAPI_QtCore->api_class_name
#define sipAddClassInstance         sipAPI_QtCore->api_add_class_instance
#define sipAddMappedTypeInstance    sipAPI_QtCore->api_add_mapped_type_instance
#define sipAddEnumInstance          sipAPI_QtCore->api_add_enum_instance
#define sipConvertFromNamedEnum     sipAPI_QtCore->api_convert_from_named_enum
#define sipGetAddress               sipAPI_QtCore->api_get_address
#define sipFreeConnection           sipAPI_QtCore->api_free_connection
#define sipEmitToSlot               sipAPI_QtCore->api_emit_to_slot
#define sipSameConnection           sipAPI_QtCore->api_same_connection
#define sipPySlotExtend             sipAPI_QtCore->api_pyslot_extend
#define sipConvertRx                sipAPI_QtCore->api_convert_rx
#define sipAddDelayedDtor           sipAPI_QtCore->api_add_delayed_dtor
#define sipCanConvertToInstance     sipAPI_QtCore->api_can_convert_to_instance
#define sipCanConvertToMappedType   sipAPI_QtCore->api_can_convert_to_mapped_type
#define sipConvertToInstance        sipAPI_QtCore->api_convert_to_instance
#define sipConvertToMappedType      sipAPI_QtCore->api_convert_to_mapped_type
#define sipForceConvertToInstance   sipAPI_QtCore->api_force_convert_to_instance
#define sipForceConvertToMappedType sipAPI_QtCore->api_force_convert_to_mapped_type
#define sipReleaseInstance          sipAPI_QtCore->api_release_instance
#define sipReleaseMappedType        sipAPI_QtCore->api_release_mapped_type
#define sipConvertFromInstance      sipAPI_QtCore->api_convert_from_instance
#define sipConvertFromNewInstance   sipAPI_QtCore->api_convert_from_new_instance
#define sipConvertFromMappedType    sipAPI_QtCore->api_convert_from_mapped_type
#define sipGetState                 sipAPI_QtCore->api_get_state
#define sipFindMappedType           sipAPI_QtCore->api_find_mapped_type
#define sipLong_AsUnsignedLong      sipAPI_QtCore->api_long_as_unsigned_long
#define sipExportSymbol             sipAPI_QtCore->api_export_symbol
#define sipImportSymbol             sipAPI_QtCore->api_import_symbol
#define sipRegisterIntTypes         sipAPI_QtCore->api_register_int_types
#define sipParseSignature           sipAPI_QtCore->api_parse_signature
#define sipFindClass                sipAPI_QtCore->api_find_class
#define sipFindNamedEnum            sipAPI_QtCore->api_find_named_enum
#define sipString_AsChar            sipAPI_QtCore->api_string_as_char
#define sipUnicode_AsWChar          sipAPI_QtCore->api_unicode_as_wchar
#define sipUnicode_AsWString        sipAPI_QtCore->api_unicode_as_wstring
#define sipConvertFromConstVoidPtr  sipAPI_QtCore->api_convert_from_const_void_ptr
#define sipConvertFromVoidPtrAndSize    sipAPI_QtCore->api_convert_from_void_ptr_and_size
#define sipConvertFromConstVoidPtrAndSize   sipAPI_QtCore->api_convert_from_const_void_ptr_and_size
#define sipInvokeSlot               sipAPI_QtCore->api_invoke_slot
#define sipParseType                sipAPI_QtCore->api_parse_type
#define sipIsExactWrappedType       sipAPI_QtCore->api_is_exact_wrapped_type
#define sipAssignInstance           sipAPI_QtCore->api_assign_instance
#define sipAssignMappedType         sipAPI_QtCore->api_assign_mapped_type
#define sipRegisterMetaType         sipAPI_QtCore->api_register_meta_type
#define sipWrappedTypeName(wt)      ((wt)->type->td_cname)
#define sipDeprecated               sipAPI_QtCore->api_deprecated

/* The strings used by this module. */
extern char sipNm_QtCore_writeCurrentToken[];
extern char sipNm_QtCore_writeStartElement[];
extern char sipNm_QtCore_writeStartDocument[];
extern char sipNm_QtCore_writeProcessingInstruction[];
extern char sipNm_QtCore_writeDefaultNamespace[];
extern char sipNm_QtCore_writeNamespace[];
extern char sipNm_QtCore_writeEntityReference[];
extern char sipNm_QtCore_writeEndElement[];
extern char sipNm_QtCore_writeEndDocument[];
extern char sipNm_QtCore_writeTextElement[];
extern char sipNm_QtCore_writeEmptyElement[];
extern char sipNm_QtCore_writeDTD[];
extern char sipNm_QtCore_writeComment[];
extern char sipNm_QtCore_writeCharacters[];
extern char sipNm_QtCore_writeCDATA[];
extern char sipNm_QtCore_writeAttributes[];
extern char sipNm_QtCore_writeAttribute[];
extern char sipNm_QtCore_autoFormattingIndent[];
extern char sipNm_QtCore_setAutoFormattingIndent[];
extern char sipNm_QtCore_autoFormatting[];
extern char sipNm_QtCore_setAutoFormatting[];
extern char sipNm_QtCore_QXmlStreamWriter[];
extern char sipNm_QtCore_entityResolver[];
extern char sipNm_QtCore_setEntityResolver[];
extern char sipNm_QtCore_hasError[];
extern char sipNm_QtCore_raiseError[];
extern char sipNm_QtCore_PrematureEndOfDocumentError[];
extern char sipNm_QtCore_NotWellFormedError[];
extern char sipNm_QtCore_CustomError[];
extern char sipNm_QtCore_UnexpectedElementError[];
extern char sipNm_QtCore_dtdSystemId[];
extern char sipNm_QtCore_dtdPublicId[];
extern char sipNm_QtCore_dtdName[];
extern char sipNm_QtCore_entityDeclarations[];
extern char sipNm_QtCore_notationDeclarations[];
extern char sipNm_QtCore_addExtraNamespaceDeclarations[];
extern char sipNm_QtCore_addExtraNamespaceDeclaration[];
extern char sipNm_QtCore_namespaceDeclarations[];
extern char sipNm_QtCore_processingInstructionData[];
extern char sipNm_QtCore_processingInstructionTarget[];
extern char sipNm_QtCore_readElementText[];
extern char sipNm_QtCore_attributes[];
extern char sipNm_QtCore_characterOffset[];
extern char sipNm_QtCore_columnNumber[];
extern char sipNm_QtCore_lineNumber[];
extern char sipNm_QtCore_documentEncoding[];
extern char sipNm_QtCore_documentVersion[];
extern char sipNm_QtCore_isStandaloneDocument[];
extern char sipNm_QtCore_isProcessingInstruction[];
extern char sipNm_QtCore_isEntityReference[];
extern char sipNm_QtCore_isDTD[];
extern char sipNm_QtCore_isComment[];
extern char sipNm_QtCore_isCDATA[];
extern char sipNm_QtCore_isWhitespace[];
extern char sipNm_QtCore_isCharacters[];
extern char sipNm_QtCore_isEndElement[];
extern char sipNm_QtCore_isStartElement[];
extern char sipNm_QtCore_isEndDocument[];
extern char sipNm_QtCore_isStartDocument[];
extern char sipNm_QtCore_namespaceProcessing[];
extern char sipNm_QtCore_setNamespaceProcessing[];
extern char sipNm_QtCore_tokenString[];
extern char sipNm_QtCore_tokenType[];
extern char sipNm_QtCore_readNext[];
extern char sipNm_QtCore_ProcessingInstruction[];
extern char sipNm_QtCore_EntityReference[];
extern char sipNm_QtCore_DTD[];
extern char sipNm_QtCore_Comment[];
extern char sipNm_QtCore_Characters[];
extern char sipNm_QtCore_EndElement[];
extern char sipNm_QtCore_StartElement[];
extern char sipNm_QtCore_EndDocument[];
extern char sipNm_QtCore_StartDocument[];
extern char sipNm_QtCore_NoToken[];
extern char sipNm_QtCore_QXmlStreamReader[];
extern char sipNm_QtCore_resolveUndeclaredEntity[];
extern char sipNm_QtCore_QXmlStreamEntityResolver[];
extern char sipNm_QtCore_notationName[];
extern char sipNm_QtCore_QXmlStreamEntityDeclaration[];
extern char sipNm_QtCore_publicId[];
extern char sipNm_QtCore_systemId[];
extern char sipNm_QtCore_QXmlStreamNotationDeclaration[];
extern char sipNm_QtCore_QXmlStreamNamespaceDeclaration[];
extern char sipNm_QtCore_QXmlStreamAttributes[];
extern char sipNm_QtCore_isDefault[];
extern char sipNm_QtCore_prefix[];
extern char sipNm_QtCore_qualifiedName[];
extern char sipNm_QtCore_namespaceUri[];
extern char sipNm_QtCore_QXmlStreamAttribute[];
extern char sipNm_QtCore_wakeAll[];
extern char sipNm_QtCore_wakeOne[];
extern char sipNm_QtCore_QWaitCondition[];
extern char sipNm_QtCore_QVector[];
extern char sipNm_QtCore_nameToType[];
extern char sipNm_QtCore_typeToName[];
extern char sipNm_QtCore_save[];
extern char sipNm_QtCore_toPyObject[];
extern char sipNm_QtCore_toRegExp[];
extern char sipNm_QtCore_toLocale[];
extern char sipNm_QtCore_toUrl[];
extern char sipNm_QtCore_toRectF[];
extern char sipNm_QtCore_toLineF[];
extern char sipNm_QtCore_toSizeF[];
extern char sipNm_QtCore_toPointF[];
extern char sipNm_QtCore_toMap[];
extern char sipNm_QtCore_toList[];
extern char sipNm_QtCore_toChar[];
extern char sipNm_QtCore_toStringList[];
extern char sipNm_QtCore_toBitArray[];
extern char sipNm_QtCore_toByteArray[];
extern char sipNm_QtCore_toBool[];
extern char sipNm_QtCore_convert[];
extern char sipNm_QtCore_canConvert[];
extern char sipNm_QtCore_fromMap[];
extern char sipNm_QtCore_fromList[];
extern char sipNm_QtCore_UserType[];
extern char sipNm_QtCore_Transform[];
extern char sipNm_QtCore_Matrix[];
extern char sipNm_QtCore_TextLength[];
extern char sipNm_QtCore_Pen[];
extern char sipNm_QtCore_KeySequence[];
extern char sipNm_QtCore_SizePolicy[];
extern char sipNm_QtCore_Cursor[];
extern char sipNm_QtCore_Bitmap[];
extern char sipNm_QtCore_Region[];
extern char sipNm_QtCore_Polygon[];
extern char sipNm_QtCore_Image[];
extern char sipNm_QtCore_Icon[];
extern char sipNm_QtCore_Palette[];
extern char sipNm_QtCore_Color[];
extern char sipNm_QtCore_Brush[];
extern char sipNm_QtCore_Pixmap[];
extern char sipNm_QtCore_PointF[];
extern char sipNm_QtCore_Point[];
extern char sipNm_QtCore_LineF[];
extern char sipNm_QtCore_SizeF[];
extern char sipNm_QtCore_RectF[];
extern char sipNm_QtCore_Rect[];
extern char sipNm_QtCore_Locale[];
extern char sipNm_QtCore_Url[];
extern char sipNm_QtCore_DateTime[];
extern char sipNm_QtCore_Date[];
extern char sipNm_QtCore_BitArray[];
extern char sipNm_QtCore_ByteArray[];
extern char sipNm_QtCore_StringList[];
extern char sipNm_QtCore_String[];
extern char sipNm_QtCore_List[];
extern char sipNm_QtCore_Map[];
extern char sipNm_QtCore_Invalid[];
extern char sipNm_QtCore_QVariant[];
extern char sipNm_QtCore_variant[];
extern char sipNm_QtCore_createUuid[];
extern char sipNm_QtCore_Random[];
extern char sipNm_QtCore_EmbeddedPOSIX[];
extern char sipNm_QtCore_VerUnknown[];
extern char sipNm_QtCore_Reserved[];
extern char sipNm_QtCore_Microsoft[];
extern char sipNm_QtCore_DCE[];
extern char sipNm_QtCore_NCS[];
extern char sipNm_QtCore_VarUnknown[];
extern char sipNm_QtCore_QUuid[];
extern char sipNm_QtCore_encodedFragment[];
extern char sipNm_QtCore_setEncodedFragment[];
extern char sipNm_QtCore_removeAllEncodedQueryItems[];
extern char sipNm_QtCore_removeEncodedQueryItem[];
extern char sipNm_QtCore_allEncodedQueryItemValues[];
extern char sipNm_QtCore_encodedQueryItemValue[];
extern char sipNm_QtCore_hasEncodedQueryItem[];
extern char sipNm_QtCore_encodedQueryItems[];
extern char sipNm_QtCore_addEncodedQueryItem[];
extern char sipNm_QtCore_setEncodedQueryItems[];
extern char sipNm_QtCore_encodedPath[];
extern char sipNm_QtCore_setEncodedPath[];
extern char sipNm_QtCore_encodedHost[];
extern char sipNm_QtCore_setEncodedHost[];
extern char sipNm_QtCore_encodedPassword[];
extern char sipNm_QtCore_setEncodedPassword[];
extern char sipNm_QtCore_encodedUserName[];
extern char sipNm_QtCore_setEncodedUserName[];
extern char sipNm_QtCore_setIdnWhitelist[];
extern char sipNm_QtCore_idnWhitelist[];
extern char sipNm_QtCore_toAce[];
extern char sipNm_QtCore_fromAce[];
extern char sipNm_QtCore_hasFragment[];
extern char sipNm_QtCore_hasQuery[];
extern char sipNm_QtCore_toPunycode[];
extern char sipNm_QtCore_fromPunycode[];
extern char sipNm_QtCore_fromEncoded[];
extern char sipNm_QtCore_toEncoded[];
extern char sipNm_QtCore_toLocalFile[];
extern char sipNm_QtCore_fromLocalFile[];
extern char sipNm_QtCore_isParentOf[];
extern char sipNm_QtCore_resolved[];
extern char sipNm_QtCore_fragment[];
extern char sipNm_QtCore_setFragment[];
extern char sipNm_QtCore_removeAllQueryItems[];
extern char sipNm_QtCore_removeQueryItem[];
extern char sipNm_QtCore_allQueryItemValues[];
extern char sipNm_QtCore_queryItemValue[];
extern char sipNm_QtCore_hasQueryItem[];
extern char sipNm_QtCore_queryItems[];
extern char sipNm_QtCore_addQueryItem[];
extern char sipNm_QtCore_setQueryItems[];
extern char sipNm_QtCore_queryPairDelimiter[];
extern char sipNm_QtCore_queryValueDelimiter[];
extern char sipNm_QtCore_setQueryDelimiters[];
extern char sipNm_QtCore_encodedQuery[];
extern char sipNm_QtCore_setEncodedQuery[];
extern char sipNm_QtCore_port[];
extern char sipNm_QtCore_setPort[];
extern char sipNm_QtCore_host[];
extern char sipNm_QtCore_setHost[];
extern char sipNm_QtCore_password[];
extern char sipNm_QtCore_setPassword[];
extern char sipNm_QtCore_userName[];
extern char sipNm_QtCore_setUserName[];
extern char sipNm_QtCore_userInfo[];
extern char sipNm_QtCore_setUserInfo[];
extern char sipNm_QtCore_authority[];
extern char sipNm_QtCore_setAuthority[];
extern char sipNm_QtCore_scheme[];
extern char sipNm_QtCore_setScheme[];
extern char sipNm_QtCore_setEncodedUrl[];
extern char sipNm_QtCore_setUrl[];
extern char sipNm_QtCore_StrictMode[];
extern char sipNm_QtCore_TolerantMode[];
extern char sipNm_QtCore_FormattingOptions[];
extern char sipNm_QtCore_StripTrailingSlash[];
extern char sipNm_QtCore_RemoveFragment[];
extern char sipNm_QtCore_RemoveQuery[];
extern char sipNm_QtCore_RemovePath[];
extern char sipNm_QtCore_RemoveAuthority[];
extern char sipNm_QtCore_RemovePort[];
extern char sipNm_QtCore_RemoveUserInfo[];
extern char sipNm_QtCore_RemovePassword[];
extern char sipNm_QtCore_RemoveScheme[];
extern char sipNm_QtCore_FormattingOption[];
extern char sipNm_QtCore_loadFromData[];
extern char sipNm_QtCore_QTranslator[];
extern char sipNm_QtCore_timeout[];
extern char sipNm_QtCore_singleShot[];
extern char sipNm_QtCore_setSingleShot[];
extern char sipNm_QtCore_isSingleShot[];
extern char sipNm_QtCore_interval[];
extern char sipNm_QtCore_setInterval[];
extern char sipNm_QtCore_QTimer[];
extern char sipNm_QtCore_valueChanged[];
extern char sipNm_QtCore_frameChanged[];
extern char sipNm_QtCore_toggleDirection[];
extern char sipNm_QtCore_setPaused[];
extern char sipNm_QtCore_setCurrentTime[];
extern char sipNm_QtCore_resume[];
extern char sipNm_QtCore_valueForTime[];
extern char sipNm_QtCore_frameForTime[];
extern char sipNm_QtCore_currentValue[];
extern char sipNm_QtCore_currentFrame[];
extern char sipNm_QtCore_setCurveShape[];
extern char sipNm_QtCore_curveShape[];
extern char sipNm_QtCore_setUpdateInterval[];
extern char sipNm_QtCore_updateInterval[];
extern char sipNm_QtCore_setFrameRange[];
extern char sipNm_QtCore_setEndFrame[];
extern char sipNm_QtCore_endFrame[];
extern char sipNm_QtCore_setStartFrame[];
extern char sipNm_QtCore_startFrame[];
extern char sipNm_QtCore_setDuration[];
extern char sipNm_QtCore_duration[];
extern char sipNm_QtCore_setDirection[];
extern char sipNm_QtCore_setLoopCount[];
extern char sipNm_QtCore_loopCount[];
extern char sipNm_QtCore_Paused[];
extern char sipNm_QtCore_Backward[];
extern char sipNm_QtCore_Forward[];
extern char sipNm_QtCore_CosineCurve[];
extern char sipNm_QtCore_SineCurve[];
extern char sipNm_QtCore_LinearCurve[];
extern char sipNm_QtCore_EaseInOutCurve[];
extern char sipNm_QtCore_EaseOutCurve[];
extern char sipNm_QtCore_EaseInCurve[];
extern char sipNm_QtCore_QTimeLine[];
extern char sipNm_QtCore_waitForDone[];
extern char sipNm_QtCore_releaseThread[];
extern char sipNm_QtCore_reserveThread[];
extern char sipNm_QtCore_activeThreadCount[];
extern char sipNm_QtCore_setMaxThreadCount[];
extern char sipNm_QtCore_maxThreadCount[];
extern char sipNm_QtCore_setExpiryTimeout[];
extern char sipNm_QtCore_expiryTimeout[];
extern char sipNm_QtCore_tryStart[];
extern char sipNm_QtCore_globalInstance[];
extern char sipNm_QtCore_QThreadPool[];
extern char sipNm_QtCore_usleep[];
extern char sipNm_QtCore_msleep[];
extern char sipNm_QtCore_sleep[];
extern char sipNm_QtCore_setTerminationEnabled[];
extern char sipNm_QtCore_terminated[];
extern char sipNm_QtCore_wait[];
extern char sipNm_QtCore_stackSize[];
extern char sipNm_QtCore_setStackSize[];
extern char sipNm_QtCore_priority[];
extern char sipNm_QtCore_setPriority[];
extern char sipNm_QtCore_isFinished[];
extern char sipNm_QtCore_InheritPriority[];
extern char sipNm_QtCore_TimeCriticalPriority[];
extern char sipNm_QtCore_HighestPriority[];
extern char sipNm_QtCore_HighPriority[];
extern char sipNm_QtCore_NormalPriority[];
extern char sipNm_QtCore_LowPriority[];
extern char sipNm_QtCore_LowestPriority[];
extern char sipNm_QtCore_IdlePriority[];
extern char sipNm_QtCore_idealThreadCount[];
extern char sipNm_QtCore_currentThreadId[];
extern char sipNm_QtCore_currentThread[];
extern char sipNm_QtCore_QThread[];
extern char sipNm_QtCore_qSetRealNumberPrecision[];
extern char sipNm_QtCore_qSetPadChar[];
extern char sipNm_QtCore_qSetFieldWidth[];
extern char sipNm_QtCore_ws[];
extern char sipNm_QtCore_bom[];
extern char sipNm_QtCore_endl[];
extern char sipNm_QtCore_scientific[];
extern char sipNm_QtCore_fixed[];
extern char sipNm_QtCore_lowercasedigits[];
extern char sipNm_QtCore_lowercasebase[];
extern char sipNm_QtCore_uppercasedigits[];
extern char sipNm_QtCore_uppercasebase[];
extern char sipNm_QtCore_noforcepoint[];
extern char sipNm_QtCore_noforcesign[];
extern char sipNm_QtCore_noshowbase[];
extern char sipNm_QtCore_forcepoint[];
extern char sipNm_QtCore_forcesign[];
extern char sipNm_QtCore_showbase[];
extern char sipNm_QtCore_hex[];
extern char sipNm_QtCore_dec[];
extern char sipNm_QtCore_oct[];
extern char sipNm_QtCore_bin[];
extern char sipNm_QtCore_QTextStreamManipulator[];
extern char sipNm_QtCore_realNumberPrecision[];
extern char sipNm_QtCore_setRealNumberPrecision[];
extern char sipNm_QtCore_realNumberNotation[];
extern char sipNm_QtCore_setRealNumberNotation[];
extern char sipNm_QtCore_integerBase[];
extern char sipNm_QtCore_setIntegerBase[];
extern char sipNm_QtCore_numberFlags[];
extern char sipNm_QtCore_setNumberFlags[];
extern char sipNm_QtCore_fieldWidth[];
extern char sipNm_QtCore_setFieldWidth[];
extern char sipNm_QtCore_padChar[];
extern char sipNm_QtCore_setPadChar[];
extern char sipNm_QtCore_fieldAlignment[];
extern char sipNm_QtCore_setFieldAlignment[];
extern char sipNm_QtCore_skipWhiteSpace[];
extern char sipNm_QtCore_setString[];
extern char sipNm_QtCore_generateByteOrderMark[];
extern char sipNm_QtCore_setGenerateByteOrderMark[];
extern char sipNm_QtCore_autoDetectUnicode[];
extern char sipNm_QtCore_setAutoDetectUnicode[];
extern char sipNm_QtCore_codec[];
extern char sipNm_QtCore_setCodec[];
extern char sipNm_QtCore_NumberFlags[];
extern char sipNm_QtCore_UppercaseDigits[];
extern char sipNm_QtCore_UppercaseBase[];
extern char sipNm_QtCore_ForceSign[];
extern char sipNm_QtCore_ForcePoint[];
extern char sipNm_QtCore_ShowBase[];
extern char sipNm_QtCore_NumberFlag[];
extern char sipNm_QtCore_AlignAccountingStyle[];
extern char sipNm_QtCore_ScientificNotation[];
extern char sipNm_QtCore_FixedNotation[];
extern char sipNm_QtCore_SmartNotation[];
extern char sipNm_QtCore_QTextStream[];
extern char sipNm_QtCore_QTextDecoder[];
extern char sipNm_QtCore_QTextEncoder[];
extern char sipNm_QtCore_setCodecForCStrings[];
extern char sipNm_QtCore_codecForCStrings[];
extern char sipNm_QtCore_setCodecForTr[];
extern char sipNm_QtCore_codecForTr[];
extern char sipNm_QtCore_convertFromUnicode[];
extern char sipNm_QtCore_convertToUnicode[];
extern char sipNm_QtCore_mibEnum[];
extern char sipNm_QtCore_aliases[];
extern char sipNm_QtCore_ConverterState[];
extern char sipNm_QtCore_ConversionFlags[];
extern char sipNm_QtCore_IgnoreHeader[];
extern char sipNm_QtCore_ConvertInvalidToNull[];
extern char sipNm_QtCore_DefaultConversion[];
extern char sipNm_QtCore_ConversionFlag[];
extern char sipNm_QtCore_fromUnicode[];
extern char sipNm_QtCore_toUnicode[];
extern char sipNm_QtCore_canEncode[];
extern char sipNm_QtCore_makeEncoder[];
extern char sipNm_QtCore_makeDecoder[];
extern char sipNm_QtCore_setCodecForLocale[];
extern char sipNm_QtCore_codecForLocale[];
extern char sipNm_QtCore_availableMibs[];
extern char sipNm_QtCore_availableCodecs[];
extern char sipNm_QtCore_codecForHtml[];
extern char sipNm_QtCore_codecForMib[];
extern char sipNm_QtCore_codecForName[];
extern char sipNm_QtCore_QTextCodec[];
extern char sipNm_QtCore_boundaryReasons[];
extern char sipNm_QtCore_isAtBoundary[];
extern char sipNm_QtCore_toPreviousBoundary[];
extern char sipNm_QtCore_toNextBoundary[];
extern char sipNm_QtCore_setPosition[];
extern char sipNm_QtCore_toEnd[];
extern char sipNm_QtCore_toStart[];
extern char sipNm_QtCore_Sentence[];
extern char sipNm_QtCore_Line[];
extern char sipNm_QtCore_Word[];
extern char sipNm_QtCore_Grapheme[];
extern char sipNm_QtCore_BoundaryReasons[];
extern char sipNm_QtCore_EndWord[];
extern char sipNm_QtCore_StartWord[];
extern char sipNm_QtCore_NotAtBoundary[];
extern char sipNm_QtCore_QTextBoundaryFinder[];
extern char sipNm_QtCore_createLocalFile[];
extern char sipNm_QtCore_setFileTemplate[];
extern char sipNm_QtCore_fileTemplate[];
extern char sipNm_QtCore_setAutoRemove[];
extern char sipNm_QtCore_autoRemove[];
extern char sipNm_QtCore_QTemporaryFile[];
extern char sipNm_QtCore_Open[];
extern char sipNm_QtCore_QSystemSemaphore[];
extern char sipNm_QtCore_QStringMatcher[];
extern char sipNm_QtCore_last[];
extern char sipNm_QtCore_first[];
extern char sipNm_QtCore_swap[];
extern char sipNm_QtCore_move[];
extern char sipNm_QtCore_takeLast[];
extern char sipNm_QtCore_takeFirst[];
extern char sipNm_QtCore_takeAt[];
extern char sipNm_QtCore_removeAll[];
extern char sipNm_QtCore_removeAt[];
extern char sipNm_QtCore___delitem__[];
extern char sipNm_QtCore___setitem__[];
extern char sipNm_QtCore_replaceInStrings[];
extern char sipNm_QtCore_join[];
extern char sipNm_QtCore_appendTo[];
extern char sipNm_QtCore_position[];
extern char sipNm_QtCore_string[];
extern char sipNm_QtCore_QStringRef[];
extern char sipNm_QtCore_latin1[];
extern char sipNm_QtCore_QLatin1String[];
extern char sipNm_QtCore___unicode__[];
extern char sipNm_QtCore_isRightToLeft[];
extern char sipNm_QtCore_isSimpleText[];
extern char sipNm_QtCore_localeAwareCompare[];
extern char sipNm_QtCore_compare[];
extern char sipNm_QtCore_fromLocal8Bit[];
extern char sipNm_QtCore_fromUtf8[];
extern char sipNm_QtCore_toLocal8Bit[];
extern char sipNm_QtCore_toUtf8[];
extern char sipNm_QtCore_NormalizationForm_KC[];
extern char sipNm_QtCore_NormalizationForm_KD[];
extern char sipNm_QtCore_NormalizationForm_C[];
extern char sipNm_QtCore_NormalizationForm_D[];
extern char sipNm_QtCore_SkipEmptyParts[];
extern char sipNm_QtCore_KeepEmptyParts[];
extern char sipNm_QtCore_section[];
extern char sipNm_QtCore_SectionFlags[];
extern char sipNm_QtCore_SectionCaseInsensitiveSeps[];
extern char sipNm_QtCore_SectionIncludeTrailingSep[];
extern char sipNm_QtCore_SectionIncludeLeadingSep[];
extern char sipNm_QtCore_SectionSkipEmpty[];
extern char sipNm_QtCore_SectionDefault[];
extern char sipNm_QtCore_SectionFlag[];
extern char sipNm_QtCore_arg[];
extern char sipNm_QtCore_activated[];
extern char sipNm_QtCore_setEnabled[];
extern char sipNm_QtCore_isEnabled[];
extern char sipNm_QtCore_socket[];
extern char sipNm_QtCore_Exception[];
extern char sipNm_QtCore_Write[];
extern char sipNm_QtCore_Read[];
extern char sipNm_QtCore_QSocketNotifier[];
extern char sipNm_QtCore_toSize[];
extern char sipNm_QtCore_boundedTo[];
extern char sipNm_QtCore_expandedTo[];
extern char sipNm_QtCore_scale[];
extern char sipNm_QtCore_transpose[];
extern char sipNm_QtCore_mapped[];
extern char sipNm_QtCore_mapping[];
extern char sipNm_QtCore_removeMappings[];
extern char sipNm_QtCore_setMapping[];
extern char sipNm_QtCore_QSignalMapper[];
extern char sipNm_QtCore_constData[];
extern char sipNm_QtCore_isAttached[];
extern char sipNm_QtCore_attach[];
extern char sipNm_QtCore_setKey[];
extern char sipNm_QtCore_OutOfResources[];
extern char sipNm_QtCore_LockError[];
extern char sipNm_QtCore_NotFound[];
extern char sipNm_QtCore_AlreadyExists[];
extern char sipNm_QtCore_KeyError[];
extern char sipNm_QtCore_InvalidSize[];
extern char sipNm_QtCore_PermissionDenied[];
extern char sipNm_QtCore_QSharedMemory[];
extern char sipNm_QtCore_defaultFormat[];
extern char sipNm_QtCore_setDefaultFormat[];
extern char sipNm_QtCore_format[];
extern char sipNm_QtCore_setUserIniPath[];
extern char sipNm_QtCore_setSystemIniPath[];
extern char sipNm_QtCore_fallbacksEnabled[];
extern char sipNm_QtCore_setFallbacksEnabled[];
extern char sipNm_QtCore_setValue[];
extern char sipNm_QtCore_childGroups[];
extern char sipNm_QtCore_childKeys[];
extern char sipNm_QtCore_allKeys[];
extern char sipNm_QtCore_setArrayIndex[];
extern char sipNm_QtCore_endArray[];
extern char sipNm_QtCore_beginWriteArray[];
extern char sipNm_QtCore_beginReadArray[];
extern char sipNm_QtCore_endGroup[];
extern char sipNm_QtCore_beginGroup[];
extern char sipNm_QtCore_sync[];
extern char sipNm_QtCore_SystemScope[];
extern char sipNm_QtCore_UserScope[];
extern char sipNm_QtCore_InvalidFormat[];
extern char sipNm_QtCore_IniFormat[];
extern char sipNm_QtCore_NativeFormat[];
extern char sipNm_QtCore_FormatError[];
extern char sipNm_QtCore_AccessError[];
extern char sipNm_QtCore_QSettings[];
extern char sipNm_QtCore_available[];
extern char sipNm_QtCore_release[];
extern char sipNm_QtCore_tryAcquire[];
extern char sipNm_QtCore_acquire[];
extern char sipNm_QtCore_QSemaphore[];
extern char sipNm_QtCore_setAutoDelete[];
extern char sipNm_QtCore_autoDelete[];
extern char sipNm_QtCore_run[];
extern char sipNm_QtCore_QRunnable[];
extern char sipNm_QtCore_unregisterResourceData[];
extern char sipNm_QtCore_unregisterResource[];
extern char sipNm_QtCore_registerResourceData[];
extern char sipNm_QtCore_registerResource[];
extern char sipNm_QtCore_setLocale[];
extern char sipNm_QtCore_locale[];
extern char sipNm_QtCore_isCompressed[];
extern char sipNm_QtCore_QResource[];
extern char sipNm_QtCore_escape[];
extern char sipNm_QtCore_cap[];
extern char sipNm_QtCore_capturedTexts[];
extern char sipNm_QtCore_numCaptures[];
extern char sipNm_QtCore_matchedLength[];
extern char sipNm_QtCore_lastIndexIn[];
extern char sipNm_QtCore_exactMatch[];
extern char sipNm_QtCore_setMinimal[];
extern char sipNm_QtCore_isMinimal[];
extern char sipNm_QtCore_setPatternSyntax[];
extern char sipNm_QtCore_patternSyntax[];
extern char sipNm_QtCore_setCaseSensitivity[];
extern char sipNm_QtCore_caseSensitivity[];
extern char sipNm_QtCore_CaretWontMatch[];
extern char sipNm_QtCore_CaretAtOffset[];
extern char sipNm_QtCore_CaretAtZero[];
extern char sipNm_QtCore_FixedString[];
extern char sipNm_QtCore_Wildcard[];
extern char sipNm_QtCore_RegExp2[];
extern char sipNm_QtCore_RegExp[];
extern char sipNm_QtCore_toRect[];
extern char sipNm_QtCore_toAlignedRect[];
extern char sipNm_QtCore_united[];
extern char sipNm_QtCore_intersected[];
extern char sipNm_QtCore_unite[];
extern char sipNm_QtCore_setHeight[];
extern char sipNm_QtCore_setWidth[];
extern char sipNm_QtCore_adjust[];
extern char sipNm_QtCore_adjusted[];
extern char sipNm_QtCore_setCoords[];
extern char sipNm_QtCore_getCoords[];
extern char sipNm_QtCore_setRect[];
extern char sipNm_QtCore_getRect[];
extern char sipNm_QtCore_moveBottomLeft[];
extern char sipNm_QtCore_moveTopRight[];
extern char sipNm_QtCore_moveBottomRight[];
extern char sipNm_QtCore_moveTopLeft[];
extern char sipNm_QtCore_moveBottom[];
extern char sipNm_QtCore_moveRight[];
extern char sipNm_QtCore_moveTop[];
extern char sipNm_QtCore_moveLeft[];
extern char sipNm_QtCore_moveTo[];
extern char sipNm_QtCore_height[];
extern char sipNm_QtCore_width[];
extern char sipNm_QtCore_center[];
extern char sipNm_QtCore_bottomLeft[];
extern char sipNm_QtCore_topRight[];
extern char sipNm_QtCore_bottomRight[];
extern char sipNm_QtCore_topLeft[];
extern char sipNm_QtCore_setBottomLeft[];
extern char sipNm_QtCore_setTopRight[];
extern char sipNm_QtCore_setBottomRight[];
extern char sipNm_QtCore_setTopLeft[];
extern char sipNm_QtCore_setBottom[];
extern char sipNm_QtCore_setRight[];
extern char sipNm_QtCore_setTop[];
extern char sipNm_QtCore_setLeft[];
extern char sipNm_QtCore_bottom[];
extern char sipNm_QtCore_top[];
extern char sipNm_QtCore_intersects[];
extern char sipNm_QtCore_moveCenter[];
extern char sipNm_QtCore_normalized[];
extern char sipNm_QtCore_QWriteLocker[];
extern char sipNm_QtCore_readWriteLock[];
extern char sipNm_QtCore_QReadLocker[];
extern char sipNm_QtCore_tryLockForWrite[];
extern char sipNm_QtCore_lockForWrite[];
extern char sipNm_QtCore_tryLockForRead[];
extern char sipNm_QtCore_lockForRead[];
extern char sipNm_QtCore_QReadWriteLock[];
extern char sipNm_QtCore_setupChildProcess[];
extern char sipNm_QtCore_setProcessState[];
extern char sipNm_QtCore_readyReadStandardError[];
extern char sipNm_QtCore_readyReadStandardOutput[];
extern char sipNm_QtCore_stateChanged[];
extern char sipNm_QtCore_finished[];
extern char sipNm_QtCore_started[];
extern char sipNm_QtCore_kill[];
extern char sipNm_QtCore_terminate[];
extern char sipNm_QtCore_setStandardOutputProcess[];
extern char sipNm_QtCore_setStandardErrorFile[];
extern char sipNm_QtCore_setStandardOutputFile[];
extern char sipNm_QtCore_setStandardInputFile[];
extern char sipNm_QtCore_setProcessChannelMode[];
extern char sipNm_QtCore_processChannelMode[];
extern char sipNm_QtCore_systemEnvironment[];
extern char sipNm_QtCore_startDetached[];
extern char sipNm_QtCore_execute[];
extern char sipNm_QtCore_exitStatus[];
extern char sipNm_QtCore_exitCode[];
extern char sipNm_QtCore_readAllStandardError[];
extern char sipNm_QtCore_readAllStandardOutput[];
extern char sipNm_QtCore_waitForFinished[];
extern char sipNm_QtCore_waitForStarted[];
extern char sipNm_QtCore_pid[];
extern char sipNm_QtCore_state[];
extern char sipNm_QtCore_environment[];
extern char sipNm_QtCore_setEnvironment[];
extern char sipNm_QtCore_setWorkingDirectory[];
extern char sipNm_QtCore_workingDirectory[];
extern char sipNm_QtCore_closeWriteChannel[];
extern char sipNm_QtCore_closeReadChannel[];
extern char sipNm_QtCore_setReadChannel[];
extern char sipNm_QtCore_readChannel[];
extern char sipNm_QtCore_setReadChannelMode[];
extern char sipNm_QtCore_readChannelMode[];
extern char sipNm_QtCore_ForwardedChannels[];
extern char sipNm_QtCore_MergedChannels[];
extern char sipNm_QtCore_SeparateChannels[];
extern char sipNm_QtCore_StandardError[];
extern char sipNm_QtCore_StandardOutput[];
extern char sipNm_QtCore_Running[];
extern char sipNm_QtCore_Starting[];
extern char sipNm_QtCore_NotRunning[];
extern char sipNm_QtCore_UnknownError[];
extern char sipNm_QtCore_Timedout[];
extern char sipNm_QtCore_Crashed[];
extern char sipNm_QtCore_FailedToStart[];
extern char sipNm_QtCore_CrashExit[];
extern char sipNm_QtCore_NormalExit[];
extern char sipNm_QtCore_QProcess[];
extern char sipNm_QtCore_toPoint[];
extern char sipNm_QtCore___div__[];
extern char sipNm_QtCore___neg__[];
extern char sipNm_QtCore___sub__[];
extern char sipNm_QtCore___idiv__[];
extern char sipNm_QtCore___isub__[];
extern char sipNm_QtCore_setY[];
extern char sipNm_QtCore_setX[];
extern char sipNm_QtCore_y[];
extern char sipNm_QtCore_x[];
extern char sipNm_QtCore_manhattanLength[];
extern char sipNm_QtCore_staticInstances[];
extern char sipNm_QtCore_QPluginLoader[];
extern char sipNm_QtCore_QPair[];
extern char sipNm_QtCore_Q_RETURN_ARG[];
extern char sipNm_QtCore_QGenericReturnArgument[];
extern char sipNm_QtCore_Q_ARG[];
extern char sipNm_QtCore_QGenericArgument[];
extern char sipNm_QtCore_invokeMethod[];
extern char sipNm_QtCore_normalizedType[];
extern char sipNm_QtCore_normalizedSignature[];
extern char sipNm_QtCore_connectSlotsByName[];
extern char sipNm_QtCore_checkConnectArgs[];
extern char sipNm_QtCore_classInfo[];
extern char sipNm_QtCore_method[];
extern char sipNm_QtCore_indexOfClassInfo[];
extern char sipNm_QtCore_indexOfProperty[];
extern char sipNm_QtCore_indexOfEnumerator[];
extern char sipNm_QtCore_indexOfSlot[];
extern char sipNm_QtCore_indexOfSignal[];
extern char sipNm_QtCore_indexOfMethod[];
extern char sipNm_QtCore_classInfoCount[];
extern char sipNm_QtCore_propertyCount[];
extern char sipNm_QtCore_enumeratorCount[];
extern char sipNm_QtCore_methodCount[];
extern char sipNm_QtCore_classInfoOffset[];
extern char sipNm_QtCore_propertyOffset[];
extern char sipNm_QtCore_enumeratorOffset[];
extern char sipNm_QtCore_methodOffset[];
extern char sipNm_QtCore_userProperty[];
extern char sipNm_QtCore_superClass[];
extern char sipNm_QtCore_className[];
extern char sipNm_QtCore_QMetaObject[];
extern char sipNm_QtCore_add[];
extern char sipNm_QtCore_QObjectCleanupHandler[];
extern char sipNm_QtCore_pyqtSignature[];
extern char sipNm_QtCore_SIGNAL[];
extern char sipNm_QtCore_SLOT[];
extern char sipNm_QtCore_QT_TRANSLATE_NOOP[];
extern char sipNm_QtCore_QT_TR_NOOP[];
extern char sipNm_QtCore_Q_FLAGS[];
extern char sipNm_QtCore_Q_ENUMS[];
extern char sipNm_QtCore_disconnectNotify[];
extern char sipNm_QtCore_connectNotify[];
extern char sipNm_QtCore_customEvent[];
extern char sipNm_QtCore_childEvent[];
extern char sipNm_QtCore_timerEvent[];
extern char sipNm_QtCore_receivers[];
extern char sipNm_QtCore_sender[];
extern char sipNm_QtCore_deleteLater[];
extern char sipNm_QtCore_inherits[];
extern char sipNm_QtCore_destroyed[];
extern char sipNm_QtCore_property[];
extern char sipNm_QtCore_setProperty[];
extern char sipNm_QtCore_dynamicPropertyNames[];
extern char sipNm_QtCore_dumpObjectTree[];
extern char sipNm_QtCore_dumpObjectInfo[];
extern char sipNm_QtCore_disconnect[];
extern char sipNm_QtCore_connect[];
extern char sipNm_QtCore_removeEventFilter[];
extern char sipNm_QtCore_installEventFilter[];
extern char sipNm_QtCore_setParent[];
extern char sipNm_QtCore_children[];
extern char sipNm_QtCore_killTimer[];
extern char sipNm_QtCore_startTimer[];
extern char sipNm_QtCore_moveToThread[];
extern char sipNm_QtCore_thread[];
extern char sipNm_QtCore_blockSignals[];
extern char sipNm_QtCore_signalsBlocked[];
extern char sipNm_QtCore_isWidgetType[];
extern char sipNm_QtCore_setObjectName[];
extern char sipNm_QtCore_objectName[];
extern char sipNm_QtCore_emit[];
extern char sipNm_QtCore_findChildren[];
extern char sipNm_QtCore_findChild[];
extern char sipNm_QtCore_trUtf8[];
extern char sipNm_QtCore_tr[];
extern char sipNm_QtCore_eventFilter[];
extern char sipNm_QtCore_metaObject[];
extern char sipNm_QtCore_staticMetaObject[];
extern char sipNm_QtCore_QWidget[];
extern char sipNm_QtCore_qQNaN[];
extern char sipNm_QtCore_qSNaN[];
extern char sipNm_QtCore_qInf[];
extern char sipNm_QtCore_qIsNaN[];
extern char sipNm_QtCore_qIsFinite[];
extern char sipNm_QtCore_qIsInf[];
extern char sipNm_QtCore___exit__[];
extern char sipNm_QtCore___enter__[];
extern char sipNm_QtCore_mutex[];
extern char sipNm_QtCore_relock[];
extern char sipNm_QtCore_QMutexLocker[];
extern char sipNm_QtCore_unlock[];
extern char sipNm_QtCore_tryLock[];
extern char sipNm_QtCore_lock[];
extern char sipNm_QtCore_Recursive[];
extern char sipNm_QtCore_NonRecursive[];
extern char sipNm_QtCore_QMutex[];
extern char sipNm_QtCore_retrieveData[];
extern char sipNm_QtCore_removeFormat[];
extern char sipNm_QtCore_formats[];
extern char sipNm_QtCore_hasFormat[];
extern char sipNm_QtCore_hasColor[];
extern char sipNm_QtCore_setColorData[];
extern char sipNm_QtCore_colorData[];
extern char sipNm_QtCore_hasImage[];
extern char sipNm_QtCore_setImageData[];
extern char sipNm_QtCore_imageData[];
extern char sipNm_QtCore_hasHtml[];
extern char sipNm_QtCore_setHtml[];
extern char sipNm_QtCore_html[];
extern char sipNm_QtCore_hasText[];
extern char sipNm_QtCore_setText[];
extern char sipNm_QtCore_text[];
extern char sipNm_QtCore_hasUrls[];
extern char sipNm_QtCore_setUrls[];
extern char sipNm_QtCore_urls[];
extern char sipNm_QtCore_QMimeData[];
extern char sipNm_QtCore_isRegistered[];
extern char sipNm_QtCore_QWidgetStar[];
extern char sipNm_QtCore_QObjectStar[];
extern char sipNm_QtCore_Float[];
extern char sipNm_QtCore_UChar[];
extern char sipNm_QtCore_UShort[];
extern char sipNm_QtCore_ULong[];
extern char sipNm_QtCore_Char[];
extern char sipNm_QtCore_Short[];
extern char sipNm_QtCore_Long[];
extern char sipNm_QtCore_VoidStar[];
extern char sipNm_QtCore_QTransform[];
extern char sipNm_QtCore_QMatrix[];
extern char sipNm_QtCore_QTextFormat[];
extern char sipNm_QtCore_QTextLength[];
extern char sipNm_QtCore_QPen[];
extern char sipNm_QtCore_QKeySequence[];
extern char sipNm_QtCore_QSizePolicy[];
extern char sipNm_QtCore_QCursor[];
extern char sipNm_QtCore_QBitmap[];
extern char sipNm_QtCore_QRegion[];
extern char sipNm_QtCore_QPolygon[];
extern char sipNm_QtCore_QImage[];
extern char sipNm_QtCore_QIcon[];
extern char sipNm_QtCore_QPalette[];
extern char sipNm_QtCore_QColor[];
extern char sipNm_QtCore_QBrush[];
extern char sipNm_QtCore_QPixmap[];
extern char sipNm_QtCore_QFont[];
extern char sipNm_QtCore_FirstGuiType[];
extern char sipNm_QtCore_LastCoreType[];
extern char sipNm_QtCore_QRegExp[];
extern char sipNm_QtCore_QPointF[];
extern char sipNm_QtCore_QPoint[];
extern char sipNm_QtCore_QSizeF[];
extern char sipNm_QtCore_QSize[];
extern char sipNm_QtCore_QRectF[];
extern char sipNm_QtCore_QRect[];
extern char sipNm_QtCore_QUrl[];
extern char sipNm_QtCore_QStringList[];
extern char sipNm_QtCore_QString[];
extern char sipNm_QtCore_QVariantList[];
extern char sipNm_QtCore_QVariantMap[];
extern char sipNm_QtCore_Double[];
extern char sipNm_QtCore_ULongLong[];
extern char sipNm_QtCore_LongLong[];
extern char sipNm_QtCore_UInt[];
extern char sipNm_QtCore_Int[];
extern char sipNm_QtCore_Bool[];
extern char sipNm_QtCore_Void[];
extern char sipNm_QtCore_QMetaType[];
extern char sipNm_QtCore_QMetaClassInfo[];
extern char sipNm_QtCore_userType[];
extern char sipNm_QtCore_isUser[];
extern char sipNm_QtCore_isResettable[];
extern char sipNm_QtCore_hasStdCppSet[];
extern char sipNm_QtCore_enumerator[];
extern char sipNm_QtCore_isEnumType[];
extern char sipNm_QtCore_isFlagType[];
extern char sipNm_QtCore_isEditable[];
extern char sipNm_QtCore_isStored[];
extern char sipNm_QtCore_isScriptable[];
extern char sipNm_QtCore_isDesignable[];
extern char sipNm_QtCore_QMetaProperty[];
extern char sipNm_QtCore_valueToKeys[];
extern char sipNm_QtCore_keysToValue[];
extern char sipNm_QtCore_valueToKey[];
extern char sipNm_QtCore_keyToValue[];
extern char sipNm_QtCore_scope[];
extern char sipNm_QtCore_value[];
extern char sipNm_QtCore_key[];
extern char sipNm_QtCore_keyCount[];
extern char sipNm_QtCore_isFlag[];
extern char sipNm_QtCore_QMetaEnum[];
extern char sipNm_QtCore_methodType[];
extern char sipNm_QtCore_Slot[];
extern char sipNm_QtCore_Signal[];
extern char sipNm_QtCore_Method[];
extern char sipNm_QtCore_access[];
extern char sipNm_QtCore_Public[];
extern char sipNm_QtCore_Protected[];
extern char sipNm_QtCore_Private[];
extern char sipNm_QtCore_tag[];
extern char sipNm_QtCore_parameterNames[];
extern char sipNm_QtCore_parameterTypes[];
extern char sipNm_QtCore_typeName[];
extern char sipNm_QtCore_signature[];
extern char sipNm_QtCore_QMetaMethod[];
extern char sipNm_QtCore_fallbackLocale[];
extern char sipNm_QtCore_query[];
extern char sipNm_QtCore_DateTimeToStringShort[];
extern char sipNm_QtCore_DateTimeToStringLong[];
extern char sipNm_QtCore_DateTimeFormatShort[];
extern char sipNm_QtCore_DateTimeFormatLong[];
extern char sipNm_QtCore_TimeToStringShort[];
extern char sipNm_QtCore_TimeToStringLong[];
extern char sipNm_QtCore_DateToStringShort[];
extern char sipNm_QtCore_DateToStringLong[];
extern char sipNm_QtCore_MonthNameShort[];
extern char sipNm_QtCore_MonthNameLong[];
extern char sipNm_QtCore_DayNameShort[];
extern char sipNm_QtCore_DayNameLong[];
extern char sipNm_QtCore_TimeFormatShort[];
extern char sipNm_QtCore_TimeFormatLong[];
extern char sipNm_QtCore_DateFormatShort[];
extern char sipNm_QtCore_DateFormatLong[];
extern char sipNm_QtCore_NegativeSign[];
extern char sipNm_QtCore_ZeroDigit[];
extern char sipNm_QtCore_GroupSeparator[];
extern char sipNm_QtCore_DecimalPoint[];
extern char sipNm_QtCore_CountryId[];
extern char sipNm_QtCore_LanguageId[];
extern char sipNm_QtCore_QSystemLocale[];
extern char sipNm_QtCore_measurementSystem[];
extern char sipNm_QtCore_ImperialSystem[];
extern char sipNm_QtCore_MetricSystem[];
extern char sipNm_QtCore_MeasurementSystem[];
extern char sipNm_QtCore_countriesForLanguage[];
extern char sipNm_QtCore_numberOptions[];
extern char sipNm_QtCore_setNumberOptions[];
extern char sipNm_QtCore_dayName[];
extern char sipNm_QtCore_monthName[];
extern char sipNm_QtCore_exponential[];
extern char sipNm_QtCore_negativeSign[];
extern char sipNm_QtCore_zeroDigit[];
extern char sipNm_QtCore_percent[];
extern char sipNm_QtCore_groupSeparator[];
extern char sipNm_QtCore_decimalPoint[];
extern char sipNm_QtCore_toDateTime[];
extern char sipNm_QtCore_toTime[];
extern char sipNm_QtCore_toDate[];
extern char sipNm_QtCore_dateTimeFormat[];
extern char sipNm_QtCore_timeFormat[];
extern char sipNm_QtCore_dateFormat[];
extern char sipNm_QtCore_ShortFormat[];
extern char sipNm_QtCore_LongFormat[];
extern char sipNm_QtCore_system[];
extern char sipNm_QtCore_c[];
extern char sipNm_QtCore_setDefault[];
extern char sipNm_QtCore_countryToString[];
extern char sipNm_QtCore_languageToString[];
extern char sipNm_QtCore_name[];
extern char sipNm_QtCore_country[];
extern char sipNm_QtCore_language[];
extern char sipNm_QtCore_NumberOptions[];
extern char sipNm_QtCore_RejectGroupSeparator[];
extern char sipNm_QtCore_OmitGroupSeparator[];
extern char sipNm_QtCore_NumberOption[];
extern char sipNm_QtCore_LastCountry[];
extern char sipNm_QtCore_SerbiaAndMontenegro[];
extern char sipNm_QtCore_Zimbabwe[];
extern char sipNm_QtCore_Zambia[];
extern char sipNm_QtCore_Yugoslavia[];
extern char sipNm_QtCore_Yemen[];
extern char sipNm_QtCore_WesternSahara[];
extern char sipNm_QtCore_WallisAndFutunaIslands[];
extern char sipNm_QtCore_USVirginIslands[];
extern char sipNm_QtCore_BritishVirginIslands[];
extern char sipNm_QtCore_VietNam[];
extern char sipNm_QtCore_Venezuela[];
extern char sipNm_QtCore_VaticanCityState[];
extern char sipNm_QtCore_Vanuatu[];
extern char sipNm_QtCore_Uzbekistan[];
extern char sipNm_QtCore_Uruguay[];
extern char sipNm_QtCore_UnitedStatesMinorOutlyingIslands[];
extern char sipNm_QtCore_UnitedStates[];
extern char sipNm_QtCore_UnitedKingdom[];
extern char sipNm_QtCore_UnitedArabEmirates[];
extern char sipNm_QtCore_Ukraine[];
extern char sipNm_QtCore_Uganda[];
extern char sipNm_QtCore_Tuvalu[];
extern char sipNm_QtCore_TurksAndCaicosIslands[];
extern char sipNm_QtCore_Turkmenistan[];
extern char sipNm_QtCore_Turkey[];
extern char sipNm_QtCore_Tunisia[];
extern char sipNm_QtCore_TrinidadAndTobago[];
extern char sipNm_QtCore_TongaCountry[];
extern char sipNm_QtCore_Tokelau[];
extern char sipNm_QtCore_Togo[];
extern char sipNm_QtCore_Thailand[];
extern char sipNm_QtCore_Tanzania[];
extern char sipNm_QtCore_Tajikistan[];
extern char sipNm_QtCore_Taiwan[];
extern char sipNm_QtCore_SyrianArabRepublic[];
extern char sipNm_QtCore_Switzerland[];
extern char sipNm_QtCore_Sweden[];
extern char sipNm_QtCore_Swaziland[];
extern char sipNm_QtCore_SvalbardAndJanMayenIslands[];
extern char sipNm_QtCore_Suriname[];
extern char sipNm_QtCore_Sudan[];
extern char sipNm_QtCore_StPierreAndMiquelon[];
extern char sipNm_QtCore_StHelena[];
extern char sipNm_QtCore_SriLanka[];
extern char sipNm_QtCore_Spain[];
extern char sipNm_QtCore_SouthGeorgiaAndTheSouthSandwichIslands[];
extern char sipNm_QtCore_SouthAfrica[];
extern char sipNm_QtCore_Somalia[];
extern char sipNm_QtCore_SolomonIslands[];
extern char sipNm_QtCore_Slovenia[];
extern char sipNm_QtCore_Slovakia[];
extern char sipNm_QtCore_Singapore[];
extern char sipNm_QtCore_SierraLeone[];
extern char sipNm_QtCore_Seychelles[];
extern char sipNm_QtCore_Senegal[];
extern char sipNm_QtCore_SaudiArabia[];
extern char sipNm_QtCore_SaoTomeAndPrincipe[];
extern char sipNm_QtCore_SanMarino[];
extern char sipNm_QtCore_Samoa[];
extern char sipNm_QtCore_StVincentAndTheGrenadines[];
extern char sipNm_QtCore_StLucia[];
extern char sipNm_QtCore_SaintKittsAndNevis[];
extern char sipNm_QtCore_Rwanda[];
extern char sipNm_QtCore_RussianFederation[];
extern char sipNm_QtCore_Romania[];
extern char sipNm_QtCore_Reunion[];
extern char sipNm_QtCore_Qatar[];
extern char sipNm_QtCore_PuertoRico[];
extern char sipNm_QtCore_Portugal[];
extern char sipNm_QtCore_Poland[];
extern char sipNm_QtCore_Pitcairn[];
extern char sipNm_QtCore_Philippines[];
extern char sipNm_QtCore_Peru[];
extern char sipNm_QtCore_Paraguay[];
extern char sipNm_QtCore_PapuaNewGuinea[];
extern char sipNm_QtCore_Panama[];
extern char sipNm_QtCore_PalestinianTerritory[];
extern char sipNm_QtCore_Palau[];
extern char sipNm_QtCore_Pakistan[];
extern char sipNm_QtCore_Oman[];
extern char sipNm_QtCore_Norway[];
extern char sipNm_QtCore_NorthernMarianaIslands[];
extern char sipNm_QtCore_NorfolkIsland[];
extern char sipNm_QtCore_Niue[];
extern char sipNm_QtCore_Nigeria[];
extern char sipNm_QtCore_Niger[];
extern char sipNm_QtCore_Nicaragua[];
extern char sipNm_QtCore_NewZealand[];
extern char sipNm_QtCore_NewCaledonia[];
extern char sipNm_QtCore_NetherlandsAntilles[];
extern char sipNm_QtCore_Netherlands[];
extern char sipNm_QtCore_Nepal[];
extern char sipNm_QtCore_NauruCountry[];
extern char sipNm_QtCore_Namibia[];
extern char sipNm_QtCore_Myanmar[];
extern char sipNm_QtCore_Mozambique[];
extern char sipNm_QtCore_Morocco[];
extern char sipNm_QtCore_Montserrat[];
extern char sipNm_QtCore_Mongolia[];
extern char sipNm_QtCore_Monaco[];
extern char sipNm_QtCore_Moldova[];
extern char sipNm_QtCore_Micronesia[];
extern char sipNm_QtCore_Mexico[];
extern char sipNm_QtCore_Mayotte[];
extern char sipNm_QtCore_Mauritius[];
extern char sipNm_QtCore_Mauritania[];
extern char sipNm_QtCore_Martinique[];
extern char sipNm_QtCore_MarshallIslands[];
extern char sipNm_QtCore_Malta[];
extern char sipNm_QtCore_Mali[];
extern char sipNm_QtCore_Maldives[];
extern char sipNm_QtCore_Malaysia[];
extern char sipNm_QtCore_Malawi[];
extern char sipNm_QtCore_Madagascar[];
extern char sipNm_QtCore_Macedonia[];
extern char sipNm_QtCore_Macau[];
extern char sipNm_QtCore_Luxembourg[];
extern char sipNm_QtCore_Lithuania[];
extern char sipNm_QtCore_Liechtenstein[];
extern char sipNm_QtCore_LibyanArabJamahiriya[];
extern char sipNm_QtCore_Liberia[];
extern char sipNm_QtCore_Lesotho[];
extern char sipNm_QtCore_Lebanon[];
extern char sipNm_QtCore_Latvia[];
extern char sipNm_QtCore_Lao[];
extern char sipNm_QtCore_Kyrgyzstan[];
extern char sipNm_QtCore_Kuwait[];
extern char sipNm_QtCore_RepublicOfKorea[];
extern char sipNm_QtCore_DemocraticRepublicOfKorea[];
extern char sipNm_QtCore_Kiribati[];
extern char sipNm_QtCore_Kenya[];
extern char sipNm_QtCore_Kazakhstan[];
extern char sipNm_QtCore_Jordan[];
extern char sipNm_QtCore_Japan[];
extern char sipNm_QtCore_Jamaica[];
extern char sipNm_QtCore_Italy[];
extern char sipNm_QtCore_Israel[];
extern char sipNm_QtCore_Ireland[];
extern char sipNm_QtCore_Iraq[];
extern char sipNm_QtCore_Iran[];
extern char sipNm_QtCore_Indonesia[];
extern char sipNm_QtCore_India[];
extern char sipNm_QtCore_Iceland[];
extern char sipNm_QtCore_Hungary[];
extern char sipNm_QtCore_HongKong[];
extern char sipNm_QtCore_Honduras[];
extern char sipNm_QtCore_HeardAndMcDonaldIslands[];
extern char sipNm_QtCore_Haiti[];
extern char sipNm_QtCore_Guyana[];
extern char sipNm_QtCore_GuineaBissau[];
extern char sipNm_QtCore_Guinea[];
extern char sipNm_QtCore_Guatemala[];
extern char sipNm_QtCore_Guam[];
extern char sipNm_QtCore_Guadeloupe[];
extern char sipNm_QtCore_Grenada[];
extern char sipNm_QtCore_Greenland[];
extern char sipNm_QtCore_Greece[];
extern char sipNm_QtCore_Gibraltar[];
extern char sipNm_QtCore_Ghana[];
extern char sipNm_QtCore_Germany[];
extern char sipNm_QtCore_Georgia[];
extern char sipNm_QtCore_Gambia[];
extern char sipNm_QtCore_Gabon[];
extern char sipNm_QtCore_FrenchSouthernTerritories[];
extern char sipNm_QtCore_FrenchPolynesia[];
extern char sipNm_QtCore_FrenchGuiana[];
extern char sipNm_QtCore_MetropolitanFrance[];
extern char sipNm_QtCore_France[];
extern char sipNm_QtCore_Finland[];
extern char sipNm_QtCore_FijiCountry[];
extern char sipNm_QtCore_FaroeIslands[];
extern char sipNm_QtCore_FalklandIslands[];
extern char sipNm_QtCore_Ethiopia[];
extern char sipNm_QtCore_Estonia[];
extern char sipNm_QtCore_Eritrea[];
extern char sipNm_QtCore_EquatorialGuinea[];
extern char sipNm_QtCore_ElSalvador[];
extern char sipNm_QtCore_Egypt[];
extern char sipNm_QtCore_Ecuador[];
extern char sipNm_QtCore_EastTimor[];
extern char sipNm_QtCore_DominicanRepublic[];
extern char sipNm_QtCore_Dominica[];
extern char sipNm_QtCore_Djibouti[];
extern char sipNm_QtCore_Denmark[];
extern char sipNm_QtCore_CzechRepublic[];
extern char sipNm_QtCore_Cyprus[];
extern char sipNm_QtCore_Cuba[];
extern char sipNm_QtCore_Croatia[];
extern char sipNm_QtCore_IvoryCoast[];
extern char sipNm_QtCore_CostaRica[];
extern char sipNm_QtCore_CookIslands[];
extern char sipNm_QtCore_PeoplesRepublicOfCongo[];
extern char sipNm_QtCore_DemocraticRepublicOfCongo[];
extern char sipNm_QtCore_Comoros[];
extern char sipNm_QtCore_Colombia[];
extern char sipNm_QtCore_CocosIslands[];
extern char sipNm_QtCore_ChristmasIsland[];
extern char sipNm_QtCore_China[];
extern char sipNm_QtCore_Chile[];
extern char sipNm_QtCore_Chad[];
extern char sipNm_QtCore_CentralAfricanRepublic[];
extern char sipNm_QtCore_CaymanIslands[];
extern char sipNm_QtCore_CapeVerde[];
extern char sipNm_QtCore_Canada[];
extern char sipNm_QtCore_Cameroon[];
extern char sipNm_QtCore_Cambodia[];
extern char sipNm_QtCore_Burundi[];
extern char sipNm_QtCore_BurkinaFaso[];
extern char sipNm_QtCore_Bulgaria[];
extern char sipNm_QtCore_BruneiDarussalam[];
extern char sipNm_QtCore_BritishIndianOceanTerritory[];
extern char sipNm_QtCore_Brazil[];
extern char sipNm_QtCore_BouvetIsland[];
extern char sipNm_QtCore_Botswana[];
extern char sipNm_QtCore_BosniaAndHerzegowina[];
extern char sipNm_QtCore_Bolivia[];
extern char sipNm_QtCore_Bhutan[];
extern char sipNm_QtCore_Bermuda[];
extern char sipNm_QtCore_Benin[];
extern char sipNm_QtCore_Belize[];
extern char sipNm_QtCore_Belgium[];
extern char sipNm_QtCore_Belarus[];
extern char sipNm_QtCore_Barbados[];
extern char sipNm_QtCore_Bangladesh[];
extern char sipNm_QtCore_Bahrain[];
extern char sipNm_QtCore_Bahamas[];
extern char sipNm_QtCore_Azerbaijan[];
extern char sipNm_QtCore_Austria[];
extern char sipNm_QtCore_Australia[];
extern char sipNm_QtCore_Aruba[];
extern char sipNm_QtCore_Armenia[];
extern char sipNm_QtCore_Argentina[];
extern char sipNm_QtCore_AntiguaAndBarbuda[];
extern char sipNm_QtCore_Antarctica[];
extern char sipNm_QtCore_Anguilla[];
extern char sipNm_QtCore_Angola[];
extern char sipNm_QtCore_Andorra[];
extern char sipNm_QtCore_AmericanSamoa[];
extern char sipNm_QtCore_Algeria[];
extern char sipNm_QtCore_Albania[];
extern char sipNm_QtCore_Afghanistan[];
extern char sipNm_QtCore_AnyCountry[];
extern char sipNm_QtCore_Chewa[];
extern char sipNm_QtCore_Tyap[];
extern char sipNm_QtCore_Hawaiian[];
extern char sipNm_QtCore_Walamo[];
extern char sipNm_QtCore_Ewe[];
extern char sipNm_QtCore_Venda[];
extern char sipNm_QtCore_Friulian[];
extern char sipNm_QtCore_Jju[];
extern char sipNm_QtCore_Tigre[];
extern char sipNm_QtCore_Atsam[];
extern char sipNm_QtCore_Sidamo[];
extern char sipNm_QtCore_Koro[];
extern char sipNm_QtCore_Geez[];
extern char sipNm_QtCore_Blin[];
extern char sipNm_QtCore_Syriac[];
extern char sipNm_QtCore_Kamba[];
extern char sipNm_QtCore_Igbo[];
extern char sipNm_QtCore_Ga[];
extern char sipNm_QtCore_Konkani[];
extern char sipNm_QtCore_Akan[];
extern char sipNm_QtCore_NorwegianNynorsk[];
extern char sipNm_QtCore_NorwegianBokmal[];
extern char sipNm_QtCore_LastLanguage[];
extern char sipNm_QtCore_Cornish[];
extern char sipNm_QtCore_Manx[];
extern char sipNm_QtCore_Divehi[];
extern char sipNm_QtCore_Bosnian[];
extern char sipNm_QtCore_Nynorsk[];
extern char sipNm_QtCore_Zulu[];
extern char sipNm_QtCore_Zhuang[];
extern char sipNm_QtCore_Yoruba[];
extern char sipNm_QtCore_Yiddish[];
extern char sipNm_QtCore_Xhosa[];
extern char sipNm_QtCore_Wolof[];
extern char sipNm_QtCore_Welsh[];
extern char sipNm_QtCore_Volapuk[];
extern char sipNm_QtCore_Vietnamese[];
extern char sipNm_QtCore_Uzbek[];
extern char sipNm_QtCore_Urdu[];
extern char sipNm_QtCore_Ukrainian[];
extern char sipNm_QtCore_Uigur[];
extern char sipNm_QtCore_Twi[];
extern char sipNm_QtCore_Turkmen[];
extern char sipNm_QtCore_Turkish[];
extern char sipNm_QtCore_Tsonga[];
extern char sipNm_QtCore_TongaLanguage[];
extern char sipNm_QtCore_Tigrinya[];
extern char sipNm_QtCore_Tibetan[];
extern char sipNm_QtCore_Thai[];
extern char sipNm_QtCore_Telugu[];
extern char sipNm_QtCore_Tatar[];
extern char sipNm_QtCore_Tamil[];
extern char sipNm_QtCore_Tajik[];
extern char sipNm_QtCore_Tagalog[];
extern char sipNm_QtCore_Swedish[];
extern char sipNm_QtCore_Swahili[];
extern char sipNm_QtCore_Sundanese[];
extern char sipNm_QtCore_Spanish[];
extern char sipNm_QtCore_Somali[];
extern char sipNm_QtCore_Slovenian[];
extern char sipNm_QtCore_Slovak[];
extern char sipNm_QtCore_Siswati[];
extern char sipNm_QtCore_Singhalese[];
extern char sipNm_QtCore_Sindhi[];
extern char sipNm_QtCore_Shona[];
extern char sipNm_QtCore_Setswana[];
extern char sipNm_QtCore_Sesotho[];
extern char sipNm_QtCore_SerboCroatian[];
extern char sipNm_QtCore_Serbian[];
extern char sipNm_QtCore_Sanskrit[];
extern char sipNm_QtCore_Sangho[];
extern char sipNm_QtCore_Samoan[];
extern char sipNm_QtCore_Russian[];
extern char sipNm_QtCore_Romanian[];
extern char sipNm_QtCore_RhaetoRomance[];
extern char sipNm_QtCore_Quechua[];
extern char sipNm_QtCore_Punjabi[];
extern char sipNm_QtCore_Portuguese[];
extern char sipNm_QtCore_Persian[];
extern char sipNm_QtCore_Pashto[];
extern char sipNm_QtCore_Oriya[];
extern char sipNm_QtCore_Occitan[];
extern char sipNm_QtCore_Norwegian[];
extern char sipNm_QtCore_Nepali[];
extern char sipNm_QtCore_NauruLanguage[];
extern char sipNm_QtCore_Mongolian[];
extern char sipNm_QtCore_Moldavian[];
extern char sipNm_QtCore_Marathi[];
extern char sipNm_QtCore_Maori[];
extern char sipNm_QtCore_Maltese[];
extern char sipNm_QtCore_Malayalam[];
extern char sipNm_QtCore_Malay[];
extern char sipNm_QtCore_Malagasy[];
extern char sipNm_QtCore_Macedonian[];
extern char sipNm_QtCore_Lithuanian[];
extern char sipNm_QtCore_Lingala[];
extern char sipNm_QtCore_Latvian[];
extern char sipNm_QtCore_Latin[];
extern char sipNm_QtCore_Laothian[];
extern char sipNm_QtCore_Kurundi[];
extern char sipNm_QtCore_Kurdish[];
extern char sipNm_QtCore_Korean[];
extern char sipNm_QtCore_Kirghiz[];
extern char sipNm_QtCore_Kinyarwanda[];
extern char sipNm_QtCore_Kazakh[];
extern char sipNm_QtCore_Kashmiri[];
extern char sipNm_QtCore_Kannada[];
extern char sipNm_QtCore_Javanese[];
extern char sipNm_QtCore_Japanese[];
extern char sipNm_QtCore_Italian[];
extern char sipNm_QtCore_Irish[];
extern char sipNm_QtCore_Inupiak[];
extern char sipNm_QtCore_Inuktitut[];
extern char sipNm_QtCore_Interlingue[];
extern char sipNm_QtCore_Interlingua[];
extern char sipNm_QtCore_Indonesian[];
extern char sipNm_QtCore_Icelandic[];
extern char sipNm_QtCore_Hungarian[];
extern char sipNm_QtCore_Hindi[];
extern char sipNm_QtCore_Hebrew[];
extern char sipNm_QtCore_Hausa[];
extern char sipNm_QtCore_Gujarati[];
extern char sipNm_QtCore_Guarani[];
extern char sipNm_QtCore_Greenlandic[];
extern char sipNm_QtCore_Greek[];
extern char sipNm_QtCore_German[];
extern char sipNm_QtCore_Georgian[];
extern char sipNm_QtCore_Galician[];
extern char sipNm_QtCore_Gaelic[];
extern char sipNm_QtCore_Frisian[];
extern char sipNm_QtCore_French[];
extern char sipNm_QtCore_Finnish[];
extern char sipNm_QtCore_FijiLanguage[];
extern char sipNm_QtCore_Faroese[];
extern char sipNm_QtCore_Estonian[];
extern char sipNm_QtCore_Esperanto[];
extern char sipNm_QtCore_English[];
extern char sipNm_QtCore_Dutch[];
extern char sipNm_QtCore_Danish[];
extern char sipNm_QtCore_Czech[];
extern char sipNm_QtCore_Croatian[];
extern char sipNm_QtCore_Corsican[];
extern char sipNm_QtCore_Chinese[];
extern char sipNm_QtCore_Catalan[];
extern char sipNm_QtCore_Cambodian[];
extern char sipNm_QtCore_Byelorussian[];
extern char sipNm_QtCore_Burmese[];
extern char sipNm_QtCore_Bulgarian[];
extern char sipNm_QtCore_Breton[];
extern char sipNm_QtCore_Bislama[];
extern char sipNm_QtCore_Bihari[];
extern char sipNm_QtCore_Bhutani[];
extern char sipNm_QtCore_Bengali[];
extern char sipNm_QtCore_Basque[];
extern char sipNm_QtCore_Bashkir[];
extern char sipNm_QtCore_Azerbaijani[];
extern char sipNm_QtCore_Aymara[];
extern char sipNm_QtCore_Assamese[];
extern char sipNm_QtCore_Armenian[];
extern char sipNm_QtCore_Arabic[];
extern char sipNm_QtCore_Amharic[];
extern char sipNm_QtCore_Albanian[];
extern char sipNm_QtCore_Afrikaans[];
extern char sipNm_QtCore_Afar[];
extern char sipNm_QtCore_Afan[];
extern char sipNm_QtCore_Abkhazian[];
extern char sipNm_QtCore_C[];
extern char sipNm_QtCore_QLocale[];
extern char sipNm_QtCore_QList[];
extern char sipNm_QtCore_angleTo[];
extern char sipNm_QtCore_setAngle[];
extern char sipNm_QtCore_fromPolar[];
extern char sipNm_QtCore_toLine[];
extern char sipNm_QtCore_pointAt[];
extern char sipNm_QtCore_setLength[];
extern char sipNm_QtCore_normalVector[];
extern char sipNm_QtCore_angle[];
extern char sipNm_QtCore_intersect[];
extern char sipNm_QtCore_unitVector[];
extern char sipNm_QtCore_UnboundedIntersection[];
extern char sipNm_QtCore_BoundedIntersection[];
extern char sipNm_QtCore_NoIntersection[];
extern char sipNm_QtCore_QLineF[];
extern char sipNm_QtCore_setLine[];
extern char sipNm_QtCore_setPoints[];
extern char sipNm_QtCore_setP2[];
extern char sipNm_QtCore_setP1[];
extern char sipNm_QtCore_translated[];
extern char sipNm_QtCore_dy[];
extern char sipNm_QtCore_dx[];
extern char sipNm_QtCore_p2[];
extern char sipNm_QtCore_p1[];
extern char sipNm_QtCore_y2[];
extern char sipNm_QtCore_x2[];
extern char sipNm_QtCore_y1[];
extern char sipNm_QtCore_x1[];
extern char sipNm_QtCore_QLine[];
extern char sipNm_QtCore_location[];
extern char sipNm_QtCore_ExamplesPath[];
extern char sipNm_QtCore_DemosPath[];
extern char sipNm_QtCore_SettingsPath[];
extern char sipNm_QtCore_TranslationsPath[];
extern char sipNm_QtCore_DataPath[];
extern char sipNm_QtCore_PluginsPath[];
extern char sipNm_QtCore_BinariesPath[];
extern char sipNm_QtCore_LibrariesPath[];
extern char sipNm_QtCore_HeadersPath[];
extern char sipNm_QtCore_DocumentationPath[];
extern char sipNm_QtCore_PrefixPath[];
extern char sipNm_QtCore_buildKey[];
extern char sipNm_QtCore_licensedProducts[];
extern char sipNm_QtCore_licensee[];
extern char sipNm_QtCore_QLibraryInfo[];
extern char sipNm_QtCore_setLoadHints[];
extern char sipNm_QtCore_setFileNameAndVersion[];
extern char sipNm_QtCore_isLibrary[];
extern char sipNm_QtCore_unload[];
extern char sipNm_QtCore_resolve[];
extern char sipNm_QtCore_loadHints[];
extern char sipNm_QtCore_load[];
extern char sipNm_QtCore_isLoaded[];
extern char sipNm_QtCore_LoadHints[];
extern char sipNm_QtCore_LoadArchiveMemberHint[];
extern char sipNm_QtCore_ExportExternalSymbolsHint[];
extern char sipNm_QtCore_ResolveAllSymbolsHint[];
extern char sipNm_QtCore_LoadHint[];
extern char sipNm_QtCore_QLibrary[];
extern char sipNm_QtCore_setErrorString[];
extern char sipNm_QtCore_setOpenMode[];
extern char sipNm_QtCore_readChannelFinished[];
extern char sipNm_QtCore_aboutToClose[];
extern char sipNm_QtCore_bytesWritten[];
extern char sipNm_QtCore_readyRead[];
extern char sipNm_QtCore_getChar[];
extern char sipNm_QtCore_putChar[];
extern char sipNm_QtCore_ungetChar[];
extern char sipNm_QtCore_waitForBytesWritten[];
extern char sipNm_QtCore_waitForReadyRead[];
extern char sipNm_QtCore_peek[];
extern char sipNm_QtCore_readAll[];
extern char sipNm_QtCore_bytesToWrite[];
extern char sipNm_QtCore_bytesAvailable[];
extern char sipNm_QtCore_isOpen[];
extern char sipNm_QtCore_isTextModeEnabled[];
extern char sipNm_QtCore_setTextModeEnabled[];
extern char sipNm_QtCore_openMode[];
extern char sipNm_QtCore_OpenMode[];
extern char sipNm_QtCore_Unbuffered[];
extern char sipNm_QtCore_Text[];
extern char sipNm_QtCore_Truncate[];
extern char sipNm_QtCore_Append[];
extern char sipNm_QtCore_ReadWrite[];
extern char sipNm_QtCore_WriteOnly[];
extern char sipNm_QtCore_ReadOnly[];
extern char sipNm_QtCore_NotOpen[];
extern char sipNm_QtCore_OpenModeFlag[];
extern char sipNm_QtCore_setCurrentPath[];
extern char sipNm_QtCore_QFSFileEngine[];
extern char sipNm_QtCore_fileChanged[];
extern char sipNm_QtCore_directoryChanged[];
extern char sipNm_QtCore_removePaths[];
extern char sipNm_QtCore_removePath[];
extern char sipNm_QtCore_files[];
extern char sipNm_QtCore_directories[];
extern char sipNm_QtCore_addPaths[];
extern char sipNm_QtCore_addPath[];
extern char sipNm_QtCore_QFileSystemWatcher[];
extern char sipNm_QtCore_isBundle[];
extern char sipNm_QtCore_bundleName[];
extern char sipNm_QtCore_setCaching[];
extern char sipNm_QtCore_caching[];
extern char sipNm_QtCore_lastRead[];
extern char sipNm_QtCore_lastModified[];
extern char sipNm_QtCore_created[];
extern char sipNm_QtCore_permission[];
extern char sipNm_QtCore_groupId[];
extern char sipNm_QtCore_group[];
extern char sipNm_QtCore_isSymLink[];
extern char sipNm_QtCore_isDir[];
extern char sipNm_QtCore_isFile[];
extern char sipNm_QtCore_isHidden[];
extern char sipNm_QtCore_isExecutable[];
extern char sipNm_QtCore_isWritable[];
extern char sipNm_QtCore_absoluteDir[];
extern char sipNm_QtCore_dir[];
extern char sipNm_QtCore_completeSuffix[];
extern char sipNm_QtCore_suffix[];
extern char sipNm_QtCore_completeBaseName[];
extern char sipNm_QtCore_baseName[];
extern char sipNm_QtCore_canonicalFilePath[];
extern char sipNm_QtCore_setFile[];
extern char sipNm_QtCore_QFileInfo[];
extern char sipNm_QtCore_readLineData[];
extern char sipNm_QtCore_symLinkTarget[];
extern char sipNm_QtCore_fileEngine[];
extern char sipNm_QtCore_permissions[];
extern char sipNm_QtCore_readLink[];
extern char sipNm_QtCore_decodeName[];
extern char sipNm_QtCore_encodeName[];
extern char sipNm_QtCore_unsetError[];
extern char sipNm_QtCore_Permissions[];
extern char sipNm_QtCore_ExeOther[];
extern char sipNm_QtCore_WriteOther[];
extern char sipNm_QtCore_ReadOther[];
extern char sipNm_QtCore_ExeGroup[];
extern char sipNm_QtCore_WriteGroup[];
extern char sipNm_QtCore_ReadGroup[];
extern char sipNm_QtCore_ExeUser[];
extern char sipNm_QtCore_WriteUser[];
extern char sipNm_QtCore_ReadUser[];
extern char sipNm_QtCore_ExeOwner[];
extern char sipNm_QtCore_WriteOwner[];
extern char sipNm_QtCore_ReadOwner[];
extern char sipNm_QtCore_Permission[];
extern char sipNm_QtCore_NoOptions[];
extern char sipNm_QtCore_CopyError[];
extern char sipNm_QtCore_PermissionsError[];
extern char sipNm_QtCore_ResizeError[];
extern char sipNm_QtCore_PositionError[];
extern char sipNm_QtCore_RenameError[];
extern char sipNm_QtCore_RemoveError[];
extern char sipNm_QtCore_UnspecifiedError[];
extern char sipNm_QtCore_TimeOutError[];
extern char sipNm_QtCore_AbortError[];
extern char sipNm_QtCore_OpenError[];
extern char sipNm_QtCore_ResourceError[];
extern char sipNm_QtCore_FatalError[];
extern char sipNm_QtCore_WriteError[];
extern char sipNm_QtCore_ReadError[];
extern char sipNm_QtCore_NoError[];
extern char sipNm_QtCore_QFile[];
extern char sipNm_QtCore_isRunning[];
extern char sipNm_QtCore_ProcessEventsFlags[];
extern char sipNm_QtCore_DeferredDeletion[];
extern char sipNm_QtCore_X11ExcludeTimers[];
extern char sipNm_QtCore_WaitForMoreEvents[];
extern char sipNm_QtCore_ExcludeSocketNotifiers[];
extern char sipNm_QtCore_ExcludeUserInputEvents[];
extern char sipNm_QtCore_AllEvents[];
extern char sipNm_QtCore_ProcessEventsFlag[];
extern char sipNm_QtCore_QEventLoop[];
extern char sipNm_QtCore_fileInfo[];
extern char sipNm_QtCore_IteratorFlags[];
extern char sipNm_QtCore_Subdirectories[];
extern char sipNm_QtCore_FollowSymlinks[];
extern char sipNm_QtCore_NoIteratorFlags[];
extern char sipNm_QtCore_IteratorFlag[];
extern char sipNm_QtCore_QDirIterator[];
extern char sipNm_QtCore_searchPaths[];
extern char sipNm_QtCore_addSearchPath[];
extern char sipNm_QtCore_setSearchPaths[];
extern char sipNm_QtCore_fromNativeSeparators[];
extern char sipNm_QtCore_toNativeSeparators[];
extern char sipNm_QtCore_cleanPath[];
extern char sipNm_QtCore_tempPath[];
extern char sipNm_QtCore_temp[];
extern char sipNm_QtCore_rootPath[];
extern char sipNm_QtCore_root[];
extern char sipNm_QtCore_homePath[];
extern char sipNm_QtCore_home[];
extern char sipNm_QtCore_currentPath[];
extern char sipNm_QtCore_current[];
extern char sipNm_QtCore_setCurrent[];
extern char sipNm_QtCore_separator[];
extern char sipNm_QtCore_drives[];
extern char sipNm_QtCore_refresh[];
extern char sipNm_QtCore_makeAbsolute[];
extern char sipNm_QtCore_isAbsolute[];
extern char sipNm_QtCore_isRelative[];
extern char sipNm_QtCore_isAbsolutePath[];
extern char sipNm_QtCore_isRoot[];
extern char sipNm_QtCore_exists[];
extern char sipNm_QtCore_isReadable[];
extern char sipNm_QtCore_rmpath[];
extern char sipNm_QtCore_mkpath[];
extern char sipNm_QtCore_entryInfoList[];
extern char sipNm_QtCore_nameFiltersFromString[];
extern char sipNm_QtCore_setSorting[];
extern char sipNm_QtCore_sorting[];
extern char sipNm_QtCore_setFilter[];
extern char sipNm_QtCore_filter[];
extern char sipNm_QtCore_setNameFilters[];
extern char sipNm_QtCore_cdUp[];
extern char sipNm_QtCore_cd[];
extern char sipNm_QtCore_convertSeparators[];
extern char sipNm_QtCore_relativeFilePath[];
extern char sipNm_QtCore_absoluteFilePath[];
extern char sipNm_QtCore_filePath[];
extern char sipNm_QtCore_dirName[];
extern char sipNm_QtCore_addResourceSearchPath[];
extern char sipNm_QtCore_canonicalPath[];
extern char sipNm_QtCore_absolutePath[];
extern char sipNm_QtCore_setPath[];
extern char sipNm_QtCore_SortFlags[];
extern char sipNm_QtCore_NoSort[];
extern char sipNm_QtCore_LocaleAware[];
extern char sipNm_QtCore_DirsLast[];
extern char sipNm_QtCore_IgnoreCase[];
extern char sipNm_QtCore_Reversed[];
extern char sipNm_QtCore_DirsFirst[];
extern char sipNm_QtCore_SortByMask[];
extern char sipNm_QtCore_Unsorted[];
extern char sipNm_QtCore_Size[];
extern char sipNm_QtCore_Time[];
extern char sipNm_QtCore_Name[];
extern char sipNm_QtCore_SortFlag[];
extern char sipNm_QtCore_Filters[];
extern char sipNm_QtCore_NoFilter[];
extern char sipNm_QtCore_NoDotAndDotDot[];
extern char sipNm_QtCore_AllDirs[];
extern char sipNm_QtCore_AccessMask[];
extern char sipNm_QtCore_System[];
extern char sipNm_QtCore_Hidden[];
extern char sipNm_QtCore_Modified[];
extern char sipNm_QtCore_PermissionMask[];
extern char sipNm_QtCore_Executable[];
extern char sipNm_QtCore_Writable[];
extern char sipNm_QtCore_Readable[];
extern char sipNm_QtCore_TypeMask[];
extern char sipNm_QtCore_AllEntries[];
extern char sipNm_QtCore_NoSymLinks[];
extern char sipNm_QtCore_Drives[];
extern char sipNm_QtCore_Files[];
extern char sipNm_QtCore_Dirs[];
extern char sipNm_QtCore_Filter[];
extern char sipNm_QtCore_QDir[];
extern char sipNm_QtCore_fromTime_t[];
extern char sipNm_QtCore_currentDateTime[];
extern char sipNm_QtCore_toUTC[];
extern char sipNm_QtCore_toLocalTime[];
extern char sipNm_QtCore_toTimeSpec[];
extern char sipNm_QtCore_setTime_t[];
extern char sipNm_QtCore_setTimeSpec[];
extern char sipNm_QtCore_setTime[];
extern char sipNm_QtCore_toTime_t[];
extern char sipNm_QtCore_timeSpec[];
extern char sipNm_QtCore_time[];
extern char sipNm_QtCore_date[];
extern char sipNm_QtCore_toPyDateTime[];
extern char sipNm_QtCore_QDateTime[];
extern char sipNm_QtCore_elapsed[];
extern char sipNm_QtCore_restart[];
extern char sipNm_QtCore_currentTime[];
extern char sipNm_QtCore_msecsTo[];
extern char sipNm_QtCore_addMSecs[];
extern char sipNm_QtCore_secsTo[];
extern char sipNm_QtCore_addSecs[];
extern char sipNm_QtCore_setHMS[];
extern char sipNm_QtCore_msec[];
extern char sipNm_QtCore_second[];
extern char sipNm_QtCore_minute[];
extern char sipNm_QtCore_hour[];
extern char sipNm_QtCore_toPyTime[];
extern char sipNm_QtCore_QTime[];
extern char sipNm_QtCore_setDate[];
extern char sipNm_QtCore_toJulianDay[];
extern char sipNm_QtCore_fromJulianDay[];
extern char sipNm_QtCore_julianToGregorian[];
extern char sipNm_QtCore_gregorianToJulian[];
extern char sipNm_QtCore_isLeapYear[];
extern char sipNm_QtCore_fromString[];
extern char sipNm_QtCore_currentDate[];
extern char sipNm_QtCore_daysTo[];
extern char sipNm_QtCore_addYears[];
extern char sipNm_QtCore_addMonths[];
extern char sipNm_QtCore_addDays[];
extern char sipNm_QtCore_setYMD[];
extern char sipNm_QtCore_toString[];
extern char sipNm_QtCore_longDayName[];
extern char sipNm_QtCore_longMonthName[];
extern char sipNm_QtCore_shortDayName[];
extern char sipNm_QtCore_shortMonthName[];
extern char sipNm_QtCore_weekNumber[];
extern char sipNm_QtCore_daysInYear[];
extern char sipNm_QtCore_daysInMonth[];
extern char sipNm_QtCore_dayOfYear[];
extern char sipNm_QtCore_dayOfWeek[];
extern char sipNm_QtCore_day[];
extern char sipNm_QtCore_month[];
extern char sipNm_QtCore_year[];
extern char sipNm_QtCore_toPyDate[];
extern char sipNm_QtCore_QDate[];
extern char sipNm_QtCore_writeRawData[];
extern char sipNm_QtCore_writeBytes[];
extern char sipNm_QtCore_readRawData[];
extern char sipNm_QtCore_readBytes[];
extern char sipNm_QtCore_writeString[];
extern char sipNm_QtCore_writeDouble[];
extern char sipNm_QtCore_writeFloat[];
extern char sipNm_QtCore_writeBool[];
extern char sipNm_QtCore_writeUInt64[];
extern char sipNm_QtCore_writeInt64[];
extern char sipNm_QtCore_writeUInt32[];
extern char sipNm_QtCore_writeInt32[];
extern char sipNm_QtCore_writeUInt16[];
extern char sipNm_QtCore_writeInt16[];
extern char sipNm_QtCore_writeUInt8[];
extern char sipNm_QtCore_writeInt8[];
extern char sipNm_QtCore_readString[];
extern char sipNm_QtCore_readDouble[];
extern char sipNm_QtCore_readFloat[];
extern char sipNm_QtCore_readBool[];
extern char sipNm_QtCore_readUInt64[];
extern char sipNm_QtCore_readInt64[];
extern char sipNm_QtCore_readUInt32[];
extern char sipNm_QtCore_readInt32[];
extern char sipNm_QtCore_readUInt16[];
extern char sipNm_QtCore_readInt16[];
extern char sipNm_QtCore_readUInt8[];
extern char sipNm_QtCore_readInt8[];
extern char sipNm_QtCore_skipRawData[];
extern char sipNm_QtCore_setVersion[];
extern char sipNm_QtCore_version[];
extern char sipNm_QtCore_setByteOrder[];
extern char sipNm_QtCore_byteOrder[];
extern char sipNm_QtCore_resetStatus[];
extern char sipNm_QtCore_setStatus[];
extern char sipNm_QtCore_status[];
extern char sipNm_QtCore_unsetDevice[];
extern char sipNm_QtCore_setDevice[];
extern char sipNm_QtCore_device[];
extern char sipNm_QtCore_ReadCorruptData[];
extern char sipNm_QtCore_ReadPastEnd[];
extern char sipNm_QtCore_Ok[];
extern char sipNm_QtCore_Qt_4_4[];
extern char sipNm_QtCore_Qt_4_3[];
extern char sipNm_QtCore_Qt_4_2[];
extern char sipNm_QtCore_Qt_4_1[];
extern char sipNm_QtCore_Qt_4_0[];
extern char sipNm_QtCore_Qt_3_3[];
extern char sipNm_QtCore_Qt_3_1[];
extern char sipNm_QtCore_Qt_3_0[];
extern char sipNm_QtCore_Qt_2_1[];
extern char sipNm_QtCore_Qt_2_0[];
extern char sipNm_QtCore_Qt_1_0[];
extern char sipNm_QtCore_QDataStream[];
extern char sipNm_QtCore_hash[];
extern char sipNm_QtCore_result[];
extern char sipNm_QtCore_addData[];
extern char sipNm_QtCore_Sha1[];
extern char sipNm_QtCore_Md5[];
extern char sipNm_QtCore_Md4[];
extern char sipNm_QtCore_QCryptographicHash[];
extern char sipNm_QtCore_propertyName[];
extern char sipNm_QtCore_QDynamicPropertyChangeEvent[];
extern char sipNm_QtCore_removed[];
extern char sipNm_QtCore_polished[];
extern char sipNm_QtCore_added[];
extern char sipNm_QtCore_QChildEvent[];
extern char sipNm_QtCore_QTimerEvent[];
extern char sipNm_QtCore_registerEventType[];
extern char sipNm_QtCore_ignore[];
extern char sipNm_QtCore_accept[];
extern char sipNm_QtCore_isAccepted[];
extern char sipNm_QtCore_setAccepted[];
extern char sipNm_QtCore_spontaneous[];
extern char sipNm_QtCore_type[];
extern char sipNm_QtCore_MaxUser[];
extern char sipNm_QtCore_User[];
extern char sipNm_QtCore_UngrabKeyboard[];
extern char sipNm_QtCore_GrabKeyboard[];
extern char sipNm_QtCore_UngrabMouse[];
extern char sipNm_QtCore_GrabMouse[];
extern char sipNm_QtCore_ToolTipChange[];
extern char sipNm_QtCore_CursorChange[];
extern char sipNm_QtCore_TabletLeaveProximity[];
extern char sipNm_QtCore_TabletEnterProximity[];
extern char sipNm_QtCore_DynamicPropertyChange[];
extern char sipNm_QtCore_KeyboardLayoutChange[];
extern char sipNm_QtCore_GraphicsSceneMove[];
extern char sipNm_QtCore_GraphicsSceneResize[];
extern char sipNm_QtCore_GraphicsSceneWheel[];
extern char sipNm_QtCore_GraphicsSceneDrop[];
extern char sipNm_QtCore_GraphicsSceneDragLeave[];
extern char sipNm_QtCore_GraphicsSceneDragMove[];
extern char sipNm_QtCore_GraphicsSceneDragEnter[];
extern char sipNm_QtCore_GraphicsSceneHelp[];
extern char sipNm_QtCore_GraphicsSceneHoverLeave[];
extern char sipNm_QtCore_GraphicsSceneHoverMove[];
extern char sipNm_QtCore_GraphicsSceneHoverEnter[];
extern char sipNm_QtCore_GraphicsSceneContextMenu[];
extern char sipNm_QtCore_GraphicsSceneMouseDoubleClick[];
extern char sipNm_QtCore_GraphicsSceneMouseRelease[];
extern char sipNm_QtCore_GraphicsSceneMousePress[];
extern char sipNm_QtCore_GraphicsSceneMouseMove[];
extern char sipNm_QtCore_ZeroTimerEvent[];
extern char sipNm_QtCore_MenubarUpdated[];
extern char sipNm_QtCore_AcceptDropsChange[];
extern char sipNm_QtCore_AccessibilityDescription[];
extern char sipNm_QtCore_AccessibilityHelp[];
extern char sipNm_QtCore_HoverMove[];
extern char sipNm_QtCore_HoverLeave[];
extern char sipNm_QtCore_HoverEnter[];
extern char sipNm_QtCore_ZOrderChange[];
extern char sipNm_QtCore_LeaveWhatsThisMode[];
extern char sipNm_QtCore_EnterWhatsThisMode[];
extern char sipNm_QtCore_QueryWhatsThis[];
extern char sipNm_QtCore_ApplicationDeactivated[];
extern char sipNm_QtCore_ApplicationDeactivate[];
extern char sipNm_QtCore_ApplicationActivated[];
extern char sipNm_QtCore_ApplicationActivate[];
extern char sipNm_QtCore_ToolBarChange[];
extern char sipNm_QtCore_WhatsThisClicked[];
extern char sipNm_QtCore_ShortcutOverride[];
extern char sipNm_QtCore_Shortcut[];
extern char sipNm_QtCore_FileOpen[];
extern char sipNm_QtCore_ActionRemoved[];
extern char sipNm_QtCore_ActionAdded[];
extern char sipNm_QtCore_ActionChanged[];
extern char sipNm_QtCore_StatusTip[];
extern char sipNm_QtCore_WhatsThis[];
extern char sipNm_QtCore_WindowStateChange[];
extern char sipNm_QtCore_WindowUnblocked[];
extern char sipNm_QtCore_WindowBlocked[];
extern char sipNm_QtCore_MouseTrackingChange[];
extern char sipNm_QtCore_ModifiedChange[];
extern char sipNm_QtCore_IconTextChange[];
extern char sipNm_QtCore_StyleChange[];
extern char sipNm_QtCore_ActivationChange[];
extern char sipNm_QtCore_EnabledChange[];
extern char sipNm_QtCore_FontChange[];
extern char sipNm_QtCore_IconDrag[];
extern char sipNm_QtCore_HelpRequest[];
extern char sipNm_QtCore_OkRequest[];
extern char sipNm_QtCore_TabletRelease[];
extern char sipNm_QtCore_TabletPress[];
extern char sipNm_QtCore_Style[];
extern char sipNm_QtCore_LayoutDirectionChange[];
extern char sipNm_QtCore_LanguageChange[];
extern char sipNm_QtCore_LocaleChange[];
extern char sipNm_QtCore_TabletMove[];
extern char sipNm_QtCore_AccessibilityPrepare[];
extern char sipNm_QtCore_InputMethod[];
extern char sipNm_QtCore_ContextMenu[];
extern char sipNm_QtCore_DeactivateControl[];
extern char sipNm_QtCore_ActivateControl[];
extern char sipNm_QtCore_EmbeddingControl[];
extern char sipNm_QtCore_UpdateLater[];
extern char sipNm_QtCore_UpdateRequest[];
extern char sipNm_QtCore_LayoutRequest[];
extern char sipNm_QtCore_Polish[];
extern char sipNm_QtCore_PolishRequest[];
extern char sipNm_QtCore_ShowWindowRequest[];
extern char sipNm_QtCore_ChildRemoved[];
extern char sipNm_QtCore_ChildPolished[];
extern char sipNm_QtCore_ChildAdded[];
extern char sipNm_QtCore_DragResponse[];
extern char sipNm_QtCore_Drop[];
extern char sipNm_QtCore_DragLeave[];
extern char sipNm_QtCore_DragMove[];
extern char sipNm_QtCore_DragEnter[];
extern char sipNm_QtCore_DeferredDelete[];
extern char sipNm_QtCore_WinEventAct[];
extern char sipNm_QtCore_SockAct[];
extern char sipNm_QtCore_MetaCall[];
extern char sipNm_QtCore_Speech[];
extern char sipNm_QtCore_Clipboard[];
extern char sipNm_QtCore_PaletteChange[];
extern char sipNm_QtCore_ApplicationPaletteChange[];
extern char sipNm_QtCore_ApplicationLayoutDirectionChange[];
extern char sipNm_QtCore_ApplicationFontChange[];
extern char sipNm_QtCore_ApplicationWindowIconChange[];
extern char sipNm_QtCore_WindowIconChange[];
extern char sipNm_QtCore_WindowTitleChange[];
extern char sipNm_QtCore_Wheel[];
extern char sipNm_QtCore_HideToParent[];
extern char sipNm_QtCore_ShowToParent[];
extern char sipNm_QtCore_WindowDeactivate[];
extern char sipNm_QtCore_WindowActivate[];
extern char sipNm_QtCore_ThreadChange[];
extern char sipNm_QtCore_ParentAboutToChange[];
extern char sipNm_QtCore_ParentChange[];
extern char sipNm_QtCore_Quit[];
extern char sipNm_QtCore_Close[];
extern char sipNm_QtCore_Hide[];
extern char sipNm_QtCore_Show[];
extern char sipNm_QtCore_Destroy[];
extern char sipNm_QtCore_Create[];
extern char sipNm_QtCore_Resize[];
extern char sipNm_QtCore_Move[];
extern char sipNm_QtCore_Paint[];
extern char sipNm_QtCore_Leave[];
extern char sipNm_QtCore_Enter[];
extern char sipNm_QtCore_FocusOut[];
extern char sipNm_QtCore_FocusIn[];
extern char sipNm_QtCore_KeyRelease[];
extern char sipNm_QtCore_KeyPress[];
extern char sipNm_QtCore_MouseMove[];
extern char sipNm_QtCore_MouseButtonDblClick[];
extern char sipNm_QtCore_MouseButtonRelease[];
extern char sipNm_QtCore_MouseButtonPress[];
extern char sipNm_QtCore_Timer[];
extern char sipNm_QtCore_None[];
extern char sipNm_QtCore_Type[];
extern char sipNm_QtCore_QEvent[];
extern char sipNm_QtCore_pyqtRestoreInputHook[];
extern char sipNm_QtCore_pyqtRemoveInputHook[];
extern char sipNm_QtCore_qRemovePostRoutine[];
extern char sipNm_QtCore_qAddPostRoutine[];
extern char sipNm_QtCore_applicationPid[];
extern char sipNm_QtCore_applicationVersion[];
extern char sipNm_QtCore_setApplicationVersion[];
extern char sipNm_QtCore_event[];
extern char sipNm_QtCore_unixSignal[];
extern char sipNm_QtCore_aboutToQuit[];
extern char sipNm_QtCore_quit[];
extern char sipNm_QtCore_testAttribute[];
extern char sipNm_QtCore_setAttribute[];
extern char sipNm_QtCore_translate[];
extern char sipNm_QtCore_DefaultCodec[];
extern char sipNm_QtCore_UnicodeUTF8[];
extern char sipNm_QtCore_CodecForTr[];
extern char sipNm_QtCore_removeTranslator[];
extern char sipNm_QtCore_installTranslator[];
extern char sipNm_QtCore_removeLibraryPath[];
extern char sipNm_QtCore_addLibraryPath[];
extern char sipNm_QtCore_libraryPaths[];
extern char sipNm_QtCore_setLibraryPaths[];
extern char sipNm_QtCore_applicationFilePath[];
extern char sipNm_QtCore_applicationDirPath[];
extern char sipNm_QtCore_notify[];
extern char sipNm_QtCore_removePostedEvents[];
extern char sipNm_QtCore_sendPostedEvents[];
extern char sipNm_QtCore_postEvent[];
extern char sipNm_QtCore_sendEvent[];
extern char sipNm_QtCore_exit[];
extern char sipNm_QtCore_exec_[];
extern char sipNm_QtCore_arguments[];
extern char sipNm_QtCore_applicationName[];
extern char sipNm_QtCore_setApplicationName[];
extern char sipNm_QtCore_organizationName[];
extern char sipNm_QtCore_setOrganizationName[];
extern char sipNm_QtCore_organizationDomain[];
extern char sipNm_QtCore_setOrganizationDomain[];
extern char sipNm_QtCore_argv[];
extern char sipNm_QtCore_argc[];
extern char sipNm_QtCore_QCoreApplication[];
extern char sipNm_QtCore_lowSurrogate[];
extern char sipNm_QtCore_highSurrogate[];
extern char sipNm_QtCore_surrogateToUcs4[];
extern char sipNm_QtCore_isLowSurrogate[];
extern char sipNm_QtCore_isHighSurrogate[];
extern char sipNm_QtCore_isTitleCase[];
extern char sipNm_QtCore_toCaseFolded[];
extern char sipNm_QtCore_toTitleCase[];
extern char sipNm_QtCore_setRow[];
extern char sipNm_QtCore_setCell[];
extern char sipNm_QtCore_fromLatin1[];
extern char sipNm_QtCore_cell[];
extern char sipNm_QtCore_isSymbol[];
extern char sipNm_QtCore_isDigit[];
extern char sipNm_QtCore_isLetterOrNumber[];
extern char sipNm_QtCore_isNumber[];
extern char sipNm_QtCore_isLetter[];
extern char sipNm_QtCore_isMark[];
extern char sipNm_QtCore_isSpace[];
extern char sipNm_QtCore_isPunct[];
extern char sipNm_QtCore_isPrint[];
extern char sipNm_QtCore_fromAscii[];
extern char sipNm_QtCore_toAscii[];
extern char sipNm_QtCore_unicodeVersion[];
extern char sipNm_QtCore_combiningClass[];
extern char sipNm_QtCore_decompositionTag[];
extern char sipNm_QtCore_decomposition[];
extern char sipNm_QtCore_mirroredChar[];
extern char sipNm_QtCore_isUpper[];
extern char sipNm_QtCore_isLower[];
extern char sipNm_QtCore_hasMirrored[];
extern char sipNm_QtCore_joining[];
extern char sipNm_QtCore_direction[];
extern char sipNm_QtCore_category[];
extern char sipNm_QtCore_digitValue[];
extern char sipNm_QtCore_Unicode_5_0[];
extern char sipNm_QtCore_Unicode_4_1[];
extern char sipNm_QtCore_Unicode_4_0[];
extern char sipNm_QtCore_Unicode_3_2[];
extern char sipNm_QtCore_Unicode_3_1[];
extern char sipNm_QtCore_Unicode_3_0[];
extern char sipNm_QtCore_Unicode_2_1_2[];
extern char sipNm_QtCore_Unicode_2_0[];
extern char sipNm_QtCore_Unicode_1_1[];
extern char sipNm_QtCore_Unicode_Unassigned[];
extern char sipNm_QtCore_Combining_IotaSubscript[];
extern char sipNm_QtCore_Combining_DoubleAbove[];
extern char sipNm_QtCore_Combining_DoubleBelow[];
extern char sipNm_QtCore_Combining_AboveRight[];
extern char sipNm_QtCore_Combining_Above[];
extern char sipNm_QtCore_Combining_AboveLeft[];
extern char sipNm_QtCore_Combining_Right[];
extern char sipNm_QtCore_Combining_Left[];
extern char sipNm_QtCore_Combining_BelowRight[];
extern char sipNm_QtCore_Combining_Below[];
extern char sipNm_QtCore_Combining_BelowLeft[];
extern char sipNm_QtCore_Combining_AboveRightAttached[];
extern char sipNm_QtCore_Combining_AboveAttached[];
extern char sipNm_QtCore_Combining_AboveLeftAttached[];
extern char sipNm_QtCore_Combining_RightAttached[];
extern char sipNm_QtCore_Combining_LeftAttached[];
extern char sipNm_QtCore_Combining_BelowRightAttached[];
extern char sipNm_QtCore_Combining_BelowAttached[];
extern char sipNm_QtCore_Combining_BelowLeftAttached[];
extern char sipNm_QtCore_Center[];
extern char sipNm_QtCore_Right[];
extern char sipNm_QtCore_Dual[];
extern char sipNm_QtCore_OtherJoining[];
extern char sipNm_QtCore_Fraction[];
extern char sipNm_QtCore_Compat[];
extern char sipNm_QtCore_Square[];
extern char sipNm_QtCore_Small[];
extern char sipNm_QtCore_Narrow[];
extern char sipNm_QtCore_Wide[];
extern char sipNm_QtCore_Sub[];
extern char sipNm_QtCore_Super[];
extern char sipNm_QtCore_Circle[];
extern char sipNm_QtCore_Isolated[];
extern char sipNm_QtCore_Final[];
extern char sipNm_QtCore_Medial[];
extern char sipNm_QtCore_Initial[];
extern char sipNm_QtCore_NoBreak[];
extern char sipNm_QtCore_Font[];
extern char sipNm_QtCore_Canonical[];
extern char sipNm_QtCore_NoDecomposition[];
extern char sipNm_QtCore_DirBN[];
extern char sipNm_QtCore_DirNSM[];
extern char sipNm_QtCore_DirPDF[];
extern char sipNm_QtCore_DirRLO[];
extern char sipNm_QtCore_DirRLE[];
extern char sipNm_QtCore_DirAL[];
extern char sipNm_QtCore_DirLRO[];
extern char sipNm_QtCore_DirLRE[];
extern char sipNm_QtCore_DirON[];
extern char sipNm_QtCore_DirWS[];
extern char sipNm_QtCore_DirS[];
extern char sipNm_QtCore_DirB[];
extern char sipNm_QtCore_DirCS[];
extern char sipNm_QtCore_DirAN[];
extern char sipNm_QtCore_DirET[];
extern char sipNm_QtCore_DirES[];
extern char sipNm_QtCore_DirEN[];
extern char sipNm_QtCore_DirR[];
extern char sipNm_QtCore_DirL[];
extern char sipNm_QtCore_Punctuation_Dask[];
extern char sipNm_QtCore_Symbol_Other[];
extern char sipNm_QtCore_Symbol_Modifier[];
extern char sipNm_QtCore_Symbol_Currency[];
extern char sipNm_QtCore_Symbol_Math[];
extern char sipNm_QtCore_Punctuation_Other[];
extern char sipNm_QtCore_Punctuation_FinalQuote[];
extern char sipNm_QtCore_Punctuation_InitialQuote[];
extern char sipNm_QtCore_Punctuation_Close[];
extern char sipNm_QtCore_Punctuation_Open[];
extern char sipNm_QtCore_Punctuation_Dash[];
extern char sipNm_QtCore_Punctuation_Connector[];
extern char sipNm_QtCore_Letter_Other[];
extern char sipNm_QtCore_Letter_Modifier[];
extern char sipNm_QtCore_Letter_Titlecase[];
extern char sipNm_QtCore_Letter_Lowercase[];
extern char sipNm_QtCore_Letter_Uppercase[];
extern char sipNm_QtCore_Other_NotAssigned[];
extern char sipNm_QtCore_Other_PrivateUse[];
extern char sipNm_QtCore_Other_Surrogate[];
extern char sipNm_QtCore_Other_Format[];
extern char sipNm_QtCore_Other_Control[];
extern char sipNm_QtCore_Separator_Paragraph[];
extern char sipNm_QtCore_Separator_Line[];
extern char sipNm_QtCore_Separator_Space[];
extern char sipNm_QtCore_Number_Other[];
extern char sipNm_QtCore_Number_Letter[];
extern char sipNm_QtCore_Number_DecimalDigit[];
extern char sipNm_QtCore_Mark_Enclosing[];
extern char sipNm_QtCore_Mark_SpacingCombining[];
extern char sipNm_QtCore_Mark_NonSpacing[];
extern char sipNm_QtCore_NoCategory[];
extern char sipNm_QtCore_LineSeparator[];
extern char sipNm_QtCore_ParagraphSeparator[];
extern char sipNm_QtCore_ByteOrderSwapped[];
extern char sipNm_QtCore_ByteOrderMark[];
extern char sipNm_QtCore_ObjectReplacementCharacter[];
extern char sipNm_QtCore_ReplacementCharacter[];
extern char sipNm_QtCore_Nbsp[];
extern char sipNm_QtCore_Null[];
extern char sipNm_QtCore_QChar[];
extern char sipNm_QtCore_unicode[];
extern char sipNm_QtCore_toLatin1[];
extern char sipNm_QtCore_QLatin1Char[];
extern char sipNm_QtCore_pattern[];
extern char sipNm_QtCore_indexIn[];
extern char sipNm_QtCore_setPattern[];
extern char sipNm_QtCore_QByteArrayMatcher[];
extern char sipNm_QtCore_qUncompress[];
extern char sipNm_QtCore_qCompress[];
extern char sipNm_QtCore___add__[];
extern char sipNm_QtCore_fromPercentEncoding[];
extern char sipNm_QtCore_toPercentEncoding[];
extern char sipNm_QtCore_toHex[];
extern char sipNm_QtCore_contains[];
extern char sipNm_QtCore_push_front[];
extern char sipNm_QtCore_push_back[];
extern char sipNm_QtCore_squeeze[];
extern char sipNm_QtCore_reserve[];
extern char sipNm_QtCore_capacity[];
extern char sipNm_QtCore___imul__[];
extern char sipNm_QtCore___mul__[];
extern char sipNm_QtCore___repr__[];
extern char sipNm_QtCore___str__[];
extern char sipNm_QtCore___contains__[];
extern char sipNm_QtCore___len__[];
extern char sipNm_QtCore_length[];
extern char sipNm_QtCore_fromHex[];
extern char sipNm_QtCore_fromRawData[];
extern char sipNm_QtCore_fromBase64[];
extern char sipNm_QtCore_number[];
extern char sipNm_QtCore_setNum[];
extern char sipNm_QtCore_toBase64[];
extern char sipNm_QtCore_toDouble[];
extern char sipNm_QtCore_toFloat[];
extern char sipNm_QtCore_toULongLong[];
extern char sipNm_QtCore_toLongLong[];
extern char sipNm_QtCore_toULong[];
extern char sipNm_QtCore_toLong[];
extern char sipNm_QtCore_toUInt[];
extern char sipNm_QtCore_toInt[];
extern char sipNm_QtCore_toUShort[];
extern char sipNm_QtCore_toShort[];
extern char sipNm_QtCore___ge__[];
extern char sipNm_QtCore___le__[];
extern char sipNm_QtCore___gt__[];
extern char sipNm_QtCore___iadd__[];
extern char sipNm_QtCore_split[];
extern char sipNm_QtCore_replace[];
extern char sipNm_QtCore_insert[];
extern char sipNm_QtCore_append[];
extern char sipNm_QtCore_prepend[];
extern char sipNm_QtCore_rightJustified[];
extern char sipNm_QtCore_leftJustified[];
extern char sipNm_QtCore_simplified[];
extern char sipNm_QtCore_trimmed[];
extern char sipNm_QtCore_toUpper[];
extern char sipNm_QtCore_toLower[];
extern char sipNm_QtCore_chop[];
extern char sipNm_QtCore_endsWith[];
extern char sipNm_QtCore_startsWith[];
extern char sipNm_QtCore_mid[];
extern char sipNm_QtCore_right[];
extern char sipNm_QtCore_left[];
extern char sipNm_QtCore_lastIndexOf[];
extern char sipNm_QtCore_indexOf[];
extern char sipNm_QtCore_QByteArray[];
extern char sipNm_QtCore_qChecksum[];
extern char sipNm_QtCore_qstrnicmp[];
extern char sipNm_QtCore_qstricmp[];
extern char sipNm_QtCore_qstrncmp[];
extern char sipNm_QtCore_qstrcmp[];
extern char sipNm_QtCore_qstrncpy[];
extern char sipNm_QtCore_qstrcpy[];
extern char sipNm_QtCore_qstrnlen[];
extern char sipNm_QtCore_qstrlen[];
extern char sipNm_QtCore_qstrdup[];
extern char sipNm_QtCore_writeData[];
extern char sipNm_QtCore_readData[];
extern char sipNm_QtCore_canReadLine[];
extern char sipNm_QtCore_setBuffer[];
extern char sipNm_QtCore_buffer[];
extern char sipNm_QtCore_QIODevice[];
extern char sipNm_QtCore_QBuffer[];
extern char sipNm_QtCore_qSwap[];
extern char sipNm_QtCore___rshift__[];
extern char sipNm_QtCore___lshift__[];
extern char sipNm_QtCore_at[];
extern char sipNm_QtCore___getitem__[];
extern char sipNm_QtCore_toggleBit[];
extern char sipNm_QtCore_clearBit[];
extern char sipNm_QtCore_setBit[];
extern char sipNm_QtCore_testBit[];
extern char sipNm_QtCore_truncate[];
extern char sipNm_QtCore_fill[];
extern char sipNm_QtCore_clear[];
extern char sipNm_QtCore_isDetached[];
extern char sipNm_QtCore_detach[];
extern char sipNm_QtCore_resize[];
extern char sipNm_QtCore_isNull[];
extern char sipNm_QtCore_isEmpty[];
extern char sipNm_QtCore_count[];
extern char sipNm_QtCore_QBitArray[];
extern char sipNm_QtCore_stop[];
extern char sipNm_QtCore_start[];
extern char sipNm_QtCore_timerId[];
extern char sipNm_QtCore_isActive[];
extern char sipNm_QtCore_QBasicTimer[];
extern char sipNm_QtCore_QAbstractListModel[];
extern char sipNm_QtCore_QAbstractTableModel[];
extern char sipNm_QtCore_createIndex[];
extern char sipNm_QtCore_supportedDragActions[];
extern char sipNm_QtCore_setSupportedDragActions[];
extern char sipNm_QtCore_removeColumn[];
extern char sipNm_QtCore_removeRow[];
extern char sipNm_QtCore_insertColumn[];
extern char sipNm_QtCore_insertRow[];
extern char sipNm_QtCore_changePersistentIndexList[];
extern char sipNm_QtCore_changePersistentIndex[];
extern char sipNm_QtCore_reset[];
extern char sipNm_QtCore_persistentIndexList[];
extern char sipNm_QtCore_endRemoveColumns[];
extern char sipNm_QtCore_beginRemoveColumns[];
extern char sipNm_QtCore_endInsertColumns[];
extern char sipNm_QtCore_beginInsertColumns[];
extern char sipNm_QtCore_endRemoveRows[];
extern char sipNm_QtCore_beginRemoveRows[];
extern char sipNm_QtCore_endInsertRows[];
extern char sipNm_QtCore_beginInsertRows[];
extern char sipNm_QtCore_decodeData[];
extern char sipNm_QtCore_encodeData[];
extern char sipNm_QtCore_revert[];
extern char sipNm_QtCore_submit[];
extern char sipNm_QtCore_layoutChanged[];
extern char sipNm_QtCore_layoutAboutToBeChanged[];
extern char sipNm_QtCore_headerDataChanged[];
extern char sipNm_QtCore_dataChanged[];
extern char sipNm_QtCore_span[];
extern char sipNm_QtCore_match[];
extern char sipNm_QtCore_buddy[];
extern char sipNm_QtCore_sort[];
extern char sipNm_QtCore_canFetchMore[];
extern char sipNm_QtCore_fetchMore[];
extern char sipNm_QtCore_removeColumns[];
extern char sipNm_QtCore_removeRows[];
extern char sipNm_QtCore_insertColumns[];
extern char sipNm_QtCore_insertRows[];
extern char sipNm_QtCore_supportedDropActions[];
extern char sipNm_QtCore_dropMimeData[];
extern char sipNm_QtCore_mimeData[];
extern char sipNm_QtCore_mimeTypes[];
extern char sipNm_QtCore_setItemData[];
extern char sipNm_QtCore_itemData[];
extern char sipNm_QtCore_setHeaderData[];
extern char sipNm_QtCore_headerData[];
extern char sipNm_QtCore_setData[];
extern char sipNm_QtCore_hasChildren[];
extern char sipNm_QtCore_columnCount[];
extern char sipNm_QtCore_rowCount[];
extern char sipNm_QtCore_index[];
extern char sipNm_QtCore_hasIndex[];
extern char sipNm_QtCore_QAbstractItemModel[];
extern char sipNm_QtCore_QPersistentModelIndex[];
extern char sipNm_QtCore___hash__[];
extern char sipNm_QtCore___lt__[];
extern char sipNm_QtCore_sibling[];
extern char sipNm_QtCore_parent[];
extern char sipNm_QtCore_isValid[];
extern char sipNm_QtCore_model[];
extern char sipNm_QtCore_internalId[];
extern char sipNm_QtCore_internalPointer[];
extern char sipNm_QtCore_flags[];
extern char sipNm_QtCore_data[];
extern char sipNm_QtCore_column[];
extern char sipNm_QtCore_row[];
extern char sipNm_QtCore_child[];
extern char sipNm_QtCore_QModelIndex[];
extern char sipNm_QtCore_currentFilePath[];
extern char sipNm_QtCore_currentFileInfo[];
extern char sipNm_QtCore_currentFileName[];
extern char sipNm_QtCore_filters[];
extern char sipNm_QtCore_nameFilters[];
extern char sipNm_QtCore_path[];
extern char sipNm_QtCore_hasNext[];
extern char sipNm_QtCore_next[];
extern char sipNm_QtCore_QAbstractFileEngineIterator[];
extern char sipNm_QtCore_QAbstractFileEngineHandler[];
extern char sipNm_QtCore_setError[];
extern char sipNm_QtCore_unmap[];
extern char sipNm_QtCore_map[];
extern char sipNm_QtCore_create[];
extern char sipNm_QtCore_errorString[];
extern char sipNm_QtCore_error[];
extern char sipNm_QtCore_write[];
extern char sipNm_QtCore_readLine[];
extern char sipNm_QtCore_read[];
extern char sipNm_QtCore_handle[];
extern char sipNm_QtCore_setFileName[];
extern char sipNm_QtCore_fileTime[];
extern char sipNm_QtCore_owner[];
extern char sipNm_QtCore_ownerId[];
extern char sipNm_QtCore_fileName[];
extern char sipNm_QtCore_setPermissions[];
extern char sipNm_QtCore_fileFlags[];
extern char sipNm_QtCore_entryList[];
extern char sipNm_QtCore_isRelativePath[];
extern char sipNm_QtCore_caseSensitive[];
extern char sipNm_QtCore_setSize[];
extern char sipNm_QtCore_rmdir[];
extern char sipNm_QtCore_mkdir[];
extern char sipNm_QtCore_link[];
extern char sipNm_QtCore_rename[];
extern char sipNm_QtCore_copy[];
extern char sipNm_QtCore_remove[];
extern char sipNm_QtCore_isSequential[];
extern char sipNm_QtCore_seek[];
extern char sipNm_QtCore_pos[];
extern char sipNm_QtCore_size[];
extern char sipNm_QtCore_close[];
extern char sipNm_QtCore_open[];
extern char sipNm_QtCore_atEnd[];
extern char sipNm_QtCore_AccessTime[];
extern char sipNm_QtCore_ModificationTime[];
extern char sipNm_QtCore_CreationTime[];
extern char sipNm_QtCore_OwnerGroup[];
extern char sipNm_QtCore_OwnerUser[];
extern char sipNm_QtCore_BundleName[];
extern char sipNm_QtCore_CanonicalPathName[];
extern char sipNm_QtCore_CanonicalName[];
extern char sipNm_QtCore_LinkName[];
extern char sipNm_QtCore_AbsolutePathName[];
extern char sipNm_QtCore_AbsoluteName[];
extern char sipNm_QtCore_PathName[];
extern char sipNm_QtCore_BaseName[];
extern char sipNm_QtCore_DefaultName[];
extern char sipNm_QtCore_FileFlags[];
extern char sipNm_QtCore_Refresh[];
extern char sipNm_QtCore_BundleType[];
extern char sipNm_QtCore_FileInfoAll[];
extern char sipNm_QtCore_FlagsMask[];
extern char sipNm_QtCore_TypesMask[];
extern char sipNm_QtCore_PermsMask[];
extern char sipNm_QtCore_RootFlag[];
extern char sipNm_QtCore_ExistsFlag[];
extern char sipNm_QtCore_LocalDiskFlag[];
extern char sipNm_QtCore_HiddenFlag[];
extern char sipNm_QtCore_DirectoryType[];
extern char sipNm_QtCore_FileType[];
extern char sipNm_QtCore_LinkType[];
extern char sipNm_QtCore_ExeOtherPerm[];
extern char sipNm_QtCore_WriteOtherPerm[];
extern char sipNm_QtCore_ReadOtherPerm[];
extern char sipNm_QtCore_ExeGroupPerm[];
extern char sipNm_QtCore_WriteGroupPerm[];
extern char sipNm_QtCore_ReadGroupPerm[];
extern char sipNm_QtCore_ExeUserPerm[];
extern char sipNm_QtCore_WriteUserPerm[];
extern char sipNm_QtCore_ReadUserPerm[];
extern char sipNm_QtCore_ExeOwnerPerm[];
extern char sipNm_QtCore_WriteOwnerPerm[];
extern char sipNm_QtCore_ReadOwnerPerm[];
extern char sipNm_QtCore_FileFlag[];
extern char sipNm_QtCore_QAbstractFileEngine[];
extern char sipNm_QtCore_awake[];
extern char sipNm_QtCore_aboutToBlock[];
extern char sipNm_QtCore_closingDown[];
extern char sipNm_QtCore_startingUp[];
extern char sipNm_QtCore_flush[];
extern char sipNm_QtCore_interrupt[];
extern char sipNm_QtCore_wakeUp[];
extern char sipNm_QtCore_registeredTimers[];
extern char sipNm_QtCore_unregisterTimers[];
extern char sipNm_QtCore_unregisterTimer[];
extern char sipNm_QtCore_registerTimer[];
extern char sipNm_QtCore_unregisterSocketNotifier[];
extern char sipNm_QtCore_registerSocketNotifier[];
extern char sipNm_QtCore_hasPendingEvents[];
extern char sipNm_QtCore_processEvents[];
extern char sipNm_QtCore_instance[];
extern char sipNm_QtCore_QObject[];
extern char sipNm_QtCore_QAbstractEventDispatcher[];
extern char sipNm_QtCore_TitleBarArea[];
extern char sipNm_QtCore_BottomLeftSection[];
extern char sipNm_QtCore_BottomSection[];
extern char sipNm_QtCore_BottomRightSection[];
extern char sipNm_QtCore_RightSection[];
extern char sipNm_QtCore_TopRightSection[];
extern char sipNm_QtCore_TopSection[];
extern char sipNm_QtCore_TopLeftSection[];
extern char sipNm_QtCore_LeftSection[];
extern char sipNm_QtCore_NoSection[];
extern char sipNm_QtCore_MinimumDescent[];
extern char sipNm_QtCore_MaximumSize[];
extern char sipNm_QtCore_PreferredSize[];
extern char sipNm_QtCore_MinimumSize[];
extern char sipNm_QtCore_RelativeSize[];
extern char sipNm_QtCore_AbsoluteSize[];
extern char sipNm_QtCore_LowEventPriority[];
extern char sipNm_QtCore_NormalEventPriority[];
extern char sipNm_QtCore_HighEventPriority[];
extern char sipNm_QtCore_ZAxis[];
extern char sipNm_QtCore_YAxis[];
extern char sipNm_QtCore_XAxis[];
extern char sipNm_QtCore_MaskOutColor[];
extern char sipNm_QtCore_MaskInColor[];
extern char sipNm_QtCore_TextInteractionFlags[];
extern char sipNm_QtCore_TextBrowserInteraction[];
extern char sipNm_QtCore_TextEditorInteraction[];
extern char sipNm_QtCore_TextEditable[];
extern char sipNm_QtCore_LinksAccessibleByKeyboard[];
extern char sipNm_QtCore_LinksAccessibleByMouse[];
extern char sipNm_QtCore_TextSelectableByKeyboard[];
extern char sipNm_QtCore_TextSelectableByMouse[];
extern char sipNm_QtCore_NoTextInteraction[];
extern char sipNm_QtCore_TextInteractionFlag[];
extern char sipNm_QtCore_IntersectsItemBoundingRect[];
extern char sipNm_QtCore_ContainsItemBoundingRect[];
extern char sipNm_QtCore_IntersectsItemShape[];
extern char sipNm_QtCore_ContainsItemShape[];
extern char sipNm_QtCore_AA_DontCreateNativeWidgetSiblings[];
extern char sipNm_QtCore_AA_NativeWindows[];
extern char sipNm_QtCore_AA_DontShowIconsInMenus[];
extern char sipNm_QtCore_AA_MSWindowsUseDirect3DByDefault[];
extern char sipNm_QtCore_AA_ImmediateWidgetCreation[];
extern char sipNm_QtCore_ApplicationModal[];
extern char sipNm_QtCore_WindowModal[];
extern char sipNm_QtCore_NonModal[];
extern char sipNm_QtCore_MatchFlags[];
extern char sipNm_QtCore_MatchRecursive[];
extern char sipNm_QtCore_MatchWrap[];
extern char sipNm_QtCore_MatchCaseSensitive[];
extern char sipNm_QtCore_MatchWildcard[];
extern char sipNm_QtCore_MatchRegExp[];
extern char sipNm_QtCore_MatchEndsWith[];
extern char sipNm_QtCore_MatchStartsWith[];
extern char sipNm_QtCore_MatchContains[];
extern char sipNm_QtCore_MatchFixedString[];
extern char sipNm_QtCore_MatchExactly[];
extern char sipNm_QtCore_MatchFlag[];
extern char sipNm_QtCore_ItemFlags[];
extern char sipNm_QtCore_ItemIsTristate[];
extern char sipNm_QtCore_ItemIsEnabled[];
extern char sipNm_QtCore_ItemIsUserCheckable[];
extern char sipNm_QtCore_ItemIsDropEnabled[];
extern char sipNm_QtCore_ItemIsDragEnabled[];
extern char sipNm_QtCore_ItemIsEditable[];
extern char sipNm_QtCore_ItemIsSelectable[];
extern char sipNm_QtCore_NoItemFlags[];
extern char sipNm_QtCore_ItemFlag[];
extern char sipNm_QtCore_UserRole[];
extern char sipNm_QtCore_SizeHintRole[];
extern char sipNm_QtCore_AccessibleDescriptionRole[];
extern char sipNm_QtCore_AccessibleTextRole[];
extern char sipNm_QtCore_CheckStateRole[];
extern char sipNm_QtCore_TextColorRole[];
extern char sipNm_QtCore_ForegroundRole[];
extern char sipNm_QtCore_BackgroundColorRole[];
extern char sipNm_QtCore_BackgroundRole[];
extern char sipNm_QtCore_TextAlignmentRole[];
extern char sipNm_QtCore_FontRole[];
extern char sipNm_QtCore_WhatsThisRole[];
extern char sipNm_QtCore_StatusTipRole[];
extern char sipNm_QtCore_ToolTipRole[];
extern char sipNm_QtCore_EditRole[];
extern char sipNm_QtCore_DecorationRole[];
extern char sipNm_QtCore_DisplayRole[];
extern char sipNm_QtCore_Checked[];
extern char sipNm_QtCore_PartiallyChecked[];
extern char sipNm_QtCore_Unchecked[];
extern char sipNm_QtCore_DropActions[];
extern char sipNm_QtCore_IgnoreAction[];
extern char sipNm_QtCore_TargetMoveAction[];
extern char sipNm_QtCore_ActionMask[];
extern char sipNm_QtCore_LinkAction[];
extern char sipNm_QtCore_MoveAction[];
extern char sipNm_QtCore_CopyAction[];
extern char sipNm_QtCore_DropAction[];
extern char sipNm_QtCore_RightToLeft[];
extern char sipNm_QtCore_LeftToRight[];
extern char sipNm_QtCore_ToolButtonTextUnderIcon[];
extern char sipNm_QtCore_ToolButtonTextBesideIcon[];
extern char sipNm_QtCore_ToolButtonTextOnly[];
extern char sipNm_QtCore_ToolButtonIconOnly[];
extern char sipNm_QtCore_ImCurrentSelection[];
extern char sipNm_QtCore_ImSurroundingText[];
extern char sipNm_QtCore_ImCursorPosition[];
extern char sipNm_QtCore_ImFont[];
extern char sipNm_QtCore_ImMicroFocus[];
extern char sipNm_QtCore_CustomContextMenu[];
extern char sipNm_QtCore_ActionsContextMenu[];
extern char sipNm_QtCore_DefaultContextMenu[];
extern char sipNm_QtCore_PreventContextMenu[];
extern char sipNm_QtCore_NoContextMenu[];
extern char sipNm_QtCore_NoFocusReason[];
extern char sipNm_QtCore_OtherFocusReason[];
extern char sipNm_QtCore_MenuBarFocusReason[];
extern char sipNm_QtCore_ShortcutFocusReason[];
extern char sipNm_QtCore_PopupFocusReason[];
extern char sipNm_QtCore_ActiveWindowFocusReason[];
extern char sipNm_QtCore_BacktabFocusReason[];
extern char sipNm_QtCore_TabFocusReason[];
extern char sipNm_QtCore_MouseFocusReason[];
extern char sipNm_QtCore_SmoothTransformation[];
extern char sipNm_QtCore_FastTransformation[];
extern char sipNm_QtCore_UniteClip[];
extern char sipNm_QtCore_IntersectClip[];
extern char sipNm_QtCore_ReplaceClip[];
extern char sipNm_QtCore_NoClip[];
extern char sipNm_QtCore_WindingFill[];
extern char sipNm_QtCore_OddEvenFill[];
extern char sipNm_QtCore_WidgetWithChildrenShortcut[];
extern char sipNm_QtCore_ApplicationShortcut[];
extern char sipNm_QtCore_WindowShortcut[];
extern char sipNm_QtCore_WidgetShortcut[];
extern char sipNm_QtCore_BlockingQueuedConnection[];
extern char sipNm_QtCore_AutoCompatConnection[];
extern char sipNm_QtCore_QueuedConnection[];
extern char sipNm_QtCore_DirectConnection[];
extern char sipNm_QtCore_AutoConnection[];
extern char sipNm_QtCore_BottomRightCorner[];
extern char sipNm_QtCore_BottomLeftCorner[];
extern char sipNm_QtCore_TopRightCorner[];
extern char sipNm_QtCore_TopLeftCorner[];
extern char sipNm_QtCore_CaseSensitive[];
extern char sipNm_QtCore_CaseInsensitive[];
extern char sipNm_QtCore_ScrollBarAlwaysOn[];
extern char sipNm_QtCore_ScrollBarAlwaysOff[];
extern char sipNm_QtCore_ScrollBarAsNeeded[];
extern char sipNm_QtCore_Sunday[];
extern char sipNm_QtCore_Saturday[];
extern char sipNm_QtCore_Friday[];
extern char sipNm_QtCore_Thursday[];
extern char sipNm_QtCore_Wednesday[];
extern char sipNm_QtCore_Tuesday[];
extern char sipNm_QtCore_Monday[];
extern char sipNm_QtCore_OffsetFromUTC[];
extern char sipNm_QtCore_UTC[];
extern char sipNm_QtCore_LocalTime[];
extern char sipNm_QtCore_DefaultLocaleLongDate[];
extern char sipNm_QtCore_DefaultLocaleShortDate[];
extern char sipNm_QtCore_SystemLocaleLongDate[];
extern char sipNm_QtCore_SystemLocaleShortDate[];
extern char sipNm_QtCore_LocaleDate[];
extern char sipNm_QtCore_SystemLocaleDate[];
extern char sipNm_QtCore_LocalDate[];
extern char sipNm_QtCore_ISODate[];
extern char sipNm_QtCore_TextDate[];
extern char sipNm_QtCore_ToolBarAreas[];
extern char sipNm_QtCore_NoToolBarArea[];
extern char sipNm_QtCore_AllToolBarAreas[];
extern char sipNm_QtCore_ToolBarArea_Mask[];
extern char sipNm_QtCore_BottomToolBarArea[];
extern char sipNm_QtCore_TopToolBarArea[];
extern char sipNm_QtCore_RightToolBarArea[];
extern char sipNm_QtCore_LeftToolBarArea[];
extern char sipNm_QtCore_ToolBarArea[];
extern char sipNm_QtCore_DockWidgetAreas[];
extern char sipNm_QtCore_NoDockWidgetArea[];
extern char sipNm_QtCore_AllDockWidgetAreas[];
extern char sipNm_QtCore_DockWidgetArea_Mask[];
extern char sipNm_QtCore_BottomDockWidgetArea[];
extern char sipNm_QtCore_TopDockWidgetArea[];
extern char sipNm_QtCore_RightDockWidgetArea[];
extern char sipNm_QtCore_LeftDockWidgetArea[];
extern char sipNm_QtCore_DockWidgetArea[];
extern char sipNm_QtCore_AnchorHref[];
extern char sipNm_QtCore_AnchorName[];
extern char sipNm_QtCore_KeepAspectRatioByExpanding[];
extern char sipNm_QtCore_KeepAspectRatio[];
extern char sipNm_QtCore_IgnoreAspectRatio[];
extern char sipNm_QtCore_LogText[];
extern char sipNm_QtCore_AutoText[];
extern char sipNm_QtCore_RichText[];
extern char sipNm_QtCore_PlainText[];
extern char sipNm_QtCore_TextFormat[];
extern char sipNm_QtCore_CustomCursor[];
extern char sipNm_QtCore_BitmapCursor[];
extern char sipNm_QtCore_LastCursor[];
extern char sipNm_QtCore_BusyCursor[];
extern char sipNm_QtCore_WhatsThisCursor[];
extern char sipNm_QtCore_ClosedHandCursor[];
extern char sipNm_QtCore_OpenHandCursor[];
extern char sipNm_QtCore_ForbiddenCursor[];
extern char sipNm_QtCore_PointingHandCursor[];
extern char sipNm_QtCore_SplitHCursor[];
extern char sipNm_QtCore_SplitVCursor[];
extern char sipNm_QtCore_BlankCursor[];
extern char sipNm_QtCore_SizeAllCursor[];
extern char sipNm_QtCore_SizeFDiagCursor[];
extern char sipNm_QtCore_SizeBDiagCursor[];
extern char sipNm_QtCore_SizeHorCursor[];
extern char sipNm_QtCore_SizeVerCursor[];
extern char sipNm_QtCore_IBeamCursor[];
extern char sipNm_QtCore_WaitCursor[];
extern char sipNm_QtCore_CrossCursor[];
extern char sipNm_QtCore_UpArrowCursor[];
extern char sipNm_QtCore_ArrowCursor[];
extern char sipNm_QtCore_UI_AnimateToolBox[];
extern char sipNm_QtCore_UI_FadeTooltip[];
extern char sipNm_QtCore_UI_AnimateTooltip[];
extern char sipNm_QtCore_UI_AnimateCombo[];
extern char sipNm_QtCore_UI_FadeMenu[];
extern char sipNm_QtCore_UI_AnimateMenu[];
extern char sipNm_QtCore_UI_General[];
extern char sipNm_QtCore_TexturePattern[];
extern char sipNm_QtCore_ConicalGradientPattern[];
extern char sipNm_QtCore_RadialGradientPattern[];
extern char sipNm_QtCore_LinearGradientPattern[];
extern char sipNm_QtCore_DiagCrossPattern[];
extern char sipNm_QtCore_FDiagPattern[];
extern char sipNm_QtCore_BDiagPattern[];
extern char sipNm_QtCore_CrossPattern[];
extern char sipNm_QtCore_VerPattern[];
extern char sipNm_QtCore_HorPattern[];
extern char sipNm_QtCore_Dense7Pattern[];
extern char sipNm_QtCore_Dense6Pattern[];
extern char sipNm_QtCore_Dense5Pattern[];
extern char sipNm_QtCore_Dense4Pattern[];
extern char sipNm_QtCore_Dense3Pattern[];
extern char sipNm_QtCore_Dense2Pattern[];
extern char sipNm_QtCore_Dense1Pattern[];
extern char sipNm_QtCore_SolidPattern[];
extern char sipNm_QtCore_NoBrush[];
extern char sipNm_QtCore_SvgMiterJoin[];
extern char sipNm_QtCore_MPenJoinStyle[];
extern char sipNm_QtCore_RoundJoin[];
extern char sipNm_QtCore_BevelJoin[];
extern char sipNm_QtCore_MiterJoin[];
extern char sipNm_QtCore_MPenCapStyle[];
extern char sipNm_QtCore_RoundCap[];
extern char sipNm_QtCore_SquareCap[];
extern char sipNm_QtCore_FlatCap[];
extern char sipNm_QtCore_MPenStyle[];
extern char sipNm_QtCore_CustomDashLine[];
extern char sipNm_QtCore_DashDotDotLine[];
extern char sipNm_QtCore_DashDotLine[];
extern char sipNm_QtCore_DotLine[];
extern char sipNm_QtCore_DashLine[];
extern char sipNm_QtCore_SolidLine[];
extern char sipNm_QtCore_NoPen[];
extern char sipNm_QtCore_RightArrow[];
extern char sipNm_QtCore_LeftArrow[];
extern char sipNm_QtCore_DownArrow[];
extern char sipNm_QtCore_UpArrow[];
extern char sipNm_QtCore_NoArrow[];
extern char sipNm_QtCore_Key_Cancel[];
extern char sipNm_QtCore_Key_Zoom[];
extern char sipNm_QtCore_Key_Sleep[];
extern char sipNm_QtCore_Key_Play[];
extern char sipNm_QtCore_Key_Printer[];
extern char sipNm_QtCore_Key_Execute[];
extern char sipNm_QtCore_Key_unknown[];
extern char sipNm_QtCore_Key_Flip[];
extern char sipNm_QtCore_Key_Hangup[];
extern char sipNm_QtCore_Key_Call[];
extern char sipNm_QtCore_Key_Context4[];
extern char sipNm_QtCore_Key_Context3[];
extern char sipNm_QtCore_Key_Context2[];
extern char sipNm_QtCore_Key_Context1[];
extern char sipNm_QtCore_Key_No[];
extern char sipNm_QtCore_Key_Yes[];
extern char sipNm_QtCore_Key_Select[];
extern char sipNm_QtCore_Key_MediaLast[];
extern char sipNm_QtCore_Key_LaunchF[];
extern char sipNm_QtCore_Key_LaunchE[];
extern char sipNm_QtCore_Key_LaunchD[];
extern char sipNm_QtCore_Key_LaunchC[];
extern char sipNm_QtCore_Key_LaunchB[];
extern char sipNm_QtCore_Key_LaunchA[];
extern char sipNm_QtCore_Key_Launch9[];
extern char sipNm_QtCore_Key_Launch8[];
extern char sipNm_QtCore_Key_Launch7[];
extern char sipNm_QtCore_Key_Launch6[];
extern char sipNm_QtCore_Key_Launch5[];
extern char sipNm_QtCore_Key_Launch4[];
extern char sipNm_QtCore_Key_Launch3[];
extern char sipNm_QtCore_Key_Launch2[];
extern char sipNm_QtCore_Key_Launch1[];
extern char sipNm_QtCore_Key_Launch0[];
extern char sipNm_QtCore_Key_LaunchMedia[];
extern char sipNm_QtCore_Key_LaunchMail[];
extern char sipNm_QtCore_Key_OpenUrl[];
extern char sipNm_QtCore_Key_Standby[];
extern char sipNm_QtCore_Key_Search[];
extern char sipNm_QtCore_Key_Favorites[];
extern char sipNm_QtCore_Key_HomePage[];
extern char sipNm_QtCore_Key_MediaRecord[];
extern char sipNm_QtCore_Key_MediaNext[];
extern char sipNm_QtCore_Key_MediaPrevious[];
extern char sipNm_QtCore_Key_MediaStop[];
extern char sipNm_QtCore_Key_MediaPlay[];
extern char sipNm_QtCore_Key_TrebleDown[];
extern char sipNm_QtCore_Key_TrebleUp[];
extern char sipNm_QtCore_Key_BassDown[];
extern char sipNm_QtCore_Key_BassUp[];
extern char sipNm_QtCore_Key_BassBoost[];
extern char sipNm_QtCore_Key_VolumeUp[];
extern char sipNm_QtCore_Key_VolumeMute[];
extern char sipNm_QtCore_Key_VolumeDown[];
extern char sipNm_QtCore_Key_Refresh[];
extern char sipNm_QtCore_Key_Stop[];
extern char sipNm_QtCore_Key_Forward[];
extern char sipNm_QtCore_Key_Back[];
extern char sipNm_QtCore_Key_Dead_Horn[];
extern char sipNm_QtCore_Key_Dead_Hook[];
extern char sipNm_QtCore_Key_Dead_Belowdot[];
extern char sipNm_QtCore_Key_Dead_Semivoiced_Sound[];
extern char sipNm_QtCore_Key_Dead_Voiced_Sound[];
extern char sipNm_QtCore_Key_Dead_Iota[];
extern char sipNm_QtCore_Key_Dead_Ogonek[];
extern char sipNm_QtCore_Key_Dead_Cedilla[];
extern char sipNm_QtCore_Key_Dead_Caron[];
extern char sipNm_QtCore_Key_Dead_Doubleacute[];
extern char sipNm_QtCore_Key_Dead_Abovering[];
extern char sipNm_QtCore_Key_Dead_Diaeresis[];
extern char sipNm_QtCore_Key_Dead_Abovedot[];
extern char sipNm_QtCore_Key_Dead_Breve[];
extern char sipNm_QtCore_Key_Dead_Macron[];
extern char sipNm_QtCore_Key_Dead_Tilde[];
extern char sipNm_QtCore_Key_Dead_Circumflex[];
extern char sipNm_QtCore_Key_Dead_Acute[];
extern char sipNm_QtCore_Key_Dead_Grave[];
extern char sipNm_QtCore_Key_Hangul_Special[];
extern char sipNm_QtCore_Key_Hangul_PostHanja[];
extern char sipNm_QtCore_Key_Hangul_PreHanja[];
extern char sipNm_QtCore_Key_Hangul_Banja[];
extern char sipNm_QtCore_Key_Hangul_Jeonja[];
extern char sipNm_QtCore_Key_Hangul_Romaja[];
extern char sipNm_QtCore_Key_Hangul_Jamo[];
extern char sipNm_QtCore_Key_Hangul_Hanja[];
extern char sipNm_QtCore_Key_Hangul_End[];
extern char sipNm_QtCore_Key_Hangul_Start[];
extern char sipNm_QtCore_Key_Hangul[];
extern char sipNm_QtCore_Key_Eisu_toggle[];
extern char sipNm_QtCore_Key_Eisu_Shift[];
extern char sipNm_QtCore_Key_Kana_Shift[];
extern char sipNm_QtCore_Key_Kana_Lock[];
extern char sipNm_QtCore_Key_Massyo[];
extern char sipNm_QtCore_Key_Touroku[];
extern char sipNm_QtCore_Key_Zenkaku_Hankaku[];
extern char sipNm_QtCore_Key_Hankaku[];
extern char sipNm_QtCore_Key_Zenkaku[];
extern char sipNm_QtCore_Key_Hiragana_Katakana[];
extern char sipNm_QtCore_Key_Katakana[];
extern char sipNm_QtCore_Key_Hiragana[];
extern char sipNm_QtCore_Key_Romaji[];
extern char sipNm_QtCore_Key_Henkan[];
extern char sipNm_QtCore_Key_Muhenkan[];
extern char sipNm_QtCore_Key_Kanji[];
extern char sipNm_QtCore_Key_Mode_switch[];
extern char sipNm_QtCore_Key_PreviousCandidate[];
extern char sipNm_QtCore_Key_MultipleCandidate[];
extern char sipNm_QtCore_Key_SingleCandidate[];
extern char sipNm_QtCore_Key_Codeinput[];
extern char sipNm_QtCore_Key_Multi_key[];
extern char sipNm_QtCore_Key_AltGr[];
extern char sipNm_QtCore_Key_ydiaeresis[];
extern char sipNm_QtCore_Key_division[];
extern char sipNm_QtCore_Key_ssharp[];
extern char sipNm_QtCore_Key_THORN[];
extern char sipNm_QtCore_Key_Yacute[];
extern char sipNm_QtCore_Key_Udiaeresis[];
extern char sipNm_QtCore_Key_Ucircumflex[];
extern char sipNm_QtCore_Key_Uacute[];
extern char sipNm_QtCore_Key_Ugrave[];
extern char sipNm_QtCore_Key_Ooblique[];
extern char sipNm_QtCore_Key_multiply[];
extern char sipNm_QtCore_Key_Odiaeresis[];
extern char sipNm_QtCore_Key_Otilde[];
extern char sipNm_QtCore_Key_Ocircumflex[];
extern char sipNm_QtCore_Key_Oacute[];
extern char sipNm_QtCore_Key_Ograve[];
extern char sipNm_QtCore_Key_Ntilde[];
extern char sipNm_QtCore_Key_ETH[];
extern char sipNm_QtCore_Key_Idiaeresis[];
extern char sipNm_QtCore_Key_Icircumflex[];
extern char sipNm_QtCore_Key_Iacute[];
extern char sipNm_QtCore_Key_Igrave[];
extern char sipNm_QtCore_Key_Ediaeresis[];
extern char sipNm_QtCore_Key_Ecircumflex[];
extern char sipNm_QtCore_Key_Eacute[];
extern char sipNm_QtCore_Key_Egrave[];
extern char sipNm_QtCore_Key_Ccedilla[];
extern char sipNm_QtCore_Key_AE[];
extern char sipNm_QtCore_Key_Aring[];
extern char sipNm_QtCore_Key_Adiaeresis[];
extern char sipNm_QtCore_Key_Atilde[];
extern char sipNm_QtCore_Key_Acircumflex[];
extern char sipNm_QtCore_Key_Aacute[];
extern char sipNm_QtCore_Key_Agrave[];
extern char sipNm_QtCore_Key_questiondown[];
extern char sipNm_QtCore_Key_threequarters[];
extern char sipNm_QtCore_Key_onehalf[];
extern char sipNm_QtCore_Key_onequarter[];
extern char sipNm_QtCore_Key_guillemotright[];
extern char sipNm_QtCore_Key_masculine[];
extern char sipNm_QtCore_Key_onesuperior[];
extern char sipNm_QtCore_Key_cedilla[];
extern char sipNm_QtCore_Key_periodcentered[];
extern char sipNm_QtCore_Key_paragraph[];
extern char sipNm_QtCore_Key_mu[];
extern char sipNm_QtCore_Key_acute[];
extern char sipNm_QtCore_Key_threesuperior[];
extern char sipNm_QtCore_Key_twosuperior[];
extern char sipNm_QtCore_Key_plusminus[];
extern char sipNm_QtCore_Key_degree[];
extern char sipNm_QtCore_Key_macron[];
extern char sipNm_QtCore_Key_registered[];
extern char sipNm_QtCore_Key_hyphen[];
extern char sipNm_QtCore_Key_notsign[];
extern char sipNm_QtCore_Key_guillemotleft[];
extern char sipNm_QtCore_Key_ordfeminine[];
extern char sipNm_QtCore_Key_copyright[];
extern char sipNm_QtCore_Key_diaeresis[];
extern char sipNm_QtCore_Key_section[];
extern char sipNm_QtCore_Key_brokenbar[];
extern char sipNm_QtCore_Key_yen[];
extern char sipNm_QtCore_Key_currency[];
extern char sipNm_QtCore_Key_sterling[];
extern char sipNm_QtCore_Key_cent[];
extern char sipNm_QtCore_Key_exclamdown[];
extern char sipNm_QtCore_Key_nobreakspace[];
extern char sipNm_QtCore_Key_AsciiTilde[];
extern char sipNm_QtCore_Key_BraceRight[];
extern char sipNm_QtCore_Key_Bar[];
extern char sipNm_QtCore_Key_BraceLeft[];
extern char sipNm_QtCore_Key_QuoteLeft[];
extern char sipNm_QtCore_Key_Underscore[];
extern char sipNm_QtCore_Key_AsciiCircum[];
extern char sipNm_QtCore_Key_BracketRight[];
extern char sipNm_QtCore_Key_Backslash[];
extern char sipNm_QtCore_Key_BracketLeft[];
extern char sipNm_QtCore_Key_Z[];
extern char sipNm_QtCore_Key_Y[];
extern char sipNm_QtCore_Key_X[];
extern char sipNm_QtCore_Key_W[];
extern char sipNm_QtCore_Key_V[];
extern char sipNm_QtCore_Key_U[];
extern char sipNm_QtCore_Key_T[];
extern char sipNm_QtCore_Key_S[];
extern char sipNm_QtCore_Key_R[];
extern char sipNm_QtCore_Key_Q[];
extern char sipNm_QtCore_Key_P[];
extern char sipNm_QtCore_Key_O[];
extern char sipNm_QtCore_Key_N[];
extern char sipNm_QtCore_Key_M[];
extern char sipNm_QtCore_Key_L[];
extern char sipNm_QtCore_Key_K[];
extern char sipNm_QtCore_Key_J[];
extern char sipNm_QtCore_Key_I[];
extern char sipNm_QtCore_Key_H[];
extern char sipNm_QtCore_Key_G[];
extern char sipNm_QtCore_Key_F[];
extern char sipNm_QtCore_Key_E[];
extern char sipNm_QtCore_Key_D[];
extern char sipNm_QtCore_Key_C[];
extern char sipNm_QtCore_Key_B[];
extern char sipNm_QtCore_Key_A[];
extern char sipNm_QtCore_Key_At[];
extern char sipNm_QtCore_Key_Question[];
extern char sipNm_QtCore_Key_Greater[];
extern char sipNm_QtCore_Key_Equal[];
extern char sipNm_QtCore_Key_Less[];
extern char sipNm_QtCore_Key_Semicolon[];
extern char sipNm_QtCore_Key_Colon[];
extern char sipNm_QtCore_Key_9[];
extern char sipNm_QtCore_Key_8[];
extern char sipNm_QtCore_Key_7[];
extern char sipNm_QtCore_Key_6[];
extern char sipNm_QtCore_Key_5[];
extern char sipNm_QtCore_Key_4[];
extern char sipNm_QtCore_Key_3[];
extern char sipNm_QtCore_Key_2[];
extern char sipNm_QtCore_Key_1[];
extern char sipNm_QtCore_Key_0[];
extern char sipNm_QtCore_Key_Slash[];
extern char sipNm_QtCore_Key_Period[];
extern char sipNm_QtCore_Key_Minus[];
extern char sipNm_QtCore_Key_Comma[];
extern char sipNm_QtCore_Key_Plus[];
extern char sipNm_QtCore_Key_Asterisk[];
extern char sipNm_QtCore_Key_ParenRight[];
extern char sipNm_QtCore_Key_ParenLeft[];
extern char sipNm_QtCore_Key_Apostrophe[];
extern char sipNm_QtCore_Key_Ampersand[];
extern char sipNm_QtCore_Key_Percent[];
extern char sipNm_QtCore_Key_Dollar[];
extern char sipNm_QtCore_Key_NumberSign[];
extern char sipNm_QtCore_Key_QuoteDbl[];
extern char sipNm_QtCore_Key_Exclam[];
extern char sipNm_QtCore_Key_Any[];
extern char sipNm_QtCore_Key_Space[];
extern char sipNm_QtCore_Key_Direction_R[];
extern char sipNm_QtCore_Key_Direction_L[];
extern char sipNm_QtCore_Key_Help[];
extern char sipNm_QtCore_Key_Hyper_R[];
extern char sipNm_QtCore_Key_Hyper_L[];
extern char sipNm_QtCore_Key_Menu[];
extern char sipNm_QtCore_Key_Super_R[];
extern char sipNm_QtCore_Key_Super_L[];
extern char sipNm_QtCore_Key_F35[];
extern char sipNm_QtCore_Key_F34[];
extern char sipNm_QtCore_Key_F33[];
extern char sipNm_QtCore_Key_F32[];
extern char sipNm_QtCore_Key_F31[];
extern char sipNm_QtCore_Key_F30[];
extern char sipNm_QtCore_Key_F29[];
extern char sipNm_QtCore_Key_F28[];
extern char sipNm_QtCore_Key_F27[];
extern char sipNm_QtCore_Key_F26[];
extern char sipNm_QtCore_Key_F25[];
extern char sipNm_QtCore_Key_F24[];
extern char sipNm_QtCore_Key_F23[];
extern char sipNm_QtCore_Key_F22[];
extern char sipNm_QtCore_Key_F21[];
extern char sipNm_QtCore_Key_F20[];
extern char sipNm_QtCore_Key_F19[];
extern char sipNm_QtCore_Key_F18[];
extern char sipNm_QtCore_Key_F17[];
extern char sipNm_QtCore_Key_F16[];
extern char sipNm_QtCore_Key_F15[];
extern char sipNm_QtCore_Key_F14[];
extern char sipNm_QtCore_Key_F13[];
extern char sipNm_QtCore_Key_F12[];
extern char sipNm_QtCore_Key_F11[];
extern char sipNm_QtCore_Key_F10[];
extern char sipNm_QtCore_Key_F9[];
extern char sipNm_QtCore_Key_F8[];
extern char sipNm_QtCore_Key_F7[];
extern char sipNm_QtCore_Key_F6[];
extern char sipNm_QtCore_Key_F5[];
extern char sipNm_QtCore_Key_F4[];
extern char sipNm_QtCore_Key_F3[];
extern char sipNm_QtCore_Key_F2[];
extern char sipNm_QtCore_Key_F1[];
extern char sipNm_QtCore_Key_ScrollLock[];
extern char sipNm_QtCore_Key_NumLock[];
extern char sipNm_QtCore_Key_CapsLock[];
extern char sipNm_QtCore_Key_Alt[];
extern char sipNm_QtCore_Key_Meta[];
extern char sipNm_QtCore_Key_Control[];
extern char sipNm_QtCore_Key_Shift[];
extern char sipNm_QtCore_Key_PageDown[];
extern char sipNm_QtCore_Key_PageUp[];
extern char sipNm_QtCore_Key_Down[];
extern char sipNm_QtCore_Key_Right[];
extern char sipNm_QtCore_Key_Up[];
extern char sipNm_QtCore_Key_Left[];
extern char sipNm_QtCore_Key_End[];
extern char sipNm_QtCore_Key_Home[];
extern char sipNm_QtCore_Key_Clear[];
extern char sipNm_QtCore_Key_SysReq[];
extern char sipNm_QtCore_Key_Print[];
extern char sipNm_QtCore_Key_Pause[];
extern char sipNm_QtCore_Key_Delete[];
extern char sipNm_QtCore_Key_Insert[];
extern char sipNm_QtCore_Key_Enter[];
extern char sipNm_QtCore_Key_Return[];
extern char sipNm_QtCore_Key_Backspace[];
extern char sipNm_QtCore_Key_Backtab[];
extern char sipNm_QtCore_Key_Tab[];
extern char sipNm_QtCore_Key_Escape[];
extern char sipNm_QtCore_OpaqueMode[];
extern char sipNm_QtCore_TransparentMode[];
extern char sipNm_QtCore_ImageConversionFlags[];
extern char sipNm_QtCore_AvoidDither[];
extern char sipNm_QtCore_PreferDither[];
extern char sipNm_QtCore_AutoDither[];
extern char sipNm_QtCore_DitherMode_Mask[];
extern char sipNm_QtCore_ThresholdDither[];
extern char sipNm_QtCore_OrderedDither[];
extern char sipNm_QtCore_DiffuseDither[];
extern char sipNm_QtCore_Dither_Mask[];
extern char sipNm_QtCore_NoAlpha[];
extern char sipNm_QtCore_DiffuseAlphaDither[];
extern char sipNm_QtCore_OrderedAlphaDither[];
extern char sipNm_QtCore_ThresholdAlphaDither[];
extern char sipNm_QtCore_AlphaDither_Mask[];
extern char sipNm_QtCore_MonoOnly[];
extern char sipNm_QtCore_ColorOnly[];
extern char sipNm_QtCore_AutoColor[];
extern char sipNm_QtCore_ColorMode_Mask[];
extern char sipNm_QtCore_ImageConversionFlag[];
extern char sipNm_QtCore_WA_X11NetWmWindowTypeDND[];
extern char sipNm_QtCore_WA_X11NetWmWindowTypeCombo[];
extern char sipNm_QtCore_WA_X11NetWmWindowTypeNotification[];
extern char sipNm_QtCore_WA_X11NetWmWindowTypeToolTip[];
extern char sipNm_QtCore_WA_X11NetWmWindowTypePopupMenu[];
extern char sipNm_QtCore_WA_X11NetWmWindowTypeDropDownMenu[];
extern char sipNm_QtCore_WA_X11NetWmWindowTypeDialog[];
extern char sipNm_QtCore_WA_X11NetWmWindowTypeSplash[];
extern char sipNm_QtCore_WA_X11NetWmWindowTypeUtility[];
extern char sipNm_QtCore_WA_X11NetWmWindowTypeMenu[];
extern char sipNm_QtCore_WA_X11NetWmWindowTypeToolBar[];
extern char sipNm_QtCore_WA_X11NetWmWindowTypeDock[];
extern char sipNm_QtCore_WA_X11NetWmWindowTypeDesktop[];
extern char sipNm_QtCore_WA_MacVariableSize[];
extern char sipNm_QtCore_WA_DontCreateNativeAncestors[];
extern char sipNm_QtCore_WA_NativeWindow[];
extern char sipNm_QtCore_WA_ShowWithoutActivating[];
extern char sipNm_QtCore_WA_StyleSheet[];
extern char sipNm_QtCore_WA_MacAlwaysShowToolWindow[];
extern char sipNm_QtCore_WA_MSWindowsUseDirect3D[];
extern char sipNm_QtCore_WA_StyledBackground[];
extern char sipNm_QtCore_WA_LayoutUsesWidgetRect[];
extern char sipNm_QtCore_WA_MacMiniSize[];
extern char sipNm_QtCore_WA_MacSmallSize[];
extern char sipNm_QtCore_WA_MacNormalSize[];
extern char sipNm_QtCore_WA_MacShowFocusRect[];
extern char sipNm_QtCore_WA_SetLocale[];
extern char sipNm_QtCore_WA_MacBrushedMetal[];
extern char sipNm_QtCore_WA_SetStyle[];
extern char sipNm_QtCore_WA_MacOpaqueSizeGrip[];
extern char sipNm_QtCore_WA_AlwaysShowToolTips[];
extern char sipNm_QtCore_WA_AttributeCount[];
extern char sipNm_QtCore_WA_X11OpenGLOverlay[];
extern char sipNm_QtCore_WA_TintedBackground[];
extern char sipNm_QtCore_WA_NoX11EventCompression[];
extern char sipNm_QtCore_WA_WindowPropagation[];
extern char sipNm_QtCore_WA_AcceptDrops[];
extern char sipNm_QtCore_WA_KeyboardFocusChange[];
extern char sipNm_QtCore_WA_QuitOnClose[];
extern char sipNm_QtCore_WA_InputMethodTransparent[];
extern char sipNm_QtCore_WA_Hover[];
extern char sipNm_QtCore_WA_NoMousePropagation[];
extern char sipNm_QtCore_WA_GroupLeader[];
extern char sipNm_QtCore_WA_MouseNoMask[];
extern char sipNm_QtCore_WA_WState_ExplicitShowHide[];
extern char sipNm_QtCore_WA_WState_OwnSizePolicy[];
extern char sipNm_QtCore_WA_WState_Polished[];
extern char sipNm_QtCore_WA_WState_ConfigPending[];
extern char sipNm_QtCore_WA_WState_Reparented[];
extern char sipNm_QtCore_WA_WState_InPaintEvent[];
extern char sipNm_QtCore_WA_WState_CompressKeys[];
extern char sipNm_QtCore_WA_WState_Created[];
extern char sipNm_QtCore_WA_ForceUpdatesDisabled[];
extern char sipNm_QtCore_WA_NoChildEventsForParent[];
extern char sipNm_QtCore_WA_SetLayoutDirection[];
extern char sipNm_QtCore_WA_RightToLeft[];
extern char sipNm_QtCore_WA_DeleteOnClose[];
extern char sipNm_QtCore_WA_NoMouseReplay[];
extern char sipNm_QtCore_WA_SetWindowIcon[];
extern char sipNm_QtCore_WA_PaintUnclipped[];
extern char sipNm_QtCore_WA_TransparentForMouseEvents[];
extern char sipNm_QtCore_WA_GrabbedShortcut[];
extern char sipNm_QtCore_WA_OutsideWSRange[];
extern char sipNm_QtCore_WA_LayoutOnEntireRect[];
extern char sipNm_QtCore_WA_CustomWhatsThis[];
extern char sipNm_QtCore_WA_MacMetalStyle[];
extern char sipNm_QtCore_WA_InvalidSize[];
extern char sipNm_QtCore_WA_PendingUpdate[];
extern char sipNm_QtCore_WA_Moved[];
extern char sipNm_QtCore_WA_Resized[];
extern char sipNm_QtCore_WA_WindowModified[];
extern char sipNm_QtCore_WA_NoChildEventsFromChildren[];
extern char sipNm_QtCore_WA_SetCursor[];
extern char sipNm_QtCore_WA_SetFont[];
extern char sipNm_QtCore_WA_SetPalette[];
extern char sipNm_QtCore_WA_PendingResizeEvent[];
extern char sipNm_QtCore_WA_PendingMoveEvent[];
extern char sipNm_QtCore_WA_KeyCompression[];
extern char sipNm_QtCore_WA_ForceDisabled[];
extern char sipNm_QtCore_WA_WState_Hidden[];
extern char sipNm_QtCore_WA_WState_Visible[];
extern char sipNm_QtCore_WA_InputMethodEnabled[];
extern char sipNm_QtCore_WA_PaintOutsidePaintEvent[];
extern char sipNm_QtCore_WA_MacNoClickThrough[];
extern char sipNm_QtCore_WA_Mapped[];
extern char sipNm_QtCore_WA_UpdatesDisabled[];
extern char sipNm_QtCore_WA_NoSystemBackground[];
extern char sipNm_QtCore_WA_PaintOnScreen[];
extern char sipNm_QtCore_WA_LaidOut[];
extern char sipNm_QtCore_WA_StaticContents[];
extern char sipNm_QtCore_WA_OpaquePaintEvent[];
extern char sipNm_QtCore_WA_MouseTracking[];
extern char sipNm_QtCore_WA_UnderMouse[];
extern char sipNm_QtCore_WA_Disabled[];
extern char sipNm_QtCore_WindowStates[];
extern char sipNm_QtCore_WindowActive[];
extern char sipNm_QtCore_WindowFullScreen[];
extern char sipNm_QtCore_WindowMaximized[];
extern char sipNm_QtCore_WindowMinimized[];
extern char sipNm_QtCore_WindowNoState[];
extern char sipNm_QtCore_WindowState[];
extern char sipNm_QtCore_WindowFlags[];
extern char sipNm_QtCore_WindowCancelButtonHint[];
extern char sipNm_QtCore_WindowOkButtonHint[];
extern char sipNm_QtCore_WindowStaysOnTopHint[];
extern char sipNm_QtCore_WindowShadeButtonHint[];
extern char sipNm_QtCore_WindowContextHelpButtonHint[];
extern char sipNm_QtCore_WindowMinMaxButtonsHint[];
extern char sipNm_QtCore_WindowMaximizeButtonHint[];
extern char sipNm_QtCore_WindowMinimizeButtonHint[];
extern char sipNm_QtCore_WindowSystemMenuHint[];
extern char sipNm_QtCore_WindowTitleHint[];
extern char sipNm_QtCore_CustomizeWindowHint[];
extern char sipNm_QtCore_FramelessWindowHint[];
extern char sipNm_QtCore_X11BypassWindowManagerHint[];
extern char sipNm_QtCore_MSWindowsOwnDC[];
extern char sipNm_QtCore_MSWindowsFixedSizeDialogHint[];
extern char sipNm_QtCore_WindowType_Mask[];
extern char sipNm_QtCore_SubWindow[];
extern char sipNm_QtCore_Desktop[];
extern char sipNm_QtCore_SplashScreen[];
extern char sipNm_QtCore_ToolTip[];
extern char sipNm_QtCore_Tool[];
extern char sipNm_QtCore_Popup[];
extern char sipNm_QtCore_Drawer[];
extern char sipNm_QtCore_Sheet[];
extern char sipNm_QtCore_Dialog[];
extern char sipNm_QtCore_Window[];
extern char sipNm_QtCore_Widget[];
extern char sipNm_QtCore_WindowType[];
extern char sipNm_QtCore_ElideNone[];
extern char sipNm_QtCore_ElideMiddle[];
extern char sipNm_QtCore_ElideRight[];
extern char sipNm_QtCore_ElideLeft[];
extern char sipNm_QtCore_TextJustificationForced[];
extern char sipNm_QtCore_TextHideMnemonic[];
extern char sipNm_QtCore_TextIncludeTrailingSpaces[];
extern char sipNm_QtCore_TextDontPrint[];
extern char sipNm_QtCore_TextWrapAnywhere[];
extern char sipNm_QtCore_TextWordWrap[];
extern char sipNm_QtCore_TextShowMnemonic[];
extern char sipNm_QtCore_TextExpandTabs[];
extern char sipNm_QtCore_TextDontClip[];
extern char sipNm_QtCore_TextSingleLine[];
extern char sipNm_QtCore_Alignment[];
extern char sipNm_QtCore_AlignCenter[];
extern char sipNm_QtCore_AlignVertical_Mask[];
extern char sipNm_QtCore_AlignVCenter[];
extern char sipNm_QtCore_AlignBottom[];
extern char sipNm_QtCore_AlignTop[];
extern char sipNm_QtCore_AlignHorizontal_Mask[];
extern char sipNm_QtCore_AlignAbsolute[];
extern char sipNm_QtCore_AlignJustify[];
extern char sipNm_QtCore_AlignHCenter[];
extern char sipNm_QtCore_AlignTrailing[];
extern char sipNm_QtCore_AlignRight[];
extern char sipNm_QtCore_AlignLeading[];
extern char sipNm_QtCore_AlignLeft[];
extern char sipNm_QtCore_AlignmentFlag[];
extern char sipNm_QtCore_DescendingOrder[];
extern char sipNm_QtCore_AscendingOrder[];
extern char sipNm_QtCore_WheelFocus[];
extern char sipNm_QtCore_StrongFocus[];
extern char sipNm_QtCore_ClickFocus[];
extern char sipNm_QtCore_TabFocus[];
extern char sipNm_QtCore_NoFocus[];
extern char sipNm_QtCore_Orientations[];
extern char sipNm_QtCore_Vertical[];
extern char sipNm_QtCore_Horizontal[];
extern char sipNm_QtCore_Orientation[];
extern char sipNm_QtCore_MouseButtons[];
extern char sipNm_QtCore_MouseButtonMask[];
extern char sipNm_QtCore_XButton2[];
extern char sipNm_QtCore_XButton1[];
extern char sipNm_QtCore_MidButton[];
extern char sipNm_QtCore_RightButton[];
extern char sipNm_QtCore_LeftButton[];
extern char sipNm_QtCore_NoButton[];
extern char sipNm_QtCore_MouseButton[];
extern char sipNm_QtCore_UNICODE_ACCEL[];
extern char sipNm_QtCore_MODIFIER_MASK[];
extern char sipNm_QtCore_ALT[];
extern char sipNm_QtCore_CTRL[];
extern char sipNm_QtCore_SHIFT[];
extern char sipNm_QtCore_META[];
extern char sipNm_QtCore_KeyboardModifiers[];
extern char sipNm_QtCore_KeyboardModifierMask[];
extern char sipNm_QtCore_GroupSwitchModifier[];
extern char sipNm_QtCore_KeypadModifier[];
extern char sipNm_QtCore_MetaModifier[];
extern char sipNm_QtCore_AltModifier[];
extern char sipNm_QtCore_ControlModifier[];
extern char sipNm_QtCore_ShiftModifier[];
extern char sipNm_QtCore_NoModifier[];
extern char sipNm_QtCore_KeyboardModifier[];
extern char sipNm_QtCore_transparent[];
extern char sipNm_QtCore_darkYellow[];
extern char sipNm_QtCore_darkMagenta[];
extern char sipNm_QtCore_darkCyan[];
extern char sipNm_QtCore_darkBlue[];
extern char sipNm_QtCore_darkGreen[];
extern char sipNm_QtCore_darkRed[];
extern char sipNm_QtCore_yellow[];
extern char sipNm_QtCore_magenta[];
extern char sipNm_QtCore_cyan[];
extern char sipNm_QtCore_blue[];
extern char sipNm_QtCore_green[];
extern char sipNm_QtCore_red[];
extern char sipNm_QtCore_lightGray[];
extern char sipNm_QtCore_gray[];
extern char sipNm_QtCore_darkGray[];
extern char sipNm_QtCore_white[];
extern char sipNm_QtCore_black[];
extern char sipNm_QtCore_color1[];
extern char sipNm_QtCore_color0[];
extern char sipNm_QtCore_qrand[];
extern char sipNm_QtCore_qsrand[];
extern char sipNm_QtCore_qIsNull[];
extern char sipNm_QtCore_qFuzzyCompare[];
extern char sipNm_QtCore_qUnregisterResourceData[];
extern char sipNm_QtCore_qRegisterResourceData[];
extern char sipNm_QtCore___nonzero__[];
extern char sipNm_QtCore___ne__[];
extern char sipNm_QtCore___eq__[];
extern char sipNm_QtCore___invert__[];
extern char sipNm_QtCore___and__[];
extern char sipNm_QtCore___xor__[];
extern char sipNm_QtCore___or__[];
extern char sipNm_QtCore___int__[];
extern char sipNm_QtCore___ixor__[];
extern char sipNm_QtCore___ior__[];
extern char sipNm_QtCore___iand__[];
extern char sipNm_QtCore_QFlags[];
extern char sipNm_QtCore_qInstallMsgHandler[];
extern char sipNm_QtCore_QtSystemMsg[];
extern char sipNm_QtCore_QtFatalMsg[];
extern char sipNm_QtCore_QtCriticalMsg[];
extern char sipNm_QtCore_QtWarningMsg[];
extern char sipNm_QtCore_QtDebugMsg[];
extern char sipNm_QtCore_qErrnoWarning[];
extern char sipNm_QtCore_qFatal[];
extern char sipNm_QtCore_qCritical[];
extern char sipNm_QtCore_qWarning[];
extern char sipNm_QtCore_qDebug[];
extern char sipNm_QtCore_qSharedBuild[];
extern char sipNm_QtCore_qVersion[];
extern char sipNm_QtCore_ByteOrder[];
extern char sipNm_QtCore_LittleEndian[];
extern char sipNm_QtCore_BigEndian[];
extern char sipNm_QtCore_WordSize[];
extern char sipNm_QtCore_QSysInfo[];
extern char sipNm_QtCore_qRound64[];
extern char sipNm_QtCore_qRound[];
extern char sipNm_QtCore_qAbs[];
extern char sipNm_QtCore_QT_VERSION_STR[];
extern char sipNm_QtCore_QT_VERSION[];
extern char sipNm_QtCore_PYQT_VERSION_STR[];
extern char sipNm_QtCore_PYQT_VERSION[];

#define sipEnum_QtMsgType              sipModuleAPI_QtCore.em_enums[134]

#define sipClass_QSysInfo             sipModuleAPI_QtCore.em_types[150]
#define sipCast_QSysInfo              sipType_QtCore_QSysInfo.td_cast
#define sipForceConvertTo_QSysInfo    sipType_QtCore_QSysInfo.td_fcto

#define sipEnum_QSysInfo_Endian              sipModuleAPI_QtCore.em_enums[135]
#define sipEnum_QSysInfo_Sizes              sipModuleAPI_QtCore.em_enums[136]

extern sipTypeDef sipType_QtCore_QSysInfo;

#define sipClass_Qt             sipModuleAPI_QtCore.em_types[136]

#define sipEnum_Qt_WindowFrameSection              sipModuleAPI_QtCore.em_enums[75]
#define sipEnum_Qt_SizeHint              sipModuleAPI_QtCore.em_enums[76]
#define sipEnum_Qt_SizeMode              sipModuleAPI_QtCore.em_enums[77]
#define sipEnum_Qt_EventPriority              sipModuleAPI_QtCore.em_enums[78]
#define sipEnum_Qt_Axis              sipModuleAPI_QtCore.em_enums[79]
#define sipEnum_Qt_MaskMode              sipModuleAPI_QtCore.em_enums[80]
#define sipEnum_Qt_TextInteractionFlag              sipModuleAPI_QtCore.em_enums[81]
#define sipEnum_Qt_ItemSelectionMode              sipModuleAPI_QtCore.em_enums[82]
#define sipEnum_Qt_ApplicationAttribute              sipModuleAPI_QtCore.em_enums[83]
#define sipEnum_Qt_WindowModality              sipModuleAPI_QtCore.em_enums[84]
#define sipEnum_Qt_MatchFlag              sipModuleAPI_QtCore.em_enums[85]
#define sipEnum_Qt_ItemFlag              sipModuleAPI_QtCore.em_enums[86]
#define sipEnum_Qt_ItemDataRole              sipModuleAPI_QtCore.em_enums[87]
#define sipEnum_Qt_CheckState              sipModuleAPI_QtCore.em_enums[88]
#define sipEnum_Qt_DropAction              sipModuleAPI_QtCore.em_enums[89]
#define sipEnum_Qt_LayoutDirection              sipModuleAPI_QtCore.em_enums[90]
#define sipEnum_Qt_ToolButtonStyle              sipModuleAPI_QtCore.em_enums[91]
#define sipEnum_Qt_InputMethodQuery              sipModuleAPI_QtCore.em_enums[92]
#define sipEnum_Qt_ContextMenuPolicy              sipModuleAPI_QtCore.em_enums[93]
#define sipEnum_Qt_FocusReason              sipModuleAPI_QtCore.em_enums[94]
#define sipEnum_Qt_TransformationMode              sipModuleAPI_QtCore.em_enums[95]
#define sipEnum_Qt_ClipOperation              sipModuleAPI_QtCore.em_enums[96]
#define sipEnum_Qt_FillRule              sipModuleAPI_QtCore.em_enums[97]
#define sipEnum_Qt_ShortcutContext              sipModuleAPI_QtCore.em_enums[98]
#define sipEnum_Qt_ConnectionType              sipModuleAPI_QtCore.em_enums[99]
#define sipEnum_Qt_Corner              sipModuleAPI_QtCore.em_enums[100]
#define sipEnum_Qt_CaseSensitivity              sipModuleAPI_QtCore.em_enums[101]
#define sipEnum_Qt_ScrollBarPolicy              sipModuleAPI_QtCore.em_enums[102]
#define sipEnum_Qt_DayOfWeek              sipModuleAPI_QtCore.em_enums[103]
#define sipEnum_Qt_TimeSpec              sipModuleAPI_QtCore.em_enums[104]
#define sipEnum_Qt_DateFormat              sipModuleAPI_QtCore.em_enums[105]
#define sipEnum_Qt_ToolBarArea              sipModuleAPI_QtCore.em_enums[106]
#define sipEnum_Qt_DockWidgetArea              sipModuleAPI_QtCore.em_enums[107]
#define sipEnum_Qt_AnchorAttribute              sipModuleAPI_QtCore.em_enums[108]
#define sipEnum_Qt_AspectRatioMode              sipModuleAPI_QtCore.em_enums[109]
#define sipEnum_Qt_TextFormat              sipModuleAPI_QtCore.em_enums[110]
#define sipEnum_Qt_CursorShape              sipModuleAPI_QtCore.em_enums[111]
#define sipEnum_Qt_UIEffect              sipModuleAPI_QtCore.em_enums[112]
#define sipEnum_Qt_BrushStyle              sipModuleAPI_QtCore.em_enums[113]
#define sipEnum_Qt_PenJoinStyle              sipModuleAPI_QtCore.em_enums[114]
#define sipEnum_Qt_PenCapStyle              sipModuleAPI_QtCore.em_enums[115]
#define sipEnum_Qt_PenStyle              sipModuleAPI_QtCore.em_enums[116]
#define sipEnum_Qt_ArrowType              sipModuleAPI_QtCore.em_enums[117]
#define sipEnum_Qt_Key              sipModuleAPI_QtCore.em_enums[118]
#define sipEnum_Qt_BGMode              sipModuleAPI_QtCore.em_enums[119]
#define sipEnum_Qt_ImageConversionFlag              sipModuleAPI_QtCore.em_enums[120]
#define sipEnum_Qt_WidgetAttribute              sipModuleAPI_QtCore.em_enums[121]
#define sipEnum_Qt_WindowState              sipModuleAPI_QtCore.em_enums[122]
#define sipEnum_Qt_WindowType              sipModuleAPI_QtCore.em_enums[123]
#define sipEnum_Qt_TextElideMode              sipModuleAPI_QtCore.em_enums[124]
#define sipEnum_Qt_TextFlag              sipModuleAPI_QtCore.em_enums[125]
#define sipEnum_Qt_AlignmentFlag              sipModuleAPI_QtCore.em_enums[126]
#define sipEnum_Qt_SortOrder              sipModuleAPI_QtCore.em_enums[127]
#define sipEnum_Qt_FocusPolicy              sipModuleAPI_QtCore.em_enums[128]
#define sipEnum_Qt_Orientation              sipModuleAPI_QtCore.em_enums[129]
#define sipEnum_Qt_MouseButton              sipModuleAPI_QtCore.em_enums[130]
#define sipEnum_Qt_Modifier              sipModuleAPI_QtCore.em_enums[131]
#define sipEnum_Qt_KeyboardModifier              sipModuleAPI_QtCore.em_enums[132]
#define sipEnum_Qt_GlobalColor              sipModuleAPI_QtCore.em_enums[133]

extern sipTypeDef sipType_QtCore_Qt;

#define sipClass_Qt_KeyboardModifiers             sipModuleAPI_QtCore.em_types[149]
#define sipCast_Qt_KeyboardModifiers              sipType_QtCore_Qt_KeyboardModifiers.td_cast
#define sipForceConvertTo_Qt_KeyboardModifiers    sipType_QtCore_Qt_KeyboardModifiers.td_fcto

extern sipTypeDef sipType_QtCore_Qt_KeyboardModifiers;

#define sipClass_Qt_MouseButtons             sipModuleAPI_QtCore.em_types[148]
#define sipCast_Qt_MouseButtons              sipType_QtCore_Qt_MouseButtons.td_cast
#define sipForceConvertTo_Qt_MouseButtons    sipType_QtCore_Qt_MouseButtons.td_fcto

extern sipTypeDef sipType_QtCore_Qt_MouseButtons;

#define sipClass_Qt_Orientations             sipModuleAPI_QtCore.em_types[147]
#define sipCast_Qt_Orientations              sipType_QtCore_Qt_Orientations.td_cast
#define sipForceConvertTo_Qt_Orientations    sipType_QtCore_Qt_Orientations.td_fcto

extern sipTypeDef sipType_QtCore_Qt_Orientations;

#define sipClass_Qt_Alignment             sipModuleAPI_QtCore.em_types[146]
#define sipCast_Qt_Alignment              sipType_QtCore_Qt_Alignment.td_cast
#define sipForceConvertTo_Qt_Alignment    sipType_QtCore_Qt_Alignment.td_fcto

extern sipTypeDef sipType_QtCore_Qt_Alignment;

#define sipClass_Qt_WindowFlags             sipModuleAPI_QtCore.em_types[145]
#define sipCast_Qt_WindowFlags              sipType_QtCore_Qt_WindowFlags.td_cast
#define sipForceConvertTo_Qt_WindowFlags    sipType_QtCore_Qt_WindowFlags.td_fcto

extern sipTypeDef sipType_QtCore_Qt_WindowFlags;

#define sipClass_Qt_WindowStates             sipModuleAPI_QtCore.em_types[144]
#define sipCast_Qt_WindowStates              sipType_QtCore_Qt_WindowStates.td_cast
#define sipForceConvertTo_Qt_WindowStates    sipType_QtCore_Qt_WindowStates.td_fcto

extern sipTypeDef sipType_QtCore_Qt_WindowStates;

#define sipClass_Qt_ImageConversionFlags             sipModuleAPI_QtCore.em_types[143]
#define sipCast_Qt_ImageConversionFlags              sipType_QtCore_Qt_ImageConversionFlags.td_cast
#define sipForceConvertTo_Qt_ImageConversionFlags    sipType_QtCore_Qt_ImageConversionFlags.td_fcto

extern sipTypeDef sipType_QtCore_Qt_ImageConversionFlags;

#define sipClass_Qt_DockWidgetAreas             sipModuleAPI_QtCore.em_types[142]
#define sipCast_Qt_DockWidgetAreas              sipType_QtCore_Qt_DockWidgetAreas.td_cast
#define sipForceConvertTo_Qt_DockWidgetAreas    sipType_QtCore_Qt_DockWidgetAreas.td_fcto

extern sipTypeDef sipType_QtCore_Qt_DockWidgetAreas;

#define sipClass_Qt_ToolBarAreas             sipModuleAPI_QtCore.em_types[141]
#define sipCast_Qt_ToolBarAreas              sipType_QtCore_Qt_ToolBarAreas.td_cast
#define sipForceConvertTo_Qt_ToolBarAreas    sipType_QtCore_Qt_ToolBarAreas.td_fcto

extern sipTypeDef sipType_QtCore_Qt_ToolBarAreas;

#define sipClass_Qt_DropActions             sipModuleAPI_QtCore.em_types[140]
#define sipCast_Qt_DropActions              sipType_QtCore_Qt_DropActions.td_cast
#define sipForceConvertTo_Qt_DropActions    sipType_QtCore_Qt_DropActions.td_fcto

extern sipTypeDef sipType_QtCore_Qt_DropActions;

#define sipClass_Qt_ItemFlags             sipModuleAPI_QtCore.em_types[139]
#define sipCast_Qt_ItemFlags              sipType_QtCore_Qt_ItemFlags.td_cast
#define sipForceConvertTo_Qt_ItemFlags    sipType_QtCore_Qt_ItemFlags.td_fcto

extern sipTypeDef sipType_QtCore_Qt_ItemFlags;

#define sipClass_Qt_MatchFlags             sipModuleAPI_QtCore.em_types[138]
#define sipCast_Qt_MatchFlags              sipType_QtCore_Qt_MatchFlags.td_cast
#define sipForceConvertTo_Qt_MatchFlags    sipType_QtCore_Qt_MatchFlags.td_fcto

extern sipTypeDef sipType_QtCore_Qt_MatchFlags;

#define sipClass_Qt_TextInteractionFlags             sipModuleAPI_QtCore.em_types[137]
#define sipCast_Qt_TextInteractionFlags              sipType_QtCore_Qt_TextInteractionFlags.td_cast
#define sipForceConvertTo_Qt_TextInteractionFlags    sipType_QtCore_Qt_TextInteractionFlags.td_fcto

extern sipTypeDef sipType_QtCore_Qt_TextInteractionFlags;

#define sipClass_QObject             sipModuleAPI_QtCore.em_types[106]
#define sipCast_QObject              sipType_QtCore_QObject.td_cast
#define sipForceConvertTo_QObject    sipType_QtCore_QObject.td_fcto

extern sipTypeDef sipType_QtCore_QObject;

#define sipClass_QAbstractEventDispatcher             sipModuleAPI_QtCore.em_types[135]
#define sipCast_QAbstractEventDispatcher              sipType_QtCore_QAbstractEventDispatcher.td_cast
#define sipForceConvertTo_QAbstractEventDispatcher    sipType_QtCore_QAbstractEventDispatcher.td_fcto

extern sipTypeDef sipType_QtCore_QAbstractEventDispatcher;

#define sipClass_QAbstractFileEngine             sipModuleAPI_QtCore.em_types[103]
#define sipCast_QAbstractFileEngine              sipType_QtCore_QAbstractFileEngine.td_cast
#define sipForceConvertTo_QAbstractFileEngine    sipType_QtCore_QAbstractFileEngine.td_fcto

#define sipEnum_QAbstractFileEngine_FileTime              sipModuleAPI_QtCore.em_enums[71]
#define sipEnum_QAbstractFileEngine_FileOwner              sipModuleAPI_QtCore.em_enums[72]
#define sipEnum_QAbstractFileEngine_FileName              sipModuleAPI_QtCore.em_enums[73]
#define sipEnum_QAbstractFileEngine_FileFlag              sipModuleAPI_QtCore.em_enums[74]

extern sipTypeDef sipType_QtCore_QAbstractFileEngine;

#define sipClass_QAbstractFileEngine_FileFlags             sipModuleAPI_QtCore.em_types[104]
#define sipCast_QAbstractFileEngine_FileFlags              sipType_QtCore_QAbstractFileEngine_FileFlags.td_cast
#define sipForceConvertTo_QAbstractFileEngine_FileFlags    sipType_QtCore_QAbstractFileEngine_FileFlags.td_fcto

extern sipTypeDef sipType_QtCore_QAbstractFileEngine_FileFlags;

#define sipClass_QAbstractFileEngineHandler             sipModuleAPI_QtCore.em_types[102]
#define sipCast_QAbstractFileEngineHandler              sipType_QtCore_QAbstractFileEngineHandler.td_cast
#define sipForceConvertTo_QAbstractFileEngineHandler    sipType_QtCore_QAbstractFileEngineHandler.td_fcto

extern sipTypeDef sipType_QtCore_QAbstractFileEngineHandler;

#define sipClass_QAbstractFileEngineIterator             sipModuleAPI_QtCore.em_types[101]
#define sipCast_QAbstractFileEngineIterator              sipType_QtCore_QAbstractFileEngineIterator.td_cast
#define sipForceConvertTo_QAbstractFileEngineIterator    sipType_QtCore_QAbstractFileEngineIterator.td_fcto

extern sipTypeDef sipType_QtCore_QAbstractFileEngineIterator;

#define sipClass_QModelIndex             sipModuleAPI_QtCore.em_types[100]
#define sipCast_QModelIndex              sipType_QtCore_QModelIndex.td_cast
#define sipForceConvertTo_QModelIndex    sipType_QtCore_QModelIndex.td_fcto

extern sipTypeDef sipType_QtCore_QModelIndex;

#define sipClass_QPersistentModelIndex             sipModuleAPI_QtCore.em_types[99]
#define sipCast_QPersistentModelIndex              sipType_QtCore_QPersistentModelIndex.td_cast
#define sipForceConvertTo_QPersistentModelIndex    sipType_QtCore_QPersistentModelIndex.td_fcto

extern sipTypeDef sipType_QtCore_QPersistentModelIndex;

#define sipClass_QAbstractItemModel             sipModuleAPI_QtCore.em_types[132]
#define sipCast_QAbstractItemModel              sipType_QtCore_QAbstractItemModel.td_cast
#define sipForceConvertTo_QAbstractItemModel    sipType_QtCore_QAbstractItemModel.td_fcto

extern sipTypeDef sipType_QtCore_QAbstractItemModel;

#define sipClass_QAbstractTableModel             sipModuleAPI_QtCore.em_types[134]
#define sipCast_QAbstractTableModel              sipType_QtCore_QAbstractTableModel.td_cast
#define sipForceConvertTo_QAbstractTableModel    sipType_QtCore_QAbstractTableModel.td_fcto

extern sipTypeDef sipType_QtCore_QAbstractTableModel;

#define sipClass_QAbstractListModel             sipModuleAPI_QtCore.em_types[133]
#define sipCast_QAbstractListModel              sipType_QtCore_QAbstractListModel.td_cast
#define sipForceConvertTo_QAbstractListModel    sipType_QtCore_QAbstractListModel.td_fcto

extern sipTypeDef sipType_QtCore_QAbstractListModel;

#define sipClass_QBasicTimer             sipModuleAPI_QtCore.em_types[98]
#define sipCast_QBasicTimer              sipType_QtCore_QBasicTimer.td_cast
#define sipForceConvertTo_QBasicTimer    sipType_QtCore_QBasicTimer.td_fcto

extern sipTypeDef sipType_QtCore_QBasicTimer;

#define sipClass_QBitArray             sipModuleAPI_QtCore.em_types[97]
#define sipCast_QBitArray              sipType_QtCore_QBitArray.td_cast
#define sipForceConvertTo_QBitArray    sipType_QtCore_QBitArray.td_fcto

extern sipTypeDef sipType_QtCore_QBitArray;

#define sipClass_QIODevice             sipModuleAPI_QtCore.em_types[125]
#define sipCast_QIODevice              sipType_QtCore_QIODevice.td_cast
#define sipForceConvertTo_QIODevice    sipType_QtCore_QIODevice.td_fcto

#define sipEnum_QIODevice_OpenModeFlag              sipModuleAPI_QtCore.em_enums[50]

extern sipTypeDef sipType_QtCore_QIODevice;

#define sipClass_QBuffer             sipModuleAPI_QtCore.em_types[131]
#define sipCast_QBuffer              sipType_QtCore_QBuffer.td_cast
#define sipForceConvertTo_QBuffer    sipType_QtCore_QBuffer.td_fcto

extern sipTypeDef sipType_QtCore_QBuffer;

#define sipClass_QByteArray             sipModuleAPI_QtCore.em_types[96]
#define sipCast_QByteArray              sipType_QtCore_QByteArray.td_cast
#define sipForceConvertTo_QByteArray    sipType_QtCore_QByteArray.td_fcto

extern sipTypeDef sipType_QtCore_QByteArray;

#define sipClass_QByteArrayMatcher             sipModuleAPI_QtCore.em_types[95]
#define sipCast_QByteArrayMatcher              sipType_QtCore_QByteArrayMatcher.td_cast
#define sipForceConvertTo_QByteArrayMatcher    sipType_QtCore_QByteArrayMatcher.td_fcto

extern sipTypeDef sipType_QtCore_QByteArrayMatcher;

#define sipClass_QLatin1Char             sipModuleAPI_QtCore.em_types[94]
#define sipCast_QLatin1Char              sipType_QtCore_QLatin1Char.td_cast
#define sipForceConvertTo_QLatin1Char    sipType_QtCore_QLatin1Char.td_fcto

extern sipTypeDef sipType_QtCore_QLatin1Char;

#define sipClass_QChar             sipModuleAPI_QtCore.em_types[93]
#define sipCast_QChar              sipType_QtCore_QChar.td_cast
#define sipForceConvertTo_QChar    sipType_QtCore_QChar.td_fcto

#define sipEnum_QChar_UnicodeVersion              sipModuleAPI_QtCore.em_enums[64]
#define sipEnum_QChar_CombiningClass              sipModuleAPI_QtCore.em_enums[65]
#define sipEnum_QChar_Joining              sipModuleAPI_QtCore.em_enums[66]
#define sipEnum_QChar_Decomposition              sipModuleAPI_QtCore.em_enums[67]
#define sipEnum_QChar_Direction              sipModuleAPI_QtCore.em_enums[68]
#define sipEnum_QChar_Category              sipModuleAPI_QtCore.em_enums[69]
#define sipEnum_QChar_SpecialCharacter              sipModuleAPI_QtCore.em_enums[70]

extern sipTypeDef sipType_QtCore_QChar;

#define sipClass_QCoreApplication             sipModuleAPI_QtCore.em_types[124]
#define sipCast_QCoreApplication              sipType_QtCore_QCoreApplication.td_cast
#define sipForceConvertTo_QCoreApplication    sipType_QtCore_QCoreApplication.td_fcto

#define sipEnum_QCoreApplication_Encoding              sipModuleAPI_QtCore.em_enums[63]

extern sipTypeDef sipType_QtCore_QCoreApplication;

#define sipClass_QEvent             sipModuleAPI_QtCore.em_types[89]
#define sipCast_QEvent              sipType_QtCore_QEvent.td_cast
#define sipForceConvertTo_QEvent    sipType_QtCore_QEvent.td_fcto

#define sipEnum_QEvent_Type              sipModuleAPI_QtCore.em_enums[62]

extern sipTypeDef sipType_QtCore_QEvent;

#define sipClass_QTimerEvent             sipModuleAPI_QtCore.em_types[92]
#define sipCast_QTimerEvent              sipType_QtCore_QTimerEvent.td_cast
#define sipForceConvertTo_QTimerEvent    sipType_QtCore_QTimerEvent.td_fcto

extern sipTypeDef sipType_QtCore_QTimerEvent;

#define sipClass_QChildEvent             sipModuleAPI_QtCore.em_types[91]
#define sipCast_QChildEvent              sipType_QtCore_QChildEvent.td_cast
#define sipForceConvertTo_QChildEvent    sipType_QtCore_QChildEvent.td_fcto

extern sipTypeDef sipType_QtCore_QChildEvent;

#define sipClass_QDynamicPropertyChangeEvent             sipModuleAPI_QtCore.em_types[90]
#define sipCast_QDynamicPropertyChangeEvent              sipType_QtCore_QDynamicPropertyChangeEvent.td_cast
#define sipForceConvertTo_QDynamicPropertyChangeEvent    sipType_QtCore_QDynamicPropertyChangeEvent.td_fcto

extern sipTypeDef sipType_QtCore_QDynamicPropertyChangeEvent;

#define sipClass_QCryptographicHash             sipModuleAPI_QtCore.em_types[88]
#define sipCast_QCryptographicHash              sipType_QtCore_QCryptographicHash.td_cast
#define sipForceConvertTo_QCryptographicHash    sipType_QtCore_QCryptographicHash.td_fcto

#define sipEnum_QCryptographicHash_Algorithm              sipModuleAPI_QtCore.em_enums[61]

extern sipTypeDef sipType_QtCore_QCryptographicHash;

#define sipClass_QDataStream             sipModuleAPI_QtCore.em_types[87]
#define sipCast_QDataStream              sipType_QtCore_QDataStream.td_cast
#define sipForceConvertTo_QDataStream    sipType_QtCore_QDataStream.td_fcto

#define sipEnum_QDataStream_Status              sipModuleAPI_QtCore.em_enums[58]
#define sipEnum_QDataStream_ByteOrder              sipModuleAPI_QtCore.em_enums[59]
#define sipEnum_QDataStream_Version              sipModuleAPI_QtCore.em_enums[60]

extern sipTypeDef sipType_QtCore_QDataStream;

#define sipClass_QDate             sipModuleAPI_QtCore.em_types[86]
#define sipCast_QDate              sipType_QtCore_QDate.td_cast
#define sipForceConvertTo_QDate    sipType_QtCore_QDate.td_fcto

extern sipTypeDef sipType_QtCore_QDate;

#define sipClass_QTime             sipModuleAPI_QtCore.em_types[85]
#define sipCast_QTime              sipType_QtCore_QTime.td_cast
#define sipForceConvertTo_QTime    sipType_QtCore_QTime.td_fcto

extern sipTypeDef sipType_QtCore_QTime;

#define sipClass_QDateTime             sipModuleAPI_QtCore.em_types[84]
#define sipCast_QDateTime              sipType_QtCore_QDateTime.td_cast
#define sipForceConvertTo_QDateTime    sipType_QtCore_QDateTime.td_fcto

extern sipTypeDef sipType_QtCore_QDateTime;

#define sipClass_QDir             sipModuleAPI_QtCore.em_types[81]
#define sipCast_QDir              sipType_QtCore_QDir.td_cast
#define sipForceConvertTo_QDir    sipType_QtCore_QDir.td_fcto

#define sipEnum_QDir_SortFlag              sipModuleAPI_QtCore.em_enums[56]
#define sipEnum_QDir_Filter              sipModuleAPI_QtCore.em_enums[57]

extern sipTypeDef sipType_QtCore_QDir;

#define sipClass_QDir_Filters             sipModuleAPI_QtCore.em_types[83]
#define sipCast_QDir_Filters              sipType_QtCore_QDir_Filters.td_cast
#define sipForceConvertTo_QDir_Filters    sipType_QtCore_QDir_Filters.td_fcto

extern sipTypeDef sipType_QtCore_QDir_Filters;

#define sipClass_QDir_SortFlags             sipModuleAPI_QtCore.em_types[82]
#define sipCast_QDir_SortFlags              sipType_QtCore_QDir_SortFlags.td_cast
#define sipForceConvertTo_QDir_SortFlags    sipType_QtCore_QDir_SortFlags.td_fcto

extern sipTypeDef sipType_QtCore_QDir_SortFlags;

#define sipClass_QDirIterator             sipModuleAPI_QtCore.em_types[79]
#define sipCast_QDirIterator              sipType_QtCore_QDirIterator.td_cast
#define sipForceConvertTo_QDirIterator    sipType_QtCore_QDirIterator.td_fcto

#define sipEnum_QDirIterator_IteratorFlag              sipModuleAPI_QtCore.em_enums[55]

extern sipTypeDef sipType_QtCore_QDirIterator;

#define sipClass_QDirIterator_IteratorFlags             sipModuleAPI_QtCore.em_types[80]
#define sipCast_QDirIterator_IteratorFlags              sipType_QtCore_QDirIterator_IteratorFlags.td_cast
#define sipForceConvertTo_QDirIterator_IteratorFlags    sipType_QtCore_QDirIterator_IteratorFlags.td_fcto

extern sipTypeDef sipType_QtCore_QDirIterator_IteratorFlags;

#define sipClass_QEventLoop             sipModuleAPI_QtCore.em_types[122]
#define sipCast_QEventLoop              sipType_QtCore_QEventLoop.td_cast
#define sipForceConvertTo_QEventLoop    sipType_QtCore_QEventLoop.td_fcto

#define sipEnum_QEventLoop_ProcessEventsFlag              sipModuleAPI_QtCore.em_enums[54]

extern sipTypeDef sipType_QtCore_QEventLoop;

#define sipClass_QEventLoop_ProcessEventsFlags             sipModuleAPI_QtCore.em_types[123]
#define sipCast_QEventLoop_ProcessEventsFlags              sipType_QtCore_QEventLoop_ProcessEventsFlags.td_cast
#define sipForceConvertTo_QEventLoop_ProcessEventsFlags    sipType_QtCore_QEventLoop_ProcessEventsFlags.td_fcto

extern sipTypeDef sipType_QtCore_QEventLoop_ProcessEventsFlags;

#define sipClass_QFile             sipModuleAPI_QtCore.em_types[128]
#define sipCast_QFile              sipType_QtCore_QFile.td_cast
#define sipForceConvertTo_QFile    sipType_QtCore_QFile.td_fcto

#define sipEnum_QFile_Permission              sipModuleAPI_QtCore.em_enums[51]
#define sipEnum_QFile_MemoryMapFlags              sipModuleAPI_QtCore.em_enums[52]
#define sipEnum_QFile_FileError              sipModuleAPI_QtCore.em_enums[53]

extern sipTypeDef sipType_QtCore_QFile;

#define sipClass_QFile_Permissions             sipModuleAPI_QtCore.em_types[129]
#define sipCast_QFile_Permissions              sipType_QtCore_QFile_Permissions.td_cast
#define sipForceConvertTo_QFile_Permissions    sipType_QtCore_QFile_Permissions.td_fcto

extern sipTypeDef sipType_QtCore_QFile_Permissions;

#define sipClass_QFileInfo             sipModuleAPI_QtCore.em_types[78]
#define sipCast_QFileInfo              sipType_QtCore_QFileInfo.td_cast
#define sipForceConvertTo_QFileInfo    sipType_QtCore_QFileInfo.td_fcto

extern sipTypeDef sipType_QtCore_QFileInfo;

#define sipClass_QFileSystemWatcher             sipModuleAPI_QtCore.em_types[121]
#define sipCast_QFileSystemWatcher              sipType_QtCore_QFileSystemWatcher.td_cast
#define sipForceConvertTo_QFileSystemWatcher    sipType_QtCore_QFileSystemWatcher.td_fcto

extern sipTypeDef sipType_QtCore_QFileSystemWatcher;

#define sipClass_QFSFileEngine             sipModuleAPI_QtCore.em_types[105]
#define sipCast_QFSFileEngine              sipType_QtCore_QFSFileEngine.td_cast
#define sipForceConvertTo_QFSFileEngine    sipType_QtCore_QFSFileEngine.td_fcto

extern sipTypeDef sipType_QtCore_QFSFileEngine;

#define sipClass_QIODevice_OpenMode             sipModuleAPI_QtCore.em_types[126]
#define sipCast_QIODevice_OpenMode              sipType_QtCore_QIODevice_OpenMode.td_cast
#define sipForceConvertTo_QIODevice_OpenMode    sipType_QtCore_QIODevice_OpenMode.td_fcto

extern sipTypeDef sipType_QtCore_QIODevice_OpenMode;

#define sipClass_QLibrary             sipModuleAPI_QtCore.em_types[119]
#define sipCast_QLibrary              sipType_QtCore_QLibrary.td_cast
#define sipForceConvertTo_QLibrary    sipType_QtCore_QLibrary.td_fcto

#define sipEnum_QLibrary_LoadHint              sipModuleAPI_QtCore.em_enums[49]

extern sipTypeDef sipType_QtCore_QLibrary;

#define sipClass_QLibrary_LoadHints             sipModuleAPI_QtCore.em_types[120]
#define sipCast_QLibrary_LoadHints              sipType_QtCore_QLibrary_LoadHints.td_cast
#define sipForceConvertTo_QLibrary_LoadHints    sipType_QtCore_QLibrary_LoadHints.td_fcto

extern sipTypeDef sipType_QtCore_QLibrary_LoadHints;

#define sipClass_QLibraryInfo             sipModuleAPI_QtCore.em_types[77]
#define sipCast_QLibraryInfo              sipType_QtCore_QLibraryInfo.td_cast
#define sipForceConvertTo_QLibraryInfo    sipType_QtCore_QLibraryInfo.td_fcto

#define sipEnum_QLibraryInfo_LibraryLocation              sipModuleAPI_QtCore.em_enums[48]

extern sipTypeDef sipType_QtCore_QLibraryInfo;

#define sipClass_QLine             sipModuleAPI_QtCore.em_types[76]
#define sipCast_QLine              sipType_QtCore_QLine.td_cast
#define sipForceConvertTo_QLine    sipType_QtCore_QLine.td_fcto

extern sipTypeDef sipType_QtCore_QLine;

#define sipClass_QLineF             sipModuleAPI_QtCore.em_types[75]
#define sipCast_QLineF              sipType_QtCore_QLineF.td_cast
#define sipForceConvertTo_QLineF    sipType_QtCore_QLineF.td_fcto

#define sipEnum_QLineF_IntersectType              sipModuleAPI_QtCore.em_enums[47]

extern sipTypeDef sipType_QtCore_QLineF;

#define sipClass_QLocale             sipModuleAPI_QtCore.em_types[73]
#define sipCast_QLocale              sipType_QtCore_QLocale.td_cast
#define sipForceConvertTo_QLocale    sipType_QtCore_QLocale.td_fcto

#define sipEnum_QLocale_MeasurementSystem              sipModuleAPI_QtCore.em_enums[42]
#define sipEnum_QLocale_FormatType              sipModuleAPI_QtCore.em_enums[43]
#define sipEnum_QLocale_NumberOption              sipModuleAPI_QtCore.em_enums[44]
#define sipEnum_QLocale_Country              sipModuleAPI_QtCore.em_enums[45]
#define sipEnum_QLocale_Language              sipModuleAPI_QtCore.em_enums[46]

extern sipTypeDef sipType_QtCore_QLocale;

#define sipClass_QLocale_NumberOptions             sipModuleAPI_QtCore.em_types[74]
#define sipCast_QLocale_NumberOptions              sipType_QtCore_QLocale_NumberOptions.td_cast
#define sipForceConvertTo_QLocale_NumberOptions    sipType_QtCore_QLocale_NumberOptions.td_fcto

extern sipTypeDef sipType_QtCore_QLocale_NumberOptions;

#define sipClass_QSystemLocale             sipModuleAPI_QtCore.em_types[72]
#define sipCast_QSystemLocale              sipType_QtCore_QSystemLocale.td_cast
#define sipForceConvertTo_QSystemLocale    sipType_QtCore_QSystemLocale.td_fcto

#define sipEnum_QSystemLocale_QueryType              sipModuleAPI_QtCore.em_enums[41]

extern sipTypeDef sipType_QtCore_QSystemLocale;

#define sipClass_QMetaMethod             sipModuleAPI_QtCore.em_types[71]
#define sipCast_QMetaMethod              sipType_QtCore_QMetaMethod.td_cast
#define sipForceConvertTo_QMetaMethod    sipType_QtCore_QMetaMethod.td_fcto

#define sipEnum_QMetaMethod_MethodType              sipModuleAPI_QtCore.em_enums[39]
#define sipEnum_QMetaMethod_Access              sipModuleAPI_QtCore.em_enums[40]

extern sipTypeDef sipType_QtCore_QMetaMethod;

#define sipClass_QMetaEnum             sipModuleAPI_QtCore.em_types[70]
#define sipCast_QMetaEnum              sipType_QtCore_QMetaEnum.td_cast
#define sipForceConvertTo_QMetaEnum    sipType_QtCore_QMetaEnum.td_fcto

extern sipTypeDef sipType_QtCore_QMetaEnum;

#define sipClass_QMetaProperty             sipModuleAPI_QtCore.em_types[69]
#define sipCast_QMetaProperty              sipType_QtCore_QMetaProperty.td_cast
#define sipForceConvertTo_QMetaProperty    sipType_QtCore_QMetaProperty.td_fcto

extern sipTypeDef sipType_QtCore_QMetaProperty;

#define sipClass_QMetaClassInfo             sipModuleAPI_QtCore.em_types[68]
#define sipCast_QMetaClassInfo              sipType_QtCore_QMetaClassInfo.td_cast
#define sipForceConvertTo_QMetaClassInfo    sipType_QtCore_QMetaClassInfo.td_fcto

extern sipTypeDef sipType_QtCore_QMetaClassInfo;

#define sipClass_QMetaType             sipModuleAPI_QtCore.em_types[67]
#define sipCast_QMetaType              sipType_QtCore_QMetaType.td_cast
#define sipForceConvertTo_QMetaType    sipType_QtCore_QMetaType.td_fcto

#define sipEnum_QMetaType_Type              sipModuleAPI_QtCore.em_enums[38]

extern sipTypeDef sipType_QtCore_QMetaType;

#define sipClass_QMimeData             sipModuleAPI_QtCore.em_types[118]
#define sipCast_QMimeData              sipType_QtCore_QMimeData.td_cast
#define sipForceConvertTo_QMimeData    sipType_QtCore_QMimeData.td_fcto

extern sipTypeDef sipType_QtCore_QMimeData;

#define sipClass_QMutex             sipModuleAPI_QtCore.em_types[66]
#define sipCast_QMutex              sipType_QtCore_QMutex.td_cast
#define sipForceConvertTo_QMutex    sipType_QtCore_QMutex.td_fcto

#define sipEnum_QMutex_RecursionMode              sipModuleAPI_QtCore.em_enums[37]

extern sipTypeDef sipType_QtCore_QMutex;

#define sipClass_QMutexLocker             sipModuleAPI_QtCore.em_types[65]
#define sipCast_QMutexLocker              sipType_QtCore_QMutexLocker.td_cast
#define sipForceConvertTo_QMutexLocker    sipType_QtCore_QMutexLocker.td_fcto

extern sipTypeDef sipType_QtCore_QMutexLocker;

#define sipClass_QWidget             sipModuleAPI_QtCore.em_types[64]

#define sipClass_QBitmap             sipModuleAPI_QtCore.em_types[63]

#define sipClass_QBrush             sipModuleAPI_QtCore.em_types[62]

#define sipClass_QColor             sipModuleAPI_QtCore.em_types[61]

#define sipClass_QCursor             sipModuleAPI_QtCore.em_types[60]

#define sipClass_QFont             sipModuleAPI_QtCore.em_types[59]

#define sipClass_QIcon             sipModuleAPI_QtCore.em_types[58]

#define sipClass_QImage             sipModuleAPI_QtCore.em_types[57]

#define sipClass_QKeySequence             sipModuleAPI_QtCore.em_types[56]

#define sipClass_QMatrix             sipModuleAPI_QtCore.em_types[55]

#define sipClass_QPalette             sipModuleAPI_QtCore.em_types[54]

#define sipClass_QPen             sipModuleAPI_QtCore.em_types[53]

#define sipClass_QPixmap             sipModuleAPI_QtCore.em_types[52]

#define sipClass_QPolygon             sipModuleAPI_QtCore.em_types[51]

#define sipClass_QRegion             sipModuleAPI_QtCore.em_types[50]

#define sipClass_QSizePolicy             sipModuleAPI_QtCore.em_types[49]

#define sipClass_QTextFormat             sipModuleAPI_QtCore.em_types[48]

#define sipClass_QTextLength             sipModuleAPI_QtCore.em_types[47]

#define sipClass_QTransform             sipModuleAPI_QtCore.em_types[46]

#define sipClass_QObjectCleanupHandler             sipModuleAPI_QtCore.em_types[117]
#define sipCast_QObjectCleanupHandler              sipType_QtCore_QObjectCleanupHandler.td_cast
#define sipForceConvertTo_QObjectCleanupHandler    sipType_QtCore_QObjectCleanupHandler.td_fcto

extern sipTypeDef sipType_QtCore_QObjectCleanupHandler;

#define sipClass_QMetaObject             sipModuleAPI_QtCore.em_types[45]
#define sipCast_QMetaObject              sipType_QtCore_QMetaObject.td_cast
#define sipForceConvertTo_QMetaObject    sipType_QtCore_QMetaObject.td_fcto

extern sipTypeDef sipType_QtCore_QMetaObject;

#define sipClass_QGenericArgument             sipModuleAPI_QtCore.em_types[44]
#define sipCast_QGenericArgument              sipType_QtCore_QGenericArgument.td_cast
#define sipForceConvertTo_QGenericArgument    sipType_QtCore_QGenericArgument.td_fcto

extern sipTypeDef sipType_QtCore_QGenericArgument;

#define sipClass_QGenericReturnArgument             sipModuleAPI_QtCore.em_types[43]
#define sipCast_QGenericReturnArgument              sipType_QtCore_QGenericReturnArgument.td_cast
#define sipForceConvertTo_QGenericReturnArgument    sipType_QtCore_QGenericReturnArgument.td_fcto

extern sipTypeDef sipType_QtCore_QGenericReturnArgument;

#define sipClass_QPluginLoader             sipModuleAPI_QtCore.em_types[116]
#define sipCast_QPluginLoader              sipType_QtCore_QPluginLoader.td_cast
#define sipForceConvertTo_QPluginLoader    sipType_QtCore_QPluginLoader.td_fcto

extern sipTypeDef sipType_QtCore_QPluginLoader;

#define sipClass_QPoint             sipModuleAPI_QtCore.em_types[42]
#define sipCast_QPoint              sipType_QtCore_QPoint.td_cast
#define sipForceConvertTo_QPoint    sipType_QtCore_QPoint.td_fcto

extern sipTypeDef sipType_QtCore_QPoint;

#define sipClass_QPointF             sipModuleAPI_QtCore.em_types[41]
#define sipCast_QPointF              sipType_QtCore_QPointF.td_cast
#define sipForceConvertTo_QPointF    sipType_QtCore_QPointF.td_fcto

extern sipTypeDef sipType_QtCore_QPointF;

#define sipClass_QProcess             sipModuleAPI_QtCore.em_types[127]
#define sipCast_QProcess              sipType_QtCore_QProcess.td_cast
#define sipForceConvertTo_QProcess    sipType_QtCore_QProcess.td_fcto

#define sipEnum_QProcess_ProcessChannelMode              sipModuleAPI_QtCore.em_enums[32]
#define sipEnum_QProcess_ProcessChannel              sipModuleAPI_QtCore.em_enums[33]
#define sipEnum_QProcess_ProcessState              sipModuleAPI_QtCore.em_enums[34]
#define sipEnum_QProcess_ProcessError              sipModuleAPI_QtCore.em_enums[35]
#define sipEnum_QProcess_ExitStatus              sipModuleAPI_QtCore.em_enums[36]

extern sipTypeDef sipType_QtCore_QProcess;

#define sipClass_QReadWriteLock             sipModuleAPI_QtCore.em_types[40]
#define sipCast_QReadWriteLock              sipType_QtCore_QReadWriteLock.td_cast
#define sipForceConvertTo_QReadWriteLock    sipType_QtCore_QReadWriteLock.td_fcto

#define sipEnum_QReadWriteLock_RecursionMode              sipModuleAPI_QtCore.em_enums[31]

extern sipTypeDef sipType_QtCore_QReadWriteLock;

#define sipClass_QReadLocker             sipModuleAPI_QtCore.em_types[39]
#define sipCast_QReadLocker              sipType_QtCore_QReadLocker.td_cast
#define sipForceConvertTo_QReadLocker    sipType_QtCore_QReadLocker.td_fcto

extern sipTypeDef sipType_QtCore_QReadLocker;

#define sipClass_QWriteLocker             sipModuleAPI_QtCore.em_types[38]
#define sipCast_QWriteLocker              sipType_QtCore_QWriteLocker.td_cast
#define sipForceConvertTo_QWriteLocker    sipType_QtCore_QWriteLocker.td_fcto

extern sipTypeDef sipType_QtCore_QWriteLocker;

#define sipClass_QRect             sipModuleAPI_QtCore.em_types[37]
#define sipCast_QRect              sipType_QtCore_QRect.td_cast
#define sipForceConvertTo_QRect    sipType_QtCore_QRect.td_fcto

extern sipTypeDef sipType_QtCore_QRect;

#define sipClass_QRectF             sipModuleAPI_QtCore.em_types[36]
#define sipCast_QRectF              sipType_QtCore_QRectF.td_cast
#define sipForceConvertTo_QRectF    sipType_QtCore_QRectF.td_fcto

extern sipTypeDef sipType_QtCore_QRectF;

#define sipClass_QRegExp             sipModuleAPI_QtCore.em_types[35]
#define sipCast_QRegExp              sipType_QtCore_QRegExp.td_cast
#define sipForceConvertTo_QRegExp    sipType_QtCore_QRegExp.td_fcto

#define sipEnum_QRegExp_CaretMode              sipModuleAPI_QtCore.em_enums[29]
#define sipEnum_QRegExp_PatternSyntax              sipModuleAPI_QtCore.em_enums[30]

extern sipTypeDef sipType_QtCore_QRegExp;

#define sipClass_QResource             sipModuleAPI_QtCore.em_types[34]
#define sipCast_QResource              sipType_QtCore_QResource.td_cast
#define sipForceConvertTo_QResource    sipType_QtCore_QResource.td_fcto

extern sipTypeDef sipType_QtCore_QResource;

#define sipClass_QRunnable             sipModuleAPI_QtCore.em_types[33]
#define sipCast_QRunnable              sipType_QtCore_QRunnable.td_cast
#define sipForceConvertTo_QRunnable    sipType_QtCore_QRunnable.td_fcto

extern sipTypeDef sipType_QtCore_QRunnable;

#define sipClass_QSemaphore             sipModuleAPI_QtCore.em_types[32]
#define sipCast_QSemaphore              sipType_QtCore_QSemaphore.td_cast
#define sipForceConvertTo_QSemaphore    sipType_QtCore_QSemaphore.td_fcto

extern sipTypeDef sipType_QtCore_QSemaphore;

#define sipClass_QSettings             sipModuleAPI_QtCore.em_types[115]
#define sipCast_QSettings              sipType_QtCore_QSettings.td_cast
#define sipForceConvertTo_QSettings    sipType_QtCore_QSettings.td_fcto

#define sipEnum_QSettings_Scope              sipModuleAPI_QtCore.em_enums[26]
#define sipEnum_QSettings_Format              sipModuleAPI_QtCore.em_enums[27]
#define sipEnum_QSettings_Status              sipModuleAPI_QtCore.em_enums[28]

extern sipTypeDef sipType_QtCore_QSettings;

#define sipClass_QSharedMemory             sipModuleAPI_QtCore.em_types[114]
#define sipCast_QSharedMemory              sipType_QtCore_QSharedMemory.td_cast
#define sipForceConvertTo_QSharedMemory    sipType_QtCore_QSharedMemory.td_fcto

#define sipEnum_QSharedMemory_SharedMemoryError              sipModuleAPI_QtCore.em_enums[24]
#define sipEnum_QSharedMemory_AccessMode              sipModuleAPI_QtCore.em_enums[25]

extern sipTypeDef sipType_QtCore_QSharedMemory;

#define sipClass_QSignalMapper             sipModuleAPI_QtCore.em_types[113]
#define sipCast_QSignalMapper              sipType_QtCore_QSignalMapper.td_cast
#define sipForceConvertTo_QSignalMapper    sipType_QtCore_QSignalMapper.td_fcto

extern sipTypeDef sipType_QtCore_QSignalMapper;

#define sipClass_QSize             sipModuleAPI_QtCore.em_types[31]
#define sipCast_QSize              sipType_QtCore_QSize.td_cast
#define sipForceConvertTo_QSize    sipType_QtCore_QSize.td_fcto

extern sipTypeDef sipType_QtCore_QSize;

#define sipClass_QSizeF             sipModuleAPI_QtCore.em_types[30]
#define sipCast_QSizeF              sipType_QtCore_QSizeF.td_cast
#define sipForceConvertTo_QSizeF    sipType_QtCore_QSizeF.td_fcto

extern sipTypeDef sipType_QtCore_QSizeF;

#define sipClass_QSocketNotifier             sipModuleAPI_QtCore.em_types[112]
#define sipCast_QSocketNotifier              sipType_QtCore_QSocketNotifier.td_cast
#define sipForceConvertTo_QSocketNotifier    sipType_QtCore_QSocketNotifier.td_fcto

#define sipEnum_QSocketNotifier_Type              sipModuleAPI_QtCore.em_enums[23]

extern sipTypeDef sipType_QtCore_QSocketNotifier;

#define sipClass_QString             sipModuleAPI_QtCore.em_types[28]
#define sipCast_QString              sipType_QtCore_QString.td_cast
#define sipForceConvertTo_QString    sipType_QtCore_QString.td_fcto

#define sipEnum_QString_NormalizationForm              sipModuleAPI_QtCore.em_enums[20]
#define sipEnum_QString_SplitBehavior              sipModuleAPI_QtCore.em_enums[21]
#define sipEnum_QString_SectionFlag              sipModuleAPI_QtCore.em_enums[22]

extern sipTypeDef sipType_QtCore_QString;

#define sipClass_QString_SectionFlags             sipModuleAPI_QtCore.em_types[29]
#define sipCast_QString_SectionFlags              sipType_QtCore_QString_SectionFlags.td_cast
#define sipForceConvertTo_QString_SectionFlags    sipType_QtCore_QString_SectionFlags.td_fcto

extern sipTypeDef sipType_QtCore_QString_SectionFlags;

#define sipClass_QLatin1String             sipModuleAPI_QtCore.em_types[27]
#define sipCast_QLatin1String              sipType_QtCore_QLatin1String.td_cast
#define sipForceConvertTo_QLatin1String    sipType_QtCore_QLatin1String.td_fcto

extern sipTypeDef sipType_QtCore_QLatin1String;

#define sipClass_QStringRef             sipModuleAPI_QtCore.em_types[26]
#define sipCast_QStringRef              sipType_QtCore_QStringRef.td_cast
#define sipForceConvertTo_QStringRef    sipType_QtCore_QStringRef.td_fcto

extern sipTypeDef sipType_QtCore_QStringRef;

#define sipClass_QStringList             sipModuleAPI_QtCore.em_types[25]
#define sipCast_QStringList              sipType_QtCore_QStringList.td_cast
#define sipForceConvertTo_QStringList    sipType_QtCore_QStringList.td_fcto

extern sipTypeDef sipType_QtCore_QStringList;

#define sipClass_QStringMatcher             sipModuleAPI_QtCore.em_types[24]
#define sipCast_QStringMatcher              sipType_QtCore_QStringMatcher.td_cast
#define sipForceConvertTo_QStringMatcher    sipType_QtCore_QStringMatcher.td_fcto

extern sipTypeDef sipType_QtCore_QStringMatcher;

#define sipClass_QSystemSemaphore             sipModuleAPI_QtCore.em_types[23]
#define sipCast_QSystemSemaphore              sipType_QtCore_QSystemSemaphore.td_cast
#define sipForceConvertTo_QSystemSemaphore    sipType_QtCore_QSystemSemaphore.td_fcto

#define sipEnum_QSystemSemaphore_SystemSemaphoreError              sipModuleAPI_QtCore.em_enums[18]
#define sipEnum_QSystemSemaphore_AccessMode              sipModuleAPI_QtCore.em_enums[19]

extern sipTypeDef sipType_QtCore_QSystemSemaphore;

#define sipClass_QTemporaryFile             sipModuleAPI_QtCore.em_types[130]
#define sipCast_QTemporaryFile              sipType_QtCore_QTemporaryFile.td_cast
#define sipForceConvertTo_QTemporaryFile    sipType_QtCore_QTemporaryFile.td_fcto

extern sipTypeDef sipType_QtCore_QTemporaryFile;

#define sipClass_QTextBoundaryFinder             sipModuleAPI_QtCore.em_types[21]
#define sipCast_QTextBoundaryFinder              sipType_QtCore_QTextBoundaryFinder.td_cast
#define sipForceConvertTo_QTextBoundaryFinder    sipType_QtCore_QTextBoundaryFinder.td_fcto

#define sipEnum_QTextBoundaryFinder_BoundaryType              sipModuleAPI_QtCore.em_enums[16]
#define sipEnum_QTextBoundaryFinder_BoundaryReason              sipModuleAPI_QtCore.em_enums[17]

extern sipTypeDef sipType_QtCore_QTextBoundaryFinder;

#define sipClass_QTextBoundaryFinder_BoundaryReasons             sipModuleAPI_QtCore.em_types[22]
#define sipCast_QTextBoundaryFinder_BoundaryReasons              sipType_QtCore_QTextBoundaryFinder_BoundaryReasons.td_cast
#define sipForceConvertTo_QTextBoundaryFinder_BoundaryReasons    sipType_QtCore_QTextBoundaryFinder_BoundaryReasons.td_fcto

extern sipTypeDef sipType_QtCore_QTextBoundaryFinder_BoundaryReasons;

#define sipClass_QTextCodec             sipModuleAPI_QtCore.em_types[18]
#define sipCast_QTextCodec              sipType_QtCore_QTextCodec.td_cast
#define sipForceConvertTo_QTextCodec    sipType_QtCore_QTextCodec.td_fcto

#define sipEnum_QTextCodec_ConversionFlag              sipModuleAPI_QtCore.em_enums[15]

extern sipTypeDef sipType_QtCore_QTextCodec;

#define sipClass_QTextCodec_ConversionFlags             sipModuleAPI_QtCore.em_types[20]
#define sipCast_QTextCodec_ConversionFlags              sipType_QtCore_QTextCodec_ConversionFlags.td_cast
#define sipForceConvertTo_QTextCodec_ConversionFlags    sipType_QtCore_QTextCodec_ConversionFlags.td_fcto

extern sipTypeDef sipType_QtCore_QTextCodec_ConversionFlags;

#define sipClass_QTextCodec_ConverterState             sipModuleAPI_QtCore.em_types[19]
#define sipCast_QTextCodec_ConverterState              sipType_QtCore_QTextCodec_ConverterState.td_cast
#define sipForceConvertTo_QTextCodec_ConverterState    sipType_QtCore_QTextCodec_ConverterState.td_fcto

extern sipTypeDef sipType_QtCore_QTextCodec_ConverterState;

#define sipClass_QTextEncoder             sipModuleAPI_QtCore.em_types[17]
#define sipCast_QTextEncoder              sipType_QtCore_QTextEncoder.td_cast
#define sipForceConvertTo_QTextEncoder    sipType_QtCore_QTextEncoder.td_fcto

extern sipTypeDef sipType_QtCore_QTextEncoder;

#define sipClass_QTextDecoder             sipModuleAPI_QtCore.em_types[16]
#define sipCast_QTextDecoder              sipType_QtCore_QTextDecoder.td_cast
#define sipForceConvertTo_QTextDecoder    sipType_QtCore_QTextDecoder.td_fcto

extern sipTypeDef sipType_QtCore_QTextDecoder;

#define sipClass_QTextStream             sipModuleAPI_QtCore.em_types[14]
#define sipCast_QTextStream              sipType_QtCore_QTextStream.td_cast
#define sipForceConvertTo_QTextStream    sipType_QtCore_QTextStream.td_fcto

#define sipEnum_QTextStream_Status              sipModuleAPI_QtCore.em_enums[11]
#define sipEnum_QTextStream_NumberFlag              sipModuleAPI_QtCore.em_enums[12]
#define sipEnum_QTextStream_FieldAlignment              sipModuleAPI_QtCore.em_enums[13]
#define sipEnum_QTextStream_RealNumberNotation              sipModuleAPI_QtCore.em_enums[14]

extern sipTypeDef sipType_QtCore_QTextStream;

#define sipClass_QTextStream_NumberFlags             sipModuleAPI_QtCore.em_types[15]
#define sipCast_QTextStream_NumberFlags              sipType_QtCore_QTextStream_NumberFlags.td_cast
#define sipForceConvertTo_QTextStream_NumberFlags    sipType_QtCore_QTextStream_NumberFlags.td_fcto

extern sipTypeDef sipType_QtCore_QTextStream_NumberFlags;

#define sipClass_QTextStreamManipulator             sipModuleAPI_QtCore.em_types[13]
#define sipCast_QTextStreamManipulator              sipType_QtCore_QTextStreamManipulator.td_cast
#define sipForceConvertTo_QTextStreamManipulator    sipType_QtCore_QTextStreamManipulator.td_fcto

extern sipTypeDef sipType_QtCore_QTextStreamManipulator;

#define sipClass_QThread             sipModuleAPI_QtCore.em_types[111]
#define sipCast_QThread              sipType_QtCore_QThread.td_cast
#define sipForceConvertTo_QThread    sipType_QtCore_QThread.td_fcto

#define sipEnum_QThread_Priority              sipModuleAPI_QtCore.em_enums[10]

extern sipTypeDef sipType_QtCore_QThread;

#define sipClass_QThreadPool             sipModuleAPI_QtCore.em_types[110]
#define sipCast_QThreadPool              sipType_QtCore_QThreadPool.td_cast
#define sipForceConvertTo_QThreadPool    sipType_QtCore_QThreadPool.td_fcto

extern sipTypeDef sipType_QtCore_QThreadPool;

#define sipClass_QTimeLine             sipModuleAPI_QtCore.em_types[109]
#define sipCast_QTimeLine              sipType_QtCore_QTimeLine.td_cast
#define sipForceConvertTo_QTimeLine    sipType_QtCore_QTimeLine.td_fcto

#define sipEnum_QTimeLine_State              sipModuleAPI_QtCore.em_enums[7]
#define sipEnum_QTimeLine_Direction              sipModuleAPI_QtCore.em_enums[8]
#define sipEnum_QTimeLine_CurveShape              sipModuleAPI_QtCore.em_enums[9]

extern sipTypeDef sipType_QtCore_QTimeLine;

#define sipClass_QTimer             sipModuleAPI_QtCore.em_types[108]
#define sipCast_QTimer              sipType_QtCore_QTimer.td_cast
#define sipForceConvertTo_QTimer    sipType_QtCore_QTimer.td_fcto

extern sipTypeDef sipType_QtCore_QTimer;

#define sipClass_QTranslator             sipModuleAPI_QtCore.em_types[107]
#define sipCast_QTranslator              sipType_QtCore_QTranslator.td_cast
#define sipForceConvertTo_QTranslator    sipType_QtCore_QTranslator.td_fcto

extern sipTypeDef sipType_QtCore_QTranslator;

#define sipClass_QUrl             sipModuleAPI_QtCore.em_types[11]
#define sipCast_QUrl              sipType_QtCore_QUrl.td_cast
#define sipForceConvertTo_QUrl    sipType_QtCore_QUrl.td_fcto

#define sipEnum_QUrl_ParsingMode              sipModuleAPI_QtCore.em_enums[5]
#define sipEnum_QUrl_FormattingOption              sipModuleAPI_QtCore.em_enums[6]

extern sipTypeDef sipType_QtCore_QUrl;

#define sipClass_QUrl_FormattingOptions             sipModuleAPI_QtCore.em_types[12]
#define sipCast_QUrl_FormattingOptions              sipType_QtCore_QUrl_FormattingOptions.td_cast
#define sipForceConvertTo_QUrl_FormattingOptions    sipType_QtCore_QUrl_FormattingOptions.td_fcto

extern sipTypeDef sipType_QtCore_QUrl_FormattingOptions;

#define sipClass_QUuid             sipModuleAPI_QtCore.em_types[10]
#define sipCast_QUuid              sipType_QtCore_QUuid.td_cast
#define sipForceConvertTo_QUuid    sipType_QtCore_QUuid.td_fcto

#define sipEnum_QUuid_Version              sipModuleAPI_QtCore.em_enums[3]
#define sipEnum_QUuid_Variant              sipModuleAPI_QtCore.em_enums[4]

extern sipTypeDef sipType_QtCore_QUuid;

#define sipClass_QVariant             sipModuleAPI_QtCore.em_types[9]
#define sipCast_QVariant              sipType_QtCore_QVariant.td_cast
#define sipForceConvertTo_QVariant    sipType_QtCore_QVariant.td_fcto

#define sipEnum_QVariant_Type              sipModuleAPI_QtCore.em_enums[2]

extern sipTypeDef sipType_QtCore_QVariant;

#define sipClass_QWaitCondition             sipModuleAPI_QtCore.em_types[8]
#define sipCast_QWaitCondition              sipType_QtCore_QWaitCondition.td_cast
#define sipForceConvertTo_QWaitCondition    sipType_QtCore_QWaitCondition.td_fcto

extern sipTypeDef sipType_QtCore_QWaitCondition;

#define sipClass_QXmlStreamAttribute             sipModuleAPI_QtCore.em_types[7]
#define sipCast_QXmlStreamAttribute              sipType_QtCore_QXmlStreamAttribute.td_cast
#define sipForceConvertTo_QXmlStreamAttribute    sipType_QtCore_QXmlStreamAttribute.td_fcto

extern sipTypeDef sipType_QtCore_QXmlStreamAttribute;

#define sipClass_QXmlStreamAttributes             sipModuleAPI_QtCore.em_types[6]
#define sipCast_QXmlStreamAttributes              sipType_QtCore_QXmlStreamAttributes.td_cast
#define sipForceConvertTo_QXmlStreamAttributes    sipType_QtCore_QXmlStreamAttributes.td_fcto

extern sipTypeDef sipType_QtCore_QXmlStreamAttributes;

#define sipClass_QXmlStreamNamespaceDeclaration             sipModuleAPI_QtCore.em_types[5]
#define sipCast_QXmlStreamNamespaceDeclaration              sipType_QtCore_QXmlStreamNamespaceDeclaration.td_cast
#define sipForceConvertTo_QXmlStreamNamespaceDeclaration    sipType_QtCore_QXmlStreamNamespaceDeclaration.td_fcto

extern sipTypeDef sipType_QtCore_QXmlStreamNamespaceDeclaration;

#define sipClass_QXmlStreamNotationDeclaration             sipModuleAPI_QtCore.em_types[4]
#define sipCast_QXmlStreamNotationDeclaration              sipType_QtCore_QXmlStreamNotationDeclaration.td_cast
#define sipForceConvertTo_QXmlStreamNotationDeclaration    sipType_QtCore_QXmlStreamNotationDeclaration.td_fcto

extern sipTypeDef sipType_QtCore_QXmlStreamNotationDeclaration;

#define sipClass_QXmlStreamEntityDeclaration             sipModuleAPI_QtCore.em_types[3]
#define sipCast_QXmlStreamEntityDeclaration              sipType_QtCore_QXmlStreamEntityDeclaration.td_cast
#define sipForceConvertTo_QXmlStreamEntityDeclaration    sipType_QtCore_QXmlStreamEntityDeclaration.td_fcto

extern sipTypeDef sipType_QtCore_QXmlStreamEntityDeclaration;

#define sipClass_QXmlStreamEntityResolver             sipModuleAPI_QtCore.em_types[2]
#define sipCast_QXmlStreamEntityResolver              sipType_QtCore_QXmlStreamEntityResolver.td_cast
#define sipForceConvertTo_QXmlStreamEntityResolver    sipType_QtCore_QXmlStreamEntityResolver.td_fcto

extern sipTypeDef sipType_QtCore_QXmlStreamEntityResolver;

#define sipClass_QXmlStreamReader             sipModuleAPI_QtCore.em_types[1]
#define sipCast_QXmlStreamReader              sipType_QtCore_QXmlStreamReader.td_cast
#define sipForceConvertTo_QXmlStreamReader    sipType_QtCore_QXmlStreamReader.td_fcto

#define sipEnum_QXmlStreamReader_Error              sipModuleAPI_QtCore.em_enums[0]
#define sipEnum_QXmlStreamReader_TokenType              sipModuleAPI_QtCore.em_enums[1]

extern sipTypeDef sipType_QtCore_QXmlStreamReader;

#define sipClass_QXmlStreamWriter             sipModuleAPI_QtCore.em_types[0]
#define sipCast_QXmlStreamWriter              sipType_QtCore_QXmlStreamWriter.td_cast
#define sipForceConvertTo_QXmlStreamWriter    sipType_QtCore_QXmlStreamWriter.td_fcto

extern sipTypeDef sipType_QtCore_QXmlStreamWriter;

#define sipMappedType_QList_0600QPair_0100QByteArray_0100QByteArray        &sipMappedTypeDef_QList_0600QPair_0100QByteArray_0100QByteArray
#define sipForceConvertTo_QList_0600QPair_0100QByteArray_0100QByteArray    sipMappedTypeDef_QList_0600QPair_0100QByteArray_0100QByteArray.mt_fcto
#define sipConvertFrom_QList_0600QPair_0100QByteArray_0100QByteArray       sipMappedTypeDef_QList_0600QPair_0100QByteArray_0100QByteArray.mt_cfrom

extern sipMappedType sipMappedTypeDef_QList_0600QPair_0100QByteArray_0100QByteArray;

#define sipMappedType_QList_0600QPair_0100QString_0100QString        &sipMappedTypeDef_QList_0600QPair_0100QString_0100QString
#define sipForceConvertTo_QList_0600QPair_0100QString_0100QString    sipMappedTypeDef_QList_0600QPair_0100QString_0100QString.mt_fcto
#define sipConvertFrom_QList_0600QPair_0100QString_0100QString       sipMappedTypeDef_QList_0600QPair_0100QString_0100QString.mt_cfrom

extern sipMappedType sipMappedTypeDef_QList_0600QPair_0100QString_0100QString;

#define sipMappedType_QList_0200QUrl        &sipMappedTypeDef_QList_0200QUrl
#define sipForceConvertTo_QList_0200QUrl    sipMappedTypeDef_QList_0200QUrl.mt_fcto
#define sipConvertFrom_QList_0200QUrl       sipMappedTypeDef_QList_0200QUrl.mt_cfrom

extern sipMappedType sipMappedTypeDef_QList_0200QUrl;

#define sipMappedType_QMap_1800_0200QVariant        &sipMappedTypeDef_QMap_1800_0200QVariant
#define sipForceConvertTo_QMap_1800_0200QVariant    sipMappedTypeDef_QMap_1800_0200QVariant.mt_fcto
#define sipConvertFrom_QMap_1800_0200QVariant       sipMappedTypeDef_QMap_1800_0200QVariant.mt_cfrom

extern sipMappedType sipMappedTypeDef_QMap_1800_0200QVariant;

#define sipMappedType_QList_0200QByteArray        &sipMappedTypeDef_QList_0200QByteArray
#define sipForceConvertTo_QList_0200QByteArray    sipMappedTypeDef_QList_0200QByteArray.mt_fcto
#define sipConvertFrom_QList_0200QByteArray       sipMappedTypeDef_QList_0200QByteArray.mt_cfrom

extern sipMappedType sipMappedTypeDef_QList_0200QByteArray;

#define sipMappedType_QList_0200QModelIndex        &sipMappedTypeDef_QList_0200QModelIndex
#define sipForceConvertTo_QList_0200QModelIndex    sipMappedTypeDef_QList_0200QModelIndex.mt_fcto
#define sipConvertFrom_QList_0200QModelIndex       sipMappedTypeDef_QList_0200QModelIndex.mt_cfrom

extern sipMappedType sipMappedTypeDef_QList_0200QModelIndex;

#define sipMappedType_QList_0200QFileInfo        &sipMappedTypeDef_QList_0200QFileInfo
#define sipForceConvertTo_QList_0200QFileInfo    sipMappedTypeDef_QList_0200QFileInfo.mt_fcto
#define sipConvertFrom_QList_0200QFileInfo       sipMappedTypeDef_QList_0200QFileInfo.mt_cfrom

extern sipMappedType sipMappedTypeDef_QList_0200QFileInfo;

#define sipMappedType_QList_0201QObject        &sipMappedTypeDef_QList_0201QObject
#define sipForceConvertTo_QList_0201QObject    sipMappedTypeDef_QList_0201QObject.mt_fcto
#define sipConvertFrom_QList_0201QObject       sipMappedTypeDef_QList_0201QObject.mt_cfrom

extern sipMappedType sipMappedTypeDef_QList_0201QObject;

#define sipMappedType_QList_0200QVariant        &sipMappedTypeDef_QList_0200QVariant
#define sipForceConvertTo_QList_0200QVariant    sipMappedTypeDef_QList_0200QVariant.mt_fcto
#define sipConvertFrom_QList_0200QVariant       sipMappedTypeDef_QList_0200QVariant.mt_cfrom

extern sipMappedType sipMappedTypeDef_QList_0200QVariant;

#define sipMappedType_QMap_0200QString_0200QVariant        &sipMappedTypeDef_QMap_0200QString_0200QVariant
#define sipForceConvertTo_QMap_0200QString_0200QVariant    sipMappedTypeDef_QMap_0200QString_0200QVariant.mt_fcto
#define sipConvertFrom_QMap_0200QString_0200QVariant       sipMappedTypeDef_QMap_0200QString_0200QVariant.mt_cfrom

extern sipMappedType sipMappedTypeDef_QMap_0200QString_0200QVariant;

#define sipMappedType_QVector_0200QXmlStreamNamespaceDeclaration        &sipMappedTypeDef_QVector_0200QXmlStreamNamespaceDeclaration
#define sipForceConvertTo_QVector_0200QXmlStreamNamespaceDeclaration    sipMappedTypeDef_QVector_0200QXmlStreamNamespaceDeclaration.mt_fcto
#define sipConvertFrom_QVector_0200QXmlStreamNamespaceDeclaration       sipMappedTypeDef_QVector_0200QXmlStreamNamespaceDeclaration.mt_cfrom

extern sipMappedType sipMappedTypeDef_QVector_0200QXmlStreamNamespaceDeclaration;

#define sipMappedType_QVector_0200QXmlStreamNotationDeclaration        &sipMappedTypeDef_QVector_0200QXmlStreamNotationDeclaration
#define sipForceConvertTo_QVector_0200QXmlStreamNotationDeclaration    sipMappedTypeDef_QVector_0200QXmlStreamNotationDeclaration.mt_fcto
#define sipConvertFrom_QVector_0200QXmlStreamNotationDeclaration       sipMappedTypeDef_QVector_0200QXmlStreamNotationDeclaration.mt_cfrom

extern sipMappedType sipMappedTypeDef_QVector_0200QXmlStreamNotationDeclaration;

#define sipMappedType_QVector_0200QXmlStreamEntityDeclaration        &sipMappedTypeDef_QVector_0200QXmlStreamEntityDeclaration
#define sipForceConvertTo_QVector_0200QXmlStreamEntityDeclaration    sipMappedTypeDef_QVector_0200QXmlStreamEntityDeclaration.mt_fcto
#define sipConvertFrom_QVector_0200QXmlStreamEntityDeclaration       sipMappedTypeDef_QVector_0200QXmlStreamEntityDeclaration.mt_cfrom

extern sipMappedType sipMappedTypeDef_QVector_0200QXmlStreamEntityDeclaration;

#define sipMappedType_QVector_2400        &sipMappedTypeDef_QVector_2400
#define sipForceConvertTo_QVector_2400    sipMappedTypeDef_QVector_2400.mt_fcto
#define sipConvertFrom_QVector_2400       sipMappedTypeDef_QVector_2400.mt_cfrom

extern sipMappedType sipMappedTypeDef_QVector_2400;

#define sipMappedType_QVector_1900        &sipMappedTypeDef_QVector_1900
#define sipForceConvertTo_QVector_1900    sipMappedTypeDef_QVector_1900.mt_fcto
#define sipConvertFrom_QVector_1900       sipMappedTypeDef_QVector_1900.mt_cfrom

extern sipMappedType sipMappedTypeDef_QVector_1900;

#define sipMappedType_QPair_1800_1800        &sipMappedTypeDef_QPair_1800_1800
#define sipForceConvertTo_QPair_1800_1800    sipMappedTypeDef_QPair_1800_1800.mt_fcto
#define sipConvertFrom_QPair_1800_1800       sipMappedTypeDef_QPair_1800_1800.mt_cfrom

extern sipMappedType sipMappedTypeDef_QPair_1800_1800;

#define sipMappedType_QList_0500QLocale_Country        &sipMappedTypeDef_QList_0500QLocale_Country
#define sipForceConvertTo_QList_0500QLocale_Country    sipMappedTypeDef_QList_0500QLocale_Country.mt_fcto
#define sipConvertFrom_QList_0500QLocale_Country       sipMappedTypeDef_QList_0500QLocale_Country.mt_cfrom

extern sipMappedType sipMappedTypeDef_QList_0500QLocale_Country;

#define sipMappedType_QList_2400        &sipMappedTypeDef_QList_2400
#define sipForceConvertTo_QList_2400    sipMappedTypeDef_QList_2400.mt_fcto
#define sipConvertFrom_QList_2400       sipMappedTypeDef_QList_2400.mt_cfrom

extern sipMappedType sipMappedTypeDef_QList_2400;

#define sipMappedType_QList_1800        &sipMappedTypeDef_QList_1800
#define sipForceConvertTo_QList_1800    sipMappedTypeDef_QList_1800.mt_fcto
#define sipConvertFrom_QList_1800       sipMappedTypeDef_QList_1800.mt_cfrom

extern sipMappedType sipMappedTypeDef_QList_1800;

#define sipMappedType_QList_0600QPair_2400_2400        &sipMappedTypeDef_QList_0600QPair_2400_2400
#define sipForceConvertTo_QList_0600QPair_2400_2400    sipMappedTypeDef_QList_0600QPair_2400_2400.mt_fcto
#define sipConvertFrom_QList_0600QPair_2400_2400       sipMappedTypeDef_QList_0600QPair_2400_2400.mt_cfrom

extern sipMappedType sipMappedTypeDef_QList_0600QPair_2400_2400;

#define sipMappedType_QList_27000600QPair_1800_1800        &sipMappedTypeDef_QList_27000600QPair_1800_1800
#define sipForceConvertTo_QList_27000600QPair_1800_1800    sipMappedTypeDef_QList_27000600QPair_1800_1800.mt_fcto
#define sipConvertFrom_QList_27000600QPair_1800_1800       sipMappedTypeDef_QList_27000600QPair_1800_1800.mt_cfrom

extern sipMappedType sipMappedTypeDef_QList_27000600QPair_1800_1800;

/* The SIP API, this module's API and the APIs of any imported modules. */
extern const sipAPIDef *sipAPI_QtCore;
extern sipExportedModuleDef sipModuleAPI_QtCore;

typedef const QMetaObject *(*sip_qt_metaobject_func)(sipWrapper *,sipWrapperType *,const QMetaObject *);
extern sip_qt_metaobject_func sip_QtCore_qt_metaobject;

typedef int (*sip_qt_metacall_func)(sipWrapper *,sipWrapperType *,QMetaObject::Call,int,void **);
extern sip_qt_metacall_func sip_QtCore_qt_metacall;

typedef int (*sip_qt_metacast_func)(sipWrapper *,sipWrapperType *,const char *);
extern sip_qt_metacast_func sip_QtCore_qt_metacast;

#endif
