/*
 * Internal module API header file.
 *
 * Generated by SIP 4.7.9 on Mon Apr 27 14:29:47 2009
 *
 * Copyright (c) 2008 Riverbank Computing Limited <info@riverbankcomputing.com>
 * 
 * This file is part of PyQt.
 * 
 * This file may be used under the terms of the GNU General Public
 * License versions 2.0 or 3.0 as published by the Free Software
 * Foundation and appearing in the files LICENSE.GPL2 and LICENSE.GPL3
 * included in the packaging of this file.  Alternatively you may (at
 * your option) use any later version of the GNU General Public
 * License if such license has been publicly approved by Riverbank
 * Computing Limited (or its successors, if any) and the KDE Free Qt
 * Foundation. In addition, as a special exception, Riverbank gives you
 * certain additional rights. These rights are described in the Riverbank
 * GPL Exception version 1.1, which can be found in the file
 * GPL_EXCEPTION.txt in this package.
 * 
 * Please review the following information to ensure GNU General
 * Public Licensing requirements will be met:
 * http://trolltech.com/products/qt/licenses/licensing/opensource/. If
 * you are unsure which license is appropriate for your use, please
 * review the following information:
 * http://trolltech.com/products/qt/licenses/licensing/licensingoverview
 * or contact the sales department at sales@riverbankcomputing.com.
 * 
 * This file is provided "AS IS" with NO WARRANTY OF ANY KIND,
 * INCLUDING THE WARRANTIES OF DESIGN, MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE. Trolltech reserves all rights not expressly
 * granted herein.
 * 
 * This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
 * WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

#ifndef _QtGuiAPI_H
#define _QtGuiAPI_H


#include <sip.h>

#include <QMetaType>

/* These are the features that are enabled. */
#define SIP_FEATURE_PyQt_qreal_double
#define SIP_FEATURE_PyQt_SizeGrip
#define SIP_FEATURE_PyQt_OpenSSL
#define SIP_FEATURE_Py_DateTime
#define SIP_FEATURE_PyQt_NoQtPrintRangeBug
#define SIP_FEATURE_PyQt_WhatsThis
#define SIP_FEATURE_PyQt_ToolTip
#define SIP_FEATURE_PyQt_StatusTip
#define SIP_FEATURE_PyQt_SessionManager
#define SIP_FEATURE_PyQt_Accessibility

#line 734 "sip/QtGui/qapplication.sip"
// Used to track QObject instances that must be explicitly destroyed before the
// QApplication instance is destroyed.  Typically these are instances that
// sometimes don't have a parent (and are not QWidgets).  (QGraphicsScene seems
// to be the most common, possibly only, example.)
void qtgui_track(QObject *o);
void qtgui_delete_tracked();
#line 188 "sip/QtGui/qfontmetrics.sip"
// Used by QFontMetrics and QFontMetricsF.
int *qtgui_tabarray(PyObject *l);
#line 243 "sip/QtGui/qimage.sip"
const char **QtGui_ListToArray(PyObject *lst);
#line 72 "sipAPIQtGui.h"

/*
 * Convenient names to refer to the names of classes defined in this module.
 * These are part of the public API.
 */
#define sipName_QX11Info  sipNm_QtGui_QX11Info
#define sipName_Display  sipNm_QtGui_Display
#define sipName_QX11EmbedContainer  sipNm_QtGui_QX11EmbedContainer
#define sipName_QX11EmbedWidget  sipNm_QtGui_QX11EmbedWidget
#define sipName_QWorkspace  sipNm_QtGui_QWorkspace
#define sipName_QWizardPage  sipNm_QtGui_QWizardPage
#define sipName_WizardOptions  sipNm_QtGui_WizardOptions
#define sipName_QWizard  sipNm_QtGui_QWizard
#define sipName_QWidgetAction  sipNm_QtGui_QWidgetAction
#define sipName_QWhatsThis  sipNm_QtGui_QWhatsThis
#define sipName_QRegExpValidator  sipNm_QtGui_QRegExpValidator
#define sipName_QDoubleValidator  sipNm_QtGui_QDoubleValidator
#define sipName_QIntValidator  sipNm_QtGui_QIntValidator
#define sipName_QValidator  sipNm_QtGui_QValidator
#define sipName_QUndoView  sipNm_QtGui_QUndoView
#define sipName_QUndoStack  sipNm_QtGui_QUndoStack
#define sipName_QUndoCommand  sipNm_QtGui_QUndoCommand
#define sipName_QUndoGroup  sipNm_QtGui_QUndoGroup
#define sipName_QTreeWidgetItemIterator  sipNm_QtGui_QTreeWidgetItemIterator
#define sipName_QTreeWidget  sipNm_QtGui_QTreeWidget
#define sipName_QTreeWidgetItem  sipNm_QtGui_QTreeWidgetItem
#define sipName_QTreeView  sipNm_QtGui_QTreeView
#define sipName_QToolTip  sipNm_QtGui_QToolTip
#define sipName_QToolButton  sipNm_QtGui_QToolButton
#define sipName_QToolBox  sipNm_QtGui_QToolBox
#define sipName_QToolBar  sipNm_QtGui_QToolBar
#define sipName_QTextTable  sipNm_QtGui_QTextTable
#define sipName_QTextTableCell  sipNm_QtGui_QTextTableCell
#define sipName_Tab  sipNm_QtGui_Tab
#define sipName_Flags  sipNm_QtGui_Flags
#define sipName_QTextOption  sipNm_QtGui_QTextOption
#define sipName_QTextBlockUserData  sipNm_QtGui_QTextBlockUserData
#define sipName_QTextFragment  sipNm_QtGui_QTextFragment
#define sipName_QTextBlock  sipNm_QtGui_QTextBlock
#define sipName_iterator  sipNm_QtGui_iterator
#define sipName_QTextFrame  sipNm_QtGui_QTextFrame
#define sipName_QTextObject  sipNm_QtGui_QTextObject
#define sipName_QTextBlockGroup  sipNm_QtGui_QTextBlockGroup
#define sipName_QTextList  sipNm_QtGui_QTextList
#define sipName_QTextLine  sipNm_QtGui_QTextLine
#define sipName_FormatRange  sipNm_QtGui_FormatRange
#define sipName_QTextLayout  sipNm_QtGui_QTextLayout
#define sipName_QTextInlineObject  sipNm_QtGui_QTextInlineObject
#define sipName_QTextTableCellFormat  sipNm_QtGui_QTextTableCellFormat
#define sipName_QTextTableFormat  sipNm_QtGui_QTextTableFormat
#define sipName_QTextFrameFormat  sipNm_QtGui_QTextFrameFormat
#define sipName_QTextImageFormat  sipNm_QtGui_QTextImageFormat
#define sipName_QTextListFormat  sipNm_QtGui_QTextListFormat
#define sipName_QTextBlockFormat  sipNm_QtGui_QTextBlockFormat
#define sipName_QTextCharFormat  sipNm_QtGui_QTextCharFormat
#define sipName_PageBreakFlags  sipNm_QtGui_PageBreakFlags
#define sipName_AutoFormatting  sipNm_QtGui_AutoFormatting
#define sipName_ExtraSelection  sipNm_QtGui_ExtraSelection
#define sipName_QTextDocumentFragment  sipNm_QtGui_QTextDocumentFragment
#define sipName_FindFlags  sipNm_QtGui_FindFlags
#define sipName_QTextDocument  sipNm_QtGui_QTextDocument
#define sipName_QTextCursor  sipNm_QtGui_QTextCursor
#define sipName_QTextEdit  sipNm_QtGui_QTextEdit
#define sipName_QTextBrowser  sipNm_QtGui_QTextBrowser
#define sipName_QTabWidget  sipNm_QtGui_QTabWidget
#define sipName_QTableWidget  sipNm_QtGui_QTableWidget
#define sipName_QTableWidgetItem  sipNm_QtGui_QTableWidgetItem
#define sipName_QTableWidgetSelectionRange  sipNm_QtGui_QTableWidgetSelectionRange
#define sipName_QTableView  sipNm_QtGui_QTableView
#define sipName_QTabBar  sipNm_QtGui_QTabBar
#define sipName_QSystemTrayIcon  sipNm_QtGui_QSystemTrayIcon
#define sipName_QSyntaxHighlighter  sipNm_QtGui_QSyntaxHighlighter
#define sipName_QStylePainter  sipNm_QtGui_QStylePainter
#define sipName_QStyleOptionViewItemV4  sipNm_QtGui_QStyleOptionViewItemV4
#define sipName_QStyleHintReturnVariant  sipNm_QtGui_QStyleHintReturnVariant
#define sipName_QStyleOptionToolBoxV2  sipNm_QtGui_QStyleOptionToolBoxV2
#define sipName_QStyleOptionViewItemV3  sipNm_QtGui_QStyleOptionViewItemV3
#define sipName_QStyleOptionDockWidgetV2  sipNm_QtGui_QStyleOptionDockWidgetV2
#define sipName_QStyleOptionGraphicsItem  sipNm_QtGui_QStyleOptionGraphicsItem
#define sipName_QStyleOptionSizeGrip  sipNm_QtGui_QStyleOptionSizeGrip
#define sipName_ViewItemFeatures  sipNm_QtGui_ViewItemFeatures
#define sipName_QStyleOptionViewItemV2  sipNm_QtGui_QStyleOptionViewItemV2
#define sipName_QStyleOptionGroupBox  sipNm_QtGui_QStyleOptionGroupBox
#define sipName_ToolBarFeatures  sipNm_QtGui_ToolBarFeatures
#define sipName_QStyleOptionToolBar  sipNm_QtGui_QStyleOptionToolBar
#define sipName_QStyleHintReturnMask  sipNm_QtGui_QStyleHintReturnMask
#define sipName_QStyleHintReturn  sipNm_QtGui_QStyleHintReturn
#define sipName_QStyleOptionTitleBar  sipNm_QtGui_QStyleOptionTitleBar
#define sipName_QStyleOptionComboBox  sipNm_QtGui_QStyleOptionComboBox
#define sipName_ToolButtonFeatures  sipNm_QtGui_ToolButtonFeatures
#define sipName_QStyleOptionToolButton  sipNm_QtGui_QStyleOptionToolButton
#define sipName_QStyleOptionSpinBox  sipNm_QtGui_QStyleOptionSpinBox
#define sipName_QStyleOptionSlider  sipNm_QtGui_QStyleOptionSlider
#define sipName_QStyleOptionComplex  sipNm_QtGui_QStyleOptionComplex
#define sipName_QStyleOptionRubberBand  sipNm_QtGui_QStyleOptionRubberBand
#define sipName_QStyleOptionToolBox  sipNm_QtGui_QStyleOptionToolBox
#define sipName_QStyleOptionViewItem  sipNm_QtGui_QStyleOptionViewItem
#define sipName_QStyleOptionDockWidget  sipNm_QtGui_QStyleOptionDockWidget
#define sipName_QStyleOptionMenuItem  sipNm_QtGui_QStyleOptionMenuItem
#define sipName_QStyleOptionProgressBarV2  sipNm_QtGui_QStyleOptionProgressBarV2
#define sipName_QStyleOptionProgressBar  sipNm_QtGui_QStyleOptionProgressBar
#define sipName_QStyleOptionTabV2  sipNm_QtGui_QStyleOptionTabV2
#define sipName_CornerWidgets  sipNm_QtGui_CornerWidgets
#define sipName_QStyleOptionTab  sipNm_QtGui_QStyleOptionTab
#define sipName_ButtonFeatures  sipNm_QtGui_ButtonFeatures
#define sipName_QStyleOptionButton  sipNm_QtGui_QStyleOptionButton
#define sipName_QStyleOptionHeader  sipNm_QtGui_QStyleOptionHeader
#define sipName_QStyleOptionTabBarBase  sipNm_QtGui_QStyleOptionTabBarBase
#define sipName_QStyleOptionTabWidgetFrame  sipNm_QtGui_QStyleOptionTabWidgetFrame
#define sipName_FrameFeatures  sipNm_QtGui_FrameFeatures
#define sipName_QStyleOptionFrameV2  sipNm_QtGui_QStyleOptionFrameV2
#define sipName_QStyleOptionFrame  sipNm_QtGui_QStyleOptionFrame
#define sipName_QStyleOptionFocusRect  sipNm_QtGui_QStyleOptionFocusRect
#define sipName_QStyleOption  sipNm_QtGui_QStyleOption
#define sipName_QStyleFactory  sipNm_QtGui_QStyleFactory
#define sipName_QStyledItemDelegate  sipNm_QtGui_QStyledItemDelegate
#define sipName_SubControls  sipNm_QtGui_SubControls
#define sipName_QStyle  sipNm_QtGui_QStyle
#define sipName_QStringListModel  sipNm_QtGui_QStringListModel
#define sipName_QStatusBar  sipNm_QtGui_QStatusBar
#define sipName_QStandardItem  sipNm_QtGui_QStandardItem
#define sipName_QStandardItemModel  sipNm_QtGui_QStandardItemModel
#define sipName_QStackedWidget  sipNm_QtGui_QStackedWidget
#define sipName_QStackedLayout  sipNm_QtGui_QStackedLayout
#define sipName_QSplitterHandle  sipNm_QtGui_QSplitterHandle
#define sipName_QSplitter  sipNm_QtGui_QSplitter
#define sipName_QSplashScreen  sipNm_QtGui_QSplashScreen
#define sipName_QDoubleSpinBox  sipNm_QtGui_QDoubleSpinBox
#define sipName_QSpinBox  sipNm_QtGui_QSpinBox
#define sipName_QSound  sipNm_QtGui_QSound
#define sipName_QSortFilterProxyModel  sipNm_QtGui_QSortFilterProxyModel
#define sipName_QSlider  sipNm_QtGui_QSlider
#define sipName_ControlTypes  sipNm_QtGui_ControlTypes
#define sipName_QSizeGrip  sipNm_QtGui_QSizeGrip
#define sipName_QShortcut  sipNm_QtGui_QShortcut
#define sipName_QSessionManager  sipNm_QtGui_QSessionManager
#define sipName_QScrollBar  sipNm_QtGui_QScrollBar
#define sipName_QScrollArea  sipNm_QtGui_QScrollArea
#define sipName_QRubberBand  sipNm_QtGui_QRubberBand
#define sipName_QRadioButton  sipNm_QtGui_QRadioButton
#define sipName_QProxyModel  sipNm_QtGui_QProxyModel
#define sipName_QProgressDialog  sipNm_QtGui_QProgressDialog
#define sipName_QProgressBar  sipNm_QtGui_QProgressBar
#define sipName_QPrintPreviewWidget  sipNm_QtGui_QPrintPreviewWidget
#define sipName_QPrintPreviewDialog  sipNm_QtGui_QPrintPreviewDialog
#define sipName_QPrinterInfo  sipNm_QtGui_QPrinterInfo
#define sipName_QPrintEngine  sipNm_QtGui_QPrintEngine
#define sipName_QPrintDialog  sipNm_QtGui_QPrintDialog
#define sipName_QPrinter  sipNm_QtGui_QPrinter
#define sipName_QPolygonF  sipNm_QtGui_QPolygonF
#define sipName_QPlainTextDocumentLayout  sipNm_QtGui_QPlainTextDocumentLayout
#define sipName_QPlainTextEdit  sipNm_QtGui_QPlainTextEdit
#define sipName_QPixmapCache  sipNm_QtGui_QPixmapCache
#define sipName_QPictureIO  sipNm_QtGui_QPictureIO
#define sipName_QPicture  sipNm_QtGui_QPicture
#define sipName_QPainterPathStroker  sipNm_QtGui_QPainterPathStroker
#define sipName_Element  sipNm_QtGui_Element
#define sipName_QPainterPath  sipNm_QtGui_QPainterPath
#define sipName_QPaintEngineState  sipNm_QtGui_QPaintEngineState
#define sipName_DirtyFlags  sipNm_QtGui_DirtyFlags
#define sipName_PaintEngineFeatures  sipNm_QtGui_PaintEngineFeatures
#define sipName_QPaintEngine  sipNm_QtGui_QPaintEngine
#define sipName_RenderFlags  sipNm_QtGui_RenderFlags
#define sipName_QTextItem  sipNm_QtGui_QTextItem
#define sipName_RenderHints  sipNm_QtGui_RenderHints
#define sipName_QPainter  sipNm_QtGui_QPainter
#define sipName_PageSetupDialogOptions  sipNm_QtGui_PageSetupDialogOptions
#define sipName_QPageSetupDialog  sipNm_QtGui_QPageSetupDialog
#define sipName_QMovie  sipNm_QtGui_QMovie
#define sipName_QMessageBox  sipNm_QtGui_QMessageBox
#define sipName_QMenuBar  sipNm_QtGui_QMenuBar
#define sipName_QMenu  sipNm_QtGui_QMenu
#define sipName_SubWindowOptions  sipNm_QtGui_SubWindowOptions
#define sipName_QMdiSubWindow  sipNm_QtGui_QMdiSubWindow
#define sipName_AreaOptions  sipNm_QtGui_AreaOptions
#define sipName_QMdiArea  sipNm_QtGui_QMdiArea
#define sipName_DockOptions  sipNm_QtGui_DockOptions
#define sipName_QMainWindow  sipNm_QtGui_QMainWindow
#define sipName_QListWidget  sipNm_QtGui_QListWidget
#define sipName_QListWidgetItem  sipNm_QtGui_QListWidgetItem
#define sipName_QListView  sipNm_QtGui_QListView
#define sipName_QLineEdit  sipNm_QtGui_QLineEdit
#define sipName_QLCDNumber  sipNm_QtGui_QLCDNumber
#define sipName_QWidgetItem  sipNm_QtGui_QWidgetItem
#define sipName_QSpacerItem  sipNm_QtGui_QSpacerItem
#define sipName_QLayoutItem  sipNm_QtGui_QLayoutItem
#define sipName_QLabel  sipNm_QtGui_QLabel
#define sipName_QItemDelegate  sipNm_QtGui_QItemDelegate
#define sipName_QInputDialog  sipNm_QtGui_QInputDialog
#define sipName_QInputContext  sipNm_QtGui_QInputContext
#define sipName_QImageWriter  sipNm_QtGui_QImageWriter
#define sipName_QImageReader  sipNm_QtGui_QImageReader
#define sipName_QImageIOHandler  sipNm_QtGui_QImageIOHandler
#define sipName_QPaintDevice  sipNm_QtGui_QPaintDevice
#define sipName_QItemSelection  sipNm_QtGui_QItemSelection
#define sipName_SelectionFlags  sipNm_QtGui_SelectionFlags
#define sipName_QItemSelectionModel  sipNm_QtGui_QItemSelectionModel
#define sipName_QItemSelectionRange  sipNm_QtGui_QItemSelectionRange
#define sipName_QItemEditorFactory  sipNm_QtGui_QItemEditorFactory
#define sipName_QItemEditorCreatorBase  sipNm_QtGui_QItemEditorCreatorBase
#define sipName_QIconEngineV2  sipNm_QtGui_QIconEngineV2
#define sipName_QIconEngine  sipNm_QtGui_QIconEngine
#define sipName_QHeaderView  sipNm_QtGui_QHeaderView
#define sipName_QGroupBox  sipNm_QtGui_QGroupBox
#define sipName_QGridLayout  sipNm_QtGui_QGridLayout
#define sipName_OptimizationFlags  sipNm_QtGui_OptimizationFlags
#define sipName_QGraphicsView  sipNm_QtGui_QGraphicsView
#define sipName_QGraphicsSceneMoveEvent  sipNm_QtGui_QGraphicsSceneMoveEvent
#define sipName_QGraphicsSceneResizeEvent  sipNm_QtGui_QGraphicsSceneResizeEvent
#define sipName_QGraphicsSceneDragDropEvent  sipNm_QtGui_QGraphicsSceneDragDropEvent
#define sipName_QGraphicsSceneHelpEvent  sipNm_QtGui_QGraphicsSceneHelpEvent
#define sipName_QGraphicsSceneHoverEvent  sipNm_QtGui_QGraphicsSceneHoverEvent
#define sipName_QGraphicsSceneContextMenuEvent  sipNm_QtGui_QGraphicsSceneContextMenuEvent
#define sipName_QGraphicsSceneWheelEvent  sipNm_QtGui_QGraphicsSceneWheelEvent
#define sipName_QGraphicsSceneMouseEvent  sipNm_QtGui_QGraphicsSceneMouseEvent
#define sipName_QGraphicsSceneEvent  sipNm_QtGui_QGraphicsSceneEvent
#define sipName_SceneLayers  sipNm_QtGui_SceneLayers
#define sipName_QGraphicsScene  sipNm_QtGui_QGraphicsScene
#define sipName_QGraphicsWidget  sipNm_QtGui_QGraphicsWidget
#define sipName_QGraphicsProxyWidget  sipNm_QtGui_QGraphicsProxyWidget
#define sipName_QGraphicsLinearLayout  sipNm_QtGui_QGraphicsLinearLayout
#define sipName_QGraphicsLayoutItem  sipNm_QtGui_QGraphicsLayoutItem
#define sipName_QGraphicsItemAnimation  sipNm_QtGui_QGraphicsItemAnimation
#define sipName_QGraphicsItemGroup  sipNm_QtGui_QGraphicsItemGroup
#define sipName_QGraphicsSimpleTextItem  sipNm_QtGui_QGraphicsSimpleTextItem
#define sipName_QGraphicsTextItem  sipNm_QtGui_QGraphicsTextItem
#define sipName_QGraphicsPixmapItem  sipNm_QtGui_QGraphicsPixmapItem
#define sipName_QGraphicsLineItem  sipNm_QtGui_QGraphicsLineItem
#define sipName_QGraphicsPolygonItem  sipNm_QtGui_QGraphicsPolygonItem
#define sipName_QGraphicsEllipseItem  sipNm_QtGui_QGraphicsEllipseItem
#define sipName_QGraphicsRectItem  sipNm_QtGui_QGraphicsRectItem
#define sipName_QGraphicsPathItem  sipNm_QtGui_QGraphicsPathItem
#define sipName_QAbstractGraphicsShapeItem  sipNm_QtGui_QAbstractGraphicsShapeItem
#define sipName_GraphicsItemFlags  sipNm_QtGui_GraphicsItemFlags
#define sipName_CacheMode  sipNm_QtGui_CacheMode
#define sipName_QGraphicsItem  sipNm_QtGui_QGraphicsItem
#define sipName_QGraphicsLayout  sipNm_QtGui_QGraphicsLayout
#define sipName_QGraphicsGridLayout  sipNm_QtGui_QGraphicsGridLayout
#define sipName_QFormLayout  sipNm_QtGui_QFormLayout
#define sipName_QFontMetricsF  sipNm_QtGui_QFontMetricsF
#define sipName_QFontMetrics  sipNm_QtGui_QFontMetrics
#define sipName_QFontInfo  sipNm_QtGui_QFontInfo
#define sipName_QFontDialog  sipNm_QtGui_QFontDialog
#define sipName_QFontDatabase  sipNm_QtGui_QFontDatabase
#define sipName_FontFilters  sipNm_QtGui_FontFilters
#define sipName_QFontComboBox  sipNm_QtGui_QFontComboBox
#define sipName_QFocusFrame  sipNm_QtGui_QFocusFrame
#define sipName_QFileSystemModel  sipNm_QtGui_QFileSystemModel
#define sipName_QFileIconProvider  sipNm_QtGui_QFileIconProvider
#define sipName_Options  sipNm_QtGui_Options
#define sipName_QFileDialog  sipNm_QtGui_QFileDialog
#define sipName_QWindowStateChangeEvent  sipNm_QtGui_QWindowStateChangeEvent
#define sipName_QShortcutEvent  sipNm_QtGui_QShortcutEvent
#define sipName_QFileOpenEvent  sipNm_QtGui_QFileOpenEvent
#define sipName_QActionEvent  sipNm_QtGui_QActionEvent
#define sipName_QWhatsThisClickedEvent  sipNm_QtGui_QWhatsThisClickedEvent
#define sipName_QStatusTipEvent  sipNm_QtGui_QStatusTipEvent
#define sipName_QHelpEvent  sipNm_QtGui_QHelpEvent
#define sipName_QDragLeaveEvent  sipNm_QtGui_QDragLeaveEvent
#define sipName_QDragEnterEvent  sipNm_QtGui_QDragEnterEvent
#define sipName_QDragMoveEvent  sipNm_QtGui_QDragMoveEvent
#define sipName_QMimeSource  sipNm_QtGui_QMimeSource
#define sipName_QDropEvent  sipNm_QtGui_QDropEvent
#define sipName_Attribute  sipNm_QtGui_Attribute
#define sipName_QInputMethodEvent  sipNm_QtGui_QInputMethodEvent
#define sipName_QContextMenuEvent  sipNm_QtGui_QContextMenuEvent
#define sipName_QHideEvent  sipNm_QtGui_QHideEvent
#define sipName_QShowEvent  sipNm_QtGui_QShowEvent
#define sipName_QIconDragEvent  sipNm_QtGui_QIconDragEvent
#define sipName_QCloseEvent  sipNm_QtGui_QCloseEvent
#define sipName_QResizeEvent  sipNm_QtGui_QResizeEvent
#define sipName_QMoveEvent  sipNm_QtGui_QMoveEvent
#define sipName_QPaintEvent  sipNm_QtGui_QPaintEvent
#define sipName_QFocusEvent  sipNm_QtGui_QFocusEvent
#define sipName_QKeyEvent  sipNm_QtGui_QKeyEvent
#define sipName_QTabletEvent  sipNm_QtGui_QTabletEvent
#define sipName_QWheelEvent  sipNm_QtGui_QWheelEvent
#define sipName_QHoverEvent  sipNm_QtGui_QHoverEvent
#define sipName_QMouseEvent  sipNm_QtGui_QMouseEvent
#define sipName_QInputEvent  sipNm_QtGui_QInputEvent
#define sipName_QErrorMessage  sipNm_QtGui_QErrorMessage
#define sipName_QDrag  sipNm_QtGui_QDrag
#define sipName_DockWidgetFeatures  sipNm_QtGui_DockWidgetFeatures
#define sipName_QDockWidget  sipNm_QtGui_QDockWidget
#define sipName_QDirModel  sipNm_QtGui_QDirModel
#define sipName_StandardButtons  sipNm_QtGui_StandardButtons
#define sipName_QDialogButtonBox  sipNm_QtGui_QDialogButtonBox
#define sipName_QDial  sipNm_QtGui_QDial
#define sipName_QDesktopWidget  sipNm_QtGui_QDesktopWidget
#define sipName_QDesktopServices  sipNm_QtGui_QDesktopServices
#define sipName_QDateEdit  sipNm_QtGui_QDateEdit
#define sipName_QTimeEdit  sipNm_QtGui_QTimeEdit
#define sipName_Sections  sipNm_QtGui_Sections
#define sipName_QDateTimeEdit  sipNm_QtGui_QDateTimeEdit
#define sipName_QDataWidgetMapper  sipNm_QtGui_QDataWidgetMapper
#define sipName_QCompleter  sipNm_QtGui_QCompleter
#define sipName_QComboBox  sipNm_QtGui_QComboBox
#define sipName_QColorDialog  sipNm_QtGui_QColorDialog
#define sipName_QColumnView  sipNm_QtGui_QColumnView
#define sipName_QClipboard  sipNm_QtGui_QClipboard
#define sipName_QCheckBox  sipNm_QtGui_QCheckBox
#define sipName_QCalendarWidget  sipNm_QtGui_QCalendarWidget
#define sipName_QButtonGroup  sipNm_QtGui_QButtonGroup
#define sipName_QConicalGradient  sipNm_QtGui_QConicalGradient
#define sipName_QRadialGradient  sipNm_QtGui_QRadialGradient
#define sipName_QLinearGradient  sipNm_QtGui_QLinearGradient
#define sipName_QGradient  sipNm_QtGui_QGradient
#define sipName_QPushButton  sipNm_QtGui_QPushButton
#define sipName_QCommandLinkButton  sipNm_QtGui_QCommandLinkButton
#define sipName_QVBoxLayout  sipNm_QtGui_QVBoxLayout
#define sipName_QHBoxLayout  sipNm_QtGui_QHBoxLayout
#define sipName_QLayout  sipNm_QtGui_QLayout
#define sipName_QBoxLayout  sipNm_QtGui_QBoxLayout
#define sipName_QApplication  sipNm_QtGui_QApplication
#define sipName_QActionGroup  sipNm_QtGui_QActionGroup
#define sipName_QAction  sipNm_QtGui_QAction
#define sipName_QAbstractSlider  sipNm_QtGui_QAbstractSlider
#define sipName_PaintContext  sipNm_QtGui_PaintContext
#define sipName_QAbstractTextDocumentLayout  sipNm_QtGui_QAbstractTextDocumentLayout
#define sipName_StepEnabled  sipNm_QtGui_StepEnabled
#define sipName_QAbstractSpinBox  sipNm_QtGui_QAbstractSpinBox
#define sipName_QFrame  sipNm_QtGui_QFrame
#define sipName_QAbstractProxyModel  sipNm_QtGui_QAbstractProxyModel
#define sipName_PrintDialogOptions  sipNm_QtGui_PrintDialogOptions
#define sipName_Selection  sipNm_QtGui_Selection
#define sipName_QDialog  sipNm_QtGui_QDialog
#define sipName_QAbstractPrintDialog  sipNm_QtGui_QAbstractPrintDialog
#define sipName_EditTriggers  sipNm_QtGui_EditTriggers
#define sipName_QAbstractScrollArea  sipNm_QtGui_QAbstractScrollArea
#define sipName_QAbstractItemView  sipNm_QtGui_QAbstractItemView
#define sipName_QAbstractItemDelegate  sipNm_QtGui_QAbstractItemDelegate
#define sipName_QAbstractButton  sipNm_QtGui_QAbstractButton
#define sipName_State  sipNm_QtGui_State
#define sipName_QWidget  sipNm_QtGui_QWidget
#define sipName_QTransform  sipNm_QtGui_QTransform
#define sipName_QMatrix  sipNm_QtGui_QMatrix
#define sipName_QTextFormat  sipNm_QtGui_QTextFormat
#define sipName_QTextLength  sipNm_QtGui_QTextLength
#define sipName_QPen  sipNm_QtGui_QPen
#define sipName_QKeySequence  sipNm_QtGui_QKeySequence
#define sipName_QSizePolicy  sipNm_QtGui_QSizePolicy
#define sipName_QCursor  sipNm_QtGui_QCursor
#define sipName_QBitmap  sipNm_QtGui_QBitmap
#define sipName_QRegion  sipNm_QtGui_QRegion
#define sipName_QPolygon  sipNm_QtGui_QPolygon
#define sipName_QImage  sipNm_QtGui_QImage
#define sipName_QIcon  sipNm_QtGui_QIcon
#define sipName_QPalette  sipNm_QtGui_QPalette
#define sipName_QColor  sipNm_QtGui_QColor
#define sipName_QBrush  sipNm_QtGui_QBrush
#define sipName_QPixmap  sipNm_QtGui_QPixmap
#define sipName_QFont  sipNm_QtGui_QFont
#define sipName_IteratorFlags  sipNm_QtGui_IteratorFlags

/* Convenient names to call the SIP API. */
#define sipConvertFromSliceObject(o,len,start,stop,step,slen)   PySlice_GetIndicesEx((PySliceObject *)(o),(len),(start),(stop),(step),(slen))
#define sipIsSubClassInstance(o,wt) PyObject_TypeCheck((o),(PyTypeObject *)(wt))

#define sipMapStringToClass         sipAPI_QtGui->api_map_string_to_class
#define sipMapIntToClass            sipAPI_QtGui->api_map_int_to_class
#define sipMalloc                   sipAPI_QtGui->api_malloc
#define sipFree                     sipAPI_QtGui->api_free
#define sipBuildResult              sipAPI_QtGui->api_build_result
#define sipCallMethod               sipAPI_QtGui->api_call_method
#define sipParseResult              sipAPI_QtGui->api_parse_result
#define sipParseArgs                sipAPI_QtGui->api_parse_args
#define sipParsePair                sipAPI_QtGui->api_parse_pair
#define sipCommonCtor               sipAPI_QtGui->api_common_ctor
#define sipCommonDtor               sipAPI_QtGui->api_common_dtor
#define sipConvertFromSequenceIndex sipAPI_QtGui->api_convert_from_sequence_index
#define sipConvertFromVoidPtr       sipAPI_QtGui->api_convert_from_void_ptr
#define sipConvertToCpp             sipAPI_QtGui->api_convert_to_cpp
#define sipConvertToVoidPtr         sipAPI_QtGui->api_convert_to_void_ptr
#define sipNoFunction               sipAPI_QtGui->api_no_function
#define sipNoMethod                 sipAPI_QtGui->api_no_method
#define sipAbstractMethod           sipAPI_QtGui->api_abstract_method
#define sipBadClass                 sipAPI_QtGui->api_bad_class
#define sipBadSetType               sipAPI_QtGui->api_bad_set_type
#define sipBadCatcherResult         sipAPI_QtGui->api_bad_catcher_result
#define sipBadOperatorArg           sipAPI_QtGui->api_bad_operator_arg
#define sipTrace                    sipAPI_QtGui->api_trace
#define sipTransfer                 sipAPI_QtGui->api_transfer
#define sipTransferBack             sipAPI_QtGui->api_transfer_back
#define sipTransferTo               sipAPI_QtGui->api_transfer_to
#define sipTransferBreak            sipAPI_QtGui->api_transfer_break
#define sipWrapper_Check            sipAPI_QtGui->api_wrapper_check
#define sipGetWrapper               sipAPI_QtGui->api_get_wrapper
#define sipGetCppPtr                sipAPI_QtGui->api_get_cpp_ptr
#define sipGetComplexCppPtr         sipAPI_QtGui->api_get_complex_cpp_ptr
#define sipIsPyMethod               sipAPI_QtGui->api_is_py_method
#define sipCallHook                 sipAPI_QtGui->api_call_hook
#define sipStartThread              sipAPI_QtGui->api_start_thread
#define sipEndThread                sipAPI_QtGui->api_end_thread
#define sipEmitSignal               sipAPI_QtGui->api_emit_signal
#define sipConnectRx                sipAPI_QtGui->api_connect_rx
#define sipDisconnectRx             sipAPI_QtGui->api_disconnect_rx
#define sipGetSender                sipAPI_QtGui->api_get_sender
#define sipRaiseUnknownException    sipAPI_QtGui->api_raise_unknown_exception
#define sipRaiseClassException      sipAPI_QtGui->api_raise_class_exception
#define sipRaiseSubClassException   sipAPI_QtGui->api_raise_sub_class_exception
#define sipBadLengthForSlice        sipAPI_QtGui->api_bad_length_for_slice
#define sipClassName                sipAPI_QtGui->api_class_name
#define sipAddClassInstance         sipAPI_QtGui->api_add_class_instance
#define sipAddMappedTypeInstance    sipAPI_QtGui->api_add_mapped_type_instance
#define sipAddEnumInstance          sipAPI_QtGui->api_add_enum_instance
#define sipConvertFromNamedEnum     sipAPI_QtGui->api_convert_from_named_enum
#define sipGetAddress               sipAPI_QtGui->api_get_address
#define sipFreeConnection           sipAPI_QtGui->api_free_connection
#define sipEmitToSlot               sipAPI_QtGui->api_emit_to_slot
#define sipSameConnection           sipAPI_QtGui->api_same_connection
#define sipPySlotExtend             sipAPI_QtGui->api_pyslot_extend
#define sipConvertRx                sipAPI_QtGui->api_convert_rx
#define sipAddDelayedDtor           sipAPI_QtGui->api_add_delayed_dtor
#define sipCanConvertToInstance     sipAPI_QtGui->api_can_convert_to_instance
#define sipCanConvertToMappedType   sipAPI_QtGui->api_can_convert_to_mapped_type
#define sipConvertToInstance        sipAPI_QtGui->api_convert_to_instance
#define sipConvertToMappedType      sipAPI_QtGui->api_convert_to_mapped_type
#define sipForceConvertToInstance   sipAPI_QtGui->api_force_convert_to_instance
#define sipForceConvertToMappedType sipAPI_QtGui->api_force_convert_to_mapped_type
#define sipReleaseInstance          sipAPI_QtGui->api_release_instance
#define sipReleaseMappedType        sipAPI_QtGui->api_release_mapped_type
#define sipConvertFromInstance      sipAPI_QtGui->api_convert_from_instance
#define sipConvertFromNewInstance   sipAPI_QtGui->api_convert_from_new_instance
#define sipConvertFromMappedType    sipAPI_QtGui->api_convert_from_mapped_type
#define sipGetState                 sipAPI_QtGui->api_get_state
#define sipFindMappedType           sipAPI_QtGui->api_find_mapped_type
#define sipLong_AsUnsignedLong      sipAPI_QtGui->api_long_as_unsigned_long
#define sipExportSymbol             sipAPI_QtGui->api_export_symbol
#define sipImportSymbol             sipAPI_QtGui->api_import_symbol
#define sipRegisterIntTypes         sipAPI_QtGui->api_register_int_types
#define sipParseSignature           sipAPI_QtGui->api_parse_signature
#define sipFindClass                sipAPI_QtGui->api_find_class
#define sipFindNamedEnum            sipAPI_QtGui->api_find_named_enum
#define sipString_AsChar            sipAPI_QtGui->api_string_as_char
#define sipUnicode_AsWChar          sipAPI_QtGui->api_unicode_as_wchar
#define sipUnicode_AsWString        sipAPI_QtGui->api_unicode_as_wstring
#define sipConvertFromConstVoidPtr  sipAPI_QtGui->api_convert_from_const_void_ptr
#define sipConvertFromVoidPtrAndSize    sipAPI_QtGui->api_convert_from_void_ptr_and_size
#define sipConvertFromConstVoidPtrAndSize   sipAPI_QtGui->api_convert_from_const_void_ptr_and_size
#define sipInvokeSlot               sipAPI_QtGui->api_invoke_slot
#define sipParseType                sipAPI_QtGui->api_parse_type
#define sipIsExactWrappedType       sipAPI_QtGui->api_is_exact_wrapped_type
#define sipAssignInstance           sipAPI_QtGui->api_assign_instance
#define sipAssignMappedType         sipAPI_QtGui->api_assign_mapped_type
#define sipRegisterMetaType         sipAPI_QtGui->api_register_meta_type
#define sipWrappedTypeName(wt)      ((wt)->type->td_cname)
#define sipDeprecated               sipAPI_QtGui->api_deprecated

/* The strings used by this module. */
extern char sipNm_QtGui_isCompositingManagerRunning[];
extern char sipNm_QtGui_setAppUserTime[];
extern char sipNm_QtGui_setAppTime[];
extern char sipNm_QtGui_appUserTime[];
extern char sipNm_QtGui_appTime[];
extern char sipNm_QtGui_setAppDpiY[];
extern char sipNm_QtGui_setAppDpiX[];
extern char sipNm_QtGui_appDpiY[];
extern char sipNm_QtGui_appDpiX[];
extern char sipNm_QtGui_appDefaultVisual[];
extern char sipNm_QtGui_appDefaultColormap[];
extern char sipNm_QtGui_appRootWindow[];
extern char sipNm_QtGui_appVisual[];
extern char sipNm_QtGui_appColormap[];
extern char sipNm_QtGui_appCells[];
extern char sipNm_QtGui_appDepth[];
extern char sipNm_QtGui_appScreen[];
extern char sipNm_QtGui_defaultVisual[];
extern char sipNm_QtGui_visual[];
extern char sipNm_QtGui_defaultColormap[];
extern char sipNm_QtGui_colormap[];
extern char sipNm_QtGui_cells[];
extern char sipNm_QtGui_appClass[];
extern char sipNm_QtGui_QX11Info[];
extern char sipNm_QtGui_Display[];
extern char sipNm_QtGui_clientIsEmbedded[];
extern char sipNm_QtGui_clientClosed[];
extern char sipNm_QtGui_embedClient[];
extern char sipNm_QtGui_discardClient[];
extern char sipNm_QtGui_clientWinId[];
extern char sipNm_QtGui_QX11EmbedContainer[];
extern char sipNm_QtGui_embedded[];
extern char sipNm_QtGui_containerClosed[];
extern char sipNm_QtGui_containerWinId[];
extern char sipNm_QtGui_embedInto[];
extern char sipNm_QtGui_InvalidWindowID[];
extern char sipNm_QtGui_Internal[];
extern char sipNm_QtGui_QX11EmbedWidget[];
extern char sipNm_QtGui_activatePreviousWindow[];
extern char sipNm_QtGui_activateNextWindow[];
extern char sipNm_QtGui_closeActiveWindow[];
extern char sipNm_QtGui_arrangeIcons[];
extern char sipNm_QtGui_tile[];
extern char sipNm_QtGui_cascade[];
extern char sipNm_QtGui_windowActivated[];
extern char sipNm_QtGui_setScrollBarsEnabled[];
extern char sipNm_QtGui_scrollBarsEnabled[];
extern char sipNm_QtGui_addWindow[];
extern char sipNm_QtGui_windowList[];
extern char sipNm_QtGui_QWorkspace[];
extern char sipNm_QtGui_wizard[];
extern char sipNm_QtGui_registerField[];
extern char sipNm_QtGui_completeChanged[];
extern char sipNm_QtGui_isComplete[];
extern char sipNm_QtGui_validatePage[];
extern char sipNm_QtGui_isCommitPage[];
extern char sipNm_QtGui_setCommitPage[];
extern char sipNm_QtGui_isFinalPage[];
extern char sipNm_QtGui_setFinalPage[];
extern char sipNm_QtGui_subTitle[];
extern char sipNm_QtGui_setSubTitle[];
extern char sipNm_QtGui_QWizardPage[];
extern char sipNm_QtGui_cleanupPage[];
extern char sipNm_QtGui_initializePage[];
extern char sipNm_QtGui_back[];
extern char sipNm_QtGui_customButtonClicked[];
extern char sipNm_QtGui_currentIdChanged[];
extern char sipNm_QtGui_setDefaultProperty[];
extern char sipNm_QtGui_subTitleFormat[];
extern char sipNm_QtGui_setSubTitleFormat[];
extern char sipNm_QtGui_titleFormat[];
extern char sipNm_QtGui_setTitleFormat[];
extern char sipNm_QtGui_setButton[];
extern char sipNm_QtGui_setButtonLayout[];
extern char sipNm_QtGui_options[];
extern char sipNm_QtGui_setOptions[];
extern char sipNm_QtGui_wizardStyle[];
extern char sipNm_QtGui_setWizardStyle[];
extern char sipNm_QtGui_field[];
extern char sipNm_QtGui_setField[];
extern char sipNm_QtGui_nextId[];
extern char sipNm_QtGui_validateCurrentPage[];
extern char sipNm_QtGui_currentId[];
extern char sipNm_QtGui_startId[];
extern char sipNm_QtGui_setStartId[];
extern char sipNm_QtGui_visitedPages[];
extern char sipNm_QtGui_hasVisitedPage[];
extern char sipNm_QtGui_page[];
extern char sipNm_QtGui_setPage[];
extern char sipNm_QtGui_addPage[];
extern char sipNm_QtGui_WizardOptions[];
extern char sipNm_QtGui_HaveCustomButton3[];
extern char sipNm_QtGui_HaveCustomButton2[];
extern char sipNm_QtGui_HaveCustomButton1[];
extern char sipNm_QtGui_HelpButtonOnRight[];
extern char sipNm_QtGui_HaveHelpButton[];
extern char sipNm_QtGui_CancelButtonOnLeft[];
extern char sipNm_QtGui_NoCancelButton[];
extern char sipNm_QtGui_HaveFinishButtonOnEarlyPages[];
extern char sipNm_QtGui_HaveNextButtonOnLastPage[];
extern char sipNm_QtGui_DisabledBackButtonOnLastPage[];
extern char sipNm_QtGui_NoBackButtonOnLastPage[];
extern char sipNm_QtGui_NoBackButtonOnStartPage[];
extern char sipNm_QtGui_NoDefaultButton[];
extern char sipNm_QtGui_ExtendedWatermarkPixmap[];
extern char sipNm_QtGui_IgnoreSubTitles[];
extern char sipNm_QtGui_IndependentPages[];
extern char sipNm_QtGui_WizardOption[];
extern char sipNm_QtGui_AeroStyle[];
extern char sipNm_QtGui_MacStyle[];
extern char sipNm_QtGui_ModernStyle[];
extern char sipNm_QtGui_ClassicStyle[];
extern char sipNm_QtGui_BackgroundPixmap[];
extern char sipNm_QtGui_BannerPixmap[];
extern char sipNm_QtGui_LogoPixmap[];
extern char sipNm_QtGui_WatermarkPixmap[];
extern char sipNm_QtGui_CustomButton3[];
extern char sipNm_QtGui_CustomButton2[];
extern char sipNm_QtGui_CustomButton1[];
extern char sipNm_QtGui_HelpButton[];
extern char sipNm_QtGui_CancelButton[];
extern char sipNm_QtGui_FinishButton[];
extern char sipNm_QtGui_CommitButton[];
extern char sipNm_QtGui_NextButton[];
extern char sipNm_QtGui_BackButton[];
extern char sipNm_QtGui_QWizard[];
extern char sipNm_QtGui_createdWidgets[];
extern char sipNm_QtGui_deleteWidget[];
extern char sipNm_QtGui_releaseWidget[];
extern char sipNm_QtGui_requestWidget[];
extern char sipNm_QtGui_defaultWidget[];
extern char sipNm_QtGui_setDefaultWidget[];
extern char sipNm_QtGui_QWidgetAction[];
extern char sipNm_QtGui_windowFilePath[];
extern char sipNm_QtGui_setWindowFilePath[];
extern char sipNm_QtGui_nativeParentWidget[];
extern char sipNm_QtGui_effectiveWinId[];
extern char sipNm_QtGui_unsetLocale[];
extern char sipNm_QtGui_IgnoreMask[];
extern char sipNm_QtGui_DrawChildren[];
extern char sipNm_QtGui_DrawWindowBackground[];
extern char sipNm_QtGui_restoreGeometry[];
extern char sipNm_QtGui_saveGeometry[];
extern char sipNm_QtGui_setShortcutAutoRepeat[];
extern char sipNm_QtGui_setAutoFillBackground[];
extern char sipNm_QtGui_autoFillBackground[];
extern char sipNm_QtGui_windowModality[];
extern char sipNm_QtGui_updatesEnabled[];
extern char sipNm_QtGui_underMouse[];
extern char sipNm_QtGui_hasMouseTracking[];
extern char sipNm_QtGui_setMouseTracking[];
extern char sipNm_QtGui_isEnabledToTLW[];
extern char sipNm_QtGui_isModal[];
extern char sipNm_QtGui_isTopLevel[];
extern char sipNm_QtGui_winId[];
extern char sipNm_QtGui_languageChange[];
extern char sipNm_QtGui_windowActivationChange[];
extern char sipNm_QtGui_fontChange[];
extern char sipNm_QtGui_paletteChange[];
extern char sipNm_QtGui_enabledChange[];
extern char sipNm_QtGui_focusPreviousChild[];
extern char sipNm_QtGui_focusNextChild[];
extern char sipNm_QtGui_destroy[];
extern char sipNm_QtGui_updateMicroFocus[];
extern char sipNm_QtGui_resetInputContext[];
extern char sipNm_QtGui_tabletEvent[];
extern char sipNm_QtGui_customContextMenuRequested[];
extern char sipNm_QtGui_ensurePolished[];
extern char sipNm_QtGui_childAt[];
extern char sipNm_QtGui_overrideWindowFlags[];
extern char sipNm_QtGui_insertActions[];
extern char sipNm_QtGui_insertAction[];
extern char sipNm_QtGui_addActions[];
extern char sipNm_QtGui_nextInFocusChain[];
extern char sipNm_QtGui_visibleRegion[];
extern char sipNm_QtGui_overrideWindowState[];
extern char sipNm_QtGui_setWindowState[];
extern char sipNm_QtGui_windowState[];
extern char sipNm_QtGui_isFullScreen[];
extern char sipNm_QtGui_isMaximized[];
extern char sipNm_QtGui_isMinimized[];
extern char sipNm_QtGui_stackUnder[];
extern char sipNm_QtGui_lower[];
extern char sipNm_QtGui_raise_[];
extern char sipNm_QtGui_showNormal[];
extern char sipNm_QtGui_showFullScreen[];
extern char sipNm_QtGui_showMaximized[];
extern char sipNm_QtGui_showMinimized[];
extern char sipNm_QtGui_setShown[];
extern char sipNm_QtGui_setUpdatesEnabled[];
extern char sipNm_QtGui_keyboardGrabber[];
extern char sipNm_QtGui_mouseGrabber[];
extern char sipNm_QtGui_setShortcutEnabled[];
extern char sipNm_QtGui_releaseShortcut[];
extern char sipNm_QtGui_grabShortcut[];
extern char sipNm_QtGui_releaseKeyboard[];
extern char sipNm_QtGui_releaseMouse[];
extern char sipNm_QtGui_setContextMenuPolicy[];
extern char sipNm_QtGui_contextMenuPolicy[];
extern char sipNm_QtGui_focusProxy[];
extern char sipNm_QtGui_setFocusProxy[];
extern char sipNm_QtGui_activateWindow[];
extern char sipNm_QtGui_setAccessibleName[];
extern char sipNm_QtGui_accessibleName[];
extern char sipNm_QtGui_isWindowModified[];
extern char sipNm_QtGui_windowOpacity[];
extern char sipNm_QtGui_setWindowOpacity[];
extern char sipNm_QtGui_windowRole[];
extern char sipNm_QtGui_setWindowRole[];
extern char sipNm_QtGui_windowIconText[];
extern char sipNm_QtGui_setWindowIconText[];
extern char sipNm_QtGui_clearMask[];
extern char sipNm_QtGui_foregroundRole[];
extern char sipNm_QtGui_setForegroundRole[];
extern char sipNm_QtGui_backgroundRole[];
extern char sipNm_QtGui_setBackgroundRole[];
extern char sipNm_QtGui_mapFrom[];
extern char sipNm_QtGui_mapTo[];
extern char sipNm_QtGui_mapFromGlobal[];
extern char sipNm_QtGui_mapToGlobal[];
extern char sipNm_QtGui_setFixedHeight[];
extern char sipNm_QtGui_setFixedWidth[];
extern char sipNm_QtGui_setFixedSize[];
extern char sipNm_QtGui_setBaseSize[];
extern char sipNm_QtGui_baseSize[];
extern char sipNm_QtGui_setSizeIncrement[];
extern char sipNm_QtGui_sizeIncrement[];
extern char sipNm_QtGui_childrenRegion[];
extern char sipNm_QtGui_childrenRect[];
extern char sipNm_QtGui_frameSize[];
extern char sipNm_QtGui_normalGeometry[];
extern char sipNm_QtGui_frameGeometry[];
extern char sipNm_QtGui_setWindowModified[];
extern char sipNm_QtGui_isEnabledTo[];
extern char sipNm_QtGui_createAction[];
extern char sipNm_QtGui_leaveWhatsThisMode[];
extern char sipNm_QtGui_inWhatsThisMode[];
extern char sipNm_QtGui_enterWhatsThisMode[];
extern char sipNm_QtGui_QWhatsThis[];
extern char sipNm_QtGui_regExp[];
extern char sipNm_QtGui_setRegExp[];
extern char sipNm_QtGui_QRegExpValidator[];
extern char sipNm_QtGui_notation[];
extern char sipNm_QtGui_setNotation[];
extern char sipNm_QtGui_StandardNotation[];
extern char sipNm_QtGui_QDoubleValidator[];
extern char sipNm_QtGui_QIntValidator[];
extern char sipNm_QtGui_Acceptable[];
extern char sipNm_QtGui_Intermediate[];
extern char sipNm_QtGui_QValidator[];
extern char sipNm_QtGui_setStack[];
extern char sipNm_QtGui_cleanIcon[];
extern char sipNm_QtGui_setCleanIcon[];
extern char sipNm_QtGui_emptyLabel[];
extern char sipNm_QtGui_setEmptyLabel[];
extern char sipNm_QtGui_stack[];
extern char sipNm_QtGui_QUndoView[];
extern char sipNm_QtGui_command[];
extern char sipNm_QtGui_undoLimit[];
extern char sipNm_QtGui_setUndoLimit[];
extern char sipNm_QtGui_setIndex[];
extern char sipNm_QtGui_setClean[];
extern char sipNm_QtGui_endMacro[];
extern char sipNm_QtGui_beginMacro[];
extern char sipNm_QtGui_cleanIndex[];
extern char sipNm_QtGui_push[];
extern char sipNm_QtGui_QUndoStack[];
extern char sipNm_QtGui_mergeWith[];
extern char sipNm_QtGui_QUndoCommand[];
extern char sipNm_QtGui_undoTextChanged[];
extern char sipNm_QtGui_redoTextChanged[];
extern char sipNm_QtGui_indexChanged[];
extern char sipNm_QtGui_cleanChanged[];
extern char sipNm_QtGui_canUndoChanged[];
extern char sipNm_QtGui_canRedoChanged[];
extern char sipNm_QtGui_activeStackChanged[];
extern char sipNm_QtGui_setActiveStack[];
extern char sipNm_QtGui_isClean[];
extern char sipNm_QtGui_redoText[];
extern char sipNm_QtGui_undoText[];
extern char sipNm_QtGui_canRedo[];
extern char sipNm_QtGui_canUndo[];
extern char sipNm_QtGui_createUndoAction[];
extern char sipNm_QtGui_createRedoAction[];
extern char sipNm_QtGui_activeStack[];
extern char sipNm_QtGui_stacks[];
extern char sipNm_QtGui_removeStack[];
extern char sipNm_QtGui_addStack[];
extern char sipNm_QtGui_QUndoGroup[];
extern char sipNm_QtGui_UserFlag[];
extern char sipNm_QtGui_NotEditable[];
extern char sipNm_QtGui_Editable[];
extern char sipNm_QtGui_Enabled[];
extern char sipNm_QtGui_NotChecked[];
extern char sipNm_QtGui_NoChildren[];
extern char sipNm_QtGui_HasChildren[];
extern char sipNm_QtGui_DropDisabled[];
extern char sipNm_QtGui_DropEnabled[];
extern char sipNm_QtGui_DragDisabled[];
extern char sipNm_QtGui_DragEnabled[];
extern char sipNm_QtGui_NotSelectable[];
extern char sipNm_QtGui_Selectable[];
extern char sipNm_QtGui_Unselected[];
extern char sipNm_QtGui_NotHidden[];
extern char sipNm_QtGui_QTreeWidgetItemIterator[];
extern char sipNm_QtGui_itemBelow[];
extern char sipNm_QtGui_itemAbove[];
extern char sipNm_QtGui_setFirstItemColumnSpanned[];
extern char sipNm_QtGui_isFirstItemColumnSpanned[];
extern char sipNm_QtGui_setHeaderLabel[];
extern char sipNm_QtGui_itemCollapsed[];
extern char sipNm_QtGui_itemExpanded[];
extern char sipNm_QtGui_collapseItem[];
extern char sipNm_QtGui_expandItem[];
extern char sipNm_QtGui_setItemExpanded[];
extern char sipNm_QtGui_isItemExpanded[];
extern char sipNm_QtGui_sortColumn[];
extern char sipNm_QtGui_setHeaderLabels[];
extern char sipNm_QtGui_setHeaderItem[];
extern char sipNm_QtGui_headerItem[];
extern char sipNm_QtGui_addTopLevelItems[];
extern char sipNm_QtGui_insertTopLevelItems[];
extern char sipNm_QtGui_indexOfTopLevelItem[];
extern char sipNm_QtGui_takeTopLevelItem[];
extern char sipNm_QtGui_addTopLevelItem[];
extern char sipNm_QtGui_insertTopLevelItem[];
extern char sipNm_QtGui_topLevelItemCount[];
extern char sipNm_QtGui_QTreeWidget[];
extern char sipNm_QtGui_isDisabled[];
extern char sipNm_QtGui_removeChild[];
extern char sipNm_QtGui_childIndicatorPolicy[];
extern char sipNm_QtGui_setChildIndicatorPolicy[];
extern char sipNm_QtGui_DontShowIndicatorWhenChildless[];
extern char sipNm_QtGui_DontShowIndicator[];
extern char sipNm_QtGui_ShowIndicator[];
extern char sipNm_QtGui_takeChildren[];
extern char sipNm_QtGui_insertChildren[];
extern char sipNm_QtGui_addChildren[];
extern char sipNm_QtGui_indexOfChild[];
extern char sipNm_QtGui_insertChild[];
extern char sipNm_QtGui_addChild[];
extern char sipNm_QtGui_childCount[];
extern char sipNm_QtGui_treeWidget[];
extern char sipNm_QtGui_QTreeWidgetItem[];
extern char sipNm_QtGui_setHeaderHidden[];
extern char sipNm_QtGui_isHeaderHidden[];
extern char sipNm_QtGui_setExpandsOnDoubleClick[];
extern char sipNm_QtGui_expandsOnDoubleClick[];
extern char sipNm_QtGui_expandToDepth[];
extern char sipNm_QtGui_setFirstColumnSpanned[];
extern char sipNm_QtGui_isFirstColumnSpanned[];
extern char sipNm_QtGui_setAutoExpandDelay[];
extern char sipNm_QtGui_autoExpandDelay[];
extern char sipNm_QtGui_allColumnsShowFocus[];
extern char sipNm_QtGui_setAllColumnsShowFocus[];
extern char sipNm_QtGui_indexRowSizeHint[];
extern char sipNm_QtGui_drawTree[];
extern char sipNm_QtGui_drawBranches[];
extern char sipNm_QtGui_drawRow[];
extern char sipNm_QtGui_rowsRemoved[];
extern char sipNm_QtGui_reexpand[];
extern char sipNm_QtGui_collapseAll[];
extern char sipNm_QtGui_collapse[];
extern char sipNm_QtGui_expandAll[];
extern char sipNm_QtGui_expand[];
extern char sipNm_QtGui_collapsed[];
extern char sipNm_QtGui_expanded[];
extern char sipNm_QtGui_indexBelow[];
extern char sipNm_QtGui_indexAbove[];
extern char sipNm_QtGui_setExpanded[];
extern char sipNm_QtGui_isExpanded[];
extern char sipNm_QtGui_setItemsExpandable[];
extern char sipNm_QtGui_itemsExpandable[];
extern char sipNm_QtGui_setUniformRowHeights[];
extern char sipNm_QtGui_uniformRowHeights[];
extern char sipNm_QtGui_setRootIsDecorated[];
extern char sipNm_QtGui_rootIsDecorated[];
extern char sipNm_QtGui_setIndentation[];
extern char sipNm_QtGui_indentation[];
extern char sipNm_QtGui_setHeader[];
extern char sipNm_QtGui_header[];
extern char sipNm_QtGui_QTreeView[];
extern char sipNm_QtGui_m33[];
extern char sipNm_QtGui_m32[];
extern char sipNm_QtGui_m31[];
extern char sipNm_QtGui_m23[];
extern char sipNm_QtGui_m13[];
extern char sipNm_QtGui_determinant[];
extern char sipNm_QtGui_isTranslating[];
extern char sipNm_QtGui_isRotating[];
extern char sipNm_QtGui_isScaling[];
extern char sipNm_QtGui_isAffine[];
extern char sipNm_QtGui_toAffine[];
extern char sipNm_QtGui_quadToQuad[];
extern char sipNm_QtGui_quadToSquare[];
extern char sipNm_QtGui_squareToQuad[];
extern char sipNm_QtGui_rotateRadians[];
extern char sipNm_QtGui_transposed[];
extern char sipNm_QtGui_adjoint[];
extern char sipNm_QtGui_TxProject[];
extern char sipNm_QtGui_TxShear[];
extern char sipNm_QtGui_TxRotate[];
extern char sipNm_QtGui_TxScale[];
extern char sipNm_QtGui_TxTranslate[];
extern char sipNm_QtGui_TxNone[];
extern char sipNm_QtGui_hideText[];
extern char sipNm_QtGui_showText[];
extern char sipNm_QtGui_QToolTip[];
extern char sipNm_QtGui_autoRaise[];
extern char sipNm_QtGui_setAutoRaise[];
extern char sipNm_QtGui_popupMode[];
extern char sipNm_QtGui_setPopupMode[];
extern char sipNm_QtGui_setArrowType[];
extern char sipNm_QtGui_InstantPopup[];
extern char sipNm_QtGui_DelayedPopup[];
extern char sipNm_QtGui_QToolButton[];
extern char sipNm_QtGui_itemRemoved[];
extern char sipNm_QtGui_itemInserted[];
extern char sipNm_QtGui_itemToolTip[];
extern char sipNm_QtGui_setItemToolTip[];
extern char sipNm_QtGui_isItemEnabled[];
extern char sipNm_QtGui_setItemEnabled[];
extern char sipNm_QtGui_QToolBox[];
extern char sipNm_QtGui_setFloatable[];
extern char sipNm_QtGui_isFloatable[];
extern char sipNm_QtGui_orientationChanged[];
extern char sipNm_QtGui_movableChanged[];
extern char sipNm_QtGui_widgetForAction[];
extern char sipNm_QtGui_QToolBar[];
extern char sipNm_QtGui_rowEnd[];
extern char sipNm_QtGui_rowStart[];
extern char sipNm_QtGui_cellAt[];
extern char sipNm_QtGui_rows[];
extern char sipNm_QtGui_splitCell[];
extern char sipNm_QtGui_mergeCells[];
extern char sipNm_QtGui_QTextTable[];
extern char sipNm_QtGui_QTextTableCell[];
extern char sipNm_QtGui_tabs[];
extern char sipNm_QtGui_setTabs[];
extern char sipNm_QtGui_delimiter[];
extern char sipNm_QtGui_Tab[];
extern char sipNm_QtGui_DelimiterTab[];
extern char sipNm_QtGui_CenterTab[];
extern char sipNm_QtGui_RightTab[];
extern char sipNm_QtGui_LeftTab[];
extern char sipNm_QtGui_setTabStop[];
extern char sipNm_QtGui_tabArray[];
extern char sipNm_QtGui_setTabArray[];
extern char sipNm_QtGui_tabStop[];
extern char sipNm_QtGui_Flags[];
extern char sipNm_QtGui_IncludeTrailingSpaces[];
extern char sipNm_QtGui_Flag[];
extern char sipNm_QtGui_wrapMode[];
extern char sipNm_QtGui_setWrapMode[];
extern char sipNm_QtGui_WrapAtWordBoundaryOrAnywhere[];
extern char sipNm_QtGui_WrapAnywhere[];
extern char sipNm_QtGui_ManualWrap[];
extern char sipNm_QtGui_WordWrap[];
extern char sipNm_QtGui_QTextOption[];
extern char sipNm_QtGui_QTextBlockUserData[];
extern char sipNm_QtGui_QTextFragment[];
extern char sipNm_QtGui_setRevision[];
extern char sipNm_QtGui_setUserState[];
extern char sipNm_QtGui_userState[];
extern char sipNm_QtGui_setUserData[];
extern char sipNm_QtGui_userData[];
extern char sipNm_QtGui_previous[];
extern char sipNm_QtGui_textList[];
extern char sipNm_QtGui_charFormatIndex[];
extern char sipNm_QtGui_blockFormatIndex[];
extern char sipNm_QtGui_QTextBlock[];
extern char sipNm_QtGui_setFrameFormat[];
extern char sipNm_QtGui_iterator[];
extern char sipNm_QtGui_parentFrame[];
extern char sipNm_QtGui_childFrames[];
extern char sipNm_QtGui_lastPosition[];
extern char sipNm_QtGui_firstPosition[];
extern char sipNm_QtGui_lastCursorPosition[];
extern char sipNm_QtGui_firstCursorPosition[];
extern char sipNm_QtGui_frameFormat[];
extern char sipNm_QtGui_QTextFrame[];
extern char sipNm_QtGui_blockList[];
extern char sipNm_QtGui_blockFormatChanged[];
extern char sipNm_QtGui_blockRemoved[];
extern char sipNm_QtGui_blockInserted[];
extern char sipNm_QtGui_QTextObject[];
extern char sipNm_QtGui_itemNumber[];
extern char sipNm_QtGui_QTextBlockGroup[];
extern char sipNm_QtGui_QTextList[];
extern char sipNm_QtGui_textLength[];
extern char sipNm_QtGui_textStart[];
extern char sipNm_QtGui_setNumColumns[];
extern char sipNm_QtGui_xToCursor[];
extern char sipNm_QtGui_cursorToX[];
extern char sipNm_QtGui_CursorOnCharacter[];
extern char sipNm_QtGui_CursorBetweenCharacters[];
extern char sipNm_QtGui_Trailing[];
extern char sipNm_QtGui_Leading[];
extern char sipNm_QtGui_naturalTextRect[];
extern char sipNm_QtGui_naturalTextWidth[];
extern char sipNm_QtGui_QTextLine[];
extern char sipNm_QtGui_clearLayout[];
extern char sipNm_QtGui_drawCursor[];
extern char sipNm_QtGui_previousCursorPosition[];
extern char sipNm_QtGui_nextCursorPosition[];
extern char sipNm_QtGui_isValidCursorPosition[];
extern char sipNm_QtGui_SkipWords[];
extern char sipNm_QtGui_SkipCharacters[];
extern char sipNm_QtGui_lineForTextPosition[];
extern char sipNm_QtGui_lineAt[];
extern char sipNm_QtGui_lineCount[];
extern char sipNm_QtGui_createLine[];
extern char sipNm_QtGui_endLayout[];
extern char sipNm_QtGui_beginLayout[];
extern char sipNm_QtGui_cacheEnabled[];
extern char sipNm_QtGui_setCacheEnabled[];
extern char sipNm_QtGui_clearAdditionalFormats[];
extern char sipNm_QtGui_additionalFormats[];
extern char sipNm_QtGui_setAdditionalFormats[];
extern char sipNm_QtGui_FormatRange[];
extern char sipNm_QtGui_preeditAreaText[];
extern char sipNm_QtGui_preeditAreaPosition[];
extern char sipNm_QtGui_setPreeditArea[];
extern char sipNm_QtGui_textOption[];
extern char sipNm_QtGui_setTextOption[];
extern char sipNm_QtGui_QTextLayout[];
extern char sipNm_QtGui_formatIndex[];
extern char sipNm_QtGui_textPosition[];
extern char sipNm_QtGui_setDescent[];
extern char sipNm_QtGui_setAscent[];
extern char sipNm_QtGui_QTextInlineObject[];
extern char sipNm_QtGui_rightPadding[];
extern char sipNm_QtGui_setRightPadding[];
extern char sipNm_QtGui_leftPadding[];
extern char sipNm_QtGui_setLeftPadding[];
extern char sipNm_QtGui_bottomPadding[];
extern char sipNm_QtGui_setBottomPadding[];
extern char sipNm_QtGui_topPadding[];
extern char sipNm_QtGui_setTopPadding[];
extern char sipNm_QtGui_QTextTableCellFormat[];
extern char sipNm_QtGui_headerRowCount[];
extern char sipNm_QtGui_setHeaderRowCount[];
extern char sipNm_QtGui_setCellPadding[];
extern char sipNm_QtGui_setColumns[];
extern char sipNm_QtGui_cellPadding[];
extern char sipNm_QtGui_setCellSpacing[];
extern char sipNm_QtGui_cellSpacing[];
extern char sipNm_QtGui_clearColumnWidthConstraints[];
extern char sipNm_QtGui_columnWidthConstraints[];
extern char sipNm_QtGui_setColumnWidthConstraints[];
extern char sipNm_QtGui_columns[];
extern char sipNm_QtGui_QTextTableFormat[];
extern char sipNm_QtGui_borderStyle[];
extern char sipNm_QtGui_setBorderStyle[];
extern char sipNm_QtGui_borderBrush[];
extern char sipNm_QtGui_setBorderBrush[];
extern char sipNm_QtGui_BorderStyle_Outset[];
extern char sipNm_QtGui_BorderStyle_Inset[];
extern char sipNm_QtGui_BorderStyle_Ridge[];
extern char sipNm_QtGui_BorderStyle_Groove[];
extern char sipNm_QtGui_BorderStyle_DotDotDash[];
extern char sipNm_QtGui_BorderStyle_DotDash[];
extern char sipNm_QtGui_BorderStyle_Double[];
extern char sipNm_QtGui_BorderStyle_Solid[];
extern char sipNm_QtGui_BorderStyle_Dashed[];
extern char sipNm_QtGui_BorderStyle_Dotted[];
extern char sipNm_QtGui_BorderStyle_None[];
extern char sipNm_QtGui_setPadding[];
extern char sipNm_QtGui_setBorder[];
extern char sipNm_QtGui_padding[];
extern char sipNm_QtGui_border[];
extern char sipNm_QtGui_FloatRight[];
extern char sipNm_QtGui_FloatLeft[];
extern char sipNm_QtGui_InFlow[];
extern char sipNm_QtGui_QTextFrameFormat[];
extern char sipNm_QtGui_setName[];
extern char sipNm_QtGui_QTextImageFormat[];
extern char sipNm_QtGui_ListStyleUndefined[];
extern char sipNm_QtGui_ListUpperAlpha[];
extern char sipNm_QtGui_ListLowerAlpha[];
extern char sipNm_QtGui_ListDecimal[];
extern char sipNm_QtGui_ListSquare[];
extern char sipNm_QtGui_ListCircle[];
extern char sipNm_QtGui_ListDisc[];
extern char sipNm_QtGui_QTextListFormat[];
extern char sipNm_QtGui_tabPositions[];
extern char sipNm_QtGui_setTabPositions[];
extern char sipNm_QtGui_pageBreakPolicy[];
extern char sipNm_QtGui_setPageBreakPolicy[];
extern char sipNm_QtGui_nonBreakableLines[];
extern char sipNm_QtGui_setNonBreakableLines[];
extern char sipNm_QtGui_textIndent[];
extern char sipNm_QtGui_setTextIndent[];
extern char sipNm_QtGui_rightMargin[];
extern char sipNm_QtGui_setRightMargin[];
extern char sipNm_QtGui_leftMargin[];
extern char sipNm_QtGui_setLeftMargin[];
extern char sipNm_QtGui_bottomMargin[];
extern char sipNm_QtGui_setBottomMargin[];
extern char sipNm_QtGui_topMargin[];
extern char sipNm_QtGui_setTopMargin[];
extern char sipNm_QtGui_QTextBlockFormat[];
extern char sipNm_QtGui_fontWordSpacing[];
extern char sipNm_QtGui_setFontWordSpacing[];
extern char sipNm_QtGui_fontLetterSpacing[];
extern char sipNm_QtGui_setFontLetterSpacing[];
extern char sipNm_QtGui_fontCapitalization[];
extern char sipNm_QtGui_setFontCapitalization[];
extern char sipNm_QtGui_anchorNames[];
extern char sipNm_QtGui_setAnchorNames[];
extern char sipNm_QtGui_underlineStyle[];
extern char sipNm_QtGui_setUnderlineStyle[];
extern char sipNm_QtGui_SpellCheckUnderline[];
extern char sipNm_QtGui_WaveUnderline[];
extern char sipNm_QtGui_DashUnderline[];
extern char sipNm_QtGui_SingleUnderline[];
extern char sipNm_QtGui_NoUnderline[];
extern char sipNm_QtGui_textOutline[];
extern char sipNm_QtGui_setTextOutline[];
extern char sipNm_QtGui_setTableCellColumnSpan[];
extern char sipNm_QtGui_setTableCellRowSpan[];
extern char sipNm_QtGui_tableCellColumnSpan[];
extern char sipNm_QtGui_tableCellRowSpan[];
extern char sipNm_QtGui_anchorName[];
extern char sipNm_QtGui_setAnchorName[];
extern char sipNm_QtGui_anchorHref[];
extern char sipNm_QtGui_setAnchorHref[];
extern char sipNm_QtGui_isAnchor[];
extern char sipNm_QtGui_setAnchor[];
extern char sipNm_QtGui_verticalAlignment[];
extern char sipNm_QtGui_setVerticalAlignment[];
extern char sipNm_QtGui_fontFixedPitch[];
extern char sipNm_QtGui_setFontFixedPitch[];
extern char sipNm_QtGui_underlineColor[];
extern char sipNm_QtGui_setUnderlineColor[];
extern char sipNm_QtGui_fontStrikeOut[];
extern char sipNm_QtGui_setFontStrikeOut[];
extern char sipNm_QtGui_fontOverline[];
extern char sipNm_QtGui_setFontOverline[];
extern char sipNm_QtGui_AlignMiddle[];
extern char sipNm_QtGui_AlignSubScript[];
extern char sipNm_QtGui_AlignSuperScript[];
extern char sipNm_QtGui_AlignNormal[];
extern char sipNm_QtGui_QTextCharFormat[];
extern char sipNm_QtGui_toTableCellFormat[];
extern char sipNm_QtGui_isTableCellFormat[];
extern char sipNm_QtGui_setObjectType[];
extern char sipNm_QtGui_clearForeground[];
extern char sipNm_QtGui_clearBackground[];
extern char sipNm_QtGui_toImageFormat[];
extern char sipNm_QtGui_toFrameFormat[];
extern char sipNm_QtGui_toTableFormat[];
extern char sipNm_QtGui_toListFormat[];
extern char sipNm_QtGui_toCharFormat[];
extern char sipNm_QtGui_toBlockFormat[];
extern char sipNm_QtGui_isTableFormat[];
extern char sipNm_QtGui_isImageFormat[];
extern char sipNm_QtGui_isFrameFormat[];
extern char sipNm_QtGui_isListFormat[];
extern char sipNm_QtGui_isBlockFormat[];
extern char sipNm_QtGui_isCharFormat[];
extern char sipNm_QtGui_objectType[];
extern char sipNm_QtGui_properties[];
extern char sipNm_QtGui_lengthVectorProperty[];
extern char sipNm_QtGui_lengthProperty[];
extern char sipNm_QtGui_brushProperty[];
extern char sipNm_QtGui_penProperty[];
extern char sipNm_QtGui_colorProperty[];
extern char sipNm_QtGui_stringProperty[];
extern char sipNm_QtGui_doubleProperty[];
extern char sipNm_QtGui_intProperty[];
extern char sipNm_QtGui_boolProperty[];
extern char sipNm_QtGui_hasProperty[];
extern char sipNm_QtGui_clearProperty[];
extern char sipNm_QtGui_setObjectIndex[];
extern char sipNm_QtGui_objectIndex[];
extern char sipNm_QtGui_UserProperty[];
extern char sipNm_QtGui_TableCellRightPadding[];
extern char sipNm_QtGui_TableCellLeftPadding[];
extern char sipNm_QtGui_TableCellBottomPadding[];
extern char sipNm_QtGui_TableCellTopPadding[];
extern char sipNm_QtGui_LastFontProperty[];
extern char sipNm_QtGui_FontWordSpacing[];
extern char sipNm_QtGui_FontLetterSpacing[];
extern char sipNm_QtGui_FontCapitalization[];
extern char sipNm_QtGui_FirstFontProperty[];
extern char sipNm_QtGui_TabPositions[];
extern char sipNm_QtGui_BackgroundImageUrl[];
extern char sipNm_QtGui_FrameBorderStyle[];
extern char sipNm_QtGui_FrameBorderBrush[];
extern char sipNm_QtGui_FrameRightMargin[];
extern char sipNm_QtGui_FrameLeftMargin[];
extern char sipNm_QtGui_FrameBottomMargin[];
extern char sipNm_QtGui_FrameTopMargin[];
extern char sipNm_QtGui_TextToolTip[];
extern char sipNm_QtGui_PageBreakPolicy[];
extern char sipNm_QtGui_FullWidthSelection[];
extern char sipNm_QtGui_TableHeaderRowCount[];
extern char sipNm_QtGui_TextUnderlineStyle[];
extern char sipNm_QtGui_ImageHeight[];
extern char sipNm_QtGui_ImageWidth[];
extern char sipNm_QtGui_ImageName[];
extern char sipNm_QtGui_TableCellColumnSpan[];
extern char sipNm_QtGui_TableCellRowSpan[];
extern char sipNm_QtGui_TableCellPadding[];
extern char sipNm_QtGui_TableCellSpacing[];
extern char sipNm_QtGui_TableColumnWidthConstraints[];
extern char sipNm_QtGui_TableColumns[];
extern char sipNm_QtGui_FrameHeight[];
extern char sipNm_QtGui_FrameWidth[];
extern char sipNm_QtGui_FramePadding[];
extern char sipNm_QtGui_FrameMargin[];
extern char sipNm_QtGui_FrameBorder[];
extern char sipNm_QtGui_ListIndent[];
extern char sipNm_QtGui_ListStyle[];
extern char sipNm_QtGui_ObjectType[];
extern char sipNm_QtGui_IsAnchor[];
extern char sipNm_QtGui_TextOutline[];
extern char sipNm_QtGui_TextVerticalAlignment[];
extern char sipNm_QtGui_TextUnderlineColor[];
extern char sipNm_QtGui_FontPixelSize[];
extern char sipNm_QtGui_FontFixedPitch[];
extern char sipNm_QtGui_FontStrikeOut[];
extern char sipNm_QtGui_FontOverline[];
extern char sipNm_QtGui_FontUnderline[];
extern char sipNm_QtGui_FontItalic[];
extern char sipNm_QtGui_FontWeight[];
extern char sipNm_QtGui_FontSizeIncrement[];
extern char sipNm_QtGui_FontSizeAdjustment[];
extern char sipNm_QtGui_FontPointSize[];
extern char sipNm_QtGui_FontFamily[];
extern char sipNm_QtGui_BlockTrailingHorizontalRulerWidth[];
extern char sipNm_QtGui_BlockNonBreakableLines[];
extern char sipNm_QtGui_BlockIndent[];
extern char sipNm_QtGui_TextIndent[];
extern char sipNm_QtGui_BlockRightMargin[];
extern char sipNm_QtGui_BlockLeftMargin[];
extern char sipNm_QtGui_BlockBottomMargin[];
extern char sipNm_QtGui_BlockTopMargin[];
extern char sipNm_QtGui_BlockAlignment[];
extern char sipNm_QtGui_ForegroundBrush[];
extern char sipNm_QtGui_BackgroundBrush[];
extern char sipNm_QtGui_OutlinePen[];
extern char sipNm_QtGui_CssFloat[];
extern char sipNm_QtGui_ObjectIndex[];
extern char sipNm_QtGui_PageBreakFlags[];
extern char sipNm_QtGui_PageBreak_AlwaysAfter[];
extern char sipNm_QtGui_PageBreak_AlwaysBefore[];
extern char sipNm_QtGui_PageBreak_Auto[];
extern char sipNm_QtGui_PageBreakFlag[];
extern char sipNm_QtGui_UserObject[];
extern char sipNm_QtGui_TableCellObject[];
extern char sipNm_QtGui_TableObject[];
extern char sipNm_QtGui_ImageObject[];
extern char sipNm_QtGui_NoObject[];
extern char sipNm_QtGui_UserFormat[];
extern char sipNm_QtGui_FrameFormat[];
extern char sipNm_QtGui_TableFormat[];
extern char sipNm_QtGui_ListFormat[];
extern char sipNm_QtGui_CharFormat[];
extern char sipNm_QtGui_BlockFormat[];
extern char sipNm_QtGui_rawValue[];
extern char sipNm_QtGui_PercentageLength[];
extern char sipNm_QtGui_FixedLength[];
extern char sipNm_QtGui_VariableLength[];
extern char sipNm_QtGui_setTextBackgroundColor[];
extern char sipNm_QtGui_textBackgroundColor[];
extern char sipNm_QtGui_currentCharFormatChanged[];
extern char sipNm_QtGui_scrollToAnchor[];
extern char sipNm_QtGui_setFontItalic[];
extern char sipNm_QtGui_setFontUnderline[];
extern char sipNm_QtGui_setFontWeight[];
extern char sipNm_QtGui_setFontFamily[];
extern char sipNm_QtGui_setFontPointSize[];
extern char sipNm_QtGui_setAcceptRichText[];
extern char sipNm_QtGui_acceptRichText[];
extern char sipNm_QtGui_setLineWrapColumnOrWidth[];
extern char sipNm_QtGui_lineWrapColumnOrWidth[];
extern char sipNm_QtGui_fontItalic[];
extern char sipNm_QtGui_fontUnderline[];
extern char sipNm_QtGui_fontWeight[];
extern char sipNm_QtGui_fontFamily[];
extern char sipNm_QtGui_fontPointSize[];
extern char sipNm_QtGui_AutoFormatting[];
extern char sipNm_QtGui_AutoAll[];
extern char sipNm_QtGui_AutoBulletList[];
extern char sipNm_QtGui_AutoNone[];
extern char sipNm_QtGui_AutoFormattingFlag[];
extern char sipNm_QtGui_FixedColumnWidth[];
extern char sipNm_QtGui_FixedPixelWidth[];
extern char sipNm_QtGui_ExtraSelection[];
extern char sipNm_QtGui_fromHtml[];
extern char sipNm_QtGui_fromPlainText[];
extern char sipNm_QtGui_QTextDocumentFragment[];
extern char sipNm_QtGui_documentLayoutChanged[];
extern char sipNm_QtGui_undoCommandAdded[];
extern char sipNm_QtGui_setIndentWidth[];
extern char sipNm_QtGui_indentWidth[];
extern char sipNm_QtGui_lastBlock[];
extern char sipNm_QtGui_firstBlock[];
extern char sipNm_QtGui_findBlockByNumber[];
extern char sipNm_QtGui_revision[];
extern char sipNm_QtGui_setDefaultTextOption[];
extern char sipNm_QtGui_defaultTextOption[];
extern char sipNm_QtGui_defaultStyleSheet[];
extern char sipNm_QtGui_setDefaultStyleSheet[];
extern char sipNm_QtGui_idealWidth[];
extern char sipNm_QtGui_createObject[];
extern char sipNm_QtGui_contentsChanged[];
extern char sipNm_QtGui_contentsChange[];
extern char sipNm_QtGui_useDesignMetrics[];
extern char sipNm_QtGui_setUseDesignMetrics[];
extern char sipNm_QtGui_markContentsDirty[];
extern char sipNm_QtGui_allFormats[];
extern char sipNm_QtGui_addResource[];
extern char sipNm_QtGui_resource[];
extern char sipNm_QtGui_UserResource[];
extern char sipNm_QtGui_StyleSheetResource[];
extern char sipNm_QtGui_ImageResource[];
extern char sipNm_QtGui_HtmlResource[];
extern char sipNm_QtGui_print_[];
extern char sipNm_QtGui_defaultFont[];
extern char sipNm_QtGui_setDefaultFont[];
extern char sipNm_QtGui_findBlock[];
extern char sipNm_QtGui_objectForFormat[];
extern char sipNm_QtGui_object[];
extern char sipNm_QtGui_rootFrame[];
extern char sipNm_QtGui_FindFlags[];
extern char sipNm_QtGui_FindWholeWords[];
extern char sipNm_QtGui_FindCaseSensitively[];
extern char sipNm_QtGui_FindBackward[];
extern char sipNm_QtGui_FindFlag[];
extern char sipNm_QtGui_metaInformation[];
extern char sipNm_QtGui_setMetaInformation[];
extern char sipNm_QtGui_DocumentUrl[];
extern char sipNm_QtGui_DocumentTitle[];
extern char sipNm_QtGui_documentLayout[];
extern char sipNm_QtGui_setDocumentLayout[];
extern char sipNm_QtGui_QTextDocument[];
extern char sipNm_QtGui_convertFromPlainText[];
extern char sipNm_QtGui_mightBeRichText[];
extern char sipNm_QtGui_WhiteSpaceModeUndefined[];
extern char sipNm_QtGui_WhiteSpaceNoWrap[];
extern char sipNm_QtGui_WhiteSpacePre[];
extern char sipNm_QtGui_WhiteSpaceNormal[];
extern char sipNm_QtGui_FuzzyHit[];
extern char sipNm_QtGui_ExactHit[];
extern char sipNm_QtGui_setVisualNavigation[];
extern char sipNm_QtGui_visualNavigation[];
extern char sipNm_QtGui_blockNumber[];
extern char sipNm_QtGui_endEditBlock[];
extern char sipNm_QtGui_joinPreviousEditBlock[];
extern char sipNm_QtGui_beginEditBlock[];
extern char sipNm_QtGui_insertImage[];
extern char sipNm_QtGui_insertHtml[];
extern char sipNm_QtGui_insertFragment[];
extern char sipNm_QtGui_insertFrame[];
extern char sipNm_QtGui_currentTable[];
extern char sipNm_QtGui_insertTable[];
extern char sipNm_QtGui_currentList[];
extern char sipNm_QtGui_createList[];
extern char sipNm_QtGui_insertList[];
extern char sipNm_QtGui_insertBlock[];
extern char sipNm_QtGui_atStart[];
extern char sipNm_QtGui_atBlockEnd[];
extern char sipNm_QtGui_atBlockStart[];
extern char sipNm_QtGui_mergeBlockCharFormat[];
extern char sipNm_QtGui_setBlockCharFormat[];
extern char sipNm_QtGui_blockCharFormat[];
extern char sipNm_QtGui_mergeBlockFormat[];
extern char sipNm_QtGui_setBlockFormat[];
extern char sipNm_QtGui_blockFormat[];
extern char sipNm_QtGui_mergeCharFormat[];
extern char sipNm_QtGui_setCharFormat[];
extern char sipNm_QtGui_charFormat[];
extern char sipNm_QtGui_block[];
extern char sipNm_QtGui_selectedTableCells[];
extern char sipNm_QtGui_selectionEnd[];
extern char sipNm_QtGui_removeSelectedText[];
extern char sipNm_QtGui_hasComplexSelection[];
extern char sipNm_QtGui_Document[];
extern char sipNm_QtGui_BlockUnderCursor[];
extern char sipNm_QtGui_LineUnderCursor[];
extern char sipNm_QtGui_WordUnderCursor[];
extern char sipNm_QtGui_deletePreviousChar[];
extern char sipNm_QtGui_deleteChar[];
extern char sipNm_QtGui_movePosition[];
extern char sipNm_QtGui_WordRight[];
extern char sipNm_QtGui_NextWord[];
extern char sipNm_QtGui_NextCharacter[];
extern char sipNm_QtGui_NextBlock[];
extern char sipNm_QtGui_EndOfBlock[];
extern char sipNm_QtGui_EndOfWord[];
extern char sipNm_QtGui_EndOfLine[];
extern char sipNm_QtGui_WordLeft[];
extern char sipNm_QtGui_PreviousWord[];
extern char sipNm_QtGui_PreviousCharacter[];
extern char sipNm_QtGui_PreviousBlock[];
extern char sipNm_QtGui_StartOfWord[];
extern char sipNm_QtGui_StartOfBlock[];
extern char sipNm_QtGui_StartOfLine[];
extern char sipNm_QtGui_Start[];
extern char sipNm_QtGui_NoMove[];
extern char sipNm_QtGui_insertText[];
extern char sipNm_QtGui_anchor[];
extern char sipNm_QtGui_KeepAnchor[];
extern char sipNm_QtGui_MoveAnchor[];
extern char sipNm_QtGui_QTextCursor[];
extern char sipNm_QtGui_historyChanged[];
extern char sipNm_QtGui_forwardHistoryCount[];
extern char sipNm_QtGui_backwardHistoryCount[];
extern char sipNm_QtGui_historyUrl[];
extern char sipNm_QtGui_historyTitle[];
extern char sipNm_QtGui_setOpenLinks[];
extern char sipNm_QtGui_openLinks[];
extern char sipNm_QtGui_clearHistory[];
extern char sipNm_QtGui_isForwardAvailable[];
extern char sipNm_QtGui_isBackwardAvailable[];
extern char sipNm_QtGui_anchorClicked[];
extern char sipNm_QtGui_sourceChanged[];
extern char sipNm_QtGui_forwardAvailable[];
extern char sipNm_QtGui_backwardAvailable[];
extern char sipNm_QtGui_reload[];
extern char sipNm_QtGui_forward[];
extern char sipNm_QtGui_backward[];
extern char sipNm_QtGui_setSource[];
extern char sipNm_QtGui_QTextEdit[];
extern char sipNm_QtGui_QTextBrowser[];
extern char sipNm_QtGui_tabBar[];
extern char sipNm_QtGui_setTabBar[];
extern char sipNm_QtGui_Triangular[];
extern char sipNm_QtGui_Rounded[];
extern char sipNm_QtGui_East[];
extern char sipNm_QtGui_West[];
extern char sipNm_QtGui_South[];
extern char sipNm_QtGui_North[];
extern char sipNm_QtGui_QTabWidget[];
extern char sipNm_QtGui_currentCellChanged[];
extern char sipNm_QtGui_cellChanged[];
extern char sipNm_QtGui_cellEntered[];
extern char sipNm_QtGui_cellActivated[];
extern char sipNm_QtGui_cellDoubleClicked[];
extern char sipNm_QtGui_cellClicked[];
extern char sipNm_QtGui_cellPressed[];
extern char sipNm_QtGui_clearContents[];
extern char sipNm_QtGui_visualColumn[];
extern char sipNm_QtGui_visualRow[];
extern char sipNm_QtGui_selectedRanges[];
extern char sipNm_QtGui_setRangeSelected[];
extern char sipNm_QtGui_removeCellWidget[];
extern char sipNm_QtGui_setCellWidget[];
extern char sipNm_QtGui_cellWidget[];
extern char sipNm_QtGui_setCurrentCell[];
extern char sipNm_QtGui_currentColumn[];
extern char sipNm_QtGui_QTableWidget[];
extern char sipNm_QtGui_tableWidget[];
extern char sipNm_QtGui_QTableWidgetItem[];
extern char sipNm_QtGui_rightColumn[];
extern char sipNm_QtGui_leftColumn[];
extern char sipNm_QtGui_bottomRow[];
extern char sipNm_QtGui_topRow[];
extern char sipNm_QtGui_QTableWidgetSelectionRange[];
extern char sipNm_QtGui_clearSpans[];
extern char sipNm_QtGui_isCornerButtonEnabled[];
extern char sipNm_QtGui_setCornerButtonEnabled[];
extern char sipNm_QtGui_columnSpan[];
extern char sipNm_QtGui_rowSpan[];
extern char sipNm_QtGui_setSpan[];
extern char sipNm_QtGui_columnCountChanged[];
extern char sipNm_QtGui_rowCountChanged[];
extern char sipNm_QtGui_columnResized[];
extern char sipNm_QtGui_rowResized[];
extern char sipNm_QtGui_columnMoved[];
extern char sipNm_QtGui_rowMoved[];
extern char sipNm_QtGui_sortByColumn[];
extern char sipNm_QtGui_resizeColumnsToContents[];
extern char sipNm_QtGui_resizeColumnToContents[];
extern char sipNm_QtGui_resizeRowsToContents[];
extern char sipNm_QtGui_resizeRowToContents[];
extern char sipNm_QtGui_showColumn[];
extern char sipNm_QtGui_showRow[];
extern char sipNm_QtGui_hideColumn[];
extern char sipNm_QtGui_hideRow[];
extern char sipNm_QtGui_selectColumn[];
extern char sipNm_QtGui_selectRow[];
extern char sipNm_QtGui_setGridStyle[];
extern char sipNm_QtGui_gridStyle[];
extern char sipNm_QtGui_setShowGrid[];
extern char sipNm_QtGui_showGrid[];
extern char sipNm_QtGui_setColumnHidden[];
extern char sipNm_QtGui_isColumnHidden[];
extern char sipNm_QtGui_columnAt[];
extern char sipNm_QtGui_columnWidth[];
extern char sipNm_QtGui_setColumnWidth[];
extern char sipNm_QtGui_columnViewportPosition[];
extern char sipNm_QtGui_rowAt[];
extern char sipNm_QtGui_rowHeight[];
extern char sipNm_QtGui_setRowHeight[];
extern char sipNm_QtGui_rowViewportPosition[];
extern char sipNm_QtGui_setVerticalHeader[];
extern char sipNm_QtGui_setHorizontalHeader[];
extern char sipNm_QtGui_verticalHeader[];
extern char sipNm_QtGui_horizontalHeader[];
extern char sipNm_QtGui_QTableView[];
extern char sipNm_QtGui_tabLayoutChange[];
extern char sipNm_QtGui_tabRemoved[];
extern char sipNm_QtGui_tabInserted[];
extern char sipNm_QtGui_tabSizeHint[];
extern char sipNm_QtGui_usesScrollButtons[];
extern char sipNm_QtGui_setUsesScrollButtons[];
extern char sipNm_QtGui_setElideMode[];
extern char sipNm_QtGui_elideMode[];
extern char sipNm_QtGui_drawBase[];
extern char sipNm_QtGui_setDrawBase[];
extern char sipNm_QtGui_tabRect[];
extern char sipNm_QtGui_tabAt[];
extern char sipNm_QtGui_tabData[];
extern char sipNm_QtGui_setTabData[];
extern char sipNm_QtGui_tabWhatsThis[];
extern char sipNm_QtGui_setTabWhatsThis[];
extern char sipNm_QtGui_tabToolTip[];
extern char sipNm_QtGui_setTabToolTip[];
extern char sipNm_QtGui_setTabIcon[];
extern char sipNm_QtGui_tabIcon[];
extern char sipNm_QtGui_setTabTextColor[];
extern char sipNm_QtGui_tabTextColor[];
extern char sipNm_QtGui_setTabText[];
extern char sipNm_QtGui_tabText[];
extern char sipNm_QtGui_setTabEnabled[];
extern char sipNm_QtGui_isTabEnabled[];
extern char sipNm_QtGui_removeTab[];
extern char sipNm_QtGui_insertTab[];
extern char sipNm_QtGui_addTab[];
extern char sipNm_QtGui_TriangularEast[];
extern char sipNm_QtGui_TriangularWest[];
extern char sipNm_QtGui_TriangularSouth[];
extern char sipNm_QtGui_TriangularNorth[];
extern char sipNm_QtGui_RoundedEast[];
extern char sipNm_QtGui_RoundedWest[];
extern char sipNm_QtGui_RoundedSouth[];
extern char sipNm_QtGui_RoundedNorth[];
extern char sipNm_QtGui_QTabBar[];
extern char sipNm_QtGui_messageClicked[];
extern char sipNm_QtGui_supportsMessages[];
extern char sipNm_QtGui_isSystemTrayAvailable[];
extern char sipNm_QtGui_contextMenu[];
extern char sipNm_QtGui_setContextMenu[];
extern char sipNm_QtGui_MiddleClick[];
extern char sipNm_QtGui_DoubleClick[];
extern char sipNm_QtGui_Context[];
extern char sipNm_QtGui_Unknown[];
extern char sipNm_QtGui_QSystemTrayIcon[];
extern char sipNm_QtGui_currentBlock[];
extern char sipNm_QtGui_currentBlockUserData[];
extern char sipNm_QtGui_setCurrentBlockUserData[];
extern char sipNm_QtGui_setCurrentBlockState[];
extern char sipNm_QtGui_currentBlockState[];
extern char sipNm_QtGui_previousBlockState[];
extern char sipNm_QtGui_highlightBlock[];
extern char sipNm_QtGui_rehighlight[];
extern char sipNm_QtGui_QSyntaxHighlighter[];
extern char sipNm_QtGui_QStylePainter[];
extern char sipNm_QtGui_viewItemPosition[];
extern char sipNm_QtGui_QStyleOptionViewItemV4[];
extern char sipNm_QtGui_QStyleHintReturnVariant[];
extern char sipNm_QtGui_QStyleOptionToolBoxV2[];
extern char sipNm_QtGui_QStyleOptionViewItemV3[];
extern char sipNm_QtGui_verticalTitleBar[];
extern char sipNm_QtGui_QStyleOptionDockWidgetV2[];
extern char sipNm_QtGui_levelOfDetail[];
extern char sipNm_QtGui_exposedRect[];
extern char sipNm_QtGui_QStyleOptionGraphicsItem[];
extern char sipNm_QtGui_QStyleOptionSizeGrip[];
extern char sipNm_QtGui_ViewItemFeatures[];
extern char sipNm_QtGui_HasDecoration[];
extern char sipNm_QtGui_HasDisplay[];
extern char sipNm_QtGui_HasCheckIndicator[];
extern char sipNm_QtGui_Alternate[];
extern char sipNm_QtGui_WrapText[];
extern char sipNm_QtGui_ViewItemFeature[];
extern char sipNm_QtGui_QStyleOptionViewItemV2[];
extern char sipNm_QtGui_QStyleOptionGroupBox[];
extern char sipNm_QtGui_positionWithinLine[];
extern char sipNm_QtGui_positionOfLine[];
extern char sipNm_QtGui_ToolBarFeatures[];
extern char sipNm_QtGui_Movable[];
extern char sipNm_QtGui_ToolBarFeature[];
extern char sipNm_QtGui_QStyleOptionToolBar[];
extern char sipNm_QtGui_QStyleHintReturnMask[];
extern char sipNm_QtGui_SH_Variant[];
extern char sipNm_QtGui_SH_Mask[];
extern char sipNm_QtGui_SH_Default[];
extern char sipNm_QtGui_QStyleHintReturn[];
extern char sipNm_QtGui_titleBarFlags[];
extern char sipNm_QtGui_titleBarState[];
extern char sipNm_QtGui_QStyleOptionTitleBar[];
extern char sipNm_QtGui_currentIcon[];
extern char sipNm_QtGui_popupRect[];
extern char sipNm_QtGui_editable[];
extern char sipNm_QtGui_QStyleOptionComboBox[];
extern char sipNm_QtGui_arrowType[];
extern char sipNm_QtGui_ToolButtonFeatures[];
extern char sipNm_QtGui_MenuButtonPopup[];
extern char sipNm_QtGui_PopupDelay[];
extern char sipNm_QtGui_Menu[];
extern char sipNm_QtGui_Arrow[];
extern char sipNm_QtGui_ToolButtonFeature[];
extern char sipNm_QtGui_QStyleOptionToolButton[];
extern char sipNm_QtGui_frame[];
extern char sipNm_QtGui_QStyleOptionSpinBox[];
extern char sipNm_QtGui_dialWrapping[];
extern char sipNm_QtGui_sliderValue[];
extern char sipNm_QtGui_upsideDown[];
extern char sipNm_QtGui_QStyleOptionSlider[];
extern char sipNm_QtGui_activeSubControls[];
extern char sipNm_QtGui_subControls[];
extern char sipNm_QtGui_QStyleOptionComplex[];
extern char sipNm_QtGui_opaque[];
extern char sipNm_QtGui_QStyleOptionRubberBand[];
extern char sipNm_QtGui_QStyleOptionToolBox[];
extern char sipNm_QtGui_showDecorationSelected[];
extern char sipNm_QtGui_decorationSize[];
extern char sipNm_QtGui_decorationPosition[];
extern char sipNm_QtGui_decorationAlignment[];
extern char sipNm_QtGui_displayAlignment[];
extern char sipNm_QtGui_Bottom[];
extern char sipNm_QtGui_Top[];
extern char sipNm_QtGui_Left[];
extern char sipNm_QtGui_QStyleOptionViewItem[];
extern char sipNm_QtGui_floatable[];
extern char sipNm_QtGui_movable[];
extern char sipNm_QtGui_closable[];
extern char sipNm_QtGui_QStyleOptionDockWidget[];
extern char sipNm_QtGui_tabWidth[];
extern char sipNm_QtGui_maxIconWidth[];
extern char sipNm_QtGui_menuRect[];
extern char sipNm_QtGui_menuHasCheckableItems[];
extern char sipNm_QtGui_checked[];
extern char sipNm_QtGui_checkType[];
extern char sipNm_QtGui_menuItemType[];
extern char sipNm_QtGui_NonExclusive[];
extern char sipNm_QtGui_Exclusive[];
extern char sipNm_QtGui_NotCheckable[];
extern char sipNm_QtGui_EmptyArea[];
extern char sipNm_QtGui_Margin[];
extern char sipNm_QtGui_TearOff[];
extern char sipNm_QtGui_Scroller[];
extern char sipNm_QtGui_SubMenu[];
extern char sipNm_QtGui_Separator[];
extern char sipNm_QtGui_DefaultItem[];
extern char sipNm_QtGui_QStyleOptionMenuItem[];
extern char sipNm_QtGui_bottomToTop[];
extern char sipNm_QtGui_QStyleOptionProgressBarV2[];
extern char sipNm_QtGui_textVisible[];
extern char sipNm_QtGui_progress[];
extern char sipNm_QtGui_QStyleOptionProgressBar[];
extern char sipNm_QtGui_QStyleOptionTabV2[];
extern char sipNm_QtGui_cornerWidgets[];
extern char sipNm_QtGui_CornerWidgets[];
extern char sipNm_QtGui_RightCornerWidget[];
extern char sipNm_QtGui_LeftCornerWidget[];
extern char sipNm_QtGui_NoCornerWidgets[];
extern char sipNm_QtGui_CornerWidget[];
extern char sipNm_QtGui_OnlyOneTab[];
extern char sipNm_QtGui_QStyleOptionTab[];
extern char sipNm_QtGui_ButtonFeatures[];
extern char sipNm_QtGui_CommandLinkButton[];
extern char sipNm_QtGui_AutoDefaultButton[];
extern char sipNm_QtGui_DefaultButton[];
extern char sipNm_QtGui_HasMenu[];
extern char sipNm_QtGui_ButtonFeature[];
extern char sipNm_QtGui_QStyleOptionButton[];
extern char sipNm_QtGui_sortIndicator[];
extern char sipNm_QtGui_selectedPosition[];
extern char sipNm_QtGui_iconAlignment[];
extern char sipNm_QtGui_SortDown[];
extern char sipNm_QtGui_SortUp[];
extern char sipNm_QtGui_NextAndPreviousAreSelected[];
extern char sipNm_QtGui_PreviousIsSelected[];
extern char sipNm_QtGui_NextIsSelected[];
extern char sipNm_QtGui_NotAdjacent[];
extern char sipNm_QtGui_OnlyOneSection[];
extern char sipNm_QtGui_End[];
extern char sipNm_QtGui_Beginning[];
extern char sipNm_QtGui_QStyleOptionHeader[];
extern char sipNm_QtGui_selectedTabRect[];
extern char sipNm_QtGui_tabBarRect[];
extern char sipNm_QtGui_QStyleOptionTabBarBase[];
extern char sipNm_QtGui_leftCornerWidgetSize[];
extern char sipNm_QtGui_rightCornerWidgetSize[];
extern char sipNm_QtGui_tabBarSize[];
extern char sipNm_QtGui_QStyleOptionTabWidgetFrame[];
extern char sipNm_QtGui_FrameFeatures[];
extern char sipNm_QtGui_FrameFeature[];
extern char sipNm_QtGui_QStyleOptionFrameV2[];
extern char sipNm_QtGui_QStyleOptionFrame[];
extern char sipNm_QtGui_QStyleOptionFocusRect[];
extern char sipNm_QtGui_init[];
extern char sipNm_QtGui_SO_CustomBase[];
extern char sipNm_QtGui_SO_SizeGrip[];
extern char sipNm_QtGui_SO_GraphicsItem[];
extern char sipNm_QtGui_SO_ComplexCustomBase[];
extern char sipNm_QtGui_SO_GroupBox[];
extern char sipNm_QtGui_SO_TitleBar[];
extern char sipNm_QtGui_SO_Q3ListView[];
extern char sipNm_QtGui_SO_ComboBox[];
extern char sipNm_QtGui_SO_ToolButton[];
extern char sipNm_QtGui_SO_SpinBox[];
extern char sipNm_QtGui_SO_Slider[];
extern char sipNm_QtGui_SO_Complex[];
extern char sipNm_QtGui_SO_ToolBar[];
extern char sipNm_QtGui_SO_RubberBand[];
extern char sipNm_QtGui_SO_TabBarBase[];
extern char sipNm_QtGui_SO_TabWidgetFrame[];
extern char sipNm_QtGui_SO_ViewItem[];
extern char sipNm_QtGui_SO_Q3ListViewItem[];
extern char sipNm_QtGui_SO_DockWidget[];
extern char sipNm_QtGui_SO_Q3DockWindow[];
extern char sipNm_QtGui_SO_Header[];
extern char sipNm_QtGui_SO_ToolBox[];
extern char sipNm_QtGui_SO_ProgressBar[];
extern char sipNm_QtGui_SO_Frame[];
extern char sipNm_QtGui_SO_MenuItem[];
extern char sipNm_QtGui_SO_Tab[];
extern char sipNm_QtGui_SO_Button[];
extern char sipNm_QtGui_SO_FocusRect[];
extern char sipNm_QtGui_SO_Default[];
extern char sipNm_QtGui_QStyleOption[];
extern char sipNm_QtGui_keys[];
extern char sipNm_QtGui_QStyleFactory[];
extern char sipNm_QtGui_QStyledItemDelegate[];
extern char sipNm_QtGui_layoutSpacingImplementation[];
extern char sipNm_QtGui_standardIconImplementation[];
extern char sipNm_QtGui_combinedLayoutSpacing[];
extern char sipNm_QtGui_layoutSpacing[];
extern char sipNm_QtGui_alignedRect[];
extern char sipNm_QtGui_visualAlignment[];
extern char sipNm_QtGui_sliderValueFromPosition[];
extern char sipNm_QtGui_sliderPositionFromValue[];
extern char sipNm_QtGui_visualPos[];
extern char sipNm_QtGui_generatedIconPixmap[];
extern char sipNm_QtGui_standardPixmap[];
extern char sipNm_QtGui_SP_CustomBase[];
extern char sipNm_QtGui_SP_MediaVolumeMuted[];
extern char sipNm_QtGui_SP_MediaVolume[];
extern char sipNm_QtGui_SP_MediaSeekBackward[];
extern char sipNm_QtGui_SP_MediaSeekForward[];
extern char sipNm_QtGui_SP_MediaSkipBackward[];
extern char sipNm_QtGui_SP_MediaSkipForward[];
extern char sipNm_QtGui_SP_MediaPause[];
extern char sipNm_QtGui_SP_MediaStop[];
extern char sipNm_QtGui_SP_MediaPlay[];
extern char sipNm_QtGui_SP_BrowserStop[];
extern char sipNm_QtGui_SP_BrowserReload[];
extern char sipNm_QtGui_SP_VistaShield[];
extern char sipNm_QtGui_SP_CommandLink[];
extern char sipNm_QtGui_SP_DirHomeIcon[];
extern char sipNm_QtGui_SP_ArrowForward[];
extern char sipNm_QtGui_SP_ArrowBack[];
extern char sipNm_QtGui_SP_ArrowRight[];
extern char sipNm_QtGui_SP_ArrowLeft[];
extern char sipNm_QtGui_SP_ArrowDown[];
extern char sipNm_QtGui_SP_ArrowUp[];
extern char sipNm_QtGui_SP_DialogNoButton[];
extern char sipNm_QtGui_SP_DialogYesButton[];
extern char sipNm_QtGui_SP_DialogDiscardButton[];
extern char sipNm_QtGui_SP_DialogResetButton[];
extern char sipNm_QtGui_SP_DialogApplyButton[];
extern char sipNm_QtGui_SP_DialogCloseButton[];
extern char sipNm_QtGui_SP_DialogSaveButton[];
extern char sipNm_QtGui_SP_DialogOpenButton[];
extern char sipNm_QtGui_SP_DialogHelpButton[];
extern char sipNm_QtGui_SP_DialogCancelButton[];
extern char sipNm_QtGui_SP_DialogOkButton[];
extern char sipNm_QtGui_SP_DirIcon[];
extern char sipNm_QtGui_SP_FileDialogBack[];
extern char sipNm_QtGui_SP_FileDialogListView[];
extern char sipNm_QtGui_SP_FileDialogContentsView[];
extern char sipNm_QtGui_SP_FileDialogInfoView[];
extern char sipNm_QtGui_SP_FileDialogDetailedView[];
extern char sipNm_QtGui_SP_FileDialogNewFolder[];
extern char sipNm_QtGui_SP_FileDialogToParent[];
extern char sipNm_QtGui_SP_FileDialogEnd[];
extern char sipNm_QtGui_SP_FileDialogStart[];
extern char sipNm_QtGui_SP_ToolBarVerticalExtensionButton[];
extern char sipNm_QtGui_SP_ToolBarHorizontalExtensionButton[];
extern char sipNm_QtGui_SP_FileLinkIcon[];
extern char sipNm_QtGui_SP_FileIcon[];
extern char sipNm_QtGui_SP_DirLinkIcon[];
extern char sipNm_QtGui_SP_DirClosedIcon[];
extern char sipNm_QtGui_SP_DirOpenIcon[];
extern char sipNm_QtGui_SP_DriveNetIcon[];
extern char sipNm_QtGui_SP_DriveDVDIcon[];
extern char sipNm_QtGui_SP_DriveCDIcon[];
extern char sipNm_QtGui_SP_DriveHDIcon[];
extern char sipNm_QtGui_SP_DriveFDIcon[];
extern char sipNm_QtGui_SP_ComputerIcon[];
extern char sipNm_QtGui_SP_TrashIcon[];
extern char sipNm_QtGui_SP_DesktopIcon[];
extern char sipNm_QtGui_SP_MessageBoxQuestion[];
extern char sipNm_QtGui_SP_MessageBoxCritical[];
extern char sipNm_QtGui_SP_MessageBoxWarning[];
extern char sipNm_QtGui_SP_MessageBoxInformation[];
extern char sipNm_QtGui_SP_DockWidgetCloseButton[];
extern char sipNm_QtGui_SP_TitleBarContextHelpButton[];
extern char sipNm_QtGui_SP_TitleBarUnshadeButton[];
extern char sipNm_QtGui_SP_TitleBarShadeButton[];
extern char sipNm_QtGui_SP_TitleBarNormalButton[];
extern char sipNm_QtGui_SP_TitleBarCloseButton[];
extern char sipNm_QtGui_SP_TitleBarMaxButton[];
extern char sipNm_QtGui_SP_TitleBarMinButton[];
extern char sipNm_QtGui_SP_TitleBarMenuButton[];
extern char sipNm_QtGui_SH_CustomBase[];
extern char sipNm_QtGui_SH_FormLayoutLabelAlignment[];
extern char sipNm_QtGui_SH_FormLayoutFormAlignment[];
extern char sipNm_QtGui_SH_FormLayoutFieldGrowthPolicy[];
extern char sipNm_QtGui_SH_ToolBar_Movable[];
extern char sipNm_QtGui_SH_TabWidget_DefaultTabPosition[];
extern char sipNm_QtGui_SH_FormLayoutWrapPolicy[];
extern char sipNm_QtGui_SH_ItemView_PaintAlternatingRowColorsForEmptyArea[];
extern char sipNm_QtGui_SH_SpinBox_ClickAutoRepeatThreshold[];
extern char sipNm_QtGui_SH_Menu_FadeOutOnHide[];
extern char sipNm_QtGui_SH_Menu_FlashTriggeredItem[];
extern char sipNm_QtGui_SH_Menu_Mask[];
extern char sipNm_QtGui_SH_ItemView_ArrowKeysNavigateIntoChildren[];
extern char sipNm_QtGui_SH_WizardStyle[];
extern char sipNm_QtGui_SH_TextControl_FocusIndicatorTextCharFormat[];
extern char sipNm_QtGui_SH_FocusFrame_AboveWidget[];
extern char sipNm_QtGui_SH_ToolTip_Mask[];
extern char sipNm_QtGui_SH_ItemView_MovementWithoutUpdatingSelection[];
extern char sipNm_QtGui_SH_Menu_SelectionWrap[];
extern char sipNm_QtGui_SH_MessageBox_CenterButtons[];
extern char sipNm_QtGui_SH_SpellCheckUnderlineStyle[];
extern char sipNm_QtGui_SH_DialogButtonBox_ButtonsHaveIcons[];
extern char sipNm_QtGui_SH_MessageBox_TextInteractionFlags[];
extern char sipNm_QtGui_SH_ComboBox_PopupFrameStyle[];
extern char sipNm_QtGui_SH_DialogButtonLayout[];
extern char sipNm_QtGui_SH_TabBar_ElideMode[];
extern char sipNm_QtGui_SH_Menu_KeyboardSearch[];
extern char sipNm_QtGui_SH_Slider_PageSetButtons[];
extern char sipNm_QtGui_SH_Slider_AbsoluteSetButtons[];
extern char sipNm_QtGui_SH_Slider_StopMouseOverSlider[];
extern char sipNm_QtGui_SH_ScrollBar_RollBetweenButtons[];
extern char sipNm_QtGui_SH_ScrollBar_ContextMenu[];
extern char sipNm_QtGui_SH_ItemView_ActivateItemOnSingleClick[];
extern char sipNm_QtGui_SH_ItemView_ShowDecorationSelected[];
extern char sipNm_QtGui_SH_ItemView_EllipsisLocation[];
extern char sipNm_QtGui_SH_ComboBox_LayoutDirection[];
extern char sipNm_QtGui_SH_Dial_BackgroundRole[];
extern char sipNm_QtGui_SH_SpinControls_DisableOnBounds[];
extern char sipNm_QtGui_SH_WindowFrame_Mask[];
extern char sipNm_QtGui_SH_RubberBand_Mask[];
extern char sipNm_QtGui_SH_FocusFrame_Mask[];
extern char sipNm_QtGui_SH_ToolButton_PopupDelay[];
extern char sipNm_QtGui_SH_TitleBar_AutoRaise[];
extern char sipNm_QtGui_SH_MessageBox_UseBorderForButtonSpacing[];
extern char sipNm_QtGui_SH_MenuBar_DismissOnSecondClick[];
extern char sipNm_QtGui_SH_Button_FocusPolicy[];
extern char sipNm_QtGui_SH_TitleBar_ModifyNotification[];
extern char sipNm_QtGui_SH_DrawMenuBarSeparator[];
extern char sipNm_QtGui_SH_ToolTipLabel_Opacity[];
extern char sipNm_QtGui_SH_Menu_FillScreenWithScroll[];
extern char sipNm_QtGui_SH_SpinBox_ClickAutoRepeatRate[];
extern char sipNm_QtGui_SH_SpinBox_KeyPressAutoRepeatRate[];
extern char sipNm_QtGui_SH_SpinBox_AnimateButton[];
extern char sipNm_QtGui_SH_UnderlineShortcut[];
extern char sipNm_QtGui_SH_Q3ListViewExpand_SelectMouseType[];
extern char sipNm_QtGui_SH_ScrollBar_LeftClickAbsolutePosition[];
extern char sipNm_QtGui_SH_TabBar_PreferNoArrows[];
extern char sipNm_QtGui_SH_ToolBox_SelectedPageTitleBold[];
extern char sipNm_QtGui_SH_DialogButtons_DefaultButton[];
extern char sipNm_QtGui_SH_LineEdit_PasswordCharacter[];
extern char sipNm_QtGui_SH_Table_GridLineColor[];
extern char sipNm_QtGui_SH_Menu_SloppySubMenus[];
extern char sipNm_QtGui_SH_GroupBox_TextLabelColor[];
extern char sipNm_QtGui_SH_GroupBox_TextLabelVerticalAlignment[];
extern char sipNm_QtGui_SH_Menu_Scrollable[];
extern char sipNm_QtGui_SH_RichText_FullWidthSelection[];
extern char sipNm_QtGui_SH_BlinkCursorWhenTextSelected[];
extern char sipNm_QtGui_SH_ScrollBar_StopMouseOverSlider[];
extern char sipNm_QtGui_SH_TitleBar_NoBorder[];
extern char sipNm_QtGui_SH_ComboBox_Popup[];
extern char sipNm_QtGui_SH_Workspace_FillSpaceOnMaximize[];
extern char sipNm_QtGui_SH_Widget_ShareActivation[];
extern char sipNm_QtGui_SH_ItemView_ChangeHighlightOnFocus[];
extern char sipNm_QtGui_SH_MenuBar_MouseTracking[];
extern char sipNm_QtGui_SH_Menu_MouseTracking[];
extern char sipNm_QtGui_SH_ComboBox_ListMouseTracking[];
extern char sipNm_QtGui_SH_MenuBar_AltKeyNavigation[];
extern char sipNm_QtGui_SH_ScrollView_FrameOnlyAroundContents[];
extern char sipNm_QtGui_SH_Menu_SubMenuPopupDelay[];
extern char sipNm_QtGui_SH_Menu_SpaceActivatesItem[];
extern char sipNm_QtGui_SH_Menu_AllowActiveAndDisabled[];
extern char sipNm_QtGui_SH_FontDialog_SelectAssociatedText[];
extern char sipNm_QtGui_SH_MainWindow_SpaceBelowMenuBar[];
extern char sipNm_QtGui_SH_PrintDialog_RightAlignButtons[];
extern char sipNm_QtGui_SH_ProgressDialog_TextLabelAlignment[];
extern char sipNm_QtGui_SH_ProgressDialog_CenterCancelButton[];
extern char sipNm_QtGui_SH_Slider_SloppyKeyEvents[];
extern char sipNm_QtGui_SH_Slider_SnapToValue[];
extern char sipNm_QtGui_SH_Header_ArrowAlignment[];
extern char sipNm_QtGui_SH_TabBar_Alignment[];
extern char sipNm_QtGui_SH_TabBar_SelectMouseType[];
extern char sipNm_QtGui_SH_ScrollBar_ScrollWhenPointerLeavesControl[];
extern char sipNm_QtGui_SH_ScrollBar_MiddleClickAbsolutePosition[];
extern char sipNm_QtGui_SH_DitherDisabledText[];
extern char sipNm_QtGui_SH_EtchDisabledText[];
extern char sipNm_QtGui_sizeFromContents[];
extern char sipNm_QtGui_CT_CustomBase[];
extern char sipNm_QtGui_CT_ItemViewItem[];
extern char sipNm_QtGui_CT_MdiControls[];
extern char sipNm_QtGui_CT_GroupBox[];
extern char sipNm_QtGui_CT_HeaderSection[];
extern char sipNm_QtGui_CT_DialogButtons[];
extern char sipNm_QtGui_CT_TabWidget[];
extern char sipNm_QtGui_CT_SizeGrip[];
extern char sipNm_QtGui_CT_SpinBox[];
extern char sipNm_QtGui_CT_LineEdit[];
extern char sipNm_QtGui_CT_Q3Header[];
extern char sipNm_QtGui_CT_ScrollBar[];
extern char sipNm_QtGui_CT_Slider[];
extern char sipNm_QtGui_CT_TabBarTab[];
extern char sipNm_QtGui_CT_Menu[];
extern char sipNm_QtGui_CT_MenuBar[];
extern char sipNm_QtGui_CT_MenuBarItem[];
extern char sipNm_QtGui_CT_MenuItem[];
extern char sipNm_QtGui_CT_ProgressBar[];
extern char sipNm_QtGui_CT_Q3DockWindow[];
extern char sipNm_QtGui_CT_Splitter[];
extern char sipNm_QtGui_CT_ComboBox[];
extern char sipNm_QtGui_CT_ToolButton[];
extern char sipNm_QtGui_CT_RadioButton[];
extern char sipNm_QtGui_CT_CheckBox[];
extern char sipNm_QtGui_CT_PushButton[];
extern char sipNm_QtGui_pixelMetric[];
extern char sipNm_QtGui_PM_CustomBase[];
extern char sipNm_QtGui_PM_TextCursorWidth[];
extern char sipNm_QtGui_PM_TabBar_ScrollButtonOverlap[];
extern char sipNm_QtGui_PM_LayoutVerticalSpacing[];
extern char sipNm_QtGui_PM_LayoutHorizontalSpacing[];
extern char sipNm_QtGui_PM_LayoutBottomMargin[];
extern char sipNm_QtGui_PM_LayoutRightMargin[];
extern char sipNm_QtGui_PM_LayoutTopMargin[];
extern char sipNm_QtGui_PM_LayoutLeftMargin[];
extern char sipNm_QtGui_PM_RadioButtonLabelSpacing[];
extern char sipNm_QtGui_PM_DockWidgetTitleBarButtonMargin[];
extern char sipNm_QtGui_PM_ButtonIconSize[];
extern char sipNm_QtGui_PM_MessageBoxIconSize[];
extern char sipNm_QtGui_PM_DockWidgetTitleMargin[];
extern char sipNm_QtGui_PM_SizeGripSize[];
extern char sipNm_QtGui_PM_TabBarIconSize[];
extern char sipNm_QtGui_PM_CheckBoxLabelSpacing[];
extern char sipNm_QtGui_PM_ToolTipLabelFrameWidth[];
extern char sipNm_QtGui_PM_FocusFrameHMargin[];
extern char sipNm_QtGui_PM_FocusFrameVMargin[];
extern char sipNm_QtGui_PM_LargeIconSize[];
extern char sipNm_QtGui_PM_SmallIconSize[];
extern char sipNm_QtGui_PM_IconViewIconSize[];
extern char sipNm_QtGui_PM_ListViewIconSize[];
extern char sipNm_QtGui_PM_ToolBarIconSize[];
extern char sipNm_QtGui_PM_DefaultLayoutSpacing[];
extern char sipNm_QtGui_PM_DefaultChildMargin[];
extern char sipNm_QtGui_PM_DefaultTopLevelMargin[];
extern char sipNm_QtGui_PM_SpinBoxSliderHeight[];
extern char sipNm_QtGui_PM_ToolBarExtensionExtent[];
extern char sipNm_QtGui_PM_ToolBarSeparatorExtent[];
extern char sipNm_QtGui_PM_ToolBarItemMargin[];
extern char sipNm_QtGui_PM_ToolBarItemSpacing[];
extern char sipNm_QtGui_PM_ToolBarHandleExtent[];
extern char sipNm_QtGui_PM_ToolBarFrameWidth[];
extern char sipNm_QtGui_PM_TabBarScrollButtonWidth[];
extern char sipNm_QtGui_PM_TabBarTabShiftVertical[];
extern char sipNm_QtGui_PM_TabBarTabShiftHorizontal[];
extern char sipNm_QtGui_PM_HeaderGripMargin[];
extern char sipNm_QtGui_PM_HeaderMarkSize[];
extern char sipNm_QtGui_PM_HeaderMargin[];
extern char sipNm_QtGui_PM_MDIMinimizedWidth[];
extern char sipNm_QtGui_PM_MdiSubWindowMinimizedWidth[];
extern char sipNm_QtGui_PM_MDIFrameWidth[];
extern char sipNm_QtGui_PM_MdiSubWindowFrameWidth[];
extern char sipNm_QtGui_PM_DialogButtonsButtonHeight[];
extern char sipNm_QtGui_PM_DialogButtonsButtonWidth[];
extern char sipNm_QtGui_PM_DialogButtonsSeparator[];
extern char sipNm_QtGui_PM_CheckListControllerSize[];
extern char sipNm_QtGui_PM_CheckListButtonSize[];
extern char sipNm_QtGui_PM_ExclusiveIndicatorHeight[];
extern char sipNm_QtGui_PM_ExclusiveIndicatorWidth[];
extern char sipNm_QtGui_PM_IndicatorHeight[];
extern char sipNm_QtGui_PM_IndicatorWidth[];
extern char sipNm_QtGui_PM_MenuBarHMargin[];
extern char sipNm_QtGui_PM_MenuBarVMargin[];
extern char sipNm_QtGui_PM_MenuBarItemSpacing[];
extern char sipNm_QtGui_PM_MenuBarPanelWidth[];
extern char sipNm_QtGui_PM_MenuDesktopFrameWidth[];
extern char sipNm_QtGui_PM_MenuTearoffHeight[];
extern char sipNm_QtGui_PM_MenuPanelWidth[];
extern char sipNm_QtGui_PM_MenuVMargin[];
extern char sipNm_QtGui_PM_MenuHMargin[];
extern char sipNm_QtGui_PM_MenuScrollerHeight[];
extern char sipNm_QtGui_PM_TitleBarHeight[];
extern char sipNm_QtGui_PM_SplitterWidth[];
extern char sipNm_QtGui_PM_ProgressBarChunkWidth[];
extern char sipNm_QtGui_PM_TabBarBaseOverlap[];
extern char sipNm_QtGui_PM_TabBarBaseHeight[];
extern char sipNm_QtGui_PM_TabBarTabVSpace[];
extern char sipNm_QtGui_PM_TabBarTabHSpace[];
extern char sipNm_QtGui_PM_TabBarTabOverlap[];
extern char sipNm_QtGui_PM_DockWidgetFrameWidth[];
extern char sipNm_QtGui_PM_DockWidgetHandleExtent[];
extern char sipNm_QtGui_PM_DockWidgetSeparatorExtent[];
extern char sipNm_QtGui_PM_SliderSpaceAvailable[];
extern char sipNm_QtGui_PM_SliderTickmarkOffset[];
extern char sipNm_QtGui_PM_SliderLength[];
extern char sipNm_QtGui_PM_SliderControlThickness[];
extern char sipNm_QtGui_PM_SliderThickness[];
extern char sipNm_QtGui_PM_ScrollBarSliderMin[];
extern char sipNm_QtGui_PM_ScrollBarExtent[];
extern char sipNm_QtGui_PM_MaximumDragDistance[];
extern char sipNm_QtGui_PM_ComboBoxFrameWidth[];
extern char sipNm_QtGui_PM_SpinBoxFrameWidth[];
extern char sipNm_QtGui_PM_DefaultFrameWidth[];
extern char sipNm_QtGui_PM_ButtonShiftVertical[];
extern char sipNm_QtGui_PM_ButtonShiftHorizontal[];
extern char sipNm_QtGui_PM_MenuButtonIndicator[];
extern char sipNm_QtGui_PM_ButtonDefaultIndicator[];
extern char sipNm_QtGui_PM_ButtonMargin[];
extern char sipNm_QtGui_subControlRect[];
extern char sipNm_QtGui_hitTestComplexControl[];
extern char sipNm_QtGui_drawComplexControl[];
extern char sipNm_QtGui_SubControls[];
extern char sipNm_QtGui_SC_All[];
extern char sipNm_QtGui_SC_MdiCloseButton[];
extern char sipNm_QtGui_SC_MdiNormalButton[];
extern char sipNm_QtGui_SC_MdiMinButton[];
extern char sipNm_QtGui_SC_GroupBoxFrame[];
extern char sipNm_QtGui_SC_GroupBoxContents[];
extern char sipNm_QtGui_SC_GroupBoxLabel[];
extern char sipNm_QtGui_SC_GroupBoxCheckBox[];
extern char sipNm_QtGui_SC_DialTickmarks[];
extern char sipNm_QtGui_SC_DialHandle[];
extern char sipNm_QtGui_SC_DialGroove[];
extern char sipNm_QtGui_SC_Q3ListViewExpand[];
extern char sipNm_QtGui_SC_Q3ListViewBranch[];
extern char sipNm_QtGui_SC_Q3ListView[];
extern char sipNm_QtGui_SC_TitleBarLabel[];
extern char sipNm_QtGui_SC_TitleBarContextHelpButton[];
extern char sipNm_QtGui_SC_TitleBarUnshadeButton[];
extern char sipNm_QtGui_SC_TitleBarShadeButton[];
extern char sipNm_QtGui_SC_TitleBarNormalButton[];
extern char sipNm_QtGui_SC_TitleBarCloseButton[];
extern char sipNm_QtGui_SC_TitleBarMaxButton[];
extern char sipNm_QtGui_SC_TitleBarMinButton[];
extern char sipNm_QtGui_SC_TitleBarSysMenu[];
extern char sipNm_QtGui_SC_ToolButtonMenu[];
extern char sipNm_QtGui_SC_ToolButton[];
extern char sipNm_QtGui_SC_SliderTickmarks[];
extern char sipNm_QtGui_SC_SliderHandle[];
extern char sipNm_QtGui_SC_SliderGroove[];
extern char sipNm_QtGui_SC_ComboBoxListBoxPopup[];
extern char sipNm_QtGui_SC_ComboBoxArrow[];
extern char sipNm_QtGui_SC_ComboBoxEditField[];
extern char sipNm_QtGui_SC_ComboBoxFrame[];
extern char sipNm_QtGui_SC_SpinBoxEditField[];
extern char sipNm_QtGui_SC_SpinBoxFrame[];
extern char sipNm_QtGui_SC_SpinBoxDown[];
extern char sipNm_QtGui_SC_SpinBoxUp[];
extern char sipNm_QtGui_SC_ScrollBarGroove[];
extern char sipNm_QtGui_SC_ScrollBarSlider[];
extern char sipNm_QtGui_SC_ScrollBarLast[];
extern char sipNm_QtGui_SC_ScrollBarFirst[];
extern char sipNm_QtGui_SC_ScrollBarSubPage[];
extern char sipNm_QtGui_SC_ScrollBarAddPage[];
extern char sipNm_QtGui_SC_ScrollBarSubLine[];
extern char sipNm_QtGui_SC_ScrollBarAddLine[];
extern char sipNm_QtGui_SC_None[];
extern char sipNm_QtGui_SubControl[];
extern char sipNm_QtGui_CC_CustomBase[];
extern char sipNm_QtGui_CC_MdiControls[];
extern char sipNm_QtGui_CC_GroupBox[];
extern char sipNm_QtGui_CC_Dial[];
extern char sipNm_QtGui_CC_Q3ListView[];
extern char sipNm_QtGui_CC_TitleBar[];
extern char sipNm_QtGui_CC_ToolButton[];
extern char sipNm_QtGui_CC_Slider[];
extern char sipNm_QtGui_CC_ScrollBar[];
extern char sipNm_QtGui_CC_ComboBox[];
extern char sipNm_QtGui_CC_SpinBox[];
extern char sipNm_QtGui_subElementRect[];
extern char sipNm_QtGui_SE_CustomBase[];
extern char sipNm_QtGui_SE_ItemViewItemFocusRect[];
extern char sipNm_QtGui_SE_ItemViewItemText[];
extern char sipNm_QtGui_SE_ItemViewItemDecoration[];
extern char sipNm_QtGui_SE_ItemViewItemCheckIndicator[];
extern char sipNm_QtGui_SE_TabWidgetLayoutItem[];
extern char sipNm_QtGui_SE_GroupBoxLayoutItem[];
extern char sipNm_QtGui_SE_FrameLayoutItem[];
extern char sipNm_QtGui_SE_ToolButtonLayoutItem[];
extern char sipNm_QtGui_SE_SpinBoxLayoutItem[];
extern char sipNm_QtGui_SE_SliderLayoutItem[];
extern char sipNm_QtGui_SE_RadioButtonLayoutItem[];
extern char sipNm_QtGui_SE_PushButtonLayoutItem[];
extern char sipNm_QtGui_SE_ProgressBarLayoutItem[];
extern char sipNm_QtGui_SE_LabelLayoutItem[];
extern char sipNm_QtGui_SE_DialogButtonBoxLayoutItem[];
extern char sipNm_QtGui_SE_DateTimeEditLayoutItem[];
extern char sipNm_QtGui_SE_ComboBoxLayoutItem[];
extern char sipNm_QtGui_SE_CheckBoxLayoutItem[];
extern char sipNm_QtGui_SE_DockWidgetIcon[];
extern char sipNm_QtGui_SE_DockWidgetTitleBarText[];
extern char sipNm_QtGui_SE_DockWidgetFloatButton[];
extern char sipNm_QtGui_SE_DockWidgetCloseButton[];
extern char sipNm_QtGui_SE_FrameContents[];
extern char sipNm_QtGui_SE_LineEditContents[];
extern char sipNm_QtGui_SE_TreeViewDisclosureItem[];
extern char sipNm_QtGui_SE_TabBarTearIndicator[];
extern char sipNm_QtGui_SE_ViewItemCheckIndicator[];
extern char sipNm_QtGui_SE_TabWidgetRightCorner[];
extern char sipNm_QtGui_SE_TabWidgetLeftCorner[];
extern char sipNm_QtGui_SE_TabWidgetTabContents[];
extern char sipNm_QtGui_SE_TabWidgetTabPane[];
extern char sipNm_QtGui_SE_TabWidgetTabBar[];
extern char sipNm_QtGui_SE_HeaderArrow[];
extern char sipNm_QtGui_SE_HeaderLabel[];
extern char sipNm_QtGui_SE_ToolBoxTabContents[];
extern char sipNm_QtGui_SE_DialogButtonCustom[];
extern char sipNm_QtGui_SE_DialogButtonRetry[];
extern char sipNm_QtGui_SE_DialogButtonIgnore[];
extern char sipNm_QtGui_SE_DialogButtonAbort[];
extern char sipNm_QtGui_SE_DialogButtonAll[];
extern char sipNm_QtGui_SE_DialogButtonHelp[];
extern char sipNm_QtGui_SE_DialogButtonApply[];
extern char sipNm_QtGui_SE_DialogButtonReject[];
extern char sipNm_QtGui_SE_DialogButtonAccept[];
extern char sipNm_QtGui_SE_ProgressBarLabel[];
extern char sipNm_QtGui_SE_ProgressBarContents[];
extern char sipNm_QtGui_SE_ProgressBarGroove[];
extern char sipNm_QtGui_SE_Q3DockWindowHandleRect[];
extern char sipNm_QtGui_SE_SliderFocusRect[];
extern char sipNm_QtGui_SE_ComboBoxFocusRect[];
extern char sipNm_QtGui_SE_RadioButtonClickRect[];
extern char sipNm_QtGui_SE_RadioButtonFocusRect[];
extern char sipNm_QtGui_SE_RadioButtonContents[];
extern char sipNm_QtGui_SE_RadioButtonIndicator[];
extern char sipNm_QtGui_SE_CheckBoxClickRect[];
extern char sipNm_QtGui_SE_CheckBoxFocusRect[];
extern char sipNm_QtGui_SE_CheckBoxContents[];
extern char sipNm_QtGui_SE_CheckBoxIndicator[];
extern char sipNm_QtGui_SE_PushButtonFocusRect[];
extern char sipNm_QtGui_SE_PushButtonContents[];
extern char sipNm_QtGui_drawControl[];
extern char sipNm_QtGui_CE_CustomBase[];
extern char sipNm_QtGui_CE_ItemViewItem[];
extern char sipNm_QtGui_CE_ColumnViewGrip[];
extern char sipNm_QtGui_CE_HeaderEmptyArea[];
extern char sipNm_QtGui_CE_ToolBoxTabLabel[];
extern char sipNm_QtGui_CE_ToolBoxTabShape[];
extern char sipNm_QtGui_CE_ToolBar[];
extern char sipNm_QtGui_CE_ComboBoxLabel[];
extern char sipNm_QtGui_CE_FocusFrame[];
extern char sipNm_QtGui_CE_ScrollBarLast[];
extern char sipNm_QtGui_CE_ScrollBarFirst[];
extern char sipNm_QtGui_CE_ScrollBarSlider[];
extern char sipNm_QtGui_CE_ScrollBarSubPage[];
extern char sipNm_QtGui_CE_ScrollBarAddPage[];
extern char sipNm_QtGui_CE_ScrollBarSubLine[];
extern char sipNm_QtGui_CE_ScrollBarAddLine[];
extern char sipNm_QtGui_CE_DockWidgetTitle[];
extern char sipNm_QtGui_CE_RubberBand[];
extern char sipNm_QtGui_CE_Splitter[];
extern char sipNm_QtGui_CE_SizeGrip[];
extern char sipNm_QtGui_CE_ToolBoxTab[];
extern char sipNm_QtGui_CE_Q3DockWindowEmptyArea[];
extern char sipNm_QtGui_CE_HeaderLabel[];
extern char sipNm_QtGui_CE_HeaderSection[];
extern char sipNm_QtGui_CE_Header[];
extern char sipNm_QtGui_CE_ToolButtonLabel[];
extern char sipNm_QtGui_CE_MenuBarEmptyArea[];
extern char sipNm_QtGui_CE_MenuBarItem[];
extern char sipNm_QtGui_CE_MenuEmptyArea[];
extern char sipNm_QtGui_CE_MenuTearoff[];
extern char sipNm_QtGui_CE_MenuHMargin[];
extern char sipNm_QtGui_CE_MenuVMargin[];
extern char sipNm_QtGui_CE_MenuScroller[];
extern char sipNm_QtGui_CE_MenuItem[];
extern char sipNm_QtGui_CE_ProgressBarLabel[];
extern char sipNm_QtGui_CE_ProgressBarContents[];
extern char sipNm_QtGui_CE_ProgressBarGroove[];
extern char sipNm_QtGui_CE_ProgressBar[];
extern char sipNm_QtGui_CE_TabBarTabLabel[];
extern char sipNm_QtGui_CE_TabBarTabShape[];
extern char sipNm_QtGui_CE_TabBarTab[];
extern char sipNm_QtGui_CE_RadioButtonLabel[];
extern char sipNm_QtGui_CE_RadioButton[];
extern char sipNm_QtGui_CE_CheckBoxLabel[];
extern char sipNm_QtGui_CE_CheckBox[];
extern char sipNm_QtGui_CE_PushButtonLabel[];
extern char sipNm_QtGui_CE_PushButtonBevel[];
extern char sipNm_QtGui_CE_PushButton[];
extern char sipNm_QtGui_drawPrimitive[];
extern char sipNm_QtGui_PE_CustomBase[];
extern char sipNm_QtGui_PE_PanelStatusBar[];
extern char sipNm_QtGui_PE_PanelItemViewRow[];
extern char sipNm_QtGui_PE_PanelItemViewItem[];
extern char sipNm_QtGui_PE_IndicatorItemViewItemDrop[];
extern char sipNm_QtGui_PE_IndicatorItemViewItemCheck[];
extern char sipNm_QtGui_PE_FrameStatusBarItem[];
extern char sipNm_QtGui_PE_IndicatorColumnViewArrow[];
extern char sipNm_QtGui_PE_Widget[];
extern char sipNm_QtGui_PE_PanelScrollAreaCorner[];
extern char sipNm_QtGui_PE_IndicatorTabTear[];
extern char sipNm_QtGui_PE_PanelTipLabel[];
extern char sipNm_QtGui_PE_IndicatorToolBarSeparator[];
extern char sipNm_QtGui_PE_IndicatorToolBarHandle[];
extern char sipNm_QtGui_PE_IndicatorSpinUp[];
extern char sipNm_QtGui_PE_IndicatorSpinPlus[];
extern char sipNm_QtGui_PE_IndicatorSpinMinus[];
extern char sipNm_QtGui_PE_IndicatorSpinDown[];
extern char sipNm_QtGui_PE_IndicatorRadioButton[];
extern char sipNm_QtGui_PE_IndicatorProgressChunk[];
extern char sipNm_QtGui_PE_IndicatorMenuCheckMark[];
extern char sipNm_QtGui_PE_IndicatorHeaderArrow[];
extern char sipNm_QtGui_PE_IndicatorDockWidgetResizeHandle[];
extern char sipNm_QtGui_PE_IndicatorCheckBox[];
extern char sipNm_QtGui_PE_IndicatorViewItemCheck[];
extern char sipNm_QtGui_PE_IndicatorButtonDropDown[];
extern char sipNm_QtGui_PE_IndicatorBranch[];
extern char sipNm_QtGui_PE_IndicatorArrowUp[];
extern char sipNm_QtGui_PE_IndicatorArrowRight[];
extern char sipNm_QtGui_PE_IndicatorArrowLeft[];
extern char sipNm_QtGui_PE_IndicatorArrowDown[];
extern char sipNm_QtGui_PE_PanelLineEdit[];
extern char sipNm_QtGui_PE_PanelToolBar[];
extern char sipNm_QtGui_PE_PanelMenuBar[];
extern char sipNm_QtGui_PE_PanelButtonTool[];
extern char sipNm_QtGui_PE_PanelButtonBevel[];
extern char sipNm_QtGui_PE_PanelButtonCommand[];
extern char sipNm_QtGui_PE_FrameTabBarBase[];
extern char sipNm_QtGui_PE_FrameButtonTool[];
extern char sipNm_QtGui_PE_FrameButtonBevel[];
extern char sipNm_QtGui_PE_FrameWindow[];
extern char sipNm_QtGui_PE_FrameTabWidget[];
extern char sipNm_QtGui_PE_FrameStatusBar[];
extern char sipNm_QtGui_PE_FrameMenu[];
extern char sipNm_QtGui_PE_FrameLineEdit[];
extern char sipNm_QtGui_PE_FrameGroupBox[];
extern char sipNm_QtGui_PE_FrameFocusRect[];
extern char sipNm_QtGui_PE_FrameDockWidget[];
extern char sipNm_QtGui_PE_FrameDefaultButton[];
extern char sipNm_QtGui_PE_Frame[];
extern char sipNm_QtGui_PE_Q3Separator[];
extern char sipNm_QtGui_PE_Q3DockWindowSeparator[];
extern char sipNm_QtGui_PE_Q3CheckListIndicator[];
extern char sipNm_QtGui_PE_Q3CheckListExclusiveIndicator[];
extern char sipNm_QtGui_PE_Q3CheckListController[];
extern char sipNm_QtGui_State_Mini[];
extern char sipNm_QtGui_State_Small[];
extern char sipNm_QtGui_State_Window[];
extern char sipNm_QtGui_State_ReadOnly[];
extern char sipNm_QtGui_State_KeyboardFocusChange[];
extern char sipNm_QtGui_State_Editing[];
extern char sipNm_QtGui_State_Sibling[];
extern char sipNm_QtGui_State_Item[];
extern char sipNm_QtGui_State_Children[];
extern char sipNm_QtGui_State_Open[];
extern char sipNm_QtGui_State_Active[];
extern char sipNm_QtGui_State_Selected[];
extern char sipNm_QtGui_State_UpArrow[];
extern char sipNm_QtGui_State_MouseOver[];
extern char sipNm_QtGui_State_AutoRaise[];
extern char sipNm_QtGui_State_FocusAtBorder[];
extern char sipNm_QtGui_State_Bottom[];
extern char sipNm_QtGui_State_Top[];
extern char sipNm_QtGui_State_HasFocus[];
extern char sipNm_QtGui_State_Horizontal[];
extern char sipNm_QtGui_State_DownArrow[];
extern char sipNm_QtGui_State_On[];
extern char sipNm_QtGui_State_NoChange[];
extern char sipNm_QtGui_State_Off[];
extern char sipNm_QtGui_State_Sunken[];
extern char sipNm_QtGui_State_Raised[];
extern char sipNm_QtGui_State_Enabled[];
extern char sipNm_QtGui_State_None[];
extern char sipNm_QtGui_StateFlag[];
extern char sipNm_QtGui_standardPalette[];
extern char sipNm_QtGui_drawItemPixmap[];
extern char sipNm_QtGui_drawItemText[];
extern char sipNm_QtGui_itemPixmapRect[];
extern char sipNm_QtGui_itemTextRect[];
extern char sipNm_QtGui_unpolish[];
extern char sipNm_QtGui_polish[];
extern char sipNm_QtGui_QStyle[];
extern char sipNm_QtGui_setStringList[];
extern char sipNm_QtGui_stringList[];
extern char sipNm_QtGui_QStringListModel[];
extern char sipNm_QtGui_hideOrShow[];
extern char sipNm_QtGui_reformat[];
extern char sipNm_QtGui_insertPermanentWidget[];
extern char sipNm_QtGui_currentMessage[];
extern char sipNm_QtGui_addPermanentWidget[];
extern char sipNm_QtGui_QStatusBar[];
extern char sipNm_QtGui_emitDataChanged[];
extern char sipNm_QtGui_appendRows[];
extern char sipNm_QtGui_setAccessibleDescription[];
extern char sipNm_QtGui_setAccessibleText[];
extern char sipNm_QtGui_sortChildren[];
extern char sipNm_QtGui_takeChild[];
extern char sipNm_QtGui_setChild[];
extern char sipNm_QtGui_setDropEnabled[];
extern char sipNm_QtGui_isDropEnabled[];
extern char sipNm_QtGui_isDragEnabled[];
extern char sipNm_QtGui_setSelectable[];
extern char sipNm_QtGui_isSelectable[];
extern char sipNm_QtGui_accessibleDescription[];
extern char sipNm_QtGui_accessibleText[];
extern char sipNm_QtGui_QStandardItem[];
extern char sipNm_QtGui_setItemPrototype[];
extern char sipNm_QtGui_itemPrototype[];
extern char sipNm_QtGui_takeVerticalHeaderItem[];
extern char sipNm_QtGui_takeHorizontalHeaderItem[];
extern char sipNm_QtGui_takeColumn[];
extern char sipNm_QtGui_takeRow[];
extern char sipNm_QtGui_appendColumn[];
extern char sipNm_QtGui_appendRow[];
extern char sipNm_QtGui_setColumnCount[];
extern char sipNm_QtGui_setRowCount[];
extern char sipNm_QtGui_setVerticalHeaderLabels[];
extern char sipNm_QtGui_setHorizontalHeaderLabels[];
extern char sipNm_QtGui_setVerticalHeaderItem[];
extern char sipNm_QtGui_verticalHeaderItem[];
extern char sipNm_QtGui_setHorizontalHeaderItem[];
extern char sipNm_QtGui_horizontalHeaderItem[];
extern char sipNm_QtGui_invisibleRootItem[];
extern char sipNm_QtGui_QStandardItemModel[];
extern char sipNm_QtGui_QStackedWidget[];
extern char sipNm_QtGui_setStackingMode[];
extern char sipNm_QtGui_stackingMode[];
extern char sipNm_QtGui_setCurrentWidget[];
extern char sipNm_QtGui_widgetRemoved[];
extern char sipNm_QtGui_currentWidget[];
extern char sipNm_QtGui_StackAll[];
extern char sipNm_QtGui_StackOne[];
extern char sipNm_QtGui_QStackedLayout[];
extern char sipNm_QtGui_splitter[];
extern char sipNm_QtGui_QSplitterHandle[];
extern char sipNm_QtGui_closestLegalPosition[];
extern char sipNm_QtGui_setRubberBand[];
extern char sipNm_QtGui_moveSplitter[];
extern char sipNm_QtGui_createHandle[];
extern char sipNm_QtGui_splitterMoved[];
extern char sipNm_QtGui_getRange[];
extern char sipNm_QtGui_setHandleWidth[];
extern char sipNm_QtGui_handleWidth[];
extern char sipNm_QtGui_setSizes[];
extern char sipNm_QtGui_sizes[];
extern char sipNm_QtGui_opaqueResize[];
extern char sipNm_QtGui_setOpaqueResize[];
extern char sipNm_QtGui_isCollapsible[];
extern char sipNm_QtGui_setCollapsible[];
extern char sipNm_QtGui_childrenCollapsible[];
extern char sipNm_QtGui_setChildrenCollapsible[];
extern char sipNm_QtGui_QSplitter[];
extern char sipNm_QtGui_drawContents[];
extern char sipNm_QtGui_messageChanged[];
extern char sipNm_QtGui_clearMessage[];
extern char sipNm_QtGui_repaint[];
extern char sipNm_QtGui_finish[];
extern char sipNm_QtGui_QSplashScreen[];
extern char sipNm_QtGui_setDecimals[];
extern char sipNm_QtGui_decimals[];
extern char sipNm_QtGui_QDoubleSpinBox[];
extern char sipNm_QtGui_textFromValue[];
extern char sipNm_QtGui_valueFromText[];
extern char sipNm_QtGui_cleanText[];
extern char sipNm_QtGui_setSuffix[];
extern char sipNm_QtGui_setPrefix[];
extern char sipNm_QtGui_QSpinBox[];
extern char sipNm_QtGui_setLoops[];
extern char sipNm_QtGui_loopsRemaining[];
extern char sipNm_QtGui_loops[];
extern char sipNm_QtGui_isAvailable[];
extern char sipNm_QtGui_QSound[];
extern char sipNm_QtGui_invalidateFilter[];
extern char sipNm_QtGui_setSortLocaleAware[];
extern char sipNm_QtGui_isSortLocaleAware[];
extern char sipNm_QtGui_setFilterRole[];
extern char sipNm_QtGui_filterRole[];
extern char sipNm_QtGui_setSortRole[];
extern char sipNm_QtGui_sortRole[];
extern char sipNm_QtGui_setDynamicSortFilter[];
extern char sipNm_QtGui_dynamicSortFilter[];
extern char sipNm_QtGui_setSortCaseSensitivity[];
extern char sipNm_QtGui_sortCaseSensitivity[];
extern char sipNm_QtGui_lessThan[];
extern char sipNm_QtGui_filterChanged[];
extern char sipNm_QtGui_filterAcceptsColumn[];
extern char sipNm_QtGui_filterAcceptsRow[];
extern char sipNm_QtGui_setFilterFixedString[];
extern char sipNm_QtGui_setFilterWildcard[];
extern char sipNm_QtGui_setFilterCaseSensitivity[];
extern char sipNm_QtGui_filterCaseSensitivity[];
extern char sipNm_QtGui_setFilterKeyColumn[];
extern char sipNm_QtGui_filterKeyColumn[];
extern char sipNm_QtGui_setFilterRegExp[];
extern char sipNm_QtGui_filterRegExp[];
extern char sipNm_QtGui_QSortFilterProxyModel[];
extern char sipNm_QtGui_tickInterval[];
extern char sipNm_QtGui_setTickInterval[];
extern char sipNm_QtGui_tickPosition[];
extern char sipNm_QtGui_setTickPosition[];
extern char sipNm_QtGui_TicksBothSides[];
extern char sipNm_QtGui_TicksRight[];
extern char sipNm_QtGui_TicksBelow[];
extern char sipNm_QtGui_TicksLeft[];
extern char sipNm_QtGui_TicksAbove[];
extern char sipNm_QtGui_NoTicks[];
extern char sipNm_QtGui_QSlider[];
extern char sipNm_QtGui_setControlType[];
extern char sipNm_QtGui_controlType[];
extern char sipNm_QtGui_ControlTypes[];
extern char sipNm_QtGui_ToolButton[];
extern char sipNm_QtGui_TabWidget[];
extern char sipNm_QtGui_SpinBox[];
extern char sipNm_QtGui_Slider[];
extern char sipNm_QtGui_RadioButton[];
extern char sipNm_QtGui_PushButton[];
extern char sipNm_QtGui_LineEdit[];
extern char sipNm_QtGui_Label[];
extern char sipNm_QtGui_GroupBox[];
extern char sipNm_QtGui_Frame[];
extern char sipNm_QtGui_ComboBox[];
extern char sipNm_QtGui_CheckBox[];
extern char sipNm_QtGui_ButtonBox[];
extern char sipNm_QtGui_DefaultType[];
extern char sipNm_QtGui_ControlType[];
extern char sipNm_QtGui_setVerticalStretch[];
extern char sipNm_QtGui_setHorizontalStretch[];
extern char sipNm_QtGui_verticalStretch[];
extern char sipNm_QtGui_horizontalStretch[];
extern char sipNm_QtGui_setHeightForWidth[];
extern char sipNm_QtGui_setVerticalPolicy[];
extern char sipNm_QtGui_setHorizontalPolicy[];
extern char sipNm_QtGui_verticalPolicy[];
extern char sipNm_QtGui_horizontalPolicy[];
extern char sipNm_QtGui_Ignored[];
extern char sipNm_QtGui_Expanding[];
extern char sipNm_QtGui_MinimumExpanding[];
extern char sipNm_QtGui_Preferred[];
extern char sipNm_QtGui_Maximum[];
extern char sipNm_QtGui_Minimum[];
extern char sipNm_QtGui_IgnoreFlag[];
extern char sipNm_QtGui_ShrinkFlag[];
extern char sipNm_QtGui_ExpandFlag[];
extern char sipNm_QtGui_GrowFlag[];
extern char sipNm_QtGui_QSizeGrip[];
extern char sipNm_QtGui_activatedAmbiguously[];
extern char sipNm_QtGui_context[];
extern char sipNm_QtGui_setContext[];
extern char sipNm_QtGui_QShortcut[];
extern char sipNm_QtGui_requestPhase2[];
extern char sipNm_QtGui_isPhase2[];
extern char sipNm_QtGui_setManagerProperty[];
extern char sipNm_QtGui_discardCommand[];
extern char sipNm_QtGui_setDiscardCommand[];
extern char sipNm_QtGui_restartCommand[];
extern char sipNm_QtGui_setRestartCommand[];
extern char sipNm_QtGui_restartHint[];
extern char sipNm_QtGui_setRestartHint[];
extern char sipNm_QtGui_RestartNever[];
extern char sipNm_QtGui_RestartImmediately[];
extern char sipNm_QtGui_RestartAnyway[];
extern char sipNm_QtGui_RestartIfRunning[];
extern char sipNm_QtGui_allowsErrorInteraction[];
extern char sipNm_QtGui_allowsInteraction[];
extern char sipNm_QtGui_QSessionManager[];
extern char sipNm_QtGui_QScrollBar[];
extern char sipNm_QtGui_ensureWidgetVisible[];
extern char sipNm_QtGui_setWidgetResizable[];
extern char sipNm_QtGui_widgetResizable[];
extern char sipNm_QtGui_takeWidget[];
extern char sipNm_QtGui_QScrollArea[];
extern char sipNm_QtGui_QRubberBand[];
extern char sipNm_QtGui_qIsGray[];
extern char sipNm_QtGui_qGray[];
extern char sipNm_QtGui_qRgba[];
extern char sipNm_QtGui_qRgb[];
extern char sipNm_QtGui_qAlpha[];
extern char sipNm_QtGui_qBlue[];
extern char sipNm_QtGui_qGreen[];
extern char sipNm_QtGui_qRed[];
extern char sipNm_QtGui_numRects[];
extern char sipNm_QtGui_xored[];
extern char sipNm_QtGui_rects[];
extern char sipNm_QtGui_eor[];
extern char sipNm_QtGui_subtract[];
extern char sipNm_QtGui_Ellipse[];
extern char sipNm_QtGui_Rectangle[];
extern char sipNm_QtGui_QRadioButton[];
extern char sipNm_QtGui_showMenu[];
extern char sipNm_QtGui_setAutoDefault[];
extern char sipNm_QtGui_autoDefault[];
extern char sipNm_QtGui_QProxyModel[];
extern char sipNm_QtGui_forceShow[];
extern char sipNm_QtGui_canceled[];
extern char sipNm_QtGui_setMinimumDuration[];
extern char sipNm_QtGui_setCancelButtonText[];
extern char sipNm_QtGui_cancel[];
extern char sipNm_QtGui_autoClose[];
extern char sipNm_QtGui_setAutoClose[];
extern char sipNm_QtGui_autoReset[];
extern char sipNm_QtGui_setAutoReset[];
extern char sipNm_QtGui_minimumDuration[];
extern char sipNm_QtGui_wasCanceled[];
extern char sipNm_QtGui_setBar[];
extern char sipNm_QtGui_setCancelButton[];
extern char sipNm_QtGui_setLabel[];
extern char sipNm_QtGui_QProgressDialog[];
extern char sipNm_QtGui_textDirection[];
extern char sipNm_QtGui_setTextDirection[];
extern char sipNm_QtGui_isTextVisible[];
extern char sipNm_QtGui_setTextVisible[];
extern char sipNm_QtGui_QProgressBar[];
extern char sipNm_QtGui_previewChanged[];
extern char sipNm_QtGui_updatePreview[];
extern char sipNm_QtGui_setAllPagesViewMode[];
extern char sipNm_QtGui_setFacingPagesViewMode[];
extern char sipNm_QtGui_setSinglePageViewMode[];
extern char sipNm_QtGui_setPortraitOrientation[];
extern char sipNm_QtGui_setLandscapeOrientation[];
extern char sipNm_QtGui_fitToWidth[];
extern char sipNm_QtGui_setZoomMode[];
extern char sipNm_QtGui_setZoomFactor[];
extern char sipNm_QtGui_zoomOut[];
extern char sipNm_QtGui_zoomIn[];
extern char sipNm_QtGui_numPages[];
extern char sipNm_QtGui_currentPage[];
extern char sipNm_QtGui_zoomMode[];
extern char sipNm_QtGui_zoomFactor[];
extern char sipNm_QtGui_FitInView[];
extern char sipNm_QtGui_FitToWidth[];
extern char sipNm_QtGui_CustomZoom[];
extern char sipNm_QtGui_AllPagesView[];
extern char sipNm_QtGui_FacingPagesView[];
extern char sipNm_QtGui_SinglePageView[];
extern char sipNm_QtGui_QPrintPreviewWidget[];
extern char sipNm_QtGui_paintRequested[];
extern char sipNm_QtGui_QPrintPreviewDialog[];
extern char sipNm_QtGui_defaultPrinter[];
extern char sipNm_QtGui_availablePrinters[];
extern char sipNm_QtGui_supportedPaperSizes[];
extern char sipNm_QtGui_QPrinterInfo[];
extern char sipNm_QtGui_PPK_CustomBase[];
extern char sipNm_QtGui_PPK_PaperSize[];
extern char sipNm_QtGui_PPK_PageMargins[];
extern char sipNm_QtGui_PPK_CustomPaperSize[];
extern char sipNm_QtGui_PPK_PaperSources[];
extern char sipNm_QtGui_PPK_Duplex[];
extern char sipNm_QtGui_PPK_SuppressSystemPrintStatus[];
extern char sipNm_QtGui_PPK_FontEmbedding[];
extern char sipNm_QtGui_PPK_WindowsPageSize[];
extern char sipNm_QtGui_PPK_SupportedResolutions[];
extern char sipNm_QtGui_PPK_SelectionOption[];
extern char sipNm_QtGui_PPK_Resolution[];
extern char sipNm_QtGui_PPK_PrinterProgram[];
extern char sipNm_QtGui_PPK_PrinterName[];
extern char sipNm_QtGui_PPK_PaperSource[];
extern char sipNm_QtGui_PPK_PaperRect[];
extern char sipNm_QtGui_PPK_PageSize[];
extern char sipNm_QtGui_PPK_PageRect[];
extern char sipNm_QtGui_PPK_PageOrder[];
extern char sipNm_QtGui_PPK_OutputFileName[];
extern char sipNm_QtGui_PPK_Orientation[];
extern char sipNm_QtGui_PPK_NumberOfCopies[];
extern char sipNm_QtGui_PPK_FullPage[];
extern char sipNm_QtGui_PPK_DocumentName[];
extern char sipNm_QtGui_PPK_Creator[];
extern char sipNm_QtGui_PPK_ColorMode[];
extern char sipNm_QtGui_PPK_CollateCopies[];
extern char sipNm_QtGui_QPrintEngine[];
extern char sipNm_QtGui_QPrintDialog[];
extern char sipNm_QtGui_setEngines[];
extern char sipNm_QtGui_getPageMargins[];
extern char sipNm_QtGui_setPageMargins[];
extern char sipNm_QtGui_duplex[];
extern char sipNm_QtGui_setDuplex[];
extern char sipNm_QtGui_paperSize[];
extern char sipNm_QtGui_setPaperSize[];
extern char sipNm_QtGui_doubleSidedPrinting[];
extern char sipNm_QtGui_setDoubleSidedPrinting[];
extern char sipNm_QtGui_printEngine[];
extern char sipNm_QtGui_fontEmbeddingEnabled[];
extern char sipNm_QtGui_setFontEmbeddingEnabled[];
extern char sipNm_QtGui_outputFormat[];
extern char sipNm_QtGui_setOutputFormat[];
extern char sipNm_QtGui_printerState[];
extern char sipNm_QtGui_abort[];
extern char sipNm_QtGui_newPage[];
extern char sipNm_QtGui_setPrinterSelectionOption[];
extern char sipNm_QtGui_printerSelectionOption[];
extern char sipNm_QtGui_pageRect[];
extern char sipNm_QtGui_paperRect[];
extern char sipNm_QtGui_supportedResolutions[];
extern char sipNm_QtGui_paperSource[];
extern char sipNm_QtGui_setPaperSource[];
extern char sipNm_QtGui_numCopies[];
extern char sipNm_QtGui_setNumCopies[];
extern char sipNm_QtGui_fullPage[];
extern char sipNm_QtGui_setFullPage[];
extern char sipNm_QtGui_collateCopies[];
extern char sipNm_QtGui_setCollateCopies[];
extern char sipNm_QtGui_colorMode[];
extern char sipNm_QtGui_setColorMode[];
extern char sipNm_QtGui_resolution[];
extern char sipNm_QtGui_setResolution[];
extern char sipNm_QtGui_pageOrder[];
extern char sipNm_QtGui_setPageOrder[];
extern char sipNm_QtGui_pageSize[];
extern char sipNm_QtGui_setPageSize[];
extern char sipNm_QtGui_creator[];
extern char sipNm_QtGui_setCreator[];
extern char sipNm_QtGui_docName[];
extern char sipNm_QtGui_setDocName[];
extern char sipNm_QtGui_printProgram[];
extern char sipNm_QtGui_setPrintProgram[];
extern char sipNm_QtGui_outputFileName[];
extern char sipNm_QtGui_setOutputFileName[];
extern char sipNm_QtGui_printerName[];
extern char sipNm_QtGui_setPrinterName[];
extern char sipNm_QtGui_DevicePixel[];
extern char sipNm_QtGui_Cicero[];
extern char sipNm_QtGui_Didot[];
extern char sipNm_QtGui_Pica[];
extern char sipNm_QtGui_Inch[];
extern char sipNm_QtGui_Millimeter[];
extern char sipNm_QtGui_DuplexShortSide[];
extern char sipNm_QtGui_DuplexLongSide[];
extern char sipNm_QtGui_DuplexAuto[];
extern char sipNm_QtGui_DuplexNone[];
extern char sipNm_QtGui_PostScriptFormat[];
extern char sipNm_QtGui_PdfFormat[];
extern char sipNm_QtGui_Aborted[];
extern char sipNm_QtGui_Idle[];
extern char sipNm_QtGui_MaxPageSource[];
extern char sipNm_QtGui_FormSource[];
extern char sipNm_QtGui_Cassette[];
extern char sipNm_QtGui_LargeCapacity[];
extern char sipNm_QtGui_LargeFormat[];
extern char sipNm_QtGui_SmallFormat[];
extern char sipNm_QtGui_Tractor[];
extern char sipNm_QtGui_Auto[];
extern char sipNm_QtGui_EnvelopeManual[];
extern char sipNm_QtGui_Envelope[];
extern char sipNm_QtGui_Manual[];
extern char sipNm_QtGui_Middle[];
extern char sipNm_QtGui_Lower[];
extern char sipNm_QtGui_OnlyOne[];
extern char sipNm_QtGui_GrayScale[];
extern char sipNm_QtGui_LastPageFirst[];
extern char sipNm_QtGui_FirstPageFirst[];
extern char sipNm_QtGui_Tabloid[];
extern char sipNm_QtGui_Ledger[];
extern char sipNm_QtGui_Folio[];
extern char sipNm_QtGui_DLE[];
extern char sipNm_QtGui_Comm10E[];
extern char sipNm_QtGui_C5E[];
extern char sipNm_QtGui_B9[];
extern char sipNm_QtGui_B8[];
extern char sipNm_QtGui_B7[];
extern char sipNm_QtGui_B6[];
extern char sipNm_QtGui_B4[];
extern char sipNm_QtGui_B3[];
extern char sipNm_QtGui_B2[];
extern char sipNm_QtGui_B10[];
extern char sipNm_QtGui_B1[];
extern char sipNm_QtGui_B0[];
extern char sipNm_QtGui_A9[];
extern char sipNm_QtGui_A8[];
extern char sipNm_QtGui_A7[];
extern char sipNm_QtGui_A6[];
extern char sipNm_QtGui_A5[];
extern char sipNm_QtGui_A3[];
extern char sipNm_QtGui_A2[];
extern char sipNm_QtGui_A1[];
extern char sipNm_QtGui_A0[];
extern char sipNm_QtGui_Executive[];
extern char sipNm_QtGui_Legal[];
extern char sipNm_QtGui_Letter[];
extern char sipNm_QtGui_B5[];
extern char sipNm_QtGui_A4[];
extern char sipNm_QtGui_Landscape[];
extern char sipNm_QtGui_Portrait[];
extern char sipNm_QtGui_HighResolution[];
extern char sipNm_QtGui_PrinterResolution[];
extern char sipNm_QtGui_ScreenResolution[];
extern char sipNm_QtGui_QPrinter[];
extern char sipNm_QtGui_isClosed[];
extern char sipNm_QtGui_toPolygon[];
extern char sipNm_QtGui_QPolygonF[];
extern char sipNm_QtGui_containsPoint[];
extern char sipNm_QtGui_setPoint[];
extern char sipNm_QtGui_putPoints[];
extern char sipNm_QtGui_point[];
extern char sipNm_QtGui_requestUpdate[];
extern char sipNm_QtGui_ensureBlockLayout[];
extern char sipNm_QtGui_QPlainTextDocumentLayout[];
extern char sipNm_QtGui_getPaintContext[];
extern char sipNm_QtGui_blockBoundingGeometry[];
extern char sipNm_QtGui_contentOffset[];
extern char sipNm_QtGui_firstVisibleBlock[];
extern char sipNm_QtGui_insertFromMimeData[];
extern char sipNm_QtGui_canInsertFromMimeData[];
extern char sipNm_QtGui_createMimeDataFromSelection[];
extern char sipNm_QtGui_modificationChanged[];
extern char sipNm_QtGui_blockCountChanged[];
extern char sipNm_QtGui_updateRequest[];
extern char sipNm_QtGui_copyAvailable[];
extern char sipNm_QtGui_redoAvailable[];
extern char sipNm_QtGui_undoAvailable[];
extern char sipNm_QtGui_centerCursor[];
extern char sipNm_QtGui_appendHtml[];
extern char sipNm_QtGui_appendPlainText[];
extern char sipNm_QtGui_insertPlainText[];
extern char sipNm_QtGui_blockCount[];
extern char sipNm_QtGui_print[];
extern char sipNm_QtGui_canPaste[];
extern char sipNm_QtGui_extraSelections[];
extern char sipNm_QtGui_setExtraSelections[];
extern char sipNm_QtGui_setCursorWidth[];
extern char sipNm_QtGui_cursorWidth[];
extern char sipNm_QtGui_setTabStopWidth[];
extern char sipNm_QtGui_tabStopWidth[];
extern char sipNm_QtGui_setOverwriteMode[];
extern char sipNm_QtGui_overwriteMode[];
extern char sipNm_QtGui_cursorForPosition[];
extern char sipNm_QtGui_loadResource[];
extern char sipNm_QtGui_ensureCursorVisible[];
extern char sipNm_QtGui_centerOnScroll[];
extern char sipNm_QtGui_setCenterOnScroll[];
extern char sipNm_QtGui_backgroundVisible[];
extern char sipNm_QtGui_setBackgroundVisible[];
extern char sipNm_QtGui_setWordWrapMode[];
extern char sipNm_QtGui_wordWrapMode[];
extern char sipNm_QtGui_setLineWrapMode[];
extern char sipNm_QtGui_lineWrapMode[];
extern char sipNm_QtGui_maximumBlockCount[];
extern char sipNm_QtGui_setMaximumBlockCount[];
extern char sipNm_QtGui_setUndoRedoEnabled[];
extern char sipNm_QtGui_isUndoRedoEnabled[];
extern char sipNm_QtGui_documentTitle[];
extern char sipNm_QtGui_setDocumentTitle[];
extern char sipNm_QtGui_setTabChangesFocus[];
extern char sipNm_QtGui_tabChangesFocus[];
extern char sipNm_QtGui_currentCharFormat[];
extern char sipNm_QtGui_setCurrentCharFormat[];
extern char sipNm_QtGui_mergeCurrentCharFormat[];
extern char sipNm_QtGui_WidgetWidth[];
extern char sipNm_QtGui_NoWrap[];
extern char sipNm_QtGui_QPlainTextEdit[];
extern char sipNm_QtGui_find[];
extern char sipNm_QtGui_setCacheLimit[];
extern char sipNm_QtGui_cacheLimit[];
extern char sipNm_QtGui_QPixmapCache[];
extern char sipNm_QtGui_x11Info[];
extern char sipNm_QtGui_isQBitmap[];
extern char sipNm_QtGui_x11PictureHandle[];
extern char sipNm_QtGui_toImage[];
extern char sipNm_QtGui_grabWidget[];
extern char sipNm_QtGui_grabWindow[];
extern char sipNm_QtGui_hasAlpha[];
extern char sipNm_QtGui_setMask[];
extern char sipNm_QtGui_defaultDepth[];
extern char sipNm_QtGui_defineIOHandler[];
extern char sipNm_QtGui_setParameters[];
extern char sipNm_QtGui_setIODevice[];
extern char sipNm_QtGui_parameters[];
extern char sipNm_QtGui_ioDevice[];
extern char sipNm_QtGui_QPictureIO[];
extern char sipNm_QtGui_outputFormatList[];
extern char sipNm_QtGui_inputFormatList[];
extern char sipNm_QtGui_outputFormats[];
extern char sipNm_QtGui_inputFormats[];
extern char sipNm_QtGui_pictureFormat[];
extern char sipNm_QtGui_setBoundingRect[];
extern char sipNm_QtGui_play[];
extern char sipNm_QtGui_QPicture[];
extern char sipNm_QtGui_setCosmetic[];
extern char sipNm_QtGui_isCosmetic[];
extern char sipNm_QtGui_isSolid[];
extern char sipNm_QtGui_setWidthF[];
extern char sipNm_QtGui_widthF[];
extern char sipNm_QtGui_isBrushSet[];
extern char sipNm_QtGui_toolTipText[];
extern char sipNm_QtGui_toolTipBase[];
extern char sipNm_QtGui_linkVisited[];
extern char sipNm_QtGui_highlightedText[];
extern char sipNm_QtGui_highlight[];
extern char sipNm_QtGui_shadow[];
extern char sipNm_QtGui_brightText[];
extern char sipNm_QtGui_midlight[];
extern char sipNm_QtGui_alternateBase[];
extern char sipNm_QtGui_base[];
extern char sipNm_QtGui_windowText[];
extern char sipNm_QtGui_isEqual[];
extern char sipNm_QtGui_setColorGroup[];
extern char sipNm_QtGui_setCurrentColorGroup[];
extern char sipNm_QtGui_currentColorGroup[];
extern char sipNm_QtGui_NColorRoles[];
extern char sipNm_QtGui_ToolTipText[];
extern char sipNm_QtGui_ToolTipBase[];
extern char sipNm_QtGui_AlternateBase[];
extern char sipNm_QtGui_LinkVisited[];
extern char sipNm_QtGui_Link[];
extern char sipNm_QtGui_HighlightedText[];
extern char sipNm_QtGui_Highlight[];
extern char sipNm_QtGui_Background[];
extern char sipNm_QtGui_Base[];
extern char sipNm_QtGui_ButtonText[];
extern char sipNm_QtGui_BrightText[];
extern char sipNm_QtGui_Mid[];
extern char sipNm_QtGui_Dark[];
extern char sipNm_QtGui_Midlight[];
extern char sipNm_QtGui_Button[];
extern char sipNm_QtGui_Foreground[];
extern char sipNm_QtGui_WindowText[];
extern char sipNm_QtGui_All[];
extern char sipNm_QtGui_NColorGroups[];
extern char sipNm_QtGui_Inactive[];
extern char sipNm_QtGui_dashOffset[];
extern char sipNm_QtGui_setDashOffset[];
extern char sipNm_QtGui_createStroke[];
extern char sipNm_QtGui_dashPattern[];
extern char sipNm_QtGui_setDashPattern[];
extern char sipNm_QtGui_curveThreshold[];
extern char sipNm_QtGui_setCurveThreshold[];
extern char sipNm_QtGui_miterLimit[];
extern char sipNm_QtGui_setMiterLimit[];
extern char sipNm_QtGui_joinStyle[];
extern char sipNm_QtGui_setJoinStyle[];
extern char sipNm_QtGui_capStyle[];
extern char sipNm_QtGui_setCapStyle[];
extern char sipNm_QtGui_QPainterPathStroker[];
extern char sipNm_QtGui_addRoundedRect[];
extern char sipNm_QtGui_subtractedInverted[];
extern char sipNm_QtGui_subtracted[];
extern char sipNm_QtGui_slopeAtPercent[];
extern char sipNm_QtGui_angleAtPercent[];
extern char sipNm_QtGui_pointAtPercent[];
extern char sipNm_QtGui_percentAtLength[];
extern char sipNm_QtGui_addRoundRect[];
extern char sipNm_QtGui_setElementPositionAt[];
extern char sipNm_QtGui_elementAt[];
extern char sipNm_QtGui_elementCount[];
extern char sipNm_QtGui_arcMoveTo[];
extern char sipNm_QtGui_toFillPolygon[];
extern char sipNm_QtGui_toFillPolygons[];
extern char sipNm_QtGui_toSubpathPolygons[];
extern char sipNm_QtGui_toReversed[];
extern char sipNm_QtGui_controlPointRect[];
extern char sipNm_QtGui_connectPath[];
extern char sipNm_QtGui_addRegion[];
extern char sipNm_QtGui_currentPosition[];
extern char sipNm_QtGui_quadTo[];
extern char sipNm_QtGui_cubicTo[];
extern char sipNm_QtGui_arcTo[];
extern char sipNm_QtGui_lineTo[];
extern char sipNm_QtGui_closeSubpath[];
extern char sipNm_QtGui_isCurveTo[];
extern char sipNm_QtGui_isLineTo[];
extern char sipNm_QtGui_isMoveTo[];
extern char sipNm_QtGui_Element[];
extern char sipNm_QtGui_CurveToDataElement[];
extern char sipNm_QtGui_CurveToElement[];
extern char sipNm_QtGui_LineToElement[];
extern char sipNm_QtGui_MoveToElement[];
extern char sipNm_QtGui_QPainterPath[];
extern char sipNm_QtGui_penNeedsResolving[];
extern char sipNm_QtGui_brushNeedsResolving[];
extern char sipNm_QtGui_isClipEnabled[];
extern char sipNm_QtGui_clipOperation[];
extern char sipNm_QtGui_QPaintEngineState[];
extern char sipNm_QtGui_painter[];
extern char sipNm_QtGui_hasFeature[];
extern char sipNm_QtGui_Pdf[];
extern char sipNm_QtGui_Direct3D[];
extern char sipNm_QtGui_Raster[];
extern char sipNm_QtGui_SVG[];
extern char sipNm_QtGui_Picture[];
extern char sipNm_QtGui_OpenGL[];
extern char sipNm_QtGui_PostScript[];
extern char sipNm_QtGui_QWindowSystem[];
extern char sipNm_QtGui_MacPrinter[];
extern char sipNm_QtGui_CoreGraphics[];
extern char sipNm_QtGui_QuickDraw[];
extern char sipNm_QtGui_Windows[];
extern char sipNm_QtGui_X11[];
extern char sipNm_QtGui_drawTextItem[];
extern char sipNm_QtGui_updateState[];
extern char sipNm_QtGui_setActive[];
extern char sipNm_QtGui_PolylineMode[];
extern char sipNm_QtGui_ConvexMode[];
extern char sipNm_QtGui_WindingMode[];
extern char sipNm_QtGui_OddEvenMode[];
extern char sipNm_QtGui_DirtyFlags[];
extern char sipNm_QtGui_AllDirty[];
extern char sipNm_QtGui_DirtyOpacity[];
extern char sipNm_QtGui_DirtyClipEnabled[];
extern char sipNm_QtGui_DirtyCompositionMode[];
extern char sipNm_QtGui_DirtyHints[];
extern char sipNm_QtGui_DirtyClipPath[];
extern char sipNm_QtGui_DirtyClipRegion[];
extern char sipNm_QtGui_DirtyTransform[];
extern char sipNm_QtGui_DirtyBackgroundMode[];
extern char sipNm_QtGui_DirtyBackground[];
extern char sipNm_QtGui_DirtyFont[];
extern char sipNm_QtGui_DirtyBrushOrigin[];
extern char sipNm_QtGui_DirtyBrush[];
extern char sipNm_QtGui_DirtyPen[];
extern char sipNm_QtGui_PaintEngineFeatures[];
extern char sipNm_QtGui_AllFeatures[];
extern char sipNm_QtGui_ObjectBoundingModeGradients[];
extern char sipNm_QtGui_BlendModes[];
extern char sipNm_QtGui_PerspectiveTransform[];
extern char sipNm_QtGui_PaintOutsidePaintEvent[];
extern char sipNm_QtGui_MaskedBrush[];
extern char sipNm_QtGui_ConstantOpacity[];
extern char sipNm_QtGui_BrushStroke[];
extern char sipNm_QtGui_PainterPaths[];
extern char sipNm_QtGui_PorterDuff[];
extern char sipNm_QtGui_AlphaBlend[];
extern char sipNm_QtGui_ConicalGradientFill[];
extern char sipNm_QtGui_RadialGradientFill[];
extern char sipNm_QtGui_LinearGradientFill[];
extern char sipNm_QtGui_PatternBrush[];
extern char sipNm_QtGui_PixmapTransform[];
extern char sipNm_QtGui_PatternTransform[];
extern char sipNm_QtGui_PrimitiveTransform[];
extern char sipNm_QtGui_PaintEngineFeature[];
extern char sipNm_QtGui_QPaintEngine[];
extern char sipNm_QtGui_renderFlags[];
extern char sipNm_QtGui_RenderFlags[];
extern char sipNm_QtGui_StrikeOut[];
extern char sipNm_QtGui_Overline[];
extern char sipNm_QtGui_RenderFlag[];
extern char sipNm_QtGui_QTextItem[];
extern char sipNm_QtGui_paintingActive[];
extern char sipNm_QtGui_physicalDpiY[];
extern char sipNm_QtGui_physicalDpiX[];
extern char sipNm_QtGui_logicalDpiY[];
extern char sipNm_QtGui_logicalDpiX[];
extern char sipNm_QtGui_heightMM[];
extern char sipNm_QtGui_widthMM[];
extern char sipNm_QtGui_PdmPhysicalDpiY[];
extern char sipNm_QtGui_PdmPhysicalDpiX[];
extern char sipNm_QtGui_PdmDpiY[];
extern char sipNm_QtGui_PdmDpiX[];
extern char sipNm_QtGui_PdmDepth[];
extern char sipNm_QtGui_PdmNumColors[];
extern char sipNm_QtGui_PdmHeightMM[];
extern char sipNm_QtGui_PdmWidthMM[];
extern char sipNm_QtGui_PdmHeight[];
extern char sipNm_QtGui_PdmWidth[];
extern char sipNm_QtGui_drawRoundedRect[];
extern char sipNm_QtGui_testRenderHint[];
extern char sipNm_QtGui_combinedTransform[];
extern char sipNm_QtGui_worldTransform[];
extern char sipNm_QtGui_setWorldTransform[];
extern char sipNm_QtGui_setWorldMatrixEnabled[];
extern char sipNm_QtGui_worldMatrixEnabled[];
extern char sipNm_QtGui_setWorldMatrix[];
extern char sipNm_QtGui_worldMatrix[];
extern char sipNm_QtGui_setOpacity[];
extern char sipNm_QtGui_opacity[];
extern char sipNm_QtGui_combinedMatrix[];
extern char sipNm_QtGui_drawPoint[];
extern char sipNm_QtGui_drawRect[];
extern char sipNm_QtGui_drawLine[];
extern char sipNm_QtGui_restoreRedirected[];
extern char sipNm_QtGui_redirected[];
extern char sipNm_QtGui_setRedirected[];
extern char sipNm_QtGui_eraseRect[];
extern char sipNm_QtGui_fillRect[];
extern char sipNm_QtGui_drawText[];
extern char sipNm_QtGui_drawImage[];
extern char sipNm_QtGui_drawPixmap[];
extern char sipNm_QtGui_drawPicture[];
extern char sipNm_QtGui_drawTiledPixmap[];
extern char sipNm_QtGui_drawRoundRect[];
extern char sipNm_QtGui_drawChord[];
extern char sipNm_QtGui_drawPie[];
extern char sipNm_QtGui_drawArc[];
extern char sipNm_QtGui_drawConvexPolygon[];
extern char sipNm_QtGui_drawPolygon[];
extern char sipNm_QtGui_drawPolyline[];
extern char sipNm_QtGui_drawEllipse[];
extern char sipNm_QtGui_drawRects[];
extern char sipNm_QtGui_drawLines[];
extern char sipNm_QtGui_drawPoints[];
extern char sipNm_QtGui_drawPath[];
extern char sipNm_QtGui_fillPath[];
extern char sipNm_QtGui_strokePath[];
extern char sipNm_QtGui_viewTransformEnabled[];
extern char sipNm_QtGui_setViewTransformEnabled[];
extern char sipNm_QtGui_setWindow[];
extern char sipNm_QtGui_matrixEnabled[];
extern char sipNm_QtGui_setMatrixEnabled[];
extern char sipNm_QtGui_deviceMatrix[];
extern char sipNm_QtGui_restore[];
extern char sipNm_QtGui_setClipPath[];
extern char sipNm_QtGui_setClipRegion[];
extern char sipNm_QtGui_clipPath[];
extern char sipNm_QtGui_clipRegion[];
extern char sipNm_QtGui_setBrushOrigin[];
extern char sipNm_QtGui_brushOrigin[];
extern char sipNm_QtGui_backgroundMode[];
extern char sipNm_QtGui_setBackgroundMode[];
extern char sipNm_QtGui_fontInfo[];
extern char sipNm_QtGui_compositionMode[];
extern char sipNm_QtGui_setCompositionMode[];
extern char sipNm_QtGui_CompositionMode_Exclusion[];
extern char sipNm_QtGui_CompositionMode_Difference[];
extern char sipNm_QtGui_CompositionMode_SoftLight[];
extern char sipNm_QtGui_CompositionMode_HardLight[];
extern char sipNm_QtGui_CompositionMode_ColorBurn[];
extern char sipNm_QtGui_CompositionMode_ColorDodge[];
extern char sipNm_QtGui_CompositionMode_Lighten[];
extern char sipNm_QtGui_CompositionMode_Darken[];
extern char sipNm_QtGui_CompositionMode_Overlay[];
extern char sipNm_QtGui_CompositionMode_Screen[];
extern char sipNm_QtGui_CompositionMode_Multiply[];
extern char sipNm_QtGui_CompositionMode_Plus[];
extern char sipNm_QtGui_CompositionMode_Xor[];
extern char sipNm_QtGui_CompositionMode_DestinationAtop[];
extern char sipNm_QtGui_CompositionMode_SourceAtop[];
extern char sipNm_QtGui_CompositionMode_DestinationOut[];
extern char sipNm_QtGui_CompositionMode_SourceOut[];
extern char sipNm_QtGui_CompositionMode_DestinationIn[];
extern char sipNm_QtGui_CompositionMode_SourceIn[];
extern char sipNm_QtGui_CompositionMode_Destination[];
extern char sipNm_QtGui_CompositionMode_Source[];
extern char sipNm_QtGui_CompositionMode_Clear[];
extern char sipNm_QtGui_CompositionMode_DestinationOver[];
extern char sipNm_QtGui_CompositionMode_SourceOver[];
extern char sipNm_QtGui_initFrom[];
extern char sipNm_QtGui_begin[];
extern char sipNm_QtGui_RenderHints[];
extern char sipNm_QtGui_NonCosmeticDefaultPen[];
extern char sipNm_QtGui_HighQualityAntialiasing[];
extern char sipNm_QtGui_SmoothPixmapTransform[];
extern char sipNm_QtGui_TextAntialiasing[];
extern char sipNm_QtGui_Antialiasing[];
extern char sipNm_QtGui_RenderHint[];
extern char sipNm_QtGui_QPainter[];
extern char sipNm_QtGui_PageSetupDialogOptions[];
extern char sipNm_QtGui_QPageSetupDialog[];
extern char sipNm_QtGui_jumpToNextFrame[];
extern char sipNm_QtGui_updated[];
extern char sipNm_QtGui_speed[];
extern char sipNm_QtGui_setSpeed[];
extern char sipNm_QtGui_currentFrameNumber[];
extern char sipNm_QtGui_nextFrameDelay[];
extern char sipNm_QtGui_frameCount[];
extern char sipNm_QtGui_jumpToFrame[];
extern char sipNm_QtGui_currentPixmap[];
extern char sipNm_QtGui_currentImage[];
extern char sipNm_QtGui_supportedFormats[];
extern char sipNm_QtGui_CacheAll[];
extern char sipNm_QtGui_QMovie[];
extern char sipNm_QtGui_setWindowModality[];
extern char sipNm_QtGui_setDetailedText[];
extern char sipNm_QtGui_detailedText[];
extern char sipNm_QtGui_setInformativeText[];
extern char sipNm_QtGui_informativeText[];
extern char sipNm_QtGui_clickedButton[];
extern char sipNm_QtGui_setEscapeButton[];
extern char sipNm_QtGui_escapeButton[];
extern char sipNm_QtGui_setDefaultButton[];
extern char sipNm_QtGui_defaultButton[];
extern char sipNm_QtGui_standardIcon[];
extern char sipNm_QtGui_about[];
extern char sipNm_QtGui_critical[];
extern char sipNm_QtGui_warning[];
extern char sipNm_QtGui_question[];
extern char sipNm_QtGui_information[];
extern char sipNm_QtGui_setButtonText[];
extern char sipNm_QtGui_buttonText[];
extern char sipNm_QtGui_setIconPixmap[];
extern char sipNm_QtGui_iconPixmap[];
extern char sipNm_QtGui_ButtonMask[];
extern char sipNm_QtGui_FlagMask[];
extern char sipNm_QtGui_Escape[];
extern char sipNm_QtGui_Default[];
extern char sipNm_QtGui_NoAll[];
extern char sipNm_QtGui_YesAll[];
extern char sipNm_QtGui_LastButton[];
extern char sipNm_QtGui_FirstButton[];
extern char sipNm_QtGui_Question[];
extern char sipNm_QtGui_Critical[];
extern char sipNm_QtGui_Warning[];
extern char sipNm_QtGui_Information[];
extern char sipNm_QtGui_NoIcon[];
extern char sipNm_QtGui_QMessageBox[];
extern char sipNm_QtGui_isDefaultUp[];
extern char sipNm_QtGui_setDefaultUp[];
extern char sipNm_QtGui_QMenuBar[];
extern char sipNm_QtGui_setSeparatorsCollapsible[];
extern char sipNm_QtGui_separatorsCollapsible[];
extern char sipNm_QtGui_actionEvent[];
extern char sipNm_QtGui_enterEvent[];
extern char sipNm_QtGui_aboutToShow[];
extern char sipNm_QtGui_aboutToHide[];
extern char sipNm_QtGui_setNoReplayFor[];
extern char sipNm_QtGui_menuAction[];
extern char sipNm_QtGui_actionAt[];
extern char sipNm_QtGui_actionGeometry[];
extern char sipNm_QtGui_activeAction[];
extern char sipNm_QtGui_setActiveAction[];
extern char sipNm_QtGui_defaultAction[];
extern char sipNm_QtGui_setDefaultAction[];
extern char sipNm_QtGui_hideTearOffMenu[];
extern char sipNm_QtGui_isTearOffMenuVisible[];
extern char sipNm_QtGui_isTearOffEnabled[];
extern char sipNm_QtGui_setTearOffEnabled[];
extern char sipNm_QtGui_insertMenu[];
extern char sipNm_QtGui_addSeparator[];
extern char sipNm_QtGui_addMenu[];
extern char sipNm_QtGui_QMenu[];
extern char sipNm_QtGui_leaveEvent[];
extern char sipNm_QtGui_showShaded[];
extern char sipNm_QtGui_showSystemMenu[];
extern char sipNm_QtGui_aboutToActivate[];
extern char sipNm_QtGui_windowStateChanged[];
extern char sipNm_QtGui_mdiArea[];
extern char sipNm_QtGui_systemMenu[];
extern char sipNm_QtGui_setSystemMenu[];
extern char sipNm_QtGui_keyboardPageStep[];
extern char sipNm_QtGui_setKeyboardPageStep[];
extern char sipNm_QtGui_keyboardSingleStep[];
extern char sipNm_QtGui_setKeyboardSingleStep[];
extern char sipNm_QtGui_isShaded[];
extern char sipNm_QtGui_SubWindowOptions[];
extern char sipNm_QtGui_RubberBandMove[];
extern char sipNm_QtGui_RubberBandResize[];
extern char sipNm_QtGui_SubWindowOption[];
extern char sipNm_QtGui_QMdiSubWindow[];
extern char sipNm_QtGui_tabPosition[];
extern char sipNm_QtGui_setTabPosition[];
extern char sipNm_QtGui_tabShape[];
extern char sipNm_QtGui_setTabShape[];
extern char sipNm_QtGui_setActivationOrder[];
extern char sipNm_QtGui_activationOrder[];
extern char sipNm_QtGui_activatePreviousSubWindow[];
extern char sipNm_QtGui_activateNextSubWindow[];
extern char sipNm_QtGui_closeAllSubWindows[];
extern char sipNm_QtGui_closeActiveSubWindow[];
extern char sipNm_QtGui_cascadeSubWindows[];
extern char sipNm_QtGui_tileSubWindows[];
extern char sipNm_QtGui_setActiveSubWindow[];
extern char sipNm_QtGui_subWindowActivated[];
extern char sipNm_QtGui_testOption[];
extern char sipNm_QtGui_removeSubWindow[];
extern char sipNm_QtGui_currentSubWindow[];
extern char sipNm_QtGui_subWindowList[];
extern char sipNm_QtGui_addSubWindow[];
extern char sipNm_QtGui_activeSubWindow[];
extern char sipNm_QtGui_ActivationHistoryOrder[];
extern char sipNm_QtGui_StackingOrder[];
extern char sipNm_QtGui_CreationOrder[];
extern char sipNm_QtGui_TabbedView[];
extern char sipNm_QtGui_SubWindowView[];
extern char sipNm_QtGui_AreaOptions[];
extern char sipNm_QtGui_DontMaximizeSubWindowOnActivation[];
extern char sipNm_QtGui_AreaOption[];
extern char sipNm_QtGui_QMdiArea[];
extern char sipNm_QtGui_isIdentity[];
extern char sipNm_QtGui_inverted[];
extern char sipNm_QtGui_det[];
extern char sipNm_QtGui_isInvertible[];
extern char sipNm_QtGui_mapToPolygon[];
extern char sipNm_QtGui_mapRect[];
extern char sipNm_QtGui_m22[];
extern char sipNm_QtGui_m21[];
extern char sipNm_QtGui_m12[];
extern char sipNm_QtGui_m11[];
extern char sipNm_QtGui_restoreDockWidget[];
extern char sipNm_QtGui_unifiedTitleAndToolBarOnMac[];
extern char sipNm_QtGui_setUnifiedTitleAndToolBarOnMac[];
extern char sipNm_QtGui_toolBarBreak[];
extern char sipNm_QtGui_removeToolBarBreak[];
extern char sipNm_QtGui_dockOptions[];
extern char sipNm_QtGui_setDockOptions[];
extern char sipNm_QtGui_DockOptions[];
extern char sipNm_QtGui_VerticalTabs[];
extern char sipNm_QtGui_ForceTabbedDocks[];
extern char sipNm_QtGui_AllowTabbedDocks[];
extern char sipNm_QtGui_AllowNestedDocks[];
extern char sipNm_QtGui_AnimatedDocks[];
extern char sipNm_QtGui_DockOption[];
extern char sipNm_QtGui_tabifyDockWidget[];
extern char sipNm_QtGui_setMenuWidget[];
extern char sipNm_QtGui_menuWidget[];
extern char sipNm_QtGui_isDockNestingEnabled[];
extern char sipNm_QtGui_isAnimated[];
extern char sipNm_QtGui_toolButtonStyleChanged[];
extern char sipNm_QtGui_iconSizeChanged[];
extern char sipNm_QtGui_setDockNestingEnabled[];
extern char sipNm_QtGui_setAnimated[];
extern char sipNm_QtGui_createPopupMenu[];
extern char sipNm_QtGui_dockWidgetArea[];
extern char sipNm_QtGui_removeDockWidget[];
extern char sipNm_QtGui_splitDockWidget[];
extern char sipNm_QtGui_addDockWidget[];
extern char sipNm_QtGui_toolBarArea[];
extern char sipNm_QtGui_removeToolBar[];
extern char sipNm_QtGui_insertToolBar[];
extern char sipNm_QtGui_addToolBar[];
extern char sipNm_QtGui_insertToolBarBreak[];
extern char sipNm_QtGui_addToolBarBreak[];
extern char sipNm_QtGui_corner[];
extern char sipNm_QtGui_setCorner[];
extern char sipNm_QtGui_setCentralWidget[];
extern char sipNm_QtGui_centralWidget[];
extern char sipNm_QtGui_setStatusBar[];
extern char sipNm_QtGui_statusBar[];
extern char sipNm_QtGui_setToolButtonStyle[];
extern char sipNm_QtGui_toolButtonStyle[];
extern char sipNm_QtGui_QMainWindow[];
extern char sipNm_QtGui_removeItemWidget[];
extern char sipNm_QtGui_isSortingEnabled[];
extern char sipNm_QtGui_setSortingEnabled[];
extern char sipNm_QtGui_itemFromIndex[];
extern char sipNm_QtGui_indexFromItem[];
extern char sipNm_QtGui_itemSelectionChanged[];
extern char sipNm_QtGui_currentTextChanged[];
extern char sipNm_QtGui_currentItemChanged[];
extern char sipNm_QtGui_itemChanged[];
extern char sipNm_QtGui_itemEntered[];
extern char sipNm_QtGui_itemActivated[];
extern char sipNm_QtGui_itemDoubleClicked[];
extern char sipNm_QtGui_itemClicked[];
extern char sipNm_QtGui_itemPressed[];
extern char sipNm_QtGui_scrollToItem[];
extern char sipNm_QtGui_setItemHidden[];
extern char sipNm_QtGui_isItemHidden[];
extern char sipNm_QtGui_findItems[];
extern char sipNm_QtGui_setItemSelected[];
extern char sipNm_QtGui_isItemSelected[];
extern char sipNm_QtGui_editItem[];
extern char sipNm_QtGui_sortItems[];
extern char sipNm_QtGui_visualItemRect[];
extern char sipNm_QtGui_setItemWidget[];
extern char sipNm_QtGui_itemWidget[];
extern char sipNm_QtGui_setCurrentItem[];
extern char sipNm_QtGui_currentItem[];
extern char sipNm_QtGui_takeItem[];
extern char sipNm_QtGui_QListWidget[];
extern char sipNm_QtGui_setHidden[];
extern char sipNm_QtGui_setForeground[];
extern char sipNm_QtGui_foreground[];
extern char sipNm_QtGui_setBackground[];
extern char sipNm_QtGui_background[];
extern char sipNm_QtGui_setSizeHint[];
extern char sipNm_QtGui_setTextColor[];
extern char sipNm_QtGui_textColor[];
extern char sipNm_QtGui_setTextAlignment[];
extern char sipNm_QtGui_textAlignment[];
extern char sipNm_QtGui_listWidget[];
extern char sipNm_QtGui_QListWidgetItem[];
extern char sipNm_QtGui_isSelectionRectVisible[];
extern char sipNm_QtGui_setSelectionRectVisible[];
extern char sipNm_QtGui_batchSize[];
extern char sipNm_QtGui_setBatchSize[];
extern char sipNm_QtGui_setPositionForIndex[];
extern char sipNm_QtGui_rectForIndex[];
extern char sipNm_QtGui_indexesMoved[];
extern char sipNm_QtGui_uniformItemSizes[];
extern char sipNm_QtGui_setUniformItemSizes[];
extern char sipNm_QtGui_setRowHidden[];
extern char sipNm_QtGui_isRowHidden[];
extern char sipNm_QtGui_clearPropertyFlags[];
extern char sipNm_QtGui_gridSize[];
extern char sipNm_QtGui_setGridSize[];
extern char sipNm_QtGui_layoutMode[];
extern char sipNm_QtGui_setLayoutMode[];
extern char sipNm_QtGui_isWrapping[];
extern char sipNm_QtGui_flow[];
extern char sipNm_QtGui_setFlow[];
extern char sipNm_QtGui_movement[];
extern char sipNm_QtGui_setMovement[];
extern char sipNm_QtGui_IconMode[];
extern char sipNm_QtGui_ListMode[];
extern char sipNm_QtGui_Batched[];
extern char sipNm_QtGui_SinglePass[];
extern char sipNm_QtGui_Adjust[];
extern char sipNm_QtGui_Snap[];
extern char sipNm_QtGui_Free[];
extern char sipNm_QtGui_Static[];
extern char sipNm_QtGui_QListView[];
extern char sipNm_QtGui_cursorRect[];
extern char sipNm_QtGui_returnPressed[];
extern char sipNm_QtGui_cursorPositionChanged[];
extern char sipNm_QtGui_textEdited[];
extern char sipNm_QtGui_textChanged[];
extern char sipNm_QtGui_createStandardContextMenu[];
extern char sipNm_QtGui_deselect[];
extern char sipNm_QtGui_paste[];
extern char sipNm_QtGui_cut[];
extern char sipNm_QtGui_redo[];
extern char sipNm_QtGui_undo[];
extern char sipNm_QtGui_setInputMask[];
extern char sipNm_QtGui_inputMask[];
extern char sipNm_QtGui_isRedoAvailable[];
extern char sipNm_QtGui_isUndoAvailable[];
extern char sipNm_QtGui_selectionStart[];
extern char sipNm_QtGui_selectedText[];
extern char sipNm_QtGui_hasSelectedText[];
extern char sipNm_QtGui_setModified[];
extern char sipNm_QtGui_isModified[];
extern char sipNm_QtGui_end[];
extern char sipNm_QtGui_del_[];
extern char sipNm_QtGui_backspace[];
extern char sipNm_QtGui_cursorWordBackward[];
extern char sipNm_QtGui_cursorWordForward[];
extern char sipNm_QtGui_cursorBackward[];
extern char sipNm_QtGui_cursorForward[];
extern char sipNm_QtGui_cursorPositionAt[];
extern char sipNm_QtGui_setCursorPosition[];
extern char sipNm_QtGui_setEchoMode[];
extern char sipNm_QtGui_echoMode[];
extern char sipNm_QtGui_PasswordEchoOnEdit[];
extern char sipNm_QtGui_Password[];
extern char sipNm_QtGui_NoEcho[];
extern char sipNm_QtGui_setMaxLength[];
extern char sipNm_QtGui_maxLength[];
extern char sipNm_QtGui_displayText[];
extern char sipNm_QtGui_QLineEdit[];
extern char sipNm_QtGui_overflow[];
extern char sipNm_QtGui_setSmallDecimalPoint[];
extern char sipNm_QtGui_setBinMode[];
extern char sipNm_QtGui_setOctMode[];
extern char sipNm_QtGui_setDecMode[];
extern char sipNm_QtGui_setHexMode[];
extern char sipNm_QtGui_display[];
extern char sipNm_QtGui_intValue[];
extern char sipNm_QtGui_setSegmentStyle[];
extern char sipNm_QtGui_segmentStyle[];
extern char sipNm_QtGui_setMode[];
extern char sipNm_QtGui_mode[];
extern char sipNm_QtGui_checkOverflow[];
extern char sipNm_QtGui_setNumDigits[];
extern char sipNm_QtGui_numDigits[];
extern char sipNm_QtGui_smallDecimalPoint[];
extern char sipNm_QtGui_Flat[];
extern char sipNm_QtGui_Filled[];
extern char sipNm_QtGui_Outline[];
extern char sipNm_QtGui_Bin[];
extern char sipNm_QtGui_Oct[];
extern char sipNm_QtGui_Dec[];
extern char sipNm_QtGui_Hex[];
extern char sipNm_QtGui_QLCDNumber[];
extern char sipNm_QtGui_QWidgetItem[];
extern char sipNm_QtGui_changeSize[];
extern char sipNm_QtGui_QSpacerItem[];
extern char sipNm_QtGui_controlTypes[];
extern char sipNm_QtGui_spacerItem[];
extern char sipNm_QtGui_alignmentRect[];
extern char sipNm_QtGui_addChildWidget[];
extern char sipNm_QtGui_addChildLayout[];
extern char sipNm_QtGui_closestAcceptableSize[];
extern char sipNm_QtGui_totalSizeHint[];
extern char sipNm_QtGui_totalMaximumSize[];
extern char sipNm_QtGui_totalMinimumSize[];
extern char sipNm_QtGui_totalHeightForWidth[];
extern char sipNm_QtGui_removeWidget[];
extern char sipNm_QtGui_menuBar[];
extern char sipNm_QtGui_setMenuBar[];
extern char sipNm_QtGui_sizeConstraint[];
extern char sipNm_QtGui_setSizeConstraint[];
extern char sipNm_QtGui_SetMinAndMaxSize[];
extern char sipNm_QtGui_SetMaximumSize[];
extern char sipNm_QtGui_SetFixedSize[];
extern char sipNm_QtGui_SetMinimumSize[];
extern char sipNm_QtGui_SetNoConstraint[];
extern char sipNm_QtGui_SetDefaultConstraint[];
extern char sipNm_QtGui_QLayoutItem[];
extern char sipNm_QtGui_setPicture[];
extern char sipNm_QtGui_setMovie[];
extern char sipNm_QtGui_setBuddy[];
extern char sipNm_QtGui_setScaledContents[];
extern char sipNm_QtGui_hasScaledContents[];
extern char sipNm_QtGui_setMargin[];
extern char sipNm_QtGui_margin[];
extern char sipNm_QtGui_setIndent[];
extern char sipNm_QtGui_indent[];
extern char sipNm_QtGui_wordWrap[];
extern char sipNm_QtGui_setWordWrap[];
extern char sipNm_QtGui_setTextFormat[];
extern char sipNm_QtGui_textFormat[];
extern char sipNm_QtGui_movie[];
extern char sipNm_QtGui_picture[];
extern char sipNm_QtGui_QLabel[];
extern char sipNm_QtGui_keyBindings[];
extern char sipNm_QtGui_mnemonic[];
extern char sipNm_QtGui_DeleteEndOfLine[];
extern char sipNm_QtGui_DeleteEndOfWord[];
extern char sipNm_QtGui_DeleteStartOfWord[];
extern char sipNm_QtGui_SelectEndOfDocument[];
extern char sipNm_QtGui_SelectStartOfDocument[];
extern char sipNm_QtGui_SelectEndOfBlock[];
extern char sipNm_QtGui_SelectStartOfBlock[];
extern char sipNm_QtGui_SelectEndOfLine[];
extern char sipNm_QtGui_SelectStartOfLine[];
extern char sipNm_QtGui_SelectPreviousPage[];
extern char sipNm_QtGui_SelectNextPage[];
extern char sipNm_QtGui_SelectPreviousLine[];
extern char sipNm_QtGui_SelectNextLine[];
extern char sipNm_QtGui_SelectPreviousWord[];
extern char sipNm_QtGui_SelectNextWord[];
extern char sipNm_QtGui_SelectPreviousChar[];
extern char sipNm_QtGui_SelectNextChar[];
extern char sipNm_QtGui_MoveToEndOfDocument[];
extern char sipNm_QtGui_MoveToStartOfDocument[];
extern char sipNm_QtGui_MoveToEndOfBlock[];
extern char sipNm_QtGui_MoveToStartOfBlock[];
extern char sipNm_QtGui_MoveToEndOfLine[];
extern char sipNm_QtGui_MoveToStartOfLine[];
extern char sipNm_QtGui_MoveToPreviousPage[];
extern char sipNm_QtGui_MoveToNextPage[];
extern char sipNm_QtGui_MoveToPreviousLine[];
extern char sipNm_QtGui_MoveToNextLine[];
extern char sipNm_QtGui_MoveToPreviousWord[];
extern char sipNm_QtGui_MoveToNextWord[];
extern char sipNm_QtGui_MoveToPreviousChar[];
extern char sipNm_QtGui_MoveToNextChar[];
extern char sipNm_QtGui_Underline[];
extern char sipNm_QtGui_Italic[];
extern char sipNm_QtGui_SelectAll[];
extern char sipNm_QtGui_Replace[];
extern char sipNm_QtGui_FindPrevious[];
extern char sipNm_QtGui_FindNext[];
extern char sipNm_QtGui_Find[];
extern char sipNm_QtGui_PreviousChild[];
extern char sipNm_QtGui_NextChild[];
extern char sipNm_QtGui_AddTab[];
extern char sipNm_QtGui_Print[];
extern char sipNm_QtGui_ZoomOut[];
extern char sipNm_QtGui_ZoomIn[];
extern char sipNm_QtGui_Back[];
extern char sipNm_QtGui_Redo[];
extern char sipNm_QtGui_Undo[];
extern char sipNm_QtGui_Paste[];
extern char sipNm_QtGui_Copy[];
extern char sipNm_QtGui_Cut[];
extern char sipNm_QtGui_Delete[];
extern char sipNm_QtGui_New[];
extern char sipNm_QtGui_HelpContents[];
extern char sipNm_QtGui_UnknownKey[];
extern char sipNm_QtGui_StandardKey[];
extern char sipNm_QtGui_ExactMatch[];
extern char sipNm_QtGui_PartialMatch[];
extern char sipNm_QtGui_NoMatch[];
extern char sipNm_QtGui_PortableText[];
extern char sipNm_QtGui_NativeText[];
extern char sipNm_QtGui_drawFocus[];
extern char sipNm_QtGui_drawDisplay[];
extern char sipNm_QtGui_drawDecoration[];
extern char sipNm_QtGui_drawCheck[];
extern char sipNm_QtGui_setClipping[];
extern char sipNm_QtGui_hasClipping[];
extern char sipNm_QtGui_setItemEditorFactory[];
extern char sipNm_QtGui_itemEditorFactory[];
extern char sipNm_QtGui_QItemDelegate[];
extern char sipNm_QtGui_getItem[];
extern char sipNm_QtGui_getDouble[];
extern char sipNm_QtGui_getInteger[];
extern char sipNm_QtGui_getText[];
extern char sipNm_QtGui_QInputDialog[];
extern char sipNm_QtGui_standardFormat[];
extern char sipNm_QtGui_SelectionFormat[];
extern char sipNm_QtGui_PreeditFormat[];
extern char sipNm_QtGui_filterEvent[];
extern char sipNm_QtGui_widgetDestroyed[];
extern char sipNm_QtGui_setFocusWidget[];
extern char sipNm_QtGui_isComposing[];
extern char sipNm_QtGui_mouseHandler[];
extern char sipNm_QtGui_identifierName[];
extern char sipNm_QtGui_QInputContext[];
extern char sipNm_QtGui_compression[];
extern char sipNm_QtGui_setCompression[];
extern char sipNm_QtGui_canWrite[];
extern char sipNm_QtGui_gamma[];
extern char sipNm_QtGui_setGamma[];
extern char sipNm_QtGui_QImageWriter[];
extern char sipNm_QtGui_quality[];
extern char sipNm_QtGui_setQuality[];
extern char sipNm_QtGui_supportsAnimation[];
extern char sipNm_QtGui_backgroundColor[];
extern char sipNm_QtGui_setBackgroundColor[];
extern char sipNm_QtGui_supportedImageFormats[];
extern char sipNm_QtGui_imageFormat[];
extern char sipNm_QtGui_scaledClipRect[];
extern char sipNm_QtGui_setScaledClipRect[];
extern char sipNm_QtGui_scaledSize[];
extern char sipNm_QtGui_setScaledSize[];
extern char sipNm_QtGui_clipRect[];
extern char sipNm_QtGui_setClipRect[];
extern char sipNm_QtGui_InvalidDataError[];
extern char sipNm_QtGui_UnsupportedFormatError[];
extern char sipNm_QtGui_DeviceError[];
extern char sipNm_QtGui_FileNotFoundError[];
extern char sipNm_QtGui_QImageReader[];
extern char sipNm_QtGui_currentImageRect[];
extern char sipNm_QtGui_currentImageNumber[];
extern char sipNm_QtGui_nextImageDelay[];
extern char sipNm_QtGui_imageCount[];
extern char sipNm_QtGui_jumpToImage[];
extern char sipNm_QtGui_jumpToNextImage[];
extern char sipNm_QtGui_supportsOption[];
extern char sipNm_QtGui_setOption[];
extern char sipNm_QtGui_option[];
extern char sipNm_QtGui_canRead[];
extern char sipNm_QtGui_setFormat[];
extern char sipNm_QtGui_BackgroundColor[];
extern char sipNm_QtGui_Animation[];
extern char sipNm_QtGui_Endianness[];
extern char sipNm_QtGui_IncrementalReading[];
extern char sipNm_QtGui_SubType[];
extern char sipNm_QtGui_Quality[];
extern char sipNm_QtGui_Gamma[];
extern char sipNm_QtGui_CompressionRatio[];
extern char sipNm_QtGui_ScaledSize[];
extern char sipNm_QtGui_ScaledClipRect[];
extern char sipNm_QtGui_Description[];
extern char sipNm_QtGui_ClipRect[];
extern char sipNm_QtGui_QImageIOHandler[];
extern char sipNm_QtGui_createMaskFromColor[];
extern char sipNm_QtGui_metric[];
extern char sipNm_QtGui_textKeys[];
extern char sipNm_QtGui_setDotsPerMeterY[];
extern char sipNm_QtGui_setDotsPerMeterX[];
extern char sipNm_QtGui_dotsPerMeterY[];
extern char sipNm_QtGui_dotsPerMeterX[];
extern char sipNm_QtGui_paintEngine[];
extern char sipNm_QtGui_invertPixels[];
extern char sipNm_QtGui_rgbSwapped[];
extern char sipNm_QtGui_mirrored[];
extern char sipNm_QtGui_trueMatrix[];
extern char sipNm_QtGui_scaledToHeight[];
extern char sipNm_QtGui_scaledToWidth[];
extern char sipNm_QtGui_scaled[];
extern char sipNm_QtGui_createHeuristicMask[];
extern char sipNm_QtGui_createAlphaMask[];
extern char sipNm_QtGui_alphaChannel[];
extern char sipNm_QtGui_setAlphaChannel[];
extern char sipNm_QtGui_hasAlphaChannel[];
extern char sipNm_QtGui_setColorTable[];
extern char sipNm_QtGui_colorTable[];
extern char sipNm_QtGui_setPixel[];
extern char sipNm_QtGui_pixel[];
extern char sipNm_QtGui_pixelIndex[];
extern char sipNm_QtGui_valid[];
extern char sipNm_QtGui_bytesPerLine[];
extern char sipNm_QtGui_scanLine[];
extern char sipNm_QtGui_numBytes[];
extern char sipNm_QtGui_bits[];
extern char sipNm_QtGui_isGrayscale[];
extern char sipNm_QtGui_allGray[];
extern char sipNm_QtGui_setNumColors[];
extern char sipNm_QtGui_numColors[];
extern char sipNm_QtGui_depth[];
extern char sipNm_QtGui_convertToFormat[];
extern char sipNm_QtGui_devType[];
extern char sipNm_QtGui_Format_ARGB4444_Premultiplied[];
extern char sipNm_QtGui_Format_RGB444[];
extern char sipNm_QtGui_Format_RGB888[];
extern char sipNm_QtGui_Format_ARGB8555_Premultiplied[];
extern char sipNm_QtGui_Format_RGB555[];
extern char sipNm_QtGui_Format_ARGB6666_Premultiplied[];
extern char sipNm_QtGui_Format_RGB666[];
extern char sipNm_QtGui_Format_ARGB8565_Premultiplied[];
extern char sipNm_QtGui_Format_RGB16[];
extern char sipNm_QtGui_Format_ARGB32_Premultiplied[];
extern char sipNm_QtGui_Format_ARGB32[];
extern char sipNm_QtGui_Format_RGB32[];
extern char sipNm_QtGui_Format_Indexed8[];
extern char sipNm_QtGui_Format_MonoLSB[];
extern char sipNm_QtGui_Format_Mono[];
extern char sipNm_QtGui_Format_Invalid[];
extern char sipNm_QtGui_InvertRgba[];
extern char sipNm_QtGui_InvertRgb[];
extern char sipNm_QtGui_QPaintDevice[];
extern char sipNm_QtGui_merge[];
extern char sipNm_QtGui_QItemSelection[];
extern char sipNm_QtGui_selectedColumns[];
extern char sipNm_QtGui_selectedRows[];
extern char sipNm_QtGui_hasSelection[];
extern char sipNm_QtGui_emitSelectionChanged[];
extern char sipNm_QtGui_currentColumnChanged[];
extern char sipNm_QtGui_currentRowChanged[];
extern char sipNm_QtGui_select[];
extern char sipNm_QtGui_selection[];
extern char sipNm_QtGui_columnIntersectsSelection[];
extern char sipNm_QtGui_rowIntersectsSelection[];
extern char sipNm_QtGui_isColumnSelected[];
extern char sipNm_QtGui_isRowSelected[];
extern char sipNm_QtGui_SelectionFlags[];
extern char sipNm_QtGui_ClearAndSelect[];
extern char sipNm_QtGui_ToggleCurrent[];
extern char sipNm_QtGui_SelectCurrent[];
extern char sipNm_QtGui_Columns[];
extern char sipNm_QtGui_Rows[];
extern char sipNm_QtGui_Current[];
extern char sipNm_QtGui_Toggle[];
extern char sipNm_QtGui_Deselect[];
extern char sipNm_QtGui_Select[];
extern char sipNm_QtGui_Clear[];
extern char sipNm_QtGui_NoUpdate[];
extern char sipNm_QtGui_SelectionFlag[];
extern char sipNm_QtGui_QItemSelectionModel[];
extern char sipNm_QtGui_indexes[];
extern char sipNm_QtGui_QItemSelectionRange[];
extern char sipNm_QtGui_setDefaultFactory[];
extern char sipNm_QtGui_defaultFactory[];
extern char sipNm_QtGui_registerEditor[];
extern char sipNm_QtGui_QItemEditorFactory[];
extern char sipNm_QtGui_valuePropertyName[];
extern char sipNm_QtGui_createWidget[];
extern char sipNm_QtGui_QItemEditorCreatorBase[];
extern char sipNm_QtGui_clone[];
extern char sipNm_QtGui_QIconEngineV2[];
extern char sipNm_QtGui_QIconEngine[];
extern char sipNm_QtGui_cacheKey[];
extern char sipNm_QtGui_addFile[];
extern char sipNm_QtGui_serialNumber[];
extern char sipNm_QtGui_actualSize[];
extern char sipNm_QtGui_Off[];
extern char sipNm_QtGui_On[];
extern char sipNm_QtGui_Selected[];
extern char sipNm_QtGui_Active[];
extern char sipNm_QtGui_Disabled[];
extern char sipNm_QtGui_sortIndicatorChanged[];
extern char sipNm_QtGui_sectionEntered[];
extern char sipNm_QtGui_setOffsetToLastSection[];
extern char sipNm_QtGui_setMinimumSectionSize[];
extern char sipNm_QtGui_minimumSectionSize[];
extern char sipNm_QtGui_setCascadingSectionResizes[];
extern char sipNm_QtGui_cascadingSectionResizes[];
extern char sipNm_QtGui_swapSections[];
extern char sipNm_QtGui_sectionsHidden[];
extern char sipNm_QtGui_setDefaultAlignment[];
extern char sipNm_QtGui_defaultAlignment[];
extern char sipNm_QtGui_setDefaultSectionSize[];
extern char sipNm_QtGui_defaultSectionSize[];
extern char sipNm_QtGui_hiddenSectionCount[];
extern char sipNm_QtGui_showSection[];
extern char sipNm_QtGui_hideSection[];
extern char sipNm_QtGui_sectionSizeFromContents[];
extern char sipNm_QtGui_paintSection[];
extern char sipNm_QtGui_initializeSections[];
extern char sipNm_QtGui_sectionsAboutToBeRemoved[];
extern char sipNm_QtGui_sectionsInserted[];
extern char sipNm_QtGui_resizeSections[];
extern char sipNm_QtGui_updateSection[];
extern char sipNm_QtGui_sectionAutoResize[];
extern char sipNm_QtGui_sectionHandleDoubleClicked[];
extern char sipNm_QtGui_sectionCountChanged[];
extern char sipNm_QtGui_sectionDoubleClicked[];
extern char sipNm_QtGui_sectionClicked[];
extern char sipNm_QtGui_sectionPressed[];
extern char sipNm_QtGui_sectionResized[];
extern char sipNm_QtGui_sectionMoved[];
extern char sipNm_QtGui_geometriesChanged[];
extern char sipNm_QtGui_setOffsetToSectionPosition[];
extern char sipNm_QtGui_sectionsMoved[];
extern char sipNm_QtGui_setStretchLastSection[];
extern char sipNm_QtGui_stretchLastSection[];
extern char sipNm_QtGui_sortIndicatorOrder[];
extern char sipNm_QtGui_sortIndicatorSection[];
extern char sipNm_QtGui_setSortIndicator[];
extern char sipNm_QtGui_isSortIndicatorShown[];
extern char sipNm_QtGui_setSortIndicatorShown[];
extern char sipNm_QtGui_stretchSectionCount[];
extern char sipNm_QtGui_resizeMode[];
extern char sipNm_QtGui_setResizeMode[];
extern char sipNm_QtGui_highlightSections[];
extern char sipNm_QtGui_setHighlightSections[];
extern char sipNm_QtGui_isClickable[];
extern char sipNm_QtGui_setClickable[];
extern char sipNm_QtGui_isMovable[];
extern char sipNm_QtGui_setMovable[];
extern char sipNm_QtGui_logicalIndex[];
extern char sipNm_QtGui_visualIndex[];
extern char sipNm_QtGui_setSectionHidden[];
extern char sipNm_QtGui_isSectionHidden[];
extern char sipNm_QtGui_resizeSection[];
extern char sipNm_QtGui_moveSection[];
extern char sipNm_QtGui_sectionViewportPosition[];
extern char sipNm_QtGui_sectionPosition[];
extern char sipNm_QtGui_sectionSize[];
extern char sipNm_QtGui_logicalIndexAt[];
extern char sipNm_QtGui_visualIndexAt[];
extern char sipNm_QtGui_sectionSizeHint[];
extern char sipNm_QtGui_Custom[];
extern char sipNm_QtGui_ResizeToContents[];
extern char sipNm_QtGui_Fixed[];
extern char sipNm_QtGui_Interactive[];
extern char sipNm_QtGui_QHeaderView[];
extern char sipNm_QtGui_setFlat[];
extern char sipNm_QtGui_isFlat[];
extern char sipNm_QtGui_setTitle[];
extern char sipNm_QtGui_title[];
extern char sipNm_QtGui_QGroupBox[];
extern char sipNm_QtGui_itemAtPosition[];
extern char sipNm_QtGui_setDefaultPositioning[];
extern char sipNm_QtGui_originCorner[];
extern char sipNm_QtGui_setOriginCorner[];
extern char sipNm_QtGui_cellRect[];
extern char sipNm_QtGui_columnStretch[];
extern char sipNm_QtGui_rowStretch[];
extern char sipNm_QtGui_setColumnStretch[];
extern char sipNm_QtGui_setRowStretch[];
extern char sipNm_QtGui_QGridLayout[];
extern char sipNm_QtGui_ungrabKeyboardEvent[];
extern char sipNm_QtGui_grabKeyboardEvent[];
extern char sipNm_QtGui_polishEvent[];
extern char sipNm_QtGui_moveEvent[];
extern char sipNm_QtGui_windowFrameSectionAt[];
extern char sipNm_QtGui_windowFrameEvent[];
extern char sipNm_QtGui_propertyChange[];
extern char sipNm_QtGui_paintWindowFrame[];
extern char sipNm_QtGui_setTabOrder[];
extern char sipNm_QtGui_setFocusPolicy[];
extern char sipNm_QtGui_focusPolicy[];
extern char sipNm_QtGui_windowTitle[];
extern char sipNm_QtGui_setWindowTitle[];
extern char sipNm_QtGui_isActiveWindow[];
extern char sipNm_QtGui_setWindowFlags[];
extern char sipNm_QtGui_windowType[];
extern char sipNm_QtGui_windowFlags[];
extern char sipNm_QtGui_windowFrameRect[];
extern char sipNm_QtGui_windowFrameGeometry[];
extern char sipNm_QtGui_unsetWindowFrameMargins[];
extern char sipNm_QtGui_getWindowFrameMargins[];
extern char sipNm_QtGui_setWindowFrameMargins[];
extern char sipNm_QtGui_unsetLayoutDirection[];
extern char sipNm_QtGui_layout[];
extern char sipNm_QtGui_viewportTransform[];
extern char sipNm_QtGui_setRubberBandSelectionMode[];
extern char sipNm_QtGui_rubberBandSelectionMode[];
extern char sipNm_QtGui_setOptimizationFlags[];
extern char sipNm_QtGui_setOptimizationFlag[];
extern char sipNm_QtGui_optimizationFlags[];
extern char sipNm_QtGui_setViewportUpdateMode[];
extern char sipNm_QtGui_viewportUpdateMode[];
extern char sipNm_QtGui_OptimizationFlags[];
extern char sipNm_QtGui_DontAdjustForAntialiasing[];
extern char sipNm_QtGui_DontSavePainterState[];
extern char sipNm_QtGui_DontClipPainter[];
extern char sipNm_QtGui_OptimizationFlag[];
extern char sipNm_QtGui_NoViewportUpdate[];
extern char sipNm_QtGui_BoundingRectViewportUpdate[];
extern char sipNm_QtGui_SmartViewportUpdate[];
extern char sipNm_QtGui_MinimalViewportUpdate[];
extern char sipNm_QtGui_FullViewportUpdate[];
extern char sipNm_QtGui_updateSceneRect[];
extern char sipNm_QtGui_updateScene[];
extern char sipNm_QtGui_invalidateScene[];
extern char sipNm_QtGui_fitInView[];
extern char sipNm_QtGui_centerOn[];
extern char sipNm_QtGui_setScene[];
extern char sipNm_QtGui_setInteractive[];
extern char sipNm_QtGui_isInteractive[];
extern char sipNm_QtGui_resetCachedContent[];
extern char sipNm_QtGui_setDragMode[];
extern char sipNm_QtGui_dragMode[];
extern char sipNm_QtGui_setResizeAnchor[];
extern char sipNm_QtGui_resizeAnchor[];
extern char sipNm_QtGui_setTransformationAnchor[];
extern char sipNm_QtGui_transformationAnchor[];
extern char sipNm_QtGui_setRenderHints[];
extern char sipNm_QtGui_setRenderHint[];
extern char sipNm_QtGui_renderHints[];
extern char sipNm_QtGui_AnchorUnderMouse[];
extern char sipNm_QtGui_AnchorViewCenter[];
extern char sipNm_QtGui_NoAnchor[];
extern char sipNm_QtGui_RubberBandDrag[];
extern char sipNm_QtGui_ScrollHandDrag[];
extern char sipNm_QtGui_NoDrag[];
extern char sipNm_QtGui_CacheBackground[];
extern char sipNm_QtGui_CacheNone[];
extern char sipNm_QtGui_CacheModeFlag[];
extern char sipNm_QtGui_QGraphicsView[];
extern char sipNm_QtGui_newPos[];
extern char sipNm_QtGui_QGraphicsSceneMoveEvent[];
extern char sipNm_QtGui_newSize[];
extern char sipNm_QtGui_QGraphicsSceneResizeEvent[];
extern char sipNm_QtGui_QGraphicsSceneDragDropEvent[];
extern char sipNm_QtGui_QGraphicsSceneHelpEvent[];
extern char sipNm_QtGui_QGraphicsSceneHoverEvent[];
extern char sipNm_QtGui_QGraphicsSceneContextMenuEvent[];
extern char sipNm_QtGui_QGraphicsSceneWheelEvent[];
extern char sipNm_QtGui_lastScreenPos[];
extern char sipNm_QtGui_lastScenePos[];
extern char sipNm_QtGui_lastPos[];
extern char sipNm_QtGui_buttonDownScreenPos[];
extern char sipNm_QtGui_buttonDownScenePos[];
extern char sipNm_QtGui_buttonDownPos[];
extern char sipNm_QtGui_screenPos[];
extern char sipNm_QtGui_QGraphicsSceneMouseEvent[];
extern char sipNm_QtGui_QGraphicsSceneEvent[];
extern char sipNm_QtGui_selectionArea[];
extern char sipNm_QtGui_setBspTreeDepth[];
extern char sipNm_QtGui_bspTreeDepth[];
extern char sipNm_QtGui_SceneLayers[];
extern char sipNm_QtGui_AllLayers[];
extern char sipNm_QtGui_ForegroundLayer[];
extern char sipNm_QtGui_BackgroundLayer[];
extern char sipNm_QtGui_ItemLayer[];
extern char sipNm_QtGui_SceneLayer[];
extern char sipNm_QtGui_drawItems[];
extern char sipNm_QtGui_drawForeground[];
extern char sipNm_QtGui_drawBackground[];
extern char sipNm_QtGui_sceneRectChanged[];
extern char sipNm_QtGui_views[];
extern char sipNm_QtGui_setForegroundBrush[];
extern char sipNm_QtGui_foregroundBrush[];
extern char sipNm_QtGui_setBackgroundBrush[];
extern char sipNm_QtGui_backgroundBrush[];
extern char sipNm_QtGui_mouseGrabberItem[];
extern char sipNm_QtGui_setFocusItem[];
extern char sipNm_QtGui_focusItem[];
extern char sipNm_QtGui_addText[];
extern char sipNm_QtGui_addSimpleText[];
extern char sipNm_QtGui_addRect[];
extern char sipNm_QtGui_addPolygon[];
extern char sipNm_QtGui_addPixmap[];
extern char sipNm_QtGui_addLine[];
extern char sipNm_QtGui_addEllipse[];
extern char sipNm_QtGui_destroyItemGroup[];
extern char sipNm_QtGui_createItemGroup[];
extern char sipNm_QtGui_setSelectionArea[];
extern char sipNm_QtGui_selectedItems[];
extern char sipNm_QtGui_items[];
extern char sipNm_QtGui_itemsBoundingRect[];
extern char sipNm_QtGui_setItemIndexMethod[];
extern char sipNm_QtGui_itemIndexMethod[];
extern char sipNm_QtGui_render[];
extern char sipNm_QtGui_setSceneRect[];
extern char sipNm_QtGui_sceneRect[];
extern char sipNm_QtGui_NoIndex[];
extern char sipNm_QtGui_BspTreeIndex[];
extern char sipNm_QtGui_QGraphicsScene[];
extern char sipNm_QtGui_ungrabMouseEvent[];
extern char sipNm_QtGui_grabMouseEvent[];
extern char sipNm_QtGui_subWidgetRect[];
extern char sipNm_QtGui_QGraphicsWidget[];
extern char sipNm_QtGui_QGraphicsProxyWidget[];
extern char sipNm_QtGui_stretchFactor[];
extern char sipNm_QtGui_itemSpacing[];
extern char sipNm_QtGui_setItemSpacing[];
extern char sipNm_QtGui_QGraphicsLinearLayout[];
extern char sipNm_QtGui_maximumHeight[];
extern char sipNm_QtGui_maximumWidth[];
extern char sipNm_QtGui_preferredHeight[];
extern char sipNm_QtGui_preferredWidth[];
extern char sipNm_QtGui_minimumHeight[];
extern char sipNm_QtGui_minimumWidth[];
extern char sipNm_QtGui_isLayout[];
extern char sipNm_QtGui_setParentLayoutItem[];
extern char sipNm_QtGui_parentLayoutItem[];
extern char sipNm_QtGui_updateGeometry[];
extern char sipNm_QtGui_effectiveSizeHint[];
extern char sipNm_QtGui_contentsRect[];
extern char sipNm_QtGui_geometry[];
extern char sipNm_QtGui_setMaximumHeight[];
extern char sipNm_QtGui_setMaximumWidth[];
extern char sipNm_QtGui_setMaximumSize[];
extern char sipNm_QtGui_setPreferredHeight[];
extern char sipNm_QtGui_setPreferredWidth[];
extern char sipNm_QtGui_preferredSize[];
extern char sipNm_QtGui_setPreferredSize[];
extern char sipNm_QtGui_setMinimumHeight[];
extern char sipNm_QtGui_setMinimumWidth[];
extern char sipNm_QtGui_setMinimumSize[];
extern char sipNm_QtGui_sizePolicy[];
extern char sipNm_QtGui_setSizePolicy[];
extern char sipNm_QtGui_widgetEvent[];
extern char sipNm_QtGui_isActivated[];
extern char sipNm_QtGui_getContentsMargins[];
extern char sipNm_QtGui_setContentsMargins[];
extern char sipNm_QtGui_QGraphicsLayoutItem[];
extern char sipNm_QtGui_shearList[];
extern char sipNm_QtGui_scaleList[];
extern char sipNm_QtGui_translationList[];
extern char sipNm_QtGui_rotationList[];
extern char sipNm_QtGui_posList[];
extern char sipNm_QtGui_beforeAnimationStep[];
extern char sipNm_QtGui_afterAnimationStep[];
extern char sipNm_QtGui_setStep[];
extern char sipNm_QtGui_setShearAt[];
extern char sipNm_QtGui_horizontalShearAt[];
extern char sipNm_QtGui_verticalShearAt[];
extern char sipNm_QtGui_setScaleAt[];
extern char sipNm_QtGui_horizontalScaleAt[];
extern char sipNm_QtGui_verticalScaleAt[];
extern char sipNm_QtGui_setTranslationAt[];
extern char sipNm_QtGui_yTranslationAt[];
extern char sipNm_QtGui_xTranslationAt[];
extern char sipNm_QtGui_setRotationAt[];
extern char sipNm_QtGui_rotationAt[];
extern char sipNm_QtGui_matrixAt[];
extern char sipNm_QtGui_setPosAt[];
extern char sipNm_QtGui_posAt[];
extern char sipNm_QtGui_setTimeLine[];
extern char sipNm_QtGui_timeLine[];
extern char sipNm_QtGui_item[];
extern char sipNm_QtGui_QGraphicsItemAnimation[];
extern char sipNm_QtGui_removeFromGroup[];
extern char sipNm_QtGui_addToGroup[];
extern char sipNm_QtGui_QGraphicsItemGroup[];
extern char sipNm_QtGui_QGraphicsSimpleTextItem[];
extern char sipNm_QtGui_linkHovered[];
extern char sipNm_QtGui_linkActivated[];
extern char sipNm_QtGui_textCursor[];
extern char sipNm_QtGui_setTextCursor[];
extern char sipNm_QtGui_openExternalLinks[];
extern char sipNm_QtGui_setOpenExternalLinks[];
extern char sipNm_QtGui_textInteractionFlags[];
extern char sipNm_QtGui_setTextInteractionFlags[];
extern char sipNm_QtGui_setDocument[];
extern char sipNm_QtGui_adjustSize[];
extern char sipNm_QtGui_textWidth[];
extern char sipNm_QtGui_setTextWidth[];
extern char sipNm_QtGui_defaultTextColor[];
extern char sipNm_QtGui_setDefaultTextColor[];
extern char sipNm_QtGui_setPlainText[];
extern char sipNm_QtGui_toPlainText[];
extern char sipNm_QtGui_toHtml[];
extern char sipNm_QtGui_QGraphicsTextItem[];
extern char sipNm_QtGui_setShapeMode[];
extern char sipNm_QtGui_shapeMode[];
extern char sipNm_QtGui_setOffset[];
extern char sipNm_QtGui_offset[];
extern char sipNm_QtGui_setTransformationMode[];
extern char sipNm_QtGui_transformationMode[];
extern char sipNm_QtGui_HeuristicMaskShape[];
extern char sipNm_QtGui_BoundingRectShape[];
extern char sipNm_QtGui_MaskShape[];
extern char sipNm_QtGui_QGraphicsPixmapItem[];
extern char sipNm_QtGui_line[];
extern char sipNm_QtGui_QGraphicsLineItem[];
extern char sipNm_QtGui_setFillRule[];
extern char sipNm_QtGui_fillRule[];
extern char sipNm_QtGui_setPolygon[];
extern char sipNm_QtGui_polygon[];
extern char sipNm_QtGui_QGraphicsPolygonItem[];
extern char sipNm_QtGui_setSpanAngle[];
extern char sipNm_QtGui_spanAngle[];
extern char sipNm_QtGui_setStartAngle[];
extern char sipNm_QtGui_startAngle[];
extern char sipNm_QtGui_QGraphicsEllipseItem[];
extern char sipNm_QtGui_QGraphicsRectItem[];
extern char sipNm_QtGui_QGraphicsPathItem[];
extern char sipNm_QtGui_setBrush[];
extern char sipNm_QtGui_brush[];
extern char sipNm_QtGui_setPen[];
extern char sipNm_QtGui_pen[];
extern char sipNm_QtGui_QAbstractGraphicsShapeItem[];
extern char sipNm_QtGui_isUnderMouse[];
extern char sipNm_QtGui_commonAncestorItem[];
extern char sipNm_QtGui_scroll[];
extern char sipNm_QtGui_setBoundingRegionGranularity[];
extern char sipNm_QtGui_boundingRegionGranularity[];
extern char sipNm_QtGui_boundingRegion[];
extern char sipNm_QtGui_ungrabKeyboard[];
extern char sipNm_QtGui_grabKeyboard[];
extern char sipNm_QtGui_ungrabMouse[];
extern char sipNm_QtGui_grabMouse[];
extern char sipNm_QtGui_setAcceptHoverEvents[];
extern char sipNm_QtGui_acceptHoverEvents[];
extern char sipNm_QtGui_isVisibleTo[];
extern char sipNm_QtGui_setCacheMode[];
extern char sipNm_QtGui_cacheMode[];
extern char sipNm_QtGui_isWindow[];
extern char sipNm_QtGui_isWidget[];
extern char sipNm_QtGui_childItems[];
extern char sipNm_QtGui_window[];
extern char sipNm_QtGui_topLevelWidget[];
extern char sipNm_QtGui_resetTransform[];
extern char sipNm_QtGui_deviceTransform[];
extern char sipNm_QtGui_sceneTransform[];
extern char sipNm_QtGui_sceneEventFilter[];
extern char sipNm_QtGui_sceneEvent[];
extern char sipNm_QtGui_prepareGeometryChange[];
extern char sipNm_QtGui_itemChange[];
extern char sipNm_QtGui_hoverMoveEvent[];
extern char sipNm_QtGui_hoverLeaveEvent[];
extern char sipNm_QtGui_hoverEnterEvent[];
extern char sipNm_QtGui_removeSceneEventFilter[];
extern char sipNm_QtGui_installSceneEventFilter[];
extern char sipNm_QtGui_isAncestorOf[];
extern char sipNm_QtGui_mapFromScene[];
extern char sipNm_QtGui_mapFromParent[];
extern char sipNm_QtGui_mapFromItem[];
extern char sipNm_QtGui_mapToScene[];
extern char sipNm_QtGui_mapToParent[];
extern char sipNm_QtGui_mapToItem[];
extern char sipNm_QtGui_opaqueArea[];
extern char sipNm_QtGui_isObscuredBy[];
extern char sipNm_QtGui_isObscured[];
extern char sipNm_QtGui_collidingItems[];
extern char sipNm_QtGui_collidesWithPath[];
extern char sipNm_QtGui_collidesWithItem[];
extern char sipNm_QtGui_sceneBoundingRect[];
extern char sipNm_QtGui_childrenBoundingRect[];
extern char sipNm_QtGui_setZValue[];
extern char sipNm_QtGui_zValue[];
extern char sipNm_QtGui_advance[];
extern char sipNm_QtGui_shear[];
extern char sipNm_QtGui_rotate[];
extern char sipNm_QtGui_resetMatrix[];
extern char sipNm_QtGui_sceneMatrix[];
extern char sipNm_QtGui_ensureVisible[];
extern char sipNm_QtGui_moveBy[];
extern char sipNm_QtGui_scenePos[];
extern char sipNm_QtGui_clearFocus[];
extern char sipNm_QtGui_setFocus[];
extern char sipNm_QtGui_hasFocus[];
extern char sipNm_QtGui_setHandlesChildEvents[];
extern char sipNm_QtGui_handlesChildEvents[];
extern char sipNm_QtGui_setAcceptsHoverEvents[];
extern char sipNm_QtGui_acceptsHoverEvents[];
extern char sipNm_QtGui_setAcceptedMouseButtons[];
extern char sipNm_QtGui_acceptedMouseButtons[];
extern char sipNm_QtGui_setAcceptDrops[];
extern char sipNm_QtGui_acceptDrops[];
extern char sipNm_QtGui_setSelected[];
extern char sipNm_QtGui_isSelected[];
extern char sipNm_QtGui_show[];
extern char sipNm_QtGui_hide[];
extern char sipNm_QtGui_unsetCursor[];
extern char sipNm_QtGui_hasCursor[];
extern char sipNm_QtGui_setCursor[];
extern char sipNm_QtGui_setFlags[];
extern char sipNm_QtGui_setFlag[];
extern char sipNm_QtGui_setGroup[];
extern char sipNm_QtGui_setParentItem[];
extern char sipNm_QtGui_topLevelItem[];
extern char sipNm_QtGui_parentItem[];
extern char sipNm_QtGui_scene[];
extern char sipNm_QtGui_GraphicsItemFlags[];
extern char sipNm_QtGui_ItemIgnoresTransformations[];
extern char sipNm_QtGui_ItemClipsChildrenToShape[];
extern char sipNm_QtGui_ItemClipsToShape[];
extern char sipNm_QtGui_ItemIsFocusable[];
extern char sipNm_QtGui_ItemIsMovable[];
extern char sipNm_QtGui_GraphicsItemFlag[];
extern char sipNm_QtGui_ItemZValueHasChanged[];
extern char sipNm_QtGui_ItemZValueChange[];
extern char sipNm_QtGui_ItemFlagsHaveChanged[];
extern char sipNm_QtGui_ItemFlagsChange[];
extern char sipNm_QtGui_ItemToolTipHasChanged[];
extern char sipNm_QtGui_ItemToolTipChange[];
extern char sipNm_QtGui_ItemCursorHasChanged[];
extern char sipNm_QtGui_ItemCursorChange[];
extern char sipNm_QtGui_ItemSceneHasChanged[];
extern char sipNm_QtGui_ItemParentHasChanged[];
extern char sipNm_QtGui_ItemSelectedHasChanged[];
extern char sipNm_QtGui_ItemEnabledHasChanged[];
extern char sipNm_QtGui_ItemVisibleHasChanged[];
extern char sipNm_QtGui_ItemSceneChange[];
extern char sipNm_QtGui_ItemTransformHasChanged[];
extern char sipNm_QtGui_ItemPositionHasChanged[];
extern char sipNm_QtGui_ItemTransformChange[];
extern char sipNm_QtGui_ItemChildRemovedChange[];
extern char sipNm_QtGui_ItemChildAddedChange[];
extern char sipNm_QtGui_ItemParentChange[];
extern char sipNm_QtGui_ItemSelectedChange[];
extern char sipNm_QtGui_ItemEnabledChange[];
extern char sipNm_QtGui_ItemVisibleChange[];
extern char sipNm_QtGui_ItemMatrixChange[];
extern char sipNm_QtGui_ItemPositionChange[];
extern char sipNm_QtGui_DeviceCoordinateCache[];
extern char sipNm_QtGui_ItemCoordinateCache[];
extern char sipNm_QtGui_NoCache[];
extern char sipNm_QtGui_CacheMode[];
extern char sipNm_QtGui_QGraphicsItem[];
extern char sipNm_QtGui_columnAlignment[];
extern char sipNm_QtGui_setColumnAlignment[];
extern char sipNm_QtGui_rowAlignment[];
extern char sipNm_QtGui_setRowAlignment[];
extern char sipNm_QtGui_setColumnFixedWidth[];
extern char sipNm_QtGui_columnMaximumWidth[];
extern char sipNm_QtGui_setColumnMaximumWidth[];
extern char sipNm_QtGui_columnPreferredWidth[];
extern char sipNm_QtGui_setColumnPreferredWidth[];
extern char sipNm_QtGui_columnMinimumWidth[];
extern char sipNm_QtGui_setColumnMinimumWidth[];
extern char sipNm_QtGui_setRowFixedHeight[];
extern char sipNm_QtGui_rowMaximumHeight[];
extern char sipNm_QtGui_setRowMaximumHeight[];
extern char sipNm_QtGui_rowPreferredHeight[];
extern char sipNm_QtGui_setRowPreferredHeight[];
extern char sipNm_QtGui_rowMinimumHeight[];
extern char sipNm_QtGui_setRowMinimumHeight[];
extern char sipNm_QtGui_columnStretchFactor[];
extern char sipNm_QtGui_setColumnStretchFactor[];
extern char sipNm_QtGui_rowStretchFactor[];
extern char sipNm_QtGui_setRowStretchFactor[];
extern char sipNm_QtGui_columnSpacing[];
extern char sipNm_QtGui_setColumnSpacing[];
extern char sipNm_QtGui_rowSpacing[];
extern char sipNm_QtGui_setRowSpacing[];
extern char sipNm_QtGui_QGraphicsLayout[];
extern char sipNm_QtGui_QGraphicsGridLayout[];
extern char sipNm_QtGui_drawFrame[];
extern char sipNm_QtGui_setFrameRect[];
extern char sipNm_QtGui_frameRect[];
extern char sipNm_QtGui_setMidLineWidth[];
extern char sipNm_QtGui_midLineWidth[];
extern char sipNm_QtGui_setLineWidth[];
extern char sipNm_QtGui_setFrameShadow[];
extern char sipNm_QtGui_frameShadow[];
extern char sipNm_QtGui_setFrameShape[];
extern char sipNm_QtGui_frameShape[];
extern char sipNm_QtGui_frameWidth[];
extern char sipNm_QtGui_setFrameStyle[];
extern char sipNm_QtGui_frameStyle[];
extern char sipNm_QtGui_Shape_Mask[];
extern char sipNm_QtGui_Shadow_Mask[];
extern char sipNm_QtGui_StyledPanel[];
extern char sipNm_QtGui_VLine[];
extern char sipNm_QtGui_HLine[];
extern char sipNm_QtGui_WinPanel[];
extern char sipNm_QtGui_Panel[];
extern char sipNm_QtGui_Box[];
extern char sipNm_QtGui_NoFrame[];
extern char sipNm_QtGui_Sunken[];
extern char sipNm_QtGui_Raised[];
extern char sipNm_QtGui_Plain[];
extern char sipNm_QtGui_Shadow[];
extern char sipNm_QtGui_labelForField[];
extern char sipNm_QtGui_getLayoutPosition[];
extern char sipNm_QtGui_getWidgetPosition[];
extern char sipNm_QtGui_getItemPosition[];
extern char sipNm_QtGui_setLayout[];
extern char sipNm_QtGui_setItem[];
extern char sipNm_QtGui_addRow[];
extern char sipNm_QtGui_verticalSpacing[];
extern char sipNm_QtGui_setVerticalSpacing[];
extern char sipNm_QtGui_horizontalSpacing[];
extern char sipNm_QtGui_setHorizontalSpacing[];
extern char sipNm_QtGui_formAlignment[];
extern char sipNm_QtGui_setFormAlignment[];
extern char sipNm_QtGui_labelAlignment[];
extern char sipNm_QtGui_setLabelAlignment[];
extern char sipNm_QtGui_rowWrapPolicy[];
extern char sipNm_QtGui_setRowWrapPolicy[];
extern char sipNm_QtGui_fieldGrowthPolicy[];
extern char sipNm_QtGui_setFieldGrowthPolicy[];
extern char sipNm_QtGui_FieldRole[];
extern char sipNm_QtGui_LabelRole[];
extern char sipNm_QtGui_WrapAllRows[];
extern char sipNm_QtGui_WrapLongRows[];
extern char sipNm_QtGui_DontWrapRows[];
extern char sipNm_QtGui_AllNonFixedFieldsGrow[];
extern char sipNm_QtGui_ExpandingFieldsGrow[];
extern char sipNm_QtGui_FieldsStayAtSizeHint[];
extern char sipNm_QtGui_QFormLayout[];
extern char sipNm_QtGui_QFontMetricsF[];
extern char sipNm_QtGui_tightBoundingRect[];
extern char sipNm_QtGui_averageCharWidth[];
extern char sipNm_QtGui_lineWidth[];
extern char sipNm_QtGui_strikeOutPos[];
extern char sipNm_QtGui_overlinePos[];
extern char sipNm_QtGui_underlinePos[];
extern char sipNm_QtGui_boundingRect[];
extern char sipNm_QtGui_charWidth[];
extern char sipNm_QtGui_rightBearing[];
extern char sipNm_QtGui_leftBearing[];
extern char sipNm_QtGui_inFont[];
extern char sipNm_QtGui_xHeight[];
extern char sipNm_QtGui_maxWidth[];
extern char sipNm_QtGui_minRightBearing[];
extern char sipNm_QtGui_minLeftBearing[];
extern char sipNm_QtGui_lineSpacing[];
extern char sipNm_QtGui_leading[];
extern char sipNm_QtGui_descent[];
extern char sipNm_QtGui_ascent[];
extern char sipNm_QtGui_QFontMetrics[];
extern char sipNm_QtGui_QFontInfo[];
extern char sipNm_QtGui_getFont[];
extern char sipNm_QtGui_QFontDialog[];
extern char sipNm_QtGui_supportsThreadedFontRendering[];
extern char sipNm_QtGui_removeAllApplicationFonts[];
extern char sipNm_QtGui_removeApplicationFont[];
extern char sipNm_QtGui_applicationFontFamilies[];
extern char sipNm_QtGui_addApplicationFontFromData[];
extern char sipNm_QtGui_addApplicationFont[];
extern char sipNm_QtGui_writingSystemSample[];
extern char sipNm_QtGui_writingSystemName[];
extern char sipNm_QtGui_isFixedPitch[];
extern char sipNm_QtGui_isScalable[];
extern char sipNm_QtGui_isSmoothlyScalable[];
extern char sipNm_QtGui_isBitmapScalable[];
extern char sipNm_QtGui_styleString[];
extern char sipNm_QtGui_smoothSizes[];
extern char sipNm_QtGui_pointSizes[];
extern char sipNm_QtGui_styles[];
extern char sipNm_QtGui_families[];
extern char sipNm_QtGui_writingSystems[];
extern char sipNm_QtGui_standardSizes[];
extern char sipNm_QtGui_Runic[];
extern char sipNm_QtGui_Ogham[];
extern char sipNm_QtGui_Symbol[];
extern char sipNm_QtGui_TraditionalChinese[];
extern char sipNm_QtGui_SimplifiedChinese[];
extern char sipNm_QtGui_Khmer[];
extern char sipNm_QtGui_Sinhala[];
extern char sipNm_QtGui_Gurmukhi[];
extern char sipNm_QtGui_Devanagari[];
extern char sipNm_QtGui_Thaana[];
extern char sipNm_QtGui_Cyrillic[];
extern char sipNm_QtGui_Any[];
extern char sipNm_QtGui_QFontDatabase[];
extern char sipNm_QtGui_currentFontChanged[];
extern char sipNm_QtGui_setCurrentFont[];
extern char sipNm_QtGui_currentFont[];
extern char sipNm_QtGui_setFontFilters[];
extern char sipNm_QtGui_FontFilters[];
extern char sipNm_QtGui_writingSystem[];
extern char sipNm_QtGui_setWritingSystem[];
extern char sipNm_QtGui_fontFilters[];
extern char sipNm_QtGui_ProportionalFonts[];
extern char sipNm_QtGui_MonospacedFonts[];
extern char sipNm_QtGui_NonScalableFonts[];
extern char sipNm_QtGui_ScalableFonts[];
extern char sipNm_QtGui_AllFonts[];
extern char sipNm_QtGui_FontFilter[];
extern char sipNm_QtGui_QFontComboBox[];
extern char sipNm_QtGui_capitalization[];
extern char sipNm_QtGui_setCapitalization[];
extern char sipNm_QtGui_setWordSpacing[];
extern char sipNm_QtGui_wordSpacing[];
extern char sipNm_QtGui_setLetterSpacing[];
extern char sipNm_QtGui_letterSpacingType[];
extern char sipNm_QtGui_letterSpacing[];
extern char sipNm_QtGui_AbsoluteSpacing[];
extern char sipNm_QtGui_PercentageSpacing[];
extern char sipNm_QtGui_Capitalize[];
extern char sipNm_QtGui_SmallCaps[];
extern char sipNm_QtGui_AllLowercase[];
extern char sipNm_QtGui_AllUppercase[];
extern char sipNm_QtGui_MixedCase[];
extern char sipNm_QtGui_setItalic[];
extern char sipNm_QtGui_italic[];
extern char sipNm_QtGui_setBold[];
extern char sipNm_QtGui_bold[];
extern char sipNm_QtGui_lastResortFont[];
extern char sipNm_QtGui_lastResortFamily[];
extern char sipNm_QtGui_defaultFamily[];
extern char sipNm_QtGui_cacheStatistics[];
extern char sipNm_QtGui_cleanup[];
extern char sipNm_QtGui_initialize[];
extern char sipNm_QtGui_removeSubstitution[];
extern char sipNm_QtGui_insertSubstitutions[];
extern char sipNm_QtGui_insertSubstitution[];
extern char sipNm_QtGui_substitutions[];
extern char sipNm_QtGui_substitutes[];
extern char sipNm_QtGui_substitute[];
extern char sipNm_QtGui_rawName[];
extern char sipNm_QtGui_setRawName[];
extern char sipNm_QtGui_isCopyOf[];
extern char sipNm_QtGui_setRawMode[];
extern char sipNm_QtGui_rawMode[];
extern char sipNm_QtGui_setStretch[];
extern char sipNm_QtGui_stretch[];
extern char sipNm_QtGui_setStyleStrategy[];
extern char sipNm_QtGui_setStyleHint[];
extern char sipNm_QtGui_styleStrategy[];
extern char sipNm_QtGui_styleHint[];
extern char sipNm_QtGui_setKerning[];
extern char sipNm_QtGui_kerning[];
extern char sipNm_QtGui_setFixedPitch[];
extern char sipNm_QtGui_fixedPitch[];
extern char sipNm_QtGui_setStrikeOut[];
extern char sipNm_QtGui_strikeOut[];
extern char sipNm_QtGui_setOverline[];
extern char sipNm_QtGui_overline[];
extern char sipNm_QtGui_setUnderline[];
extern char sipNm_QtGui_underline[];
extern char sipNm_QtGui_setWeight[];
extern char sipNm_QtGui_weight[];
extern char sipNm_QtGui_setPixelSize[];
extern char sipNm_QtGui_pixelSize[];
extern char sipNm_QtGui_setPointSizeF[];
extern char sipNm_QtGui_pointSizeF[];
extern char sipNm_QtGui_setPointSize[];
extern char sipNm_QtGui_pointSize[];
extern char sipNm_QtGui_setFamily[];
extern char sipNm_QtGui_family[];
extern char sipNm_QtGui_UltraExpanded[];
extern char sipNm_QtGui_ExtraExpanded[];
extern char sipNm_QtGui_Expanded[];
extern char sipNm_QtGui_SemiExpanded[];
extern char sipNm_QtGui_Unstretched[];
extern char sipNm_QtGui_SemiCondensed[];
extern char sipNm_QtGui_Condensed[];
extern char sipNm_QtGui_ExtraCondensed[];
extern char sipNm_QtGui_UltraCondensed[];
extern char sipNm_QtGui_Stretch[];
extern char sipNm_QtGui_StyleOblique[];
extern char sipNm_QtGui_StyleItalic[];
extern char sipNm_QtGui_StyleNormal[];
extern char sipNm_QtGui_Black[];
extern char sipNm_QtGui_Bold[];
extern char sipNm_QtGui_DemiBold[];
extern char sipNm_QtGui_Normal[];
extern char sipNm_QtGui_Light[];
extern char sipNm_QtGui_NoFontMerging[];
extern char sipNm_QtGui_OpenGLCompatible[];
extern char sipNm_QtGui_NoAntialias[];
extern char sipNm_QtGui_PreferAntialias[];
extern char sipNm_QtGui_PreferQuality[];
extern char sipNm_QtGui_PreferMatch[];
extern char sipNm_QtGui_ForceOutline[];
extern char sipNm_QtGui_PreferOutline[];
extern char sipNm_QtGui_PreferDevice[];
extern char sipNm_QtGui_PreferBitmap[];
extern char sipNm_QtGui_PreferDefault[];
extern char sipNm_QtGui_AnyStyle[];
extern char sipNm_QtGui_Decorative[];
extern char sipNm_QtGui_OldEnglish[];
extern char sipNm_QtGui_TypeWriter[];
extern char sipNm_QtGui_Courier[];
extern char sipNm_QtGui_Serif[];
extern char sipNm_QtGui_Times[];
extern char sipNm_QtGui_SansSerif[];
extern char sipNm_QtGui_Helvetica[];
extern char sipNm_QtGui_QFocusFrame[];
extern char sipNm_QtGui_rootPathChanged[];
extern char sipNm_QtGui_fileRenamed[];
extern char sipNm_QtGui_nameFilterDisables[];
extern char sipNm_QtGui_setNameFilterDisables[];
extern char sipNm_QtGui_rootDirectory[];
extern char sipNm_QtGui_setRootPath[];
extern char sipNm_QtGui_myComputer[];
extern char sipNm_QtGui_FilePermissions[];
extern char sipNm_QtGui_QFileSystemModel[];
extern char sipNm_QtGui_File[];
extern char sipNm_QtGui_Folder[];
extern char sipNm_QtGui_Drive[];
extern char sipNm_QtGui_Network[];
extern char sipNm_QtGui_Trashcan[];
extern char sipNm_QtGui_Computer[];
extern char sipNm_QtGui_QFileIconProvider[];
extern char sipNm_QtGui_selectedNameFilter[];
extern char sipNm_QtGui_selectNameFilter[];
extern char sipNm_QtGui_setNameFilter[];
extern char sipNm_QtGui_isNameFilterDetailsVisible[];
extern char sipNm_QtGui_setNameFilterDetailsVisible[];
extern char sipNm_QtGui_proxyModel[];
extern char sipNm_QtGui_setProxyModel[];
extern char sipNm_QtGui_restoreState[];
extern char sipNm_QtGui_sidebarUrls[];
extern char sipNm_QtGui_setSidebarUrls[];
extern char sipNm_QtGui_getOpenFileNames[];
extern char sipNm_QtGui_getExistingDirectory[];
extern char sipNm_QtGui_getSaveFileName[];
extern char sipNm_QtGui_getOpenFileName[];
extern char sipNm_QtGui_filterSelected[];
extern char sipNm_QtGui_filesSelected[];
extern char sipNm_QtGui_directoryEntered[];
extern char sipNm_QtGui_labelText[];
extern char sipNm_QtGui_setLabelText[];
extern char sipNm_QtGui_history[];
extern char sipNm_QtGui_setHistory[];
extern char sipNm_QtGui_defaultSuffix[];
extern char sipNm_QtGui_setDefaultSuffix[];
extern char sipNm_QtGui_confirmOverwrite[];
extern char sipNm_QtGui_setConfirmOverwrite[];
extern char sipNm_QtGui_acceptMode[];
extern char sipNm_QtGui_setAcceptMode[];
extern char sipNm_QtGui_fileMode[];
extern char sipNm_QtGui_setFileMode[];
extern char sipNm_QtGui_viewMode[];
extern char sipNm_QtGui_setViewMode[];
extern char sipNm_QtGui_selectedFilter[];
extern char sipNm_QtGui_selectFilter[];
extern char sipNm_QtGui_setFilters[];
extern char sipNm_QtGui_selectedFiles[];
extern char sipNm_QtGui_selectFile[];
extern char sipNm_QtGui_directory[];
extern char sipNm_QtGui_setDirectory[];
extern char sipNm_QtGui_Options[];
extern char sipNm_QtGui_DontUseNativeDialog[];
extern char sipNm_QtGui_DontConfirmOverwrite[];
extern char sipNm_QtGui_DontResolveSymlinks[];
extern char sipNm_QtGui_ShowDirsOnly[];
extern char sipNm_QtGui_Option[];
extern char sipNm_QtGui_Reject[];
extern char sipNm_QtGui_Accept[];
extern char sipNm_QtGui_LookIn[];
extern char sipNm_QtGui_AcceptSave[];
extern char sipNm_QtGui_AcceptOpen[];
extern char sipNm_QtGui_DirectoryOnly[];
extern char sipNm_QtGui_ExistingFiles[];
extern char sipNm_QtGui_Directory[];
extern char sipNm_QtGui_ExistingFile[];
extern char sipNm_QtGui_AnyFile[];
extern char sipNm_QtGui_Detail[];
extern char sipNm_QtGui_QFileDialog[];
extern char sipNm_QtGui_oldState[];
extern char sipNm_QtGui_QWindowStateChangeEvent[];
extern char sipNm_QtGui_shortcutId[];
extern char sipNm_QtGui_isAmbiguous[];
extern char sipNm_QtGui_QShortcutEvent[];
extern char sipNm_QtGui_file[];
extern char sipNm_QtGui_QFileOpenEvent[];
extern char sipNm_QtGui_before[];
extern char sipNm_QtGui_action[];
extern char sipNm_QtGui_QActionEvent[];
extern char sipNm_QtGui_href[];
extern char sipNm_QtGui_QWhatsThisClickedEvent[];
extern char sipNm_QtGui_tip[];
extern char sipNm_QtGui_QStatusTipEvent[];
extern char sipNm_QtGui_QHelpEvent[];
extern char sipNm_QtGui_QDragLeaveEvent[];
extern char sipNm_QtGui_QDragEnterEvent[];
extern char sipNm_QtGui_answerRect[];
extern char sipNm_QtGui_QDragMoveEvent[];
extern char sipNm_QtGui_provides[];
extern char sipNm_QtGui_encodedData[];
extern char sipNm_QtGui_setDropAction[];
extern char sipNm_QtGui_dropAction[];
extern char sipNm_QtGui_acceptProposedAction[];
extern char sipNm_QtGui_proposedAction[];
extern char sipNm_QtGui_possibleActions[];
extern char sipNm_QtGui_QMimeSource[];
extern char sipNm_QtGui_QDropEvent[];
extern char sipNm_QtGui_replacementLength[];
extern char sipNm_QtGui_replacementStart[];
extern char sipNm_QtGui_commitString[];
extern char sipNm_QtGui_preeditString[];
extern char sipNm_QtGui_setCommitString[];
extern char sipNm_QtGui_Attribute[];
extern char sipNm_QtGui_Ruby[];
extern char sipNm_QtGui_QInputMethodEvent[];
extern char sipNm_QtGui_Other[];
extern char sipNm_QtGui_Keyboard[];
extern char sipNm_QtGui_Mouse[];
extern char sipNm_QtGui_QContextMenuEvent[];
extern char sipNm_QtGui_QHideEvent[];
extern char sipNm_QtGui_QShowEvent[];
extern char sipNm_QtGui_QIconDragEvent[];
extern char sipNm_QtGui_QCloseEvent[];
extern char sipNm_QtGui_oldSize[];
extern char sipNm_QtGui_QResizeEvent[];
extern char sipNm_QtGui_QMoveEvent[];
extern char sipNm_QtGui_region[];
extern char sipNm_QtGui_rect[];
extern char sipNm_QtGui_QPaintEvent[];
extern char sipNm_QtGui_reason[];
extern char sipNm_QtGui_lostFocus[];
extern char sipNm_QtGui_gotFocus[];
extern char sipNm_QtGui_QFocusEvent[];
extern char sipNm_QtGui_nativeVirtualKey[];
extern char sipNm_QtGui_nativeScanCode[];
extern char sipNm_QtGui_nativeModifiers[];
extern char sipNm_QtGui_matches[];
extern char sipNm_QtGui_isAutoRepeat[];
extern char sipNm_QtGui_QKeyEvent[];
extern char sipNm_QtGui_yTilt[];
extern char sipNm_QtGui_xTilt[];
extern char sipNm_QtGui_rotation[];
extern char sipNm_QtGui_tangentialPressure[];
extern char sipNm_QtGui_z[];
extern char sipNm_QtGui_pressure[];
extern char sipNm_QtGui_uniqueId[];
extern char sipNm_QtGui_pointerType[];
extern char sipNm_QtGui_hiResGlobalY[];
extern char sipNm_QtGui_hiResGlobalX[];
extern char sipNm_QtGui_hiResGlobalPos[];
extern char sipNm_QtGui_Eraser[];
extern char sipNm_QtGui_UnknownPointer[];
extern char sipNm_QtGui_RotationStylus[];
extern char sipNm_QtGui_XFreeEraser[];
extern char sipNm_QtGui_FourDMouse[];
extern char sipNm_QtGui_Airbrush[];
extern char sipNm_QtGui_Stylus[];
extern char sipNm_QtGui_Puck[];
extern char sipNm_QtGui_NoDevice[];
extern char sipNm_QtGui_QTabletEvent[];
extern char sipNm_QtGui_delta[];
extern char sipNm_QtGui_QWheelEvent[];
extern char sipNm_QtGui_oldPos[];
extern char sipNm_QtGui_QHoverEvent[];
extern char sipNm_QtGui_posF[];
extern char sipNm_QtGui_hasExtendedInfo[];
extern char sipNm_QtGui_globalY[];
extern char sipNm_QtGui_globalX[];
extern char sipNm_QtGui_globalPos[];
extern char sipNm_QtGui_QMouseEvent[];
extern char sipNm_QtGui_modifiers[];
extern char sipNm_QtGui_QInputEvent[];
extern char sipNm_QtGui_showMessage[];
extern char sipNm_QtGui_qtHandler[];
extern char sipNm_QtGui_QErrorMessage[];
extern char sipNm_QtGui_qDrawPlainRect[];
extern char sipNm_QtGui_qDrawWinPanel[];
extern char sipNm_QtGui_qDrawWinButton[];
extern char sipNm_QtGui_qDrawShadePanel[];
extern char sipNm_QtGui_qDrawShadeRect[];
extern char sipNm_QtGui_qDrawShadeLine[];
extern char sipNm_QtGui_targetChanged[];
extern char sipNm_QtGui_actionChanged[];
extern char sipNm_QtGui_setDragCursor[];
extern char sipNm_QtGui_target[];
extern char sipNm_QtGui_source[];
extern char sipNm_QtGui_setHotSpot[];
extern char sipNm_QtGui_QDrag[];
extern char sipNm_QtGui_visibilityChanged[];
extern char sipNm_QtGui_dockLocationChanged[];
extern char sipNm_QtGui_allowedAreasChanged[];
extern char sipNm_QtGui_topLevelChanged[];
extern char sipNm_QtGui_featuresChanged[];
extern char sipNm_QtGui_titleBarWidget[];
extern char sipNm_QtGui_setTitleBarWidget[];
extern char sipNm_QtGui_toggleViewAction[];
extern char sipNm_QtGui_isAreaAllowed[];
extern char sipNm_QtGui_allowedAreas[];
extern char sipNm_QtGui_setAllowedAreas[];
extern char sipNm_QtGui_isFloating[];
extern char sipNm_QtGui_setFloating[];
extern char sipNm_QtGui_features[];
extern char sipNm_QtGui_setFeatures[];
extern char sipNm_QtGui_DockWidgetFeatures[];
extern char sipNm_QtGui_NoDockWidgetFeatures[];
extern char sipNm_QtGui_AllDockWidgetFeatures[];
extern char sipNm_QtGui_DockWidgetVerticalTitleBar[];
extern char sipNm_QtGui_DockWidgetFloatable[];
extern char sipNm_QtGui_DockWidgetMovable[];
extern char sipNm_QtGui_DockWidgetClosable[];
extern char sipNm_QtGui_DockWidgetFeature[];
extern char sipNm_QtGui_QDockWidget[];
extern char sipNm_QtGui_fileIcon[];
extern char sipNm_QtGui_lazyChildCount[];
extern char sipNm_QtGui_setLazyChildCount[];
extern char sipNm_QtGui_resolveSymlinks[];
extern char sipNm_QtGui_setResolveSymlinks[];
extern char sipNm_QtGui_iconProvider[];
extern char sipNm_QtGui_setIconProvider[];
extern char sipNm_QtGui_FileNameRole[];
extern char sipNm_QtGui_FilePathRole[];
extern char sipNm_QtGui_FileIconRole[];
extern char sipNm_QtGui_QDirModel[];
extern char sipNm_QtGui_helpRequested[];
extern char sipNm_QtGui_centerButtons[];
extern char sipNm_QtGui_setCenterButtons[];
extern char sipNm_QtGui_standardButton[];
extern char sipNm_QtGui_standardButtons[];
extern char sipNm_QtGui_setStandardButtons[];
extern char sipNm_QtGui_buttonRole[];
extern char sipNm_QtGui_StandardButtons[];
extern char sipNm_QtGui_RestoreDefaults[];
extern char sipNm_QtGui_Reset[];
extern char sipNm_QtGui_Apply[];
extern char sipNm_QtGui_Help[];
extern char sipNm_QtGui_Discard[];
extern char sipNm_QtGui_Cancel[];
extern char sipNm_QtGui_Ignore[];
extern char sipNm_QtGui_Retry[];
extern char sipNm_QtGui_Abort[];
extern char sipNm_QtGui_NoToAll[];
extern char sipNm_QtGui_No[];
extern char sipNm_QtGui_YesToAll[];
extern char sipNm_QtGui_Yes[];
extern char sipNm_QtGui_SaveAll[];
extern char sipNm_QtGui_Save[];
extern char sipNm_QtGui_StandardButton[];
extern char sipNm_QtGui_ApplyRole[];
extern char sipNm_QtGui_ResetRole[];
extern char sipNm_QtGui_YesRole[];
extern char sipNm_QtGui_HelpRole[];
extern char sipNm_QtGui_ActionRole[];
extern char sipNm_QtGui_DestructiveRole[];
extern char sipNm_QtGui_RejectRole[];
extern char sipNm_QtGui_AcceptRole[];
extern char sipNm_QtGui_InvalidRole[];
extern char sipNm_QtGui_GnomeLayout[];
extern char sipNm_QtGui_KdeLayout[];
extern char sipNm_QtGui_MacLayout[];
extern char sipNm_QtGui_WinLayout[];
extern char sipNm_QtGui_QDialogButtonBox[];
extern char sipNm_QtGui_rejected[];
extern char sipNm_QtGui_accepted[];
extern char sipNm_QtGui_showExtension[];
extern char sipNm_QtGui_reject[];
extern char sipNm_QtGui_done[];
extern char sipNm_QtGui_setResult[];
extern char sipNm_QtGui_setModal[];
extern char sipNm_QtGui_isSizeGripEnabled[];
extern char sipNm_QtGui_setSizeGripEnabled[];
extern char sipNm_QtGui_extension[];
extern char sipNm_QtGui_setExtension[];
extern char sipNm_QtGui_Accepted[];
extern char sipNm_QtGui_Rejected[];
extern char sipNm_QtGui_setNotchesVisible[];
extern char sipNm_QtGui_notchesVisible[];
extern char sipNm_QtGui_notchTarget[];
extern char sipNm_QtGui_setNotchTarget[];
extern char sipNm_QtGui_notchSize[];
extern char sipNm_QtGui_QDial[];
extern char sipNm_QtGui_workAreaResized[];
extern char sipNm_QtGui_resized[];
extern char sipNm_QtGui_availableGeometry[];
extern char sipNm_QtGui_screenGeometry[];
extern char sipNm_QtGui_screen[];
extern char sipNm_QtGui_screenNumber[];
extern char sipNm_QtGui_primaryScreen[];
extern char sipNm_QtGui_numScreens[];
extern char sipNm_QtGui_isVirtualDesktop[];
extern char sipNm_QtGui_QDesktopWidget[];
extern char sipNm_QtGui_displayName[];
extern char sipNm_QtGui_storageLocation[];
extern char sipNm_QtGui_unsetUrlHandler[];
extern char sipNm_QtGui_setUrlHandler[];
extern char sipNm_QtGui_openUrl[];
extern char sipNm_QtGui_DataLocation[];
extern char sipNm_QtGui_HomeLocation[];
extern char sipNm_QtGui_TempLocation[];
extern char sipNm_QtGui_PicturesLocation[];
extern char sipNm_QtGui_MoviesLocation[];
extern char sipNm_QtGui_MusicLocation[];
extern char sipNm_QtGui_ApplicationsLocation[];
extern char sipNm_QtGui_FontsLocation[];
extern char sipNm_QtGui_DocumentsLocation[];
extern char sipNm_QtGui_DesktopLocation[];
extern char sipNm_QtGui_QDesktopServices[];
extern char sipNm_QtGui_QDateEdit[];
extern char sipNm_QtGui_QTimeEdit[];
extern char sipNm_QtGui_setCalendarWidget[];
extern char sipNm_QtGui_calendarWidget[];
extern char sipNm_QtGui_setDateTimeRange[];
extern char sipNm_QtGui_setMaximumDateTime[];
extern char sipNm_QtGui_clearMaximumDateTime[];
extern char sipNm_QtGui_maximumDateTime[];
extern char sipNm_QtGui_setMinimumDateTime[];
extern char sipNm_QtGui_clearMinimumDateTime[];
extern char sipNm_QtGui_minimumDateTime[];
extern char sipNm_QtGui_textFromDateTime[];
extern char sipNm_QtGui_dateTimeFromText[];
extern char sipNm_QtGui_setDateTime[];
extern char sipNm_QtGui_dateChanged[];
extern char sipNm_QtGui_timeChanged[];
extern char sipNm_QtGui_dateTimeChanged[];
extern char sipNm_QtGui_sectionCount[];
extern char sipNm_QtGui_setCurrentSectionIndex[];
extern char sipNm_QtGui_currentSectionIndex[];
extern char sipNm_QtGui_sectionAt[];
extern char sipNm_QtGui_setSelectedSection[];
extern char sipNm_QtGui_setCalendarPopup[];
extern char sipNm_QtGui_calendarPopup[];
extern char sipNm_QtGui_setDisplayFormat[];
extern char sipNm_QtGui_displayFormat[];
extern char sipNm_QtGui_sectionText[];
extern char sipNm_QtGui_setCurrentSection[];
extern char sipNm_QtGui_currentSection[];
extern char sipNm_QtGui_displayedSections[];
extern char sipNm_QtGui_setTimeRange[];
extern char sipNm_QtGui_clearMaximumTime[];
extern char sipNm_QtGui_setMaximumTime[];
extern char sipNm_QtGui_maximumTime[];
extern char sipNm_QtGui_clearMinimumTime[];
extern char sipNm_QtGui_setMinimumTime[];
extern char sipNm_QtGui_minimumTime[];
extern char sipNm_QtGui_clearMaximumDate[];
extern char sipNm_QtGui_clearMinimumDate[];
extern char sipNm_QtGui_dateTime[];
extern char sipNm_QtGui_Sections[];
extern char sipNm_QtGui_DateSections_Mask[];
extern char sipNm_QtGui_TimeSections_Mask[];
extern char sipNm_QtGui_YearSection[];
extern char sipNm_QtGui_MonthSection[];
extern char sipNm_QtGui_DaySection[];
extern char sipNm_QtGui_HourSection[];
extern char sipNm_QtGui_MinuteSection[];
extern char sipNm_QtGui_SecondSection[];
extern char sipNm_QtGui_MSecSection[];
extern char sipNm_QtGui_AmPmSection[];
extern char sipNm_QtGui_Section[];
extern char sipNm_QtGui_QDateTimeEdit[];
extern char sipNm_QtGui_toPrevious[];
extern char sipNm_QtGui_toNext[];
extern char sipNm_QtGui_toLast[];
extern char sipNm_QtGui_toFirst[];
extern char sipNm_QtGui_setCurrentModelIndex[];
extern char sipNm_QtGui_clearMapping[];
extern char sipNm_QtGui_mappedWidgetAt[];
extern char sipNm_QtGui_mappedSection[];
extern char sipNm_QtGui_mappedPropertyName[];
extern char sipNm_QtGui_removeMapping[];
extern char sipNm_QtGui_addMapping[];
extern char sipNm_QtGui_submitPolicy[];
extern char sipNm_QtGui_setSubmitPolicy[];
extern char sipNm_QtGui_ManualSubmit[];
extern char sipNm_QtGui_AutoSubmit[];
extern char sipNm_QtGui_QDataWidgetMapper[];
extern char sipNm_QtGui_setPos[];
extern char sipNm_QtGui_hotSpot[];
extern char sipNm_QtGui_mask[];
extern char sipNm_QtGui_bitmap[];
extern char sipNm_QtGui_setShape[];
extern char sipNm_QtGui_shape[];
extern char sipNm_QtGui_setWrapAround[];
extern char sipNm_QtGui_setCompletionPrefix[];
extern char sipNm_QtGui_complete[];
extern char sipNm_QtGui_wrapAround[];
extern char sipNm_QtGui_splitPath[];
extern char sipNm_QtGui_pathFromIndex[];
extern char sipNm_QtGui_completionPrefix[];
extern char sipNm_QtGui_completionModel[];
extern char sipNm_QtGui_currentCompletion[];
extern char sipNm_QtGui_currentRow[];
extern char sipNm_QtGui_setCurrentRow[];
extern char sipNm_QtGui_completionCount[];
extern char sipNm_QtGui_completionRole[];
extern char sipNm_QtGui_setCompletionRole[];
extern char sipNm_QtGui_completionColumn[];
extern char sipNm_QtGui_setCompletionColumn[];
extern char sipNm_QtGui_modelSorting[];
extern char sipNm_QtGui_setModelSorting[];
extern char sipNm_QtGui_setPopup[];
extern char sipNm_QtGui_popup[];
extern char sipNm_QtGui_completionMode[];
extern char sipNm_QtGui_setCompletionMode[];
extern char sipNm_QtGui_widget[];
extern char sipNm_QtGui_setWidget[];
extern char sipNm_QtGui_CaseInsensitivelySortedModel[];
extern char sipNm_QtGui_CaseSensitivelySortedModel[];
extern char sipNm_QtGui_UnsortedModel[];
extern char sipNm_QtGui_InlineCompletion[];
extern char sipNm_QtGui_UnfilteredPopupCompletion[];
extern char sipNm_QtGui_PopupCompletion[];
extern char sipNm_QtGui_QCompleter[];
extern char sipNm_QtGui_highlighted[];
extern char sipNm_QtGui_currentIndexChanged[];
extern char sipNm_QtGui_editTextChanged[];
extern char sipNm_QtGui_setEditText[];
extern char sipNm_QtGui_clearEditText[];
extern char sipNm_QtGui_insertSeparator[];
extern char sipNm_QtGui_completer[];
extern char sipNm_QtGui_setCompleter[];
extern char sipNm_QtGui_hidePopup[];
extern char sipNm_QtGui_showPopup[];
extern char sipNm_QtGui_setView[];
extern char sipNm_QtGui_view[];
extern char sipNm_QtGui_setItemIcon[];
extern char sipNm_QtGui_setItemText[];
extern char sipNm_QtGui_removeItem[];
extern char sipNm_QtGui_insertItems[];
extern char sipNm_QtGui_addItems[];
extern char sipNm_QtGui_itemIcon[];
extern char sipNm_QtGui_itemText[];
extern char sipNm_QtGui_currentText[];
extern char sipNm_QtGui_setModelColumn[];
extern char sipNm_QtGui_modelColumn[];
extern char sipNm_QtGui_setRootModelIndex[];
extern char sipNm_QtGui_rootModelIndex[];
extern char sipNm_QtGui_validator[];
extern char sipNm_QtGui_setValidator[];
extern char sipNm_QtGui_setEditable[];
extern char sipNm_QtGui_setMinimumContentsLength[];
extern char sipNm_QtGui_minimumContentsLength[];
extern char sipNm_QtGui_setSizeAdjustPolicy[];
extern char sipNm_QtGui_sizeAdjustPolicy[];
extern char sipNm_QtGui_AdjustToMinimumContentsLengthWithIcon[];
extern char sipNm_QtGui_AdjustToMinimumContentsLength[];
extern char sipNm_QtGui_AdjustToContentsOnFirstShow[];
extern char sipNm_QtGui_AdjustToContents[];
extern char sipNm_QtGui_setInsertPolicy[];
extern char sipNm_QtGui_insertPolicy[];
extern char sipNm_QtGui_InsertAlphabetically[];
extern char sipNm_QtGui_InsertBeforeCurrent[];
extern char sipNm_QtGui_InsertAfterCurrent[];
extern char sipNm_QtGui_InsertAtBottom[];
extern char sipNm_QtGui_InsertAtCurrent[];
extern char sipNm_QtGui_InsertAtTop[];
extern char sipNm_QtGui_NoInsert[];
extern char sipNm_QtGui_findData[];
extern char sipNm_QtGui_findText[];
extern char sipNm_QtGui_setDuplicatesEnabled[];
extern char sipNm_QtGui_duplicatesEnabled[];
extern char sipNm_QtGui_setAutoCompletionCaseSensitivity[];
extern char sipNm_QtGui_autoCompletionCaseSensitivity[];
extern char sipNm_QtGui_setAutoCompletion[];
extern char sipNm_QtGui_autoCompletion[];
extern char sipNm_QtGui_maxCount[];
extern char sipNm_QtGui_setMaxCount[];
extern char sipNm_QtGui_setMaxVisibleItems[];
extern char sipNm_QtGui_maxVisibleItems[];
extern char sipNm_QtGui_QComboBox[];
extern char sipNm_QtGui_setStandardColor[];
extern char sipNm_QtGui_setCustomColor[];
extern char sipNm_QtGui_customColor[];
extern char sipNm_QtGui_customCount[];
extern char sipNm_QtGui_getRgba[];
extern char sipNm_QtGui_getColor[];
extern char sipNm_QtGui_QColorDialog[];
extern char sipNm_QtGui_initializeColumn[];
extern char sipNm_QtGui_createColumn[];
extern char sipNm_QtGui_updatePreviewWidget[];
extern char sipNm_QtGui_setResizeGripsVisible[];
extern char sipNm_QtGui_setPreviewWidget[];
extern char sipNm_QtGui_setColumnWidths[];
extern char sipNm_QtGui_resizeGripsVisible[];
extern char sipNm_QtGui_previewWidget[];
extern char sipNm_QtGui_columnWidths[];
extern char sipNm_QtGui_QColumnView[];
extern char sipNm_QtGui_findBufferChanged[];
extern char sipNm_QtGui_setPixmap[];
extern char sipNm_QtGui_setImage[];
extern char sipNm_QtGui_pixmap[];
extern char sipNm_QtGui_image[];
extern char sipNm_QtGui_setMimeData[];
extern char sipNm_QtGui_ownsSelection[];
extern char sipNm_QtGui_ownsFindBuffer[];
extern char sipNm_QtGui_ownsClipboard[];
extern char sipNm_QtGui_supportsSelection[];
extern char sipNm_QtGui_supportsFindBuffer[];
extern char sipNm_QtGui_FindBuffer[];
extern char sipNm_QtGui_QClipboard[];
extern char sipNm_QtGui_setCheckState[];
extern char sipNm_QtGui_checkState[];
extern char sipNm_QtGui_isTristate[];
extern char sipNm_QtGui_setTristate[];
extern char sipNm_QtGui_QCheckBox[];
extern char sipNm_QtGui_setNavigationBarVisible[];
extern char sipNm_QtGui_setDateEditAcceptDelay[];
extern char sipNm_QtGui_dateEditAcceptDelay[];
extern char sipNm_QtGui_setDateEditEnabled[];
extern char sipNm_QtGui_isDateEditEnabled[];
extern char sipNm_QtGui_isNavigationBarVisible[];
extern char sipNm_QtGui_currentPageChanged[];
extern char sipNm_QtGui_showToday[];
extern char sipNm_QtGui_showSelectedDate[];
extern char sipNm_QtGui_showPreviousYear[];
extern char sipNm_QtGui_showPreviousMonth[];
extern char sipNm_QtGui_showNextYear[];
extern char sipNm_QtGui_showNextMonth[];
extern char sipNm_QtGui_setSelectedDate[];
extern char sipNm_QtGui_setDateRange[];
extern char sipNm_QtGui_setCurrentPage[];
extern char sipNm_QtGui_paintCell[];
extern char sipNm_QtGui_updateCells[];
extern char sipNm_QtGui_updateCell[];
extern char sipNm_QtGui_setDateTextFormat[];
extern char sipNm_QtGui_dateTextFormat[];
extern char sipNm_QtGui_setWeekdayTextFormat[];
extern char sipNm_QtGui_weekdayTextFormat[];
extern char sipNm_QtGui_setHeaderTextFormat[];
extern char sipNm_QtGui_headerTextFormat[];
extern char sipNm_QtGui_setVerticalHeaderFormat[];
extern char sipNm_QtGui_verticalHeaderFormat[];
extern char sipNm_QtGui_setHorizontalHeaderFormat[];
extern char sipNm_QtGui_horizontalHeaderFormat[];
extern char sipNm_QtGui_setGridVisible[];
extern char sipNm_QtGui_isGridVisible[];
extern char sipNm_QtGui_setHeaderVisible[];
extern char sipNm_QtGui_isHeaderVisible[];
extern char sipNm_QtGui_setFirstDayOfWeek[];
extern char sipNm_QtGui_firstDayOfWeek[];
extern char sipNm_QtGui_setMaximumDate[];
extern char sipNm_QtGui_maximumDate[];
extern char sipNm_QtGui_setMinimumDate[];
extern char sipNm_QtGui_minimumDate[];
extern char sipNm_QtGui_monthShown[];
extern char sipNm_QtGui_yearShown[];
extern char sipNm_QtGui_selectedDate[];
extern char sipNm_QtGui_ISOWeekNumbers[];
extern char sipNm_QtGui_NoVerticalHeader[];
extern char sipNm_QtGui_LongDayNames[];
extern char sipNm_QtGui_ShortDayNames[];
extern char sipNm_QtGui_SingleLetterDayNames[];
extern char sipNm_QtGui_NoHorizontalHeader[];
extern char sipNm_QtGui_QCalendarWidget[];
extern char sipNm_QtGui_buttonReleased[];
extern char sipNm_QtGui_buttonPressed[];
extern char sipNm_QtGui_buttonClicked[];
extern char sipNm_QtGui_checkedId[];
extern char sipNm_QtGui_id[];
extern char sipNm_QtGui_setId[];
extern char sipNm_QtGui_checkedButton[];
extern char sipNm_QtGui_button[];
extern char sipNm_QtGui_buttons[];
extern char sipNm_QtGui_removeButton[];
extern char sipNm_QtGui_addButton[];
extern char sipNm_QtGui_exclusive[];
extern char sipNm_QtGui_QButtonGroup[];
extern char sipNm_QtGui_QConicalGradient[];
extern char sipNm_QtGui_setRadius[];
extern char sipNm_QtGui_setFocalPoint[];
extern char sipNm_QtGui_setCenter[];
extern char sipNm_QtGui_radius[];
extern char sipNm_QtGui_focalPoint[];
extern char sipNm_QtGui_QRadialGradient[];
extern char sipNm_QtGui_setFinalStop[];
extern char sipNm_QtGui_setStart[];
extern char sipNm_QtGui_finalStop[];
extern char sipNm_QtGui_QLinearGradient[];
extern char sipNm_QtGui_setSpread[];
extern char sipNm_QtGui_stops[];
extern char sipNm_QtGui_setStops[];
extern char sipNm_QtGui_setColorAt[];
extern char sipNm_QtGui_spread[];
extern char sipNm_QtGui_RepeatSpread[];
extern char sipNm_QtGui_ReflectSpread[];
extern char sipNm_QtGui_PadSpread[];
extern char sipNm_QtGui_NoGradient[];
extern char sipNm_QtGui_ConicalGradient[];
extern char sipNm_QtGui_RadialGradient[];
extern char sipNm_QtGui_LinearGradient[];
extern char sipNm_QtGui_QGradient[];
extern char sipNm_QtGui_transform[];
extern char sipNm_QtGui_setTransform[];
extern char sipNm_QtGui_textureImage[];
extern char sipNm_QtGui_setTextureImage[];
extern char sipNm_QtGui_matrix[];
extern char sipNm_QtGui_setMatrix[];
extern char sipNm_QtGui_color[];
extern char sipNm_QtGui_isOpaque[];
extern char sipNm_QtGui_gradient[];
extern char sipNm_QtGui_setColor[];
extern char sipNm_QtGui_setTexture[];
extern char sipNm_QtGui_texture[];
extern char sipNm_QtGui_setDescription[];
extern char sipNm_QtGui_description[];
extern char sipNm_QtGui_QPushButton[];
extern char sipNm_QtGui_QCommandLinkButton[];
extern char sipNm_QtGui_darker[];
extern char sipNm_QtGui_lighter[];
extern char sipNm_QtGui_setAllowX11ColorNames[];
extern char sipNm_QtGui_allowX11ColorNames[];
extern char sipNm_QtGui_dark[];
extern char sipNm_QtGui_light[];
extern char sipNm_QtGui_fromCmykF[];
extern char sipNm_QtGui_fromCmyk[];
extern char sipNm_QtGui_fromHsvF[];
extern char sipNm_QtGui_fromHsv[];
extern char sipNm_QtGui_fromRgbF[];
extern char sipNm_QtGui_fromRgba[];
extern char sipNm_QtGui_fromRgb[];
extern char sipNm_QtGui_convertTo[];
extern char sipNm_QtGui_toCmyk[];
extern char sipNm_QtGui_toHsv[];
extern char sipNm_QtGui_toRgb[];
extern char sipNm_QtGui_setCmykF[];
extern char sipNm_QtGui_getCmykF[];
extern char sipNm_QtGui_setCmyk[];
extern char sipNm_QtGui_getCmyk[];
extern char sipNm_QtGui_blackF[];
extern char sipNm_QtGui_yellowF[];
extern char sipNm_QtGui_magentaF[];
extern char sipNm_QtGui_cyanF[];
extern char sipNm_QtGui_setHsvF[];
extern char sipNm_QtGui_getHsvF[];
extern char sipNm_QtGui_setHsv[];
extern char sipNm_QtGui_getHsv[];
extern char sipNm_QtGui_valueF[];
extern char sipNm_QtGui_saturationF[];
extern char sipNm_QtGui_hueF[];
extern char sipNm_QtGui_saturation[];
extern char sipNm_QtGui_hue[];
extern char sipNm_QtGui_rgb[];
extern char sipNm_QtGui_setRgba[];
extern char sipNm_QtGui_rgba[];
extern char sipNm_QtGui_setRgbF[];
extern char sipNm_QtGui_getRgbF[];
extern char sipNm_QtGui_setRgb[];
extern char sipNm_QtGui_getRgb[];
extern char sipNm_QtGui_setBlueF[];
extern char sipNm_QtGui_setGreenF[];
extern char sipNm_QtGui_setRedF[];
extern char sipNm_QtGui_blueF[];
extern char sipNm_QtGui_greenF[];
extern char sipNm_QtGui_redF[];
extern char sipNm_QtGui_setBlue[];
extern char sipNm_QtGui_setGreen[];
extern char sipNm_QtGui_setRed[];
extern char sipNm_QtGui_setAlphaF[];
extern char sipNm_QtGui_alphaF[];
extern char sipNm_QtGui_setAlpha[];
extern char sipNm_QtGui_alpha[];
extern char sipNm_QtGui_spec[];
extern char sipNm_QtGui_colorNames[];
extern char sipNm_QtGui_setNamedColor[];
extern char sipNm_QtGui_Cmyk[];
extern char sipNm_QtGui_Hsv[];
extern char sipNm_QtGui_Rgb[];
extern char sipNm_QtGui_QVBoxLayout[];
extern char sipNm_QtGui_QHBoxLayout[];
extern char sipNm_QtGui_insertItem[];
extern char sipNm_QtGui_insertSpacerItem[];
extern char sipNm_QtGui_addSpacerItem[];
extern char sipNm_QtGui_setSpacing[];
extern char sipNm_QtGui_spacing[];
extern char sipNm_QtGui_setGeometry[];
extern char sipNm_QtGui_itemAt[];
extern char sipNm_QtGui_invalidate[];
extern char sipNm_QtGui_expandingDirections[];
extern char sipNm_QtGui_minimumHeightForWidth[];
extern char sipNm_QtGui_heightForWidth[];
extern char sipNm_QtGui_hasHeightForWidth[];
extern char sipNm_QtGui_maximumSize[];
extern char sipNm_QtGui_minimumSize[];
extern char sipNm_QtGui_setStretchFactor[];
extern char sipNm_QtGui_insertLayout[];
extern char sipNm_QtGui_insertWidget[];
extern char sipNm_QtGui_insertStretch[];
extern char sipNm_QtGui_insertSpacing[];
extern char sipNm_QtGui_addItem[];
extern char sipNm_QtGui_addStrut[];
extern char sipNm_QtGui_addLayout[];
extern char sipNm_QtGui_addWidget[];
extern char sipNm_QtGui_addStretch[];
extern char sipNm_QtGui_addSpacing[];
extern char sipNm_QtGui_Up[];
extern char sipNm_QtGui_Down[];
extern char sipNm_QtGui_BottomToTop[];
extern char sipNm_QtGui_TopToBottom[];
extern char sipNm_QtGui_QLayout[];
extern char sipNm_QtGui_QBoxLayout[];
extern char sipNm_QtGui_transformed[];
extern char sipNm_QtGui_fromData[];
extern char sipNm_QtGui_fromImage[];
extern char sipNm_QtGui_alert[];
extern char sipNm_QtGui_styleSheet[];
extern char sipNm_QtGui_keyboardInputDirection[];
extern char sipNm_QtGui_keyboardInputLocale[];
extern char sipNm_QtGui_setStyleSheet[];
extern char sipNm_QtGui_closeAllWindows[];
extern char sipNm_QtGui_aboutQt[];
extern char sipNm_QtGui_saveStateRequest[];
extern char sipNm_QtGui_lastWindowClosed[];
extern char sipNm_QtGui_focusChanged[];
extern char sipNm_QtGui_commitDataRequest[];
extern char sipNm_QtGui_quitOnLastWindowClosed[];
extern char sipNm_QtGui_setQuitOnLastWindowClosed[];
extern char sipNm_QtGui_inputContext[];
extern char sipNm_QtGui_setInputContext[];
extern char sipNm_QtGui_saveState[];
extern char sipNm_QtGui_sessionKey[];
extern char sipNm_QtGui_sessionId[];
extern char sipNm_QtGui_isSessionRestored[];
extern char sipNm_QtGui_x11ProcessEvent[];
extern char sipNm_QtGui_x11EventFilter[];
extern char sipNm_QtGui_setEffectEnabled[];
extern char sipNm_QtGui_isEffectEnabled[];
extern char sipNm_QtGui_isLeftToRight[];
extern char sipNm_QtGui_layoutDirection[];
extern char sipNm_QtGui_setLayoutDirection[];
extern char sipNm_QtGui_startDragDistance[];
extern char sipNm_QtGui_setStartDragDistance[];
extern char sipNm_QtGui_startDragTime[];
extern char sipNm_QtGui_setStartDragTime[];
extern char sipNm_QtGui_globalStrut[];
extern char sipNm_QtGui_setGlobalStrut[];
extern char sipNm_QtGui_wheelScrollLines[];
extern char sipNm_QtGui_setWheelScrollLines[];
extern char sipNm_QtGui_keyboardInputInterval[];
extern char sipNm_QtGui_setKeyboardInputInterval[];
extern char sipNm_QtGui_doubleClickInterval[];
extern char sipNm_QtGui_setDoubleClickInterval[];
extern char sipNm_QtGui_cursorFlashTime[];
extern char sipNm_QtGui_setCursorFlashTime[];
extern char sipNm_QtGui_desktopSettingsAware[];
extern char sipNm_QtGui_setDesktopSettingsAware[];
extern char sipNm_QtGui_mouseButtons[];
extern char sipNm_QtGui_keyboardModifiers[];
extern char sipNm_QtGui_beep[];
extern char sipNm_QtGui_syncX[];
extern char sipNm_QtGui_topLevelAt[];
extern char sipNm_QtGui_widgetAt[];
extern char sipNm_QtGui_setActiveWindow[];
extern char sipNm_QtGui_activeWindow[];
extern char sipNm_QtGui_focusWidget[];
extern char sipNm_QtGui_clipboard[];
extern char sipNm_QtGui_activeModalWidget[];
extern char sipNm_QtGui_activePopupWidget[];
extern char sipNm_QtGui_desktop[];
extern char sipNm_QtGui_topLevelWidgets[];
extern char sipNm_QtGui_allWidgets[];
extern char sipNm_QtGui_windowIcon[];
extern char sipNm_QtGui_setWindowIcon[];
extern char sipNm_QtGui_fontMetrics[];
extern char sipNm_QtGui_setPalette[];
extern char sipNm_QtGui_restoreOverrideCursor[];
extern char sipNm_QtGui_changeOverrideCursor[];
extern char sipNm_QtGui_setOverrideCursor[];
extern char sipNm_QtGui_overrideCursor[];
extern char sipNm_QtGui_setColorSpec[];
extern char sipNm_QtGui_colorSpec[];
extern char sipNm_QtGui_ManyColor[];
extern char sipNm_QtGui_CustomColor[];
extern char sipNm_QtGui_NormalColor[];
extern char sipNm_QtGui_setStyle[];
extern char sipNm_QtGui_style[];
extern char sipNm_QtGui_GuiServer[];
extern char sipNm_QtGui_GuiClient[];
extern char sipNm_QtGui_Tty[];
extern char sipNm_QtGui_QApplication[];
extern char sipNm_QtGui_qApp[];
extern char sipNm_QtGui_qt_x11_wait_for_window_manager[];
extern char sipNm_QtGui_qt_set_sequence_auto_mnemonic[];
extern char sipNm_QtGui_XEvent[];
extern char sipNm_QtGui_selected[];
extern char sipNm_QtGui_setExclusive[];
extern char sipNm_QtGui_isExclusive[];
extern char sipNm_QtGui_checkedAction[];
extern char sipNm_QtGui_actions[];
extern char sipNm_QtGui_removeAction[];
extern char sipNm_QtGui_addAction[];
extern char sipNm_QtGui_QActionGroup[];
extern char sipNm_QtGui_isIconVisibleInMenu[];
extern char sipNm_QtGui_setIconVisibleInMenu[];
extern char sipNm_QtGui_associatedWidgets[];
extern char sipNm_QtGui_menuRole[];
extern char sipNm_QtGui_setMenuRole[];
extern char sipNm_QtGui_shortcuts[];
extern char sipNm_QtGui_setShortcuts[];
extern char sipNm_QtGui_QuitRole[];
extern char sipNm_QtGui_PreferencesRole[];
extern char sipNm_QtGui_AboutRole[];
extern char sipNm_QtGui_AboutQtRole[];
extern char sipNm_QtGui_ApplicationSpecificRole[];
extern char sipNm_QtGui_TextHeuristicRole[];
extern char sipNm_QtGui_NoRole[];
extern char sipNm_QtGui_hovered[];
extern char sipNm_QtGui_triggered[];
extern char sipNm_QtGui_changed[];
extern char sipNm_QtGui_setVisible[];
extern char sipNm_QtGui_setDisabled[];
extern char sipNm_QtGui_hover[];
extern char sipNm_QtGui_trigger[];
extern char sipNm_QtGui_parentWidget[];
extern char sipNm_QtGui_showStatusText[];
extern char sipNm_QtGui_activate[];
extern char sipNm_QtGui_Hover[];
extern char sipNm_QtGui_Trigger[];
extern char sipNm_QtGui_isVisible[];
extern char sipNm_QtGui_font[];
extern char sipNm_QtGui_setFont[];
extern char sipNm_QtGui_shortcutContext[];
extern char sipNm_QtGui_setShortcutContext[];
extern char sipNm_QtGui_isSeparator[];
extern char sipNm_QtGui_setSeparator[];
extern char sipNm_QtGui_setMenu[];
extern char sipNm_QtGui_menu[];
extern char sipNm_QtGui_whatsThis[];
extern char sipNm_QtGui_setWhatsThis[];
extern char sipNm_QtGui_statusTip[];
extern char sipNm_QtGui_setStatusTip[];
extern char sipNm_QtGui_toolTip[];
extern char sipNm_QtGui_setToolTip[];
extern char sipNm_QtGui_iconText[];
extern char sipNm_QtGui_setIconText[];
extern char sipNm_QtGui_actionGroup[];
extern char sipNm_QtGui_setActionGroup[];
extern char sipNm_QtGui_QAction[];
extern char sipNm_QtGui_sliderChange[];
extern char sipNm_QtGui_SliderValueChange[];
extern char sipNm_QtGui_SliderStepsChange[];
extern char sipNm_QtGui_SliderOrientationChange[];
extern char sipNm_QtGui_SliderRangeChange[];
extern char sipNm_QtGui_repeatAction[];
extern char sipNm_QtGui_setRepeatAction[];
extern char sipNm_QtGui_actionTriggered[];
extern char sipNm_QtGui_rangeChanged[];
extern char sipNm_QtGui_sliderReleased[];
extern char sipNm_QtGui_sliderMoved[];
extern char sipNm_QtGui_sliderPressed[];
extern char sipNm_QtGui_setOrientation[];
extern char sipNm_QtGui_triggerAction[];
extern char sipNm_QtGui_SliderMove[];
extern char sipNm_QtGui_SliderToMaximum[];
extern char sipNm_QtGui_SliderToMinimum[];
extern char sipNm_QtGui_SliderPageStepSub[];
extern char sipNm_QtGui_SliderPageStepAdd[];
extern char sipNm_QtGui_SliderSingleStepSub[];
extern char sipNm_QtGui_SliderSingleStepAdd[];
extern char sipNm_QtGui_SliderNoAction[];
extern char sipNm_QtGui_invertedControls[];
extern char sipNm_QtGui_setInvertedControls[];
extern char sipNm_QtGui_invertedAppearance[];
extern char sipNm_QtGui_setInvertedAppearance[];
extern char sipNm_QtGui_sliderPosition[];
extern char sipNm_QtGui_setSliderPosition[];
extern char sipNm_QtGui_isSliderDown[];
extern char sipNm_QtGui_setSliderDown[];
extern char sipNm_QtGui_hasTracking[];
extern char sipNm_QtGui_setTracking[];
extern char sipNm_QtGui_pageStep[];
extern char sipNm_QtGui_setPageStep[];
extern char sipNm_QtGui_singleStep[];
extern char sipNm_QtGui_setSingleStep[];
extern char sipNm_QtGui_setRange[];
extern char sipNm_QtGui_maximum[];
extern char sipNm_QtGui_setMaximum[];
extern char sipNm_QtGui_minimum[];
extern char sipNm_QtGui_setMinimum[];
extern char sipNm_QtGui_orientation[];
extern char sipNm_QtGui_QAbstractSlider[];
extern char sipNm_QtGui_drawInlineObject[];
extern char sipNm_QtGui_positionInlineObject[];
extern char sipNm_QtGui_resizeInlineObject[];
extern char sipNm_QtGui_documentChanged[];
extern char sipNm_QtGui_updateBlock[];
extern char sipNm_QtGui_pageCountChanged[];
extern char sipNm_QtGui_documentSizeChanged[];
extern char sipNm_QtGui_document[];
extern char sipNm_QtGui_paintDevice[];
extern char sipNm_QtGui_setPaintDevice[];
extern char sipNm_QtGui_blockBoundingRect[];
extern char sipNm_QtGui_frameBoundingRect[];
extern char sipNm_QtGui_documentSize[];
extern char sipNm_QtGui_pageCount[];
extern char sipNm_QtGui_anchorAt[];
extern char sipNm_QtGui_hitTest[];
extern char sipNm_QtGui_draw[];
extern char sipNm_QtGui_selections[];
extern char sipNm_QtGui_clip[];
extern char sipNm_QtGui_palette[];
extern char sipNm_QtGui_cursorPosition[];
extern char sipNm_QtGui_PaintContext[];
extern char sipNm_QtGui_cursor[];
extern char sipNm_QtGui_QAbstractTextDocumentLayout[];
extern char sipNm_QtGui_initStyleOption[];
extern char sipNm_QtGui_keyboardTracking[];
extern char sipNm_QtGui_setKeyboardTracking[];
extern char sipNm_QtGui_isAccelerated[];
extern char sipNm_QtGui_setAccelerated[];
extern char sipNm_QtGui_hasAcceptableInput[];
extern char sipNm_QtGui_correctionMode[];
extern char sipNm_QtGui_setCorrectionMode[];
extern char sipNm_QtGui_CorrectToNearestValue[];
extern char sipNm_QtGui_CorrectToPreviousValue[];
extern char sipNm_QtGui_stepEnabled[];
extern char sipNm_QtGui_setLineEdit[];
extern char sipNm_QtGui_lineEdit[];
extern char sipNm_QtGui_showEvent[];
extern char sipNm_QtGui_hideEvent[];
extern char sipNm_QtGui_closeEvent[];
extern char sipNm_QtGui_editingFinished[];
extern char sipNm_QtGui_stepDown[];
extern char sipNm_QtGui_stepUp[];
extern char sipNm_QtGui_stepBy[];
extern char sipNm_QtGui_fixup[];
extern char sipNm_QtGui_validate[];
extern char sipNm_QtGui_interpretText[];
extern char sipNm_QtGui_hasFrame[];
extern char sipNm_QtGui_setFrame[];
extern char sipNm_QtGui_alignment[];
extern char sipNm_QtGui_setAlignment[];
extern char sipNm_QtGui_isReadOnly[];
extern char sipNm_QtGui_setReadOnly[];
extern char sipNm_QtGui_setWrapping[];
extern char sipNm_QtGui_wrapping[];
extern char sipNm_QtGui_setSpecialValueText[];
extern char sipNm_QtGui_specialValueText[];
extern char sipNm_QtGui_setButtonSymbols[];
extern char sipNm_QtGui_buttonSymbols[];
extern char sipNm_QtGui_NoButtons[];
extern char sipNm_QtGui_PlusMinus[];
extern char sipNm_QtGui_UpDownArrows[];
extern char sipNm_QtGui_StepEnabled[];
extern char sipNm_QtGui_StepDownEnabled[];
extern char sipNm_QtGui_StepUpEnabled[];
extern char sipNm_QtGui_StepNone[];
extern char sipNm_QtGui_StepEnabledFlag[];
extern char sipNm_QtGui_QAbstractSpinBox[];
extern char sipNm_QtGui_setupViewport[];
extern char sipNm_QtGui_setViewport[];
extern char sipNm_QtGui_scrollBarWidgets[];
extern char sipNm_QtGui_addScrollBarWidget[];
extern char sipNm_QtGui_setCornerWidget[];
extern char sipNm_QtGui_cornerWidget[];
extern char sipNm_QtGui_setHorizontalScrollBar[];
extern char sipNm_QtGui_setVerticalScrollBar[];
extern char sipNm_QtGui_scrollContentsBy[];
extern char sipNm_QtGui_contextMenuEvent[];
extern char sipNm_QtGui_wheelEvent[];
extern char sipNm_QtGui_setViewportMargins[];
extern char sipNm_QtGui_minimumSizeHint[];
extern char sipNm_QtGui_maximumViewportSize[];
extern char sipNm_QtGui_viewport[];
extern char sipNm_QtGui_horizontalScrollBar[];
extern char sipNm_QtGui_setHorizontalScrollBarPolicy[];
extern char sipNm_QtGui_horizontalScrollBarPolicy[];
extern char sipNm_QtGui_verticalScrollBar[];
extern char sipNm_QtGui_setVerticalScrollBarPolicy[];
extern char sipNm_QtGui_verticalScrollBarPolicy[];
extern char sipNm_QtGui_QFrame[];
extern char sipNm_QtGui_mapSelectionFromSource[];
extern char sipNm_QtGui_mapSelectionToSource[];
extern char sipNm_QtGui_mapFromSource[];
extern char sipNm_QtGui_mapToSource[];
extern char sipNm_QtGui_sourceModel[];
extern char sipNm_QtGui_setSourceModel[];
extern char sipNm_QtGui_QAbstractProxyModel[];
extern char sipNm_QtGui_setOptionTabs[];
extern char sipNm_QtGui_printer[];
extern char sipNm_QtGui_toPage[];
extern char sipNm_QtGui_fromPage[];
extern char sipNm_QtGui_setFromTo[];
extern char sipNm_QtGui_maxPage[];
extern char sipNm_QtGui_minPage[];
extern char sipNm_QtGui_setMinMax[];
extern char sipNm_QtGui_printRange[];
extern char sipNm_QtGui_setPrintRange[];
extern char sipNm_QtGui_isOptionEnabled[];
extern char sipNm_QtGui_enabledOptions[];
extern char sipNm_QtGui_setEnabledOptions[];
extern char sipNm_QtGui_addEnabledOption[];
extern char sipNm_QtGui_PrintDialogOptions[];
extern char sipNm_QtGui_DontUseSheet[];
extern char sipNm_QtGui_PrintShowPageSize[];
extern char sipNm_QtGui_PrintCollateCopies[];
extern char sipNm_QtGui_PrintPageRange[];
extern char sipNm_QtGui_PrintSelection[];
extern char sipNm_QtGui_PrintToFile[];
extern char sipNm_QtGui_PrintDialogOption[];
extern char sipNm_QtGui_PageRange[];
extern char sipNm_QtGui_Selection[];
extern char sipNm_QtGui_AllPages[];
extern char sipNm_QtGui_QDialog[];
extern char sipNm_QtGui_QAbstractPrintDialog[];
extern char sipNm_QtGui_inputMethodEvent[];
extern char sipNm_QtGui_focusNextPrevChild[];
extern char sipNm_QtGui_autoScrollMargin[];
extern char sipNm_QtGui_setAutoScrollMargin[];
extern char sipNm_QtGui_inputMethodQuery[];
extern char sipNm_QtGui_itemDelegateForColumn[];
extern char sipNm_QtGui_setItemDelegateForColumn[];
extern char sipNm_QtGui_itemDelegateForRow[];
extern char sipNm_QtGui_setItemDelegateForRow[];
extern char sipNm_QtGui_dragDropMode[];
extern char sipNm_QtGui_setDragDropMode[];
extern char sipNm_QtGui_dragDropOverwriteMode[];
extern char sipNm_QtGui_setDragDropOverwriteMode[];
extern char sipNm_QtGui_horizontalScrollMode[];
extern char sipNm_QtGui_setHorizontalScrollMode[];
extern char sipNm_QtGui_verticalScrollMode[];
extern char sipNm_QtGui_setVerticalScrollMode[];
extern char sipNm_QtGui_dropIndicatorPosition[];
extern char sipNm_QtGui_OnViewport[];
extern char sipNm_QtGui_BelowItem[];
extern char sipNm_QtGui_AboveItem[];
extern char sipNm_QtGui_OnItem[];
extern char sipNm_QtGui_resizeEvent[];
extern char sipNm_QtGui_dropEvent[];
extern char sipNm_QtGui_dragLeaveEvent[];
extern char sipNm_QtGui_dragMoveEvent[];
extern char sipNm_QtGui_dragEnterEvent[];
extern char sipNm_QtGui_mouseDoubleClickEvent[];
extern char sipNm_QtGui_viewportEvent[];
extern char sipNm_QtGui_dirtyRegionOffset[];
extern char sipNm_QtGui_setDirtyRegion[];
extern char sipNm_QtGui_scrollDirtyRegion[];
extern char sipNm_QtGui_executeDelayedItemsLayout[];
extern char sipNm_QtGui_scheduleDelayedItemsLayout[];
extern char sipNm_QtGui_setState[];
extern char sipNm_QtGui_AnimatingState[];
extern char sipNm_QtGui_CollapsingState[];
extern char sipNm_QtGui_ExpandingState[];
extern char sipNm_QtGui_EditingState[];
extern char sipNm_QtGui_DragSelectingState[];
extern char sipNm_QtGui_DraggingState[];
extern char sipNm_QtGui_NoState[];
extern char sipNm_QtGui_viewOptions[];
extern char sipNm_QtGui_startDrag[];
extern char sipNm_QtGui_selectionCommand[];
extern char sipNm_QtGui_selectedIndexes[];
extern char sipNm_QtGui_visualRegionForSelection[];
extern char sipNm_QtGui_setSelection[];
extern char sipNm_QtGui_isIndexHidden[];
extern char sipNm_QtGui_verticalOffset[];
extern char sipNm_QtGui_horizontalOffset[];
extern char sipNm_QtGui_moveCursor[];
extern char sipNm_QtGui_MovePrevious[];
extern char sipNm_QtGui_MoveNext[];
extern char sipNm_QtGui_MovePageDown[];
extern char sipNm_QtGui_MovePageUp[];
extern char sipNm_QtGui_MoveEnd[];
extern char sipNm_QtGui_MoveHome[];
extern char sipNm_QtGui_MoveRight[];
extern char sipNm_QtGui_MoveLeft[];
extern char sipNm_QtGui_MoveDown[];
extern char sipNm_QtGui_MoveUp[];
extern char sipNm_QtGui_verticalStepsPerItem[];
extern char sipNm_QtGui_setVerticalStepsPerItem[];
extern char sipNm_QtGui_horizontalStepsPerItem[];
extern char sipNm_QtGui_setHorizontalStepsPerItem[];
extern char sipNm_QtGui_viewportEntered[];
extern char sipNm_QtGui_entered[];
extern char sipNm_QtGui_doubleClicked[];
extern char sipNm_QtGui_editorDestroyed[];
extern char sipNm_QtGui_horizontalScrollbarValueChanged[];
extern char sipNm_QtGui_verticalScrollbarValueChanged[];
extern char sipNm_QtGui_horizontalScrollbarAction[];
extern char sipNm_QtGui_verticalScrollbarAction[];
extern char sipNm_QtGui_updateGeometries[];
extern char sipNm_QtGui_updateEditorGeometries[];
extern char sipNm_QtGui_updateEditorData[];
extern char sipNm_QtGui_currentChanged[];
extern char sipNm_QtGui_selectionChanged[];
extern char sipNm_QtGui_rowsAboutToBeRemoved[];
extern char sipNm_QtGui_rowsInserted[];
extern char sipNm_QtGui_update[];
extern char sipNm_QtGui_scrollToBottom[];
extern char sipNm_QtGui_scrollToTop[];
extern char sipNm_QtGui_setCurrentIndex[];
extern char sipNm_QtGui_clearSelection[];
extern char sipNm_QtGui_edit[];
extern char sipNm_QtGui_selectAll[];
extern char sipNm_QtGui_doItemsLayout[];
extern char sipNm_QtGui_setRootIndex[];
extern char sipNm_QtGui_indexWidget[];
extern char sipNm_QtGui_setIndexWidget[];
extern char sipNm_QtGui_closePersistentEditor[];
extern char sipNm_QtGui_openPersistentEditor[];
extern char sipNm_QtGui_sizeHintForColumn[];
extern char sipNm_QtGui_sizeHintForRow[];
extern char sipNm_QtGui_sizeHintForIndex[];
extern char sipNm_QtGui_indexAt[];
extern char sipNm_QtGui_scrollTo[];
extern char sipNm_QtGui_visualRect[];
extern char sipNm_QtGui_keyboardSearch[];
extern char sipNm_QtGui_textElideMode[];
extern char sipNm_QtGui_setTextElideMode[];
extern char sipNm_QtGui_alternatingRowColors[];
extern char sipNm_QtGui_setAlternatingRowColors[];
extern char sipNm_QtGui_dragEnabled[];
extern char sipNm_QtGui_setDragEnabled[];
extern char sipNm_QtGui_showDropIndicator[];
extern char sipNm_QtGui_setDropIndicatorShown[];
extern char sipNm_QtGui_tabKeyNavigation[];
extern char sipNm_QtGui_setTabKeyNavigation[];
extern char sipNm_QtGui_hasAutoScroll[];
extern char sipNm_QtGui_setAutoScroll[];
extern char sipNm_QtGui_editTriggers[];
extern char sipNm_QtGui_setEditTriggers[];
extern char sipNm_QtGui_rootIndex[];
extern char sipNm_QtGui_currentIndex[];
extern char sipNm_QtGui_selectionBehavior[];
extern char sipNm_QtGui_setSelectionBehavior[];
extern char sipNm_QtGui_selectionMode[];
extern char sipNm_QtGui_setSelectionMode[];
extern char sipNm_QtGui_itemDelegate[];
extern char sipNm_QtGui_setItemDelegate[];
extern char sipNm_QtGui_selectionModel[];
extern char sipNm_QtGui_setSelectionModel[];
extern char sipNm_QtGui_setModel[];
extern char sipNm_QtGui_ContiguousSelection[];
extern char sipNm_QtGui_ExtendedSelection[];
extern char sipNm_QtGui_MultiSelection[];
extern char sipNm_QtGui_SingleSelection[];
extern char sipNm_QtGui_NoSelection[];
extern char sipNm_QtGui_SelectColumns[];
extern char sipNm_QtGui_SelectRows[];
extern char sipNm_QtGui_SelectItems[];
extern char sipNm_QtGui_ScrollPerPixel[];
extern char sipNm_QtGui_ScrollPerItem[];
extern char sipNm_QtGui_PositionAtCenter[];
extern char sipNm_QtGui_PositionAtBottom[];
extern char sipNm_QtGui_PositionAtTop[];
extern char sipNm_QtGui_EnsureVisible[];
extern char sipNm_QtGui_EditTriggers[];
extern char sipNm_QtGui_AllEditTriggers[];
extern char sipNm_QtGui_AnyKeyPressed[];
extern char sipNm_QtGui_EditKeyPressed[];
extern char sipNm_QtGui_SelectedClicked[];
extern char sipNm_QtGui_DoubleClicked[];
extern char sipNm_QtGui_CurrentChanged[];
extern char sipNm_QtGui_NoEditTriggers[];
extern char sipNm_QtGui_EditTrigger[];
extern char sipNm_QtGui_InternalMove[];
extern char sipNm_QtGui_DragDrop[];
extern char sipNm_QtGui_DropOnly[];
extern char sipNm_QtGui_DragOnly[];
extern char sipNm_QtGui_NoDragDrop[];
extern char sipNm_QtGui_QAbstractScrollArea[];
extern char sipNm_QtGui_QAbstractItemView[];
extern char sipNm_QtGui_sizeHintChanged[];
extern char sipNm_QtGui_closeEditor[];
extern char sipNm_QtGui_commitData[];
extern char sipNm_QtGui_helpEvent[];
extern char sipNm_QtGui_elidedText[];
extern char sipNm_QtGui_editorEvent[];
extern char sipNm_QtGui_updateEditorGeometry[];
extern char sipNm_QtGui_setModelData[];
extern char sipNm_QtGui_setEditorData[];
extern char sipNm_QtGui_createEditor[];
extern char sipNm_QtGui_sizeHint[];
extern char sipNm_QtGui_paint[];
extern char sipNm_QtGui_RevertModelCache[];
extern char sipNm_QtGui_SubmitModelCache[];
extern char sipNm_QtGui_EditPreviousItem[];
extern char sipNm_QtGui_EditNextItem[];
extern char sipNm_QtGui_NoHint[];
extern char sipNm_QtGui_QAbstractItemDelegate[];
extern char sipNm_QtGui_changeEvent[];
extern char sipNm_QtGui_focusOutEvent[];
extern char sipNm_QtGui_focusInEvent[];
extern char sipNm_QtGui_mouseMoveEvent[];
extern char sipNm_QtGui_mouseReleaseEvent[];
extern char sipNm_QtGui_mousePressEvent[];
extern char sipNm_QtGui_keyReleaseEvent[];
extern char sipNm_QtGui_keyPressEvent[];
extern char sipNm_QtGui_nextCheckState[];
extern char sipNm_QtGui_checkStateSet[];
extern char sipNm_QtGui_hitButton[];
extern char sipNm_QtGui_paintEvent[];
extern char sipNm_QtGui_toggled[];
extern char sipNm_QtGui_clicked[];
extern char sipNm_QtGui_released[];
extern char sipNm_QtGui_pressed[];
extern char sipNm_QtGui_setChecked[];
extern char sipNm_QtGui_toggle[];
extern char sipNm_QtGui_click[];
extern char sipNm_QtGui_animateClick[];
extern char sipNm_QtGui_setIconSize[];
extern char sipNm_QtGui_autoExclusive[];
extern char sipNm_QtGui_setAutoExclusive[];
extern char sipNm_QtGui_autoRepeat[];
extern char sipNm_QtGui_setAutoRepeat[];
extern char sipNm_QtGui_isDown[];
extern char sipNm_QtGui_setDown[];
extern char sipNm_QtGui_isChecked[];
extern char sipNm_QtGui_isCheckable[];
extern char sipNm_QtGui_setCheckable[];
extern char sipNm_QtGui_shortcut[];
extern char sipNm_QtGui_setShortcut[];
extern char sipNm_QtGui_iconSize[];
extern char sipNm_QtGui_icon[];
extern char sipNm_QtGui_setIcon[];
extern char sipNm_QtGui_autoRepeatInterval[];
extern char sipNm_QtGui_setAutoRepeatInterval[];
extern char sipNm_QtGui_autoRepeatDelay[];
extern char sipNm_QtGui_setAutoRepeatDelay[];
extern char sipNm_QtGui_QAbstractButton[];
extern char sipNm_QtGui_autoFormatting[];
extern char sipNm_QtGui_setAutoFormatting[];
extern char sipNm_QtGui_Error[];
extern char sipNm_QtGui_attributes[];
extern char sipNm_QtGui_columnNumber[];
extern char sipNm_QtGui_lineNumber[];
extern char sipNm_QtGui_isDefault[];
extern char sipNm_QtGui_prefix[];
extern char sipNm_QtGui_save[];
extern char sipNm_QtGui_UserType[];
extern char sipNm_QtGui_Pen[];
extern char sipNm_QtGui_Cursor[];
extern char sipNm_QtGui_Color[];
extern char sipNm_QtGui_Point[];
extern char sipNm_QtGui_List[];
extern char sipNm_QtGui_Invalid[];
extern char sipNm_QtGui_variant[];
extern char sipNm_QtGui_fragment[];
extern char sipNm_QtGui_loadFromData[];
extern char sipNm_QtGui_valueChanged[];
extern char sipNm_QtGui_frameChanged[];
extern char sipNm_QtGui_setPaused[];
extern char sipNm_QtGui_currentFrame[];
extern char sipNm_QtGui_setDirection[];
extern char sipNm_QtGui_loopCount[];
extern char sipNm_QtGui_Paused[];
extern char sipNm_QtGui_State[];
extern char sipNm_QtGui_Forward[];
extern char sipNm_QtGui_isFinished[];
extern char sipNm_QtGui_ScientificNotation[];
extern char sipNm_QtGui_setPosition[];
extern char sipNm_QtGui_Line[];
extern char sipNm_QtGui_Open[];
extern char sipNm_QtGui_last[];
extern char sipNm_QtGui_first[];
extern char sipNm_QtGui_swap[];
extern char sipNm_QtGui_move[];
extern char sipNm_QtGui_takeLast[];
extern char sipNm_QtGui_takeFirst[];
extern char sipNm_QtGui_takeAt[];
extern char sipNm_QtGui_removeAll[];
extern char sipNm_QtGui_removeAt[];
extern char sipNm_QtGui___delitem__[];
extern char sipNm_QtGui___setitem__[];
extern char sipNm_QtGui_position[];
extern char sipNm_QtGui_isRightToLeft[];
extern char sipNm_QtGui_section[];
extern char sipNm_QtGui_activated[];
extern char sipNm_QtGui_setEnabled[];
extern char sipNm_QtGui_isEnabled[];
extern char sipNm_QtGui_scale[];
extern char sipNm_QtGui_transpose[];
extern char sipNm_QtGui_setKey[];
extern char sipNm_QtGui_format[];
extern char sipNm_QtGui_setValue[];
extern char sipNm_QtGui_InvalidFormat[];
extern char sipNm_QtGui_NativeFormat[];
extern char sipNm_QtGui_release[];
extern char sipNm_QtGui_setLocale[];
extern char sipNm_QtGui_locale[];
extern char sipNm_QtGui_escape[];
extern char sipNm_QtGui_exactMatch[];
extern char sipNm_QtGui_setCaseSensitivity[];
extern char sipNm_QtGui_caseSensitivity[];
extern char sipNm_QtGui_united[];
extern char sipNm_QtGui_intersected[];
extern char sipNm_QtGui_unite[];
extern char sipNm_QtGui_setHeight[];
extern char sipNm_QtGui_setWidth[];
extern char sipNm_QtGui_setRect[];
extern char sipNm_QtGui_moveTo[];
extern char sipNm_QtGui_height[];
extern char sipNm_QtGui_width[];
extern char sipNm_QtGui_center[];
extern char sipNm_QtGui_bottomRight[];
extern char sipNm_QtGui_topLeft[];
extern char sipNm_QtGui_setBottom[];
extern char sipNm_QtGui_setTop[];
extern char sipNm_QtGui_bottom[];
extern char sipNm_QtGui_top[];
extern char sipNm_QtGui_intersects[];
extern char sipNm_QtGui_stateChanged[];
extern char sipNm_QtGui_finished[];
extern char sipNm_QtGui_started[];
extern char sipNm_QtGui_state[];
extern char sipNm_QtGui_Running[];
extern char sipNm_QtGui_NotRunning[];
extern char sipNm_QtGui_UnknownError[];
extern char sipNm_QtGui___div__[];
extern char sipNm_QtGui___sub__[];
extern char sipNm_QtGui___idiv__[];
extern char sipNm_QtGui___isub__[];
extern char sipNm_QtGui_y[];
extern char sipNm_QtGui_x[];
extern char sipNm_QtGui_propertyCount[];
extern char sipNm_QtGui_add[];
extern char sipNm_QtGui_disconnectNotify[];
extern char sipNm_QtGui_connectNotify[];
extern char sipNm_QtGui_customEvent[];
extern char sipNm_QtGui_childEvent[];
extern char sipNm_QtGui_timerEvent[];
extern char sipNm_QtGui_receivers[];
extern char sipNm_QtGui_sender[];
extern char sipNm_QtGui_property[];
extern char sipNm_QtGui_setProperty[];
extern char sipNm_QtGui_setParent[];
extern char sipNm_QtGui_children[];
extern char sipNm_QtGui_eventFilter[];
extern char sipNm_QtGui_QWidget[];
extern char sipNm_QtGui_setHtml[];
extern char sipNm_QtGui_setText[];
extern char sipNm_QtGui_text[];
extern char sipNm_QtGui_QTransform[];
extern char sipNm_QtGui_QMatrix[];
extern char sipNm_QtGui_QTextFormat[];
extern char sipNm_QtGui_QTextLength[];
extern char sipNm_QtGui_QPen[];
extern char sipNm_QtGui_QKeySequence[];
extern char sipNm_QtGui_QSizePolicy[];
extern char sipNm_QtGui_QCursor[];
extern char sipNm_QtGui_QBitmap[];
extern char sipNm_QtGui_QRegion[];
extern char sipNm_QtGui_QPolygon[];
extern char sipNm_QtGui_QImage[];
extern char sipNm_QtGui_QIcon[];
extern char sipNm_QtGui_QPalette[];
extern char sipNm_QtGui_QColor[];
extern char sipNm_QtGui_QBrush[];
extern char sipNm_QtGui_QPixmap[];
extern char sipNm_QtGui_QFont[];
extern char sipNm_QtGui_isEditable[];
extern char sipNm_QtGui_value[];
extern char sipNm_QtGui_key[];
extern char sipNm_QtGui_setDefault[];
extern char sipNm_QtGui_name[];
extern char sipNm_QtGui_language[];
extern char sipNm_QtGui_Myanmar[];
extern char sipNm_QtGui_Lao[];
extern char sipNm_QtGui_Syriac[];
extern char sipNm_QtGui_Vietnamese[];
extern char sipNm_QtGui_Tibetan[];
extern char sipNm_QtGui_Thai[];
extern char sipNm_QtGui_Telugu[];
extern char sipNm_QtGui_Tamil[];
extern char sipNm_QtGui_Oriya[];
extern char sipNm_QtGui_Malayalam[];
extern char sipNm_QtGui_Latin[];
extern char sipNm_QtGui_Korean[];
extern char sipNm_QtGui_Kannada[];
extern char sipNm_QtGui_Japanese[];
extern char sipNm_QtGui_Hebrew[];
extern char sipNm_QtGui_Gujarati[];
extern char sipNm_QtGui_Greek[];
extern char sipNm_QtGui_Georgian[];
extern char sipNm_QtGui_Bengali[];
extern char sipNm_QtGui_Armenian[];
extern char sipNm_QtGui_Arabic[];
extern char sipNm_QtGui_Language[];
extern char sipNm_QtGui_QList[];
extern char sipNm_QtGui_setAngle[];
extern char sipNm_QtGui_angle[];
extern char sipNm_QtGui_intersect[];
extern char sipNm_QtGui_setLine[];
extern char sipNm_QtGui_setPoints[];
extern char sipNm_QtGui_translated[];
extern char sipNm_QtGui_dy[];
extern char sipNm_QtGui_dx[];
extern char sipNm_QtGui_resolve[];
extern char sipNm_QtGui_load[];
extern char sipNm_QtGui_Text[];
extern char sipNm_QtGui_addPath[];
extern char sipNm_QtGui_lastModified[];
extern char sipNm_QtGui_group[];
extern char sipNm_QtGui_isDir[];
extern char sipNm_QtGui_isHidden[];
extern char sipNm_QtGui_suffix[];
extern char sipNm_QtGui_permissions[];
extern char sipNm_QtGui_fileInfo[];
extern char sipNm_QtGui_IteratorFlags[];
extern char sipNm_QtGui_IteratorFlag[];
extern char sipNm_QtGui_searchPaths[];
extern char sipNm_QtGui_setSearchPaths[];
extern char sipNm_QtGui_rootPath[];
extern char sipNm_QtGui_home[];
extern char sipNm_QtGui_refresh[];
extern char sipNm_QtGui_setSorting[];
extern char sipNm_QtGui_sorting[];
extern char sipNm_QtGui_setFilter[];
extern char sipNm_QtGui_filter[];
extern char sipNm_QtGui_setNameFilters[];
extern char sipNm_QtGui_filePath[];
extern char sipNm_QtGui_setPath[];
extern char sipNm_QtGui_Size[];
extern char sipNm_QtGui_Name[];
extern char sipNm_QtGui_System[];
extern char sipNm_QtGui_Hidden[];
extern char sipNm_QtGui_setTimeSpec[];
extern char sipNm_QtGui_setTime[];
extern char sipNm_QtGui_timeSpec[];
extern char sipNm_QtGui_time[];
extern char sipNm_QtGui_date[];
extern char sipNm_QtGui_restart[];
extern char sipNm_QtGui_setDate[];
extern char sipNm_QtGui_fromString[];
extern char sipNm_QtGui_toString[];
extern char sipNm_QtGui_version[];
extern char sipNm_QtGui_setStatus[];
extern char sipNm_QtGui_status[];
extern char sipNm_QtGui_setDevice[];
extern char sipNm_QtGui_device[];
extern char sipNm_QtGui_Ok[];
extern char sipNm_QtGui_Version[];
extern char sipNm_QtGui_result[];
extern char sipNm_QtGui_ignore[];
extern char sipNm_QtGui_accept[];
extern char sipNm_QtGui_type[];
extern char sipNm_QtGui_MaxUser[];
extern char sipNm_QtGui_User[];
extern char sipNm_QtGui_WhatsThis[];
extern char sipNm_QtGui_Clipboard[];
extern char sipNm_QtGui_Close[];
extern char sipNm_QtGui_None[];
extern char sipNm_QtGui_Type[];
extern char sipNm_QtGui_event[];
extern char sipNm_QtGui_testAttribute[];
extern char sipNm_QtGui_setAttribute[];
extern char sipNm_QtGui_translate[];
extern char sipNm_QtGui_notify[];
extern char sipNm_QtGui_sendEvent[];
extern char sipNm_QtGui_exec_[];
extern char sipNm_QtGui_direction[];
extern char sipNm_QtGui_Right[];
extern char sipNm_QtGui___add__[];
extern char sipNm_QtGui_contains[];
extern char sipNm_QtGui___imul__[];
extern char sipNm_QtGui___mul__[];
extern char sipNm_QtGui___contains__[];
extern char sipNm_QtGui___len__[];
extern char sipNm_QtGui_length[];
extern char sipNm_QtGui_setNum[];
extern char sipNm_QtGui___ge__[];
extern char sipNm_QtGui___le__[];
extern char sipNm_QtGui___gt__[];
extern char sipNm_QtGui___iadd__[];
extern char sipNm_QtGui_split[];
extern char sipNm_QtGui_replace[];
extern char sipNm_QtGui_insert[];
extern char sipNm_QtGui_append[];
extern char sipNm_QtGui_prepend[];
extern char sipNm_QtGui_simplified[];
extern char sipNm_QtGui_mid[];
extern char sipNm_QtGui_right[];
extern char sipNm_QtGui_left[];
extern char sipNm_QtGui_lastIndexOf[];
extern char sipNm_QtGui_indexOf[];
extern char sipNm_QtGui_qSwap[];
extern char sipNm_QtGui___rshift__[];
extern char sipNm_QtGui___lshift__[];
extern char sipNm_QtGui_at[];
extern char sipNm_QtGui___getitem__[];
extern char sipNm_QtGui_fill[];
extern char sipNm_QtGui_clear[];
extern char sipNm_QtGui_isDetached[];
extern char sipNm_QtGui_detach[];
extern char sipNm_QtGui_resize[];
extern char sipNm_QtGui_isNull[];
extern char sipNm_QtGui_isEmpty[];
extern char sipNm_QtGui_count[];
extern char sipNm_QtGui_stop[];
extern char sipNm_QtGui_start[];
extern char sipNm_QtGui_isActive[];
extern char sipNm_QtGui_createIndex[];
extern char sipNm_QtGui_removeColumn[];
extern char sipNm_QtGui_removeRow[];
extern char sipNm_QtGui_insertColumn[];
extern char sipNm_QtGui_insertRow[];
extern char sipNm_QtGui_changePersistentIndexList[];
extern char sipNm_QtGui_changePersistentIndex[];
extern char sipNm_QtGui_reset[];
extern char sipNm_QtGui_persistentIndexList[];
extern char sipNm_QtGui_endRemoveColumns[];
extern char sipNm_QtGui_beginRemoveColumns[];
extern char sipNm_QtGui_endInsertColumns[];
extern char sipNm_QtGui_beginInsertColumns[];
extern char sipNm_QtGui_endRemoveRows[];
extern char sipNm_QtGui_beginRemoveRows[];
extern char sipNm_QtGui_endInsertRows[];
extern char sipNm_QtGui_beginInsertRows[];
extern char sipNm_QtGui_decodeData[];
extern char sipNm_QtGui_encodeData[];
extern char sipNm_QtGui_revert[];
extern char sipNm_QtGui_submit[];
extern char sipNm_QtGui_headerDataChanged[];
extern char sipNm_QtGui_dataChanged[];
extern char sipNm_QtGui_span[];
extern char sipNm_QtGui_match[];
extern char sipNm_QtGui_buddy[];
extern char sipNm_QtGui_sort[];
extern char sipNm_QtGui_canFetchMore[];
extern char sipNm_QtGui_fetchMore[];
extern char sipNm_QtGui_removeColumns[];
extern char sipNm_QtGui_removeRows[];
extern char sipNm_QtGui_insertColumns[];
extern char sipNm_QtGui_insertRows[];
extern char sipNm_QtGui_supportedDropActions[];
extern char sipNm_QtGui_dropMimeData[];
extern char sipNm_QtGui_mimeData[];
extern char sipNm_QtGui_mimeTypes[];
extern char sipNm_QtGui_setItemData[];
extern char sipNm_QtGui_itemData[];
extern char sipNm_QtGui_setHeaderData[];
extern char sipNm_QtGui_headerData[];
extern char sipNm_QtGui_setData[];
extern char sipNm_QtGui_hasChildren[];
extern char sipNm_QtGui_columnCount[];
extern char sipNm_QtGui_rowCount[];
extern char sipNm_QtGui_index[];
extern char sipNm_QtGui___hash__[];
extern char sipNm_QtGui___lt__[];
extern char sipNm_QtGui_parent[];
extern char sipNm_QtGui_isValid[];
extern char sipNm_QtGui_model[];
extern char sipNm_QtGui_flags[];
extern char sipNm_QtGui_data[];
extern char sipNm_QtGui_column[];
extern char sipNm_QtGui_row[];
extern char sipNm_QtGui_child[];
extern char sipNm_QtGui_filters[];
extern char sipNm_QtGui_nameFilters[];
extern char sipNm_QtGui_path[];
extern char sipNm_QtGui_next[];
extern char sipNm_QtGui_map[];
extern char sipNm_QtGui_create[];
extern char sipNm_QtGui_errorString[];
extern char sipNm_QtGui_error[];
extern char sipNm_QtGui_write[];
extern char sipNm_QtGui_read[];
extern char sipNm_QtGui_handle[];
extern char sipNm_QtGui_setFileName[];
extern char sipNm_QtGui_fileName[];
extern char sipNm_QtGui_rmdir[];
extern char sipNm_QtGui_mkdir[];
extern char sipNm_QtGui_link[];
extern char sipNm_QtGui_copy[];
extern char sipNm_QtGui_remove[];
extern char sipNm_QtGui_pos[];
extern char sipNm_QtGui_size[];
extern char sipNm_QtGui_close[];
extern char sipNm_QtGui_atEnd[];
extern char sipNm_QtGui_FileName[];
extern char sipNm_QtGui_Refresh[];
extern char sipNm_QtGui_FileType[];
extern char sipNm_QtGui_NoSection[];
extern char sipNm_QtGui_ItemIsSelectable[];
extern char sipNm_QtGui_Checked[];
extern char sipNm_QtGui_RightToLeft[];
extern char sipNm_QtGui_LeftToRight[];
extern char sipNm_QtGui_LayoutDirection[];
extern char sipNm_QtGui_AnchorHref[];
extern char sipNm_QtGui_AnchorName[];
extern char sipNm_QtGui_TextFormat[];
extern char sipNm_QtGui_DashDotDotLine[];
extern char sipNm_QtGui_DashDotLine[];
extern char sipNm_QtGui_DotLine[];
extern char sipNm_QtGui_Desktop[];
extern char sipNm_QtGui_Window[];
extern char sipNm_QtGui_AlignBottom[];
extern char sipNm_QtGui_AlignTop[];
extern char sipNm_QtGui_NoButton[];
extern char sipNm_QtGui_yellow[];
extern char sipNm_QtGui_magenta[];
extern char sipNm_QtGui_cyan[];
extern char sipNm_QtGui_blue[];
extern char sipNm_QtGui_green[];
extern char sipNm_QtGui_red[];
extern char sipNm_QtGui_black[];
extern char sipNm_QtGui___nonzero__[];
extern char sipNm_QtGui___ne__[];
extern char sipNm_QtGui___eq__[];
extern char sipNm_QtGui___invert__[];
extern char sipNm_QtGui___and__[];
extern char sipNm_QtGui___xor__[];
extern char sipNm_QtGui___or__[];
extern char sipNm_QtGui___int__[];
extern char sipNm_QtGui___ixor__[];
extern char sipNm_QtGui___ior__[];
extern char sipNm_QtGui___iand__[];

#define sipEnum_QtMsgType              sipModuleAPI_QtGui_QtCore->em_enums[134]

#define sipClass_QPaintDevice             sipModuleAPI_QtGui.em_types[247]
#define sipCast_QPaintDevice              sipType_QtGui_QPaintDevice.td_cast
#define sipForceConvertTo_QPaintDevice    sipType_QtGui_QPaintDevice.td_fcto

#define sipEnum_QPaintDevice_PaintDeviceMetric              sipModuleAPI_QtGui.em_enums[173]

extern sipTypeDef sipType_QtGui_QPaintDevice;

#define sipClass_QWidget             sipModuleAPI_QtGui.em_types[253]
#define sipCast_QWidget              sipType_QtGui_QWidget.td_cast
#define sipForceConvertTo_QWidget    sipType_QtGui_QWidget.td_fcto

#define sipEnum_QWidget_RenderFlag              sipModuleAPI_QtGui.em_enums[7]

extern sipTypeDef sipType_QtGui_QWidget;

#define sipClass_QAbstractButton             sipModuleAPI_QtGui.em_types[346]
#define sipCast_QAbstractButton              sipType_QtGui_QAbstractButton.td_cast
#define sipForceConvertTo_QAbstractButton    sipType_QtGui_QAbstractButton.td_fcto

extern sipTypeDef sipType_QtGui_QAbstractButton;

#define sipClass_QAbstractItemDelegate             sipModuleAPI_QtGui.em_types[244]
#define sipCast_QAbstractItemDelegate              sipType_QtGui_QAbstractItemDelegate.td_cast
#define sipForceConvertTo_QAbstractItemDelegate    sipType_QtGui_QAbstractItemDelegate.td_fcto

#define sipEnum_QAbstractItemDelegate_EndEditHint              sipModuleAPI_QtGui.em_enums[289]

extern sipTypeDef sipType_QtGui_QAbstractItemDelegate;

#define sipClass_QFrame             sipModuleAPI_QtGui.em_types[317]
#define sipCast_QFrame              sipType_QtGui_QFrame.td_cast
#define sipForceConvertTo_QFrame    sipType_QtGui_QFrame.td_fcto

#define sipEnum_QFrame_StyleMask              sipModuleAPI_QtGui.em_enums[222]
#define sipEnum_QFrame_Shape              sipModuleAPI_QtGui.em_enums[223]
#define sipEnum_QFrame_Shadow              sipModuleAPI_QtGui.em_enums[224]

extern sipTypeDef sipType_QtGui_QFrame;

#define sipClass_QAbstractScrollArea             sipModuleAPI_QtGui.em_types[323]
#define sipCast_QAbstractScrollArea              sipType_QtGui_QAbstractScrollArea.td_cast
#define sipForceConvertTo_QAbstractScrollArea    sipType_QtGui_QAbstractScrollArea.td_fcto

extern sipTypeDef sipType_QtGui_QAbstractScrollArea;

#define sipClass_QAbstractItemView             sipModuleAPI_QtGui.em_types[335]
#define sipCast_QAbstractItemView              sipType_QtGui_QAbstractItemView.td_cast
#define sipForceConvertTo_QAbstractItemView    sipType_QtGui_QAbstractItemView.td_fcto

#define sipEnum_QAbstractItemView_DropIndicatorPosition              sipModuleAPI_QtGui.em_enums[280]
#define sipEnum_QAbstractItemView_State              sipModuleAPI_QtGui.em_enums[281]
#define sipEnum_QAbstractItemView_CursorAction              sipModuleAPI_QtGui.em_enums[282]
#define sipEnum_QAbstractItemView_SelectionMode              sipModuleAPI_QtGui.em_enums[283]
#define sipEnum_QAbstractItemView_SelectionBehavior              sipModuleAPI_QtGui.em_enums[284]
#define sipEnum_QAbstractItemView_ScrollMode              sipModuleAPI_QtGui.em_enums[285]
#define sipEnum_QAbstractItemView_ScrollHint              sipModuleAPI_QtGui.em_enums[286]
#define sipEnum_QAbstractItemView_EditTrigger              sipModuleAPI_QtGui.em_enums[287]
#define sipEnum_QAbstractItemView_DragDropMode              sipModuleAPI_QtGui.em_enums[288]

extern sipTypeDef sipType_QtGui_QAbstractItemView;

#define sipClass_QAbstractItemView_EditTriggers             sipModuleAPI_QtGui.em_types[336]
#define sipCast_QAbstractItemView_EditTriggers              sipType_QtGui_QAbstractItemView_EditTriggers.td_cast
#define sipForceConvertTo_QAbstractItemView_EditTriggers    sipType_QtGui_QAbstractItemView_EditTriggers.td_fcto

extern sipTypeDef sipType_QtGui_QAbstractItemView_EditTriggers;

#define sipClass_QDialog             sipModuleAPI_QtGui.em_types[299]
#define sipCast_QDialog              sipType_QtGui_QDialog.td_cast
#define sipForceConvertTo_QDialog    sipType_QtGui_QDialog.td_fcto

#define sipEnum_QDialog_DialogCode              sipModuleAPI_QtGui.em_enums[253]

extern sipTypeDef sipType_QtGui_QDialog;

#define sipClass_QAbstractPrintDialog             sipModuleAPI_QtGui.em_types[314]
#define sipCast_QAbstractPrintDialog              sipType_QtGui_QAbstractPrintDialog.td_cast
#define sipForceConvertTo_QAbstractPrintDialog    sipType_QtGui_QAbstractPrintDialog.td_fcto

#define sipEnum_QAbstractPrintDialog_PrintDialogOption              sipModuleAPI_QtGui.em_enums[278]
#define sipEnum_QAbstractPrintDialog_PrintRange              sipModuleAPI_QtGui.em_enums[279]

extern sipTypeDef sipType_QtGui_QAbstractPrintDialog;

#define sipClass_QAbstractPrintDialog_PrintDialogOptions             sipModuleAPI_QtGui.em_types[315]
#define sipCast_QAbstractPrintDialog_PrintDialogOptions              sipType_QtGui_QAbstractPrintDialog_PrintDialogOptions.td_cast
#define sipForceConvertTo_QAbstractPrintDialog_PrintDialogOptions    sipType_QtGui_QAbstractPrintDialog_PrintDialogOptions.td_fcto

extern sipTypeDef sipType_QtGui_QAbstractPrintDialog_PrintDialogOptions;

#define sipClass_QAbstractProxyModel             sipModuleAPI_QtGui.em_types[242]
#define sipCast_QAbstractProxyModel              sipType_QtGui_QAbstractProxyModel.td_cast
#define sipForceConvertTo_QAbstractProxyModel    sipType_QtGui_QAbstractProxyModel.td_fcto

extern sipTypeDef sipType_QtGui_QAbstractProxyModel;

#define sipClass_QAbstractSpinBox             sipModuleAPI_QtGui.em_types[291]
#define sipCast_QAbstractSpinBox              sipType_QtGui_QAbstractSpinBox.td_cast
#define sipForceConvertTo_QAbstractSpinBox    sipType_QtGui_QAbstractSpinBox.td_fcto

#define sipEnum_QAbstractSpinBox_CorrectionMode              sipModuleAPI_QtGui.em_enums[275]
#define sipEnum_QAbstractSpinBox_ButtonSymbols              sipModuleAPI_QtGui.em_enums[276]
#define sipEnum_QAbstractSpinBox_StepEnabledFlag              sipModuleAPI_QtGui.em_enums[277]

extern sipTypeDef sipType_QtGui_QAbstractSpinBox;

#define sipClass_QAbstractSpinBox_StepEnabled             sipModuleAPI_QtGui.em_types[292]
#define sipCast_QAbstractSpinBox_StepEnabled              sipType_QtGui_QAbstractSpinBox_StepEnabled.td_cast
#define sipForceConvertTo_QAbstractSpinBox_StepEnabled    sipType_QtGui_QAbstractSpinBox_StepEnabled.td_fcto

extern sipTypeDef sipType_QtGui_QAbstractSpinBox_StepEnabled;

#define sipClass_QAbstractTextDocumentLayout             sipModuleAPI_QtGui.em_types[238]
#define sipCast_QAbstractTextDocumentLayout              sipType_QtGui_QAbstractTextDocumentLayout.td_cast
#define sipForceConvertTo_QAbstractTextDocumentLayout    sipType_QtGui_QAbstractTextDocumentLayout.td_fcto

extern sipTypeDef sipType_QtGui_QAbstractTextDocumentLayout;

#define sipClass_QAbstractTextDocumentLayout_Selection             sipModuleAPI_QtGui.em_types[240]
#define sipCast_QAbstractTextDocumentLayout_Selection              sipType_QtGui_QAbstractTextDocumentLayout_Selection.td_cast
#define sipForceConvertTo_QAbstractTextDocumentLayout_Selection    sipType_QtGui_QAbstractTextDocumentLayout_Selection.td_fcto

extern sipTypeDef sipType_QtGui_QAbstractTextDocumentLayout_Selection;

#define sipClass_QAbstractTextDocumentLayout_PaintContext             sipModuleAPI_QtGui.em_types[239]
#define sipCast_QAbstractTextDocumentLayout_PaintContext              sipType_QtGui_QAbstractTextDocumentLayout_PaintContext.td_cast
#define sipForceConvertTo_QAbstractTextDocumentLayout_PaintContext    sipType_QtGui_QAbstractTextDocumentLayout_PaintContext.td_fcto

extern sipTypeDef sipType_QtGui_QAbstractTextDocumentLayout_PaintContext;

#define sipClass_QAbstractSlider             sipModuleAPI_QtGui.em_types[287]
#define sipCast_QAbstractSlider              sipType_QtGui_QAbstractSlider.td_cast
#define sipForceConvertTo_QAbstractSlider    sipType_QtGui_QAbstractSlider.td_fcto

#define sipEnum_QAbstractSlider_SliderChange              sipModuleAPI_QtGui.em_enums[273]
#define sipEnum_QAbstractSlider_SliderAction              sipModuleAPI_QtGui.em_enums[274]

extern sipTypeDef sipType_QtGui_QAbstractSlider;

#define sipClass_QAction             sipModuleAPI_QtGui.em_types[236]
#define sipCast_QAction              sipType_QtGui_QAction.td_cast
#define sipForceConvertTo_QAction    sipType_QtGui_QAction.td_fcto

#define sipEnum_QAction_MenuRole              sipModuleAPI_QtGui.em_enums[271]
#define sipEnum_QAction_ActionEvent              sipModuleAPI_QtGui.em_enums[272]

extern sipTypeDef sipType_QtGui_QAction;

#define sipClass_QActionGroup             sipModuleAPI_QtGui.em_types[235]
#define sipCast_QActionGroup              sipType_QtGui_QActionGroup.td_cast
#define sipForceConvertTo_QActionGroup    sipType_QtGui_QActionGroup.td_fcto

extern sipTypeDef sipType_QtGui_QActionGroup;

#define sipClass_QApplication             sipModuleAPI_QtGui.em_types[234]
#define sipCast_QApplication              sipType_QtGui_QApplication.td_cast
#define sipForceConvertTo_QApplication    sipType_QtGui_QApplication.td_fcto

#define sipEnum_QApplication_ColorSpec              sipModuleAPI_QtGui.em_enums[269]
#define sipEnum_QApplication_Type              sipModuleAPI_QtGui.em_enums[270]

extern sipTypeDef sipType_QtGui_QApplication;

#define sipClass_QPixmap             sipModuleAPI_QtGui.em_types[251]
#define sipCast_QPixmap              sipType_QtGui_QPixmap.td_cast
#define sipForceConvertTo_QPixmap    sipType_QtGui_QPixmap.td_fcto

extern sipTypeDef sipType_QtGui_QPixmap;

#define sipClass_QBitmap             sipModuleAPI_QtGui.em_types[252]
#define sipCast_QBitmap              sipType_QtGui_QBitmap.td_cast
#define sipForceConvertTo_QBitmap    sipType_QtGui_QBitmap.td_fcto

extern sipTypeDef sipType_QtGui_QBitmap;

#define sipClass_QLayoutItem             sipModuleAPI_QtGui.em_types[224]
#define sipCast_QLayoutItem              sipType_QtGui_QLayoutItem.td_cast
#define sipForceConvertTo_QLayoutItem    sipType_QtGui_QLayoutItem.td_fcto

extern sipTypeDef sipType_QtGui_QLayoutItem;

#define sipClass_QLayout             sipModuleAPI_QtGui.em_types[227]
#define sipCast_QLayout              sipType_QtGui_QLayout.td_cast
#define sipForceConvertTo_QLayout    sipType_QtGui_QLayout.td_fcto

#define sipEnum_QLayout_SizeConstraint              sipModuleAPI_QtGui.em_enums[196]

extern sipTypeDef sipType_QtGui_QLayout;

#define sipClass_QBoxLayout             sipModuleAPI_QtGui.em_types[231]
#define sipCast_QBoxLayout              sipType_QtGui_QBoxLayout.td_cast
#define sipForceConvertTo_QBoxLayout    sipType_QtGui_QBoxLayout.td_fcto

#define sipEnum_QBoxLayout_Direction              sipModuleAPI_QtGui.em_enums[268]

extern sipTypeDef sipType_QtGui_QBoxLayout;

#define sipClass_QHBoxLayout             sipModuleAPI_QtGui.em_types[233]
#define sipCast_QHBoxLayout              sipType_QtGui_QHBoxLayout.td_cast
#define sipForceConvertTo_QHBoxLayout    sipType_QtGui_QHBoxLayout.td_fcto

extern sipTypeDef sipType_QtGui_QHBoxLayout;

#define sipClass_QVBoxLayout             sipModuleAPI_QtGui.em_types[232]
#define sipCast_QVBoxLayout              sipType_QtGui_QVBoxLayout.td_cast
#define sipForceConvertTo_QVBoxLayout    sipType_QtGui_QVBoxLayout.td_fcto

extern sipTypeDef sipType_QtGui_QVBoxLayout;

#define sipClass_QColor             sipModuleAPI_QtGui.em_types[223]
#define sipCast_QColor              sipType_QtGui_QColor.td_cast
#define sipForceConvertTo_QColor    sipType_QtGui_QColor.td_fcto

#define sipEnum_QColor_Spec              sipModuleAPI_QtGui.em_enums[267]

extern sipTypeDef sipType_QtGui_QColor;

#define sipClass_QPushButton             sipModuleAPI_QtGui.em_types[350]
#define sipCast_QPushButton              sipType_QtGui_QPushButton.td_cast
#define sipForceConvertTo_QPushButton    sipType_QtGui_QPushButton.td_fcto

extern sipTypeDef sipType_QtGui_QPushButton;

#define sipClass_QCommandLinkButton             sipModuleAPI_QtGui.em_types[351]
#define sipCast_QCommandLinkButton              sipType_QtGui_QCommandLinkButton.td_cast
#define sipForceConvertTo_QCommandLinkButton    sipType_QtGui_QCommandLinkButton.td_fcto

extern sipTypeDef sipType_QtGui_QCommandLinkButton;

#define sipClass_QBrush             sipModuleAPI_QtGui.em_types[222]
#define sipCast_QBrush              sipType_QtGui_QBrush.td_cast
#define sipForceConvertTo_QBrush    sipType_QtGui_QBrush.td_fcto

extern sipTypeDef sipType_QtGui_QBrush;

#define sipClass_QGradient             sipModuleAPI_QtGui.em_types[218]
#define sipCast_QGradient              sipType_QtGui_QGradient.td_cast
#define sipForceConvertTo_QGradient    sipType_QtGui_QGradient.td_fcto

#define sipEnum_QGradient_Spread              sipModuleAPI_QtGui.em_enums[265]
#define sipEnum_QGradient_Type              sipModuleAPI_QtGui.em_enums[266]

extern sipTypeDef sipType_QtGui_QGradient;

#define sipClass_QLinearGradient             sipModuleAPI_QtGui.em_types[221]
#define sipCast_QLinearGradient              sipType_QtGui_QLinearGradient.td_cast
#define sipForceConvertTo_QLinearGradient    sipType_QtGui_QLinearGradient.td_fcto

extern sipTypeDef sipType_QtGui_QLinearGradient;

#define sipClass_QRadialGradient             sipModuleAPI_QtGui.em_types[220]
#define sipCast_QRadialGradient              sipType_QtGui_QRadialGradient.td_cast
#define sipForceConvertTo_QRadialGradient    sipType_QtGui_QRadialGradient.td_fcto

extern sipTypeDef sipType_QtGui_QRadialGradient;

#define sipClass_QConicalGradient             sipModuleAPI_QtGui.em_types[219]
#define sipCast_QConicalGradient              sipType_QtGui_QConicalGradient.td_cast
#define sipForceConvertTo_QConicalGradient    sipType_QtGui_QConicalGradient.td_fcto

extern sipTypeDef sipType_QtGui_QConicalGradient;

#define sipClass_QButtonGroup             sipModuleAPI_QtGui.em_types[217]
#define sipCast_QButtonGroup              sipType_QtGui_QButtonGroup.td_cast
#define sipForceConvertTo_QButtonGroup    sipType_QtGui_QButtonGroup.td_fcto

extern sipTypeDef sipType_QtGui_QButtonGroup;

#define sipClass_QCalendarWidget             sipModuleAPI_QtGui.em_types[286]
#define sipCast_QCalendarWidget              sipType_QtGui_QCalendarWidget.td_cast
#define sipForceConvertTo_QCalendarWidget    sipType_QtGui_QCalendarWidget.td_fcto

#define sipEnum_QCalendarWidget_SelectionMode              sipModuleAPI_QtGui.em_enums[262]
#define sipEnum_QCalendarWidget_VerticalHeaderFormat              sipModuleAPI_QtGui.em_enums[263]
#define sipEnum_QCalendarWidget_HorizontalHeaderFormat              sipModuleAPI_QtGui.em_enums[264]

extern sipTypeDef sipType_QtGui_QCalendarWidget;

#define sipClass_QCheckBox             sipModuleAPI_QtGui.em_types[349]
#define sipCast_QCheckBox              sipType_QtGui_QCheckBox.td_cast
#define sipForceConvertTo_QCheckBox    sipType_QtGui_QCheckBox.td_fcto

extern sipTypeDef sipType_QtGui_QCheckBox;

#define sipClass_QClipboard             sipModuleAPI_QtGui.em_types[216]
#define sipCast_QClipboard              sipType_QtGui_QClipboard.td_cast
#define sipForceConvertTo_QClipboard    sipType_QtGui_QClipboard.td_fcto

#define sipEnum_QClipboard_Mode              sipModuleAPI_QtGui.em_enums[261]

extern sipTypeDef sipType_QtGui_QClipboard;

#define sipClass_QColumnView             sipModuleAPI_QtGui.em_types[345]
#define sipCast_QColumnView              sipType_QtGui_QColumnView.td_cast
#define sipForceConvertTo_QColumnView    sipType_QtGui_QColumnView.td_fcto

extern sipTypeDef sipType_QtGui_QColumnView;

#define sipClass_QColorDialog             sipModuleAPI_QtGui.em_types[313]
#define sipCast_QColorDialog              sipType_QtGui_QColorDialog.td_cast
#define sipForceConvertTo_QColorDialog    sipType_QtGui_QColorDialog.td_fcto

extern sipTypeDef sipType_QtGui_QColorDialog;

#define sipClass_QComboBox             sipModuleAPI_QtGui.em_types[283]
#define sipCast_QComboBox              sipType_QtGui_QComboBox.td_cast
#define sipForceConvertTo_QComboBox    sipType_QtGui_QComboBox.td_fcto

#define sipEnum_QComboBox_SizeAdjustPolicy              sipModuleAPI_QtGui.em_enums[259]
#define sipEnum_QComboBox_InsertPolicy              sipModuleAPI_QtGui.em_enums[260]

extern sipTypeDef sipType_QtGui_QComboBox;

#define sipClass_QCompleter             sipModuleAPI_QtGui.em_types[215]
#define sipCast_QCompleter              sipType_QtGui_QCompleter.td_cast
#define sipForceConvertTo_QCompleter    sipType_QtGui_QCompleter.td_fcto

#define sipEnum_QCompleter_ModelSorting              sipModuleAPI_QtGui.em_enums[257]
#define sipEnum_QCompleter_CompletionMode              sipModuleAPI_QtGui.em_enums[258]

extern sipTypeDef sipType_QtGui_QCompleter;

#define sipClass_QCursor             sipModuleAPI_QtGui.em_types[214]
#define sipCast_QCursor              sipType_QtGui_QCursor.td_cast
#define sipForceConvertTo_QCursor    sipType_QtGui_QCursor.td_fcto

extern sipTypeDef sipType_QtGui_QCursor;

#define sipClass_QDataWidgetMapper             sipModuleAPI_QtGui.em_types[213]
#define sipCast_QDataWidgetMapper              sipType_QtGui_QDataWidgetMapper.td_cast
#define sipForceConvertTo_QDataWidgetMapper    sipType_QtGui_QDataWidgetMapper.td_fcto

#define sipEnum_QDataWidgetMapper_SubmitPolicy              sipModuleAPI_QtGui.em_enums[256]

extern sipTypeDef sipType_QtGui_QDataWidgetMapper;

#define sipClass_QDateTimeEdit             sipModuleAPI_QtGui.em_types[295]
#define sipCast_QDateTimeEdit              sipType_QtGui_QDateTimeEdit.td_cast
#define sipForceConvertTo_QDateTimeEdit    sipType_QtGui_QDateTimeEdit.td_fcto

#define sipEnum_QDateTimeEdit_Section              sipModuleAPI_QtGui.em_enums[255]

extern sipTypeDef sipType_QtGui_QDateTimeEdit;

#define sipClass_QDateTimeEdit_Sections             sipModuleAPI_QtGui.em_types[296]
#define sipCast_QDateTimeEdit_Sections              sipType_QtGui_QDateTimeEdit_Sections.td_cast
#define sipForceConvertTo_QDateTimeEdit_Sections    sipType_QtGui_QDateTimeEdit_Sections.td_fcto

extern sipTypeDef sipType_QtGui_QDateTimeEdit_Sections;

#define sipClass_QTimeEdit             sipModuleAPI_QtGui.em_types[298]
#define sipCast_QTimeEdit              sipType_QtGui_QTimeEdit.td_cast
#define sipForceConvertTo_QTimeEdit    sipType_QtGui_QTimeEdit.td_fcto

extern sipTypeDef sipType_QtGui_QTimeEdit;

#define sipClass_QDateEdit             sipModuleAPI_QtGui.em_types[297]
#define sipCast_QDateEdit              sipType_QtGui_QDateEdit.td_cast
#define sipForceConvertTo_QDateEdit    sipType_QtGui_QDateEdit.td_fcto

extern sipTypeDef sipType_QtGui_QDateEdit;

#define sipClass_QDesktopServices             sipModuleAPI_QtGui.em_types[212]
#define sipCast_QDesktopServices              sipType_QtGui_QDesktopServices.td_cast
#define sipForceConvertTo_QDesktopServices    sipType_QtGui_QDesktopServices.td_fcto

#define sipEnum_QDesktopServices_StandardLocation              sipModuleAPI_QtGui.em_enums[254]

extern sipTypeDef sipType_QtGui_QDesktopServices;

#define sipClass_QDesktopWidget             sipModuleAPI_QtGui.em_types[282]
#define sipCast_QDesktopWidget              sipType_QtGui_QDesktopWidget.td_cast
#define sipForceConvertTo_QDesktopWidget    sipType_QtGui_QDesktopWidget.td_fcto

extern sipTypeDef sipType_QtGui_QDesktopWidget;

#define sipClass_QDial             sipModuleAPI_QtGui.em_types[290]
#define sipCast_QDial              sipType_QtGui_QDial.td_cast
#define sipForceConvertTo_QDial    sipType_QtGui_QDial.td_fcto

extern sipTypeDef sipType_QtGui_QDial;

#define sipClass_QDialogButtonBox             sipModuleAPI_QtGui.em_types[280]
#define sipCast_QDialogButtonBox              sipType_QtGui_QDialogButtonBox.td_cast
#define sipForceConvertTo_QDialogButtonBox    sipType_QtGui_QDialogButtonBox.td_fcto

#define sipEnum_QDialogButtonBox_StandardButton              sipModuleAPI_QtGui.em_enums[250]
#define sipEnum_QDialogButtonBox_ButtonRole              sipModuleAPI_QtGui.em_enums[251]
#define sipEnum_QDialogButtonBox_ButtonLayout              sipModuleAPI_QtGui.em_enums[252]

extern sipTypeDef sipType_QtGui_QDialogButtonBox;

#define sipClass_QDialogButtonBox_StandardButtons             sipModuleAPI_QtGui.em_types[281]
#define sipCast_QDialogButtonBox_StandardButtons              sipType_QtGui_QDialogButtonBox_StandardButtons.td_cast
#define sipForceConvertTo_QDialogButtonBox_StandardButtons    sipType_QtGui_QDialogButtonBox_StandardButtons.td_fcto

extern sipTypeDef sipType_QtGui_QDialogButtonBox_StandardButtons;

#define sipClass_QDirModel             sipModuleAPI_QtGui.em_types[211]
#define sipCast_QDirModel              sipType_QtGui_QDirModel.td_cast
#define sipForceConvertTo_QDirModel    sipType_QtGui_QDirModel.td_fcto

#define sipEnum_QDirModel_Roles              sipModuleAPI_QtGui.em_enums[249]

extern sipTypeDef sipType_QtGui_QDirModel;

#define sipClass_QDockWidget             sipModuleAPI_QtGui.em_types[278]
#define sipCast_QDockWidget              sipType_QtGui_QDockWidget.td_cast
#define sipForceConvertTo_QDockWidget    sipType_QtGui_QDockWidget.td_fcto

#define sipEnum_QDockWidget_DockWidgetFeature              sipModuleAPI_QtGui.em_enums[248]

extern sipTypeDef sipType_QtGui_QDockWidget;

#define sipClass_QDockWidget_DockWidgetFeatures             sipModuleAPI_QtGui.em_types[279]
#define sipCast_QDockWidget_DockWidgetFeatures              sipType_QtGui_QDockWidget_DockWidgetFeatures.td_cast
#define sipForceConvertTo_QDockWidget_DockWidgetFeatures    sipType_QtGui_QDockWidget_DockWidgetFeatures.td_fcto

extern sipTypeDef sipType_QtGui_QDockWidget_DockWidgetFeatures;

#define sipClass_QDrag             sipModuleAPI_QtGui.em_types[210]
#define sipCast_QDrag              sipType_QtGui_QDrag.td_cast
#define sipForceConvertTo_QDrag    sipType_QtGui_QDrag.td_fcto

extern sipTypeDef sipType_QtGui_QDrag;

#define sipClass_QErrorMessage             sipModuleAPI_QtGui.em_types[312]
#define sipCast_QErrorMessage              sipType_QtGui_QErrorMessage.td_cast
#define sipForceConvertTo_QErrorMessage    sipType_QtGui_QErrorMessage.td_fcto

extern sipTypeDef sipType_QtGui_QErrorMessage;

#define sipClass_QInputEvent             sipModuleAPI_QtGui.em_types[204]
#define sipCast_QInputEvent              sipType_QtGui_QInputEvent.td_cast
#define sipForceConvertTo_QInputEvent    sipType_QtGui_QInputEvent.td_fcto

extern sipTypeDef sipType_QtGui_QInputEvent;

#define sipClass_QMouseEvent             sipModuleAPI_QtGui.em_types[209]
#define sipCast_QMouseEvent              sipType_QtGui_QMouseEvent.td_cast
#define sipForceConvertTo_QMouseEvent    sipType_QtGui_QMouseEvent.td_fcto

extern sipTypeDef sipType_QtGui_QMouseEvent;

#define sipClass_QHoverEvent             sipModuleAPI_QtGui.em_types[203]
#define sipCast_QHoverEvent              sipType_QtGui_QHoverEvent.td_cast
#define sipForceConvertTo_QHoverEvent    sipType_QtGui_QHoverEvent.td_fcto

extern sipTypeDef sipType_QtGui_QHoverEvent;

#define sipClass_QWheelEvent             sipModuleAPI_QtGui.em_types[208]
#define sipCast_QWheelEvent              sipType_QtGui_QWheelEvent.td_cast
#define sipForceConvertTo_QWheelEvent    sipType_QtGui_QWheelEvent.td_fcto

extern sipTypeDef sipType_QtGui_QWheelEvent;

#define sipClass_QTabletEvent             sipModuleAPI_QtGui.em_types[207]
#define sipCast_QTabletEvent              sipType_QtGui_QTabletEvent.td_cast
#define sipForceConvertTo_QTabletEvent    sipType_QtGui_QTabletEvent.td_fcto

#define sipEnum_QTabletEvent_PointerType              sipModuleAPI_QtGui.em_enums[246]
#define sipEnum_QTabletEvent_TabletDevice              sipModuleAPI_QtGui.em_enums[247]

extern sipTypeDef sipType_QtGui_QTabletEvent;

#define sipClass_QKeyEvent             sipModuleAPI_QtGui.em_types[206]
#define sipCast_QKeyEvent              sipType_QtGui_QKeyEvent.td_cast
#define sipForceConvertTo_QKeyEvent    sipType_QtGui_QKeyEvent.td_fcto

extern sipTypeDef sipType_QtGui_QKeyEvent;

#define sipClass_QFocusEvent             sipModuleAPI_QtGui.em_types[202]
#define sipCast_QFocusEvent              sipType_QtGui_QFocusEvent.td_cast
#define sipForceConvertTo_QFocusEvent    sipType_QtGui_QFocusEvent.td_fcto

extern sipTypeDef sipType_QtGui_QFocusEvent;

#define sipClass_QPaintEvent             sipModuleAPI_QtGui.em_types[201]
#define sipCast_QPaintEvent              sipType_QtGui_QPaintEvent.td_cast
#define sipForceConvertTo_QPaintEvent    sipType_QtGui_QPaintEvent.td_fcto

extern sipTypeDef sipType_QtGui_QPaintEvent;

#define sipClass_QMoveEvent             sipModuleAPI_QtGui.em_types[200]
#define sipCast_QMoveEvent              sipType_QtGui_QMoveEvent.td_cast
#define sipForceConvertTo_QMoveEvent    sipType_QtGui_QMoveEvent.td_fcto

extern sipTypeDef sipType_QtGui_QMoveEvent;

#define sipClass_QResizeEvent             sipModuleAPI_QtGui.em_types[199]
#define sipCast_QResizeEvent              sipType_QtGui_QResizeEvent.td_cast
#define sipForceConvertTo_QResizeEvent    sipType_QtGui_QResizeEvent.td_fcto

extern sipTypeDef sipType_QtGui_QResizeEvent;

#define sipClass_QCloseEvent             sipModuleAPI_QtGui.em_types[198]
#define sipCast_QCloseEvent              sipType_QtGui_QCloseEvent.td_cast
#define sipForceConvertTo_QCloseEvent    sipType_QtGui_QCloseEvent.td_fcto

extern sipTypeDef sipType_QtGui_QCloseEvent;

#define sipClass_QIconDragEvent             sipModuleAPI_QtGui.em_types[197]
#define sipCast_QIconDragEvent              sipType_QtGui_QIconDragEvent.td_cast
#define sipForceConvertTo_QIconDragEvent    sipType_QtGui_QIconDragEvent.td_fcto

extern sipTypeDef sipType_QtGui_QIconDragEvent;

#define sipClass_QShowEvent             sipModuleAPI_QtGui.em_types[196]
#define sipCast_QShowEvent              sipType_QtGui_QShowEvent.td_cast
#define sipForceConvertTo_QShowEvent    sipType_QtGui_QShowEvent.td_fcto

extern sipTypeDef sipType_QtGui_QShowEvent;

#define sipClass_QHideEvent             sipModuleAPI_QtGui.em_types[195]
#define sipCast_QHideEvent              sipType_QtGui_QHideEvent.td_cast
#define sipForceConvertTo_QHideEvent    sipType_QtGui_QHideEvent.td_fcto

extern sipTypeDef sipType_QtGui_QHideEvent;

#define sipClass_QContextMenuEvent             sipModuleAPI_QtGui.em_types[205]
#define sipCast_QContextMenuEvent              sipType_QtGui_QContextMenuEvent.td_cast
#define sipForceConvertTo_QContextMenuEvent    sipType_QtGui_QContextMenuEvent.td_fcto

#define sipEnum_QContextMenuEvent_Reason              sipModuleAPI_QtGui.em_enums[245]

extern sipTypeDef sipType_QtGui_QContextMenuEvent;

#define sipClass_QInputMethodEvent             sipModuleAPI_QtGui.em_types[193]
#define sipCast_QInputMethodEvent              sipType_QtGui_QInputMethodEvent.td_cast
#define sipForceConvertTo_QInputMethodEvent    sipType_QtGui_QInputMethodEvent.td_fcto

#define sipEnum_QInputMethodEvent_AttributeType              sipModuleAPI_QtGui.em_enums[244]

extern sipTypeDef sipType_QtGui_QInputMethodEvent;

#define sipClass_QInputMethodEvent_Attribute             sipModuleAPI_QtGui.em_types[194]
#define sipCast_QInputMethodEvent_Attribute              sipType_QtGui_QInputMethodEvent_Attribute.td_cast
#define sipForceConvertTo_QInputMethodEvent_Attribute    sipType_QtGui_QInputMethodEvent_Attribute.td_fcto

extern sipTypeDef sipType_QtGui_QInputMethodEvent_Attribute;

#define sipClass_QMimeSource             sipModuleAPI_QtGui.em_types[189]
#define sipCast_QMimeSource              sipType_QtGui_QMimeSource.td_cast
#define sipForceConvertTo_QMimeSource    sipType_QtGui_QMimeSource.td_fcto

extern sipTypeDef sipType_QtGui_QMimeSource;

#define sipClass_QDropEvent             sipModuleAPI_QtGui.em_types[190]
#define sipCast_QDropEvent              sipType_QtGui_QDropEvent.td_cast
#define sipForceConvertTo_QDropEvent    sipType_QtGui_QDropEvent.td_fcto

extern sipTypeDef sipType_QtGui_QDropEvent;

#define sipClass_QDragMoveEvent             sipModuleAPI_QtGui.em_types[191]
#define sipCast_QDragMoveEvent              sipType_QtGui_QDragMoveEvent.td_cast
#define sipForceConvertTo_QDragMoveEvent    sipType_QtGui_QDragMoveEvent.td_fcto

extern sipTypeDef sipType_QtGui_QDragMoveEvent;

#define sipClass_QDragEnterEvent             sipModuleAPI_QtGui.em_types[192]
#define sipCast_QDragEnterEvent              sipType_QtGui_QDragEnterEvent.td_cast
#define sipForceConvertTo_QDragEnterEvent    sipType_QtGui_QDragEnterEvent.td_fcto

extern sipTypeDef sipType_QtGui_QDragEnterEvent;

#define sipClass_QDragLeaveEvent             sipModuleAPI_QtGui.em_types[188]
#define sipCast_QDragLeaveEvent              sipType_QtGui_QDragLeaveEvent.td_cast
#define sipForceConvertTo_QDragLeaveEvent    sipType_QtGui_QDragLeaveEvent.td_fcto

extern sipTypeDef sipType_QtGui_QDragLeaveEvent;

#define sipClass_QHelpEvent             sipModuleAPI_QtGui.em_types[187]
#define sipCast_QHelpEvent              sipType_QtGui_QHelpEvent.td_cast
#define sipForceConvertTo_QHelpEvent    sipType_QtGui_QHelpEvent.td_fcto

extern sipTypeDef sipType_QtGui_QHelpEvent;

#define sipClass_QStatusTipEvent             sipModuleAPI_QtGui.em_types[186]
#define sipCast_QStatusTipEvent              sipType_QtGui_QStatusTipEvent.td_cast
#define sipForceConvertTo_QStatusTipEvent    sipType_QtGui_QStatusTipEvent.td_fcto

extern sipTypeDef sipType_QtGui_QStatusTipEvent;

#define sipClass_QWhatsThisClickedEvent             sipModuleAPI_QtGui.em_types[185]
#define sipCast_QWhatsThisClickedEvent              sipType_QtGui_QWhatsThisClickedEvent.td_cast
#define sipForceConvertTo_QWhatsThisClickedEvent    sipType_QtGui_QWhatsThisClickedEvent.td_fcto

extern sipTypeDef sipType_QtGui_QWhatsThisClickedEvent;

#define sipClass_QActionEvent             sipModuleAPI_QtGui.em_types[184]
#define sipCast_QActionEvent              sipType_QtGui_QActionEvent.td_cast
#define sipForceConvertTo_QActionEvent    sipType_QtGui_QActionEvent.td_fcto

extern sipTypeDef sipType_QtGui_QActionEvent;

#define sipClass_QFileOpenEvent             sipModuleAPI_QtGui.em_types[183]
#define sipCast_QFileOpenEvent              sipType_QtGui_QFileOpenEvent.td_cast
#define sipForceConvertTo_QFileOpenEvent    sipType_QtGui_QFileOpenEvent.td_fcto

extern sipTypeDef sipType_QtGui_QFileOpenEvent;

#define sipClass_QShortcutEvent             sipModuleAPI_QtGui.em_types[182]
#define sipCast_QShortcutEvent              sipType_QtGui_QShortcutEvent.td_cast
#define sipForceConvertTo_QShortcutEvent    sipType_QtGui_QShortcutEvent.td_fcto

extern sipTypeDef sipType_QtGui_QShortcutEvent;

#define sipClass_QWindowStateChangeEvent             sipModuleAPI_QtGui.em_types[181]
#define sipCast_QWindowStateChangeEvent              sipType_QtGui_QWindowStateChangeEvent.td_cast
#define sipForceConvertTo_QWindowStateChangeEvent    sipType_QtGui_QWindowStateChangeEvent.td_fcto

extern sipTypeDef sipType_QtGui_QWindowStateChangeEvent;

#define sipClass_QFileDialog             sipModuleAPI_QtGui.em_types[310]
#define sipCast_QFileDialog              sipType_QtGui_QFileDialog.td_cast
#define sipForceConvertTo_QFileDialog    sipType_QtGui_QFileDialog.td_fcto

#define sipEnum_QFileDialog_Option              sipModuleAPI_QtGui.em_enums[239]
#define sipEnum_QFileDialog_DialogLabel              sipModuleAPI_QtGui.em_enums[240]
#define sipEnum_QFileDialog_AcceptMode              sipModuleAPI_QtGui.em_enums[241]
#define sipEnum_QFileDialog_FileMode              sipModuleAPI_QtGui.em_enums[242]
#define sipEnum_QFileDialog_ViewMode              sipModuleAPI_QtGui.em_enums[243]

extern sipTypeDef sipType_QtGui_QFileDialog;

#define sipClass_QFileDialog_Options             sipModuleAPI_QtGui.em_types[311]
#define sipCast_QFileDialog_Options              sipType_QtGui_QFileDialog_Options.td_cast
#define sipForceConvertTo_QFileDialog_Options    sipType_QtGui_QFileDialog_Options.td_fcto

extern sipTypeDef sipType_QtGui_QFileDialog_Options;

#define sipClass_QFileIconProvider             sipModuleAPI_QtGui.em_types[180]
#define sipCast_QFileIconProvider              sipType_QtGui_QFileIconProvider.td_cast
#define sipForceConvertTo_QFileIconProvider    sipType_QtGui_QFileIconProvider.td_fcto

#define sipEnum_QFileIconProvider_IconType              sipModuleAPI_QtGui.em_enums[238]

extern sipTypeDef sipType_QtGui_QFileIconProvider;

#define sipClass_QFileSystemModel             sipModuleAPI_QtGui.em_types[179]
#define sipCast_QFileSystemModel              sipType_QtGui_QFileSystemModel.td_cast
#define sipForceConvertTo_QFileSystemModel    sipType_QtGui_QFileSystemModel.td_fcto

#define sipEnum_QFileSystemModel_Roles              sipModuleAPI_QtGui.em_enums[237]

extern sipTypeDef sipType_QtGui_QFileSystemModel;

#define sipClass_QFocusFrame             sipModuleAPI_QtGui.em_types[277]
#define sipCast_QFocusFrame              sipType_QtGui_QFocusFrame.td_cast
#define sipForceConvertTo_QFocusFrame    sipType_QtGui_QFocusFrame.td_fcto

extern sipTypeDef sipType_QtGui_QFocusFrame;

#define sipClass_QFont             sipModuleAPI_QtGui.em_types[178]
#define sipCast_QFont              sipType_QtGui_QFont.td_cast
#define sipForceConvertTo_QFont    sipType_QtGui_QFont.td_fcto

#define sipEnum_QFont_SpacingType              sipModuleAPI_QtGui.em_enums[230]
#define sipEnum_QFont_Capitalization              sipModuleAPI_QtGui.em_enums[231]
#define sipEnum_QFont_Stretch              sipModuleAPI_QtGui.em_enums[232]
#define sipEnum_QFont_Style              sipModuleAPI_QtGui.em_enums[233]
#define sipEnum_QFont_Weight              sipModuleAPI_QtGui.em_enums[234]
#define sipEnum_QFont_StyleStrategy              sipModuleAPI_QtGui.em_enums[235]
#define sipEnum_QFont_StyleHint              sipModuleAPI_QtGui.em_enums[236]

extern sipTypeDef sipType_QtGui_QFont;

#define sipClass_QFontComboBox             sipModuleAPI_QtGui.em_types[284]
#define sipCast_QFontComboBox              sipType_QtGui_QFontComboBox.td_cast
#define sipForceConvertTo_QFontComboBox    sipType_QtGui_QFontComboBox.td_fcto

#define sipEnum_QFontComboBox_FontFilter              sipModuleAPI_QtGui.em_enums[229]

extern sipTypeDef sipType_QtGui_QFontComboBox;

#define sipClass_QFontComboBox_FontFilters             sipModuleAPI_QtGui.em_types[285]
#define sipCast_QFontComboBox_FontFilters              sipType_QtGui_QFontComboBox_FontFilters.td_cast
#define sipForceConvertTo_QFontComboBox_FontFilters    sipType_QtGui_QFontComboBox_FontFilters.td_fcto

extern sipTypeDef sipType_QtGui_QFontComboBox_FontFilters;

#define sipClass_QFontDatabase             sipModuleAPI_QtGui.em_types[177]
#define sipCast_QFontDatabase              sipType_QtGui_QFontDatabase.td_cast
#define sipForceConvertTo_QFontDatabase    sipType_QtGui_QFontDatabase.td_fcto

#define sipEnum_QFontDatabase_WritingSystem              sipModuleAPI_QtGui.em_enums[228]

extern sipTypeDef sipType_QtGui_QFontDatabase;

#define sipClass_QFontDialog             sipModuleAPI_QtGui.em_types[309]
#define sipCast_QFontDialog              sipType_QtGui_QFontDialog.td_cast
#define sipForceConvertTo_QFontDialog    sipType_QtGui_QFontDialog.td_fcto

extern sipTypeDef sipType_QtGui_QFontDialog;

#define sipClass_QFontInfo             sipModuleAPI_QtGui.em_types[176]
#define sipCast_QFontInfo              sipType_QtGui_QFontInfo.td_cast
#define sipForceConvertTo_QFontInfo    sipType_QtGui_QFontInfo.td_fcto

extern sipTypeDef sipType_QtGui_QFontInfo;

#define sipClass_QFontMetrics             sipModuleAPI_QtGui.em_types[175]
#define sipCast_QFontMetrics              sipType_QtGui_QFontMetrics.td_cast
#define sipForceConvertTo_QFontMetrics    sipType_QtGui_QFontMetrics.td_fcto

extern sipTypeDef sipType_QtGui_QFontMetrics;

#define sipClass_QFontMetricsF             sipModuleAPI_QtGui.em_types[174]
#define sipCast_QFontMetricsF              sipType_QtGui_QFontMetricsF.td_cast
#define sipForceConvertTo_QFontMetricsF    sipType_QtGui_QFontMetricsF.td_fcto

extern sipTypeDef sipType_QtGui_QFontMetricsF;

#define sipClass_QFormLayout             sipModuleAPI_QtGui.em_types[230]
#define sipCast_QFormLayout              sipType_QtGui_QFormLayout.td_cast
#define sipForceConvertTo_QFormLayout    sipType_QtGui_QFormLayout.td_fcto

#define sipEnum_QFormLayout_ItemRole              sipModuleAPI_QtGui.em_enums[225]
#define sipEnum_QFormLayout_RowWrapPolicy              sipModuleAPI_QtGui.em_enums[226]
#define sipEnum_QFormLayout_FieldGrowthPolicy              sipModuleAPI_QtGui.em_enums[227]

extern sipTypeDef sipType_QtGui_QFormLayout;

#define sipClass_QGraphicsLayoutItem             sipModuleAPI_QtGui.em_types[168]
#define sipCast_QGraphicsLayoutItem              sipType_QtGui_QGraphicsLayoutItem.td_cast
#define sipForceConvertTo_QGraphicsLayoutItem    sipType_QtGui_QGraphicsLayoutItem.td_fcto

extern sipTypeDef sipType_QtGui_QGraphicsLayoutItem;

#define sipClass_QGraphicsLayout             sipModuleAPI_QtGui.em_types[171]
#define sipCast_QGraphicsLayout              sipType_QtGui_QGraphicsLayout.td_cast
#define sipForceConvertTo_QGraphicsLayout    sipType_QtGui_QGraphicsLayout.td_fcto

extern sipTypeDef sipType_QtGui_QGraphicsLayout;

#define sipClass_QGraphicsGridLayout             sipModuleAPI_QtGui.em_types[173]
#define sipCast_QGraphicsGridLayout              sipType_QtGui_QGraphicsGridLayout.td_cast
#define sipForceConvertTo_QGraphicsGridLayout    sipType_QtGui_QGraphicsGridLayout.td_fcto

extern sipTypeDef sipType_QtGui_QGraphicsGridLayout;

#define sipClass_QGraphicsItem             sipModuleAPI_QtGui.em_types[156]
#define sipCast_QGraphicsItem              sipType_QtGui_QGraphicsItem.td_cast
#define sipForceConvertTo_QGraphicsItem    sipType_QtGui_QGraphicsItem.td_fcto

#define sipEnum_QGraphicsItem_GraphicsItemFlag              sipModuleAPI_QtGui.em_enums[219]
#define sipEnum_QGraphicsItem_GraphicsItemChange              sipModuleAPI_QtGui.em_enums[220]
#define sipEnum_QGraphicsItem_CacheMode              sipModuleAPI_QtGui.em_enums[221]

extern sipTypeDef sipType_QtGui_QGraphicsItem;

#define sipClass_QGraphicsItem_GraphicsItemFlags             sipModuleAPI_QtGui.em_types[157]
#define sipCast_QGraphicsItem_GraphicsItemFlags              sipType_QtGui_QGraphicsItem_GraphicsItemFlags.td_cast
#define sipForceConvertTo_QGraphicsItem_GraphicsItemFlags    sipType_QtGui_QGraphicsItem_GraphicsItemFlags.td_fcto

extern sipTypeDef sipType_QtGui_QGraphicsItem_GraphicsItemFlags;

#define sipClass_QAbstractGraphicsShapeItem             sipModuleAPI_QtGui.em_types[162]
#define sipCast_QAbstractGraphicsShapeItem              sipType_QtGui_QAbstractGraphicsShapeItem.td_cast
#define sipForceConvertTo_QAbstractGraphicsShapeItem    sipType_QtGui_QAbstractGraphicsShapeItem.td_fcto

extern sipTypeDef sipType_QtGui_QAbstractGraphicsShapeItem;

#define sipClass_QGraphicsPathItem             sipModuleAPI_QtGui.em_types[167]
#define sipCast_QGraphicsPathItem              sipType_QtGui_QGraphicsPathItem.td_cast
#define sipForceConvertTo_QGraphicsPathItem    sipType_QtGui_QGraphicsPathItem.td_fcto

extern sipTypeDef sipType_QtGui_QGraphicsPathItem;

#define sipClass_QGraphicsRectItem             sipModuleAPI_QtGui.em_types[166]
#define sipCast_QGraphicsRectItem              sipType_QtGui_QGraphicsRectItem.td_cast
#define sipForceConvertTo_QGraphicsRectItem    sipType_QtGui_QGraphicsRectItem.td_fcto

extern sipTypeDef sipType_QtGui_QGraphicsRectItem;

#define sipClass_QGraphicsEllipseItem             sipModuleAPI_QtGui.em_types[165]
#define sipCast_QGraphicsEllipseItem              sipType_QtGui_QGraphicsEllipseItem.td_cast
#define sipForceConvertTo_QGraphicsEllipseItem    sipType_QtGui_QGraphicsEllipseItem.td_fcto

extern sipTypeDef sipType_QtGui_QGraphicsEllipseItem;

#define sipClass_QGraphicsPolygonItem             sipModuleAPI_QtGui.em_types[164]
#define sipCast_QGraphicsPolygonItem              sipType_QtGui_QGraphicsPolygonItem.td_cast
#define sipForceConvertTo_QGraphicsPolygonItem    sipType_QtGui_QGraphicsPolygonItem.td_fcto

extern sipTypeDef sipType_QtGui_QGraphicsPolygonItem;

#define sipClass_QGraphicsLineItem             sipModuleAPI_QtGui.em_types[161]
#define sipCast_QGraphicsLineItem              sipType_QtGui_QGraphicsLineItem.td_cast
#define sipForceConvertTo_QGraphicsLineItem    sipType_QtGui_QGraphicsLineItem.td_fcto

extern sipTypeDef sipType_QtGui_QGraphicsLineItem;

#define sipClass_QGraphicsPixmapItem             sipModuleAPI_QtGui.em_types[160]
#define sipCast_QGraphicsPixmapItem              sipType_QtGui_QGraphicsPixmapItem.td_cast
#define sipForceConvertTo_QGraphicsPixmapItem    sipType_QtGui_QGraphicsPixmapItem.td_fcto

#define sipEnum_QGraphicsPixmapItem_ShapeMode              sipModuleAPI_QtGui.em_enums[218]

extern sipTypeDef sipType_QtGui_QGraphicsPixmapItem;

#define sipClass_QGraphicsTextItem             sipModuleAPI_QtGui.em_types[159]
#define sipCast_QGraphicsTextItem              sipType_QtGui_QGraphicsTextItem.td_cast
#define sipForceConvertTo_QGraphicsTextItem    sipType_QtGui_QGraphicsTextItem.td_fcto

extern sipTypeDef sipType_QtGui_QGraphicsTextItem;

#define sipClass_QGraphicsSimpleTextItem             sipModuleAPI_QtGui.em_types[163]
#define sipCast_QGraphicsSimpleTextItem              sipType_QtGui_QGraphicsSimpleTextItem.td_cast
#define sipForceConvertTo_QGraphicsSimpleTextItem    sipType_QtGui_QGraphicsSimpleTextItem.td_fcto

extern sipTypeDef sipType_QtGui_QGraphicsSimpleTextItem;

#define sipClass_QGraphicsItemGroup             sipModuleAPI_QtGui.em_types[158]
#define sipCast_QGraphicsItemGroup              sipType_QtGui_QGraphicsItemGroup.td_cast
#define sipForceConvertTo_QGraphicsItemGroup    sipType_QtGui_QGraphicsItemGroup.td_fcto

extern sipTypeDef sipType_QtGui_QGraphicsItemGroup;

#define sipClass_QGraphicsItemAnimation             sipModuleAPI_QtGui.em_types[155]
#define sipCast_QGraphicsItemAnimation              sipType_QtGui_QGraphicsItemAnimation.td_cast
#define sipForceConvertTo_QGraphicsItemAnimation    sipType_QtGui_QGraphicsItemAnimation.td_fcto

extern sipTypeDef sipType_QtGui_QGraphicsItemAnimation;

#define sipClass_QGraphicsLinearLayout             sipModuleAPI_QtGui.em_types[172]
#define sipCast_QGraphicsLinearLayout              sipType_QtGui_QGraphicsLinearLayout.td_cast
#define sipForceConvertTo_QGraphicsLinearLayout    sipType_QtGui_QGraphicsLinearLayout.td_fcto

extern sipTypeDef sipType_QtGui_QGraphicsLinearLayout;

#define sipClass_QGraphicsWidget             sipModuleAPI_QtGui.em_types[169]
#define sipCast_QGraphicsWidget              sipType_QtGui_QGraphicsWidget.td_cast
#define sipForceConvertTo_QGraphicsWidget    sipType_QtGui_QGraphicsWidget.td_fcto

extern sipTypeDef sipType_QtGui_QGraphicsWidget;

#define sipClass_QGraphicsProxyWidget             sipModuleAPI_QtGui.em_types[170]
#define sipCast_QGraphicsProxyWidget              sipType_QtGui_QGraphicsProxyWidget.td_cast
#define sipForceConvertTo_QGraphicsProxyWidget    sipType_QtGui_QGraphicsProxyWidget.td_fcto

extern sipTypeDef sipType_QtGui_QGraphicsProxyWidget;

#define sipClass_QGraphicsScene             sipModuleAPI_QtGui.em_types[153]
#define sipCast_QGraphicsScene              sipType_QtGui_QGraphicsScene.td_cast
#define sipForceConvertTo_QGraphicsScene    sipType_QtGui_QGraphicsScene.td_fcto

#define sipEnum_QGraphicsScene_SceneLayer              sipModuleAPI_QtGui.em_enums[216]
#define sipEnum_QGraphicsScene_ItemIndexMethod              sipModuleAPI_QtGui.em_enums[217]

extern sipTypeDef sipType_QtGui_QGraphicsScene;

#define sipClass_QGraphicsScene_SceneLayers             sipModuleAPI_QtGui.em_types[154]
#define sipCast_QGraphicsScene_SceneLayers              sipType_QtGui_QGraphicsScene_SceneLayers.td_cast
#define sipForceConvertTo_QGraphicsScene_SceneLayers    sipType_QtGui_QGraphicsScene_SceneLayers.td_fcto

extern sipTypeDef sipType_QtGui_QGraphicsScene_SceneLayers;

#define sipClass_QGraphicsSceneEvent             sipModuleAPI_QtGui.em_types[144]
#define sipCast_QGraphicsSceneEvent              sipType_QtGui_QGraphicsSceneEvent.td_cast
#define sipForceConvertTo_QGraphicsSceneEvent    sipType_QtGui_QGraphicsSceneEvent.td_fcto

extern sipTypeDef sipType_QtGui_QGraphicsSceneEvent;

#define sipClass_QGraphicsSceneMouseEvent             sipModuleAPI_QtGui.em_types[152]
#define sipCast_QGraphicsSceneMouseEvent              sipType_QtGui_QGraphicsSceneMouseEvent.td_cast
#define sipForceConvertTo_QGraphicsSceneMouseEvent    sipType_QtGui_QGraphicsSceneMouseEvent.td_fcto

extern sipTypeDef sipType_QtGui_QGraphicsSceneMouseEvent;

#define sipClass_QGraphicsSceneWheelEvent             sipModuleAPI_QtGui.em_types[151]
#define sipCast_QGraphicsSceneWheelEvent              sipType_QtGui_QGraphicsSceneWheelEvent.td_cast
#define sipForceConvertTo_QGraphicsSceneWheelEvent    sipType_QtGui_QGraphicsSceneWheelEvent.td_fcto

extern sipTypeDef sipType_QtGui_QGraphicsSceneWheelEvent;

#define sipClass_QGraphicsSceneContextMenuEvent             sipModuleAPI_QtGui.em_types[150]
#define sipCast_QGraphicsSceneContextMenuEvent              sipType_QtGui_QGraphicsSceneContextMenuEvent.td_cast
#define sipForceConvertTo_QGraphicsSceneContextMenuEvent    sipType_QtGui_QGraphicsSceneContextMenuEvent.td_fcto

#define sipEnum_QGraphicsSceneContextMenuEvent_Reason              sipModuleAPI_QtGui.em_enums[215]

extern sipTypeDef sipType_QtGui_QGraphicsSceneContextMenuEvent;

#define sipClass_QGraphicsSceneHoverEvent             sipModuleAPI_QtGui.em_types[149]
#define sipCast_QGraphicsSceneHoverEvent              sipType_QtGui_QGraphicsSceneHoverEvent.td_cast
#define sipForceConvertTo_QGraphicsSceneHoverEvent    sipType_QtGui_QGraphicsSceneHoverEvent.td_fcto

extern sipTypeDef sipType_QtGui_QGraphicsSceneHoverEvent;

#define sipClass_QGraphicsSceneHelpEvent             sipModuleAPI_QtGui.em_types[148]
#define sipCast_QGraphicsSceneHelpEvent              sipType_QtGui_QGraphicsSceneHelpEvent.td_cast
#define sipForceConvertTo_QGraphicsSceneHelpEvent    sipType_QtGui_QGraphicsSceneHelpEvent.td_fcto

extern sipTypeDef sipType_QtGui_QGraphicsSceneHelpEvent;

#define sipClass_QGraphicsSceneDragDropEvent             sipModuleAPI_QtGui.em_types[147]
#define sipCast_QGraphicsSceneDragDropEvent              sipType_QtGui_QGraphicsSceneDragDropEvent.td_cast
#define sipForceConvertTo_QGraphicsSceneDragDropEvent    sipType_QtGui_QGraphicsSceneDragDropEvent.td_fcto

extern sipTypeDef sipType_QtGui_QGraphicsSceneDragDropEvent;

#define sipClass_QGraphicsSceneResizeEvent             sipModuleAPI_QtGui.em_types[146]
#define sipCast_QGraphicsSceneResizeEvent              sipType_QtGui_QGraphicsSceneResizeEvent.td_cast
#define sipForceConvertTo_QGraphicsSceneResizeEvent    sipType_QtGui_QGraphicsSceneResizeEvent.td_fcto

extern sipTypeDef sipType_QtGui_QGraphicsSceneResizeEvent;

#define sipClass_QGraphicsSceneMoveEvent             sipModuleAPI_QtGui.em_types[145]
#define sipCast_QGraphicsSceneMoveEvent              sipType_QtGui_QGraphicsSceneMoveEvent.td_cast
#define sipForceConvertTo_QGraphicsSceneMoveEvent    sipType_QtGui_QGraphicsSceneMoveEvent.td_fcto

extern sipTypeDef sipType_QtGui_QGraphicsSceneMoveEvent;

#define sipClass_QGraphicsView             sipModuleAPI_QtGui.em_types[332]
#define sipCast_QGraphicsView              sipType_QtGui_QGraphicsView.td_cast
#define sipForceConvertTo_QGraphicsView    sipType_QtGui_QGraphicsView.td_fcto

#define sipEnum_QGraphicsView_OptimizationFlag              sipModuleAPI_QtGui.em_enums[210]
#define sipEnum_QGraphicsView_ViewportUpdateMode              sipModuleAPI_QtGui.em_enums[211]
#define sipEnum_QGraphicsView_ViewportAnchor              sipModuleAPI_QtGui.em_enums[212]
#define sipEnum_QGraphicsView_DragMode              sipModuleAPI_QtGui.em_enums[213]
#define sipEnum_QGraphicsView_CacheModeFlag              sipModuleAPI_QtGui.em_enums[214]

extern sipTypeDef sipType_QtGui_QGraphicsView;

#define sipClass_QGraphicsView_CacheMode             sipModuleAPI_QtGui.em_types[334]
#define sipCast_QGraphicsView_CacheMode              sipType_QtGui_QGraphicsView_CacheMode.td_cast
#define sipForceConvertTo_QGraphicsView_CacheMode    sipType_QtGui_QGraphicsView_CacheMode.td_fcto

extern sipTypeDef sipType_QtGui_QGraphicsView_CacheMode;

#define sipClass_QGraphicsView_OptimizationFlags             sipModuleAPI_QtGui.em_types[333]
#define sipCast_QGraphicsView_OptimizationFlags              sipType_QtGui_QGraphicsView_OptimizationFlags.td_cast
#define sipForceConvertTo_QGraphicsView_OptimizationFlags    sipType_QtGui_QGraphicsView_OptimizationFlags.td_fcto

extern sipTypeDef sipType_QtGui_QGraphicsView_OptimizationFlags;

#define sipClass_QGridLayout             sipModuleAPI_QtGui.em_types[229]
#define sipCast_QGridLayout              sipType_QtGui_QGridLayout.td_cast
#define sipForceConvertTo_QGridLayout    sipType_QtGui_QGridLayout.td_fcto

extern sipTypeDef sipType_QtGui_QGridLayout;

#define sipClass_QGroupBox             sipModuleAPI_QtGui.em_types[276]
#define sipCast_QGroupBox              sipType_QtGui_QGroupBox.td_cast
#define sipForceConvertTo_QGroupBox    sipType_QtGui_QGroupBox.td_fcto

extern sipTypeDef sipType_QtGui_QGroupBox;

#define sipClass_QHeaderView             sipModuleAPI_QtGui.em_types[344]
#define sipCast_QHeaderView              sipType_QtGui_QHeaderView.td_cast
#define sipForceConvertTo_QHeaderView    sipType_QtGui_QHeaderView.td_fcto

#define sipEnum_QHeaderView_ResizeMode              sipModuleAPI_QtGui.em_enums[209]

extern sipTypeDef sipType_QtGui_QHeaderView;

#define sipClass_QIcon             sipModuleAPI_QtGui.em_types[143]
#define sipCast_QIcon              sipType_QtGui_QIcon.td_cast
#define sipForceConvertTo_QIcon    sipType_QtGui_QIcon.td_fcto

#define sipEnum_QIcon_State              sipModuleAPI_QtGui.em_enums[207]
#define sipEnum_QIcon_Mode              sipModuleAPI_QtGui.em_enums[208]

extern sipTypeDef sipType_QtGui_QIcon;

#define sipClass_QIconEngine             sipModuleAPI_QtGui.em_types[141]
#define sipCast_QIconEngine              sipType_QtGui_QIconEngine.td_cast
#define sipForceConvertTo_QIconEngine    sipType_QtGui_QIconEngine.td_fcto

extern sipTypeDef sipType_QtGui_QIconEngine;

#define sipClass_QIconEngineV2             sipModuleAPI_QtGui.em_types[142]
#define sipCast_QIconEngineV2              sipType_QtGui_QIconEngineV2.td_cast
#define sipForceConvertTo_QIconEngineV2    sipType_QtGui_QIconEngineV2.td_fcto

extern sipTypeDef sipType_QtGui_QIconEngineV2;

#define sipClass_QItemEditorCreatorBase             sipModuleAPI_QtGui.em_types[140]
#define sipCast_QItemEditorCreatorBase              sipType_QtGui_QItemEditorCreatorBase.td_cast
#define sipForceConvertTo_QItemEditorCreatorBase    sipType_QtGui_QItemEditorCreatorBase.td_fcto

extern sipTypeDef sipType_QtGui_QItemEditorCreatorBase;

#define sipClass_QItemEditorFactory             sipModuleAPI_QtGui.em_types[139]
#define sipCast_QItemEditorFactory              sipType_QtGui_QItemEditorFactory.td_cast
#define sipForceConvertTo_QItemEditorFactory    sipType_QtGui_QItemEditorFactory.td_fcto

extern sipTypeDef sipType_QtGui_QItemEditorFactory;

#define sipClass_QItemSelectionRange             sipModuleAPI_QtGui.em_types[138]
#define sipCast_QItemSelectionRange              sipType_QtGui_QItemSelectionRange.td_cast
#define sipForceConvertTo_QItemSelectionRange    sipType_QtGui_QItemSelectionRange.td_fcto

extern sipTypeDef sipType_QtGui_QItemSelectionRange;

#define sipClass_QItemSelectionModel             sipModuleAPI_QtGui.em_types[136]
#define sipCast_QItemSelectionModel              sipType_QtGui_QItemSelectionModel.td_cast
#define sipForceConvertTo_QItemSelectionModel    sipType_QtGui_QItemSelectionModel.td_fcto

#define sipEnum_QItemSelectionModel_SelectionFlag              sipModuleAPI_QtGui.em_enums[206]

extern sipTypeDef sipType_QtGui_QItemSelectionModel;

#define sipClass_QItemSelectionModel_SelectionFlags             sipModuleAPI_QtGui.em_types[137]
#define sipCast_QItemSelectionModel_SelectionFlags              sipType_QtGui_QItemSelectionModel_SelectionFlags.td_cast
#define sipForceConvertTo_QItemSelectionModel_SelectionFlags    sipType_QtGui_QItemSelectionModel_SelectionFlags.td_fcto

extern sipTypeDef sipType_QtGui_QItemSelectionModel_SelectionFlags;

#define sipClass_QItemSelection             sipModuleAPI_QtGui.em_types[135]
#define sipCast_QItemSelection              sipType_QtGui_QItemSelection.td_cast
#define sipForceConvertTo_QItemSelection    sipType_QtGui_QItemSelection.td_fcto

extern sipTypeDef sipType_QtGui_QItemSelection;

#define sipClass_QImage             sipModuleAPI_QtGui.em_types[250]
#define sipCast_QImage              sipType_QtGui_QImage.td_cast
#define sipForceConvertTo_QImage    sipType_QtGui_QImage.td_fcto

#define sipEnum_QImage_Format              sipModuleAPI_QtGui.em_enums[204]
#define sipEnum_QImage_InvertMode              sipModuleAPI_QtGui.em_enums[205]

extern sipTypeDef sipType_QtGui_QImage;

#define sipClass_QImageIOHandler             sipModuleAPI_QtGui.em_types[134]
#define sipCast_QImageIOHandler              sipType_QtGui_QImageIOHandler.td_cast
#define sipForceConvertTo_QImageIOHandler    sipType_QtGui_QImageIOHandler.td_fcto

#define sipEnum_QImageIOHandler_ImageOption              sipModuleAPI_QtGui.em_enums[203]

extern sipTypeDef sipType_QtGui_QImageIOHandler;

#define sipClass_QImageReader             sipModuleAPI_QtGui.em_types[133]
#define sipCast_QImageReader              sipType_QtGui_QImageReader.td_cast
#define sipForceConvertTo_QImageReader    sipType_QtGui_QImageReader.td_fcto

#define sipEnum_QImageReader_ImageReaderError              sipModuleAPI_QtGui.em_enums[202]

extern sipTypeDef sipType_QtGui_QImageReader;

#define sipClass_QImageWriter             sipModuleAPI_QtGui.em_types[132]
#define sipCast_QImageWriter              sipType_QtGui_QImageWriter.td_cast
#define sipForceConvertTo_QImageWriter    sipType_QtGui_QImageWriter.td_fcto

#define sipEnum_QImageWriter_ImageWriterError              sipModuleAPI_QtGui.em_enums[201]

extern sipTypeDef sipType_QtGui_QImageWriter;

#define sipClass_QInputContext             sipModuleAPI_QtGui.em_types[131]
#define sipCast_QInputContext              sipType_QtGui_QInputContext.td_cast
#define sipForceConvertTo_QInputContext    sipType_QtGui_QInputContext.td_fcto

#define sipEnum_QInputContext_StandardFormat              sipModuleAPI_QtGui.em_enums[200]

extern sipTypeDef sipType_QtGui_QInputContext;

#define sipClass_QInputDialog             sipModuleAPI_QtGui.em_types[308]
#define sipCast_QInputDialog              sipType_QtGui_QInputDialog.td_cast
#define sipForceConvertTo_QInputDialog    sipType_QtGui_QInputDialog.td_fcto

extern sipTypeDef sipType_QtGui_QInputDialog;

#define sipClass_QItemDelegate             sipModuleAPI_QtGui.em_types[246]
#define sipCast_QItemDelegate              sipType_QtGui_QItemDelegate.td_cast
#define sipForceConvertTo_QItemDelegate    sipType_QtGui_QItemDelegate.td_fcto

extern sipTypeDef sipType_QtGui_QItemDelegate;

#define sipClass_QKeySequence             sipModuleAPI_QtGui.em_types[130]
#define sipCast_QKeySequence              sipType_QtGui_QKeySequence.td_cast
#define sipForceConvertTo_QKeySequence    sipType_QtGui_QKeySequence.td_fcto

#define sipEnum_QKeySequence_StandardKey              sipModuleAPI_QtGui.em_enums[197]
#define sipEnum_QKeySequence_SequenceMatch              sipModuleAPI_QtGui.em_enums[198]
#define sipEnum_QKeySequence_SequenceFormat              sipModuleAPI_QtGui.em_enums[199]

extern sipTypeDef sipType_QtGui_QKeySequence;

#define sipClass_QLabel             sipModuleAPI_QtGui.em_types[322]
#define sipCast_QLabel              sipType_QtGui_QLabel.td_cast
#define sipForceConvertTo_QLabel    sipType_QtGui_QLabel.td_fcto

extern sipTypeDef sipType_QtGui_QLabel;

#define sipClass_QSpacerItem             sipModuleAPI_QtGui.em_types[226]
#define sipCast_QSpacerItem              sipType_QtGui_QSpacerItem.td_cast
#define sipForceConvertTo_QSpacerItem    sipType_QtGui_QSpacerItem.td_fcto

extern sipTypeDef sipType_QtGui_QSpacerItem;

#define sipClass_QWidgetItem             sipModuleAPI_QtGui.em_types[225]
#define sipCast_QWidgetItem              sipType_QtGui_QWidgetItem.td_cast
#define sipForceConvertTo_QWidgetItem    sipType_QtGui_QWidgetItem.td_fcto

extern sipTypeDef sipType_QtGui_QWidgetItem;

#define sipClass_QLCDNumber             sipModuleAPI_QtGui.em_types[321]
#define sipCast_QLCDNumber              sipType_QtGui_QLCDNumber.td_cast
#define sipForceConvertTo_QLCDNumber    sipType_QtGui_QLCDNumber.td_fcto

#define sipEnum_QLCDNumber_SegmentStyle              sipModuleAPI_QtGui.em_enums[194]
#define sipEnum_QLCDNumber_Mode              sipModuleAPI_QtGui.em_enums[195]

extern sipTypeDef sipType_QtGui_QLCDNumber;

#define sipClass_QLineEdit             sipModuleAPI_QtGui.em_types[275]
#define sipCast_QLineEdit              sipType_QtGui_QLineEdit.td_cast
#define sipForceConvertTo_QLineEdit    sipType_QtGui_QLineEdit.td_fcto

#define sipEnum_QLineEdit_EchoMode              sipModuleAPI_QtGui.em_enums[193]

extern sipTypeDef sipType_QtGui_QLineEdit;

#define sipClass_QListView             sipModuleAPI_QtGui.em_types[341]
#define sipCast_QListView              sipType_QtGui_QListView.td_cast
#define sipForceConvertTo_QListView    sipType_QtGui_QListView.td_fcto

#define sipEnum_QListView_ViewMode              sipModuleAPI_QtGui.em_enums[188]
#define sipEnum_QListView_LayoutMode              sipModuleAPI_QtGui.em_enums[189]
#define sipEnum_QListView_ResizeMode              sipModuleAPI_QtGui.em_enums[190]
#define sipEnum_QListView_Flow              sipModuleAPI_QtGui.em_enums[191]
#define sipEnum_QListView_Movement              sipModuleAPI_QtGui.em_enums[192]

extern sipTypeDef sipType_QtGui_QListView;

#define sipClass_QListWidgetItem             sipModuleAPI_QtGui.em_types[129]
#define sipCast_QListWidgetItem              sipType_QtGui_QListWidgetItem.td_cast
#define sipForceConvertTo_QListWidgetItem    sipType_QtGui_QListWidgetItem.td_fcto

#define sipEnum_QListWidgetItem_ItemType              sipModuleAPI_QtGui.em_enums[187]

extern sipTypeDef sipType_QtGui_QListWidgetItem;

#define sipClass_QListWidget             sipModuleAPI_QtGui.em_types[343]
#define sipCast_QListWidget              sipType_QtGui_QListWidget.td_cast
#define sipForceConvertTo_QListWidget    sipType_QtGui_QListWidget.td_fcto

extern sipTypeDef sipType_QtGui_QListWidget;

#define sipClass_QMainWindow             sipModuleAPI_QtGui.em_types[273]
#define sipCast_QMainWindow              sipType_QtGui_QMainWindow.td_cast
#define sipForceConvertTo_QMainWindow    sipType_QtGui_QMainWindow.td_fcto

#define sipEnum_QMainWindow_DockOption              sipModuleAPI_QtGui.em_enums[186]

extern sipTypeDef sipType_QtGui_QMainWindow;

#define sipClass_QMainWindow_DockOptions             sipModuleAPI_QtGui.em_types[274]
#define sipCast_QMainWindow_DockOptions              sipType_QtGui_QMainWindow_DockOptions.td_cast
#define sipForceConvertTo_QMainWindow_DockOptions    sipType_QtGui_QMainWindow_DockOptions.td_fcto

extern sipTypeDef sipType_QtGui_QMainWindow_DockOptions;

#define sipClass_QMatrix             sipModuleAPI_QtGui.em_types[128]
#define sipCast_QMatrix              sipType_QtGui_QMatrix.td_cast
#define sipForceConvertTo_QMatrix    sipType_QtGui_QMatrix.td_fcto

extern sipTypeDef sipType_QtGui_QMatrix;

#define sipClass_QMdiArea             sipModuleAPI_QtGui.em_types[330]
#define sipCast_QMdiArea              sipType_QtGui_QMdiArea.td_cast
#define sipForceConvertTo_QMdiArea    sipType_QtGui_QMdiArea.td_fcto

#define sipEnum_QMdiArea_WindowOrder              sipModuleAPI_QtGui.em_enums[183]
#define sipEnum_QMdiArea_ViewMode              sipModuleAPI_QtGui.em_enums[184]
#define sipEnum_QMdiArea_AreaOption              sipModuleAPI_QtGui.em_enums[185]

extern sipTypeDef sipType_QtGui_QMdiArea;

#define sipClass_QMdiArea_AreaOptions             sipModuleAPI_QtGui.em_types[331]
#define sipCast_QMdiArea_AreaOptions              sipType_QtGui_QMdiArea_AreaOptions.td_cast
#define sipForceConvertTo_QMdiArea_AreaOptions    sipType_QtGui_QMdiArea_AreaOptions.td_fcto

extern sipTypeDef sipType_QtGui_QMdiArea_AreaOptions;

#define sipClass_QMdiSubWindow             sipModuleAPI_QtGui.em_types[271]
#define sipCast_QMdiSubWindow              sipType_QtGui_QMdiSubWindow.td_cast
#define sipForceConvertTo_QMdiSubWindow    sipType_QtGui_QMdiSubWindow.td_fcto

#define sipEnum_QMdiSubWindow_SubWindowOption              sipModuleAPI_QtGui.em_enums[182]

extern sipTypeDef sipType_QtGui_QMdiSubWindow;

#define sipClass_QMdiSubWindow_SubWindowOptions             sipModuleAPI_QtGui.em_types[272]
#define sipCast_QMdiSubWindow_SubWindowOptions              sipType_QtGui_QMdiSubWindow_SubWindowOptions.td_cast
#define sipForceConvertTo_QMdiSubWindow_SubWindowOptions    sipType_QtGui_QMdiSubWindow_SubWindowOptions.td_fcto

extern sipTypeDef sipType_QtGui_QMdiSubWindow_SubWindowOptions;

#define sipClass_QMenu             sipModuleAPI_QtGui.em_types[270]
#define sipCast_QMenu              sipType_QtGui_QMenu.td_cast
#define sipForceConvertTo_QMenu    sipType_QtGui_QMenu.td_fcto

extern sipTypeDef sipType_QtGui_QMenu;

#define sipClass_QMenuBar             sipModuleAPI_QtGui.em_types[269]
#define sipCast_QMenuBar              sipType_QtGui_QMenuBar.td_cast
#define sipForceConvertTo_QMenuBar    sipType_QtGui_QMenuBar.td_fcto

extern sipTypeDef sipType_QtGui_QMenuBar;

#define sipClass_QMessageBox             sipModuleAPI_QtGui.em_types[306]
#define sipCast_QMessageBox              sipType_QtGui_QMessageBox.td_cast
#define sipForceConvertTo_QMessageBox    sipType_QtGui_QMessageBox.td_fcto

#define sipEnum_QMessageBox_StandardButton              sipModuleAPI_QtGui.em_enums[179]
#define sipEnum_QMessageBox_Icon              sipModuleAPI_QtGui.em_enums[180]
#define sipEnum_QMessageBox_ButtonRole              sipModuleAPI_QtGui.em_enums[181]

extern sipTypeDef sipType_QtGui_QMessageBox;

#define sipClass_QMessageBox_StandardButtons             sipModuleAPI_QtGui.em_types[307]
#define sipCast_QMessageBox_StandardButtons              sipType_QtGui_QMessageBox_StandardButtons.td_cast
#define sipForceConvertTo_QMessageBox_StandardButtons    sipType_QtGui_QMessageBox_StandardButtons.td_fcto

extern sipTypeDef sipType_QtGui_QMessageBox_StandardButtons;

#define sipClass_QMovie             sipModuleAPI_QtGui.em_types[127]
#define sipCast_QMovie              sipType_QtGui_QMovie.td_cast
#define sipForceConvertTo_QMovie    sipType_QtGui_QMovie.td_fcto

#define sipEnum_QMovie_CacheMode              sipModuleAPI_QtGui.em_enums[177]
#define sipEnum_QMovie_MovieState              sipModuleAPI_QtGui.em_enums[178]

extern sipTypeDef sipType_QtGui_QMovie;

#define sipClass_QPageSetupDialog             sipModuleAPI_QtGui.em_types[304]
#define sipCast_QPageSetupDialog              sipType_QtGui_QPageSetupDialog.td_cast
#define sipForceConvertTo_QPageSetupDialog    sipType_QtGui_QPageSetupDialog.td_fcto

#define sipEnum_QPageSetupDialog_PageSetupDialogOption              sipModuleAPI_QtGui.em_enums[176]

extern sipTypeDef sipType_QtGui_QPageSetupDialog;

#define sipClass_QPageSetupDialog_PageSetupDialogOptions             sipModuleAPI_QtGui.em_types[305]
#define sipCast_QPageSetupDialog_PageSetupDialogOptions              sipType_QtGui_QPageSetupDialog_PageSetupDialogOptions.td_cast
#define sipForceConvertTo_QPageSetupDialog_PageSetupDialogOptions    sipType_QtGui_QPageSetupDialog_PageSetupDialogOptions.td_fcto

extern sipTypeDef sipType_QtGui_QPageSetupDialog_PageSetupDialogOptions;

#define sipClass_QPainter             sipModuleAPI_QtGui.em_types[124]
#define sipCast_QPainter              sipType_QtGui_QPainter.td_cast
#define sipForceConvertTo_QPainter    sipType_QtGui_QPainter.td_fcto

#define sipEnum_QPainter_CompositionMode              sipModuleAPI_QtGui.em_enums[174]
#define sipEnum_QPainter_RenderHint              sipModuleAPI_QtGui.em_enums[175]

extern sipTypeDef sipType_QtGui_QPainter;

#define sipClass_QPainter_RenderHints             sipModuleAPI_QtGui.em_types[125]
#define sipCast_QPainter_RenderHints              sipType_QtGui_QPainter_RenderHints.td_cast
#define sipForceConvertTo_QPainter_RenderHints    sipType_QtGui_QPainter_RenderHints.td_fcto

extern sipTypeDef sipType_QtGui_QPainter_RenderHints;

#define sipClass_QTextItem             sipModuleAPI_QtGui.em_types[122]
#define sipCast_QTextItem              sipType_QtGui_QTextItem.td_cast
#define sipForceConvertTo_QTextItem    sipType_QtGui_QTextItem.td_fcto

#define sipEnum_QTextItem_RenderFlag              sipModuleAPI_QtGui.em_enums[172]

extern sipTypeDef sipType_QtGui_QTextItem;

#define sipClass_QTextItem_RenderFlags             sipModuleAPI_QtGui.em_types[123]
#define sipCast_QTextItem_RenderFlags              sipType_QtGui_QTextItem_RenderFlags.td_cast
#define sipForceConvertTo_QTextItem_RenderFlags    sipType_QtGui_QTextItem_RenderFlags.td_fcto

extern sipTypeDef sipType_QtGui_QTextItem_RenderFlags;

#define sipClass_QPaintEngine             sipModuleAPI_QtGui.em_types[119]
#define sipCast_QPaintEngine              sipType_QtGui_QPaintEngine.td_cast
#define sipForceConvertTo_QPaintEngine    sipType_QtGui_QPaintEngine.td_fcto

#define sipEnum_QPaintEngine_Type              sipModuleAPI_QtGui.em_enums[168]
#define sipEnum_QPaintEngine_PolygonDrawMode              sipModuleAPI_QtGui.em_enums[169]
#define sipEnum_QPaintEngine_DirtyFlag              sipModuleAPI_QtGui.em_enums[170]
#define sipEnum_QPaintEngine_PaintEngineFeature              sipModuleAPI_QtGui.em_enums[171]

extern sipTypeDef sipType_QtGui_QPaintEngine;

#define sipClass_QPaintEngine_PaintEngineFeatures             sipModuleAPI_QtGui.em_types[121]
#define sipCast_QPaintEngine_PaintEngineFeatures              sipType_QtGui_QPaintEngine_PaintEngineFeatures.td_cast
#define sipForceConvertTo_QPaintEngine_PaintEngineFeatures    sipType_QtGui_QPaintEngine_PaintEngineFeatures.td_fcto

extern sipTypeDef sipType_QtGui_QPaintEngine_PaintEngineFeatures;

#define sipClass_QPaintEngine_DirtyFlags             sipModuleAPI_QtGui.em_types[120]
#define sipCast_QPaintEngine_DirtyFlags              sipType_QtGui_QPaintEngine_DirtyFlags.td_cast
#define sipForceConvertTo_QPaintEngine_DirtyFlags    sipType_QtGui_QPaintEngine_DirtyFlags.td_fcto

extern sipTypeDef sipType_QtGui_QPaintEngine_DirtyFlags;

#define sipClass_QPaintEngineState             sipModuleAPI_QtGui.em_types[118]
#define sipCast_QPaintEngineState              sipType_QtGui_QPaintEngineState.td_cast
#define sipForceConvertTo_QPaintEngineState    sipType_QtGui_QPaintEngineState.td_fcto

extern sipTypeDef sipType_QtGui_QPaintEngineState;

#define sipClass_QPainterPath             sipModuleAPI_QtGui.em_types[116]
#define sipCast_QPainterPath              sipType_QtGui_QPainterPath.td_cast
#define sipForceConvertTo_QPainterPath    sipType_QtGui_QPainterPath.td_fcto

#define sipEnum_QPainterPath_ElementType              sipModuleAPI_QtGui.em_enums[167]

extern sipTypeDef sipType_QtGui_QPainterPath;

#define sipClass_QPainterPath_Element             sipModuleAPI_QtGui.em_types[117]
#define sipCast_QPainterPath_Element              sipType_QtGui_QPainterPath_Element.td_cast
#define sipForceConvertTo_QPainterPath_Element    sipType_QtGui_QPainterPath_Element.td_fcto

extern sipTypeDef sipType_QtGui_QPainterPath_Element;

#define sipClass_QPainterPathStroker             sipModuleAPI_QtGui.em_types[115]
#define sipCast_QPainterPathStroker              sipType_QtGui_QPainterPathStroker.td_cast
#define sipForceConvertTo_QPainterPathStroker    sipType_QtGui_QPainterPathStroker.td_fcto

extern sipTypeDef sipType_QtGui_QPainterPathStroker;

#define sipClass_QPalette             sipModuleAPI_QtGui.em_types[114]
#define sipCast_QPalette              sipType_QtGui_QPalette.td_cast
#define sipForceConvertTo_QPalette    sipType_QtGui_QPalette.td_fcto

#define sipEnum_QPalette_ColorRole              sipModuleAPI_QtGui.em_enums[165]
#define sipEnum_QPalette_ColorGroup              sipModuleAPI_QtGui.em_enums[166]

extern sipTypeDef sipType_QtGui_QPalette;

#define sipClass_QPen             sipModuleAPI_QtGui.em_types[113]
#define sipCast_QPen              sipType_QtGui_QPen.td_cast
#define sipForceConvertTo_QPen    sipType_QtGui_QPen.td_fcto

extern sipTypeDef sipType_QtGui_QPen;

#define sipClass_QPicture             sipModuleAPI_QtGui.em_types[249]
#define sipCast_QPicture              sipType_QtGui_QPicture.td_cast
#define sipForceConvertTo_QPicture    sipType_QtGui_QPicture.td_fcto

extern sipTypeDef sipType_QtGui_QPicture;

#define sipClass_QPictureIO             sipModuleAPI_QtGui.em_types[112]
#define sipCast_QPictureIO              sipType_QtGui_QPictureIO.td_cast
#define sipForceConvertTo_QPictureIO    sipType_QtGui_QPictureIO.td_fcto

extern sipTypeDef sipType_QtGui_QPictureIO;

#define sipClass_QPixmapCache             sipModuleAPI_QtGui.em_types[111]
#define sipCast_QPixmapCache              sipType_QtGui_QPixmapCache.td_cast
#define sipForceConvertTo_QPixmapCache    sipType_QtGui_QPixmapCache.td_fcto

extern sipTypeDef sipType_QtGui_QPixmapCache;

#define sipClass_QPlainTextEdit             sipModuleAPI_QtGui.em_types[329]
#define sipCast_QPlainTextEdit              sipType_QtGui_QPlainTextEdit.td_cast
#define sipForceConvertTo_QPlainTextEdit    sipType_QtGui_QPlainTextEdit.td_fcto

#define sipEnum_QPlainTextEdit_LineWrapMode              sipModuleAPI_QtGui.em_enums[164]

extern sipTypeDef sipType_QtGui_QPlainTextEdit;

#define sipClass_QPlainTextDocumentLayout             sipModuleAPI_QtGui.em_types[241]
#define sipCast_QPlainTextDocumentLayout              sipType_QtGui_QPlainTextDocumentLayout.td_cast
#define sipForceConvertTo_QPlainTextDocumentLayout    sipType_QtGui_QPlainTextDocumentLayout.td_fcto

extern sipTypeDef sipType_QtGui_QPlainTextDocumentLayout;

#define sipClass_QPolygon             sipModuleAPI_QtGui.em_types[110]
#define sipCast_QPolygon              sipType_QtGui_QPolygon.td_cast
#define sipForceConvertTo_QPolygon    sipType_QtGui_QPolygon.td_fcto

extern sipTypeDef sipType_QtGui_QPolygon;

#define sipClass_QPolygonF             sipModuleAPI_QtGui.em_types[109]
#define sipCast_QPolygonF              sipType_QtGui_QPolygonF.td_cast
#define sipForceConvertTo_QPolygonF    sipType_QtGui_QPolygonF.td_fcto

extern sipTypeDef sipType_QtGui_QPolygonF;

#define sipClass_QPrinter             sipModuleAPI_QtGui.em_types[248]
#define sipCast_QPrinter              sipType_QtGui_QPrinter.td_cast
#define sipForceConvertTo_QPrinter    sipType_QtGui_QPrinter.td_fcto

#define sipEnum_QPrinter_Unit              sipModuleAPI_QtGui.em_enums[153]
#define sipEnum_QPrinter_DuplexMode              sipModuleAPI_QtGui.em_enums[154]
#define sipEnum_QPrinter_PrintRange              sipModuleAPI_QtGui.em_enums[155]
#define sipEnum_QPrinter_OutputFormat              sipModuleAPI_QtGui.em_enums[156]
#define sipEnum_QPrinter_PrinterState              sipModuleAPI_QtGui.em_enums[157]
#define sipEnum_QPrinter_PaperSource              sipModuleAPI_QtGui.em_enums[158]
#define sipEnum_QPrinter_ColorMode              sipModuleAPI_QtGui.em_enums[159]
#define sipEnum_QPrinter_PageOrder              sipModuleAPI_QtGui.em_enums[160]
#define sipEnum_QPrinter_PageSize              sipModuleAPI_QtGui.em_enums[161]
#define sipEnum_QPrinter_Orientation              sipModuleAPI_QtGui.em_enums[162]
#define sipEnum_QPrinter_PrinterMode              sipModuleAPI_QtGui.em_enums[163]

extern sipTypeDef sipType_QtGui_QPrinter;

#define sipClass_QPrintDialog             sipModuleAPI_QtGui.em_types[316]
#define sipCast_QPrintDialog              sipType_QtGui_QPrintDialog.td_cast
#define sipForceConvertTo_QPrintDialog    sipType_QtGui_QPrintDialog.td_fcto

extern sipTypeDef sipType_QtGui_QPrintDialog;

#define sipClass_QPrintEngine             sipModuleAPI_QtGui.em_types[108]
#define sipCast_QPrintEngine              sipType_QtGui_QPrintEngine.td_cast
#define sipForceConvertTo_QPrintEngine    sipType_QtGui_QPrintEngine.td_fcto

#define sipEnum_QPrintEngine_PrintEnginePropertyKey              sipModuleAPI_QtGui.em_enums[152]

extern sipTypeDef sipType_QtGui_QPrintEngine;

#define sipClass_QPrinterInfo             sipModuleAPI_QtGui.em_types[107]
#define sipCast_QPrinterInfo              sipType_QtGui_QPrinterInfo.td_cast
#define sipForceConvertTo_QPrinterInfo    sipType_QtGui_QPrinterInfo.td_fcto

extern sipTypeDef sipType_QtGui_QPrinterInfo;

#define sipClass_QPrintPreviewDialog             sipModuleAPI_QtGui.em_types[303]
#define sipCast_QPrintPreviewDialog              sipType_QtGui_QPrintPreviewDialog.td_cast
#define sipForceConvertTo_QPrintPreviewDialog    sipType_QtGui_QPrintPreviewDialog.td_fcto

extern sipTypeDef sipType_QtGui_QPrintPreviewDialog;

#define sipClass_QPrintPreviewWidget             sipModuleAPI_QtGui.em_types[268]
#define sipCast_QPrintPreviewWidget              sipType_QtGui_QPrintPreviewWidget.td_cast
#define sipForceConvertTo_QPrintPreviewWidget    sipType_QtGui_QPrintPreviewWidget.td_fcto

#define sipEnum_QPrintPreviewWidget_ZoomMode              sipModuleAPI_QtGui.em_enums[150]
#define sipEnum_QPrintPreviewWidget_ViewMode              sipModuleAPI_QtGui.em_enums[151]

extern sipTypeDef sipType_QtGui_QPrintPreviewWidget;

#define sipClass_QProgressBar             sipModuleAPI_QtGui.em_types[267]
#define sipCast_QProgressBar              sipType_QtGui_QProgressBar.td_cast
#define sipForceConvertTo_QProgressBar    sipType_QtGui_QProgressBar.td_fcto

#define sipEnum_QProgressBar_Direction              sipModuleAPI_QtGui.em_enums[149]

extern sipTypeDef sipType_QtGui_QProgressBar;

#define sipClass_QProgressDialog             sipModuleAPI_QtGui.em_types[302]
#define sipCast_QProgressDialog              sipType_QtGui_QProgressDialog.td_cast
#define sipForceConvertTo_QProgressDialog    sipType_QtGui_QProgressDialog.td_fcto

extern sipTypeDef sipType_QtGui_QProgressDialog;

#define sipClass_QProxyModel             sipModuleAPI_QtGui.em_types[106]
#define sipCast_QProxyModel              sipType_QtGui_QProxyModel.td_cast
#define sipForceConvertTo_QProxyModel    sipType_QtGui_QProxyModel.td_fcto

extern sipTypeDef sipType_QtGui_QProxyModel;

#define sipClass_QRadioButton             sipModuleAPI_QtGui.em_types[348]
#define sipCast_QRadioButton              sipType_QtGui_QRadioButton.td_cast
#define sipForceConvertTo_QRadioButton    sipType_QtGui_QRadioButton.td_fcto

extern sipTypeDef sipType_QtGui_QRadioButton;

#define sipClass_QRegion             sipModuleAPI_QtGui.em_types[105]
#define sipCast_QRegion              sipType_QtGui_QRegion.td_cast
#define sipForceConvertTo_QRegion    sipType_QtGui_QRegion.td_fcto

#define sipEnum_QRegion_RegionType              sipModuleAPI_QtGui.em_enums[148]

extern sipTypeDef sipType_QtGui_QRegion;

#define sipClass_QRubberBand             sipModuleAPI_QtGui.em_types[266]
#define sipCast_QRubberBand              sipType_QtGui_QRubberBand.td_cast
#define sipForceConvertTo_QRubberBand    sipType_QtGui_QRubberBand.td_fcto

#define sipEnum_QRubberBand_Shape              sipModuleAPI_QtGui.em_enums[147]

extern sipTypeDef sipType_QtGui_QRubberBand;

#define sipClass_QScrollArea             sipModuleAPI_QtGui.em_types[328]
#define sipCast_QScrollArea              sipType_QtGui_QScrollArea.td_cast
#define sipForceConvertTo_QScrollArea    sipType_QtGui_QScrollArea.td_fcto

extern sipTypeDef sipType_QtGui_QScrollArea;

#define sipClass_QScrollBar             sipModuleAPI_QtGui.em_types[289]
#define sipCast_QScrollBar              sipType_QtGui_QScrollBar.td_cast
#define sipForceConvertTo_QScrollBar    sipType_QtGui_QScrollBar.td_fcto

extern sipTypeDef sipType_QtGui_QScrollBar;

#define sipClass_QSessionManager             sipModuleAPI_QtGui.em_types[104]
#define sipCast_QSessionManager              sipType_QtGui_QSessionManager.td_cast
#define sipForceConvertTo_QSessionManager    sipType_QtGui_QSessionManager.td_fcto

#define sipEnum_QSessionManager_RestartHint              sipModuleAPI_QtGui.em_enums[146]

extern sipTypeDef sipType_QtGui_QSessionManager;

#define sipClass_QShortcut             sipModuleAPI_QtGui.em_types[103]
#define sipCast_QShortcut              sipType_QtGui_QShortcut.td_cast
#define sipForceConvertTo_QShortcut    sipType_QtGui_QShortcut.td_fcto

extern sipTypeDef sipType_QtGui_QShortcut;

#define sipClass_QSizeGrip             sipModuleAPI_QtGui.em_types[265]
#define sipCast_QSizeGrip              sipType_QtGui_QSizeGrip.td_cast
#define sipForceConvertTo_QSizeGrip    sipType_QtGui_QSizeGrip.td_fcto

extern sipTypeDef sipType_QtGui_QSizeGrip;

#define sipClass_QSizePolicy             sipModuleAPI_QtGui.em_types[101]
#define sipCast_QSizePolicy              sipType_QtGui_QSizePolicy.td_cast
#define sipForceConvertTo_QSizePolicy    sipType_QtGui_QSizePolicy.td_fcto

#define sipEnum_QSizePolicy_ControlType              sipModuleAPI_QtGui.em_enums[143]
#define sipEnum_QSizePolicy_Policy              sipModuleAPI_QtGui.em_enums[144]
#define sipEnum_QSizePolicy_PolicyFlag              sipModuleAPI_QtGui.em_enums[145]

extern sipTypeDef sipType_QtGui_QSizePolicy;

#define sipClass_QSizePolicy_ControlTypes             sipModuleAPI_QtGui.em_types[102]
#define sipCast_QSizePolicy_ControlTypes              sipType_QtGui_QSizePolicy_ControlTypes.td_cast
#define sipForceConvertTo_QSizePolicy_ControlTypes    sipType_QtGui_QSizePolicy_ControlTypes.td_fcto

extern sipTypeDef sipType_QtGui_QSizePolicy_ControlTypes;

#define sipClass_QSlider             sipModuleAPI_QtGui.em_types[288]
#define sipCast_QSlider              sipType_QtGui_QSlider.td_cast
#define sipForceConvertTo_QSlider    sipType_QtGui_QSlider.td_fcto

#define sipEnum_QSlider_TickPosition              sipModuleAPI_QtGui.em_enums[142]

extern sipTypeDef sipType_QtGui_QSlider;

#define sipClass_QSortFilterProxyModel             sipModuleAPI_QtGui.em_types[243]
#define sipCast_QSortFilterProxyModel              sipType_QtGui_QSortFilterProxyModel.td_cast
#define sipForceConvertTo_QSortFilterProxyModel    sipType_QtGui_QSortFilterProxyModel.td_fcto

extern sipTypeDef sipType_QtGui_QSortFilterProxyModel;

#define sipClass_QSound             sipModuleAPI_QtGui.em_types[100]
#define sipCast_QSound              sipType_QtGui_QSound.td_cast
#define sipForceConvertTo_QSound    sipType_QtGui_QSound.td_fcto

extern sipTypeDef sipType_QtGui_QSound;

#define sipClass_QSpinBox             sipModuleAPI_QtGui.em_types[294]
#define sipCast_QSpinBox              sipType_QtGui_QSpinBox.td_cast
#define sipForceConvertTo_QSpinBox    sipType_QtGui_QSpinBox.td_fcto

extern sipTypeDef sipType_QtGui_QSpinBox;

#define sipClass_QDoubleSpinBox             sipModuleAPI_QtGui.em_types[293]
#define sipCast_QDoubleSpinBox              sipType_QtGui_QDoubleSpinBox.td_cast
#define sipForceConvertTo_QDoubleSpinBox    sipType_QtGui_QDoubleSpinBox.td_fcto

extern sipTypeDef sipType_QtGui_QDoubleSpinBox;

#define sipClass_QSplashScreen             sipModuleAPI_QtGui.em_types[264]
#define sipCast_QSplashScreen              sipType_QtGui_QSplashScreen.td_cast
#define sipForceConvertTo_QSplashScreen    sipType_QtGui_QSplashScreen.td_fcto

extern sipTypeDef sipType_QtGui_QSplashScreen;

#define sipClass_QSplitter             sipModuleAPI_QtGui.em_types[320]
#define sipCast_QSplitter              sipType_QtGui_QSplitter.td_cast
#define sipForceConvertTo_QSplitter    sipType_QtGui_QSplitter.td_fcto

extern sipTypeDef sipType_QtGui_QSplitter;

#define sipClass_QSplitterHandle             sipModuleAPI_QtGui.em_types[263]
#define sipCast_QSplitterHandle              sipType_QtGui_QSplitterHandle.td_cast
#define sipForceConvertTo_QSplitterHandle    sipType_QtGui_QSplitterHandle.td_fcto

extern sipTypeDef sipType_QtGui_QSplitterHandle;

#define sipClass_QStackedLayout             sipModuleAPI_QtGui.em_types[228]
#define sipCast_QStackedLayout              sipType_QtGui_QStackedLayout.td_cast
#define sipForceConvertTo_QStackedLayout    sipType_QtGui_QStackedLayout.td_fcto

#define sipEnum_QStackedLayout_StackingMode              sipModuleAPI_QtGui.em_enums[141]

extern sipTypeDef sipType_QtGui_QStackedLayout;

#define sipClass_QStackedWidget             sipModuleAPI_QtGui.em_types[319]
#define sipCast_QStackedWidget              sipType_QtGui_QStackedWidget.td_cast
#define sipForceConvertTo_QStackedWidget    sipType_QtGui_QStackedWidget.td_fcto

extern sipTypeDef sipType_QtGui_QStackedWidget;

#define sipClass_QStandardItemModel             sipModuleAPI_QtGui.em_types[99]
#define sipCast_QStandardItemModel              sipType_QtGui_QStandardItemModel.td_cast
#define sipForceConvertTo_QStandardItemModel    sipType_QtGui_QStandardItemModel.td_fcto

extern sipTypeDef sipType_QtGui_QStandardItemModel;

#define sipClass_QStandardItem             sipModuleAPI_QtGui.em_types[98]
#define sipCast_QStandardItem              sipType_QtGui_QStandardItem.td_cast
#define sipForceConvertTo_QStandardItem    sipType_QtGui_QStandardItem.td_fcto

#define sipEnum_QStandardItem_ItemType              sipModuleAPI_QtGui.em_enums[140]

extern sipTypeDef sipType_QtGui_QStandardItem;

#define sipClass_QStatusBar             sipModuleAPI_QtGui.em_types[262]
#define sipCast_QStatusBar              sipType_QtGui_QStatusBar.td_cast
#define sipForceConvertTo_QStatusBar    sipType_QtGui_QStatusBar.td_fcto

extern sipTypeDef sipType_QtGui_QStatusBar;

#define sipClass_QStringListModel             sipModuleAPI_QtGui.em_types[97]
#define sipCast_QStringListModel              sipType_QtGui_QStringListModel.td_cast
#define sipForceConvertTo_QStringListModel    sipType_QtGui_QStringListModel.td_fcto

extern sipTypeDef sipType_QtGui_QStringListModel;

#define sipClass_QStyle             sipModuleAPI_QtGui.em_types[94]
#define sipCast_QStyle              sipType_QtGui_QStyle.td_cast
#define sipForceConvertTo_QStyle    sipType_QtGui_QStyle.td_fcto

#define sipEnum_QStyle_StandardPixmap              sipModuleAPI_QtGui.em_enums[130]
#define sipEnum_QStyle_StyleHint              sipModuleAPI_QtGui.em_enums[131]
#define sipEnum_QStyle_ContentsType              sipModuleAPI_QtGui.em_enums[132]
#define sipEnum_QStyle_PixelMetric              sipModuleAPI_QtGui.em_enums[133]
#define sipEnum_QStyle_SubControl              sipModuleAPI_QtGui.em_enums[134]
#define sipEnum_QStyle_ComplexControl              sipModuleAPI_QtGui.em_enums[135]
#define sipEnum_QStyle_SubElement              sipModuleAPI_QtGui.em_enums[136]
#define sipEnum_QStyle_ControlElement              sipModuleAPI_QtGui.em_enums[137]
#define sipEnum_QStyle_PrimitiveElement              sipModuleAPI_QtGui.em_enums[138]
#define sipEnum_QStyle_StateFlag              sipModuleAPI_QtGui.em_enums[139]

extern sipTypeDef sipType_QtGui_QStyle;

#define sipClass_QStyle_State             sipModuleAPI_QtGui.em_types[96]
#define sipCast_QStyle_State              sipType_QtGui_QStyle_State.td_cast
#define sipForceConvertTo_QStyle_State    sipType_QtGui_QStyle_State.td_fcto

extern sipTypeDef sipType_QtGui_QStyle_State;

#define sipClass_QStyle_SubControls             sipModuleAPI_QtGui.em_types[95]
#define sipCast_QStyle_SubControls              sipType_QtGui_QStyle_SubControls.td_cast
#define sipForceConvertTo_QStyle_SubControls    sipType_QtGui_QStyle_SubControls.td_fcto

extern sipTypeDef sipType_QtGui_QStyle_SubControls;

#define sipClass_QStyledItemDelegate             sipModuleAPI_QtGui.em_types[245]
#define sipCast_QStyledItemDelegate              sipType_QtGui_QStyledItemDelegate.td_cast
#define sipForceConvertTo_QStyledItemDelegate    sipType_QtGui_QStyledItemDelegate.td_fcto

extern sipTypeDef sipType_QtGui_QStyledItemDelegate;

#define sipClass_QStyleFactory             sipModuleAPI_QtGui.em_types[93]
#define sipCast_QStyleFactory              sipType_QtGui_QStyleFactory.td_cast
#define sipForceConvertTo_QStyleFactory    sipType_QtGui_QStyleFactory.td_fcto

extern sipTypeDef sipType_QtGui_QStyleFactory;

#define sipClass_QStyleOption             sipModuleAPI_QtGui.em_types[55]
#define sipCast_QStyleOption              sipType_QtGui_QStyleOption.td_cast
#define sipForceConvertTo_QStyleOption    sipType_QtGui_QStyleOption.td_fcto

#define sipEnum_QStyleOption_StyleOptionVersion              sipModuleAPI_QtGui.em_enums[127]
#define sipEnum_QStyleOption_StyleOptionType              sipModuleAPI_QtGui.em_enums[128]
#define sipEnum_QStyleOption_OptionType              sipModuleAPI_QtGui.em_enums[129]

extern sipTypeDef sipType_QtGui_QStyleOption;

#define sipClass_QStyleOptionFocusRect             sipModuleAPI_QtGui.em_types[92]
#define sipCast_QStyleOptionFocusRect              sipType_QtGui_QStyleOptionFocusRect.td_cast
#define sipForceConvertTo_QStyleOptionFocusRect    sipType_QtGui_QStyleOptionFocusRect.td_fcto

#define sipEnum_QStyleOptionFocusRect_StyleOptionVersion              sipModuleAPI_QtGui.em_enums[125]
#define sipEnum_QStyleOptionFocusRect_StyleOptionType              sipModuleAPI_QtGui.em_enums[126]

extern sipTypeDef sipType_QtGui_QStyleOptionFocusRect;

#define sipClass_QStyleOptionFrame             sipModuleAPI_QtGui.em_types[89]
#define sipCast_QStyleOptionFrame              sipType_QtGui_QStyleOptionFrame.td_cast
#define sipForceConvertTo_QStyleOptionFrame    sipType_QtGui_QStyleOptionFrame.td_fcto

#define sipEnum_QStyleOptionFrame_StyleOptionVersion              sipModuleAPI_QtGui.em_enums[123]
#define sipEnum_QStyleOptionFrame_StyleOptionType              sipModuleAPI_QtGui.em_enums[124]

extern sipTypeDef sipType_QtGui_QStyleOptionFrame;

#define sipClass_QStyleOptionFrameV2             sipModuleAPI_QtGui.em_types[90]
#define sipCast_QStyleOptionFrameV2              sipType_QtGui_QStyleOptionFrameV2.td_cast
#define sipForceConvertTo_QStyleOptionFrameV2    sipType_QtGui_QStyleOptionFrameV2.td_fcto

#define sipEnum_QStyleOptionFrameV2_FrameFeature              sipModuleAPI_QtGui.em_enums[121]
#define sipEnum_QStyleOptionFrameV2_StyleOptionVersion              sipModuleAPI_QtGui.em_enums[122]

extern sipTypeDef sipType_QtGui_QStyleOptionFrameV2;

#define sipClass_QStyleOptionFrameV2_FrameFeatures             sipModuleAPI_QtGui.em_types[91]
#define sipCast_QStyleOptionFrameV2_FrameFeatures              sipType_QtGui_QStyleOptionFrameV2_FrameFeatures.td_cast
#define sipForceConvertTo_QStyleOptionFrameV2_FrameFeatures    sipType_QtGui_QStyleOptionFrameV2_FrameFeatures.td_fcto

extern sipTypeDef sipType_QtGui_QStyleOptionFrameV2_FrameFeatures;

#define sipClass_QStyleOptionTabWidgetFrame             sipModuleAPI_QtGui.em_types[88]
#define sipCast_QStyleOptionTabWidgetFrame              sipType_QtGui_QStyleOptionTabWidgetFrame.td_cast
#define sipForceConvertTo_QStyleOptionTabWidgetFrame    sipType_QtGui_QStyleOptionTabWidgetFrame.td_fcto

#define sipEnum_QStyleOptionTabWidgetFrame_StyleOptionVersion              sipModuleAPI_QtGui.em_enums[119]
#define sipEnum_QStyleOptionTabWidgetFrame_StyleOptionType              sipModuleAPI_QtGui.em_enums[120]

extern sipTypeDef sipType_QtGui_QStyleOptionTabWidgetFrame;

#define sipClass_QStyleOptionTabBarBase             sipModuleAPI_QtGui.em_types[87]
#define sipCast_QStyleOptionTabBarBase              sipType_QtGui_QStyleOptionTabBarBase.td_cast
#define sipForceConvertTo_QStyleOptionTabBarBase    sipType_QtGui_QStyleOptionTabBarBase.td_fcto

#define sipEnum_QStyleOptionTabBarBase_StyleOptionVersion              sipModuleAPI_QtGui.em_enums[117]
#define sipEnum_QStyleOptionTabBarBase_StyleOptionType              sipModuleAPI_QtGui.em_enums[118]

extern sipTypeDef sipType_QtGui_QStyleOptionTabBarBase;

#define sipClass_QStyleOptionHeader             sipModuleAPI_QtGui.em_types[86]
#define sipCast_QStyleOptionHeader              sipType_QtGui_QStyleOptionHeader.td_cast
#define sipForceConvertTo_QStyleOptionHeader    sipType_QtGui_QStyleOptionHeader.td_fcto

#define sipEnum_QStyleOptionHeader_SortIndicator              sipModuleAPI_QtGui.em_enums[112]
#define sipEnum_QStyleOptionHeader_SelectedPosition              sipModuleAPI_QtGui.em_enums[113]
#define sipEnum_QStyleOptionHeader_SectionPosition              sipModuleAPI_QtGui.em_enums[114]
#define sipEnum_QStyleOptionHeader_StyleOptionVersion              sipModuleAPI_QtGui.em_enums[115]
#define sipEnum_QStyleOptionHeader_StyleOptionType              sipModuleAPI_QtGui.em_enums[116]

extern sipTypeDef sipType_QtGui_QStyleOptionHeader;

#define sipClass_QStyleOptionButton             sipModuleAPI_QtGui.em_types[84]
#define sipCast_QStyleOptionButton              sipType_QtGui_QStyleOptionButton.td_cast
#define sipForceConvertTo_QStyleOptionButton    sipType_QtGui_QStyleOptionButton.td_fcto

#define sipEnum_QStyleOptionButton_ButtonFeature              sipModuleAPI_QtGui.em_enums[109]
#define sipEnum_QStyleOptionButton_StyleOptionVersion              sipModuleAPI_QtGui.em_enums[110]
#define sipEnum_QStyleOptionButton_StyleOptionType              sipModuleAPI_QtGui.em_enums[111]

extern sipTypeDef sipType_QtGui_QStyleOptionButton;

#define sipClass_QStyleOptionButton_ButtonFeatures             sipModuleAPI_QtGui.em_types[85]
#define sipCast_QStyleOptionButton_ButtonFeatures              sipType_QtGui_QStyleOptionButton_ButtonFeatures.td_cast
#define sipForceConvertTo_QStyleOptionButton_ButtonFeatures    sipType_QtGui_QStyleOptionButton_ButtonFeatures.td_fcto

extern sipTypeDef sipType_QtGui_QStyleOptionButton_ButtonFeatures;

#define sipClass_QStyleOptionTab             sipModuleAPI_QtGui.em_types[81]
#define sipCast_QStyleOptionTab              sipType_QtGui_QStyleOptionTab.td_cast
#define sipForceConvertTo_QStyleOptionTab    sipType_QtGui_QStyleOptionTab.td_fcto

#define sipEnum_QStyleOptionTab_CornerWidget              sipModuleAPI_QtGui.em_enums[104]
#define sipEnum_QStyleOptionTab_SelectedPosition              sipModuleAPI_QtGui.em_enums[105]
#define sipEnum_QStyleOptionTab_TabPosition              sipModuleAPI_QtGui.em_enums[106]
#define sipEnum_QStyleOptionTab_StyleOptionVersion              sipModuleAPI_QtGui.em_enums[107]
#define sipEnum_QStyleOptionTab_StyleOptionType              sipModuleAPI_QtGui.em_enums[108]

extern sipTypeDef sipType_QtGui_QStyleOptionTab;

#define sipClass_QStyleOptionTab_CornerWidgets             sipModuleAPI_QtGui.em_types[82]
#define sipCast_QStyleOptionTab_CornerWidgets              sipType_QtGui_QStyleOptionTab_CornerWidgets.td_cast
#define sipForceConvertTo_QStyleOptionTab_CornerWidgets    sipType_QtGui_QStyleOptionTab_CornerWidgets.td_fcto

extern sipTypeDef sipType_QtGui_QStyleOptionTab_CornerWidgets;

#define sipClass_QStyleOptionTabV2             sipModuleAPI_QtGui.em_types[83]
#define sipCast_QStyleOptionTabV2              sipType_QtGui_QStyleOptionTabV2.td_cast
#define sipForceConvertTo_QStyleOptionTabV2    sipType_QtGui_QStyleOptionTabV2.td_fcto

#define sipEnum_QStyleOptionTabV2_StyleOptionVersion              sipModuleAPI_QtGui.em_enums[103]

extern sipTypeDef sipType_QtGui_QStyleOptionTabV2;

#define sipClass_QStyleOptionProgressBar             sipModuleAPI_QtGui.em_types[79]
#define sipCast_QStyleOptionProgressBar              sipType_QtGui_QStyleOptionProgressBar.td_cast
#define sipForceConvertTo_QStyleOptionProgressBar    sipType_QtGui_QStyleOptionProgressBar.td_fcto

#define sipEnum_QStyleOptionProgressBar_StyleOptionVersion              sipModuleAPI_QtGui.em_enums[101]
#define sipEnum_QStyleOptionProgressBar_StyleOptionType              sipModuleAPI_QtGui.em_enums[102]

extern sipTypeDef sipType_QtGui_QStyleOptionProgressBar;

#define sipClass_QStyleOptionProgressBarV2             sipModuleAPI_QtGui.em_types[80]
#define sipCast_QStyleOptionProgressBarV2              sipType_QtGui_QStyleOptionProgressBarV2.td_cast
#define sipForceConvertTo_QStyleOptionProgressBarV2    sipType_QtGui_QStyleOptionProgressBarV2.td_fcto

#define sipEnum_QStyleOptionProgressBarV2_StyleOptionVersion              sipModuleAPI_QtGui.em_enums[99]
#define sipEnum_QStyleOptionProgressBarV2_StyleOptionType              sipModuleAPI_QtGui.em_enums[100]

extern sipTypeDef sipType_QtGui_QStyleOptionProgressBarV2;

#define sipClass_QStyleOptionMenuItem             sipModuleAPI_QtGui.em_types[78]
#define sipCast_QStyleOptionMenuItem              sipType_QtGui_QStyleOptionMenuItem.td_cast
#define sipForceConvertTo_QStyleOptionMenuItem    sipType_QtGui_QStyleOptionMenuItem.td_fcto

#define sipEnum_QStyleOptionMenuItem_CheckType              sipModuleAPI_QtGui.em_enums[95]
#define sipEnum_QStyleOptionMenuItem_MenuItemType              sipModuleAPI_QtGui.em_enums[96]
#define sipEnum_QStyleOptionMenuItem_StyleOptionVersion              sipModuleAPI_QtGui.em_enums[97]
#define sipEnum_QStyleOptionMenuItem_StyleOptionType              sipModuleAPI_QtGui.em_enums[98]

extern sipTypeDef sipType_QtGui_QStyleOptionMenuItem;

#define sipClass_QStyleOptionDockWidget             sipModuleAPI_QtGui.em_types[76]
#define sipCast_QStyleOptionDockWidget              sipType_QtGui_QStyleOptionDockWidget.td_cast
#define sipForceConvertTo_QStyleOptionDockWidget    sipType_QtGui_QStyleOptionDockWidget.td_fcto

#define sipEnum_QStyleOptionDockWidget_StyleOptionVersion              sipModuleAPI_QtGui.em_enums[93]
#define sipEnum_QStyleOptionDockWidget_StyleOptionType              sipModuleAPI_QtGui.em_enums[94]

extern sipTypeDef sipType_QtGui_QStyleOptionDockWidget;

#define sipClass_QStyleOptionViewItem             sipModuleAPI_QtGui.em_types[71]
#define sipCast_QStyleOptionViewItem              sipType_QtGui_QStyleOptionViewItem.td_cast
#define sipForceConvertTo_QStyleOptionViewItem    sipType_QtGui_QStyleOptionViewItem.td_fcto

#define sipEnum_QStyleOptionViewItem_Position              sipModuleAPI_QtGui.em_enums[90]
#define sipEnum_QStyleOptionViewItem_StyleOptionVersion              sipModuleAPI_QtGui.em_enums[91]
#define sipEnum_QStyleOptionViewItem_StyleOptionType              sipModuleAPI_QtGui.em_enums[92]

extern sipTypeDef sipType_QtGui_QStyleOptionViewItem;

#define sipClass_QStyleOptionToolBox             sipModuleAPI_QtGui.em_types[69]
#define sipCast_QStyleOptionToolBox              sipType_QtGui_QStyleOptionToolBox.td_cast
#define sipForceConvertTo_QStyleOptionToolBox    sipType_QtGui_QStyleOptionToolBox.td_fcto

#define sipEnum_QStyleOptionToolBox_StyleOptionVersion              sipModuleAPI_QtGui.em_enums[88]
#define sipEnum_QStyleOptionToolBox_StyleOptionType              sipModuleAPI_QtGui.em_enums[89]

extern sipTypeDef sipType_QtGui_QStyleOptionToolBox;

#define sipClass_QStyleOptionRubberBand             sipModuleAPI_QtGui.em_types[68]
#define sipCast_QStyleOptionRubberBand              sipType_QtGui_QStyleOptionRubberBand.td_cast
#define sipForceConvertTo_QStyleOptionRubberBand    sipType_QtGui_QStyleOptionRubberBand.td_fcto

#define sipEnum_QStyleOptionRubberBand_StyleOptionVersion              sipModuleAPI_QtGui.em_enums[86]
#define sipEnum_QStyleOptionRubberBand_StyleOptionType              sipModuleAPI_QtGui.em_enums[87]

extern sipTypeDef sipType_QtGui_QStyleOptionRubberBand;

#define sipClass_QStyleOptionComplex             sipModuleAPI_QtGui.em_types[59]
#define sipCast_QStyleOptionComplex              sipType_QtGui_QStyleOptionComplex.td_cast
#define sipForceConvertTo_QStyleOptionComplex    sipType_QtGui_QStyleOptionComplex.td_fcto

#define sipEnum_QStyleOptionComplex_StyleOptionVersion              sipModuleAPI_QtGui.em_enums[84]
#define sipEnum_QStyleOptionComplex_StyleOptionType              sipModuleAPI_QtGui.em_enums[85]

extern sipTypeDef sipType_QtGui_QStyleOptionComplex;

#define sipClass_QStyleOptionSlider             sipModuleAPI_QtGui.em_types[67]
#define sipCast_QStyleOptionSlider              sipType_QtGui_QStyleOptionSlider.td_cast
#define sipForceConvertTo_QStyleOptionSlider    sipType_QtGui_QStyleOptionSlider.td_fcto

#define sipEnum_QStyleOptionSlider_StyleOptionVersion              sipModuleAPI_QtGui.em_enums[82]
#define sipEnum_QStyleOptionSlider_StyleOptionType              sipModuleAPI_QtGui.em_enums[83]

extern sipTypeDef sipType_QtGui_QStyleOptionSlider;

#define sipClass_QStyleOptionSpinBox             sipModuleAPI_QtGui.em_types[66]
#define sipCast_QStyleOptionSpinBox              sipType_QtGui_QStyleOptionSpinBox.td_cast
#define sipForceConvertTo_QStyleOptionSpinBox    sipType_QtGui_QStyleOptionSpinBox.td_fcto

#define sipEnum_QStyleOptionSpinBox_StyleOptionVersion              sipModuleAPI_QtGui.em_enums[80]
#define sipEnum_QStyleOptionSpinBox_StyleOptionType              sipModuleAPI_QtGui.em_enums[81]

extern sipTypeDef sipType_QtGui_QStyleOptionSpinBox;

#define sipClass_QStyleOptionToolButton             sipModuleAPI_QtGui.em_types[64]
#define sipCast_QStyleOptionToolButton              sipType_QtGui_QStyleOptionToolButton.td_cast
#define sipForceConvertTo_QStyleOptionToolButton    sipType_QtGui_QStyleOptionToolButton.td_fcto

#define sipEnum_QStyleOptionToolButton_ToolButtonFeature              sipModuleAPI_QtGui.em_enums[77]
#define sipEnum_QStyleOptionToolButton_StyleOptionVersion              sipModuleAPI_QtGui.em_enums[78]
#define sipEnum_QStyleOptionToolButton_StyleOptionType              sipModuleAPI_QtGui.em_enums[79]

extern sipTypeDef sipType_QtGui_QStyleOptionToolButton;

#define sipClass_QStyleOptionToolButton_ToolButtonFeatures             sipModuleAPI_QtGui.em_types[65]
#define sipCast_QStyleOptionToolButton_ToolButtonFeatures              sipType_QtGui_QStyleOptionToolButton_ToolButtonFeatures.td_cast
#define sipForceConvertTo_QStyleOptionToolButton_ToolButtonFeatures    sipType_QtGui_QStyleOptionToolButton_ToolButtonFeatures.td_fcto

extern sipTypeDef sipType_QtGui_QStyleOptionToolButton_ToolButtonFeatures;

#define sipClass_QStyleOptionComboBox             sipModuleAPI_QtGui.em_types[63]
#define sipCast_QStyleOptionComboBox              sipType_QtGui_QStyleOptionComboBox.td_cast
#define sipForceConvertTo_QStyleOptionComboBox    sipType_QtGui_QStyleOptionComboBox.td_fcto

#define sipEnum_QStyleOptionComboBox_StyleOptionVersion              sipModuleAPI_QtGui.em_enums[75]
#define sipEnum_QStyleOptionComboBox_StyleOptionType              sipModuleAPI_QtGui.em_enums[76]

extern sipTypeDef sipType_QtGui_QStyleOptionComboBox;

#define sipClass_QStyleOptionTitleBar             sipModuleAPI_QtGui.em_types[62]
#define sipCast_QStyleOptionTitleBar              sipType_QtGui_QStyleOptionTitleBar.td_cast
#define sipForceConvertTo_QStyleOptionTitleBar    sipType_QtGui_QStyleOptionTitleBar.td_fcto

#define sipEnum_QStyleOptionTitleBar_StyleOptionVersion              sipModuleAPI_QtGui.em_enums[73]
#define sipEnum_QStyleOptionTitleBar_StyleOptionType              sipModuleAPI_QtGui.em_enums[74]

extern sipTypeDef sipType_QtGui_QStyleOptionTitleBar;

#define sipClass_QStyleHintReturn             sipModuleAPI_QtGui.em_types[52]
#define sipCast_QStyleHintReturn              sipType_QtGui_QStyleHintReturn.td_cast
#define sipForceConvertTo_QStyleHintReturn    sipType_QtGui_QStyleHintReturn.td_fcto

#define sipEnum_QStyleHintReturn_StyleOptionVersion              sipModuleAPI_QtGui.em_enums[70]
#define sipEnum_QStyleHintReturn_StyleOptionType              sipModuleAPI_QtGui.em_enums[71]
#define sipEnum_QStyleHintReturn_HintReturnType              sipModuleAPI_QtGui.em_enums[72]

extern sipTypeDef sipType_QtGui_QStyleHintReturn;

#define sipClass_QStyleHintReturnMask             sipModuleAPI_QtGui.em_types[54]
#define sipCast_QStyleHintReturnMask              sipType_QtGui_QStyleHintReturnMask.td_cast
#define sipForceConvertTo_QStyleHintReturnMask    sipType_QtGui_QStyleHintReturnMask.td_fcto

#define sipEnum_QStyleHintReturnMask_StyleOptionVersion              sipModuleAPI_QtGui.em_enums[68]
#define sipEnum_QStyleHintReturnMask_StyleOptionType              sipModuleAPI_QtGui.em_enums[69]

extern sipTypeDef sipType_QtGui_QStyleHintReturnMask;

#define sipClass_QStyleOptionToolBar             sipModuleAPI_QtGui.em_types[57]
#define sipCast_QStyleOptionToolBar              sipType_QtGui_QStyleOptionToolBar.td_cast
#define sipForceConvertTo_QStyleOptionToolBar    sipType_QtGui_QStyleOptionToolBar.td_fcto

#define sipEnum_QStyleOptionToolBar_ToolBarFeature              sipModuleAPI_QtGui.em_enums[64]
#define sipEnum_QStyleOptionToolBar_ToolBarPosition              sipModuleAPI_QtGui.em_enums[65]
#define sipEnum_QStyleOptionToolBar_StyleOptionVersion              sipModuleAPI_QtGui.em_enums[66]
#define sipEnum_QStyleOptionToolBar_StyleOptionType              sipModuleAPI_QtGui.em_enums[67]

extern sipTypeDef sipType_QtGui_QStyleOptionToolBar;

#define sipClass_QStyleOptionToolBar_ToolBarFeatures             sipModuleAPI_QtGui.em_types[58]
#define sipCast_QStyleOptionToolBar_ToolBarFeatures              sipType_QtGui_QStyleOptionToolBar_ToolBarFeatures.td_cast
#define sipForceConvertTo_QStyleOptionToolBar_ToolBarFeatures    sipType_QtGui_QStyleOptionToolBar_ToolBarFeatures.td_fcto

extern sipTypeDef sipType_QtGui_QStyleOptionToolBar_ToolBarFeatures;

#define sipClass_QStyleOptionGroupBox             sipModuleAPI_QtGui.em_types[61]
#define sipCast_QStyleOptionGroupBox              sipType_QtGui_QStyleOptionGroupBox.td_cast
#define sipForceConvertTo_QStyleOptionGroupBox    sipType_QtGui_QStyleOptionGroupBox.td_fcto

#define sipEnum_QStyleOptionGroupBox_StyleOptionVersion              sipModuleAPI_QtGui.em_enums[62]
#define sipEnum_QStyleOptionGroupBox_StyleOptionType              sipModuleAPI_QtGui.em_enums[63]

extern sipTypeDef sipType_QtGui_QStyleOptionGroupBox;

#define sipClass_QStyleOptionViewItemV2             sipModuleAPI_QtGui.em_types[72]
#define sipCast_QStyleOptionViewItemV2              sipType_QtGui_QStyleOptionViewItemV2.td_cast
#define sipForceConvertTo_QStyleOptionViewItemV2    sipType_QtGui_QStyleOptionViewItemV2.td_fcto

#define sipEnum_QStyleOptionViewItemV2_ViewItemFeature              sipModuleAPI_QtGui.em_enums[60]
#define sipEnum_QStyleOptionViewItemV2_StyleOptionVersion              sipModuleAPI_QtGui.em_enums[61]

extern sipTypeDef sipType_QtGui_QStyleOptionViewItemV2;

#define sipClass_QStyleOptionViewItemV2_ViewItemFeatures             sipModuleAPI_QtGui.em_types[73]
#define sipCast_QStyleOptionViewItemV2_ViewItemFeatures              sipType_QtGui_QStyleOptionViewItemV2_ViewItemFeatures.td_cast
#define sipForceConvertTo_QStyleOptionViewItemV2_ViewItemFeatures    sipType_QtGui_QStyleOptionViewItemV2_ViewItemFeatures.td_fcto

extern sipTypeDef sipType_QtGui_QStyleOptionViewItemV2_ViewItemFeatures;

#define sipClass_QStyleOptionSizeGrip             sipModuleAPI_QtGui.em_types[60]
#define sipCast_QStyleOptionSizeGrip              sipType_QtGui_QStyleOptionSizeGrip.td_cast
#define sipForceConvertTo_QStyleOptionSizeGrip    sipType_QtGui_QStyleOptionSizeGrip.td_fcto

#define sipEnum_QStyleOptionSizeGrip_StyleOptionVersion              sipModuleAPI_QtGui.em_enums[58]
#define sipEnum_QStyleOptionSizeGrip_StyleOptionType              sipModuleAPI_QtGui.em_enums[59]

extern sipTypeDef sipType_QtGui_QStyleOptionSizeGrip;

#define sipClass_QStyleOptionGraphicsItem             sipModuleAPI_QtGui.em_types[56]
#define sipCast_QStyleOptionGraphicsItem              sipType_QtGui_QStyleOptionGraphicsItem.td_cast
#define sipForceConvertTo_QStyleOptionGraphicsItem    sipType_QtGui_QStyleOptionGraphicsItem.td_fcto

#define sipEnum_QStyleOptionGraphicsItem_StyleOptionVersion              sipModuleAPI_QtGui.em_enums[56]
#define sipEnum_QStyleOptionGraphicsItem_StyleOptionType              sipModuleAPI_QtGui.em_enums[57]

extern sipTypeDef sipType_QtGui_QStyleOptionGraphicsItem;

#define sipClass_QStyleOptionDockWidgetV2             sipModuleAPI_QtGui.em_types[77]
#define sipCast_QStyleOptionDockWidgetV2              sipType_QtGui_QStyleOptionDockWidgetV2.td_cast
#define sipForceConvertTo_QStyleOptionDockWidgetV2    sipType_QtGui_QStyleOptionDockWidgetV2.td_fcto

#define sipEnum_QStyleOptionDockWidgetV2_StyleOptionVersion              sipModuleAPI_QtGui.em_enums[55]

extern sipTypeDef sipType_QtGui_QStyleOptionDockWidgetV2;

#define sipClass_QStyleOptionViewItemV3             sipModuleAPI_QtGui.em_types[74]
#define sipCast_QStyleOptionViewItemV3              sipType_QtGui_QStyleOptionViewItemV3.td_cast
#define sipForceConvertTo_QStyleOptionViewItemV3    sipType_QtGui_QStyleOptionViewItemV3.td_fcto

#define sipEnum_QStyleOptionViewItemV3_StyleOptionVersion              sipModuleAPI_QtGui.em_enums[54]

extern sipTypeDef sipType_QtGui_QStyleOptionViewItemV3;

#define sipClass_QStyleOptionToolBoxV2             sipModuleAPI_QtGui.em_types[70]
#define sipCast_QStyleOptionToolBoxV2              sipType_QtGui_QStyleOptionToolBoxV2.td_cast
#define sipForceConvertTo_QStyleOptionToolBoxV2    sipType_QtGui_QStyleOptionToolBoxV2.td_fcto

#define sipEnum_QStyleOptionToolBoxV2_SelectedPosition              sipModuleAPI_QtGui.em_enums[51]
#define sipEnum_QStyleOptionToolBoxV2_TabPosition              sipModuleAPI_QtGui.em_enums[52]
#define sipEnum_QStyleOptionToolBoxV2_StyleOptionVersion              sipModuleAPI_QtGui.em_enums[53]

extern sipTypeDef sipType_QtGui_QStyleOptionToolBoxV2;

#define sipClass_QStyleHintReturnVariant             sipModuleAPI_QtGui.em_types[53]
#define sipCast_QStyleHintReturnVariant              sipType_QtGui_QStyleHintReturnVariant.td_cast
#define sipForceConvertTo_QStyleHintReturnVariant    sipType_QtGui_QStyleHintReturnVariant.td_fcto

#define sipEnum_QStyleHintReturnVariant_StyleOptionVersion              sipModuleAPI_QtGui.em_enums[49]
#define sipEnum_QStyleHintReturnVariant_StyleOptionType              sipModuleAPI_QtGui.em_enums[50]

extern sipTypeDef sipType_QtGui_QStyleHintReturnVariant;

#define sipClass_QStyleOptionViewItemV4             sipModuleAPI_QtGui.em_types[75]
#define sipCast_QStyleOptionViewItemV4              sipType_QtGui_QStyleOptionViewItemV4.td_cast
#define sipForceConvertTo_QStyleOptionViewItemV4    sipType_QtGui_QStyleOptionViewItemV4.td_fcto

#define sipEnum_QStyleOptionViewItemV4_ViewItemPosition              sipModuleAPI_QtGui.em_enums[47]
#define sipEnum_QStyleOptionViewItemV4_StyleOptionVersion              sipModuleAPI_QtGui.em_enums[48]

extern sipTypeDef sipType_QtGui_QStyleOptionViewItemV4;

#define sipClass_QStylePainter             sipModuleAPI_QtGui.em_types[126]
#define sipCast_QStylePainter              sipType_QtGui_QStylePainter.td_cast
#define sipForceConvertTo_QStylePainter    sipType_QtGui_QStylePainter.td_fcto

extern sipTypeDef sipType_QtGui_QStylePainter;

#define sipClass_QSyntaxHighlighter             sipModuleAPI_QtGui.em_types[51]
#define sipCast_QSyntaxHighlighter              sipType_QtGui_QSyntaxHighlighter.td_cast
#define sipForceConvertTo_QSyntaxHighlighter    sipType_QtGui_QSyntaxHighlighter.td_fcto

extern sipTypeDef sipType_QtGui_QSyntaxHighlighter;

#define sipClass_QSystemTrayIcon             sipModuleAPI_QtGui.em_types[50]
#define sipCast_QSystemTrayIcon              sipType_QtGui_QSystemTrayIcon.td_cast
#define sipForceConvertTo_QSystemTrayIcon    sipType_QtGui_QSystemTrayIcon.td_fcto

#define sipEnum_QSystemTrayIcon_MessageIcon              sipModuleAPI_QtGui.em_enums[45]
#define sipEnum_QSystemTrayIcon_ActivationReason              sipModuleAPI_QtGui.em_enums[46]

extern sipTypeDef sipType_QtGui_QSystemTrayIcon;

#define sipClass_QTabBar             sipModuleAPI_QtGui.em_types[261]
#define sipCast_QTabBar              sipType_QtGui_QTabBar.td_cast
#define sipForceConvertTo_QTabBar    sipType_QtGui_QTabBar.td_fcto

#define sipEnum_QTabBar_Shape              sipModuleAPI_QtGui.em_enums[44]

extern sipTypeDef sipType_QtGui_QTabBar;

#define sipClass_QTableView             sipModuleAPI_QtGui.em_types[339]
#define sipCast_QTableView              sipType_QtGui_QTableView.td_cast
#define sipForceConvertTo_QTableView    sipType_QtGui_QTableView.td_fcto

extern sipTypeDef sipType_QtGui_QTableView;

#define sipClass_QTableWidgetSelectionRange             sipModuleAPI_QtGui.em_types[49]
#define sipCast_QTableWidgetSelectionRange              sipType_QtGui_QTableWidgetSelectionRange.td_cast
#define sipForceConvertTo_QTableWidgetSelectionRange    sipType_QtGui_QTableWidgetSelectionRange.td_fcto

extern sipTypeDef sipType_QtGui_QTableWidgetSelectionRange;

#define sipClass_QTableWidgetItem             sipModuleAPI_QtGui.em_types[48]
#define sipCast_QTableWidgetItem              sipType_QtGui_QTableWidgetItem.td_cast
#define sipForceConvertTo_QTableWidgetItem    sipType_QtGui_QTableWidgetItem.td_fcto

#define sipEnum_QTableWidgetItem_ItemType              sipModuleAPI_QtGui.em_enums[43]

extern sipTypeDef sipType_QtGui_QTableWidgetItem;

#define sipClass_QTableWidget             sipModuleAPI_QtGui.em_types[340]
#define sipCast_QTableWidget              sipType_QtGui_QTableWidget.td_cast
#define sipForceConvertTo_QTableWidget    sipType_QtGui_QTableWidget.td_fcto

extern sipTypeDef sipType_QtGui_QTableWidget;

#define sipClass_QTabWidget             sipModuleAPI_QtGui.em_types[260]
#define sipCast_QTabWidget              sipType_QtGui_QTabWidget.td_cast
#define sipForceConvertTo_QTabWidget    sipType_QtGui_QTabWidget.td_fcto

#define sipEnum_QTabWidget_TabShape              sipModuleAPI_QtGui.em_enums[41]
#define sipEnum_QTabWidget_TabPosition              sipModuleAPI_QtGui.em_enums[42]

extern sipTypeDef sipType_QtGui_QTabWidget;

#define sipClass_QTextEdit             sipModuleAPI_QtGui.em_types[324]
#define sipCast_QTextEdit              sipType_QtGui_QTextEdit.td_cast
#define sipForceConvertTo_QTextEdit    sipType_QtGui_QTextEdit.td_fcto

#define sipEnum_QTextEdit_AutoFormattingFlag              sipModuleAPI_QtGui.em_enums[31]
#define sipEnum_QTextEdit_LineWrapMode              sipModuleAPI_QtGui.em_enums[32]

extern sipTypeDef sipType_QtGui_QTextEdit;

#define sipClass_QTextBrowser             sipModuleAPI_QtGui.em_types[327]
#define sipCast_QTextBrowser              sipType_QtGui_QTextBrowser.td_cast
#define sipForceConvertTo_QTextBrowser    sipType_QtGui_QTextBrowser.td_fcto

extern sipTypeDef sipType_QtGui_QTextBrowser;

#define sipClass_QTextCursor             sipModuleAPI_QtGui.em_types[47]
#define sipCast_QTextCursor              sipType_QtGui_QTextCursor.td_cast
#define sipForceConvertTo_QTextCursor    sipType_QtGui_QTextCursor.td_fcto

#define sipEnum_QTextCursor_SelectionType              sipModuleAPI_QtGui.em_enums[38]
#define sipEnum_QTextCursor_MoveOperation              sipModuleAPI_QtGui.em_enums[39]
#define sipEnum_QTextCursor_MoveMode              sipModuleAPI_QtGui.em_enums[40]

extern sipTypeDef sipType_QtGui_QTextCursor;


#define sipEnum_Qt_WhiteSpaceMode              sipModuleAPI_QtGui.em_enums[36]
#define sipEnum_Qt_HitTestAccuracy              sipModuleAPI_QtGui.em_enums[37]

extern sipTypeDef sipType_QtGui_Qt;

#define sipClass_QTextDocument             sipModuleAPI_QtGui.em_types[44]
#define sipCast_QTextDocument              sipType_QtGui_QTextDocument.td_cast
#define sipForceConvertTo_QTextDocument    sipType_QtGui_QTextDocument.td_fcto

#define sipEnum_QTextDocument_ResourceType              sipModuleAPI_QtGui.em_enums[33]
#define sipEnum_QTextDocument_FindFlag              sipModuleAPI_QtGui.em_enums[34]
#define sipEnum_QTextDocument_MetaInformation              sipModuleAPI_QtGui.em_enums[35]

extern sipTypeDef sipType_QtGui_QTextDocument;

#define sipClass_QTextDocument_FindFlags             sipModuleAPI_QtGui.em_types[45]
#define sipCast_QTextDocument_FindFlags              sipType_QtGui_QTextDocument_FindFlags.td_cast
#define sipForceConvertTo_QTextDocument_FindFlags    sipType_QtGui_QTextDocument_FindFlags.td_fcto

extern sipTypeDef sipType_QtGui_QTextDocument_FindFlags;

#define sipClass_QTextDocumentFragment             sipModuleAPI_QtGui.em_types[43]
#define sipCast_QTextDocumentFragment              sipType_QtGui_QTextDocumentFragment.td_cast
#define sipForceConvertTo_QTextDocumentFragment    sipType_QtGui_QTextDocumentFragment.td_fcto

extern sipTypeDef sipType_QtGui_QTextDocumentFragment;

#define sipClass_QTextEdit_ExtraSelection             sipModuleAPI_QtGui.em_types[326]
#define sipCast_QTextEdit_ExtraSelection              sipType_QtGui_QTextEdit_ExtraSelection.td_cast
#define sipForceConvertTo_QTextEdit_ExtraSelection    sipType_QtGui_QTextEdit_ExtraSelection.td_fcto

extern sipTypeDef sipType_QtGui_QTextEdit_ExtraSelection;

#define sipClass_QTextEdit_AutoFormatting             sipModuleAPI_QtGui.em_types[325]
#define sipCast_QTextEdit_AutoFormatting              sipType_QtGui_QTextEdit_AutoFormatting.td_cast
#define sipForceConvertTo_QTextEdit_AutoFormatting    sipType_QtGui_QTextEdit_AutoFormatting.td_fcto

extern sipTypeDef sipType_QtGui_QTextEdit_AutoFormatting;

#define sipClass_QTextLength             sipModuleAPI_QtGui.em_types[42]
#define sipCast_QTextLength              sipType_QtGui_QTextLength.td_cast
#define sipForceConvertTo_QTextLength    sipType_QtGui_QTextLength.td_fcto

#define sipEnum_QTextLength_Type              sipModuleAPI_QtGui.em_enums[30]

extern sipTypeDef sipType_QtGui_QTextLength;

#define sipClass_QTextFormat             sipModuleAPI_QtGui.em_types[33]
#define sipCast_QTextFormat              sipType_QtGui_QTextFormat.td_cast
#define sipForceConvertTo_QTextFormat    sipType_QtGui_QTextFormat.td_fcto

#define sipEnum_QTextFormat_Property              sipModuleAPI_QtGui.em_enums[26]
#define sipEnum_QTextFormat_PageBreakFlag              sipModuleAPI_QtGui.em_enums[27]
#define sipEnum_QTextFormat_ObjectTypes              sipModuleAPI_QtGui.em_enums[28]
#define sipEnum_QTextFormat_FormatType              sipModuleAPI_QtGui.em_enums[29]

extern sipTypeDef sipType_QtGui_QTextFormat;

#define sipClass_QTextFormat_PageBreakFlags             sipModuleAPI_QtGui.em_types[34]
#define sipCast_QTextFormat_PageBreakFlags              sipType_QtGui_QTextFormat_PageBreakFlags.td_cast
#define sipForceConvertTo_QTextFormat_PageBreakFlags    sipType_QtGui_QTextFormat_PageBreakFlags.td_fcto

extern sipTypeDef sipType_QtGui_QTextFormat_PageBreakFlags;

#define sipClass_QTextCharFormat             sipModuleAPI_QtGui.em_types[39]
#define sipCast_QTextCharFormat              sipType_QtGui_QTextCharFormat.td_cast
#define sipForceConvertTo_QTextCharFormat    sipType_QtGui_QTextCharFormat.td_fcto

#define sipEnum_QTextCharFormat_UnderlineStyle              sipModuleAPI_QtGui.em_enums[24]
#define sipEnum_QTextCharFormat_VerticalAlignment              sipModuleAPI_QtGui.em_enums[25]

extern sipTypeDef sipType_QtGui_QTextCharFormat;

#define sipClass_QTextBlockFormat             sipModuleAPI_QtGui.em_types[38]
#define sipCast_QTextBlockFormat              sipType_QtGui_QTextBlockFormat.td_cast
#define sipForceConvertTo_QTextBlockFormat    sipType_QtGui_QTextBlockFormat.td_fcto

extern sipTypeDef sipType_QtGui_QTextBlockFormat;

#define sipClass_QTextListFormat             sipModuleAPI_QtGui.em_types[37]
#define sipCast_QTextListFormat              sipType_QtGui_QTextListFormat.td_cast
#define sipForceConvertTo_QTextListFormat    sipType_QtGui_QTextListFormat.td_fcto

#define sipEnum_QTextListFormat_Style              sipModuleAPI_QtGui.em_enums[23]

extern sipTypeDef sipType_QtGui_QTextListFormat;

#define sipClass_QTextImageFormat             sipModuleAPI_QtGui.em_types[41]
#define sipCast_QTextImageFormat              sipType_QtGui_QTextImageFormat.td_cast
#define sipForceConvertTo_QTextImageFormat    sipType_QtGui_QTextImageFormat.td_fcto

extern sipTypeDef sipType_QtGui_QTextImageFormat;

#define sipClass_QTextFrameFormat             sipModuleAPI_QtGui.em_types[35]
#define sipCast_QTextFrameFormat              sipType_QtGui_QTextFrameFormat.td_cast
#define sipForceConvertTo_QTextFrameFormat    sipType_QtGui_QTextFrameFormat.td_fcto

#define sipEnum_QTextFrameFormat_BorderStyle              sipModuleAPI_QtGui.em_enums[21]
#define sipEnum_QTextFrameFormat_Position              sipModuleAPI_QtGui.em_enums[22]

extern sipTypeDef sipType_QtGui_QTextFrameFormat;

#define sipClass_QTextTableFormat             sipModuleAPI_QtGui.em_types[36]
#define sipCast_QTextTableFormat              sipType_QtGui_QTextTableFormat.td_cast
#define sipForceConvertTo_QTextTableFormat    sipType_QtGui_QTextTableFormat.td_fcto

extern sipTypeDef sipType_QtGui_QTextTableFormat;

#define sipClass_QTextTableCellFormat             sipModuleAPI_QtGui.em_types[40]
#define sipCast_QTextTableCellFormat              sipType_QtGui_QTextTableCellFormat.td_cast
#define sipForceConvertTo_QTextTableCellFormat    sipType_QtGui_QTextTableCellFormat.td_fcto

extern sipTypeDef sipType_QtGui_QTextTableCellFormat;

#define sipClass_QTextInlineObject             sipModuleAPI_QtGui.em_types[32]
#define sipCast_QTextInlineObject              sipType_QtGui_QTextInlineObject.td_cast
#define sipForceConvertTo_QTextInlineObject    sipType_QtGui_QTextInlineObject.td_fcto

extern sipTypeDef sipType_QtGui_QTextInlineObject;

#define sipClass_QTextLayout             sipModuleAPI_QtGui.em_types[30]
#define sipCast_QTextLayout              sipType_QtGui_QTextLayout.td_cast
#define sipForceConvertTo_QTextLayout    sipType_QtGui_QTextLayout.td_fcto

#define sipEnum_QTextLayout_CursorMode              sipModuleAPI_QtGui.em_enums[20]

extern sipTypeDef sipType_QtGui_QTextLayout;

#define sipClass_QTextLayout_FormatRange             sipModuleAPI_QtGui.em_types[31]
#define sipCast_QTextLayout_FormatRange              sipType_QtGui_QTextLayout_FormatRange.td_cast
#define sipForceConvertTo_QTextLayout_FormatRange    sipType_QtGui_QTextLayout_FormatRange.td_fcto

extern sipTypeDef sipType_QtGui_QTextLayout_FormatRange;

#define sipClass_QTextLine             sipModuleAPI_QtGui.em_types[29]
#define sipCast_QTextLine              sipType_QtGui_QTextLine.td_cast
#define sipForceConvertTo_QTextLine    sipType_QtGui_QTextLine.td_fcto

#define sipEnum_QTextLine_CursorPosition              sipModuleAPI_QtGui.em_enums[18]
#define sipEnum_QTextLine_Edge              sipModuleAPI_QtGui.em_enums[19]

extern sipTypeDef sipType_QtGui_QTextLine;

#define sipClass_QTextObject             sipModuleAPI_QtGui.em_types[23]
#define sipCast_QTextObject              sipType_QtGui_QTextObject.td_cast
#define sipForceConvertTo_QTextObject    sipType_QtGui_QTextObject.td_fcto

extern sipTypeDef sipType_QtGui_QTextObject;

#define sipClass_QTextBlockGroup             sipModuleAPI_QtGui.em_types[27]
#define sipCast_QTextBlockGroup              sipType_QtGui_QTextBlockGroup.td_cast
#define sipForceConvertTo_QTextBlockGroup    sipType_QtGui_QTextBlockGroup.td_fcto

extern sipTypeDef sipType_QtGui_QTextBlockGroup;

#define sipClass_QTextList             sipModuleAPI_QtGui.em_types[28]
#define sipCast_QTextList              sipType_QtGui_QTextList.td_cast
#define sipForceConvertTo_QTextList    sipType_QtGui_QTextList.td_fcto

extern sipTypeDef sipType_QtGui_QTextList;

#define sipClass_QTextFrame             sipModuleAPI_QtGui.em_types[24]
#define sipCast_QTextFrame              sipType_QtGui_QTextFrame.td_cast
#define sipForceConvertTo_QTextFrame    sipType_QtGui_QTextFrame.td_fcto

extern sipTypeDef sipType_QtGui_QTextFrame;

#define sipClass_QTextFrame_iterator             sipModuleAPI_QtGui.em_types[25]
#define sipCast_QTextFrame_iterator              sipType_QtGui_QTextFrame_iterator.td_cast
#define sipForceConvertTo_QTextFrame_iterator    sipType_QtGui_QTextFrame_iterator.td_fcto

extern sipTypeDef sipType_QtGui_QTextFrame_iterator;

#define sipClass_QTextBlock             sipModuleAPI_QtGui.em_types[21]
#define sipCast_QTextBlock              sipType_QtGui_QTextBlock.td_cast
#define sipForceConvertTo_QTextBlock    sipType_QtGui_QTextBlock.td_fcto

extern sipTypeDef sipType_QtGui_QTextBlock;

#define sipClass_QTextBlock_iterator             sipModuleAPI_QtGui.em_types[22]
#define sipCast_QTextBlock_iterator              sipType_QtGui_QTextBlock_iterator.td_cast
#define sipForceConvertTo_QTextBlock_iterator    sipType_QtGui_QTextBlock_iterator.td_fcto

extern sipTypeDef sipType_QtGui_QTextBlock_iterator;

#define sipClass_QTextFragment             sipModuleAPI_QtGui.em_types[20]
#define sipCast_QTextFragment              sipType_QtGui_QTextFragment.td_cast
#define sipForceConvertTo_QTextFragment    sipType_QtGui_QTextFragment.td_fcto

extern sipTypeDef sipType_QtGui_QTextFragment;

#define sipClass_QTextBlockUserData             sipModuleAPI_QtGui.em_types[19]
#define sipCast_QTextBlockUserData              sipType_QtGui_QTextBlockUserData.td_cast
#define sipForceConvertTo_QTextBlockUserData    sipType_QtGui_QTextBlockUserData.td_fcto

extern sipTypeDef sipType_QtGui_QTextBlockUserData;

#define sipClass_QTextOption             sipModuleAPI_QtGui.em_types[16]
#define sipCast_QTextOption              sipType_QtGui_QTextOption.td_cast
#define sipForceConvertTo_QTextOption    sipType_QtGui_QTextOption.td_fcto

#define sipEnum_QTextOption_TabType              sipModuleAPI_QtGui.em_enums[15]
#define sipEnum_QTextOption_Flag              sipModuleAPI_QtGui.em_enums[16]
#define sipEnum_QTextOption_WrapMode              sipModuleAPI_QtGui.em_enums[17]

extern sipTypeDef sipType_QtGui_QTextOption;

#define sipClass_QTextOption_Flags             sipModuleAPI_QtGui.em_types[18]
#define sipCast_QTextOption_Flags              sipType_QtGui_QTextOption_Flags.td_cast
#define sipForceConvertTo_QTextOption_Flags    sipType_QtGui_QTextOption_Flags.td_fcto

extern sipTypeDef sipType_QtGui_QTextOption_Flags;

#define sipClass_QTextOption_Tab             sipModuleAPI_QtGui.em_types[17]
#define sipCast_QTextOption_Tab              sipType_QtGui_QTextOption_Tab.td_cast
#define sipForceConvertTo_QTextOption_Tab    sipType_QtGui_QTextOption_Tab.td_fcto

extern sipTypeDef sipType_QtGui_QTextOption_Tab;

#define sipClass_QTextTableCell             sipModuleAPI_QtGui.em_types[15]
#define sipCast_QTextTableCell              sipType_QtGui_QTextTableCell.td_cast
#define sipForceConvertTo_QTextTableCell    sipType_QtGui_QTextTableCell.td_fcto

extern sipTypeDef sipType_QtGui_QTextTableCell;

#define sipClass_QTextTable             sipModuleAPI_QtGui.em_types[26]
#define sipCast_QTextTable              sipType_QtGui_QTextTable.td_cast
#define sipForceConvertTo_QTextTable    sipType_QtGui_QTextTable.td_fcto

extern sipTypeDef sipType_QtGui_QTextTable;

#define sipClass_QToolBar             sipModuleAPI_QtGui.em_types[259]
#define sipCast_QToolBar              sipType_QtGui_QToolBar.td_cast
#define sipForceConvertTo_QToolBar    sipType_QtGui_QToolBar.td_fcto

extern sipTypeDef sipType_QtGui_QToolBar;

#define sipClass_QToolBox             sipModuleAPI_QtGui.em_types[318]
#define sipCast_QToolBox              sipType_QtGui_QToolBox.td_cast
#define sipForceConvertTo_QToolBox    sipType_QtGui_QToolBox.td_fcto

extern sipTypeDef sipType_QtGui_QToolBox;

#define sipClass_QToolButton             sipModuleAPI_QtGui.em_types[347]
#define sipCast_QToolButton              sipType_QtGui_QToolButton.td_cast
#define sipForceConvertTo_QToolButton    sipType_QtGui_QToolButton.td_fcto

#define sipEnum_QToolButton_ToolButtonPopupMode              sipModuleAPI_QtGui.em_enums[14]

extern sipTypeDef sipType_QtGui_QToolButton;

#define sipClass_QToolTip             sipModuleAPI_QtGui.em_types[14]
#define sipCast_QToolTip              sipType_QtGui_QToolTip.td_cast
#define sipForceConvertTo_QToolTip    sipType_QtGui_QToolTip.td_fcto

extern sipTypeDef sipType_QtGui_QToolTip;

#define sipClass_QTransform             sipModuleAPI_QtGui.em_types[13]
#define sipCast_QTransform              sipType_QtGui_QTransform.td_cast
#define sipForceConvertTo_QTransform    sipType_QtGui_QTransform.td_fcto

#define sipEnum_QTransform_TransformationType              sipModuleAPI_QtGui.em_enums[13]

extern sipTypeDef sipType_QtGui_QTransform;

#define sipClass_QTreeView             sipModuleAPI_QtGui.em_types[337]
#define sipCast_QTreeView              sipType_QtGui_QTreeView.td_cast
#define sipForceConvertTo_QTreeView    sipType_QtGui_QTreeView.td_fcto

extern sipTypeDef sipType_QtGui_QTreeView;

#define sipClass_QTreeWidgetItem             sipModuleAPI_QtGui.em_types[12]
#define sipCast_QTreeWidgetItem              sipType_QtGui_QTreeWidgetItem.td_cast
#define sipForceConvertTo_QTreeWidgetItem    sipType_QtGui_QTreeWidgetItem.td_fcto

#define sipEnum_QTreeWidgetItem_ChildIndicatorPolicy              sipModuleAPI_QtGui.em_enums[11]
#define sipEnum_QTreeWidgetItem_ItemType              sipModuleAPI_QtGui.em_enums[12]

extern sipTypeDef sipType_QtGui_QTreeWidgetItem;

#define sipClass_QTreeWidget             sipModuleAPI_QtGui.em_types[338]
#define sipCast_QTreeWidget              sipType_QtGui_QTreeWidget.td_cast
#define sipForceConvertTo_QTreeWidget    sipType_QtGui_QTreeWidget.td_fcto

extern sipTypeDef sipType_QtGui_QTreeWidget;

#define sipClass_QTreeWidgetItemIterator             sipModuleAPI_QtGui.em_types[10]
#define sipCast_QTreeWidgetItemIterator              sipType_QtGui_QTreeWidgetItemIterator.td_cast
#define sipForceConvertTo_QTreeWidgetItemIterator    sipType_QtGui_QTreeWidgetItemIterator.td_fcto

#define sipEnum_QTreeWidgetItemIterator_IteratorFlag              sipModuleAPI_QtGui.em_enums[10]

extern sipTypeDef sipType_QtGui_QTreeWidgetItemIterator;

#define sipClass_QTreeWidgetItemIterator_IteratorFlags             sipModuleAPI_QtGui.em_types[11]
#define sipCast_QTreeWidgetItemIterator_IteratorFlags              sipType_QtGui_QTreeWidgetItemIterator_IteratorFlags.td_cast
#define sipForceConvertTo_QTreeWidgetItemIterator_IteratorFlags    sipType_QtGui_QTreeWidgetItemIterator_IteratorFlags.td_fcto

extern sipTypeDef sipType_QtGui_QTreeWidgetItemIterator_IteratorFlags;

#define sipClass_QUndoGroup             sipModuleAPI_QtGui.em_types[9]
#define sipCast_QUndoGroup              sipType_QtGui_QUndoGroup.td_cast
#define sipForceConvertTo_QUndoGroup    sipType_QtGui_QUndoGroup.td_fcto

extern sipTypeDef sipType_QtGui_QUndoGroup;

#define sipClass_QUndoCommand             sipModuleAPI_QtGui.em_types[8]
#define sipCast_QUndoCommand              sipType_QtGui_QUndoCommand.td_cast
#define sipForceConvertTo_QUndoCommand    sipType_QtGui_QUndoCommand.td_fcto

extern sipTypeDef sipType_QtGui_QUndoCommand;

#define sipClass_QUndoStack             sipModuleAPI_QtGui.em_types[7]
#define sipCast_QUndoStack              sipType_QtGui_QUndoStack.td_cast
#define sipForceConvertTo_QUndoStack    sipType_QtGui_QUndoStack.td_fcto

extern sipTypeDef sipType_QtGui_QUndoStack;

#define sipClass_QUndoView             sipModuleAPI_QtGui.em_types[342]
#define sipCast_QUndoView              sipType_QtGui_QUndoView.td_cast
#define sipForceConvertTo_QUndoView    sipType_QtGui_QUndoView.td_fcto

extern sipTypeDef sipType_QtGui_QUndoView;

#define sipClass_QValidator             sipModuleAPI_QtGui.em_types[3]
#define sipCast_QValidator              sipType_QtGui_QValidator.td_cast
#define sipForceConvertTo_QValidator    sipType_QtGui_QValidator.td_fcto

#define sipEnum_QValidator_State              sipModuleAPI_QtGui.em_enums[9]

extern sipTypeDef sipType_QtGui_QValidator;

#define sipClass_QIntValidator             sipModuleAPI_QtGui.em_types[6]
#define sipCast_QIntValidator              sipType_QtGui_QIntValidator.td_cast
#define sipForceConvertTo_QIntValidator    sipType_QtGui_QIntValidator.td_fcto

extern sipTypeDef sipType_QtGui_QIntValidator;

#define sipClass_QDoubleValidator             sipModuleAPI_QtGui.em_types[5]
#define sipCast_QDoubleValidator              sipType_QtGui_QDoubleValidator.td_cast
#define sipForceConvertTo_QDoubleValidator    sipType_QtGui_QDoubleValidator.td_fcto

#define sipEnum_QDoubleValidator_Notation              sipModuleAPI_QtGui.em_enums[8]

extern sipTypeDef sipType_QtGui_QDoubleValidator;

#define sipClass_QRegExpValidator             sipModuleAPI_QtGui.em_types[4]
#define sipCast_QRegExpValidator              sipType_QtGui_QRegExpValidator.td_cast
#define sipForceConvertTo_QRegExpValidator    sipType_QtGui_QRegExpValidator.td_fcto

extern sipTypeDef sipType_QtGui_QRegExpValidator;

#define sipClass_QWhatsThis             sipModuleAPI_QtGui.em_types[2]
#define sipCast_QWhatsThis              sipType_QtGui_QWhatsThis.td_cast
#define sipForceConvertTo_QWhatsThis    sipType_QtGui_QWhatsThis.td_fcto

extern sipTypeDef sipType_QtGui_QWhatsThis;

#define sipClass_QWidget_RenderFlags             sipModuleAPI_QtGui.em_types[254]
#define sipCast_QWidget_RenderFlags              sipType_QtGui_QWidget_RenderFlags.td_cast
#define sipForceConvertTo_QWidget_RenderFlags    sipType_QtGui_QWidget_RenderFlags.td_fcto

extern sipTypeDef sipType_QtGui_QWidget_RenderFlags;

#define sipClass_QWidgetAction             sipModuleAPI_QtGui.em_types[237]
#define sipCast_QWidgetAction              sipType_QtGui_QWidgetAction.td_cast
#define sipForceConvertTo_QWidgetAction    sipType_QtGui_QWidgetAction.td_fcto

extern sipTypeDef sipType_QtGui_QWidgetAction;

#define sipClass_QWizard             sipModuleAPI_QtGui.em_types[300]
#define sipCast_QWizard              sipType_QtGui_QWizard.td_cast
#define sipForceConvertTo_QWizard    sipType_QtGui_QWizard.td_fcto

#define sipEnum_QWizard_WizardOption              sipModuleAPI_QtGui.em_enums[3]
#define sipEnum_QWizard_WizardStyle              sipModuleAPI_QtGui.em_enums[4]
#define sipEnum_QWizard_WizardPixmap              sipModuleAPI_QtGui.em_enums[5]
#define sipEnum_QWizard_WizardButton              sipModuleAPI_QtGui.em_enums[6]

extern sipTypeDef sipType_QtGui_QWizard;

#define sipClass_QWizard_WizardOptions             sipModuleAPI_QtGui.em_types[301]
#define sipCast_QWizard_WizardOptions              sipType_QtGui_QWizard_WizardOptions.td_cast
#define sipForceConvertTo_QWizard_WizardOptions    sipType_QtGui_QWizard_WizardOptions.td_fcto

extern sipTypeDef sipType_QtGui_QWizard_WizardOptions;

#define sipClass_QWizardPage             sipModuleAPI_QtGui.em_types[258]
#define sipCast_QWizardPage              sipType_QtGui_QWizardPage.td_cast
#define sipForceConvertTo_QWizardPage    sipType_QtGui_QWizardPage.td_fcto

extern sipTypeDef sipType_QtGui_QWizardPage;

#define sipClass_QWorkspace             sipModuleAPI_QtGui.em_types[257]
#define sipCast_QWorkspace              sipType_QtGui_QWorkspace.td_cast
#define sipForceConvertTo_QWorkspace    sipType_QtGui_QWorkspace.td_fcto

#define sipEnum_QWorkspace_WindowOrder              sipModuleAPI_QtGui.em_enums[2]

extern sipTypeDef sipType_QtGui_QWorkspace;

#define sipClass_QX11EmbedWidget             sipModuleAPI_QtGui.em_types[256]
#define sipCast_QX11EmbedWidget              sipType_QtGui_QX11EmbedWidget.td_cast
#define sipForceConvertTo_QX11EmbedWidget    sipType_QtGui_QX11EmbedWidget.td_fcto

#define sipEnum_QX11EmbedWidget_Error              sipModuleAPI_QtGui.em_enums[1]

extern sipTypeDef sipType_QtGui_QX11EmbedWidget;

#define sipClass_QX11EmbedContainer             sipModuleAPI_QtGui.em_types[255]
#define sipCast_QX11EmbedContainer              sipType_QtGui_QX11EmbedContainer.td_cast
#define sipForceConvertTo_QX11EmbedContainer    sipType_QtGui_QX11EmbedContainer.td_fcto

#define sipEnum_QX11EmbedContainer_Error              sipModuleAPI_QtGui.em_enums[0]

extern sipTypeDef sipType_QtGui_QX11EmbedContainer;

#define sipClass_Display             sipModuleAPI_QtGui.em_types[1]
#define sipCast_Display              sipType_QtGui_Display.td_cast
#define sipForceConvertTo_Display    sipType_QtGui_Display.td_fcto

extern sipTypeDef sipType_QtGui_Display;

#define sipClass_QX11Info             sipModuleAPI_QtGui.em_types[0]
#define sipCast_QX11Info              sipType_QtGui_QX11Info.td_cast
#define sipForceConvertTo_QX11Info    sipType_QtGui_QX11Info.td_fcto

extern sipTypeDef sipType_QtGui_QX11Info;

#define sipMappedType_QList_0201QUndoStack        &sipMappedTypeDef_QList_0201QUndoStack
#define sipForceConvertTo_QList_0201QUndoStack    sipMappedTypeDef_QList_0201QUndoStack.mt_fcto
#define sipConvertFrom_QList_0201QUndoStack       sipMappedTypeDef_QList_0201QUndoStack.mt_cfrom

extern sipMappedType sipMappedTypeDef_QList_0201QUndoStack;

#define sipMappedType_QList_0201QTreeWidgetItem        &sipMappedTypeDef_QList_0201QTreeWidgetItem
#define sipForceConvertTo_QList_0201QTreeWidgetItem    sipMappedTypeDef_QList_0201QTreeWidgetItem.mt_fcto
#define sipConvertFrom_QList_0201QTreeWidgetItem       sipMappedTypeDef_QList_0201QTreeWidgetItem.mt_cfrom

extern sipMappedType sipMappedTypeDef_QList_0201QTreeWidgetItem;

#define sipMappedType_QList_0201QTextFrame        &sipMappedTypeDef_QList_0201QTextFrame
#define sipForceConvertTo_QList_0201QTextFrame    sipMappedTypeDef_QList_0201QTextFrame.mt_fcto
#define sipConvertFrom_QList_0201QTextFrame       sipMappedTypeDef_QList_0201QTextFrame.mt_cfrom

extern sipMappedType sipMappedTypeDef_QList_0201QTextFrame;

#define sipMappedType_QList_0200QTextBlock        &sipMappedTypeDef_QList_0200QTextBlock
#define sipForceConvertTo_QList_0200QTextBlock    sipMappedTypeDef_QList_0200QTextBlock.mt_fcto
#define sipConvertFrom_QList_0200QTextBlock       sipMappedTypeDef_QList_0200QTextBlock.mt_cfrom

extern sipMappedType sipMappedTypeDef_QList_0200QTextBlock;

#define sipMappedType_QVector_0200QTextLayout_FormatRange        &sipMappedTypeDef_QVector_0200QTextLayout_FormatRange
#define sipForceConvertTo_QVector_0200QTextLayout_FormatRange    sipMappedTypeDef_QVector_0200QTextLayout_FormatRange.mt_fcto
#define sipConvertFrom_QVector_0200QTextLayout_FormatRange       sipMappedTypeDef_QVector_0200QTextLayout_FormatRange.mt_cfrom

extern sipMappedType sipMappedTypeDef_QVector_0200QTextLayout_FormatRange;

#define sipMappedType_QList_0200QTextLayout_FormatRange        &sipMappedTypeDef_QList_0200QTextLayout_FormatRange
#define sipForceConvertTo_QList_0200QTextLayout_FormatRange    sipMappedTypeDef_QList_0200QTextLayout_FormatRange.mt_fcto
#define sipConvertFrom_QList_0200QTextLayout_FormatRange       sipMappedTypeDef_QList_0200QTextLayout_FormatRange.mt_cfrom

extern sipMappedType sipMappedTypeDef_QList_0200QTextLayout_FormatRange;

#define sipMappedType_QList_0200QTextOption_Tab        &sipMappedTypeDef_QList_0200QTextOption_Tab
#define sipForceConvertTo_QList_0200QTextOption_Tab    sipMappedTypeDef_QList_0200QTextOption_Tab.mt_fcto
#define sipConvertFrom_QList_0200QTextOption_Tab       sipMappedTypeDef_QList_0200QTextOption_Tab.mt_cfrom

extern sipMappedType sipMappedTypeDef_QList_0200QTextOption_Tab;

#define sipMappedType_QVector_0200QTextLength        &sipMappedTypeDef_QVector_0200QTextLength
#define sipForceConvertTo_QVector_0200QTextLength    sipMappedTypeDef_QVector_0200QTextLength.mt_fcto
#define sipConvertFrom_QVector_0200QTextLength       sipMappedTypeDef_QVector_0200QTextLength.mt_cfrom

extern sipMappedType sipMappedTypeDef_QVector_0200QTextLength;

#define sipMappedType_QVector_0200QTextFormat        &sipMappedTypeDef_QVector_0200QTextFormat
#define sipForceConvertTo_QVector_0200QTextFormat    sipMappedTypeDef_QVector_0200QTextFormat.mt_fcto
#define sipConvertFrom_QVector_0200QTextFormat       sipMappedTypeDef_QVector_0200QTextFormat.mt_cfrom

extern sipMappedType sipMappedTypeDef_QVector_0200QTextFormat;

#define sipMappedType_QList_0201QTableWidgetItem        &sipMappedTypeDef_QList_0201QTableWidgetItem
#define sipForceConvertTo_QList_0201QTableWidgetItem    sipMappedTypeDef_QList_0201QTableWidgetItem.mt_fcto
#define sipConvertFrom_QList_0201QTableWidgetItem       sipMappedTypeDef_QList_0201QTableWidgetItem.mt_cfrom

extern sipMappedType sipMappedTypeDef_QList_0201QTableWidgetItem;

#define sipMappedType_QList_0200QTableWidgetSelectionRange        &sipMappedTypeDef_QList_0200QTableWidgetSelectionRange
#define sipForceConvertTo_QList_0200QTableWidgetSelectionRange    sipMappedTypeDef_QList_0200QTableWidgetSelectionRange.mt_fcto
#define sipConvertFrom_QList_0200QTableWidgetSelectionRange       sipMappedTypeDef_QList_0200QTableWidgetSelectionRange.mt_cfrom

extern sipMappedType sipMappedTypeDef_QList_0200QTableWidgetSelectionRange;

#define sipMappedType_QList_0201QStandardItem        &sipMappedTypeDef_QList_0201QStandardItem
#define sipForceConvertTo_QList_0201QStandardItem    sipMappedTypeDef_QList_0201QStandardItem.mt_fcto
#define sipConvertFrom_QList_0201QStandardItem       sipMappedTypeDef_QList_0201QStandardItem.mt_cfrom

extern sipMappedType sipMappedTypeDef_QList_0201QStandardItem;

#define sipMappedType_QList_0200QPrinterInfo        &sipMappedTypeDef_QList_0200QPrinterInfo
#define sipForceConvertTo_QList_0200QPrinterInfo    sipMappedTypeDef_QList_0200QPrinterInfo.mt_fcto
#define sipConvertFrom_QList_0200QPrinterInfo       sipMappedTypeDef_QList_0200QPrinterInfo.mt_cfrom

extern sipMappedType sipMappedTypeDef_QList_0200QPrinterInfo;

#define sipMappedType_QList_0200QTextEdit_ExtraSelection        &sipMappedTypeDef_QList_0200QTextEdit_ExtraSelection
#define sipForceConvertTo_QList_0200QTextEdit_ExtraSelection    sipMappedTypeDef_QList_0200QTextEdit_ExtraSelection.mt_fcto
#define sipConvertFrom_QList_0200QTextEdit_ExtraSelection       sipMappedTypeDef_QList_0200QTextEdit_ExtraSelection.mt_cfrom

extern sipMappedType sipMappedTypeDef_QList_0200QTextEdit_ExtraSelection;

#define sipMappedType_QList_0200QPolygonF        &sipMappedTypeDef_QList_0200QPolygonF
#define sipForceConvertTo_QList_0200QPolygonF    sipMappedTypeDef_QList_0200QPolygonF.mt_fcto
#define sipConvertFrom_QList_0200QPolygonF       sipMappedTypeDef_QList_0200QPolygonF.mt_cfrom

extern sipMappedType sipMappedTypeDef_QList_0200QPolygonF;

#define sipMappedType_QVector_0200QRect        &sipMappedTypeDef_QVector_0200QRect
#define sipForceConvertTo_QVector_0200QRect    sipMappedTypeDef_QVector_0200QRect.mt_fcto
#define sipConvertFrom_QVector_0200QRect       sipMappedTypeDef_QVector_0200QRect.mt_cfrom

extern sipMappedType sipMappedTypeDef_QVector_0200QRect;

#define sipMappedType_QVector_0200QRectF        &sipMappedTypeDef_QVector_0200QRectF
#define sipForceConvertTo_QVector_0200QRectF    sipMappedTypeDef_QVector_0200QRectF.mt_fcto
#define sipConvertFrom_QVector_0200QRectF       sipMappedTypeDef_QVector_0200QRectF.mt_cfrom

extern sipMappedType sipMappedTypeDef_QVector_0200QRectF;

#define sipMappedType_QVector_0200QPoint        &sipMappedTypeDef_QVector_0200QPoint
#define sipForceConvertTo_QVector_0200QPoint    sipMappedTypeDef_QVector_0200QPoint.mt_fcto
#define sipConvertFrom_QVector_0200QPoint       sipMappedTypeDef_QVector_0200QPoint.mt_cfrom

extern sipMappedType sipMappedTypeDef_QVector_0200QPoint;

#define sipMappedType_QVector_0200QLine        &sipMappedTypeDef_QVector_0200QLine
#define sipForceConvertTo_QVector_0200QLine    sipMappedTypeDef_QVector_0200QLine.mt_fcto
#define sipConvertFrom_QVector_0200QLine       sipMappedTypeDef_QVector_0200QLine.mt_cfrom

extern sipMappedType sipMappedTypeDef_QVector_0200QLine;

#define sipMappedType_QVector_0200QPointF        &sipMappedTypeDef_QVector_0200QPointF
#define sipForceConvertTo_QVector_0200QPointF    sipMappedTypeDef_QVector_0200QPointF.mt_fcto
#define sipConvertFrom_QVector_0200QPointF       sipMappedTypeDef_QVector_0200QPointF.mt_cfrom

extern sipMappedType sipMappedTypeDef_QVector_0200QPointF;

#define sipMappedType_QVector_0200QLineF        &sipMappedTypeDef_QVector_0200QLineF
#define sipForceConvertTo_QVector_0200QLineF    sipMappedTypeDef_QVector_0200QLineF.mt_fcto
#define sipConvertFrom_QVector_0200QLineF       sipMappedTypeDef_QVector_0200QLineF.mt_cfrom

extern sipMappedType sipMappedTypeDef_QVector_0200QLineF;

#define sipMappedType_QList_0201QMdiSubWindow        &sipMappedTypeDef_QList_0201QMdiSubWindow
#define sipForceConvertTo_QList_0201QMdiSubWindow    sipMappedTypeDef_QList_0201QMdiSubWindow.mt_fcto
#define sipConvertFrom_QList_0201QMdiSubWindow       sipMappedTypeDef_QList_0201QMdiSubWindow.mt_cfrom

extern sipMappedType sipMappedTypeDef_QList_0201QMdiSubWindow;

#define sipMappedType_QList_0201QListWidgetItem        &sipMappedTypeDef_QList_0201QListWidgetItem
#define sipForceConvertTo_QList_0201QListWidgetItem    sipMappedTypeDef_QList_0201QListWidgetItem.mt_fcto
#define sipConvertFrom_QList_0201QListWidgetItem       sipMappedTypeDef_QList_0201QListWidgetItem.mt_cfrom

extern sipMappedType sipMappedTypeDef_QList_0201QListWidgetItem;

#define sipMappedType_QList_0200QRectF        &sipMappedTypeDef_QList_0200QRectF
#define sipForceConvertTo_QList_0200QRectF    sipMappedTypeDef_QList_0200QRectF.mt_fcto
#define sipConvertFrom_QList_0200QRectF       sipMappedTypeDef_QList_0200QRectF.mt_cfrom

extern sipMappedType sipMappedTypeDef_QList_0200QRectF;

#define sipMappedType_QList_0201QGraphicsView        &sipMappedTypeDef_QList_0201QGraphicsView
#define sipForceConvertTo_QList_0201QGraphicsView    sipMappedTypeDef_QList_0201QGraphicsView.mt_fcto
#define sipConvertFrom_QList_0201QGraphicsView       sipMappedTypeDef_QList_0201QGraphicsView.mt_cfrom

extern sipMappedType sipMappedTypeDef_QList_0201QGraphicsView;

#define sipMappedType_QList_0600QPair_2400_0100QPointF        &sipMappedTypeDef_QList_0600QPair_2400_0100QPointF
#define sipForceConvertTo_QList_0600QPair_2400_0100QPointF    sipMappedTypeDef_QList_0600QPair_2400_0100QPointF.mt_fcto
#define sipConvertFrom_QList_0600QPair_2400_0100QPointF       sipMappedTypeDef_QList_0600QPair_2400_0100QPointF.mt_cfrom

extern sipMappedType sipMappedTypeDef_QList_0600QPair_2400_0100QPointF;

#define sipMappedType_QList_0201QGraphicsItem        &sipMappedTypeDef_QList_0201QGraphicsItem
#define sipForceConvertTo_QList_0201QGraphicsItem    sipMappedTypeDef_QList_0201QGraphicsItem.mt_fcto
#define sipConvertFrom_QList_0201QGraphicsItem       sipMappedTypeDef_QList_0201QGraphicsItem.mt_cfrom

extern sipMappedType sipMappedTypeDef_QList_0201QGraphicsItem;

#define sipMappedType_QList_0200QInputMethodEvent_Attribute        &sipMappedTypeDef_QList_0200QInputMethodEvent_Attribute
#define sipForceConvertTo_QList_0200QInputMethodEvent_Attribute    sipMappedTypeDef_QList_0200QInputMethodEvent_Attribute.mt_fcto
#define sipConvertFrom_QList_0200QInputMethodEvent_Attribute       sipMappedTypeDef_QList_0200QInputMethodEvent_Attribute.mt_cfrom

extern sipMappedType sipMappedTypeDef_QList_0200QInputMethodEvent_Attribute;

#define sipMappedType_QMap_0200QDate_0200QTextCharFormat        &sipMappedTypeDef_QMap_0200QDate_0200QTextCharFormat
#define sipForceConvertTo_QMap_0200QDate_0200QTextCharFormat    sipMappedTypeDef_QMap_0200QDate_0200QTextCharFormat.mt_fcto
#define sipConvertFrom_QMap_0200QDate_0200QTextCharFormat       sipMappedTypeDef_QMap_0200QDate_0200QTextCharFormat.mt_cfrom

extern sipMappedType sipMappedTypeDef_QMap_0200QDate_0200QTextCharFormat;

#define sipMappedType_QList_0201QAbstractButton        &sipMappedTypeDef_QList_0201QAbstractButton
#define sipForceConvertTo_QList_0201QAbstractButton    sipMappedTypeDef_QList_0201QAbstractButton.mt_fcto
#define sipConvertFrom_QList_0201QAbstractButton       sipMappedTypeDef_QList_0201QAbstractButton.mt_cfrom

extern sipMappedType sipMappedTypeDef_QList_0201QAbstractButton;

#define sipMappedType_QList_0200QKeySequence        &sipMappedTypeDef_QList_0200QKeySequence
#define sipForceConvertTo_QList_0200QKeySequence    sipMappedTypeDef_QList_0200QKeySequence.mt_fcto
#define sipConvertFrom_QList_0200QKeySequence       sipMappedTypeDef_QList_0200QKeySequence.mt_cfrom

extern sipMappedType sipMappedTypeDef_QList_0200QKeySequence;

#define sipMappedType_QList_0201QAction        &sipMappedTypeDef_QList_0201QAction
#define sipForceConvertTo_QList_0201QAction    sipMappedTypeDef_QList_0201QAction.mt_fcto
#define sipConvertFrom_QList_0201QAction       sipMappedTypeDef_QList_0201QAction.mt_cfrom

extern sipMappedType sipMappedTypeDef_QList_0201QAction;

#define sipMappedType_QVector_0200QAbstractTextDocumentLayout_Selection        &sipMappedTypeDef_QVector_0200QAbstractTextDocumentLayout_Selection
#define sipForceConvertTo_QVector_0200QAbstractTextDocumentLayout_Selection    sipMappedTypeDef_QVector_0200QAbstractTextDocumentLayout_Selection.mt_fcto
#define sipConvertFrom_QVector_0200QAbstractTextDocumentLayout_Selection       sipMappedTypeDef_QVector_0200QAbstractTextDocumentLayout_Selection.mt_cfrom

extern sipMappedType sipMappedTypeDef_QVector_0200QAbstractTextDocumentLayout_Selection;

#define sipMappedType_QVector_0600QPair_2400_0100QColor        &sipMappedTypeDef_QVector_0600QPair_2400_0100QColor
#define sipForceConvertTo_QVector_0600QPair_2400_0100QColor    sipMappedTypeDef_QVector_0600QPair_2400_0100QColor.mt_fcto
#define sipConvertFrom_QVector_0600QPair_2400_0100QColor       sipMappedTypeDef_QVector_0600QPair_2400_0100QColor.mt_cfrom

extern sipMappedType sipMappedTypeDef_QVector_0600QPair_2400_0100QColor;

#define sipMappedType_QList_0201QWidget        &sipMappedTypeDef_QList_0201QWidget
#define sipForceConvertTo_QList_0201QWidget    sipMappedTypeDef_QList_0201QWidget.mt_fcto
#define sipConvertFrom_QList_0201QWidget       sipMappedTypeDef_QList_0201QWidget.mt_cfrom

extern sipMappedType sipMappedTypeDef_QList_0201QWidget;

#define sipMappedType_QList_0500QWizard_WizardButton        &sipMappedTypeDef_QList_0500QWizard_WizardButton
#define sipForceConvertTo_QList_0500QWizard_WizardButton    sipMappedTypeDef_QList_0500QWizard_WizardButton.mt_fcto
#define sipConvertFrom_QList_0500QWizard_WizardButton       sipMappedTypeDef_QList_0500QWizard_WizardButton.mt_cfrom

extern sipMappedType sipMappedTypeDef_QList_0500QWizard_WizardButton;

#define sipMappedType_QList_0500QPrinter_PageSize        &sipMappedTypeDef_QList_0500QPrinter_PageSize
#define sipForceConvertTo_QList_0500QPrinter_PageSize    sipMappedTypeDef_QList_0500QPrinter_PageSize.mt_fcto
#define sipConvertFrom_QList_0500QPrinter_PageSize       sipMappedTypeDef_QList_0500QPrinter_PageSize.mt_cfrom

extern sipMappedType sipMappedTypeDef_QList_0500QPrinter_PageSize;

#define sipMappedType_QList_0500QFontDatabase_WritingSystem        &sipMappedTypeDef_QList_0500QFontDatabase_WritingSystem
#define sipForceConvertTo_QList_0500QFontDatabase_WritingSystem    sipMappedTypeDef_QList_0500QFontDatabase_WritingSystem.mt_fcto
#define sipConvertFrom_QList_0500QFontDatabase_WritingSystem       sipMappedTypeDef_QList_0500QFontDatabase_WritingSystem.mt_cfrom

extern sipMappedType sipMappedTypeDef_QList_0500QFontDatabase_WritingSystem;

#define sipMappedType_XEvent        &sipMappedTypeDef_XEvent
#define sipForceConvertTo_XEvent    sipMappedTypeDef_XEvent.mt_fcto
#define sipConvertFrom_XEvent       sipMappedTypeDef_XEvent.mt_cfrom

extern sipMappedType sipMappedTypeDef_XEvent;

/* The SIP API, this module's API and the APIs of any imported modules. */
extern const sipAPIDef *sipAPI_QtGui;
extern sipExportedModuleDef sipModuleAPI_QtGui;

#define sipClass_QSysInfo             sipModuleAPI_QtGui_QtCore->em_types[150]
#define sipCast_QSysInfo              sipModuleAPI_QtGui_QtCore->em_types[150]->type->td_cast
#define sipForceConvertTo_QSysInfo    sipModuleAPI_QtGui_QtCore->em_types[150]->type->td_fcto

#define sipEnum_QSysInfo_Endian              sipModuleAPI_QtGui_QtCore->em_enums[135]
#define sipEnum_QSysInfo_Sizes              sipModuleAPI_QtGui_QtCore->em_enums[136]

#if !defined(sipClass_Qt)
#define sipClass_Qt             sipModuleAPI_QtGui_QtCore->em_types[136]
#endif

#define sipEnum_Qt_WindowFrameSection              sipModuleAPI_QtGui_QtCore->em_enums[75]
#define sipEnum_Qt_SizeHint              sipModuleAPI_QtGui_QtCore->em_enums[76]
#define sipEnum_Qt_SizeMode              sipModuleAPI_QtGui_QtCore->em_enums[77]
#define sipEnum_Qt_EventPriority              sipModuleAPI_QtGui_QtCore->em_enums[78]
#define sipEnum_Qt_Axis              sipModuleAPI_QtGui_QtCore->em_enums[79]
#define sipEnum_Qt_MaskMode              sipModuleAPI_QtGui_QtCore->em_enums[80]
#define sipEnum_Qt_TextInteractionFlag              sipModuleAPI_QtGui_QtCore->em_enums[81]
#define sipEnum_Qt_ItemSelectionMode              sipModuleAPI_QtGui_QtCore->em_enums[82]
#define sipEnum_Qt_ApplicationAttribute              sipModuleAPI_QtGui_QtCore->em_enums[83]
#define sipEnum_Qt_WindowModality              sipModuleAPI_QtGui_QtCore->em_enums[84]
#define sipEnum_Qt_MatchFlag              sipModuleAPI_QtGui_QtCore->em_enums[85]
#define sipEnum_Qt_ItemFlag              sipModuleAPI_QtGui_QtCore->em_enums[86]
#define sipEnum_Qt_ItemDataRole              sipModuleAPI_QtGui_QtCore->em_enums[87]
#define sipEnum_Qt_CheckState              sipModuleAPI_QtGui_QtCore->em_enums[88]
#define sipEnum_Qt_DropAction              sipModuleAPI_QtGui_QtCore->em_enums[89]
#define sipEnum_Qt_LayoutDirection              sipModuleAPI_QtGui_QtCore->em_enums[90]
#define sipEnum_Qt_ToolButtonStyle              sipModuleAPI_QtGui_QtCore->em_enums[91]
#define sipEnum_Qt_InputMethodQuery              sipModuleAPI_QtGui_QtCore->em_enums[92]
#define sipEnum_Qt_ContextMenuPolicy              sipModuleAPI_QtGui_QtCore->em_enums[93]
#define sipEnum_Qt_FocusReason              sipModuleAPI_QtGui_QtCore->em_enums[94]
#define sipEnum_Qt_TransformationMode              sipModuleAPI_QtGui_QtCore->em_enums[95]
#define sipEnum_Qt_ClipOperation              sipModuleAPI_QtGui_QtCore->em_enums[96]
#define sipEnum_Qt_FillRule              sipModuleAPI_QtGui_QtCore->em_enums[97]
#define sipEnum_Qt_ShortcutContext              sipModuleAPI_QtGui_QtCore->em_enums[98]
#define sipEnum_Qt_ConnectionType              sipModuleAPI_QtGui_QtCore->em_enums[99]
#define sipEnum_Qt_Corner              sipModuleAPI_QtGui_QtCore->em_enums[100]
#define sipEnum_Qt_CaseSensitivity              sipModuleAPI_QtGui_QtCore->em_enums[101]
#define sipEnum_Qt_ScrollBarPolicy              sipModuleAPI_QtGui_QtCore->em_enums[102]
#define sipEnum_Qt_DayOfWeek              sipModuleAPI_QtGui_QtCore->em_enums[103]
#define sipEnum_Qt_TimeSpec              sipModuleAPI_QtGui_QtCore->em_enums[104]
#define sipEnum_Qt_DateFormat              sipModuleAPI_QtGui_QtCore->em_enums[105]
#define sipEnum_Qt_ToolBarArea              sipModuleAPI_QtGui_QtCore->em_enums[106]
#define sipEnum_Qt_DockWidgetArea              sipModuleAPI_QtGui_QtCore->em_enums[107]
#define sipEnum_Qt_AnchorAttribute              sipModuleAPI_QtGui_QtCore->em_enums[108]
#define sipEnum_Qt_AspectRatioMode              sipModuleAPI_QtGui_QtCore->em_enums[109]
#define sipEnum_Qt_TextFormat              sipModuleAPI_QtGui_QtCore->em_enums[110]
#define sipEnum_Qt_CursorShape              sipModuleAPI_QtGui_QtCore->em_enums[111]
#define sipEnum_Qt_UIEffect              sipModuleAPI_QtGui_QtCore->em_enums[112]
#define sipEnum_Qt_BrushStyle              sipModuleAPI_QtGui_QtCore->em_enums[113]
#define sipEnum_Qt_PenJoinStyle              sipModuleAPI_QtGui_QtCore->em_enums[114]
#define sipEnum_Qt_PenCapStyle              sipModuleAPI_QtGui_QtCore->em_enums[115]
#define sipEnum_Qt_PenStyle              sipModuleAPI_QtGui_QtCore->em_enums[116]
#define sipEnum_Qt_ArrowType              sipModuleAPI_QtGui_QtCore->em_enums[117]
#define sipEnum_Qt_Key              sipModuleAPI_QtGui_QtCore->em_enums[118]
#define sipEnum_Qt_BGMode              sipModuleAPI_QtGui_QtCore->em_enums[119]
#define sipEnum_Qt_ImageConversionFlag              sipModuleAPI_QtGui_QtCore->em_enums[120]
#define sipEnum_Qt_WidgetAttribute              sipModuleAPI_QtGui_QtCore->em_enums[121]
#define sipEnum_Qt_WindowState              sipModuleAPI_QtGui_QtCore->em_enums[122]
#define sipEnum_Qt_WindowType              sipModuleAPI_QtGui_QtCore->em_enums[123]
#define sipEnum_Qt_TextElideMode              sipModuleAPI_QtGui_QtCore->em_enums[124]
#define sipEnum_Qt_TextFlag              sipModuleAPI_QtGui_QtCore->em_enums[125]
#define sipEnum_Qt_AlignmentFlag              sipModuleAPI_QtGui_QtCore->em_enums[126]
#define sipEnum_Qt_SortOrder              sipModuleAPI_QtGui_QtCore->em_enums[127]
#define sipEnum_Qt_FocusPolicy              sipModuleAPI_QtGui_QtCore->em_enums[128]
#define sipEnum_Qt_Orientation              sipModuleAPI_QtGui_QtCore->em_enums[129]
#define sipEnum_Qt_MouseButton              sipModuleAPI_QtGui_QtCore->em_enums[130]
#define sipEnum_Qt_Modifier              sipModuleAPI_QtGui_QtCore->em_enums[131]
#define sipEnum_Qt_KeyboardModifier              sipModuleAPI_QtGui_QtCore->em_enums[132]
#define sipEnum_Qt_GlobalColor              sipModuleAPI_QtGui_QtCore->em_enums[133]

#define sipClass_Qt_KeyboardModifiers             sipModuleAPI_QtGui_QtCore->em_types[149]
#define sipCast_Qt_KeyboardModifiers              sipModuleAPI_QtGui_QtCore->em_types[149]->type->td_cast
#define sipForceConvertTo_Qt_KeyboardModifiers    sipModuleAPI_QtGui_QtCore->em_types[149]->type->td_fcto

#define sipClass_Qt_MouseButtons             sipModuleAPI_QtGui_QtCore->em_types[148]
#define sipCast_Qt_MouseButtons              sipModuleAPI_QtGui_QtCore->em_types[148]->type->td_cast
#define sipForceConvertTo_Qt_MouseButtons    sipModuleAPI_QtGui_QtCore->em_types[148]->type->td_fcto

#define sipClass_Qt_Orientations             sipModuleAPI_QtGui_QtCore->em_types[147]
#define sipCast_Qt_Orientations              sipModuleAPI_QtGui_QtCore->em_types[147]->type->td_cast
#define sipForceConvertTo_Qt_Orientations    sipModuleAPI_QtGui_QtCore->em_types[147]->type->td_fcto

#define sipClass_Qt_Alignment             sipModuleAPI_QtGui_QtCore->em_types[146]
#define sipCast_Qt_Alignment              sipModuleAPI_QtGui_QtCore->em_types[146]->type->td_cast
#define sipForceConvertTo_Qt_Alignment    sipModuleAPI_QtGui_QtCore->em_types[146]->type->td_fcto

#define sipClass_Qt_WindowFlags             sipModuleAPI_QtGui_QtCore->em_types[145]
#define sipCast_Qt_WindowFlags              sipModuleAPI_QtGui_QtCore->em_types[145]->type->td_cast
#define sipForceConvertTo_Qt_WindowFlags    sipModuleAPI_QtGui_QtCore->em_types[145]->type->td_fcto

#define sipClass_Qt_WindowStates             sipModuleAPI_QtGui_QtCore->em_types[144]
#define sipCast_Qt_WindowStates              sipModuleAPI_QtGui_QtCore->em_types[144]->type->td_cast
#define sipForceConvertTo_Qt_WindowStates    sipModuleAPI_QtGui_QtCore->em_types[144]->type->td_fcto

#define sipClass_Qt_ImageConversionFlags             sipModuleAPI_QtGui_QtCore->em_types[143]
#define sipCast_Qt_ImageConversionFlags              sipModuleAPI_QtGui_QtCore->em_types[143]->type->td_cast
#define sipForceConvertTo_Qt_ImageConversionFlags    sipModuleAPI_QtGui_QtCore->em_types[143]->type->td_fcto

#define sipClass_Qt_DockWidgetAreas             sipModuleAPI_QtGui_QtCore->em_types[142]
#define sipCast_Qt_DockWidgetAreas              sipModuleAPI_QtGui_QtCore->em_types[142]->type->td_cast
#define sipForceConvertTo_Qt_DockWidgetAreas    sipModuleAPI_QtGui_QtCore->em_types[142]->type->td_fcto

#define sipClass_Qt_ToolBarAreas             sipModuleAPI_QtGui_QtCore->em_types[141]
#define sipCast_Qt_ToolBarAreas              sipModuleAPI_QtGui_QtCore->em_types[141]->type->td_cast
#define sipForceConvertTo_Qt_ToolBarAreas    sipModuleAPI_QtGui_QtCore->em_types[141]->type->td_fcto

#define sipClass_Qt_DropActions             sipModuleAPI_QtGui_QtCore->em_types[140]
#define sipCast_Qt_DropActions              sipModuleAPI_QtGui_QtCore->em_types[140]->type->td_cast
#define sipForceConvertTo_Qt_DropActions    sipModuleAPI_QtGui_QtCore->em_types[140]->type->td_fcto

#define sipClass_Qt_ItemFlags             sipModuleAPI_QtGui_QtCore->em_types[139]
#define sipCast_Qt_ItemFlags              sipModuleAPI_QtGui_QtCore->em_types[139]->type->td_cast
#define sipForceConvertTo_Qt_ItemFlags    sipModuleAPI_QtGui_QtCore->em_types[139]->type->td_fcto

#define sipClass_Qt_MatchFlags             sipModuleAPI_QtGui_QtCore->em_types[138]
#define sipCast_Qt_MatchFlags              sipModuleAPI_QtGui_QtCore->em_types[138]->type->td_cast
#define sipForceConvertTo_Qt_MatchFlags    sipModuleAPI_QtGui_QtCore->em_types[138]->type->td_fcto

#define sipClass_Qt_TextInteractionFlags             sipModuleAPI_QtGui_QtCore->em_types[137]
#define sipCast_Qt_TextInteractionFlags              sipModuleAPI_QtGui_QtCore->em_types[137]->type->td_cast
#define sipForceConvertTo_Qt_TextInteractionFlags    sipModuleAPI_QtGui_QtCore->em_types[137]->type->td_fcto

#define sipClass_QObject             sipModuleAPI_QtGui_QtCore->em_types[106]
#define sipCast_QObject              sipModuleAPI_QtGui_QtCore->em_types[106]->type->td_cast
#define sipForceConvertTo_QObject    sipModuleAPI_QtGui_QtCore->em_types[106]->type->td_fcto

#define sipClass_QAbstractEventDispatcher             sipModuleAPI_QtGui_QtCore->em_types[135]
#define sipCast_QAbstractEventDispatcher              sipModuleAPI_QtGui_QtCore->em_types[135]->type->td_cast
#define sipForceConvertTo_QAbstractEventDispatcher    sipModuleAPI_QtGui_QtCore->em_types[135]->type->td_fcto

#define sipClass_QAbstractFileEngine             sipModuleAPI_QtGui_QtCore->em_types[103]
#define sipCast_QAbstractFileEngine              sipModuleAPI_QtGui_QtCore->em_types[103]->type->td_cast
#define sipForceConvertTo_QAbstractFileEngine    sipModuleAPI_QtGui_QtCore->em_types[103]->type->td_fcto

#define sipEnum_QAbstractFileEngine_FileTime              sipModuleAPI_QtGui_QtCore->em_enums[71]
#define sipEnum_QAbstractFileEngine_FileOwner              sipModuleAPI_QtGui_QtCore->em_enums[72]
#define sipEnum_QAbstractFileEngine_FileName              sipModuleAPI_QtGui_QtCore->em_enums[73]
#define sipEnum_QAbstractFileEngine_FileFlag              sipModuleAPI_QtGui_QtCore->em_enums[74]

#define sipClass_QAbstractFileEngine_FileFlags             sipModuleAPI_QtGui_QtCore->em_types[104]
#define sipCast_QAbstractFileEngine_FileFlags              sipModuleAPI_QtGui_QtCore->em_types[104]->type->td_cast
#define sipForceConvertTo_QAbstractFileEngine_FileFlags    sipModuleAPI_QtGui_QtCore->em_types[104]->type->td_fcto

#define sipClass_QAbstractFileEngineHandler             sipModuleAPI_QtGui_QtCore->em_types[102]
#define sipCast_QAbstractFileEngineHandler              sipModuleAPI_QtGui_QtCore->em_types[102]->type->td_cast
#define sipForceConvertTo_QAbstractFileEngineHandler    sipModuleAPI_QtGui_QtCore->em_types[102]->type->td_fcto

#define sipClass_QAbstractFileEngineIterator             sipModuleAPI_QtGui_QtCore->em_types[101]
#define sipCast_QAbstractFileEngineIterator              sipModuleAPI_QtGui_QtCore->em_types[101]->type->td_cast
#define sipForceConvertTo_QAbstractFileEngineIterator    sipModuleAPI_QtGui_QtCore->em_types[101]->type->td_fcto

#define sipClass_QModelIndex             sipModuleAPI_QtGui_QtCore->em_types[100]
#define sipCast_QModelIndex              sipModuleAPI_QtGui_QtCore->em_types[100]->type->td_cast
#define sipForceConvertTo_QModelIndex    sipModuleAPI_QtGui_QtCore->em_types[100]->type->td_fcto

#define sipClass_QPersistentModelIndex             sipModuleAPI_QtGui_QtCore->em_types[99]
#define sipCast_QPersistentModelIndex              sipModuleAPI_QtGui_QtCore->em_types[99]->type->td_cast
#define sipForceConvertTo_QPersistentModelIndex    sipModuleAPI_QtGui_QtCore->em_types[99]->type->td_fcto

#define sipClass_QAbstractItemModel             sipModuleAPI_QtGui_QtCore->em_types[132]
#define sipCast_QAbstractItemModel              sipModuleAPI_QtGui_QtCore->em_types[132]->type->td_cast
#define sipForceConvertTo_QAbstractItemModel    sipModuleAPI_QtGui_QtCore->em_types[132]->type->td_fcto

#define sipClass_QAbstractTableModel             sipModuleAPI_QtGui_QtCore->em_types[134]
#define sipCast_QAbstractTableModel              sipModuleAPI_QtGui_QtCore->em_types[134]->type->td_cast
#define sipForceConvertTo_QAbstractTableModel    sipModuleAPI_QtGui_QtCore->em_types[134]->type->td_fcto

#define sipClass_QAbstractListModel             sipModuleAPI_QtGui_QtCore->em_types[133]
#define sipCast_QAbstractListModel              sipModuleAPI_QtGui_QtCore->em_types[133]->type->td_cast
#define sipForceConvertTo_QAbstractListModel    sipModuleAPI_QtGui_QtCore->em_types[133]->type->td_fcto

#define sipClass_QBasicTimer             sipModuleAPI_QtGui_QtCore->em_types[98]
#define sipCast_QBasicTimer              sipModuleAPI_QtGui_QtCore->em_types[98]->type->td_cast
#define sipForceConvertTo_QBasicTimer    sipModuleAPI_QtGui_QtCore->em_types[98]->type->td_fcto

#define sipClass_QBitArray             sipModuleAPI_QtGui_QtCore->em_types[97]
#define sipCast_QBitArray              sipModuleAPI_QtGui_QtCore->em_types[97]->type->td_cast
#define sipForceConvertTo_QBitArray    sipModuleAPI_QtGui_QtCore->em_types[97]->type->td_fcto

#define sipClass_QIODevice             sipModuleAPI_QtGui_QtCore->em_types[125]
#define sipCast_QIODevice              sipModuleAPI_QtGui_QtCore->em_types[125]->type->td_cast
#define sipForceConvertTo_QIODevice    sipModuleAPI_QtGui_QtCore->em_types[125]->type->td_fcto

#define sipEnum_QIODevice_OpenModeFlag              sipModuleAPI_QtGui_QtCore->em_enums[50]

#define sipClass_QBuffer             sipModuleAPI_QtGui_QtCore->em_types[131]
#define sipCast_QBuffer              sipModuleAPI_QtGui_QtCore->em_types[131]->type->td_cast
#define sipForceConvertTo_QBuffer    sipModuleAPI_QtGui_QtCore->em_types[131]->type->td_fcto

#define sipClass_QByteArray             sipModuleAPI_QtGui_QtCore->em_types[96]
#define sipCast_QByteArray              sipModuleAPI_QtGui_QtCore->em_types[96]->type->td_cast
#define sipForceConvertTo_QByteArray    sipModuleAPI_QtGui_QtCore->em_types[96]->type->td_fcto

#define sipClass_QByteArrayMatcher             sipModuleAPI_QtGui_QtCore->em_types[95]
#define sipCast_QByteArrayMatcher              sipModuleAPI_QtGui_QtCore->em_types[95]->type->td_cast
#define sipForceConvertTo_QByteArrayMatcher    sipModuleAPI_QtGui_QtCore->em_types[95]->type->td_fcto

#define sipClass_QLatin1Char             sipModuleAPI_QtGui_QtCore->em_types[94]
#define sipCast_QLatin1Char              sipModuleAPI_QtGui_QtCore->em_types[94]->type->td_cast
#define sipForceConvertTo_QLatin1Char    sipModuleAPI_QtGui_QtCore->em_types[94]->type->td_fcto

#define sipClass_QChar             sipModuleAPI_QtGui_QtCore->em_types[93]
#define sipCast_QChar              sipModuleAPI_QtGui_QtCore->em_types[93]->type->td_cast
#define sipForceConvertTo_QChar    sipModuleAPI_QtGui_QtCore->em_types[93]->type->td_fcto

#define sipEnum_QChar_UnicodeVersion              sipModuleAPI_QtGui_QtCore->em_enums[64]
#define sipEnum_QChar_CombiningClass              sipModuleAPI_QtGui_QtCore->em_enums[65]
#define sipEnum_QChar_Joining              sipModuleAPI_QtGui_QtCore->em_enums[66]
#define sipEnum_QChar_Decomposition              sipModuleAPI_QtGui_QtCore->em_enums[67]
#define sipEnum_QChar_Direction              sipModuleAPI_QtGui_QtCore->em_enums[68]
#define sipEnum_QChar_Category              sipModuleAPI_QtGui_QtCore->em_enums[69]
#define sipEnum_QChar_SpecialCharacter              sipModuleAPI_QtGui_QtCore->em_enums[70]

#define sipClass_QCoreApplication             sipModuleAPI_QtGui_QtCore->em_types[124]
#define sipCast_QCoreApplication              sipModuleAPI_QtGui_QtCore->em_types[124]->type->td_cast
#define sipForceConvertTo_QCoreApplication    sipModuleAPI_QtGui_QtCore->em_types[124]->type->td_fcto

#define sipEnum_QCoreApplication_Encoding              sipModuleAPI_QtGui_QtCore->em_enums[63]

#define sipClass_QEvent             sipModuleAPI_QtGui_QtCore->em_types[89]
#define sipCast_QEvent              sipModuleAPI_QtGui_QtCore->em_types[89]->type->td_cast
#define sipForceConvertTo_QEvent    sipModuleAPI_QtGui_QtCore->em_types[89]->type->td_fcto

#define sipEnum_QEvent_Type              sipModuleAPI_QtGui_QtCore->em_enums[62]

#define sipClass_QTimerEvent             sipModuleAPI_QtGui_QtCore->em_types[92]
#define sipCast_QTimerEvent              sipModuleAPI_QtGui_QtCore->em_types[92]->type->td_cast
#define sipForceConvertTo_QTimerEvent    sipModuleAPI_QtGui_QtCore->em_types[92]->type->td_fcto

#define sipClass_QChildEvent             sipModuleAPI_QtGui_QtCore->em_types[91]
#define sipCast_QChildEvent              sipModuleAPI_QtGui_QtCore->em_types[91]->type->td_cast
#define sipForceConvertTo_QChildEvent    sipModuleAPI_QtGui_QtCore->em_types[91]->type->td_fcto

#define sipClass_QDynamicPropertyChangeEvent             sipModuleAPI_QtGui_QtCore->em_types[90]
#define sipCast_QDynamicPropertyChangeEvent              sipModuleAPI_QtGui_QtCore->em_types[90]->type->td_cast
#define sipForceConvertTo_QDynamicPropertyChangeEvent    sipModuleAPI_QtGui_QtCore->em_types[90]->type->td_fcto

#define sipClass_QCryptographicHash             sipModuleAPI_QtGui_QtCore->em_types[88]
#define sipCast_QCryptographicHash              sipModuleAPI_QtGui_QtCore->em_types[88]->type->td_cast
#define sipForceConvertTo_QCryptographicHash    sipModuleAPI_QtGui_QtCore->em_types[88]->type->td_fcto

#define sipEnum_QCryptographicHash_Algorithm              sipModuleAPI_QtGui_QtCore->em_enums[61]

#define sipClass_QDataStream             sipModuleAPI_QtGui_QtCore->em_types[87]
#define sipCast_QDataStream              sipModuleAPI_QtGui_QtCore->em_types[87]->type->td_cast
#define sipForceConvertTo_QDataStream    sipModuleAPI_QtGui_QtCore->em_types[87]->type->td_fcto

#define sipEnum_QDataStream_Status              sipModuleAPI_QtGui_QtCore->em_enums[58]
#define sipEnum_QDataStream_ByteOrder              sipModuleAPI_QtGui_QtCore->em_enums[59]
#define sipEnum_QDataStream_Version              sipModuleAPI_QtGui_QtCore->em_enums[60]

#define sipClass_QDate             sipModuleAPI_QtGui_QtCore->em_types[86]
#define sipCast_QDate              sipModuleAPI_QtGui_QtCore->em_types[86]->type->td_cast
#define sipForceConvertTo_QDate    sipModuleAPI_QtGui_QtCore->em_types[86]->type->td_fcto

#define sipClass_QTime             sipModuleAPI_QtGui_QtCore->em_types[85]
#define sipCast_QTime              sipModuleAPI_QtGui_QtCore->em_types[85]->type->td_cast
#define sipForceConvertTo_QTime    sipModuleAPI_QtGui_QtCore->em_types[85]->type->td_fcto

#define sipClass_QDateTime             sipModuleAPI_QtGui_QtCore->em_types[84]
#define sipCast_QDateTime              sipModuleAPI_QtGui_QtCore->em_types[84]->type->td_cast
#define sipForceConvertTo_QDateTime    sipModuleAPI_QtGui_QtCore->em_types[84]->type->td_fcto

#define sipClass_QDir             sipModuleAPI_QtGui_QtCore->em_types[81]
#define sipCast_QDir              sipModuleAPI_QtGui_QtCore->em_types[81]->type->td_cast
#define sipForceConvertTo_QDir    sipModuleAPI_QtGui_QtCore->em_types[81]->type->td_fcto

#define sipEnum_QDir_SortFlag              sipModuleAPI_QtGui_QtCore->em_enums[56]
#define sipEnum_QDir_Filter              sipModuleAPI_QtGui_QtCore->em_enums[57]

#define sipClass_QDir_Filters             sipModuleAPI_QtGui_QtCore->em_types[83]
#define sipCast_QDir_Filters              sipModuleAPI_QtGui_QtCore->em_types[83]->type->td_cast
#define sipForceConvertTo_QDir_Filters    sipModuleAPI_QtGui_QtCore->em_types[83]->type->td_fcto

#define sipClass_QDir_SortFlags             sipModuleAPI_QtGui_QtCore->em_types[82]
#define sipCast_QDir_SortFlags              sipModuleAPI_QtGui_QtCore->em_types[82]->type->td_cast
#define sipForceConvertTo_QDir_SortFlags    sipModuleAPI_QtGui_QtCore->em_types[82]->type->td_fcto

#define sipClass_QDirIterator             sipModuleAPI_QtGui_QtCore->em_types[79]
#define sipCast_QDirIterator              sipModuleAPI_QtGui_QtCore->em_types[79]->type->td_cast
#define sipForceConvertTo_QDirIterator    sipModuleAPI_QtGui_QtCore->em_types[79]->type->td_fcto

#define sipEnum_QDirIterator_IteratorFlag              sipModuleAPI_QtGui_QtCore->em_enums[55]

#define sipClass_QDirIterator_IteratorFlags             sipModuleAPI_QtGui_QtCore->em_types[80]
#define sipCast_QDirIterator_IteratorFlags              sipModuleAPI_QtGui_QtCore->em_types[80]->type->td_cast
#define sipForceConvertTo_QDirIterator_IteratorFlags    sipModuleAPI_QtGui_QtCore->em_types[80]->type->td_fcto

#define sipClass_QEventLoop             sipModuleAPI_QtGui_QtCore->em_types[122]
#define sipCast_QEventLoop              sipModuleAPI_QtGui_QtCore->em_types[122]->type->td_cast
#define sipForceConvertTo_QEventLoop    sipModuleAPI_QtGui_QtCore->em_types[122]->type->td_fcto

#define sipEnum_QEventLoop_ProcessEventsFlag              sipModuleAPI_QtGui_QtCore->em_enums[54]

#define sipClass_QEventLoop_ProcessEventsFlags             sipModuleAPI_QtGui_QtCore->em_types[123]
#define sipCast_QEventLoop_ProcessEventsFlags              sipModuleAPI_QtGui_QtCore->em_types[123]->type->td_cast
#define sipForceConvertTo_QEventLoop_ProcessEventsFlags    sipModuleAPI_QtGui_QtCore->em_types[123]->type->td_fcto

#define sipClass_QFile             sipModuleAPI_QtGui_QtCore->em_types[128]
#define sipCast_QFile              sipModuleAPI_QtGui_QtCore->em_types[128]->type->td_cast
#define sipForceConvertTo_QFile    sipModuleAPI_QtGui_QtCore->em_types[128]->type->td_fcto

#define sipEnum_QFile_Permission              sipModuleAPI_QtGui_QtCore->em_enums[51]
#define sipEnum_QFile_MemoryMapFlags              sipModuleAPI_QtGui_QtCore->em_enums[52]
#define sipEnum_QFile_FileError              sipModuleAPI_QtGui_QtCore->em_enums[53]

#define sipClass_QFile_Permissions             sipModuleAPI_QtGui_QtCore->em_types[129]
#define sipCast_QFile_Permissions              sipModuleAPI_QtGui_QtCore->em_types[129]->type->td_cast
#define sipForceConvertTo_QFile_Permissions    sipModuleAPI_QtGui_QtCore->em_types[129]->type->td_fcto

#define sipClass_QFileInfo             sipModuleAPI_QtGui_QtCore->em_types[78]
#define sipCast_QFileInfo              sipModuleAPI_QtGui_QtCore->em_types[78]->type->td_cast
#define sipForceConvertTo_QFileInfo    sipModuleAPI_QtGui_QtCore->em_types[78]->type->td_fcto

#define sipClass_QFileSystemWatcher             sipModuleAPI_QtGui_QtCore->em_types[121]
#define sipCast_QFileSystemWatcher              sipModuleAPI_QtGui_QtCore->em_types[121]->type->td_cast
#define sipForceConvertTo_QFileSystemWatcher    sipModuleAPI_QtGui_QtCore->em_types[121]->type->td_fcto

#define sipClass_QFSFileEngine             sipModuleAPI_QtGui_QtCore->em_types[105]
#define sipCast_QFSFileEngine              sipModuleAPI_QtGui_QtCore->em_types[105]->type->td_cast
#define sipForceConvertTo_QFSFileEngine    sipModuleAPI_QtGui_QtCore->em_types[105]->type->td_fcto

#define sipClass_QIODevice_OpenMode             sipModuleAPI_QtGui_QtCore->em_types[126]
#define sipCast_QIODevice_OpenMode              sipModuleAPI_QtGui_QtCore->em_types[126]->type->td_cast
#define sipForceConvertTo_QIODevice_OpenMode    sipModuleAPI_QtGui_QtCore->em_types[126]->type->td_fcto

#define sipClass_QLibrary             sipModuleAPI_QtGui_QtCore->em_types[119]
#define sipCast_QLibrary              sipModuleAPI_QtGui_QtCore->em_types[119]->type->td_cast
#define sipForceConvertTo_QLibrary    sipModuleAPI_QtGui_QtCore->em_types[119]->type->td_fcto

#define sipEnum_QLibrary_LoadHint              sipModuleAPI_QtGui_QtCore->em_enums[49]

#define sipClass_QLibrary_LoadHints             sipModuleAPI_QtGui_QtCore->em_types[120]
#define sipCast_QLibrary_LoadHints              sipModuleAPI_QtGui_QtCore->em_types[120]->type->td_cast
#define sipForceConvertTo_QLibrary_LoadHints    sipModuleAPI_QtGui_QtCore->em_types[120]->type->td_fcto

#define sipClass_QLibraryInfo             sipModuleAPI_QtGui_QtCore->em_types[77]
#define sipCast_QLibraryInfo              sipModuleAPI_QtGui_QtCore->em_types[77]->type->td_cast
#define sipForceConvertTo_QLibraryInfo    sipModuleAPI_QtGui_QtCore->em_types[77]->type->td_fcto

#define sipEnum_QLibraryInfo_LibraryLocation              sipModuleAPI_QtGui_QtCore->em_enums[48]

#define sipClass_QLine             sipModuleAPI_QtGui_QtCore->em_types[76]
#define sipCast_QLine              sipModuleAPI_QtGui_QtCore->em_types[76]->type->td_cast
#define sipForceConvertTo_QLine    sipModuleAPI_QtGui_QtCore->em_types[76]->type->td_fcto

#define sipClass_QLineF             sipModuleAPI_QtGui_QtCore->em_types[75]
#define sipCast_QLineF              sipModuleAPI_QtGui_QtCore->em_types[75]->type->td_cast
#define sipForceConvertTo_QLineF    sipModuleAPI_QtGui_QtCore->em_types[75]->type->td_fcto

#define sipEnum_QLineF_IntersectType              sipModuleAPI_QtGui_QtCore->em_enums[47]

#define sipClass_QLocale             sipModuleAPI_QtGui_QtCore->em_types[73]
#define sipCast_QLocale              sipModuleAPI_QtGui_QtCore->em_types[73]->type->td_cast
#define sipForceConvertTo_QLocale    sipModuleAPI_QtGui_QtCore->em_types[73]->type->td_fcto

#define sipEnum_QLocale_MeasurementSystem              sipModuleAPI_QtGui_QtCore->em_enums[42]
#define sipEnum_QLocale_FormatType              sipModuleAPI_QtGui_QtCore->em_enums[43]
#define sipEnum_QLocale_NumberOption              sipModuleAPI_QtGui_QtCore->em_enums[44]
#define sipEnum_QLocale_Country              sipModuleAPI_QtGui_QtCore->em_enums[45]
#define sipEnum_QLocale_Language              sipModuleAPI_QtGui_QtCore->em_enums[46]

#define sipClass_QLocale_NumberOptions             sipModuleAPI_QtGui_QtCore->em_types[74]
#define sipCast_QLocale_NumberOptions              sipModuleAPI_QtGui_QtCore->em_types[74]->type->td_cast
#define sipForceConvertTo_QLocale_NumberOptions    sipModuleAPI_QtGui_QtCore->em_types[74]->type->td_fcto

#define sipClass_QSystemLocale             sipModuleAPI_QtGui_QtCore->em_types[72]
#define sipCast_QSystemLocale              sipModuleAPI_QtGui_QtCore->em_types[72]->type->td_cast
#define sipForceConvertTo_QSystemLocale    sipModuleAPI_QtGui_QtCore->em_types[72]->type->td_fcto

#define sipEnum_QSystemLocale_QueryType              sipModuleAPI_QtGui_QtCore->em_enums[41]

#define sipClass_QMetaMethod             sipModuleAPI_QtGui_QtCore->em_types[71]
#define sipCast_QMetaMethod              sipModuleAPI_QtGui_QtCore->em_types[71]->type->td_cast
#define sipForceConvertTo_QMetaMethod    sipModuleAPI_QtGui_QtCore->em_types[71]->type->td_fcto

#define sipEnum_QMetaMethod_MethodType              sipModuleAPI_QtGui_QtCore->em_enums[39]
#define sipEnum_QMetaMethod_Access              sipModuleAPI_QtGui_QtCore->em_enums[40]

#define sipClass_QMetaEnum             sipModuleAPI_QtGui_QtCore->em_types[70]
#define sipCast_QMetaEnum              sipModuleAPI_QtGui_QtCore->em_types[70]->type->td_cast
#define sipForceConvertTo_QMetaEnum    sipModuleAPI_QtGui_QtCore->em_types[70]->type->td_fcto

#define sipClass_QMetaProperty             sipModuleAPI_QtGui_QtCore->em_types[69]
#define sipCast_QMetaProperty              sipModuleAPI_QtGui_QtCore->em_types[69]->type->td_cast
#define sipForceConvertTo_QMetaProperty    sipModuleAPI_QtGui_QtCore->em_types[69]->type->td_fcto

#define sipClass_QMetaClassInfo             sipModuleAPI_QtGui_QtCore->em_types[68]
#define sipCast_QMetaClassInfo              sipModuleAPI_QtGui_QtCore->em_types[68]->type->td_cast
#define sipForceConvertTo_QMetaClassInfo    sipModuleAPI_QtGui_QtCore->em_types[68]->type->td_fcto

#define sipClass_QMetaType             sipModuleAPI_QtGui_QtCore->em_types[67]
#define sipCast_QMetaType              sipModuleAPI_QtGui_QtCore->em_types[67]->type->td_cast
#define sipForceConvertTo_QMetaType    sipModuleAPI_QtGui_QtCore->em_types[67]->type->td_fcto

#define sipEnum_QMetaType_Type              sipModuleAPI_QtGui_QtCore->em_enums[38]

#define sipClass_QMimeData             sipModuleAPI_QtGui_QtCore->em_types[118]
#define sipCast_QMimeData              sipModuleAPI_QtGui_QtCore->em_types[118]->type->td_cast
#define sipForceConvertTo_QMimeData    sipModuleAPI_QtGui_QtCore->em_types[118]->type->td_fcto

#define sipClass_QMutex             sipModuleAPI_QtGui_QtCore->em_types[66]
#define sipCast_QMutex              sipModuleAPI_QtGui_QtCore->em_types[66]->type->td_cast
#define sipForceConvertTo_QMutex    sipModuleAPI_QtGui_QtCore->em_types[66]->type->td_fcto

#define sipEnum_QMutex_RecursionMode              sipModuleAPI_QtGui_QtCore->em_enums[37]

#define sipClass_QMutexLocker             sipModuleAPI_QtGui_QtCore->em_types[65]
#define sipCast_QMutexLocker              sipModuleAPI_QtGui_QtCore->em_types[65]->type->td_cast
#define sipForceConvertTo_QMutexLocker    sipModuleAPI_QtGui_QtCore->em_types[65]->type->td_fcto

#define sipClass_QObjectCleanupHandler             sipModuleAPI_QtGui_QtCore->em_types[117]
#define sipCast_QObjectCleanupHandler              sipModuleAPI_QtGui_QtCore->em_types[117]->type->td_cast
#define sipForceConvertTo_QObjectCleanupHandler    sipModuleAPI_QtGui_QtCore->em_types[117]->type->td_fcto

#define sipClass_QMetaObject             sipModuleAPI_QtGui_QtCore->em_types[45]
#define sipCast_QMetaObject              sipModuleAPI_QtGui_QtCore->em_types[45]->type->td_cast
#define sipForceConvertTo_QMetaObject    sipModuleAPI_QtGui_QtCore->em_types[45]->type->td_fcto

#define sipClass_QGenericArgument             sipModuleAPI_QtGui_QtCore->em_types[44]
#define sipCast_QGenericArgument              sipModuleAPI_QtGui_QtCore->em_types[44]->type->td_cast
#define sipForceConvertTo_QGenericArgument    sipModuleAPI_QtGui_QtCore->em_types[44]->type->td_fcto

#define sipClass_QGenericReturnArgument             sipModuleAPI_QtGui_QtCore->em_types[43]
#define sipCast_QGenericReturnArgument              sipModuleAPI_QtGui_QtCore->em_types[43]->type->td_cast
#define sipForceConvertTo_QGenericReturnArgument    sipModuleAPI_QtGui_QtCore->em_types[43]->type->td_fcto

#define sipClass_QPluginLoader             sipModuleAPI_QtGui_QtCore->em_types[116]
#define sipCast_QPluginLoader              sipModuleAPI_QtGui_QtCore->em_types[116]->type->td_cast
#define sipForceConvertTo_QPluginLoader    sipModuleAPI_QtGui_QtCore->em_types[116]->type->td_fcto

#define sipClass_QPoint             sipModuleAPI_QtGui_QtCore->em_types[42]
#define sipCast_QPoint              sipModuleAPI_QtGui_QtCore->em_types[42]->type->td_cast
#define sipForceConvertTo_QPoint    sipModuleAPI_QtGui_QtCore->em_types[42]->type->td_fcto

#define sipClass_QPointF             sipModuleAPI_QtGui_QtCore->em_types[41]
#define sipCast_QPointF              sipModuleAPI_QtGui_QtCore->em_types[41]->type->td_cast
#define sipForceConvertTo_QPointF    sipModuleAPI_QtGui_QtCore->em_types[41]->type->td_fcto

#define sipClass_QProcess             sipModuleAPI_QtGui_QtCore->em_types[127]
#define sipCast_QProcess              sipModuleAPI_QtGui_QtCore->em_types[127]->type->td_cast
#define sipForceConvertTo_QProcess    sipModuleAPI_QtGui_QtCore->em_types[127]->type->td_fcto

#define sipEnum_QProcess_ProcessChannelMode              sipModuleAPI_QtGui_QtCore->em_enums[32]
#define sipEnum_QProcess_ProcessChannel              sipModuleAPI_QtGui_QtCore->em_enums[33]
#define sipEnum_QProcess_ProcessState              sipModuleAPI_QtGui_QtCore->em_enums[34]
#define sipEnum_QProcess_ProcessError              sipModuleAPI_QtGui_QtCore->em_enums[35]
#define sipEnum_QProcess_ExitStatus              sipModuleAPI_QtGui_QtCore->em_enums[36]

#define sipClass_QReadWriteLock             sipModuleAPI_QtGui_QtCore->em_types[40]
#define sipCast_QReadWriteLock              sipModuleAPI_QtGui_QtCore->em_types[40]->type->td_cast
#define sipForceConvertTo_QReadWriteLock    sipModuleAPI_QtGui_QtCore->em_types[40]->type->td_fcto

#define sipEnum_QReadWriteLock_RecursionMode              sipModuleAPI_QtGui_QtCore->em_enums[31]

#define sipClass_QReadLocker             sipModuleAPI_QtGui_QtCore->em_types[39]
#define sipCast_QReadLocker              sipModuleAPI_QtGui_QtCore->em_types[39]->type->td_cast
#define sipForceConvertTo_QReadLocker    sipModuleAPI_QtGui_QtCore->em_types[39]->type->td_fcto

#define sipClass_QWriteLocker             sipModuleAPI_QtGui_QtCore->em_types[38]
#define sipCast_QWriteLocker              sipModuleAPI_QtGui_QtCore->em_types[38]->type->td_cast
#define sipForceConvertTo_QWriteLocker    sipModuleAPI_QtGui_QtCore->em_types[38]->type->td_fcto

#define sipClass_QRect             sipModuleAPI_QtGui_QtCore->em_types[37]
#define sipCast_QRect              sipModuleAPI_QtGui_QtCore->em_types[37]->type->td_cast
#define sipForceConvertTo_QRect    sipModuleAPI_QtGui_QtCore->em_types[37]->type->td_fcto

#define sipClass_QRectF             sipModuleAPI_QtGui_QtCore->em_types[36]
#define sipCast_QRectF              sipModuleAPI_QtGui_QtCore->em_types[36]->type->td_cast
#define sipForceConvertTo_QRectF    sipModuleAPI_QtGui_QtCore->em_types[36]->type->td_fcto

#define sipClass_QRegExp             sipModuleAPI_QtGui_QtCore->em_types[35]
#define sipCast_QRegExp              sipModuleAPI_QtGui_QtCore->em_types[35]->type->td_cast
#define sipForceConvertTo_QRegExp    sipModuleAPI_QtGui_QtCore->em_types[35]->type->td_fcto

#define sipEnum_QRegExp_CaretMode              sipModuleAPI_QtGui_QtCore->em_enums[29]
#define sipEnum_QRegExp_PatternSyntax              sipModuleAPI_QtGui_QtCore->em_enums[30]

#define sipClass_QResource             sipModuleAPI_QtGui_QtCore->em_types[34]
#define sipCast_QResource              sipModuleAPI_QtGui_QtCore->em_types[34]->type->td_cast
#define sipForceConvertTo_QResource    sipModuleAPI_QtGui_QtCore->em_types[34]->type->td_fcto

#define sipClass_QRunnable             sipModuleAPI_QtGui_QtCore->em_types[33]
#define sipCast_QRunnable              sipModuleAPI_QtGui_QtCore->em_types[33]->type->td_cast
#define sipForceConvertTo_QRunnable    sipModuleAPI_QtGui_QtCore->em_types[33]->type->td_fcto

#define sipClass_QSemaphore             sipModuleAPI_QtGui_QtCore->em_types[32]
#define sipCast_QSemaphore              sipModuleAPI_QtGui_QtCore->em_types[32]->type->td_cast
#define sipForceConvertTo_QSemaphore    sipModuleAPI_QtGui_QtCore->em_types[32]->type->td_fcto

#define sipClass_QSettings             sipModuleAPI_QtGui_QtCore->em_types[115]
#define sipCast_QSettings              sipModuleAPI_QtGui_QtCore->em_types[115]->type->td_cast
#define sipForceConvertTo_QSettings    sipModuleAPI_QtGui_QtCore->em_types[115]->type->td_fcto

#define sipEnum_QSettings_Scope              sipModuleAPI_QtGui_QtCore->em_enums[26]
#define sipEnum_QSettings_Format              sipModuleAPI_QtGui_QtCore->em_enums[27]
#define sipEnum_QSettings_Status              sipModuleAPI_QtGui_QtCore->em_enums[28]

#define sipClass_QSharedMemory             sipModuleAPI_QtGui_QtCore->em_types[114]
#define sipCast_QSharedMemory              sipModuleAPI_QtGui_QtCore->em_types[114]->type->td_cast
#define sipForceConvertTo_QSharedMemory    sipModuleAPI_QtGui_QtCore->em_types[114]->type->td_fcto

#define sipEnum_QSharedMemory_SharedMemoryError              sipModuleAPI_QtGui_QtCore->em_enums[24]
#define sipEnum_QSharedMemory_AccessMode              sipModuleAPI_QtGui_QtCore->em_enums[25]

#define sipClass_QSignalMapper             sipModuleAPI_QtGui_QtCore->em_types[113]
#define sipCast_QSignalMapper              sipModuleAPI_QtGui_QtCore->em_types[113]->type->td_cast
#define sipForceConvertTo_QSignalMapper    sipModuleAPI_QtGui_QtCore->em_types[113]->type->td_fcto

#define sipClass_QSize             sipModuleAPI_QtGui_QtCore->em_types[31]
#define sipCast_QSize              sipModuleAPI_QtGui_QtCore->em_types[31]->type->td_cast
#define sipForceConvertTo_QSize    sipModuleAPI_QtGui_QtCore->em_types[31]->type->td_fcto

#define sipClass_QSizeF             sipModuleAPI_QtGui_QtCore->em_types[30]
#define sipCast_QSizeF              sipModuleAPI_QtGui_QtCore->em_types[30]->type->td_cast
#define sipForceConvertTo_QSizeF    sipModuleAPI_QtGui_QtCore->em_types[30]->type->td_fcto

#define sipClass_QSocketNotifier             sipModuleAPI_QtGui_QtCore->em_types[112]
#define sipCast_QSocketNotifier              sipModuleAPI_QtGui_QtCore->em_types[112]->type->td_cast
#define sipForceConvertTo_QSocketNotifier    sipModuleAPI_QtGui_QtCore->em_types[112]->type->td_fcto

#define sipEnum_QSocketNotifier_Type              sipModuleAPI_QtGui_QtCore->em_enums[23]

#define sipClass_QString             sipModuleAPI_QtGui_QtCore->em_types[28]
#define sipCast_QString              sipModuleAPI_QtGui_QtCore->em_types[28]->type->td_cast
#define sipForceConvertTo_QString    sipModuleAPI_QtGui_QtCore->em_types[28]->type->td_fcto

#define sipEnum_QString_NormalizationForm              sipModuleAPI_QtGui_QtCore->em_enums[20]
#define sipEnum_QString_SplitBehavior              sipModuleAPI_QtGui_QtCore->em_enums[21]
#define sipEnum_QString_SectionFlag              sipModuleAPI_QtGui_QtCore->em_enums[22]

#define sipClass_QString_SectionFlags             sipModuleAPI_QtGui_QtCore->em_types[29]
#define sipCast_QString_SectionFlags              sipModuleAPI_QtGui_QtCore->em_types[29]->type->td_cast
#define sipForceConvertTo_QString_SectionFlags    sipModuleAPI_QtGui_QtCore->em_types[29]->type->td_fcto

#define sipClass_QLatin1String             sipModuleAPI_QtGui_QtCore->em_types[27]
#define sipCast_QLatin1String              sipModuleAPI_QtGui_QtCore->em_types[27]->type->td_cast
#define sipForceConvertTo_QLatin1String    sipModuleAPI_QtGui_QtCore->em_types[27]->type->td_fcto

#define sipClass_QStringRef             sipModuleAPI_QtGui_QtCore->em_types[26]
#define sipCast_QStringRef              sipModuleAPI_QtGui_QtCore->em_types[26]->type->td_cast
#define sipForceConvertTo_QStringRef    sipModuleAPI_QtGui_QtCore->em_types[26]->type->td_fcto

#define sipClass_QStringList             sipModuleAPI_QtGui_QtCore->em_types[25]
#define sipCast_QStringList              sipModuleAPI_QtGui_QtCore->em_types[25]->type->td_cast
#define sipForceConvertTo_QStringList    sipModuleAPI_QtGui_QtCore->em_types[25]->type->td_fcto

#define sipClass_QStringMatcher             sipModuleAPI_QtGui_QtCore->em_types[24]
#define sipCast_QStringMatcher              sipModuleAPI_QtGui_QtCore->em_types[24]->type->td_cast
#define sipForceConvertTo_QStringMatcher    sipModuleAPI_QtGui_QtCore->em_types[24]->type->td_fcto

#define sipClass_QSystemSemaphore             sipModuleAPI_QtGui_QtCore->em_types[23]
#define sipCast_QSystemSemaphore              sipModuleAPI_QtGui_QtCore->em_types[23]->type->td_cast
#define sipForceConvertTo_QSystemSemaphore    sipModuleAPI_QtGui_QtCore->em_types[23]->type->td_fcto

#define sipEnum_QSystemSemaphore_SystemSemaphoreError              sipModuleAPI_QtGui_QtCore->em_enums[18]
#define sipEnum_QSystemSemaphore_AccessMode              sipModuleAPI_QtGui_QtCore->em_enums[19]

#define sipClass_QTemporaryFile             sipModuleAPI_QtGui_QtCore->em_types[130]
#define sipCast_QTemporaryFile              sipModuleAPI_QtGui_QtCore->em_types[130]->type->td_cast
#define sipForceConvertTo_QTemporaryFile    sipModuleAPI_QtGui_QtCore->em_types[130]->type->td_fcto

#define sipClass_QTextBoundaryFinder             sipModuleAPI_QtGui_QtCore->em_types[21]
#define sipCast_QTextBoundaryFinder              sipModuleAPI_QtGui_QtCore->em_types[21]->type->td_cast
#define sipForceConvertTo_QTextBoundaryFinder    sipModuleAPI_QtGui_QtCore->em_types[21]->type->td_fcto

#define sipEnum_QTextBoundaryFinder_BoundaryType              sipModuleAPI_QtGui_QtCore->em_enums[16]
#define sipEnum_QTextBoundaryFinder_BoundaryReason              sipModuleAPI_QtGui_QtCore->em_enums[17]

#define sipClass_QTextBoundaryFinder_BoundaryReasons             sipModuleAPI_QtGui_QtCore->em_types[22]
#define sipCast_QTextBoundaryFinder_BoundaryReasons              sipModuleAPI_QtGui_QtCore->em_types[22]->type->td_cast
#define sipForceConvertTo_QTextBoundaryFinder_BoundaryReasons    sipModuleAPI_QtGui_QtCore->em_types[22]->type->td_fcto

#define sipClass_QTextCodec             sipModuleAPI_QtGui_QtCore->em_types[18]
#define sipCast_QTextCodec              sipModuleAPI_QtGui_QtCore->em_types[18]->type->td_cast
#define sipForceConvertTo_QTextCodec    sipModuleAPI_QtGui_QtCore->em_types[18]->type->td_fcto

#define sipEnum_QTextCodec_ConversionFlag              sipModuleAPI_QtGui_QtCore->em_enums[15]

#define sipClass_QTextCodec_ConversionFlags             sipModuleAPI_QtGui_QtCore->em_types[20]
#define sipCast_QTextCodec_ConversionFlags              sipModuleAPI_QtGui_QtCore->em_types[20]->type->td_cast
#define sipForceConvertTo_QTextCodec_ConversionFlags    sipModuleAPI_QtGui_QtCore->em_types[20]->type->td_fcto

#define sipClass_QTextCodec_ConverterState             sipModuleAPI_QtGui_QtCore->em_types[19]
#define sipCast_QTextCodec_ConverterState              sipModuleAPI_QtGui_QtCore->em_types[19]->type->td_cast
#define sipForceConvertTo_QTextCodec_ConverterState    sipModuleAPI_QtGui_QtCore->em_types[19]->type->td_fcto

#define sipClass_QTextEncoder             sipModuleAPI_QtGui_QtCore->em_types[17]
#define sipCast_QTextEncoder              sipModuleAPI_QtGui_QtCore->em_types[17]->type->td_cast
#define sipForceConvertTo_QTextEncoder    sipModuleAPI_QtGui_QtCore->em_types[17]->type->td_fcto

#define sipClass_QTextDecoder             sipModuleAPI_QtGui_QtCore->em_types[16]
#define sipCast_QTextDecoder              sipModuleAPI_QtGui_QtCore->em_types[16]->type->td_cast
#define sipForceConvertTo_QTextDecoder    sipModuleAPI_QtGui_QtCore->em_types[16]->type->td_fcto

#define sipClass_QTextStream             sipModuleAPI_QtGui_QtCore->em_types[14]
#define sipCast_QTextStream              sipModuleAPI_QtGui_QtCore->em_types[14]->type->td_cast
#define sipForceConvertTo_QTextStream    sipModuleAPI_QtGui_QtCore->em_types[14]->type->td_fcto

#define sipEnum_QTextStream_Status              sipModuleAPI_QtGui_QtCore->em_enums[11]
#define sipEnum_QTextStream_NumberFlag              sipModuleAPI_QtGui_QtCore->em_enums[12]
#define sipEnum_QTextStream_FieldAlignment              sipModuleAPI_QtGui_QtCore->em_enums[13]
#define sipEnum_QTextStream_RealNumberNotation              sipModuleAPI_QtGui_QtCore->em_enums[14]

#define sipClass_QTextStream_NumberFlags             sipModuleAPI_QtGui_QtCore->em_types[15]
#define sipCast_QTextStream_NumberFlags              sipModuleAPI_QtGui_QtCore->em_types[15]->type->td_cast
#define sipForceConvertTo_QTextStream_NumberFlags    sipModuleAPI_QtGui_QtCore->em_types[15]->type->td_fcto

#define sipClass_QTextStreamManipulator             sipModuleAPI_QtGui_QtCore->em_types[13]
#define sipCast_QTextStreamManipulator              sipModuleAPI_QtGui_QtCore->em_types[13]->type->td_cast
#define sipForceConvertTo_QTextStreamManipulator    sipModuleAPI_QtGui_QtCore->em_types[13]->type->td_fcto

#define sipClass_QThread             sipModuleAPI_QtGui_QtCore->em_types[111]
#define sipCast_QThread              sipModuleAPI_QtGui_QtCore->em_types[111]->type->td_cast
#define sipForceConvertTo_QThread    sipModuleAPI_QtGui_QtCore->em_types[111]->type->td_fcto

#define sipEnum_QThread_Priority              sipModuleAPI_QtGui_QtCore->em_enums[10]

#define sipClass_QThreadPool             sipModuleAPI_QtGui_QtCore->em_types[110]
#define sipCast_QThreadPool              sipModuleAPI_QtGui_QtCore->em_types[110]->type->td_cast
#define sipForceConvertTo_QThreadPool    sipModuleAPI_QtGui_QtCore->em_types[110]->type->td_fcto

#define sipClass_QTimeLine             sipModuleAPI_QtGui_QtCore->em_types[109]
#define sipCast_QTimeLine              sipModuleAPI_QtGui_QtCore->em_types[109]->type->td_cast
#define sipForceConvertTo_QTimeLine    sipModuleAPI_QtGui_QtCore->em_types[109]->type->td_fcto

#define sipEnum_QTimeLine_State              sipModuleAPI_QtGui_QtCore->em_enums[7]
#define sipEnum_QTimeLine_Direction              sipModuleAPI_QtGui_QtCore->em_enums[8]
#define sipEnum_QTimeLine_CurveShape              sipModuleAPI_QtGui_QtCore->em_enums[9]

#define sipClass_QTimer             sipModuleAPI_QtGui_QtCore->em_types[108]
#define sipCast_QTimer              sipModuleAPI_QtGui_QtCore->em_types[108]->type->td_cast
#define sipForceConvertTo_QTimer    sipModuleAPI_QtGui_QtCore->em_types[108]->type->td_fcto

#define sipClass_QTranslator             sipModuleAPI_QtGui_QtCore->em_types[107]
#define sipCast_QTranslator              sipModuleAPI_QtGui_QtCore->em_types[107]->type->td_cast
#define sipForceConvertTo_QTranslator    sipModuleAPI_QtGui_QtCore->em_types[107]->type->td_fcto

#define sipClass_QUrl             sipModuleAPI_QtGui_QtCore->em_types[11]
#define sipCast_QUrl              sipModuleAPI_QtGui_QtCore->em_types[11]->type->td_cast
#define sipForceConvertTo_QUrl    sipModuleAPI_QtGui_QtCore->em_types[11]->type->td_fcto

#define sipEnum_QUrl_ParsingMode              sipModuleAPI_QtGui_QtCore->em_enums[5]
#define sipEnum_QUrl_FormattingOption              sipModuleAPI_QtGui_QtCore->em_enums[6]

#define sipClass_QUrl_FormattingOptions             sipModuleAPI_QtGui_QtCore->em_types[12]
#define sipCast_QUrl_FormattingOptions              sipModuleAPI_QtGui_QtCore->em_types[12]->type->td_cast
#define sipForceConvertTo_QUrl_FormattingOptions    sipModuleAPI_QtGui_QtCore->em_types[12]->type->td_fcto

#define sipClass_QUuid             sipModuleAPI_QtGui_QtCore->em_types[10]
#define sipCast_QUuid              sipModuleAPI_QtGui_QtCore->em_types[10]->type->td_cast
#define sipForceConvertTo_QUuid    sipModuleAPI_QtGui_QtCore->em_types[10]->type->td_fcto

#define sipEnum_QUuid_Version              sipModuleAPI_QtGui_QtCore->em_enums[3]
#define sipEnum_QUuid_Variant              sipModuleAPI_QtGui_QtCore->em_enums[4]

#define sipClass_QVariant             sipModuleAPI_QtGui_QtCore->em_types[9]
#define sipCast_QVariant              sipModuleAPI_QtGui_QtCore->em_types[9]->type->td_cast
#define sipForceConvertTo_QVariant    sipModuleAPI_QtGui_QtCore->em_types[9]->type->td_fcto

#define sipEnum_QVariant_Type              sipModuleAPI_QtGui_QtCore->em_enums[2]

#define sipClass_QWaitCondition             sipModuleAPI_QtGui_QtCore->em_types[8]
#define sipCast_QWaitCondition              sipModuleAPI_QtGui_QtCore->em_types[8]->type->td_cast
#define sipForceConvertTo_QWaitCondition    sipModuleAPI_QtGui_QtCore->em_types[8]->type->td_fcto

#define sipClass_QXmlStreamAttribute             sipModuleAPI_QtGui_QtCore->em_types[7]
#define sipCast_QXmlStreamAttribute              sipModuleAPI_QtGui_QtCore->em_types[7]->type->td_cast
#define sipForceConvertTo_QXmlStreamAttribute    sipModuleAPI_QtGui_QtCore->em_types[7]->type->td_fcto

#define sipClass_QXmlStreamAttributes             sipModuleAPI_QtGui_QtCore->em_types[6]
#define sipCast_QXmlStreamAttributes              sipModuleAPI_QtGui_QtCore->em_types[6]->type->td_cast
#define sipForceConvertTo_QXmlStreamAttributes    sipModuleAPI_QtGui_QtCore->em_types[6]->type->td_fcto

#define sipClass_QXmlStreamNamespaceDeclaration             sipModuleAPI_QtGui_QtCore->em_types[5]
#define sipCast_QXmlStreamNamespaceDeclaration              sipModuleAPI_QtGui_QtCore->em_types[5]->type->td_cast
#define sipForceConvertTo_QXmlStreamNamespaceDeclaration    sipModuleAPI_QtGui_QtCore->em_types[5]->type->td_fcto

#define sipClass_QXmlStreamNotationDeclaration             sipModuleAPI_QtGui_QtCore->em_types[4]
#define sipCast_QXmlStreamNotationDeclaration              sipModuleAPI_QtGui_QtCore->em_types[4]->type->td_cast
#define sipForceConvertTo_QXmlStreamNotationDeclaration    sipModuleAPI_QtGui_QtCore->em_types[4]->type->td_fcto

#define sipClass_QXmlStreamEntityDeclaration             sipModuleAPI_QtGui_QtCore->em_types[3]
#define sipCast_QXmlStreamEntityDeclaration              sipModuleAPI_QtGui_QtCore->em_types[3]->type->td_cast
#define sipForceConvertTo_QXmlStreamEntityDeclaration    sipModuleAPI_QtGui_QtCore->em_types[3]->type->td_fcto

#define sipClass_QXmlStreamEntityResolver             sipModuleAPI_QtGui_QtCore->em_types[2]
#define sipCast_QXmlStreamEntityResolver              sipModuleAPI_QtGui_QtCore->em_types[2]->type->td_cast
#define sipForceConvertTo_QXmlStreamEntityResolver    sipModuleAPI_QtGui_QtCore->em_types[2]->type->td_fcto

#define sipClass_QXmlStreamReader             sipModuleAPI_QtGui_QtCore->em_types[1]
#define sipCast_QXmlStreamReader              sipModuleAPI_QtGui_QtCore->em_types[1]->type->td_cast
#define sipForceConvertTo_QXmlStreamReader    sipModuleAPI_QtGui_QtCore->em_types[1]->type->td_fcto

#define sipEnum_QXmlStreamReader_Error              sipModuleAPI_QtGui_QtCore->em_enums[0]
#define sipEnum_QXmlStreamReader_TokenType              sipModuleAPI_QtGui_QtCore->em_enums[1]

#define sipClass_QXmlStreamWriter             sipModuleAPI_QtGui_QtCore->em_types[0]
#define sipCast_QXmlStreamWriter              sipModuleAPI_QtGui_QtCore->em_types[0]->type->td_cast
#define sipForceConvertTo_QXmlStreamWriter    sipModuleAPI_QtGui_QtCore->em_types[0]->type->td_fcto

#define sipMappedType_QList_0600QPair_0100QByteArray_0100QByteArray        sipModuleAPI_QtGui_QtCore->em_mappedtypes[0]
#define sipForceConvertTo_QList_0600QPair_0100QByteArray_0100QByteArray    sipModuleAPI_QtGui_QtCore->em_mappedtypes[0]->mt_fcto
#define sipConvertFrom_QList_0600QPair_0100QByteArray_0100QByteArray       sipModuleAPI_QtGui_QtCore->em_mappedtypes[0]->mt_cfrom

#define sipMappedType_QList_0600QPair_0100QString_0100QString        sipModuleAPI_QtGui_QtCore->em_mappedtypes[1]
#define sipForceConvertTo_QList_0600QPair_0100QString_0100QString    sipModuleAPI_QtGui_QtCore->em_mappedtypes[1]->mt_fcto
#define sipConvertFrom_QList_0600QPair_0100QString_0100QString       sipModuleAPI_QtGui_QtCore->em_mappedtypes[1]->mt_cfrom

#define sipMappedType_QList_0200QUrl        sipModuleAPI_QtGui_QtCore->em_mappedtypes[2]
#define sipForceConvertTo_QList_0200QUrl    sipModuleAPI_QtGui_QtCore->em_mappedtypes[2]->mt_fcto
#define sipConvertFrom_QList_0200QUrl       sipModuleAPI_QtGui_QtCore->em_mappedtypes[2]->mt_cfrom

#define sipMappedType_QMap_1800_0200QVariant        sipModuleAPI_QtGui_QtCore->em_mappedtypes[3]
#define sipForceConvertTo_QMap_1800_0200QVariant    sipModuleAPI_QtGui_QtCore->em_mappedtypes[3]->mt_fcto
#define sipConvertFrom_QMap_1800_0200QVariant       sipModuleAPI_QtGui_QtCore->em_mappedtypes[3]->mt_cfrom

#define sipMappedType_QList_0200QByteArray        sipModuleAPI_QtGui_QtCore->em_mappedtypes[4]
#define sipForceConvertTo_QList_0200QByteArray    sipModuleAPI_QtGui_QtCore->em_mappedtypes[4]->mt_fcto
#define sipConvertFrom_QList_0200QByteArray       sipModuleAPI_QtGui_QtCore->em_mappedtypes[4]->mt_cfrom

#define sipMappedType_QList_0200QModelIndex        sipModuleAPI_QtGui_QtCore->em_mappedtypes[5]
#define sipForceConvertTo_QList_0200QModelIndex    sipModuleAPI_QtGui_QtCore->em_mappedtypes[5]->mt_fcto
#define sipConvertFrom_QList_0200QModelIndex       sipModuleAPI_QtGui_QtCore->em_mappedtypes[5]->mt_cfrom

#define sipMappedType_QList_0200QFileInfo        sipModuleAPI_QtGui_QtCore->em_mappedtypes[6]
#define sipForceConvertTo_QList_0200QFileInfo    sipModuleAPI_QtGui_QtCore->em_mappedtypes[6]->mt_fcto
#define sipConvertFrom_QList_0200QFileInfo       sipModuleAPI_QtGui_QtCore->em_mappedtypes[6]->mt_cfrom

#define sipMappedType_QList_0201QObject        sipModuleAPI_QtGui_QtCore->em_mappedtypes[7]
#define sipForceConvertTo_QList_0201QObject    sipModuleAPI_QtGui_QtCore->em_mappedtypes[7]->mt_fcto
#define sipConvertFrom_QList_0201QObject       sipModuleAPI_QtGui_QtCore->em_mappedtypes[7]->mt_cfrom

#define sipMappedType_QList_0200QVariant        sipModuleAPI_QtGui_QtCore->em_mappedtypes[8]
#define sipForceConvertTo_QList_0200QVariant    sipModuleAPI_QtGui_QtCore->em_mappedtypes[8]->mt_fcto
#define sipConvertFrom_QList_0200QVariant       sipModuleAPI_QtGui_QtCore->em_mappedtypes[8]->mt_cfrom

#define sipMappedType_QMap_0200QString_0200QVariant        sipModuleAPI_QtGui_QtCore->em_mappedtypes[9]
#define sipForceConvertTo_QMap_0200QString_0200QVariant    sipModuleAPI_QtGui_QtCore->em_mappedtypes[9]->mt_fcto
#define sipConvertFrom_QMap_0200QString_0200QVariant       sipModuleAPI_QtGui_QtCore->em_mappedtypes[9]->mt_cfrom

#define sipMappedType_QVector_0200QXmlStreamNamespaceDeclaration        sipModuleAPI_QtGui_QtCore->em_mappedtypes[10]
#define sipForceConvertTo_QVector_0200QXmlStreamNamespaceDeclaration    sipModuleAPI_QtGui_QtCore->em_mappedtypes[10]->mt_fcto
#define sipConvertFrom_QVector_0200QXmlStreamNamespaceDeclaration       sipModuleAPI_QtGui_QtCore->em_mappedtypes[10]->mt_cfrom

#define sipMappedType_QVector_0200QXmlStreamNotationDeclaration        sipModuleAPI_QtGui_QtCore->em_mappedtypes[11]
#define sipForceConvertTo_QVector_0200QXmlStreamNotationDeclaration    sipModuleAPI_QtGui_QtCore->em_mappedtypes[11]->mt_fcto
#define sipConvertFrom_QVector_0200QXmlStreamNotationDeclaration       sipModuleAPI_QtGui_QtCore->em_mappedtypes[11]->mt_cfrom

#define sipMappedType_QVector_0200QXmlStreamEntityDeclaration        sipModuleAPI_QtGui_QtCore->em_mappedtypes[12]
#define sipForceConvertTo_QVector_0200QXmlStreamEntityDeclaration    sipModuleAPI_QtGui_QtCore->em_mappedtypes[12]->mt_fcto
#define sipConvertFrom_QVector_0200QXmlStreamEntityDeclaration       sipModuleAPI_QtGui_QtCore->em_mappedtypes[12]->mt_cfrom

#define sipMappedType_QVector_2400        sipModuleAPI_QtGui_QtCore->em_mappedtypes[13]
#define sipForceConvertTo_QVector_2400    sipModuleAPI_QtGui_QtCore->em_mappedtypes[13]->mt_fcto
#define sipConvertFrom_QVector_2400       sipModuleAPI_QtGui_QtCore->em_mappedtypes[13]->mt_cfrom

#define sipMappedType_QVector_1900        sipModuleAPI_QtGui_QtCore->em_mappedtypes[14]
#define sipForceConvertTo_QVector_1900    sipModuleAPI_QtGui_QtCore->em_mappedtypes[14]->mt_fcto
#define sipConvertFrom_QVector_1900       sipModuleAPI_QtGui_QtCore->em_mappedtypes[14]->mt_cfrom

#define sipMappedType_QPair_1800_1800        sipModuleAPI_QtGui_QtCore->em_mappedtypes[15]
#define sipForceConvertTo_QPair_1800_1800    sipModuleAPI_QtGui_QtCore->em_mappedtypes[15]->mt_fcto
#define sipConvertFrom_QPair_1800_1800       sipModuleAPI_QtGui_QtCore->em_mappedtypes[15]->mt_cfrom

#define sipMappedType_QList_0500QLocale_Country        sipModuleAPI_QtGui_QtCore->em_mappedtypes[16]
#define sipForceConvertTo_QList_0500QLocale_Country    sipModuleAPI_QtGui_QtCore->em_mappedtypes[16]->mt_fcto
#define sipConvertFrom_QList_0500QLocale_Country       sipModuleAPI_QtGui_QtCore->em_mappedtypes[16]->mt_cfrom

#define sipMappedType_QList_2400        sipModuleAPI_QtGui_QtCore->em_mappedtypes[17]
#define sipForceConvertTo_QList_2400    sipModuleAPI_QtGui_QtCore->em_mappedtypes[17]->mt_fcto
#define sipConvertFrom_QList_2400       sipModuleAPI_QtGui_QtCore->em_mappedtypes[17]->mt_cfrom

#define sipMappedType_QList_1800        sipModuleAPI_QtGui_QtCore->em_mappedtypes[18]
#define sipForceConvertTo_QList_1800    sipModuleAPI_QtGui_QtCore->em_mappedtypes[18]->mt_fcto
#define sipConvertFrom_QList_1800       sipModuleAPI_QtGui_QtCore->em_mappedtypes[18]->mt_cfrom

#define sipMappedType_QList_0600QPair_2400_2400        sipModuleAPI_QtGui_QtCore->em_mappedtypes[19]
#define sipForceConvertTo_QList_0600QPair_2400_2400    sipModuleAPI_QtGui_QtCore->em_mappedtypes[19]->mt_fcto
#define sipConvertFrom_QList_0600QPair_2400_2400       sipModuleAPI_QtGui_QtCore->em_mappedtypes[19]->mt_cfrom

#define sipMappedType_QList_27000600QPair_1800_1800        sipModuleAPI_QtGui_QtCore->em_mappedtypes[20]
#define sipForceConvertTo_QList_27000600QPair_1800_1800    sipModuleAPI_QtGui_QtCore->em_mappedtypes[20]->mt_fcto
#define sipConvertFrom_QList_27000600QPair_1800_1800       sipModuleAPI_QtGui_QtCore->em_mappedtypes[20]->mt_cfrom
extern const sipExportedModuleDef *sipModuleAPI_QtGui_QtCore;

typedef const QMetaObject *(*sip_qt_metaobject_func)(sipWrapper *,sipWrapperType *,const QMetaObject *);
extern sip_qt_metaobject_func sip_QtGui_qt_metaobject;

typedef int (*sip_qt_metacall_func)(sipWrapper *,sipWrapperType *,QMetaObject::Call,int,void **);
extern sip_qt_metacall_func sip_QtGui_qt_metacall;

typedef int (*sip_qt_metacast_func)(sipWrapper *,sipWrapperType *,const char *);
extern sip_qt_metacast_func sip_QtGui_qt_metacast;

#endif
